<% 'Module: AssetLabels.inc

   'Description: This module is contains the Asset Labels that are placed
   ' infront the asset information in various modules.
   ' The asset information is stored in the asset table in the database.
   ' The column names in the database cannot change, but the
   ' web-viewable labels infront of that data can be easily changed
   ' by editing the labels here or in the AssetLabelsCustom.inc file. 
   ' This allows the asset database
   ' to be more configurable to your asset management requirements
   
   ' This file should be located in the wclanguage virtual directory so it is
   ' available for both Customer+Center and Tech+Center applications.
   
   '(C) 2000, 2001, 2002, 2006 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '12/03/01	SAV		Created original AssetLabels.inc Page
   '05/06/02	SAV		Modifed page for Version 4.0 release	
   '08/17/06	SAV		Created flag to call custom version
   '10/03/11    CMB             New Asset labels
   '02/03/12   CMB             SendTechAssignedToEmail and several cosmetic changes to msgs
   '04/25/12   CMB              Added stuff for batch move to surplus and retire
   '05/01/14   SAV		updated Assetlabels.inc for customer+Center asset viewing and better label mapping
   
   ' NOTES: Description_Label is currently a required field but code can be commented out
   ' wc_Property_tag_Label is set up to be a barcode
    'The following must be unique: IP_Address_Label, Serial_Number_Label
   ' wc_Other_Asset_Number must exist and be numeric;  This label is defined in wc_Labels and not here
   %>
<%     'New Asset stuff - CMB 09/13/2011 version 7.5
	wc_Asset_Category = "Asset Category"
	wc_Manage_Asset_Category_Label = "Manage Asset Categories"
	wc_Edit_Create_Asset_Category = "Create or Edit an Asset Category"
	wc_Edit_Create_Asset_Category_Block = "To create a new asset category, enter the name of the category and whether this is a required field.  To edit an existing category, select the category in the grid below and make the changes here."
	wc_Asset_Required = "Required"
	wc_Asset_Categories = "Asset Categories"
	wc_Edit_Asset_Category_Block = "To edit an existing category, click the Rename/Edit link and edit above. " 
	wc_Number_Of_Values = "# of values"
	wc_Rename_Edit = "Rename/Edit"
	wc_Edit_Subitems = "Create/Edit Values"
	wc_Delete_Asset_Category = "Delete Asset Category"
	wc_Add_New_Asset_Category = "Add New Asset Category"
	wc_Must_Be_Unique = " must be unique"
	wc_Must_Be_Numeric = " must be numeric"
	wc_Asset_Category_Values = "Asset Category Values"
	wc_Asset_Category_Value = "Asset Category Value"
	wc_Manage_Asset_Category_Values = "Manage Asset Category Values"
	wc_Edit_Create_Asset_Category = "Create or Edit an Asset Category"
	wc_Edit_Create_Asset_Category_Value_Block = "To create a new asset category value, enter the value and whether this is the default Value.  To edit an existing value, select the value in the grid below and make the changes here."
	wc_Edit_Asset_Category_Block = "To edit an existing category, click the Rename/Edit link and edit above. "
	wc_Default = "Default"
	wc_Edit_Asset_Category_Value_Block = "To edit an existing value, click the Rename/Edit link and edit above. Deleting or editing a value will not change values already existing for assets." 
	wc_Delete_Asset_Category_Value = "Delete Asset Category Value"
	wc_Add_New_Asset_Category_Value = "Add New Asset Category Value"
	wc_Is_An_Invalid_Date = " is an invalid date"
	wc_Cases_with_Asset_Number = "Cases for Asset Number"
	wc_Number_of_Cases = "# Cases"
	wc_Is_A_Required_field = " is a required field" ' for error messages
	
	wc_SearchRetireSurplus = "Search and Retire or Move to Surplus"
	wc_SearchRetireSurplus_Block = "This utility allows you to enter criteria in order to select assets and then either move them to surplus or retire them."
	wc_set_Retire_Confirm =  "Please confirm that you wish to retire these assets.  This action cannot be reversed!"
	wc_set_Surplus_Confirm =  "Please confirm that you wish to move these assets into surplus.  This action cannot be reversed!"

	wc_SetRetire_Status_part1 = "This utility attempted to retire "
	wc_SetRetire_Status_part2 = "assets.  Please review the results below..."
	wc_SetRetire_warning = "This query will retire ALL the records listed below. "
	wc_SetRetire_no_Criteria ="You cannot retire over 1000 assets at a time!  Please return to the last screen and select more restrictive search criteria."
	wc_SetRetire_Results = "Asset Search and Retire Values Results"

	wc_SetSurplus_Status_part1 = "This utility attempted to move "
	wc_SetSurplus_Status_part2 = "assets to surplus.  Please review the results below..."
	wc_SetSurplus_warning = "This query will move ALL the records listed below to surplus. "
	wc_SetSurplus_no_Criteria ="You cannot move over 1000 assets at a time to surplus!  Please return to the last screen and select more restrictive search criteria."
	wc_SetSurplus_Results = "Asset Search and Surplus Values Results"
	wc_SetRetireSurplus_Button = "Search and Retire/Surplus"
	wc_CSVRetireSurplus_Button = "Retire/Surplus using csv"
	wc_Surplus_Title = "Move Assets to Surplus"
	wc_Retire_Title = "Retire Assets"
	wc_Import_not_Found = "Asset not found"
	 wc_RetireSurplus_Title = "Asset Retire/Move to Surplus"
%>

<% ' *********** IMPORTANT USER CUSTOMIZATION *********************
' Uncomment the CustomAssets field below bring in custom asset labels in  AssetLabelsCustom.inc

	'CustomAssets = "YES"
'	SendTechAssignedToEmail = "YES" ' this determines whether the tech gets an email when the assetinfo is assigned to him 02/03/12
	
	If CustomAssets = "YES" THEN
%>
<!-- #INCLUDE FILE="AssetLabelsCustom.inc" -->	

	<% Else %>
	

<% ' * * * * * * * * * * * User Customizations * * * * * * * * * * * * *

	' First these are the values for the various sections on the asset INfo/create/edit page.
	Asset_Information_Label = "Asset Information"
	Asset_Assignments_Label = "Asset Assignments"
	Asset_Details_Acquisition_Label  = "Asset Details/Acquisition"
	Specifications = "Specifications"
	Specifications_Label = "Specifications"

	Custom_Fields_Label = "Custom Fields"
	Software_Label = "Software"


	' Edit the variable VALUES below to change the displayed custom asset field names
	' I.E. To change the Field 1 to you custom value of Mac Or PC change
	' the line Custom_Field_1_Label = "Field 1" to Custom_Field_1_Label="Mac Or PC"
	Custom_Field_1_Label = "Field 1"
	Custom_Field_2_Label = "Field 2"
	Custom_Field_3_Label = "Field 3"
	Custom_Field_4_Label = "Field 4"
	Custom_Field_5_Label = "Field 5"

	' Note this Custom database fields are limited to 50 characters each.
	
	' General Asset Info
	Asset_Number_Label = "Asset Number"	
	Description_Label = "Description"
	Property_Tag_Label = "Property Tag"
	
	Assigned_Group_Label = "Assigned Group"
	Location_Label = "Location"
	Date_Assigned_Label = "Date Assigned"
	IP_Address_Label = "IP Address"
	Wall_Port_Number_Label = "Wall Port Number"
	
	' Asset Details
	Computer_ID_Label = "Computer ID"
	Lease_Or_Purchase_Label = "Lease or Purchase"
	Purchase_Order_Number_Label = "Purchase Order Number"
	Serial_Number_Label = "Serial Number"
	
	' Acquisition Fields
	Acquired_From_Label = "Acquired From"
	Date_Acquired_Label = "Date Acquired"
	Date_put_into_service_Label = "Date put into service"
	
	' Specifications
	Processor_Speed_Label = "Processor speed"
	RAM_Size_Label = "RAM size"
	Hard_Drive_Size_Label = "Hard Drive Size"
	Monitor_model_Label = "Monitor Model"
	Monitor_size_Label = "Monitor Size"
	Monitor_Serial_Number_Label = "Monitor Serial number"
	
	'Software Labels
	Operating_System_1_Label = "Operating system 1"
	Operating_System_2_Label = "Operating system 2"
	
	App_1_Label = "App 1"
	App_1_Product_ID_Label = "App 1 product ID"
	App_1_Installation_Date_Label = "App 1 installation Date"
		
	App_2_Label = "App 2"
	App_2_Product_ID_Label = "App 2 product ID"
	App_2_Installation_Date_Label = "App 2 installation Date"
	
	App_3_Label = "App 3"
	App_3_Product_ID_Label = "App 3 product ID"
	App_3_Installation_Date_Label = "App 3 installation Date"
	
	App_4_Label = "App 4"
	App_4_Product_ID_Label = "App 4 product ID"
	App_4_Installation_Date_Label = "App 4 installation Date"
	
	App_5_Label = "App 5"
	App_5_Product_ID_Label = "App 5 product ID"
	App_5_Installation_Date_Label = "App 5 installation Date"
	
	App_6_Label = "App 6"
	App_6_Product_ID_Label = "App 6 product ID"
	App_6_Installation_Date_Label = "App 6 installation Date"
	
	App_7_Label = "App 7"
	App_7_Product_ID_Label = "App 7 product ID"
	App_7_Installation_Date_Label = "App 7 installation Date"
	
	App_8_Label = "App 8"
	App_8_Product_ID_Label = "App 8 product ID"
	App_8_Installation_Date_Label = "App 8 installation Date"
	
	App_9_Label = "App 9"
	App_9_Product_ID_Label = "App 9 product ID"
	App_9_Installation_Date_Label = "App 9 installation Date"
	
	App_10_Label = "App 10"
	App_10_Product_ID_Label = "App 10 product ID"
	App_10_Installation_Date_Label = "App 10 installation Date"
	
	App_11_Label = "App 11"
	App_11_Product_ID_Label = "App 11 product ID"
	App_11_Installation_Date_Label = "App 11 installation Date"
	
	App_12_Label = "App 12"
	App_12_Product_ID_Label = "App 12 product ID"
	App_12_Installation_Date_Label = "App 12 installation Date"
	
	App_13_Label = "App 13"
	App_13_Product_ID_Label = "App 13 product ID"
	App_13_Installation_Date_Label = "App 13 installation Date"
	
	App_14_Label = "App 14"
	App_14_Product_ID_Label = "App 14 product ID"
	App_14_Installation_Date_Label = "App 14 installation Date"
	
	App_15_Label = "App 15"
	App_15_Product_ID_Label = "App 15 product ID"
	App_15_Installation_Date_Label = "App 15 installation Date"
	
' * * * * * * * * * The Following are the same names but as used in the Pocket PC Environment * * * * * * * * *
' * * * * * * * * * These may need to be shorter than the "originals" above to cater foe the smaall screen * * *
	

	wcp_Custom_Field_1_Label = "Field 1"
	wcp_Custom_Field_2_Label = "Field 2"
	wcp_Custom_Field_3_Label = "Field 3"
	wcp_Custom_Field_4_Label = "Field 4"
	wcp_Custom_Field_5_Label = "Field 5"

	' Note this Custom database fields are limited to 50 characters each.
	
	' General Asset Info
	wcp_Asset_Number_Label = "Asset No"	
	wcp_Description_Label = "Descr"
	wcp_Property_Tag_Label = "Tag No"
	
	wcp_Assigned_Group_Label = "Assigned Group"
	wcp_Location_Label = "Location"
	wcp_Date_Assigned_Label = "Date Assigned"
	wcp_IP_Address_Label = "IP Addr."
	wcp_Wall_Port_Number_Label = "Wall Port No"
	
	' Asset Details
	wcp_Computer_ID_Label = "Computer ID"
	wcp_Lease_Or_Purchase_Label = "Lease or Purchase"
	wcp_Purchase_Order_Number_Label = "P.O. Number"
	wcp_Serial_Number_Label = "S/N"
	
	' Acquisition Fields
	wcp_Acquired_From_Label = "Acquired From"
	wcp_Date_Acquired_Label = "Date Acquired"
	wcp_Date_put_into_service_Label = "Date put into service"
	
	' Specifications
	wcp_Processor_Speed_Label = "Processor speed"
	wcp_RAM_Size_Label = "RAM size"
	wcp_Hard_Drive_Size_Label = "Hard Drive Size"
	wcp_Monitor_model_Label = "Monitor Model"
	wcp_Monitor_size_Label = "Monitor Size"
	wcp_Monitor_Serial_Number_Label = "Monitor S/N"
	
	'Software Labels
	wcp_Operating_System_1_Label = "Operating system 1"
	wcp_Operating_System_2_Label = "Operating system 2"
	
	wcp_App_1_Label = "App 1"
	wcp_App_1_Product_ID_Label = "App 1 product ID"
	wcp_App_1_Installation_Date_Label = "App 1 installation Date"
		
	wcp_App_2_Label = "App 2"
	wcp_App_2_Product_ID_Label = "App 2 product ID"
	wcp_App_2_Installation_Date_Label = "App 2 installation Date"
	
	wcp_App_3_Label = "App 3"
	wcp_App_3_Product_ID_Label = "App 3 product ID"
	wcp_App_3_Installation_Date_Label = "App 3 installation Date"
	
	wcp_App_4_Label = "App 4"
	wcp_App_4_Product_ID_Label = "App 4 product ID"
	wcp_App_4_Installation_Date_Label = "App 4 installation Date"
	
	wcp_App_5_Label = "App 5"
	wcp_App_5_Product_ID_Label = "App 5 product ID"
	wcp_App_5_Installation_Date_Label = "App 5 installation Date"
	
	wcp_App_6_Label = "App 6"
	wcp_App_6_Product_ID_Label = "App 6 product ID"
	wcp_App_6_Installation_Date_Label = "App 6 installation Date"
	
	wcp_App_7_Label = "App 7"
	wcp_App_7_Product_ID_Label = "App 7 product ID"
	wcp_App_7_Installation_Date_Label = "App 7 installation Date"
	
	wcp_App_8_Label = "App 8"
	wcp_App_8_Product_ID_Label = "App 8 product ID"
	wcp_App_8_Installation_Date_Label = "App 8 installation Date"
	
	wcp_App_9_Label = "App 9"
	wcp_App_9_Product_ID_Label = "App 9 product ID"
	wcp_App_9_Installation_Date_Label = "App 9 installation Date"
	
	wcp_App_10_Label = "App 10"
	wcp_App_10_Product_ID_Label = "App 10 product ID"
	wcp_App_10_Installation_Date_Label = "App 10 installation Date"
	
	wcp_App_11_Label = "App 11"
	wcp_App_11_Product_ID_Label = "App 11 product ID"
	wcp_App_11_Installation_Date_Label = "App 11 installation Date"
	
	wcp_App_12_Label = "App 12"
	wcp_App_12_Product_ID_Label = "App 12 product ID"
	wcp_App_12_Installation_Date_Label = "App 12 installation Date"
	
	wcp_App_13_Label = "App 13"
	wcp_App_13_Product_ID_Label = "App 13 product ID"
	wcp_App_13_Installation_Date_Label = "App 13 installation Date"
	
	wcp_App_14_Label = "App 14"
	wcp_App_14_Product_ID_Label = "App 14 product ID"
	wcp_App_14_Installation_Date_Label = "App 14 installation Date"
	
	wcp_App_15_Label = "App 15"
	wcp_App_15_Product_ID_Label = "App 15 product ID"
	wcp_App_15_Installation_Date_Label = "App 15 installation Date"


' * * * * * * * * * End User Customizations Section * * * * ** * * *	
	
	
%>

<% End If %>
