<% 'Module: TxtMsgConfiguration.inc

   'Description: This module is contains the Text Messaging Configuration parameters
   ' that are used to control refresh rates, screen designs for the Text Messaging
   ' options of the Web+Center application.  Changing certain parameters here
   ' could impact over all application performance.
   ' This file should be located in the languageXX virtual directory so it is
   ' available for both Customer+Center and Tech+Center applications.
   
   '(C) 2000, 2001, 2002, 2006, 2007 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------		---		------------------------------------------------
   '01/17/07		SAV		Created Original TxtMsgConfiguraton File

%>


<% ' * * * * * * * * * * * User Customizations * * * * * * * * * * * * *

	'Text Messaging Refresh rates
	
	' TECH Interface windows refresh rates
	wc_TechCheckForTxtMsgRefreshRate = 30 ' Refresh every 30 seconds for the tech window that shows Txt Messages currently active
	wc_TechTxtWindowRefreshRate = 10 ' Refresh every 10 seconds
	
	' Customer Text Messaging Refresh Rates
	wc_CustomerTextWindowRefreshRate =   10 ' Refresh every 10 seconds the screen that shows the Txt messages
	

	' ***** Alarm sound configuration
	' Option to include enable a alarm sound (bell sound as example) when a 
	' a text message session has been started by the customer.  This defaults
	' to a school bell sound but it can be replaced by any sound type file
	' that is supported by your browser environment.
	
	' To disable a sound file, simply comment out this line below

	AlertSoundWaveFile = "schoolbell.wav"
	
	






%>
