<%
 module = "SQL_Script_Interpreter"

'(C)  2004 Internet Software Sciences
' www.inet-sciences.com


'History:

'Date			Who		What
'-------		---		------------------------------------------------
' 11/16/2004	JC		Created initial version
'03/29/05		TGF		Updated for SQL 2000
'06/23/2009		SAV		Updated for Version 6 to 7
'  added - 1/19/2011
'	EmailToCaseReplyToName TEXT (100) NULL,
'	EmailToCaseReplyToEmail TEXT (100) NULL



' This module is an autolytic program - i.e. it is a program that digests it's own source code file as a data file.
' To explain how it works, consider there are 2 phases when this code executes:
'
' a) When the module is being processed by the ASP interpreter
'    ----------------------------------------------------
' The first part of the module is actualy executable code written in ASP, but the second part
' of the module is passed over by the ASP interpreter because it thinks it is html code - which technically
' it is - so while the ASP interpreter in fact passes this part through to the client when the module is executed
' it doesn't appear on the user's screen because it is seen as "comments" by the browser
'
' b) When the module is executing as a program
'    -----------------------------------------
' The program fist figures out the location of itself (i.e. the filename on which the module itself resides)
' by means of examining variables made available by the server
' Once it has figured out the full path to this file, it reads the file as data and processes it thus:
'   1) It skips over and ignores any lines in the file until is sees a line containing "START" concatenated with "SCRIPT"
'   2) It takes subsequent lines and concatenates them into a command string until it finds one ending in a semi-colon
'   3) When it encounters a line ending in a semi-colon, it executes the command string (accumulated so far) as a SQL statement
'   4) It continues doing (2) and (3) until it sees a line containing "STOP" concatenated with "SCRIPT" whereupon it reverts to (1)
'   5) While doing (2) and (3) it ignores any line whose first character is # - i.e. treats it as a comment in the script
' In essence it is a script interpreter using the MySQL conventions for comments and end-of-command
'
%>
<html>
<head>
<title> Script Engine </title>
</head>
<style>
.Wrapper {
		border-width: 2px;
		border-style: solid;
		border-color: black;
		background-color: palegreen;
		padding-top: 5px;
		padding-bottom: 5px;
		padding-left: 15px;
		padding-right: 15px;
		}

</style>
<body bgcolor=cornsilk>

<%
' first we need to figure out the full pathname to the file we are being executed from, so we ourselves can read this file
Basepath  = Server.MapPath(".")
scriptname = Request.ServerVariables("script_name")

' Now pull out the actual filename from the full scriptname
a = InstrRev(scriptname, "/") ' Note this is always forward slash as it is an http URL and not a filepath
lambda = Len(scriptname)
b = Lambda - a
FileName = Right(scriptname,b)

' Now figure out if we want to use a forward or backward slash in assempling the path name - depends on our OS
xxxpos = Instr(Basepath, "\")
if xxxpos <> 0 then
   slash = "\"
else
   slash = "/"
end if

' Now we are ready to assemble the full pathname to the file
filepath = Basepath & slash & filename

' Set up a couple of other flags and constants we will be needing

bypass = "Yes"
tabchar = Chr(9)
startscriptflag = "START" & "SCRIPT"
stopscriptflag = "STOP" & "SCRIPT"

' -----------------------------------------------------------------------------------
'   CAUTION - This program is currently set to use the DSN as defined in global.asa
'
'  If using a different test database, replace the line following this comment block
'  withone that looks like
'
'            Application("myDSN") = "DSN=webcenter50_db;uid=wc50;pwd=wc50pass"
'
'  but with the parameter values adjusted as appropriate
' -----------------------------------------------------------------------------------

 myDSN=Application("myDSN")

' And now we can start executing real work

set conntemp=server.createobject("adodb.connection")
conntemp.open myDSN



 response.write "<font color=red size=+1>Processing The File " & FilePath & "</font><p>"

Set fs1 = CreateObject("Scripting.FileSystemObject")
REM the "1" in the next statement represents "ForReading"
Set b = fs1.OpenTextFile(FilePath, 1, FALSE)


linecounter = 0
SQL = ""

While not b.AtEndOfStream
   InRec  = b.Readline
   ' start processing a single line of input
   linecounter = linecounter + 1
   Inrec = Trim(InRec)
   Inrec = Replace(InRec,tabchar," ") ' replace any tab characters with a single space
   firstchar = Left(InRec,1)
   lastchar = Right(InRec,1)


   If InRec = "" Then
     'do nothing
   Elseif firstchar = "#" Then
      'do nothing
   Elseif Instr(InRec, startscriptflag) Then
      bypass = "No"
   Elseif Instr(InRec, stopscriptflag) Then
      bypass = "Yes"
   Elseif bypass = "Yes" Then
      ' do nothing
   Else
	response.write "<font size=-1> " & linecounter & " <font color=navy> "   & Replace(Inrec, " ", "&nbsp;") & "</font></font><br>"
	' concatenate this line into the end of the SQL statement
	SQL = SQL & Inrec & " "
   End If

   ' Now if we have hit a line that ends in semi-colon, then execute the accumulated SQL command

   If SQL <> "" and lastchar = ";" Then

   ' remove the semicolon (and the extra seaparator space we inserted) at the end of the SQL command
     xpos = Len(SQL)
     xpos = xpos-2
     SQL2 = Left(SQL, xpos)

     response.write "<p><font color=red>Executing</font><br><blockquote><div class=wrapper> " & SQL2 & "</div></blockquote><P>"
     response.flush
     set rstemp=conntemp.execute(SQL2)
     SQL = ""
   End if


Wend


b.Close
%>


<p>



<!-- STARTSCRIPT


# Any line starting with "#" is a comment line for the script engine - usefull for temporarily disabling lines

# V7 Table additions to existing tables

# Cases Table

#ALTER TABLE Cases ADD AdditionalCCList ntext NULL;
#ALTER TABLE Cases ADD AdditionalNotifications bit not null;


# Configuration Table

#ALTER TABLE Configuration ADD PrimaryAdditionalNotificationEmail CHAR (100);


#  *****************  Add EmailToCase Configuration table ***************


CREATE TABLE EmailToCaseConfig (

	EmailToCaseIndex AUTOINCREMENT constraint Primarykeyname Primary Key,
	popemailaddress TEXT (100) NULL,
	popemailusername TEXT (100)  NULL,
	popemailpassword TEXT (100) NULL,
	checkintervalMinutes TEXT (20) NULL,
	EmailDomainRequired TEXT (100) NULL,

	OnlyExistingEmailAddresses LOGICAL NULL ,
	DisableEmailToCase LOGICAL NULL,
	CustomerNotificationEmail LOGICAL NULL,
	AllowAttachedFiles LOGICAL NULL,

	EmailToCaseReplyToName TEXT (100) NULL,
	EmailToCaseReplyToEmail TEXT (100) NULL

);


# Asset Inspection Tables





STOPSCRIPT -->


Done!

</body>
</html>
