
<% 'Module: AdvancedEscalation.asp - Version 5.0

   'Description: This module performs the case auto-escalation for
   ' the Web+Center Help Desk.

   ' The Case Escalation works by having this window up on some machine in the
   ' brower running at all times and it performs an auto-refresh of a page
   ' that performs the quering of the database and sends out the
   ' necessary email alerts (email and cell email) and reassign cases to
   ' particular groups when needed.

   ' To Stop the escalation, one should simply close this window.  Only one
   ' of these windows should be activated at any one time.

   '(C) 1998,1999, 2000, 2001, 2002, 2005 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------		---		------------------------------------------------
   '6/11/2002	SAV		Created original Escalation.asp page
	'5/6/2005	SAV		Updated Escalation for HTML based emails
	'03/28/13	SAV		Created AdvancedEscalation.asp
	'04/34/13	SAV 	Updated with additional flag to check for assigned to tech or not.
	'05/30/13	SAV		Added option to set the last time it was updated for checking on status
	'06/04/13   CMB      Added caseOneLine to subject
	' CONSTANTS



	'EscalateDebugFlag = "YES" ' comment out to control debugging info

	DebugParameter = request.querystring("DEBUG")

	If DebugParameter = "YES" Then
		EscalateDebugFlag = "YES" ' comment out to control debugging info
	End If



%>


<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->
<!-- #INCLUDE FILE="../Language/SendEmail.inc" -->
<!-- #INCLUDE FILE="../Language/HTMLEmailTemplateTechUpdate.inc" -->
<!-- #INCLUDE FILE="../Language/HTMLEmailTemplateCustomerNotification.inc" -->
<!-- #INCLUDE FILE="../Language/HTMLEmailTemplateCustomerSurvey.inc" -->


<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->

<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 2 ' Allow valid techs to access this function.


	CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN") ' Get the Logged TechID from the cookie

	If SecurityON = "YES" Then ' Execute this code only if Security Option Flag is set to YES
		' This flag will be set in the DB_define.inc file.

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="SELECT * from Tech_staff where Tech_ID = '" & CookieID & "' AND Tech_Level >= " & TechLevel
		set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF <> True Then
			TechFullName = rstemp("first_name") & " " & rstemp("Last_name")
			ValidUser = "YES" ' Set this variable to prevent problems on next page
		End If

		rstemp.close
		set rstemp=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing
	Else
		ValidUser = "YES"
	End If


 ' End of ASP page security checks
 %>


<% if ValidUser <> "YES" Then %>
	<% ASPPage = "AdvancedEscalation.asp"%>

	<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function %>

<% UserPageColor = "FFFFFF" %>

<% ' Advanced Escalation Algorithm -


	'

	' The advanced Escalation requires checking the following criterias:
	' (1) First, the highest level criteria is the Time Filters.  If any of the time filters
	' is determined to be true, it's exists all future processing. This is done by looping through
	' all of the time filters and comparing it with the current Time and Date

	' (2) Next it checks and starts looping for all open cases and checks to see if the Escalated boolen flag
	' AND ALSO if ContinueToEscalate Flag is set or not set.
	' for the case is already set. If set, it skips to the next case
	' (3) If not already escalated, then it needs to be checked with all of the escalation rules
	' (4) loop through all of the escalation rules for that case
	' (5) First checks for interval
	' (6) Checks for Group
	' (7) Checks for Priority
	' (8) Checks for Status
	' (9) If all pass then escalate case and set escalation bit in case table for that case

'Get the Escalation Configuration options %>
<%

   ' NOTE - the Connection "conntemp" is opened ONCE here at the beginning of the main path
   ' of the program - and it remains open until the end - thus catering for use by multiple
   ' subroutines during execution without intermediate opening and closing of the connection

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN


	' Get the system settings such as SMTP addresses


	mySQL="select * from Configuration" ' We will allow up to 10 Priority values


	set rstemp = server.createobject("adodb.recordset")
	rstemp.open mySQL, conntemp, 1,3


	' Old Way - Do not  use with SQL*Server
	'set rstemp=conntemp.execute(mySQL)


	If rstemp.EOF = True  Then
		Response.write "No Configuration file found"
	Else

		' Get the other fields with another lookup

		smtp_host_address = rstemp("smtp_host_address")
		Standard_reply_to_address = rstemp("Standard_reply_to_address")
		UserPageColor = rstemp("ts_user_page_color")

		MaxHistorySize =  CLng(rstemp("max_case_history_size"))
		MaxSummarySize =  Cint(rstemp("max_case_summary_size"))
		MaxResolutionSize =  Cint(rstemp("max_case_resolution_size"))

		OrganizationFromName = rstemp("Customer_Name_Text") ' Use this for organization name in mail out

		' New 5.0 SMTP mailer options

		SendHTMLEmail = rstemp("SendHTMLEmail") ' Boolean value
		SMTP_User_Name = rstemp("SMTP_User_Name")
		SMTP_Password = rstemp("SMTP_Password")

		If SendHTMLEmail = True Then
			HTMLEmail = "YES"
		Else
			HTMLEmail = ""
		End IF

		' Set the Date/Time value with current time

		rstemp("LastAdvancedEscalation") = Now() ' Set this field for each escalation

		rstemp.update



	End If

	rstemp.close
	set rstemp=nothing


%>

<HTML>
<HEAD>

<% ' Defining the Refresh rate for this page
	Advanced_Escalation_Refresh_rate = 10 ' minutes
	Advanced_Escalation_Refresh_Minutes = 60 * Advanced_Escalation_Refresh_Rate  ' default to 10 minutes/ 600 seconds
%>



<% If Advanced_Escalation_Refresh_minutes <> 0 Then %>
   <META HTTP-EQUIV="Refresh" CONTENT="<%=Advanced_Escalation_Refresh_Minutes%>">
<%End If %>

   <TITLE><%=wc_Advanced_Escalation_Window%></TITLE>
<!-- (C) 2013 by Internet Software Sciences -->
</HEAD>
<BODY BGCOLOR="#<%=UserPageColor%>">
<center>
<table cellspacing=2 cellpadding=2 width=90% border=1><tr>
<th bgcolor=F0D0D0><font size=-1><%=wc_Status%></th>
<th bgcolor=F0D0D0><font size=-1><%=wc_Refresh%></th>

</tr>
<tr>
<% If Disable_All = "YES" then %>
<td align=center bgcolor=red><font size=-1>
<B><%=wc_DISABLED%></b>
</td>
<%else%>
<td  align=center bgcolor=GREEN><font size=-1>
<B><%=wc_RUNNING%></b>
</td>
<%End If %>


<td align=center >
<font size=-1><%=Advanced_Escalation_Refresh_rate%> &nbsp;&nbsp;<%=wc_Minutes%></font>
</td>


</tr>

</table>



<% if Disable_ALL = "YES" Then
	Cases_Found_String = "---"
Else

	'response.write "Checking for cases"
	' Start with New Case Checking

%>
<br>



<%


' First Check the time Filters
	TimeFilters = "YES"

	IF TimeFilters = "YES" Then


	'*************************************************************
	'*************** Time Filters Code ***************************
	'*************************************************************


	mySQL2="select * from EscalationTimeFilters"


	'If EscalateDebugFlag = "YES" Then
	'	response.write "Escalate Time Filters SQL = " & mySQL2 & "<P>"
	'End If


	set rstemp12=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursor for record count to be correct.

	If DatabaseType <> "ACCESS97" Then
		rstemp12.CursorLocation = adUseClient
	End If

	rstemp12.open mySQL2, conntemp, adopenstatic


		'set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the


		If rstemp12.EOF <> True Then

		RecordsFound = rstemp12.recordcount
		'NewCase_Count = RecordsFound


		' Default the TimeFilter flag to NO outside of the loop
		TimeFilterMatchFound = "NO"


		do while not rstemp12.eof AND TimeFilterMatchFound = "NO"


		' Now we need to compare current Date/Time with the Time Filter

		' So first get all of the information about the current date/time/ day of the week

			CurrentDate = Date()
			CurrentDayOfWeek = WeekDay(Date())
			CurrentTime = Time()

			' Debug
	'If EscalateDebugFlag = "YES" Then
	'		response.write "CurrentDate = " & Currentdate
	'		response.write "CurrentDayOfWeek=" & CurrentDayOfWeek
	'		response.write "CurrentTime=" & CurrentTime
	'End IF


			'Time Filter Tests


			' Test 1 - Check for matching date

			If CurrentDate = rstemp12("TimeFilterDate") Then
				TimeFilterMatchFound = "YES"
			End If


			' Convert string of start and end times to Time Datatypes



			'Check for when entire day is listed as filter
			If (CurrentDayOfWeek = rstemp12("DayOfWeek")) AND  IsNull(rstemp12("StartTime")) AND isNull(rstemp12("EndTime")) Then
				TimeFilterMatchFound = "YES"
			End If


			'Check for when time window of day of week is listed as filter

			If IsNull(rstemp12("StartTime")) AND IsNull(rstemp12("EndTime")) Then
			' do nothing
			Else

			StartTime = TimeValue(rstemp12("StartTime"))
			EndTime = TimeValue(rstemp12("EndTime"))
					TimeFilterNameDisplay = rstemp12("TimeFilterName")



				If Cint(CurrentDayOfWeek) = CInt(rstemp12("DayOfWeek")) AND  StartTime < CurrentTime AND Endtime > CurrentTime THEN
					TimeFilterMatchFound = "YES"
					TimeFilterName = rstemp12("TimeFilterName")
				End IF

			End If

		' DEBUG



	'		Response.write "Comparing Day of Week "& CurrentDayOfWeek & " with " & rstemp12("DayOfWeek") & " AND Current Time "  & CurrentTime & " AND " & StartTime & " AND " & EndTime & "<br>"

	If EscalateDebugFlag = "YES" Then

			Response.write "Checking Time Filter: " & TimeFilterNameDisplay  & " and result is: " & TimeFilterMatchFound & "<br>"
	End IF

	'		Response.flush
	'		Response.end



			rstemp12.MoveNext
		loop

		Else ' No records found

		End If

		rstemp12.close
		set rstemp12=nothing


		' End of Time Filter Checks

	End IF ' End of Time Filters = YES

' Display information about time Filters

%>

<table cellspacing=2 cellpadding=2 width=90% border=1>
<tr>
<td  bgcolor=F0C0F0 align=center>
<font size=-1>

<% If TimeFilterMatchFound = "YES" Then
	Response.write " Time Filter Match Found <br> FILTER:" & TimeFilterName  & " <br> No further processing"
   Else
	Response.write " No Time Filter Match Found"
   End IF
%>
</td>
</tr>
</table>


<% If TimeFilterMatchFound = "YES" Then

%>

</body>
</html>

<% 	Response.flush
	response.end
%>

<% End If %>


<table cellspacing=2 cellpadding=2 width=90% border=1>
<tr>
<td colspan=3 bgcolor=F0C0F0 align=center>
<font size=-1><B>Advanced Escalaton Report</b>
</td>
</tr>
<tr>
<tr>
<th bgcolor=F0D0D0><font size=-1><%=wc_Case%></th>
<th bgcolor=F0D0D0><font size=-1><%=wc_one_line_description%></th>
<th bgcolor=F0D0D0><font size=-1>Rule Name</th>
</tr>



<%

		'**********************************************************************
		'****************** Advanced Escalation Rules Processing **************
		'**********************************************************************

	' (2) Next it checks and starts looping for all open cases
	'
	' (3) If not already escalated, then it needs to be checked with all of the escalation rules
	' (4) loop through all of the escalation rules for that case
	' (5) First check is escalated and if continue to escalate bit is set or not
	' (6) First checks for interval
	' (7) Checks to see if case is already has a tech assignment
	' (8) Checks for Group
	' (9) Checks for Priority
	' (10) Checks for Status
	' (11) If all pass then escalate case and set escalation bit in case table for that case

	mySQL2="select * from Cases where Status <> 1" ' Find all open cases


'	mySQL2 = mySQL2 & "where reopen_date IS NOT NULL AND " & Status_SQL


'	If EscalateDebugFlag = "YES" Then
'		response.write "Rules Processing SQL = " & mySQL2 & "<p>"
'
'	End IF
	set rstemp6=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursor for record count to be correct.

	If DatabaseType <> "ACCESS97" Then
		rstemp6.CursorLocation = adUseClient
	End If

	rstemp6.open mySQL2, conntemp, adopenstatic


		ExistCase_Count = 0


		If rstemp6.EOF <> True Then

		RecordsFound = rstemp6.recordcount

	If EscalateDebugFlag = "YES" Then
		response.write "Number of Open Cases Records: " & RecordsFound & "<P>"
	End If



		'ExistCase_Count = RecordsFound

		'ExistCase_Count = 0

		do while not rstemp6.eof


'		'Check for Escalate bit set had to be moved to the rule area with the new ContinueToEscalate
'
'			' First check if the escalation bit in the case table is already set for this case
'
'			'Debug
'			'Response.write "Escalated bit = " & rstemp6("Escalated") & "<br>"
'
'
'			if rstemp6("Escalated") = True  Then' Already escalated to exit tests for this case
'
'			'DEBUG
'
'	If EscalateDebugFlag = "YES" Then
'
'			response.write "Escalated Bit Set for case: " & rstemp6("Case_number") & " NO PROCESSING <br><hr>"
'	End If
'
'
'			Else ' Not set so do more processing
'
'			'DEBUG
'			'response.write "Checking case: " & rstemp6("Case_number")



			' Now for each open case lets first compute the time between last mod and NOW()

				' Compare the Mod Date/Time and current date time
				Mod_Time = rstemp6("Mod_Time")
				Mod_Date = rstemp6("Mod_Date")

			CurrentDate = FormatDateTime( Date, vbGeneralDate)
			' Now put this OpenDate format into a format that the DateDiff() function
			' can work with converting from YYYYMMDD to mm/dd/yyyy

			FormattedModDate = mid(Mod_Date,5,2) & "/" & mid(Mod_Date,7,2) & "/" & mid(mod_Date,1,4)
			' Now we need to add the time as well to that string as hh:mm
			FormattedModTime = mid(Mod_Time,1,2) & ":" & mid(Mod_Time,3,2)
			FormattedDateTime = FormattedModDate & " " & formattedModTime

			MinutesDiff = DateDiff("n", FormattedDatetime, Now())
			If EscalateDebugFlag = "YES" Then

					'response.write "Now=" & Now()
					'response.write "FormattedDateTime = " & FormattedDatetime
					'response.write "Minutes Difference = " & MinutesDiff
			End IF


			' Get the Priority and Status of this case

			CasePriority = rstemp6("Severity")
			CaseStatus = rstemp6("Status")
			CaseGroup  = rstemp6("Group_number")
			Escalate_Case_Number = rstemp6("Case_Number")
			Tech_ID = rstemp6("Tech_ID") ' Assigned Tech

			CaseAlreadyEscalated =  rstemp6("Escalated")


			'Debugging

			If EscalateDebugFlag = "YES" Then


					Response.write " Processing Rules for Case: " & rstemp6("Case_Number") & "<br>"



				Response.write "Interval = " & MinutesDiff & " minutes <br>"
				Response.write " Status = " & CaseStatus & " Case Priority = " & CasePriority
			End IF

			'			Response.flush
			'			Response.end


		' Now loop through all of the rules and compare to the priority, status, group and time intervals

		' INNER LOOP

			mySQL5="SELECT * from EscalationRules"


			set rstemp5 = server.createobject("adodb.recordset")
			rstemp5.open mySQL5, conntemp, 1,3

			EscalateCase = "NO"

			do while not rstemp5.eof AND EscalateCase = "NO"


				' All of the following criteria must pass to escalate the case
				'  First checks for interval
				'  Check for if Assigned to Tech and if flag is set for that rule.
				'  Checks for Group
				'  Checks for Priority
				'  Checks for Status
				'  If all pass then escalate case and set escalation bit in case table for that case

	  		EscalateIFTechAssignedCheck = "NO - Tech Assigned"

		   	IF rstemp5("EscalateIfTechAssigned") = TRUE Then ' if yes then always escalate tech or not tech assignment
				EscalateIFTechAssignedCheck = "YES"
			End If


		   	IF rstemp5("EscalateIfTechAssigned") = FALSE Then ' if NO then only escalate if tech assignment is null

					If ISNULL (Tech_ID) Then
				  		EscalateIFTechAssignedCheck = "YES" ' yes escalate case since no tech is assigned
				  	End IF

			 End If


			' Escalation Bit Set Check
			' This will query if the escalation bit is set and if the ContinueToEscalate Rule is set to false
			' and if both conditions are true, the ContinueToEscalateCheck will be set to YES

				ContinueToEscalateCheck = "YES" ' Yes, indicates it is okay to escalate

			If CaseAlreadyEscalated AND rstemp5("ContinueToEscalate") = FALSE Then
				ContinueToEscalateCheck = "NO"
			End If

				If MinutesDiff >= Cint(rstemp5("EscalationInterval")) Then
					IntervalCheck="YES"
				Else
					IntervalCheck = "NO"
				End If

				If CaseGroup  = rstemp5("OriginalAssignedGroup") Then
					GroupCheck = "YES"
				End IF

				IF CasePriority <= rstemp5("OriginalMinimumPriority") or rstemp5("OriginalMinimumPriority") = "" Then
					PriorityCheck = "YES"
				End IF

				If CaseStatus = rstemp5("OriginalStatus")  or (rstemp5("OriginalStatus")= 4) Then
					StatusCheck = "YES"
				End IF

				If IntervalCheck = "YES" AND GroupCheck= "YES" AND PriorityCheck = "YES" and  StatusCheck = "YES" AND EscalateIfTechAssignedCheck = "YES" AND ContinueToEscalateCheck = "YES" Then
					EscalateCase = "YES"
				End If

				EscalationEmail  = rstemp5("EscalationEmail")
				EscalationRuleName = rstemp5("EscalationRuleName")

				NewStatus = rstemp5("NewStatus")
				NewPriority  = rstemp5("NewPriority")
				NewGroup = rstemp5("AssignToNewGroup")
				EscalationHistoryMessage = rstemp5("EscalationHistoryMessage")

				'debug

				' Checking through rules

	If EscalateDebugFlag = "YES" Then

				response.write "<hr>Checking Rule: <B>" & EscalationRuleName & "</b><br>"
				response.write "EscalationInterval=" & rstemp5("EscalationInterval") & "<br>"


				response.write "IntervalCheck=" & IntervalCheck & "<br>"
				response.write "GroupCheck = " & GroupCheck & "<br>"
				response.write "PriorityCheck = " & PriorityCheck & "<br>"
				response.write "StatusCheck = " & StatusCheck & "<br>"
				response.write "EscalateIfTechAssignedCheck = " & EscalateIfTechAssignedCheck & "<br>"
				response.write "ContinueToEscalateCheck= " & ContinueToEscalateCheck & "<br>"
				response.write "Final Escalate Case Status: "
				if EscalateCase = "YES" Then
					response.write "<font color=RED>YES -  escalated</font><br><hr>"
				else
					response.write "<font color=GREEN>NO - NOT escalated</font><br><hr>"
				End if


	End If

				rstemp5.MoveNext
			loop

	rstemp5.close
	set rstemp5=nothing
	' do not close the connection

	'If escalation was found then put a link into the table

		If EscalateCase = "YES" Then

			Escalate_Case_Number = rstemp6("Case_Number")


				Existcase_Count = ExistCase_Count + 1

			' Display the information in the table
%>

			<tr><td align=center bgcolor=F0C0E0><font size=-1>
			<a HREF="TCaseForm.asp?b_get_x=0&b_get_y=0&customer_id=0&case_number=<%=escalate_Case_number%>" target="user_screen"><%=escalate_Case_Number%></a>
&nbsp;&nbsp;&nbsp;

			<a HREF="TCaseForm.asp?b_get_x=0&b_get_y=0&customer_id=0&case_number=<%=escalate_case_number%>" target="newcasewindow<%=escalate_Case_number%>"><img SRC="newwindow.gif" BORDER=0 ></a>

			</td>

			<td align=center bgcolor=F0C0E0><font size=-1><%=rstemp6("case_One_Line")%></font></td>

			<td align=center bgcolor=F0C0E0><font size=-1><%=EscalationRuleNAme%></td>
			</tr>

<%

				If EscalateDebugFlag = "YES" Then

							Response.write "Escalating Case= " & Escalate_Case_number
				End If


				' First escalate the case by updating case history, group assignment, etc


				EscalateUpdateNewCase Escalate_Case_Number, NewGroup, NewStatus, NewPriority, EscalationHistoryMessage

				' Send Email to New Case Escalation email
				If EscalationEmail <> "" Then
					'response.write "Sending Email for case " & Escalate_Case_number & "To user " & NewCase_Email
					SendEscalationEmail Escalate_Case_Number , EscalationEmail
				End If


			End If ' IF escalated based on time interval or other criteria



			rstemp6.MoveNext
		loop

		Else ' No records found

		End If

		rstemp6.close
		set rstemp6=nothing

		' End of Existing Case Escalation

		End IF  ' End of If Existcase_Enable = "YES"


%>

	</table>


</BODY>
</HTML>



<%End If ' End of security checks %>

<% ' Functions to Escalate Cases %>

<%Sub CreateTimeDateValues( DateString, TimeString, DateTimeString)
'	This Sub creates the TimeDate values that are used
' 	when adding or updating the case record

	' We must very carefully create the date string that we are going to
	' use in the SQL instruction since the system can easily
	' return incorrect values like 9/12/99 or 09/12/1999
	' depending upon their regional settings so this code
	' will hopefully extract the right values.


	' Compute the new Date and Time based on Server Time Zones plus
	' or minus the Time Zone Adjustments.  The time difference between
	' the Server Time and time where the web transaction is taking
	' placing is set by the variable called TimeZoneAdjustment

	'TimeZoneAdjustment = 0 ' Set this +/- Server Time Zone

	'TimeZoneAdjustment is set in the System Configuration Menu
	' Stored in Database as String
	If TimeZoneAdjustment = "" Or IsNull(TimeZoneAdjustment) Then
		TimeZoneAdjustmentInt = 0
	Else
		TimeZoneAdjustmentInt = CInt(TimeZoneAdjustment)
	End If

	' Time Zone Label is also stored in configurable table in DB

	'TimeZoneLabel = "(PST)"

	NewDate = DateAdd("h", TimeZoneAdjustmentInt, Now)

	CurrentDateFormatted = CStr(Year(NewDate))

	If len(CStr(Month(Date))) < 2 then
		CurrentDateFormatted = CurrentDateFormatted & "0" & CStr(Month(NewDate))
	Else
		CurrentDateFormatted = CurrentDateFormatted & CStr(Month(NewDate))
	End If

	If len(CStr(Day(Date))) < 2 then
		CurrentDateFormatted = CurrentDateFormatted & "0" & CStr(Day(NewDate))
	Else
		CurrentDateFormatted = CurrentDateFormatted & CStr(Day(NewDate))
	End If

	DateString = CurrentDateFormatted ' In YYYYMMDD format

	' Now Create the time string in the format of HHMMSS

	TimeString = Right("0" & Hour(time), 2) & Right("0" & Minute(time),2) & Right("0" &Second(time),2)
	TimeString = Right("0" & DatePart("h",NewDate), 2) & Right("0" & DatePart("n", NewDate),2) & Right("0" & DatePart("s", NewDate),2)

	DateTimeString= Date & " " & time

	DateTimeString =    WeekDayName(Weekday(NewDate)) & " " & MonthName(Month(NewDate)) & " " & Day(NewDate) & ", " & Year(NewDate) & " " & Time
	DateTimeString =    WeekDayName(Weekday(NewDate)) & " " & MonthName(Month(NewDate)) & " " & Day(NewDate) & ", " & Year(NewDate) & " "
	' Now computer the time in HH:MM PM/AM
	HourPart = DatePart("h", NewDate)
	If HourPart > 12 Then
		HourPart = HourPart - 12
		DateTimeString = DateTimeString & HourPart & ":" & Right("0" & DatePart("n", NewDate),2) & " PM " & TimeZoneLabel
	Else
		DateTimeString = DateTimeString & HourPart & ":" & Right("0" & DatePart("n", NewDate),2) & " AM " & TimeZoneLabel
	End IF


	End Sub ' End of CreateTimeDateValues
%>



<% Sub GetDatabaseConfiguration(MaxHistorySize, MaxSummarySize, MaxResolutionSize, smtp_host_address,Standard_reply_to_address, Customer_case_notify, userpagecolor)
	'This function gets the database configuration information
	' including the max size of the history field and
	' the email message appendages


		mySQL2="select * from Configuration"
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			MaxHistorySize = 2000 ' Default to white if record not found
		Else
		    MaxHistorySize =  CLng(rstemp2("max_case_history_size"))
			MaxSummarySize =  rstemp2("max_case_summary_size")
			MaxResolutionSize =  rstemp2("max_case_resolution_size")

			smtp_host_address = rstemp2("smtp_host_address")
			Standard_reply_to_address = rstemp2("Standard_reply_to_address")
			Customer_case_notify = CInt(rstemp2("customer_case_notify"))
			UserPageColor = rstemp2("ts_user_page_color")
		End If

		rstemp2.close
		set rstemp2=nothing


	End Sub ' End of GetdatabaseConfiguration
	%>



<% Sub SendEscalationEmail(Case_Number, Tech_Assigned_Email)
	'	This subroutine sends out a notification email to individual for
	' case escalation.

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL5="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL5)

	If  err.number>0 then
	      response.write "VBScript Errors Occured:" & "<P>"
	      response.write "Error Number=" & err.number & "<P>"
	     response.write "Error Descr.=" & err.description & "<P>"
	      response.write "Help Context=" & err.helpcontext & "<P>"
	      response.write "Help Path=" & err.helppath & "<P>"
	      response.write "Native Error=" & err.nativeerror & "<P>"
	      response.write "Source=" & err.source & "<P>"
	      response.write "SQLState=" & err.sqlstate & "<P>"


	else
	      ' response.write "No VBScript Errors Occured" & "<P>"
	end if


	IF  conntemp.errors.count> 0 then
	    response.write "Database Errors Occured" & "<P>"
		for counter= 0 to conntemp.errors.count
		      response.write "Error #" & conntemp.errors(counter).number & "<P>"
		      response.write "Error desc. -> " & conntemp.errors(counter).description & "<P>"
		next

	else
	      ' response.write "No Database Errors Occured!" & "<P>"
	end if



		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1
			Tech_ID = ""

		Else
			' Get all of the information while we are here

			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Tech_ID = rstemp2("Tech_ID")
			Customer_ID = rstemp2("Customer_ID")
			PriorityID = rstemp2("Severity")

			' Perform another query to get the Priority text
			mySQL6="SELECT * from Priority where PriorityID = " & PriorityID
			set rstemp4=conntemp.execute(mySQL6)

			PriorityText = rstemp4("ShortDesc")
			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			' Perform another query to get the Tech's Full Name

			If IsNull(Tech_ID) = False OR Tech_ID <> "" Then
				mySQL6="SELECT * from Tech_staff where Tech_ID = '" & Tech_ID & "'"
				set rstemp4=conntemp.execute(mySQL6)

				If rstemp4.EOF <> True Then
				Tech_Full_Name =  rstemp4("First_name") & " " & rstemp4("Last_name")
			    End If

			    ' Close record set

			   rstemp4.close
			   set rstemp4 = nothing
			End If


			'******* CELL PHONE EMAIL TEXT FIELDS *****************************
			' Perform another query to get the customer information so
			' it can be displayed in the email for text page cell phone email
			' We will grab the two phone numbers and company name

			mySQL6="SELECT * from Customers where customer_id = '" & Customer_ID & "'"
			set rstemp4=conntemp.execute(mySQL6)


			CustomerCompany = rstemp4("Company")
			CustomerPhone1 = rstemp4("Phone1")
			CustomerPhone2 = rstemp4("Phone2")


			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			'********** CELL PHONE EMAIL TEXT FIELD ENDING

		End If

		rstemp2.close
		set rstemp2=nothing


			Message = ""

			' Now Build the Whole message body
			' *********************** USER CUSTOMIZATIONS**********************
			' The fix part of the message that is sent out can be modified by
			' changing the text below.


			Message = Message & vbCRLF & wc_Case_capital_letters & " " & case_number & "  " & wc_Case_Escalation_Notification_for_case & vbCRLF

			' Now display a link directly to the tech+center for that case window.

			' Get the full server http URL for the direct LINK.
		 For each key in Request.serverVariables

			if Key = "SERVER_NAME" Then
				HostName =  Request.ServerVariables(key)
			End IF

			if Key = "SCRIPT_NAME" Then
				SCRIPT_Name =  Request.ServerVariables(key)
				' Replace DoEmailListSend.asp with RemoveFromList.asp
				' This will handle all of the necessary virtual directory mappings

				' Make this subsitution case insensitive with the 1,99,1

				'Virtual_Path = replace(Script_Name, "escalation.asp", "SC.asp")
				Virtual_Path = replace(Script_Name, "escalation.asp", "SC.asp",1,99,1)

			End IF

		Next

			Message = Message & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF
			Message = Message &  "http://" &  hostname & Virtual_path &"?ID=" & Tech_ID & "&N=" & Case_Number & vbCRLF

				' Create Case Link for HTML message
			CaseLink = "http://" &  hostname & Virtual_path &"?ID=" & Tech_ID & "&N=" & Case_Number


			Message = Message & vbCRLF & wc_Tech_assignment & Tech_Full_Name & vbCRLF

			Message = Message & wc_Case_Number_capital_letters  & Case_Number & vbCRLF
			Message = Message & wc_Case_Status_capital_letters

			If CInt(Status) = 1 Then
				Message = Message & wc_Closed & vbCRLF
			ElseIf CInt(Status) = 0 Then
				Message = Message & wc_Open_Active & vbCRLF
			ElseIf CInt(Status) = 2 Then
				Message = Message & wc_Open_Waiting	& vbCRLF
			ElseIf CInt(Status) = 3 Then
				Message = Message & wc_Open_On_Hold & vbCRLF
			End If
			Message = Message & wc_Priority_capital_letters & PriorityText & vbCRLF

			Message = Message & wc_Customer_ID_capital_letters & Customer_ID & vbCRLF
			Message = Message & wc_Phone_numbers_capital_letters & CustomerPhone1 & "/" & CustomerPhone2 & vbCRLF

			Message = Message & wc_Case_description_capital_letters & Case_One_Line & vbCRLF

			Message = Message & CategoryText ' Display category text

			' The special color codes have to be removed before sending the case_history

			Case_Text = Case_History
			Case_History = CleanUpHistoryText(Case_Text)
			Message = Message & wc_Case_History & ": " & vbCRLF & Case_History & vbCRLF

			If Case_Summary <> "" Then
				Message = Message & wc_Case_summary_head & vbCRLF & Case_Summary & vbCRLF
			End IF
			If Case_Resolution <> "" Then
				Message = Message & wc_Case_Resolution_head & vbCRLF & Case_Resolution & vbCRLF
			End If

			' Do not remove this line.
			Message = Message & EmailChecksum

	'wc_Case_email_subject1        		= "*** Case "
	'wc_Case_email_subject2			= " Escalation Notification ***"

		' 06/04/13	SubjectLine = wc_Case_email_subject1 & Case_Number & wc_Case_email_subject2

			SubjectLine = wc_Case_email_subject1 & Case_Number & " -- " & Case_One_Line & " -- " & wc_Case_email_subject2  ' 06/04/13

			' Now we have everything we need to send the email to the tech
			' Only send the message if ToEmail exists and

			If HTMLEmail = "YES" Then

				'NotificationReportTitle = wc_Notification_Report_Assigned_Tech_update
				NotificationReportTitle = wc_Notification_Report_Case_Escalation


				AltBody = Message ' First save Text message into separate variable
				Message = CreateHTMLTechMsg(Case_Number, CaseLink, NotificationReportTitle)

				' Debugging
				'response.write Message


			End IF





			If Tech_Assigned_Email <> ""   Then
				'Response.write "Sending Email for Escalation"

			   If MyOS = "Windows" Then
				 SendEmail Tech_Assigned_Email, "", SubjectLine, Message
			   Else
				 SendLinuxEmail Tech_Assigned_Email, "", SubjectLine, Message
			   End If

			End If




End Sub ' End of SendEscalationEmail() subroutine
%>

<% Sub EscalateUpdateNewCase(Case_Number, NewGroup, NewStatus, NewPriority, EscalationHistoryMessage)

' This sub will perform the necessary updating to the case by:
'	(1) Updating the Mod Time with the current time and Date
'	(2) Upating the history showing that the case was escalated
'	(3) Show that the group was modifed to specified group if needed
'   (4) Updating the prioirty and note it in history
'   (5) Update the case status
'   (6) List in the case history the EscalationHistoryMessage for this rule
'   (7) Important - Set the EscalatedBit to True for this case



	' First create the Date and Time strings

	CreateTimeDateValues DateString, TimeString, DateTimeString


	' Check to see if case_number exists then this is an update


		Set NewRecord = Server.CreateObject("ADODB.Recordset")

		If Case_Number = "0" Then
			SQL = "Select * from Cases"
		Else
				SQL = "Select * from Cases where case_number = " & case_number
		End IF

		'response.write SQL
		'response.write "Escalating/Updating Case: " & Case_Number

		NewRecord.Open SQL,Conntemp,3,3

		' We should only need to do existing case updates

			NewRecord("modified_flag") = 1
			NewRecord("mod_date") = DateString ' YYYYMMSS
			NewRecord("mod_time") = TimeString ' HHMMSS

			' Set the escalation Bit - Version 8.0 change

			NewRecord("Escalated") = True ' Set it to true from false or null


			'NewRecord("Case_One_Line") = Case_One_Line

			' *************************************************************
			' Only a limited set of fields will be updated by escalation!
			' Fields include:
			'   Priority
			'   Status
			'   Group
			'   Case History

			'**************************************************************


			' Set New Status and Priority and group if they exist

			If (NewStatus <> 4) Then
				NewRecord("Status") = NewStatus
			End If


			Current_Case_History = NewRecord("Case_History")

			' Make sure we are not exceeding the size of the case_history field.

			' Append to the bottom of the case

			New_Case_History = Current_Case_History &	vbCRLF & "{r[" &  DatetimeString &  " Updated by [Advanced Escalation]["& EscalationHistoryMessage & "] ]r}"  &  vbCRLF

			' Now Add in any info about changed records for Tech, Status, group and priority
			Old_Group_Number = Cint(NewRecord("Group_Number"))


			' NewGroup is passed as a parameter to this sub

			If NewGroup <> 0 Then

				If Old_Group_Number <> NewGroup then
					NewGroupName = GroupFullName(NewGroup)
					GroupChanged = "YES"
					New_Case_History = New_Case_History &  wc_Case_Escalation_changed_group_to  & NewGroupName & vbCRLF

					' Reset the group to the new escalation group
					NewRecord("Group_Number") = NewGroup

				End IF
			End IF ' Only process new group if group is not zero

			Old_Priority = CStr(NewRecord("Severity"))
			If Old_Priority <> NewPriority then
			' Get new priority name


			mySQL8="select * from Priority where PriorityID =  " & NewPriority
			set rstemp8=conntemp.execute(mySQL8)

			' Check to see if any records are returned
			' if none found the
			if rstemp8.EOF then
				PriorityFullDescription = "Priority Not Defined"
			Else
				PriorityFullDescription = rstemp8("ShortDesc")
			End If

			rstemp8.close
			set rstemp8=nothing

			' Set the new priority into the case if not equal
				NewRecord("Severity") = Cint(NewPriority)


				NewPriorityString = PriorityFullDescription

				New_Case_History = New_Case_History & wc_Case_priority_changed_to    & NewPriorityString & vbCRLF
			End IF


			New_Case_History = New_Case_History  & wc_Case_History & ": " & vbCRLF & Case_History & vbCRLF
			If Len(New_Case_History) < (MaxHistorySize - 10) Then ' Only update is size is ok.
				NewRecord("Case_History") = New_Case_History
			Else
				Response.Write wc_Case_History_size_of & Len(New_Case_History) & wc_exceeds_maximum_value_of & MaxHistorySize - 10 & "<br>"
			End If


			' Update Summary and Resolution Fields
			' Limit the size based on the max case resolution and summary sizes

			' Only update these fields if the case_resolution or
			' case_summary is not empty.  DO NOT RESET these
			' from their null values

			If Case_Resolution <> "" Then
				NewRecord("Case_Resolution") = Mid(Case_Resolution, 1, MaxResolutionSize - 5)
			End If

			IF Case_Summary <> "" Then
				NewRecord("Case_Summary") = Mid(Case_Summary, 1, MaxSummarySize - 5)
			End IF

		NewRecord.Update

	If  err.number>0 then
	      response.write "VBScript Errors Occured:" & "<P>"
	      response.write "Error Number=" & err.number & "<P>"
	      response.write "Error Descr.=" & err.description & "<P>"
	      response.write "Help Context=" & err.helpcontext & "<P>"
	      response.write "Help Path=" & err.helppath & "<P>"
	      response.write "Native Error=" & err.nativeerror & "<P>"
	      response.write "Source=" & err.source & "<P>"
	      response.write "SQLState=" & err.sqlstate & "<P>"
	else
	'      response.write "No VBScript Errors Occured" & "<P>"
	end if


	IF  conntemp.errors.count> 0 then
	    response.write "Database Errors Occured" & "<P>"
		for counter= 0 to conntemp.errors.count
		      response.write "Error #" & conntemp.errors(counter).number & "<P>"
		      response.write "Error desc. -> " & conntemp.errors(counter).description & "<P>"
		next
	else
	      'response.write "No Database Errors Occured!" & "<P>"
	end if

	NewRecord.Close
	Set NewRecord = Nothing


	End Sub

%>


<% Sub SendEscalationCellEmail(Case_Number, Email_Address)

	' First we determine if case has a tech assigned to it.

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL7="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL7)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1
			Tech_ID = ""

		Else
			' Get all of the information while we are here

			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Tech_ID = rstemp2("Tech_ID")
			Customer_ID = rstemp2("Customer_ID")
			PriorityID = rstemp2("Severity")

			' Perform another query to get the Priority text
			mySQL8="SELECT * from Priority where PriorityID = " & PriorityID
			set rstemp4=conntemp.execute(mySQL8)

			PriorityText = rstemp4("ShortDesc")
			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			'******* CELL PHONE EMAIL TEXT FIELDS *****************************
			' Perform another query to get the customer information so
			' it can be displayed in the email for text page cell phone email
			' We will grab the two phone numbers and company name

			mySQL8="SELECT * from Customers where customer_id = '" & Customer_ID & "'"
			set rstemp4=conntemp.execute(mySQL8)


			CustomerCompany = rstemp4("Company")
			CustomerPhone1 = rstemp4("Phone1")
			CustomerPhone2 = rstemp4("Phone2")


			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			'********** CELL PHONE EMAIL TEXT FIELD ENDING

		End If

		rstemp2.close
		set rstemp2=nothing


		'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************
		' To enable a short condensed email to be sent to a tech cell email address/home email
		' beginning of the email message, comment/uncomment the
		' variable definition below
		CELLPHONE_EMAIL_NOTIFICATION = "YES" ' Comment out this line to disable
		'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************

		If CELLPHONE_EMAIL_NOTIFICATION = "YES" Then
			CellMessage = ""
			CellMessage = CellMessage & Customer_ID & vbCRLF & CustomerCompany & vbCRLF &vbCRLF
			CellMessage = CellMessage & CustomerPhone1 & vbCRLF  & CustomerPhone2  & vbCRLF
			CellMessage = CellMessage & "->" & Case_One_Line & vbCRLF
			CellSubjectLine = wc_Alert
		End If


	   If MyOS = "Windows" Then
		  SendEmail Email_Address, "", CellSubjectLine, CellMessage
	   Else
	     SendLinuxEmail Email_Address, "",  CellSubjectLine, CellMessage
	   End If




End Sub ' End of SendEscalationCellEmail() subroutine
%>


<% Function GroupFullName(Group_Number)
	'This function gets the full name of the Passed Group Number
		If Group_Number = "" Then
			GroupFullName = "Default Group"
		Else

			mySQL8="select * from Group_list where Group_Number = " & Group_Number
			set rstemp2=conntemp.execute(mySQL8)

			' Check to see if any records are returned
			' if none found the
			if rstemp2.EOF then
				GroupFullName = "Group Not Defined"
			Else
				GroupFullName = rstemp2("Group_Name")
			End If

			rstemp2.close
			set rstemp2=nothing


		End If

	End Function ' End of GroupFullName
%>


<% Function CleanUpHistoryText(Case_Text)
' This functions removes all of the special color coding codes
' that exists in the case_history field so when the email is sent it sends
' it without all of those funny colors.


' This subroutines formats the case_text with the proper color coding conventions

NewText = Case_Text
	' Tags entered by the user can be security issue so we will replace
	' them with printable html text of &lt; and & gt;


		' Replace the special color coding characters

		NewText = Replace (Newtext, chr(10), vbCRLF)

		NewText = Replace (NewText, "{g[", "")

		NewText = Replace (NewText, "{r[", "")

		NewText = Replace (NewText, "]r}", "")

		NewText = Replace (NewText, "]g}", "")

'		NewText = Replace (NewText, vbLF, vbCRLF)

		' There are some places where we have put LFCR
		' at the end of the end of the lines in techcenter
'		NewText = Replace (NewText, vbLF & vbCR, vbCRLF)

		' Other places have just LF (10)
'		NewText = Replace (Newtext, vbCR, vbCRLF)

	CleanUpHistoryText = NewText

'	For i = 1 to len(NewText)
'		NewMessage  = NewMessage & mid(NewText,i,1)
'		NewMessage = NewMessage & "[" & asc(mid(NewText,i,1)) & "]"
'	next

'	response.write NewMessage


'	CleanUpHistoryText = Case_Text

End function
%>


