<% 'Module: AssetNumberAssistRobust.asp

   'Description: This module is the Tech+Center AssetNumber Asset page
   ' that is invoked into a sub-window to help the user select a given asset
   ' It searches the database based on user-supplied values and then allows the user
   ' to click on a generated line which in turn causes the appropriate asset number value
   ' to be passed back to the invoking "main" window where it is placed into the Formfield
   ' without otherwise disturbing the latter. It uses javascript to achieve this function.


   '(C) 2000,2001, 2002 2003, 2004 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------		---		------------------------------------------------
   '4/3/2004	JC		Created original module
   '5/5/2010 	SAV		Copied JC module
   '09/15/2011  CMB     Needed a module that returned serial number and computer id as well; it only
   '                    will work correctly if called from tcaseform since it updates several fields
   '                    in that screen as well as changing visibility of several of the asset-related controls.
   '10/25/2011  CMB     Dont' show search option for labels that aren't defined; added serial number and building
   '03/30/12    CMB     Property tag misspelled in search string
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->

<%' Include this file for special database cursor constants %>

<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->
<!-- #INCLUDE FILE="../Language/AssetLabels.inc" -->


<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 2 ' Allow any tech  to access this function.

	CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN") ' Get the Logged TechID from the cookie

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="SELECT * from Tech_staff where Tech_ID = '" & CookieID & "' AND Tech_Level >= " & TechLevel
		set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF  = True Then

			%>
			<html>
			<head>
			<title>Invalid User</title>
			</head>
			<body bgcolor=beige>
			<p><font size=+2 color=red>
			   You do not have authorization to use this program - please Login first<p>
			   </font>
			</body>
			</html>
			<%

			response.flush
			response.end
		End If

		rstemp.close
		set rstemp=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing

 ' End of ASP page security checks
 %>





<% ' Display the Customer Search Form %>


<html>
<head>
	<title>Asset Number Assist</title>
    <!-- #INCLUDE FILE="Stylesheet.inc" -->




<script language="javascript">
function writeValue(recept,recept2,recept3){
	if(opener == null)
		document.write('<h5>We do not see opener</h5>');
	else
		{
		window.opener.document.getElementById("tr1").style.visibility="visible";
		window.opener.document.getElementById("tr2").style.visibility="visible";
		window.opener.document.getElementById("AssetInfoLink2").style.visibility="visible";
		window.opener.document.getElementById("AssetInfoLink1").style.visibility="visible";
		window.opener.document.getElementById("imgSame").style.visibility="visible";
		window.opener.document.getElementById("imgNew").style.visibility="visible";
		window.opener.document.myform.asset_number.value = recept;
		window.opener.document.myform.computer_ID.value = recept2;
		window.opener.document.myform.Serial_number.value = recept3;
		window.opener.document.getElementById("AssetInfoLink1").href = "AssetInfo.asp?asset_Number="+ recept;
		window.opener.document.getElementById("AssetInfoLink2").href = "AssetInfo.asp?asset_Number="+ recept;
	     window.close();
	     }
	return;
}
</script>


<!-- The following style is necessary to prevent all kinds of ugly underlines appearing on the sreen on every selection line,
because they are in fact URL's - but the user doesn't need to know that and it makes it really hard to read -->

<style>
#TagA {
          text-decoration: none;
          font-family: 'Trebuchet MS', 'Comic Sans MS', 'Arial', 'Sans-Serif';
          font-size: 12;
          color: black
          }


.inputbox { color: black;
           font-family: "Verdana, Geneva, Arial, Helvetica";
           font-size: 12;
		  }



.screentitle { color: black;
          font-family: "Verdana, Geneva, Arial, Helvetica";
          font-size: 16;
          font-weight: bold;
		  }

.tablewrapper {
		border-width: 2px;
		border-style: solid;
		border-color: #000000;
		background-color: #eeeeee;
		padding-top: 5px;
		padding-bottom: 5px;
		padding-left: 5px;
		padding-right: 5px;
		}


.screentitlewrapper {
		padding-top: 0px;
		padding-bottom: 5px;
		}

.liner {
          	border-top-width: 0px;
	  		border-bottom-width: 1px;
	  		border-left-width: 0px;
	  		border-right-width: 0px;
	  		border-style: solid;
	  		border-bottom-color: gray;
		    padding-left: 0px;
		    padding-right: 0px;
		    padding-top: 0px;
		    padding-bottom: 0px;
		}

.colhead { color: white;
          background-color: #053E5B;
          font-family: "Verdana, Geneva, Arial, Helvetica";
          font-size: 12;
          font-weight: bold;
          padding-top: 1px;
		  padding-bottom: 1px;
		  }
</style>

</head>
<body class=popup-assist>
<% If request.form("invoked") = "" Then ' Only put out screen title if freshly invoked - to save real estate %>
	<center>
	<Table  class=screentitlewrapper><tr><td>
	<div class=screentitle>
	 <%=wc_Search_For_Asset%>
	</div>
	</tr></td></table>
	</center>
<% end if %>

<%

searchvalue = request.form("searchval")
searchoption = request.form("searchoption")


%>


<center>
<table class=innerformwrapper>
<tr>
	<form action=AssetNumberAssistRobust.asp method=post>
	  <td class=formlabel>
		<input type=hidden size=3 name=invoked value="Yes">
		<%=wc_Find_Asset_Where%></td>
		<td class=formboxholder>
		<select name=searchoption class=inputbox>
		 <% if computer_id_Label > "" then %>

		   <option value="computer_id"
			  <% if searchoption = "computer_id" then
				  response.write "selected"
				 end if %>
			  ><%=Computer_ID_label%>
		<% end if %>

			 <% if Description_Label > "" then %>
		   <option value="equipment_type"
			   <% if searchoption = "equipment_type" then
				  response.write "selected"
				  end if %>
			  ><%=Description_Label%>

			 <% end if %>

			 <% if Property_tag_label > "" then %>
		   <option value="property_tag"
			   <% if searchoption = "property_tag" then
				  response.write "selected"
				  end if %>
			  ><%=Property_tag_label%>
			 <% end if %>

	 <% if custom_field_1_label > "" then %>
	 <option value="custom_field1"
			   <% if searchoption = "custom_field1" then
				  response.write "selected"
				  end if %>
			  ><%=custom_field_1_label%>
		<% end if %>

			 <% if Location_Label > "" then %>
		   <option value="location"
			   <% if searchoption = "location" then
				  response.write "selected"
				  end if %>
			  ><%=Location_Label%>

			 <% end if %>


			 <% if serial_number_label > "" then %>
		   <option value="serial_number"
			   <% if searchoption = "serial_number" then
				  response.write "selected"
				  end if %>
			  ><%=serial_number_Label%>

			 <% end if %>

		</select>
		</td>
		<td class=formlabel><%=wc_Starts_with_the_letters%></td>
		<td class=formboxholder><input type=text  class=inputbox size=5 name="searchval" value="<%=searchvalue%>"></td>
		<td><input type=submit class=inputbox name=submit value="Go"></td>
	  </td>
	</form>
</tr>
</table>
</center>

<%

If request.form("invoked") = "" Then ' initial call - just display form and and intial help text
    %>
    <blockquote>
     <p> &nbsp; <p> &nbsp; <p><%=wc_Customer_ID_Search_Assistance_help_block%>


	</blockquote>
    <%
Else'    Control only reaches this point if the form was actually "submitted"




If searchvalue <> "" Then

    searchvalue = searchvalue & "%"

    searchvalue = Replace(searchvalue, "'", "''")


	if searchoption = "computer_id" Then
	   SQL = "SELECT * From Assets WHERE Computer_ID LIKE '" & searchvalue & "' order by computer_id"
	End If


	if searchoption = "property_tag" Then
	   SQL = "SELECT * From Assets WHERE property_tag LIKE '" & searchvalue & "' order by property_tag"  ' 03/30/12 misspelled
	End If


	if searchoption = "equipment_type" Then
	   SQL = "SELECT * From Assets WHERE equipment_type LIKE '" & searchvalue & "' order by equipment_type"
	End If


	if searchoption = "location" Then
	   SQL = "SELECT * From Assets WHERE location LIKE '" & searchvalue & "' order by location"
	End If

	if searchoption = "custom_field1" Then
	   SQL = "SELECT * From Assets WHERE custom_field1 LIKE '" & searchvalue & "' order by custom_field1"
	End If

	if searchoption = "serial_number" Then
	   SQL = "SELECT * From Assets WHERE serial_number LIKE '" & searchvalue & "' order by serial_number"
	End If



Else ' we have an empty search string - so return whole database


	if searchoption = "computer_id" Then
	   SQL = "SELECT * From Assets  order by computer_id"
	End If


	if searchoption = "property_tag" Then
	   SQL = "SELECT * From Assets  order by property_tag"
	End If


	if searchoption = "equipment_type" Then
	   SQL = "SELECT * From Assets  order by equipment_type"
	End If


	if searchoption = "location" Then
	   SQL = "SELECT * From Assets  order by location"
	End If

	if searchoption = "custom_field1" Then
	   SQL = "SELECT * From Assets  order by custom_field1"
	End If

	if searchoption = "serial_number" Then
	   SQL = "SELECT * From Assets  order by serial_number"
	End If



End If

  '   response.write SQL & "<P>"

	set conntemp=server.createobject("adodb.connection")
	conntemp.open MyDSN

	set rstemp=conntemp.execute(SQL)

	If rstemp.eof Then
	    %>
	   <center>
	      <p> &nbsp; <p> &nbsp; <p><%=wc_No_records_found%>
	   </center>
	   <%

	Else
	Response.write "<br><Center>" & wc_Click_on_desired_asset & "<p>"


	    if searchoption = "computer_id" Then
	           %>
	            <table cellpadding=0 cellspacing=0>
	              <tr>
	               <td class=colhead align=center><%=computer_id_Label%></td>
		            <td class=colhead align=center><%=property_tag_label%></td>
	               <td class=colhead align=center><%=description_label%></td>
		            <td class=colhead align=center><%=Serial_Number_Label%></td>
		              </tr>
	           <%
			Do while (Not rstemp.eof)
					%>
					<tr>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><b><%=rstemp("computer_id")%></b>&nbsp;&nbsp;</a></td>

					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><%=rstemp("property_tag")%></a></td>

					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><%=rstemp("equipment_type")%>&nbsp;&nbsp;</a></td>

					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><b><%=rstemp("Serial_Number")%></b>&nbsp;&nbsp;</a></td>

					</tr>
					<%

					rstemp.Movenext
			Loop
			Response.write  vbcrlf & "</table>"
		end if



	    if searchoption = "equipment_type" Then
	           %>
	            <table cellpadding=0 cellspacing=0>
	              <tr>
	               <td class=colhead align=center><%=description_label%></td>
	               <td class=colhead align=center><%=computer_id_Label%></td>
	               <td class=colhead align=center><%=property_tag_label%></td>
	               <td class=colhead align=center><%=Serial_Number_Label%></td>
	              </tr>
	           <%
			Do while (Not rstemp.eof)
					%>
					<tr>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><b><%=rstemp("equipment_type")%>&nbsp;&nbsp;</a></td>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><%=rstemp("computer_id")%></b>&nbsp;&nbsp;</a></td>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><%=rstemp("property_tag")%></a></td>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><b><%=rstemp("Serial_Number")%></b>&nbsp;&nbsp;</a></td>
					</tr>
					<%

					rstemp.Movenext
			Loop
			Response.write  vbcrlf & "</table>"
		end if


	    if searchoption = "property_tag" Then
	           %>
	            <table cellpadding=0 cellspacing=0>
	              <tr>
	               <td class=colhead align=center><%=property_tag_label%></td>
	               <td class=colhead align=center><%=description_label%></td>
	               <td class=colhead align=center><%=computer_id_Label%></td>
 					<td class=colhead align=center><%=Serial_Number_Label%></td>
	              </tr>
	           <%
			Do while (Not rstemp.eof)
					%>
					<tr>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><%=rstemp("property_tag")%></a></td>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><%=rstemp("equipment_type")%>&nbsp;&nbsp;</a></td>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><b><%=rstemp("computer_id")%></b>&nbsp;&nbsp;</a></td>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><b><%=rstemp("Serial_Number")%></b>&nbsp;&nbsp;</a></td>
					</tr>
					<%

					rstemp.Movenext
			Loop
			Response.write  vbcrlf & "</table>"
		end if

	    if searchoption = "location" or searchoption = "serial_number" Then
	           %>
	            <table cellpadding=0 cellspacing=0>
	              <tr>
	               <td class=colhead align=center><%=computer_id_Label%></td>
		           <td class=colhead align=center><%=property_tag_label%></td>
	               <td class=colhead align=center><%=description_label%></td>
		           <td class=colhead align=center><%=Serial_Number_Label%></td>
		          </tr>
	           <%
			Do while (Not rstemp.eof)
					%>
					<tr>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><b><%=rstemp("computer_id")%></b>&nbsp;&nbsp;</a></td>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><%=rstemp("property_tag")%></a></td>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><%=rstemp("equipment_type")%>&nbsp;&nbsp;</a></td>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><b><%=rstemp("Serial_Number")%></b>&nbsp;&nbsp;</a></td>
					</tr>
					<%

					rstemp.Movenext
			Loop
			Response.write  vbcrlf & "</table>"
		end if


	    if searchoption = "custom_field1" Then
	           %>
	            <table cellpadding=0 cellspacing=0>
	              <tr>

	               <td class=colhead align=center><%=custom_field_1_label%></td>
	               <td class=colhead align=center><%=description_label%></td>
	               <td class=colhead align=center><%=computer_id_Label%></td>
					<td class=colhead align=center><%=Serial_Number_Label%></td>
	              </tr>
	           <%
			Do while (Not rstemp.eof)
					%>
					<tr>

					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><%=rstemp("custom_field1")%></a></td>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><%=rstemp("equipment_type")%>&nbsp;&nbsp;</a></td>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><b><%=rstemp("computer_id")%></b>&nbsp;&nbsp;</a></td>
					   <td valign=top class=liner><a id=Taga href="javascript:writeValue('<%=rstemp("asset_number")%>','<%=rstemp("computer_id")%>','<%=rstemp("Serial_Number")%>');"><b><%=rstemp("Serial_Number")%></b>&nbsp;&nbsp;</a></td>

		</tr>
					<%

					rstemp.Movenext
			Loop
			Response.write  vbcrlf & "</table>"
		end if



	End if ' not immediate eof
%>





<%
end if ' the form was actually invked
%>

<% ' the following function (which is invoked automatically every time the window is loaded because it is "in-line code") is
   ' necessary to prevent user-confusion - by allways forcing this sub-window to the front when it is invoked.
   ' If you don't have it and the user by chance clicks on the main window befor using it (this subwindow) and then clicks again on the assist
   ' button, this sub-window will stay hidden behind the main window and cause the user to become absolutely lost...
%>

<SCRIPT language="javascript">
    window.focus();
</SCRIPT>

</body>
</html>
