
<% 'Module: DisplayCasesForAssetNumber.asp

   'Description: This module displays cases associated with this asset number

   '(C) 1998,1999, 2000, 2001, 2002 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '6/25/2000	SAV		Created original MyCases.asp page
   '3/27/05		SAV		Created from MyCases.asp page to show all open cases
   '10/03/2011  CMB     Created from DisplayAllOpenCases.asp; added two includes
   '10/25/2011  CMB     Fixed status display; closed showing as onhold

	' CONSTANTS
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->
<!-- #INCLUDE FILE="../Language/GetPriorityFontColor.inc" -->
<!-- #INCLUDE FILE="Reports.inc" -->
<!-- #INCLUDE FILE="../Language/AssetLabels.inc" -->


<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->

<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 1 'anyone

	If SecurityON = "YES" Then ' Execute this code only if Security Option Flag is set to YES
		' This flag will be set in the db_define.inc file.

		ValidUser=IsValidUser(TechLevel)

		 if ValidUser <> "YES" Then
			 ASPPage = "DisplayCasesForAssetNumber.asp"
		 %>

		<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function

 'Get the value of the User Screen background color
	' And the open Cases refresh rate from the Configuration Table

	set conntemp=server.createobject("adodb.connection")

	conntemp.open myDSN ' Open the connection once here

	mySQL2="select * from Configuration"
	set rstemp2=conntemp.execute(mySQL2)

	' Check to see if any records are returned
	' if none found the
	if rstemp2.EOF then
		UserPageColor = "FFFFFF" ' Default to white if record not found
	Else
		UserPageColor = rstemp2("ts_user_page_color")
		Pending_Screen_Refresh_Rate = rstemp2("Pending_Screen_Refresh_Rate")
		ts_pending_color = rstemp2("ts_Pending_Color")
		WCDateFormat = rstemp2("Date_Display_Format")
		TimeZoneAdjustment = rstemp2("Time_zone_Adjustment")
	End If

	rstemp2.close
	set rstemp2=nothing
	' Do NOT close connection here ... wait until end of module
'	conntemp.close ' Close the connection
'	set conntemp=nothing
%>


<HTML>
<HEAD>

<% If Pending_Screen_Refresh_rate <> 0 Then %>
   <META HTTP-EQUIV="Refresh" CONTENT="<%=Pending_Screen_Refresh_Rate%>">
<%End If %>

   <TITLE><%=wc_Cases_with_Asset_Number%></TITLE>
   <!-- #INCLUDE FILE="Stylesheet.inc" -->


<!-- (C) 1996,1998, 1999, 2000, 2001, 2002-2005 by Internet Software Sciences -->
</HEAD>

<BODY class=topwindow TOPMARGIN=0  MARGINHEIGHT=0 >

<% ' Now search for the open Cases for a specified Asset Number
	' It can be called from the button panel as DisplayCasesForAssetNumber.asp
	' from other Cases, the Asset_Number is passed as a query string

	   Asset_Number = Request.QueryString("Asset_Number")

'		set conntemp=server.createobject("adodb.connection")
'		conntemp.open myDSN

		'  * * * * * * Time Zone Adjustment Calculation * * * * *
		' Late is computed by comparing the Date and time with the system time
		' A special date computation is needed if TimeZoneAdjustment is set.
		If TimeZoneAdjustment = "" Or IsNull(TimeZoneAdjustment) = True Then
				TimeZoneAdjustmentInt = 0
			Else
				TimeZoneAdjustmentInt = CInt(TimeZoneAdjustment)
		End If

		NewDate = DateAdd("h", TimeZoneAdjustmentInt, Now)
		NewDateDateOnly = DateValue(NewDate)
		NewTime = TimeValue(NewDate)

	'	mySQL2="SELECT * from Cases where Asset_Number = " & Asset_Number
		mySQL2 = " SELECT Group_list.group_name, Tech_ID, Due_Date, Due_Time, Cases.case_number, Cases.customer_id, Cases.open_date, Cases.open_time, Cases.mod_date, Cases.mod_time, Cases.case_one_line, Cases.severity, Cases.status, Cases.modified_flag, Customers.contact_lname, Customers.contact_fname, Customers.company FROM Cases, Group_list, Customers WHERE Cases.customer_id=Customers.customer_id AND Cases.group_number = Group_list.group_number AND Cases.customer_id = Customers.customer_id AND Asset_Number = " & Asset_Number
' Added due date and due time? tech_ID
		' Now add Sort Order and toggle sort order if necessary

		SortOrder = Request.Querystring("SortBy")

		' Define Default Sort Orders that will be changed below to
		' toggle the views from Ascending to Decending

		AscendDescend = Request.Querystring("Ascend")
		If AscendDescend = "" Then
			AscendDescend = "ASC"
		End If

		If AscendDescend = "ASC" Then
			AscendDescend = "DESC"
		Else
			AscendDescend = "ASC"
		End If

		If SortOrder = "case_number" OR SortOrder = ""  Then
			FixedSortOrder = " Case_Number "
			Case_Number_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "severity"  Then
			FixedSortOrder = " Severity"
			Severity_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "open_time"  Then
			FixedSortOrder = " Open_Date " & AscendDescend & ", Open_Time "
			Open_time_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "mod_time"  Then
			FixedSortOrder = " mod_Date " & AscendDescend & ", mod_Time "
			mod_time_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "contact_fname"  Then
			FixedSortOrder = " contact_fname "
			contact_fname_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "group_name"  Then
			FixedSortOrder = " group_name "
			group_name_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "Tech_ID"  Then
			FixedSortOrder = " tech_ID "
			Tech_ID_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "status"  Then
			FixedSortOrder = " status "
			status_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "Due_Date"  Then
			FixedSortOrder = " Due_Date " & AscendDescend & ", Due_Time "
			due_date_Background = " bgcolor=FFFFFF "
		End IF

		mySQL2 = mySQL2 & " Order by " & FixedSortOrder  & " " & AscendDescend

		'response.write "MySQL = " & mySQL2 & "<br>"

	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursor for record count to be correct.

	If DatabaseType <> "ACCESS97" Then
		rstemp.CursorLocation = adUseClient
	End If

	rstemp.open mySQL2, conntemp, adopenstatic

	If not rstemp.EOF  Then

		RecordsFound = rstemp.recordcount

	 ' We need to get the tech name directly from the database since we won't have
		' the tech name since no rows were returned NOTE Possibly get other asset info here for display?

		MySQL3 = " Select * from Assets where Asset_Number = " & Asset_Number

		set rstemp2=Server.CreateObject("adodb.Recordset")

		rstemp2.open mySQL3, conntemp, adopenstatic

		If not rstemp2.EOF  Then
			Computer_ID = rstemp2("Computer_ID")
		Else
			Computer_ID = Computer_ID_Label & " Not Defined"
		End IF
		rstemp2.close
		set rstemp2=nothing
	%>
<CENTER>
<table class=TightTableWrapper >
<tr>
<td  width=70% class=MinorScreenTitle nowrap=nowrap><%=RecordsFound %> &nbsp;<%=wc_Cases_with_Asset_Number%>: <%=Asset_Number%> </td>
<td  class=tinyprint> <a href=DisplayCasesForAssetNumber.asp?Asset_Number=<%=Asset_Number%> target=DispatcherWindow>(<%=wc_New_Window%>)</a></td>

</tr>

</table>

<table cellpadding=0 cellspacing=0><tr><td height=0></td> </tr></table> <!-- little spacer  -->

</CENTER>

<% ' Display the Table Headers %>

<TABLE class=TightTableWrapper cellspacing=1>
<TR>
<TD  class=ColumnLabel align=center><A HREF="DisplayCasesForAssetNumber.asp?Asset_Number=<%=Asset_Number%>&SortBy=case_number&Ascend=<%=AscendDescend%>"><%=wc_Case%></A></TD>

<TD  class=ColumnLabel align=center><A HREF="DisplayCasesForAssetNumber.asp?Asset_Number=<%=Asset_Number%>&SortBy=severity&Ascend=<%=AscendDescend%>"><%=wc_P%></A></TD>

<TD  class=ColumnLabel align=center><A HREF="DisplayCasesForAssetNumber.asp?Asset_Number=<%=Asset_Number%>&SortBy=status&Group_Number=<%=Group_Number%>&Ascend=<%=AscendDescend%>"><%=wc_Status%></A></TD>

<TD  class=ColumnLabel align=center><A HREF="DisplayCasesForAssetNumber.asp?Asset_Number=<%=Asset_Number%>&SortBy=open_time&Ascend=<%=AscendDescend%>"><%=wc_Opened%></A></TD>

<TD  class=ColumnLabel align=center><A HREF="DisplayCasesForAssetNumber.asp?Asset_Number=<%=Asset_Number%>&SortBy=mod_time&Ascend=<%=AscendDescend%>"><%=wc_Modified%></A></TD>

<TD  class=ColumnLabel align=center><A HREF="DisplayCasesForAssetNumber.asp?Asset_Number=<%=Asset_Number%>&SortBy=Due_Date&Ascend=<%=AscendDescend%>"><%=wc_Due_Date%></A></TD>

<TD  class=ColumnLabel align=center><A HREF="DisplayCasesForAssetNumber.asp?Asset_Number=<%=Asset_Number%>&SortBy=contact_fname&Ascend=<%=AscendDescend%>"><%=wc_Customer%></a> / One Line Description</TD>

<TD  class=ColumnLabel align=center><A HREF="DisplayCasesForAssetNumber.asp?Asset_Number=<%=Asset_Number%>&SortBy=Tech_ID&Ascend=<%=AscendDescend%>"><%=wc_Tech%></A></TD>

<TD  class=ColumnLabel align=center><A HREF="DisplayCasesForAssetNumber.asp?Asset_Number=<%=Asset_Number%>&SortBy=group_name&Ascend=<%=AscendDescend%>"><%=wc_Group%></A></TD>
</TR>

<%
			do while not rstemp.eof

			If CInt(rstemp("Modified_Flag")) = 0 Then
				FontColor= "000000" ' Black font color
			Else
				FontColor = "FF0000" ' All Red
			End If

' New enhancement to have the font color based  on priority/severity

	Severity = rstemp("severity")

	' Comment out this line below to use the current modified flag red/black text

	FontColor = GetPriorityFontColor(Severity)
	%>

<TR>
<TD align=center
   <% If Case_Number_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>
WIDTH="4%">
<B>

<% ' If case_number is less than 1000, then fill to the left with extra zeros

	Case_Number = rstemp("Case_Number")

	If len(case_number) = 1 Then
		DisplayCaseNumber = "000" & Case_Number
	ElseIf LEn(case_number) = 2 Then
		DisplayCaseNumber = "00" & Case_Number
	Elseif Len(case_number) = 3 Then
		DisplayCaseNumber = "0" & Case_Number
	Else
		DisplayCaseNumber = Case_Number
	End If
%>

<A HREF="TCaseForm.asp?b_get_x=0&b_get_y=0&customer_id=0&case_number=<%=Case_number%>" target="user_screen"><%=DisplayCaseNumber%></A></B>&nbsp;<BR><A HREF=TCaseForm.asp?b_get_x=0&b_get_y=0&customer_id=0&case_number=<%=rstemp("Case_number")%> target="newcasewindow<%=rstemp("Case_number")%>"><IMG SRC="newwindow.gif" BORDER=0 ></A>
</TD>

<TD
   <% If Severity_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

><FONT COLOR="#<%=FontColor%>"><%=rstemp("Severity")%></FONT></TD>

<TD
   <% If Status_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

><FONT COLOR="#<%=FontColor%>">

<% ' Case Status Mappings
	' 0 = Active
	' 1 = closed
	' 2 = Wating
	' 3 = On-Hold
%>
<%
	Case_status_value = CInt(rstemp("status"))
	If case_status_value = 0 THEN
		response.write wc_Active
	ElseIf case_status_value = 2 THEN
		response.write wc_Waiting
	ElseIf case_status_value = 3 then
		response.write wc_On_Hold
	else
		response.write wc_closed
	End If

			If CInt(rstemp("Modified_Flag")) = 1 Then
				Response.write "<img src=red_tri.gif><br>"
			End If
%>

</FONT>

<% ' Now Display the Scheduled Case Status Too

	Due_Date = rstemp("Due_Date")
	Due_Time = rstemp("Due_Time")

	If IsNull(Due_Date) = False AND IsNull(Due_Time) = False Then

		' Comment out these lines if you don't like the blink
		StartBlinkTag = "<Blink>"
		EndBlinkTag = "</Blink>"

		If Due_date < NewDateDateOnly Then
			response.write "<font color=RED>"
			response.write StartBlinkTag & "LATE" & EndBlinkTag & "</font>"
		Elseif Due_date = NewDateDateOnly AND  Due_Time <= NewTime Then
			response.write "<font  color=RED>"
			response.write StartBlinkTag & "LATE" & EndBlinkTag & "</font>"
		Else
			response.write "<font  color=GREEN>"
			response.write "OK</font>"
		End IF
	End IF
%>

</TD>

<TD ALIGN=CENTER WIDTH="9%"

   <% If Open_time_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>
>
<FONT COLOR="#<%=FontColor%>">

<% ' Date and Time must be reformatted from the internal Text format of:
	' YYYYMMDD to mm/dd/yyyy
	' And Time must be converted from: HHMMSS in 24 hour format to AM/PM formats

	' Depending upon the WCDateFormat Setting (set in db_define.inc) we will
	' display the date in
	' in MM/DD/YYYY (US Version and default) or DD/MM/YYYY for UK version

	If WCDateFormat = "DDMMYYYY" Then
		ConvertedOpenDate =   mid(rstemp("open_date"),7,2) & "/" & mid(rstemp("open_date"),5,2) & "/" & mid(rstemp("open_date"),1,4)
	Else
		ConvertedOpenDate = mid(rstemp("open_date"),5,2) & "/" & mid(rstemp("open_date"),7,2) & "/" & mid(rstemp("open_date"),1,4)
	End IF

	ConvertedOpenTime = mid(rstemp("Open_time"), 1,2) & ":" & mid(rstemp("Open_time"),3,2)

	ConvertedHour = int(mid(rstemp("Open_time"),1,2))
	If ConvertedHour > 12 then
		ConvertedHour = ConvertedHour -12
		AMPM = " PM"
		ConvertedOpenTime = CStr(ConvertedHour) & mid(ConvertedOpenTime, 3,3)
	Else

		If ConvertedHour = 12 Then
			AMPM = " PM"
		Else
			AMPM = " AM"
		End If

	End If
%>

<%=ConvertedOpenDate%><Br>
<%=ConvertedOpenTime%><%=AMPM%>

</FONT>
</TD>

<TD ALIGN=CENTER WIDTH="9%"

   <% If mod_time_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

>
<FONT COLOR="#<%=FontColor%>">

<% ' Date and Time must be reformatted from the internal Text format of:
	' YYYYMMDD to mm/dd/yyyy
	' And Time must be converted from: HHMMSS in 24 hour format to AM/PM formats

	' Depending upon the WCDateFormat Setting (set in db_define.inc) we will
	' display the date in
	' in MM/DD/YYYY (US Version and default) or DD/MM/YYYY for UK version

	If WCDateFormat = "DDMMYYYY" Then

		ConvertedmodDate = mid(rstemp("mod_date"),7,2) & "/" & mid(rstemp("mod_date"),5,2)  &  "/" & mid(rstemp("mod_date"),1,4)
	else ' Default to US version
		ConvertedmodDate = mid(rstemp("mod_date"),5,2) & "/" & mid(rstemp("mod_date"),7,2) & "/" & mid(rstemp("mod_date"),1,4)
	End IF

	ConvertedmodTime = mid(rstemp("mod_time"), 1,2) & ":" & mid(rstemp("mod_time"),3,2)

	ConvertedHour = int(mid(rstemp("mod_time"),1,2))
	If ConvertedHour > 12 then
		ConvertedHour = ConvertedHour -12
		AMPM = " PM"
		ConvertedmodTime = CStr(ConvertedHour) & mid(ConvertedmodTime, 3,3)
	Else
		If ConvertedHour = 12 Then
			AMPM = " PM"
		Else
			AMPM = " AM"
		End If
	End If
%>

<%=ConvertedModDate%><Br>
<%=ConvertedModTime%><%=AMPM%>

</FONT>
</TD>

<TD ALIGN=CENTER WIDTH="9%"
   <% If due_date_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>
>
<FONT COLOR="#<%=FontColor%>">

<% ' Display the Date in UK or US formats depending upon configuration value %>
<% 	If WCDateFormat = "DDMMYYYY" Then ' Set to UK date formats
		DateDisplayString = Day(rstemp("Due_Date")) & "/" & Month(rstemp("Due_Date")) & "/" & Year(rstemp("Due_Date"))
	Else
		DateDisplayString = Month(rstemp("Due_Date")) & "/" & Day(rstemp("Due_Date")) & "/"  & Year(rstemp("Due_Date"))
	End IF
%>
<%=DateDisplayString%><br>

<%' Create Time Display String %>
<% ' Check if Due_Time is Null %>

<%
If ISNull(rstemp("Due_Time")) = False Then

	 DueHour = Hour(rstemp("Due_Time"))

	If DueHour > 12 Then
		DueHour = DueHour - 12
	End If

	DueHour = CStr(DueHour)
	If Len(DueHour) < 2 Then
		DueHour = "0" & DueHour
	End If
	DueMinute = CStr(Minute(rstemp("Due_Time")))
	If Len(DueMinute) < 2 Then
		DueMinute = "0" & DueMinute
	End If

	AMPM = Right(CStr(rstemp("Due_Time")),2)

	DisplayTimeString = DueHour & ":" & DueMinute & " " & AMPM
%>

<%=DisplayTimeString %>

<%	Else ' Display no time setting %>

--:--

<%End If %>

</font>
</TD>

<TD WIDTH="52%"
   <% If contact_fname_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>
>
<FONT COLOR="#<%=FontColor%>">

(
<a href=NewCustomer.asp?ID=<%=rstemp("Customer_ID")%> target= "user_screen">
<%=rstemp("Contact_fname")%>
<% response.write " " %>
<%=rstemp("Contact_lname")%></a>)

<% ' Display the company name only if it exists
	If rstemp("Company") <> "" Then
		Response.write " [" & rstemp("Company") & "]"
	End If
%>

<br>

<B><%=rstemp("Case_One_Line")%></b></FONT></TD>

<% ' Display the tech name %>

<TD WIDTH="12%"
   <% If tech_ID_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

><FONT COLOR="#<%=FontColor%>">

<% ' Get the name of the tech from a separate database lookup since it may be null
	' and it will not be found from the search if included in the original lookup
	Tech_ID = rstemp("Tech_ID")
	MySQL3 = " Select * from Tech_staff where tech_ID = '" & 	Tech_ID & "'"

	set rstemp2=Server.CreateObject("adodb.Recordset")

	rstemp2.open mySQL3, conntemp, adopenstatic

	If rstemp2.EOF <> "True" Then
		TechFullName = rstemp2("First_name") & " " & rstemp2("Last_Name")
	Else
		TechFullName = "Not Assigned"
	End IF

	rstemp2.close
	set rstemp2=nothing
%>
<%=TechFullName %>
</FONT>
</TD>

<TD WIDTH="12%"
   <% If group_name_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

><FONT COLOR="#<%=FontColor%>"><%=rstemp("Group_Name")%>
</FONT>
</TD>
</TR>

<%
				rstemp.MoveNext
			loop

		Else
	%>

<CENTER>No  Cases for: <B><%=Asset_Number%></B></CENTER>

		<%End If %>

	<%	 ' Close the record set and close the connection

		rstemp.close
		set rstemp=nothing

		' Close the only connection to the database

		conntemp.close ' Close the connection
		set conntemp=nothing
	%>

</TABLE>
&nbsp;
</BODY>
</HTML>

<%End If ' End of security checks
%>
<% end if %>
