
<% 'Module: DoConvertToSQLServer.asp

   'Description: This module is the Submit modules for ConvertToSQLServer.asp
   ' module and it moves data from an Access Database
   ' to a SQL*Server or SQL 2000 database.
   ' This module should be only be run once to export data from an
   ' Access Data to a SQL*Server 7.0 or SQL 2000 database that
   ' has been configured to accept data.  This initial SQL*Server
   ' database must be a modified version of the Web+Center SQL*Server database
   ' that has several selected identity fields disabled during this conversion so all
   ' of the tables key indexes data can be copied over with the same indexes
   ' in the access table.

   ' Once the data is moved over, you must convert these index fields
   ' back to the column definitions for the identity fields so they
   ' are auto-increment type fields.

   ' Directions: To import data into the Customers Web+Center table,
   ' you must first define TWO ODBC database.  The Access database DSN must
   ' be defined as Webcenter30_DBAccess.

   ' The SQL*Server database DSN must be defined at webcenter30_db and
   ' and must point to the SQL*Server database.

   ' IMPORTANT: Before launching any data conversion process, please completely
   ' backup the database so it can be restored.  Do not attempt this script
   ' once you are running with SQL*Server as your main database.

   '(C) 2002 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date		Who		What
   '-------		---		------------------------------------------------
   '02/07/02	SAV		Created original ConvertToSQLServer.asp page

	' CONSTANTS

	' Set the time out to 40 minutes so it does not time out with larger imports
	Server.ScriptTimeOut = 12000 ' Set to 1200 seconds (40 minutes)

	' Define Which Tables to Export - Comment out if necessary
	'--------------------------------------------------------------------
	If Request.form("AllTables") = "YES" Then
		ExportCustomers = 1
		ExportCases = 1
		ExportTech_staff = 1
		ExportGroup_list = 1
		ExportGroups = 1
		ExportCategories = 1
		ExportAssets = 1
		ExportBConfiguration = 1
		ExportConfiguration = 1
		ExportCustomerTechAssignment = 1
		ExportDeleteList = 1
		ExportEmailCategory = 1
		ExportEmailCategoryLinks = 1
		ExportEmailText = 1
		ExportEmail_text = 1
		ExportKBConfiguration = 1
		ExportKBMap = 1
		ExportKBWords = 1
		ExportPriority = 1
		ExportTopCases = 1
	End IF

	If Request.form("AllTables") <> "YES" Then

		If Request.form("AssetAssignment") = "YES" Then
			ExportAssetAssignment = 1
		End If

		If Request.form("Assets") = "YES" Then
			ExportAssets = 1
		End If

		If Request.form("BConfiguration") = "YES" Then
			ExportBConfiguration = 1
		End If

		If Request.form("Cases") = "YES" Then
			ExportCases = 1
		End If

		If Request.form("Categories") = "YES" Then
			ExportCategories = 1
		End If

		If Request.form("Customers") = "YES" Then
			ExportCustomers = 1
		End If

		If Request.form("Configuration") = "YES" Then
			ExportConfiguration = 1
		End If

		If Request.form("CustomerNotes") = "YES" Then
			ExportCustomerNotes = 1
		End If

		If Request.form("DeleteList") = "YES" Then
			ExportDeleteList = 1
		End If

		If Request.form("EmailCategory") = "YES" Then
			ExportEmailCategory = 1
		End If

		If Request.form("EmailCategoryLinks") = "YES" Then
			ExportEmailCategoryLinks = 1
		End If

		If Request.form("EmailText") = "YES" Then
			ExportEmailText = 1
		End If

		If Request.form("Email_text") = "YES" Then
			ExportEmail_text = 1
		End If

		If Request.form("Group_list") = "YES" Then
			ExportGroup_list = 1
		End If

		If Request.form("KBConfiguration") = "YES" Then
			ExportKBConfiguration = 1
		End If

		If Request.form("KBMap") = "YES" Then
			ExportKBMap = 1
		End If
		If Request.form("KBWords") = "YES" Then
			ExportKBWords = 1
		End If

		If Request.form("Priority") = "YES" Then
			ExportPriority = 1
		End If

		If Request.form("Tech_staff") = "YES" Then
			ExportTech_staff = 1
		End If

		If Request.form("TopCases") = "YES" Then
			ExportTopCases = 1
		End If

		If Request.form("UserCategory") = "YES" Then
			ExportUserCategory = 1
		End If

End If ' End of if AllTables <> "YES"

LoggingOptions = Request.form("LoggingOptions") ' Set to MIN or FULL

%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->

<html>

<head>
<title>Web+Center Access To SQL*Server Export Process</title>
</head>

<body bgcolor=FFFFFF>

<% ' ***************************************

	' ODBC Definition for your Access Database using a DSN

		AccessDatabaseDSN = "webcenter30_db"
		'SQL*Server DSN is defined by the DSN string in DB_define.inc

%>
	<center><font face=arial>Web+Center Customer Data Import Filter</font></center><P>
	<font size=-1 face=arial>
	<B>Test #1 - Testing Both Databases</b>:
<%

	response.write "<B>Attempting Access Database Connectivity:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	Conn.Close

	response.write "<B> Access Database Connectivity Successful:</b><P>"

	response.write "<B>Attempting SQL*Server/2000 Database Connectivity:</b><P>"


	'response.write "Connecting to SQL with " & myDSN & "<br>"
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN   ' Conn = SQLServer Destination Database

	Conn2.Close

	response.write "<B> SQL Server Database Connectivity Successful:</b><P>"


	' *************** CUSTOMERS TABLE EXPORT ************************************
	If ExportCustomers = 1 Then
		response.write "<B>Now attempting to export customer tables to SQL*Server:</b><P>"


		Set Conn = Server.CreateObject("ADODB.Connection")
		conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

		' Open second connection to source database
		Set Conn2 = Server.CreateObject("ADODB.Connection")
		conn2.open  myDSN ' If it fails here, then check your connect string.


		' Now step through all of the records on the source database

		Set SourceRecord = Server.CreateObject("ADODB.Recordset")
				SQL2 = "Select * from Customers"
				SourceRecord.Open SQL2,Conn,3,3

		Do while SourceRecord.EOF <> True

			' Create a new record on the desintation database

			Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
			SQL = "Select * from Customers" '

				'response.write SQL

				DestinationRecord.Open SQL,Conn2,3,3
				DestinationRecord.AddNew


				DestinationRecord("Customer_ID") = SourceRecord("customer_id")
				DestinationRecord("customer_password") = SourceRecord("Customer_password")
				DestinationRecord("contact_fname") = SourceRecord("contact_fname")
				DestinationRecord("contact_lname") = SourceRecord("contact_lname")
				DestinationRecord("company") = SourceRecord("company")
				DestinationRecord("address") = SourceRecord("address")
				DestinationRecord("mailstop") = SourceRecord("mailstop")
				DestinationRecord("city") = SourceRecord("city")
				DestinationRecord("state") = SourceRecord("state")
				DestinationRecord("zip") = SourceRecord("zip")
				DestinationRecord("country") = SourceRecord("country")
				DestinationRecord("email") = SourceRecord("email")
				DestinationRecord("phone1") = SourceRecord("phone1")
				DestinationRecord("phone2") = SourceRecord("phone2")
				DestinationRecord("fax") = SourceRecord("fax")
				DestinationRecord("contact_method") = SourceRecord("contact_method")
				DestinationRecord("contact_times") = SourceRecord("contact_times")
				DestinationRecord("login_ip") = SourceRecord("login_ip")
				DestinationRecord("login_timeout") = SourceRecord("login_timeout")
				DestinationRecord("customer_username") = SourceRecord("customer_username")
				DestinationRecord("ViewEmailCategoryID") = SourceRecord("ViewEmailCategoryID")

				DestinationRecord.Update


				If LoggingOptions = "FULL" Then
					response.write " <font color=green> <LI>Customer Record: " &  SourceRecord("Customer_ID") & " Exported</li>"
				End IF
					If  err.number>0 then
						  response.write "VBScript Errors Occured:" & "<P>"
						  response.write "Error Number=" & err.number & "<P>"
						 response.write "Error Descr.=" & err.description & "<P>"
						  response.write "Help Context=" & err.helpcontext & "<P>"
						  response.write "Help Path=" & err.helppath & "<P>"
						  response.write "Native Error=" & err.nativeerror & "<P>"
						  response.write "Source=" & err.source & "<P>"
						  response.write "SQLState=" & err.sqlstate & "<P>"
					else
					'      response.write "No VBScript Errors Occured" & "<P>"
					end if
					IF  conn.errors.count> 0 then
						  response.write "Database Errors Occured" & "<P>"
					for counter= 0 to conn.errors.count
						  response.write "Error #" & conn.errors(counter).number & "<P>"
						  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
					next
					else
					'      response.write "No Database Errors Occured!" & "<P>"
					end if


			DestinationRecord.Close
			Set DestinationRecord = Nothing
			SourceRecord.MoveNext
			TotalImportedRecords = TotalImportedRecords + 1
		loop

		SourceRecord.Close ' Close the source recordset
		' Close both connections

		Conn.Close
		Set SourceRecord = Nothing
		Set DestinationRecord = Nothing
		Conn2.close

	%>

		<B>Customer Table Successfully Exported</B><P>
		<UL> <%=TotalImportedRecords%> Customer records exported<br>
		</ul>

	<%

	End If ' End if ExportCustomers = 1

	' ******************* CASES TABLE EXPORT ******************************************

	If ExportCases = 1 Then

	TotalImportedRecords = Request.form("StartAtRecord")' Reset back to zero
	LastImportCount = 0


	CloseConnectionsCount = Request.form("RecordsToProcess")


	response.write "<B>Now attempting to export Cases tables to SQL*Server </b><P>"

	response.write "<B>Starting at record " & TotalImpoprtedRecords & " FOR " & CloseConnectionsCount 7 "Records"




'	LastRecordFound = "NO"

'	Do While LastRecordFound <> "YES"


	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from Cases"
			SourceRecord.Open SQL2,Conn,3,3

			Sourcerecord.Move TotalImportedRecords

	Do while (SourceRecord.EOF <> True) AND (LastImportCount < CloseConnectionsCount)



		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from Cases"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("Case_Number") = SourceRecord("Case_Number")
			DestinationRecord("External_Case_Number") = SourceRecord("External_Case_Number")
			DestinationRecord("Dup_Case_Num") = SourceRecord("dup_Case_Num")
			DestinationRecord("Group_Number") = SourceRecord("Group_Number")
			DestinationRecord("asset_Number") = SourceRecord("asset_Number")
			DestinationRecord("customer_id") = SourceRecord("Customer_id")
			DestinationRecord("tech_id") = SourceRecord("tech_id")
			DestinationRecord("Open_date") = SourceRecord("Open_date")
			DestinationRecord("Open_time") = SourceRecord("Open_time")
			DestinationRecord("reopen_date") = SourceRecord("reopen_date")
			DestinationRecord("reopen_time") = SourceRecord("reopen_time")
			DestinationRecord("mod_date") = SourceRecord("mod_date")
			DestinationRecord("mod_time") = SourceRecord("mod_time")
			DestinationRecord("case_one_line") = SourceRecord("case_one_line")
			DestinationRecord("case_history") = SourceRecord("case_history")
			DestinationRecord("case_summary") = SourceRecord("case_summary")
			DestinationRecord("case_resolution") = SourceRecord("case_resolution")
			DestinationRecord("status") = SourceRecord("status")
			DestinationRecord("severity") = SourceRecord("severity")
			DestinationRecord("Scheduled_case_type") = SourceRecord("Scheduled_case_type")
			DestinationRecord("repeat_interval") = SourceRecord("repeat_interval")
			DestinationRecord("due_date") = SourceRecord("due_date")
			DestinationRecord("due_Time") = SourceRecord("due_Time")
			DestinationRecord("Overdue_Email") = SourceRecord("overdue_email")
			DestinationRecord("modified_flag") = SourceRecord("modified_flag")
			DestinationRecord("category_count") = SourceRecord("category_count")
			DestinationRecord("c1") = SourceRecord("c1")
			DestinationRecord("c2") = SourceRecord("c2")
			DestinationRecord("c3") = SourceRecord("c3")
			DestinationRecord("c4") = SourceRecord("c4")
			DestinationRecord("c5") = SourceRecord("c5")
			DestinationRecord("c6") = SourceRecord("c6")
			DestinationRecord("c7") = SourceRecord("c7")
			DestinationRecord("c8") = SourceRecord("c8")
			DestinationRecord("c9") = SourceRecord("c9")
			DestinationRecord("c10") = SourceRecord("c10")

			' Categories 11-20
			DestinationRecord("c11") = SourceRecord("c11")
			DestinationRecord("c12") = SourceRecord("c12")
			DestinationRecord("c13") = SourceRecord("c13")
			DestinationRecord("c14") = SourceRecord("c14")
			DestinationRecord("c15") = SourceRecord("c15")
			DestinationRecord("c16") = SourceRecord("c16")
			DestinationRecord("c17") = SourceRecord("c17")
			DestinationRecord("c18") = SourceRecord("c18")
			DestinationRecord("c19") = SourceRecord("c19")
			DestinationRecord("c20") = SourceRecord("c20")

			' Categories 21-30
			DestinationRecord("c21") = SourceRecord("c21")
			DestinationRecord("c22") = SourceRecord("c22")
			DestinationRecord("c23") = SourceRecord("c23")
			DestinationRecord("c24") = SourceRecord("c24")
			DestinationRecord("c25") = SourceRecord("c25")
			DestinationRecord("c26") = SourceRecord("c26")
			DestinationRecord("c27") = SourceRecord("c27")
			DestinationRecord("c28") = SourceRecord("c28")
			DestinationRecord("c29") = SourceRecord("c29")
			DestinationRecord("c30") = SourceRecord("c30")


			' Categories 31-40
			DestinationRecord("c31") = SourceRecord("c31")
			DestinationRecord("c32") = SourceRecord("c32")
			DestinationRecord("c33") = SourceRecord("c33")
			DestinationRecord("c34") = SourceRecord("c34")
			DestinationRecord("c35") = SourceRecord("c35")
			DestinationRecord("c36") = SourceRecord("c36")
			DestinationRecord("c37") = SourceRecord("c37")
			DestinationRecord("c38") = SourceRecord("c38")
			DestinationRecord("c39") = SourceRecord("c39")
			DestinationRecord("c40") = SourceRecord("c40")

			' If you use more than 40 categories, you will
			' need to duplicate more values above and transfer them.

			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>Case: " &  SourceRecord("Case_Number") & " Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext


	If SourceRecord.EOF = True Then
		LastRecordFound = "YES"
	End If


		TotalImportedRecords = TotalImportedRecords + 1
		LastImportCount = LastImportCount + 1

	loop


	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


	Response.write "------- " & CloseConnectionsCount & " Records imported -----<br>"
	response.flush ' Flush the information we have now



loop ' perform the outer loop



%>

	</ul>

	<B>Case Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> Case records imported<br>
	</ul>

<%
	End IF ' End of ExportCases = 1
%>

<% '*************************** Tech_staff TABLE EXPORT *******************

	If ExportTech_staff = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export Tech_staff table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from Tech_staff"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from Tech_staff"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("tech_id") = SourceRecord("tech_id")
			DestinationRecord("tech_password") = SourceRecord("tech_password")
			DestinationRecord("tech_level") = SourceRecord("tech_level")
			DestinationRecord("first_name") = SourceRecord("first_name")
			DestinationRecord("last_name") = SourceRecord("last_name")
			DestinationRecord("department") = SourceRecord("department")
			DestinationRecord("mailstop") = SourceRecord("mailstop")
			DestinationRecord("work_email") = SourceRecord("work_email")
			DestinationRecord("work_phone1") = SourceRecord("work_phone1")
			DestinationRecord("work_phone2") = SourceRecord("work_phone2")
			DestinationRecord("work_fax") = SourceRecord("work_fax")
			DestinationRecord("home_address") = SourceRecord("home_address")
			DestinationRecord("home_city") = SourceRecord("home_city")
			DestinationRecord("home_state") = SourceRecord("home_state")

			DestinationRecord("home_zip") = SourceRecord("home_zip")
			DestinationRecord("home_email") = SourceRecord("home_email")
			DestinationRecord("home_phone") = SourceRecord("home_phone")
			DestinationRecord("home_fax") = SourceRecord("home_fax")
			DestinationRecord("notes") = SourceRecord("notes")
			DestinationRecord("current_customer_id") = SourceRecord("current_customer_id")
			DestinationRecord("current_case_number") = SourceRecord("current_case_number")
			DestinationRecord("availability") = SourceRecord("availability")
			DestinationRecord("show_dispatch_flag") = SourceRecord("show_dispatch_flag")

			DestinationRecord("login_ip") = SourceRecord("login_ip")
			DestinationRecord("login_timeout") = SourceRecord("login_timeout")
			DestinationRecord("new_case_notify") = SourceRecord("new_case_notify")

			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>Tech Staff Member " &  SourceRecord("First_Name") &  " " &  SourceRecord("Last_Name") & " Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext



		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>Tech_staff Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> Tech Staff records exported<br>
	</ul>
<% 	End IF ' End of ExportCases = 1
%>


<%
	' *************************** GROUP_LIST EXPORT ****************************

	If ExportGroup_list = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export Group_list table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from Group_list"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from Group_list"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("Group_Number") = SourceRecord("Group_Number")
			DestinationRecord("Group_Name") = SourceRecord("Group_Name")
			DestinationRecord("Default_Flag") = SourceRecord("default_flag")
			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>Group " &  SourceRecord("Group_Name")  & "Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>Group_list Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> Groups List records exported<br>
	</ul>

<%
	End IF ' End of ExporGroupsLis = 1


	' *************************************** GROUPS TABLE EXPORT ********

	If ExportGroups = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export Groups table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from Groups"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from Groups"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("tech_id") = SourceRecord("tech_id")
			DestinationRecord("Group_Number") = SourceRecord("Group_Number")
			DestinationRecord("New_case_Notify") = SourceRecord("new_case_notify")
			' Note GroupsID is an auto number field but is not used but will be created.

			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>Groups with Tech: " &  SourceRecord("Tech_ID") &   " With For Group: " & SourceRecord("Group_Number")  & " Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>Groups Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> Groups records exported<br>
	</ul>
<%
	End IF ' End of ExportGroup = 1
%>


<% '****************************Categories TABLE ****************************

	If ExportCategories = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export Categories table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from Categories"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from Categories"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("category_number") = SourceRecord("category_number")
			DestinationRecord("item_number") = SourceRecord("item_number")
			DestinationRecord("category_name") = SourceRecord("category_name")
			DestinationRecord("item_name") = SourceRecord("item_name")
			DestinationRecord("state") = SourceRecord("state")
			DestinationRecord("group_number") = SourceRecord("group_number")
			' Category_index is an auto number field and not used.


			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>Category: " &  SourceRecord("category_name") &   " With Item: " & SourceRecord("Item_Name")  & " Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>Categories Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> Categories records exported<br>
	</ul>

<%
	End IF ' End of ExportCases = 1
%>

<% '************************** Assets TABLE EXPORT **************************************
	If ExportAssets = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export Assets table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from Assets"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from Assets"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("asset_number") = SourceRecord("asset_number")
			DestinationRecord("dummy_field") = SourceRecord("dummy_field")
			DestinationRecord("computer_id") = SourceRecord("computer_id")
			DestinationRecord("property_tag") = SourceRecord("property_tag")
			DestinationRecord("equipment_type") = SourceRecord("equipment_type")
			DestinationRecord("lease_or_purchase") = SourceRecord("lease_or_purchase")
			DestinationRecord("serial_number") = SourceRecord("serial_number")
			DestinationRecord("acquired_from") = SourceRecord("acquired_from")
			DestinationRecord("date_acquired") = SourceRecord("date_acquired")
			DestinationRecord("date_in_service") = SourceRecord("date_in_service")
			DestinationRecord("processor_speed") = SourceRecord("processor_speed")
			DestinationRecord("ram_size") = SourceRecord("ram_size")
			DestinationRecord("hd_size") = SourceRecord("hd_size")
			DestinationRecord("monitor_model") = SourceRecord("monitor_model")
			DestinationRecord("monitor_size") = SourceRecord("monitor_size")
			DestinationRecord("monitor_serial_num") = SourceRecord("monitor_serial_num")
			DestinationRecord("assigned_group") = SourceRecord("assigned_group")
			DestinationRecord("location") = SourceRecord("location")
			DestinationRecord("date_assigned") = SourceRecord("date_assigned")
			DestinationRecord("location") = SourceRecord("location")
			DestinationRecord("date_assigned") = SourceRecord("date_assigned")
			DestinationRecord("ip_address") = SourceRecord("ip_address")
			DestinationRecord("wall_port_number") = SourceRecord("wall_port_number")
			DestinationRecord("operating_system1") = SourceRecord("operating_system1")
			DestinationRecord("operating_system2") = SourceRecord("operating_system2")
			' Applications

			' Application #1
			DestinationRecord("app1") = SourceRecord("app1")
			DestinationRecord("app1_product_id") = SourceRecord("app1_product_id")
			DestinationRecord("app1_install_date") = SourceRecord("app1_install_date")


			' Application #2
			DestinationRecord("app2") = SourceRecord("app2")
			DestinationRecord("app2_product_id") = SourceRecord("app2_product_id")
			DestinationRecord("app2_install_date") = SourceRecord("app2_install_date")

			' Application #3
			DestinationRecord("app3") = SourceRecord("app3")
			DestinationRecord("app3_product_id") = SourceRecord("app3_product_id")
			DestinationRecord("app3_install_date") = SourceRecord("app3_install_date")

			' Application #4
			DestinationRecord("app4") = SourceRecord("app4")
			DestinationRecord("app4_product_id") = SourceRecord("app4_product_id")
			DestinationRecord("app4_install_date") = SourceRecord("app4_install_date")

			' Application #5
			DestinationRecord("app5") = SourceRecord("app5")
			DestinationRecord("app5_product_id") = SourceRecord("app5_product_id")
			DestinationRecord("app5_install_date") = SourceRecord("app5_install_date")

			' Application #6
			DestinationRecord("app6") = SourceRecord("app6")
			DestinationRecord("app6_product_id") = SourceRecord("app6_product_id")
			DestinationRecord("app6_install_date") = SourceRecord("app6_install_date")

			' Application #7
			DestinationRecord("app7") = SourceRecord("app7")
			DestinationRecord("app7_product_id") = SourceRecord("app7_product_id")
			DestinationRecord("app7_install_date") = SourceRecord("app7_install_date")

			' Application #8
			DestinationRecord("app8") = SourceRecord("app8")
			DestinationRecord("app8_product_id") = SourceRecord("app8_product_id")
			DestinationRecord("app8_install_date") = SourceRecord("app8_install_date")

			' Application #9
			DestinationRecord("app9") = SourceRecord("app9")
			DestinationRecord("app9_product_id") = SourceRecord("app9_product_id")
			DestinationRecord("app9_install_date") = SourceRecord("app9_install_date")

			' Application #10
			DestinationRecord("app10") = SourceRecord("app10")
			DestinationRecord("app10_product_id") = SourceRecord("app10_product_id")
			DestinationRecord("app10_install_date") = SourceRecord("app10_install_date")

			' Application #11
			DestinationRecord("app11") = SourceRecord("app11")
			DestinationRecord("app11_product_id") = SourceRecord("app11_product_id")
			DestinationRecord("app11_install_date") = SourceRecord("app11_install_date")

			' Application #12
			DestinationRecord("app12") = SourceRecord("app12")
			DestinationRecord("app12_product_id") = SourceRecord("app12_product_id")
			DestinationRecord("app12_install_date") = SourceRecord("app12_install_date")

			' Application #13
			DestinationRecord("app13") = SourceRecord("app13")
			DestinationRecord("app13_product_id") = SourceRecord("app13_product_id")
			DestinationRecord("app13_install_date") = SourceRecord("app13_install_date")

			' Application #14
			DestinationRecord("app14") = SourceRecord("app14")
			DestinationRecord("app14_product_id") = SourceRecord("app14_product_id")
			DestinationRecord("app14_install_date") = SourceRecord("app14_install_date")

			' Application #15
			DestinationRecord("app15") = SourceRecord("app15")
			DestinationRecord("app15_product_id") = SourceRecord("app15_product_id")
			DestinationRecord("app15_install_date") = SourceRecord("app15_install_date")

			' End of Application fields

			DestinationRecord("lastupdate") = SourceRecord("lastupdate")
			DestinationRecord("assetnotes") = SourceRecord("assetnotes")
			DestinationRecord("custom_field1") = SourceRecord("custom_field1")
			DestinationRecord("custom_field2") = SourceRecord("custom_field2")
			DestinationRecord("custom_field3") = SourceRecord("custom_field3")
			DestinationRecord("custom_field4") = SourceRecord("custom_field4")
			DestinationRecord("custom_field5") = SourceRecord("custom_field5")


			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>Asset Number: " &  SourceRecord("Asset_Number") &   " With Asset Description: " & SourceRecord("Equipment_Type")  & " Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>Assets Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> Assets records exported<br>
	</ul>

<% 	End IF ' End of ExportAssets = 1
%>

<% '****************************BConfigURATION TABLE EXPORT ****************************

	' Note this table should only have one row so no need to change primary key field
	' back to int and then back to autonumber

	If ExportBConfiguration = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export BConfiguration table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from BConfiguration"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from BConfiguration"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("BWhiteBoard") = SourceRecord("BWhiteBoard")
			DestinationRecord("OptionColor") = SourceRecord("OptionColor")
			DestinationRecord("UserWindowColor") = SourceRecord("UserWindowColor")
			DestinationRecord("AssignedContactsColor") = SourceRecord("AssignedContactsColor")
			DestinationRecord("RemoveEmailText") = SourceRecord("RemoveEmailText")

			' Customer Customer Fields
			DestinationRecord("Box1Label") = SourceRecord("Box1Label")
			DestinationRecord("Box2Label") = SourceRecord("Box2Label")
			DestinationRecord("Box3Label") = SourceRecord("Box3Label")
			DestinationRecord("Box4Label") = SourceRecord("Box4Label")
			DestinationRecord("Box5Label") = SourceRecord("Box5Label")
			DestinationRecord("Box6Label") = SourceRecord("Box6Label")
			DestinationRecord("Box7Label") = SourceRecord("Box7Label")
			DestinationRecord("Box8Label") = SourceRecord("Box8Label")
			DestinationRecord("Box9Label") = SourceRecord("Box9Label")
			DestinationRecord("Box10Label") = SourceRecord("Box10Label")

			DestinationRecord("Box1Enabled") = SourceRecord("Box1Enabled")
			DestinationRecord("Box2Enabled") = SourceRecord("Box2Enabled")
			DestinationRecord("Box3Enabled") = SourceRecord("Box3Enabled")
			DestinationRecord("Box4Enabled") = SourceRecord("Box4Enabled")
			DestinationRecord("Box5Enabled") = SourceRecord("Box5Enabled")
			DestinationRecord("Box6Enabled") = SourceRecord("Box6Enabled")
			DestinationRecord("Box7Enabled") = SourceRecord("Box7Enabled")
			DestinationRecord("Box8Enabled") = SourceRecord("Box8Enabled")
			DestinationRecord("Box9Enabled") = SourceRecord("Box9Enabled")
			DestinationRecord("Box10Enabled") = SourceRecord("Box10Enabled")

			' BConfigurationID will be set automatically from autonumber

			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>BConfiguration Row Found and Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>BConfiguration Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> BConfiguration records exported<br>
	</ul>

<%
	End IF ' End of ExportCases = 1
%>


<% '****************************Configuration TABLE EXPORT ****************************

	' Note this table should only have one row so no need to change primary key field
	' back to int and then back to autonumber

	If ExportConfiguration = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export Configuration table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from Configuration"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from Configuration"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("ts_options_color") = SourceRecord("ts_options_color")
			DestinationRecord("ts_pending_color") = SourceRecord("ts_pending_color")
			DestinationRecord("ts_user_page_color") = SourceRecord("ts_user_page_color")
			DestinationRecord("customer_color") = SourceRecord("customer_color")
			DestinationRecord("customer_name_text") = SourceRecord("customer_name_text")
			DestinationRecord("customer_name_html") = SourceRecord("customer_name_html")
			DestinationRecord("max_case_history_size") = SourceRecord("max_case_history_size")
			DestinationRecord("max_case_summary_size") = SourceRecord("max_case_summary_size")
			DestinationRecord("max_case_resolution_size") = SourceRecord("max_case_resolution_size")
			DestinationRecord("pending_screen_refresh_rate") = SourceRecord("pending_screen_refresh_rate")
			DestinationRecord("dispatcher_screen_refresh_rate") = SourceRecord("dispatcher_screen_refresh_rate")
			DestinationRecord("smtp_host_address") = SourceRecord("smtp_host_address")
			DestinationRecord("standard_reply_to_address") = SourceRecord("standard_reply_to_address")
			DestinationRecord("email_retry_timeout") = SourceRecord("email_retry_timeout")
			DestinationRecord("customer_id_list") = SourceRecord("customer_id_list")
			DestinationRecord("Assets_db") = SourceRecord("Assets_db")
			DestinationRecord("customer_case_notify") = SourceRecord("customer_case_notify")
			DestinationRecord("max_tech_case_search_return") = SourceRecord("max_tech_case_search_return")
			DestinationRecord("text_box_sizing") = SourceRecord("text_box_sizing")
			DestinationRecord("case_summary_rows") = SourceRecord("case_summary_rows")
			DestinationRecord("case_summary_max_rows") = SourceRecord("case_summary_max_rows")
			DestinationRecord("case_resolution_rows") = SourceRecord("case_resolution_rows")
			DestinationRecord("case_resolution_max_rows") = SourceRecord("case_resolution_max_rows")
			DestinationRecord("case_history_rows") = SourceRecord("case_history_rows")
			DestinationRecord("case_text_box_columns") = SourceRecord("case_text_box_columns")
			DestinationRecord("time_zone_adjustment") = SourceRecord("time_zone_adjustment")
			DestinationRecord("time_zone_label") = SourceRecord("time_zone_label")
			DestinationRecord("language") = SourceRecord("language")
			DestinationRecord("All_KB_Update") = SourceRecord("All_KB_Update")
			DestinationRecord("Time_Spent_Category") = SourceRecord("Time_spent_Category")
			DestinationRecord("Time_Spent_Interval") = SourceRecord("Time_Spent_Interval")
			DestinationRecord("Date_Display_Format") = SourceRecord("Date_Display_Format")

			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>Configuration Table Row Found and Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>Configuration Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> Configuration records exported<br>
	</ul>

<%
	End IF ' End of ExportCases = 1
%>


<% '****************************CustomerNotes TABLE ****************************

	If ExportCustomerNotes = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export CustomerNotes table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from CustomerNotes"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from CustomerNotes"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("NotesID") = SourceRecord("NotesID")
			DestinationRecord("ContactNotes") = SourceRecord("ContactNotes")
			DestinationRecord("customer_ID") = SourceRecord("customer_ID")
			DestinationRecord("TextNote1") = SourceRecord("TextNote1")
			DestinationRecord("TextNote2") = SourceRecord("TextNote2")
			DestinationRecord("TextNote3") = SourceRecord("TextNote3")
			DestinationRecord("TextNote4") = SourceRecord("TextNote4")
			DestinationRecord("TextNote5") = SourceRecord("TextNote5")
			DestinationRecord("TextNote6") = SourceRecord("TextNote6")
			DestinationRecord("TextNote7") = SourceRecord("TextNote7")
			DestinationRecord("TextNote8") = SourceRecord("TextNote8")
			DestinationRecord("TextNote9") = SourceRecord("TextNote9")
			DestinationRecord("TextNote10") = SourceRecord("TextNote10")

			DestinationRecord("CustCat1") = SourceRecord("CustCat1")
			DestinationRecord("CustCat2") = SourceRecord("CustCat2")
			DestinationRecord("CustCat3") = SourceRecord("CustCat3")
			DestinationRecord("CustCat4") = SourceRecord("CustCat4")
			DestinationRecord("CustCat5") = SourceRecord("CustCat5")
			DestinationRecord("CustCat6") = SourceRecord("CustCat6")
			DestinationRecord("CustCat7") = SourceRecord("CustCat7")
			DestinationRecord("CustCat8") = SourceRecord("CustCat8")
			DestinationRecord("CustCat9") = SourceRecord("CustCat9")
			DestinationRecord("CustCat10") = SourceRecord("CustCat10")


			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>CustomerNotes For Customer: " &  SourceRecord("customer_id") &   " Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>CustomerNotes Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> Customer Note records exported<br>
	</ul>

<%
	End IF ' End of ExportCustomerNotes = 1
%>


<% '****************************CustomerTechAssignment TABLE ****************************

	If ExportCustomerTechAssignment = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export CustomerTechAssignment table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from CustomerTechAssignment"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from CustomerTechAssignment"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew



			DestinationRecord("Customer_ID") = SourceRecord("customer_ID")
			DestinationRecord("Tech_ID") = SourceRecord("Tech_ID")

			' CustomerTechAssignmentID field is autonumber but it is not reference so
			' Autonumber does not have be reset.  They may not match exactly.


			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>Customer Tech Assignments For Customer: " &  SourceRecord("customer_id") &   "And Tech:" &  SourceRecord("tech_id") & " Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>CustomerTechAssignment Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> Customer Tech Assignment records exported<br>
	</ul>

<%
	End IF ' End of ExportTechAssignment = 1
%>

<% '****************************DeleteList TABLE ****************************

	If ExportDeleteList = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export DeleteList table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from DeleteList"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from DeleteList"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew



			DestinationRecord("Customer_ID") = SourceRecord("customer_ID")
			DestinationRecord("DeletedByIP") = SourceRecord("DeletedByIP")
			DestinationRecord("DateDeleted") = SourceRecord("DateDeleted")

		' Note: ListDeleteID is autonumber field but is not referenced as a key field
		' so we can let the new record be any number as needed.

			' CustomerTechAssignmentID field is autonumber but it is not reference so
			' Autonumber does not have be reset.  They may not match exactly.


			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>Delete List entries for Customer: " &  SourceRecord("customer_id") & " Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>DeleteList Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> DeleteList records exported<br>
	</ul>

<%
	End IF ' End of ExportDeleteList = 1
%>

<% '****************************EmailCategory TABLE ****************************

	If ExportEmailCategory = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export EmailCategory table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from EmailCategory"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from EmailCategory"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("EmailCategoryID") = SourceRecord("EmailCategoryID")
			DestinationRecord("EmailCategory") = SourceRecord("EmailCategory")

			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>EmailCategory entries for Category: " &  SourceRecord("emailcategory") & " Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>EmailCategory Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> EmailCategory records exported<br>
	</ul>

<%
	End IF ' End of ExportEmailCategory = 1
%>


<% '****************************EmailCategoryLinks TABLE ****************************

	If ExportEmailCategoryLinks = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export EmailCategoryLinks table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from EmailCategoryLinks"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from EmailCategoryLinks"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("EmailCategoryID") = SourceRecord("EmailCategoryID")
			DestinationRecord("Customer_ID") = SourceRecord("Customer_Id")

			' EmailCustomerCategoryID is autonumber and can be left auto number

			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>EmailCategoryLinks entries for Customer: " &  SourceRecord("customer_id") & " Exported</li>"

			End IF
				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>EmailCategoryLinks Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> EmailCategoryLinks records exported<br>
	</ul>

<%
	End IF ' End of ExportEmailCategoryLinks = 1
%>



<% '****************************EmailText TABLE ****************************

	If ExportEmailText = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export EmailText table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from EmailText"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from EmailText"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("EmailTextID") = SourceRecord("EmailTextID")
			DestinationRecord("EmailTextTitle") = SourceRecord("EmailTextTitle")
			DestinationRecord("EmailTextSubject") = SourceRecord("EmailTextSubject")
			DestinationRecord("CustomDearUser") = SourceRecord("CustomDearUser")
			DestinationRecord("RemovalLink") = SourceRecord("RemovalLink")
			DestinationRecord("Attachments") = SourceRecord("Attachments")
			DestinationRecord("ReplyToEmail") = SourceRecord("ReplyToEmail")
			DestinationRecord("FromOrganization") = SourceRecord("FromOrganization")


			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>EmailText Table entries for Entry subject: " &  SourceRecord("EmailTextSubject") & " Exported</li>"
			End If
				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>EmailText Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> EmailText records exported<br>
	</ul>

<%
	End IF ' End of ExportEmailText = 1
%>


<% '****************************Email_text TABLE ****************************

	If ExportEmail_text = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export Email_text table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from Email_text"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from Email_text"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("tech_update_case") = SourceRecord("Tech_update_case")
			DestinationRecord("customer_update_case") = SourceRecord("customer_update_case")
			DestinationRecord("customer_registration") = SourceRecord("customer_registration")
			DestinationRecord("tech_case_assigned") = SourceRecord("tech_case_assigned")
			DestinationRecord("lost_customer_id_search") = SourceRecord("lost_customer_id_search")
			DestinationRecord("user_page_html") = SourceRecord("user_page_html")

			'email_number is not used as key since only 1 record is recorded
			' so the autonumber can be left on for this table.

			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>Email_text Table Successfully Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>Email_text Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> Email_text records exported<br>
	</ul>

<%
	End IF ' End of ExportEmailText = 1
%>

<% '****************************KBConfiguration TABLE ****************************

	If ExportKBConfiguration = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export KBConfiguration table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from KBConfiguration"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from KBConfiguration"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("LastKBDate") = SourceRecord("LastKBDate")
			DestinationRecord("IncludeOneLine") = SourceRecord("IncludeOneLine")
			DestinationRecord("IncludeHistory") = SourceRecord("IncludeHistory")
			DestinationRecord("IncludeSummary") = SourceRecord("IncludeSummary")
			DestinationRecord("IncludeResolution") = SourceRecord("IncludeResolution")

			' KBConfigID is auto number but we only have one fields so it does not have
			' to be disabled.

			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>KBConfiguration Table successfully Exported</li>"
			End If

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>KBConfiguration Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> KBConfiguration records exported<br>
	</ul>

<%
	End IF ' End of ExportKBConfiguration = 1
%>


<% '****************************KBWords TABLE ****************************

	If ExportKBWords = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export KBWords table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from KBWords"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from KBWords"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("WordIndex") = SourceRecord("WordIndex")
			DestinationRecord("Word") = SourceRecord("Word")

			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>KBWords Table entries for word: " &  SourceRecord("Word") & " Exported</li>"
			End If


				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>KBWords Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> KBWord Table records exported<br>
	</ul>

<%
	End IF ' End of ExportKBWords = 1
%>


<% '****************************KBMap TABLE ****************************

	If ExportKBMap = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export KBMap table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from KBMap"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from KBMap"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("WordIndex") = SourceRecord("WordIndex")
			DestinationRecord("case_number") = SourceRecord("case_number")
			DestinationRecord("Section") = SourceRecord("Section")

			' Note MapIndex field is autonumber and not used so it can be left autonumber

			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>KBMap Table entries for word Index: " &  SourceRecord("Wordindex") & "Case Number: " & SourceRecord("Case_Number") & " Exported</li>"
			End If


				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>KBMap Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> KBMap Table records exported<br>
	</ul>

<%
	End IF ' End of ExportKBMap = 1
%>


<% '****************************Priority TABLE ****************************

	If ExportPriority = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export Priority table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from Priority"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from Priority"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("PriorityID") = SourceRecord("PriorityID")
			DestinationRecord("ShortDesc") = SourceRecord("ShortDesc")
			DestinationRecord("LongDesc") = SourceRecord("LongDesc")


			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>Priority Table entry: " &  SourceRecord("ShortDesc") & " Exported</li>"
			End If


				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>Priority Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> Priority Table records exported<br>
	</ul>

<%
	End IF ' End of ExportPriority = 1
%>

<% '****************************TopCases TABLE ****************************

	If ExportTopCases = 1 Then

	TotalImportedRecords = 0 ' Reset back to zero

	response.write "<B>Now attempting to export TopCases table to SQL*Server:</b><P>"

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  AccessDatabaseDSN   ' Conn = Access Source Database

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.


	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from TopCases"
			SourceRecord.Open SQL2,Conn,3,3

	Do while SourceRecord.EOF <> True

		' Create a new record on the desintation database

		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from TopCases"

			'response.write SQL

			DestinationRecord.Open SQL,Conn2,3,3
			DestinationRecord.AddNew

			DestinationRecord("case_number") = SourceRecord("case_number")
			DestinationRecord("caselisttype") = SourceRecord("caselisttype")

			DestinationRecord.Update

			If LoggingOptions = "FULL" Then

				response.write " <font color=green> <LI>TopCases Table entry: " &  SourceRecord("case_Number") & " Exported</li>"
			End If


				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if


		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections

	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close


%>

	</ul>

	<B>TopCases Table Successfully Exported</B><P>
	<UL> <%=TotalImportedRecords%> TopCases Table records exported<br>
	</ul>

<%
	End IF ' End of ExportPriority = 1
%>



</body>
</html>



<% Function CheckForUniqueTableValues(Tablename, Columnname, tablevalue)
	'This function checks to see if the passed column for a selected
	' table is unique (ie email in customer table, username, etc)
	' This functions either a "UNIQUE" or "NOTUNIQUE" returns

		' Notice we using another connection incase we already using conntemp.

		set conntemp2=server.createobject("adodb.connection")

		conntemp2.open myDSN ' Open the connection once here

		mySQL2="select * from " & tablename & " where " & Columnname & " = '" & TableValue & "'"

		set rstemp5=conntemp2.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp5.EOF then
			CheckForUniqueTableValues = "UNIQUE"
		Else
			CheckForUniqueTableValues = "NONUNIQUE"
		End If

		rstemp5.close
		set rstemp5=nothing

		conntemp2.close ' Close the connection
		set conntemp2=nothing

	End Function ' End of CheckForUniqueTableValues
	%>

