<%  ' Module: DoDirectoryLookup.asp
	'
	' Description: Submit Module For DirectoryLookup module - which checks against an LDAP directory,
	'  and (if found) updates the Customer Table with appropriate values and
	'

	'
	'
	' (C) 2000,2001, 2006 Internet Software Sciences
	'
	' Author: JC
	' History:
	' Date		Who		What
	' -----		----	----------------------------------------------
	'2/2/06		JC		Original version for new LDAP-enabled login to Customer+Center
	'3/16/06	JC		Cloned from DoAutologin


 ' Note - first we read up the LDAP parameters and execute the LDAP command to retrieve all the values from Active Directory
 ' Then we place
 '   a) the value passed to us (in the HTTP header) into the field called Customer_username
 '   b) The concatenated lastname-underscore-firstname into the field called Customer_id
 '
 ' If this guy does not yet exist in the customer table, we do an insert with these two values to establish him there
 ' Then, whether he existed previously or not, we update all his other values so that they are current and synched with the directory


%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->

<html>

<!-- (C) 1996,1998, 1999, 2000 by Internet Software Sciences -->

<head>

<title><%=wc_Customer_Information%> </title>
<!-- #INCLUDE FILE="Stylesheet.inc" -->
</head>

<body class=rightwindow>




<%





sUser = request.querystring("ID")


 'debugmode = "Yes"

If debugmode <> "" Then
      response.write "Debug mode is ON<P>"
      response.write "User_id is " & sUser & "<P>"
      response.flush
End if



baseDirectory = Server.MapPath(".")
slash = "\"
' now we chop off end of baseDirectory string to point us up to our parent directory
lastpos = InstrRev(baseDirectory,slash)
baseDirectory = Left(baseDirectory,lastpos)
TargetFilePath = baseDirectory & "ZCustomerHolder.asp"


Set fs1 = CreateObject("Scripting.FileSystemObject")


If fs1.FileExists(TargetFilePath) Then
   ' do nothing
Else
   response.write "<p><font size=+1 color=red><b>Error - </b></font>The settings for LDAP Directory Access are missing. Please ask your System Administrator to set these up.  <P>"
   response.flush
   response.end
End if



REM the "1" in the next statement represents "ForReading"
Set b = fs1.OpenTextFile(TargetFilePath, 1, FALSE)


linecounter = 0
Tabchar = Chr(9)

While not b.AtEndOfStream
   InRec  = b.Readline
   if Left(Inrec,1) =  "'" Then ' chop off the first character
       InRec = Mid(InRec,2)
	   linecounter = linecounter + 1
	   splitter = split(InRec,Tabchar)
	   If splitter(1) = "ConnectString1" Then ConnectString1 = splitter(0)
	   If splitter(1) = "ConnectString2" Then ConnectString2 = DeObfuscate(splitter(0))
	   If splitter(1) = "RetrieveField1" Then RetrieveField1 = splitter(0)
	   If splitter(1) = "RetrieveField2" Then RetrieveField2 = splitter(0)
	   If splitter(1) = "RetrieveField3" Then RetrieveField3 = splitter(0)
	   If splitter(1) = "RetrieveField4" Then RetrieveField4 = splitter(0)
	   If splitter(1) = "RetrieveField5" Then RetrieveField5 = splitter(0)
	   If splitter(1) = "RetrieveField6" Then RetrieveField6 = splitter(0)
	   If splitter(1) = "RetrieveField7" Then RetrieveField7 = splitter(0)
	   If splitter(1) = "RetrieveField8" Then RetrieveField8 = splitter(0)
	   If splitter(1) = "RetrieveField9" Then RetrieveField9 = splitter(0)
	   If splitter(1) = "RetrieveField10" Then RetrieveField10 = splitter(0)
	   If splitter(1) = "RetrieveField11" Then RetrieveField11 = splitter(0)
	   If splitter(1) = "RetrieveField12" Then RetrieveField12 = splitter(0)
	   If splitter(1) = "RetrieveField13" Then RetrieveField13 = splitter(0)
	   If splitter(1) = "RetrieveField14" Then RetrieveField14 = splitter(0)
	   If splitter(1) = "RetrieveField15" Then RetrieveField15 = splitter(0)
	   If splitter(1) = "RetrieveField16" Then RetrieveField16 = splitter(0)
	   If splitter(1) = "LdapAddress" Then LdapAddress = splitter(0)
	   If splitter(1) = "WhereField1" Then WhereField1 = splitter(0)
	   If splitter(1) = "SearchField1" Then SearchField1 = splitter(0)
	   If splitter(1) = "WhereField2" Then WhereField2 = splitter(0)
	   If splitter(1) = "SearchField2" Then SearchField2 = splitter(0)

	   If splitter(1) = "WhereField3" Then WhereField3 = splitter(0)
	   If splitter(1) = "SearchField3" Then SearchField3 = splitter(0)


	   If splitter(1) = "Upperlimit" Then Upperlimit = splitter(0)
	   If splitter(1) = "Lowerlimit" Then Lowerlimit = splitter(0)
	   If splitter(1) = "RangeVariable" Then RangeVariable = splitter(0)
   end if
Wend
b.Close



' --------------------- done loading up all the parameters ---------------------


'-------------------------- tricky bit ------------------------------------------------------
'  At this point, although we have loaded SearchField2 from the stored parameter settings - where it was
'  just a specimen for test purposes. At this point we actually want to use this user's id which we retrieved above,
'  so we put that into this field instead
'---------------------------------------------------------------------------------------------


  ' --- Make sure the target is safe in terms of embedded apostrophes,
  '        both in the sUser (where it is used in WHERE clause of subsequent SELECT, INSERT and UPDATE sql commands
  '        and in SearchField2 (where it is used in the WHERE clause of the LDAP command string

sUser = Replace(sUser,"'","''")
SearchField2 = sUser






' --------------- so now we build up the LDAP string --------------------------





' First we will capture the names of the source and target fields in 2 parallel arrays


Tabchar = Chr(9)
SourceFieldstring = ""
TargetFieldstring = ""
Call Collect (RetrieveField1,"Customer_id",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField2,"Contact_Fname",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField3,"Contact_Lname",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField4,"Company",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField5,"Mailstop",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField6,"Address",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField7,"City",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField8,"State",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField9,"Zip",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField10,"Country",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField11,"Email",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField12,"Phone1",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField13,"Phone2",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField14,"Fax",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField15,"Customer_Password",SourceFieldstring,TargetFieldstring)
Call Collect (RetrieveField16,"Customer_Username",SourceFieldstring,TargetFieldstring)
ArySourceField = Split(SourceFieldstring,Tabchar)
AryTargetField = Split(TargetFieldstring,Tabchar)

FieldCount = Ubound(ArySourceField) - 1



' ---- Assemble the names of the fields to be selected into the SELECT string

SelectString = "SELECT "

used_status = 0

DIM Aryused()
ReDim Preserve Aryused(1)
Aryused(0) = "&/()garbage_preset"

For i = 0 to FieldCount
  Call CheckUsed(ArySourceField(i), Aryused, used_status)
  If  used_status = 0 Then
    SelectString = SelectString & ArySourceField(i) & ", "
    'response.write "Checking " & ArySourceField(i) &" NOT Used at postiton " & Instr(UsedAlready,ArySourceField(i)) & "<br>"
 Else
    'response.write "Checking " & ArySourceField(i) &" IS Used at postiton " & Instr(UsedAlready,ArySourceField(i)) & "<br>"
  End if
Next

' ---- chop off the final comma space and append FROM and the address

Lambda = Len(SelectString)
Lambda = Lambda - 2
conjunct = " WHERE "
SelectString = Left(SelectString,Lambda)
SelectString = SelectString & " FROM " & "'" & LdapAddress & "'"


' ---- now append Range Control to Select string

If RangeVariable <> "" Then
  SelectString = SelectString & conjunct
  SelectString = SelectString & RangeVariable & " >= '" & Lowerlimit & "' AND " & RangeVariable & " <= '" & UpperLimit & "'"
  conjunct = " AND "
End If

' ---- now append the first Search to Select string
If WhereField1 <> "" Then
  SelectString = SelectString & conjunct
  SelectString = SelectString & WhereField1 & " = '" & SearchField1 & "'"
  conjunct = " AND "
End If

' ---- now append the second Search to Select string (this is the User-Id field)
If WhereField2 <> "" Then
  SelectString = SelectString & conjunct
  SelectString = SelectString & WhereField2 & " = '" & SearchField2 & "'"
  conjunct = " AND "
End If


' ---- now append the third Search to Select string (this is the Password field)
If WhereField3<> "" Then
  SelectString = SelectString & conjunct
  SelectString = SelectString & WhereField3 & " = '" & SearchField3 & "'"
  conjunct = " AND "
End If



If debugmode <> "" then
    response.write "Accessing the direcory with the  string --- <br><Blockquote><Span class=yellowhilight>" & SelectString & "</span></blockquote><P>"
	response.write "<center><table border=1 bgcolor=lightgrey><tr>"
	For i = 0 to FieldCount
	  response.write "<td align=center><b>" & ArySourceField(i) & "</b><br><font size=-1><i>maps into</i></font><br><b>" & AryTargetField(i) & "</b></td> "
	Next
	response.write "</tr>"
	response.flush

end if


' Now here (next line) is where we actualy cause LDAP to be fired and retrieve values...

DIM TheValues()
ReDim Preserve TheValues(FieldCount)


showvalue SelectString,FieldCount,ArySourceField,AryTargetField,TheValues,ConnectString1,ConnectString2






		AryValueField = thevalues

		If debugmode <> "" then
			for i = 0 to FieldCount
			   response.write "Entry " & I & " contains <b>" & ArySourceField(i) & "</b> to be mapped into <b>" & AryTargetField(i) & "</b> and has the value <b>" & AryValueField(i) & "</b><BR>"
			Next
			response.write "Field Count goes from 0 to " & FieldCount & "<P>"
		End If

       ' ---- here we generate a (new) skeleton record for this new user who does not yet exist
       ' but first we have to generate a value for the  customer_id composed of lastname_firstname if those 2 fields exist.
         genned_fname = ""
         genned_lname = ""
         genned_id = ""

		for i = 0 to FieldCount
			   If Ucase(AryTargetField(i)) = "CONTACT_FNAME" then genned_fname =  AryValueField(i)
			   If Ucase(AryTargetField(i)) = "CONTACT_LNAME" then genned_Lname =  AryValueField(i)
		Next

		' Guard against any nulls in either of these two fields so that it doesn't blow up subesequent replace
		if isNull(genned_fname) Then
		  genned_fname = ""
		end if

		if isNull(genned_lname) Then
		  genned_lname = ""
		end if

		genned_fname = Replace(genned_fname," ","-") '  replace spaces with hypen in first name
		genned_fname = Replace(genned_fname,"'","")  '  remove apostrophes in first name
		genned_fname = Replace(genned_fname,"~","")  '  remove tilde in first name
		genned_lname = Replace(genned_lname," ","-") '  replace spaces with hypen in first name
		genned_lname = Replace(genned_lname,"'","")  '  remove apostrophes in last name
		genned_lname = Replace(genned_lname,"~","")  '  remove tilde in last name


		if genned_fname <> "" AND genned_lname <> "" then genned_id = genned_lname & "_" & genned_fname
		if genned_fname <> "" AND genned_lname = "" then genned_id = genned_fname
		if genned_fname = "" AND genned_lname <> "" then genned_id = genned_lname
		if genned_fname = "" AND genned_lname = "" then genned_id = sUser




		genned_id = mid(genned_id, 1,20) ' ensure length does not exceed 20 chars



        If debugmode <> "" then
			response.write " I generated " & genned_id  & " as the customer_id<P>"
        end if



		' now we attempt to retrieve the users record - if it doesnt exist we must first create it before we can update it

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN
		mySQL2="SELECT * from Customers where customer_username= '" & sUser & "'"

        If debugmode <> "" then
		      response.write "Testing if customer already in Customer+Center Database with " & mySQL2 & "<P>"
        end if
		set rstemp=conntemp.execute(mySQL2)
		if rstemp.eof = True then
		     Flag1 = "Insert"
             If debugmode <> "" then
                 response.write "This user does not currently exist in Customer+Center database - so INSERT new record first<p>"
	             response.flush
	         end if

	         ' ***** at this point - before creating new customer record - we must ensure uniqueness of the generated customer_id field - our candidate value is in genned_id

	         Call ensure_unique(genned_id)

	         ' ***** and now we can do the actual insert

			 MySQL2  = "INSERT into Customers (customer_username, customer_id) values ('" & sUser & "','" & genned_id   & "')"
			 If debugmode <> "" then
			    response.write "Inserting new record with SQL thus: " & MySQL2 & "<P>"
			 end if
			 set rstemp=conntemp.execute(mySQL2)
         else
             Flag1 = "Update"
             If debugmode <> "" then
                 response.write "This user already exists in Customer+Center database - prepare to UPDATE the record<p>"
                 response.write "Old customer_id is " & rstemp("customer_id") & "<br>"
                 response.write "Old customer_name is " & rstemp("customer_username") & "<br>"
                 response.write "Old firstname is " & rstemp("contact_fname") & "<br>"
                 response.write "Old lastname is " & rstemp("contact_lname") & "<br>"
                 response.flush
	         end if
		end if

       ' --  Now we loop thru each of the fields truncating it to max size and issuing diagnostic if necessary

        for i = 0 to FieldCount
          if Ucase(AryTargetField(i)) = "CONTACT_FNAME" then AryValueField(i) = Fixtrunck("First Name", AryValueField(i), 50)
          if Ucase(AryTargetField(i)) = "CONTACT_LNAME" then AryValueField(i) = Fixtrunck("Last name", AryValueField(i), 50)
          if Ucase(AryTargetField(i)) = "COMPANY" then AryValueField(i) = Fixtrunck("Company", AryValueField(i), 80)
          if Ucase(AryTargetField(i)) = "ADDRESS" then AryValueField(i) = Fixtrunck("Address", AryValueField(i), 80)
          if Ucase(AryTargetField(i)) = "MAILSTOP" then AryValueField(i) = Fixtrunck("Mailstop", AryValueField(i), 50)
          if Ucase(AryTargetField(i)) = "CITY" then AryValueField(i) = Fixtrunck("City", AryValueField(i), 40)
          if Ucase(AryTargetField(i)) = "STATE" then AryValueField(i) = Fixtrunck("State", AryValueField(i), 40)
          if Ucase(AryTargetField(i)) = "ZIP" then AryValueField(i) = Fixtrunck("Zip", AryValueField(i), 40)
          if Ucase(AryTargetField(i)) = "COUNTRY" then AryValueField(i) = Fixtrunck("Country", AryValueField(i), 40)
          if Ucase(AryTargetField(i)) = "EMAIL" then AryValueField(i) = Fixtrunck("Email", AryValueField(i), 80)
          if Ucase(AryTargetField(i)) = "PHONE1" then AryValueField(i) = Fixtrunck("Phone1", AryValueField(i), 20)
          if Ucase(AryTargetField(i)) = "PHONE2" then AryValueField(i) = Fixtrunck("Phone2", AryValueField(i), 20)
          if Ucase(AryTargetField(i)) = "FAX" then AryValueField(i) = Fixtrunck("Fax", AryValueField(i), 20)
        next



		' --- now we can update the user's record with the values we got back from the directory -

		MySQL = "UPDATE Customers SET "

        for i = 0 to FieldCount
         MySQL = MySQL & AryTargetField(i) & "='" & detilde(AryValueField(i)) & "', "
        next

        ' at this point we have an extraneour comma-space at the end of the string with we have to remove before appending the WHERE clause

        lambda = Len(MySQL)
        lambda = lambda - 2
        MySQL = Left(MySQL,Lambda)

        ' now we append the WHERE string

           MySQL = MySQL & " WHERE customer_username = '" & sUser & "'"


        if debugmode <> "" then
           response.write "Update command is " & MySQL & "<P>"
           'response.write "Stopped before actual update"
           response.flush
           'response.end
        end if

        set rstemp=conntemp.execute(mySQL)

        ' now we read the record back in order to be able to display it

        MySQL = "SELECT * from Customers WHERE customer_username = '" & sUser & "'"

        if debugmode <> "" then
           response.write "Reading it back now to get the data with " & MySQL & "<P>"
           response.flush
        end if

        set rstemp=conntemp.execute(mySQL)

        If rstemp.eof then
           response.write "Failed to read back the record we just created/inserted"
           response.flush
           response.end
        end if

 		contact_fname = rstemp("contact_fname")
 		contact_lname = rstemp("contact_lname")
 		company = rstemp("company")
 		address = rstemp("address")
 		mailstop = rstemp("mailstop")
 		city = rstemp("city")
 		state = rstemp("state")
 		Zip = rstemp("Zip")
 		Country = rstemp("Country")
 		email = rstemp("email")
 		phone1 = rstemp("phone1")
 		phone2 = rstemp("phone2")
 		fax = rstemp("fax")
 		contact_method = rstemp("contact_method")
 		contact_times = rstemp("contact_times")
 		customer_username = rstemp("customer_username")
 		customer_id = rstemp("customer_id")
		ViewEmailCategoryID = rstemp("ViewEmailCategoryID")

        %>
    <center>
 	<Table class=BGWrapper >
 	<tr>
 	<td  align=center valign=center class=majorscreentitlefixed>

           <% if Flag1 = "Update" Then %>
              The following record has been <b>updated</b> using the Directory Entry
           <% else %>
              The following record has been <b>created</b> from the Directory Entry
           <% end If %>

 	</td>
	</tr></table>
<p>
  <table>
   <tr>
      <td class=outerformwrapper align=center> <!---- start of overall form wrapper -->

        <table class=BoxTableWrapper cellpadding=2 cellspacing=1>

			<tr><td  align=right class=formlabelsuper><%=wc_First_Name %>:</td> <td class=formlabel> <%=Contact_fname%></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_Last_Name %>:</td> <td class=formlabel> <%=Contact_lname%></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_Phone%>:</td> <td class=formlabel>   <%=Phone1%></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_Company%>:</td> <td class=formlabel> <%=Company%></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_Mailstop%>:</td> <td class=formlabel> <%=mailstop%></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_Phone2_Cell%>:</td> <td class=formlabel>   <%=Phone2%></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_Address%>:</td> <td class=formlabel>  <%=Address %></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_city%>:</td> <td class=formlabel>  <%=city %></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_state%>:</td> <td class=formlabel>  <%=state %></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_zipcode%>:</td> <td class=formlabel>  <%=zip %></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_country%>:</td> <td class=formlabel>  <%=country %></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_email%>:</td> <td class=formlabel>  <%=email %></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_Fax%>:</td> <td class=formlabel>   <%=Fax%></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_Mailstop%>:</td> <td class=formlabel>  <%=Mailstop%></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_Customer_ID%>:</td> <td class=formlabel>   <%=customer_id%></td></tr>
			<tr><td  align=right class=formlabelsuper><%=wc_Username%>:</td> <td class=formlabel>   <%=customer_username%></td></tr>

        </table>
      </td>
    </tr>
  </table>
<p>
  <table>
      <tr>
        <td><a href=TcaseForm.asp?Case_number=0&Customer_id=<%=customer_id%>><img src=/<%=WCLanguageDirectory%>/ts_new_case30x120.gif border=0></a></td>
        <td width=15></td>
        <td><a href=NewCustomer.asp?id=<%=customer_id%>><img src=/<%=WCLanguageDirectory%>/ts_edit_record30x100.gif border=0></a></td>

        <% if Flag1 = "Update" Then %>
			<td width=15></td>
			<td><a href=DoGetCase.asp?customer_id=<%=customer_id%>><img src=/<%=WCLanguageDirectory%>/ts_all_cases30x100.gif border=0></a></td>
            <td width=15></td>
            <td><a href=TCustomerSummary.asp?id=<%=customer_id%>><img src=/<%=WCLanguageDirectory%>/ts_summary30x100.gif border=0></a></td>
        <% end if %>
      </tr>
  </table>



       <%
       if debugmode <> "" then
         response.write "Halted in debug mode<p>"
         response.write "Execute this program again <b>without</b> debug=yes to continue<p>"
         response.flush
         response.end
       end if






 %>





<%
sub Collect(Sourcex,Targetx,SourceFieldString,TargetFieldString)
Tabchar = Chr(9)
If Trim(Sourcex) <> "" Then
   SourceFieldstring = SourceFieldstring & Trim(Sourcex) & Tabchar
   TargetFieldstring = TargetFieldstring & Trim(Targetx) & Tabchar
End If
End Sub
%>






<%

Sub showvalue(SQL,FieldCountx,Sources,Targets,TheValues,username,password)



		Set Conn = CreateObject("ADODB.Connection")
		' (following line fails in Linux environment)
	    Conn.Provider = "ADSDSOObject"

	    If username = "" and password = "" Then
		    Conn.Open "ADs Provider"
		    If debugmode <> "" then
				response.write "Connecting to ADs Provider without username and password<p>"
				response.flush
		    End If
		Else
			Conn.Open "ADs Provider", username, password
			If debugmode <> "" then
				response.write "Connecting to ADs Provider with the provided username and password <p>"
				response.flush
		    end if
		End If

         Set rs = Conn.Execute(SQL)

		If rs.EOF Or rs.BOF then
		    XX = Bailout(SQL)
			Response.write "No record returned"
		Else
		    safety_count = 0
            Do While Not rs.EOF Or rs.BOF
               If safety_count <> 0 then ' then it means we retrieved more than 1 record from directory - which is a problem....
                  %>
                     <html>
                     <head>
                     <title>Problem</title>
                     </head>
                     <body>
                       <font size=+1><b>Error - retrieved more than one entry from Active Directory for this login name</b></font>
                       <p>Please contact your system administration organization and report this promlem to them.

                     </body>
                     </html>
                  <%
                    response.flush
                    response.end
               end if ' safety count violated



              ' retrieve each of the fields in a given record into an array
               For k = 0 to FieldCountx
                  thefield = Sources(k)
                  ReturnValue = Rs(thefield)
                  If not isArray(ReturnValue) then
                      TheValues(k) = ReturnValue
                  else
                      ' put fixed string (i.e. array converted to string) into  TheValues(k)
                       MyAry = ReturnValue
					   Aryholder = ""
					   for zz = 0 to Ubound(MyAry)
						 if MyAry(zz) <> "" Then
							Aryholder = Aryholder & MyAry(zz) & " "
						 end if
					   next
					   TheValues(k) = Aryholder
                  end if

               Next
               safety_count = safety_count + 1
               'now emit the array as a row in a table
                If debugmode <> "" then
				   response.write "<tr>"
				   For k = 0 to FieldCountx
					  if TheValues(k) <> "" Then
						 response.write "<td>" & TheValues(k) & "<br></td>"
					  Else
						 response.write "<td align=center><font color=red>" & "[empty]" & "</font></td>"
					  End if
				   Next
				   response.write "</tr>"
			   end if
			   rs.MoveNext
			Loop
			If debugmode <> "" then
               response.write "</table><p></center>"
            End If
		End If

End Sub

%>


<%


Function DeObfuscate(thecode)

For I = 1 to 80 ' search for the string length value
	 ThisChar = Mid(thecode,I,1)
	 thisChar = Asc(thisChar) - 48
	 if Cint(thisChar) = Cint(I-1) Then
	  Strlength = I-1
	  Exit For
	 End if
Next
 'response.write "String length is " & Strlength & "<BR>"

Target = ""
For I = 1 to Strlength

  Offset =  Asc(Mid(thecode,I,1)) - 48
   ' response.write "Offset Number " & I & " has the value " & offset
  Target = Target & Mid(thecode,offset+1,1)
 ' Response.write " where the char I see is " & Mid(thecode,offset+1,1) & "<BR>"
Next
DeObfuscate = Target
End Function

%>

<%
Function BailOut(themessage)
error_message = themessage

   %>
      <html>
      <head>
      <title>Login Failed</title>
      </head>
      <body bgcolor=beige>
      <p>
      <font size=+1><b>Auto-Login Failure. No entry found for this user in the Directory </b></font>
      <p>
      <%=error_message%>

      </body>
      </html>


   <%
response.flush
response.end
End Function
%>

<%
Sub CheckUsed(FieldToBeChecked, Aryused, used_status)
Used_count = Ubound(Aryused)
If used_count = 0 Then
  used_count = used_count + 1
  ReDim Preserve Aryused(used_count)
  response.write "fisrt one is " & FieldToBeChecked & "<br>"
  Aryused(used_count) = FieldToBeChecked
  used_status = 0
Else
  used_status = 0
  for KK = 0 to Used_count
	  if Aryused(kk) = FieldToBeChecked Then
		' response.write "checking " & FieldToBeChecked & " and it is <b>used</b><br>"
		used_status = 1
		exit sub
	  else
		used_count = used_count + 1
		ReDim Preserve Aryused(used_count)
		Aryused(used_count) = FieldToBeChecked
		' response.write "checking " & FieldToBeChecked & " and storing as unused so far<br>"
	  end if
  Next
End If

End Sub
%>

<%
Sub ensure_unique(genned_id)


' this subroutine checks that genned_id does not exist in the customer table (as customer_id), and if it does, tries a different value
    Randomize ' Seed the generator with a new value
	set conntemp2=server.createobject("adodb.connection")
	conntemp2.open myDSN ' Open the connection once here
    candidate = genned_id

	mySQL2="select * from Customers where customer_id = '" & candidate & "'"
    set rstemp5=conntemp2.execute(mySQL2)
	if rstemp5.EOF then
		genned_id = candidate
        If debugmode <> "" then
		    response.write "The initialy generated ID is unique " & genned_id & "<P>"
		end if


	Else ' Ensure length is less than 17  and append random string - try this value and loop until we get a unique hit
	 candidate = mid(genned_id, 1,17)
     safety_fuse = 0

     If debugmode <> "" then
		    response.write "Duplicate ID exists - entering routine to generate a unique value<P>"
	 end if


     Do while not rstemp5.EOF
		  candidate = candidate & cstr(Int(rnd*100))
		  mySQL2="select * from Customers where customer_id = '" & candidate & "'"

		  If debugmode <> "" then
		      response.write "SQL try is " & mySQL2 & "<br>"
		  end if

		  set rstemp5=conntemp2.execute(mySQL2)
		  safety_fuse = safety_fuse + 1
		  if safety_fuse > 90 then
		    response.write "We blew up trying to generate a unique user_id for " & gennd_id & "<p>"
		    response.flush
		    response.end
		  end if
     loop

     genned_id = candidate

	End if



	rstemp5.close
	set rstemp5=nothing

	conntemp2.close ' Close the connection
	set conntemp2=nothing

end sub
%>

<% Function detilde(thestring)

If isNull(thestring) or thestring="" then
   thestring = ""
else
   thestring = Replace(thestring,"'","''")
   thestring = Replace(thestring,"~","''")
end if

detilde = thestring

End Function

%>


<%

Function Fixtrunck(thename, thevalue, thelength)

	If isNull(thevalue) or thevalue ="" then
	  Fixtrunck = thevalue
	else
	  if Len(thevalue) > cint(thelength) Then
		 response.write "<font color=red><b> Caution! - </b></font> The field <b>" & thename & "</b> has the value <b>" & thevalue  & "</b> which exceeded " & thelength & " characters and was truncated <p>"
		 Fixtrunck = Left(thevalue, thelength)
	  else
		 Fixtrunck = thevalue
	  end if
	end if

end function
%>