<% 'Module: 

   'Description: This module is invoked by ShowStaffByGroup whenever a Toggle of the "Group Notify"
   'setting for a given Tech_ID is requested - and it "remembers" the sort setting and selected group setting merely
   'to be able to pass these back to the caller
   'It expects to be called with a five parameters on the URL thus
   '     techid = the value of the techid whose record is to be updated
   '     value = the current value of the setting that needs to be toggled
   '     sort = the name of the field to be sorted on (required only for purposes of remembering current sort order
   '                                                   so it can redisplay the records in the same sequence as before)
   '     group_number = merely to be remembered and passed on back, this is the *selected* group to be displayed,
   '                    and may = 999999 meaning "ALL"
   '     target_group = this is the group number of this tech that needs to be toggled - i.e. the combo of tech_id and
   '                    target group tells us which record in the database needs to be modified


   '(C) 2000, 2001, 2002 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date		Who		What
   '-------	    ---		------------------------------------------------
   '08/03/05	JC		Created original ASP module to replace the ?dll version

%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->


<%' Include this file to get special database cursor constants to read record count values %>


<!-- #INCLUDE FILE="Adovbs.inc" -->

<%' Get the Internationalisation File - it is needed even in this program because we refer to wc_yes and wc_no  %>
<!-- #INCLUDE FILE="../Language/wcLabelsAdmin.inc" -->




<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 5

	CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN") ' Get the Logged TechID from the cookie

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="SELECT * from Tech_staff where Tech_ID = '" & CookieID & "' AND Tech_Level >= " & TechLevel
		set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF <> True Then
			ValidUser = "YES" ' Set this variable to prevent problems on next page
		End If

		rstemp.close
		set rstemp=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing

 ' End of ASP page security checks
 %>


<% if ValidUser <> "YES" Then %>
	<% ASPPage = "EditConfiguration.asp"%>

	<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function %>




<%


set conntemp=server.createobject("adodb.connection")
conntemp.open myDSN



' ------------- First pick up all the parameters from the URL string -------------------

sort_vector = request.querystring("sort")
techid_vector = request.querystring("techid")
value_vector = request.querystring("value")
group_vector = request.querystring("group_number")
target_group_vector = request.querystring("target_group")

SQL = "UPDATE Groups "


	' -------- Prepare the SQL ststement to set either the notify field or the dispatch field to the toggled value


	If value_vector = wc_Yes Then
	  SQL = SQL & " SET new_case_notify = '0' "
	Else
	  SQL = SQL & " SET new_case_notify = '1' "
	End If




SQL = SQL & " WHERE tech_id ='" & techid_vector & "' AND group_number =" & target_group_vector

     ' -------- And execute the SQL statement ------------------

set rstemp=conntemp.execute(SQL)

   ' -----------End Game Follows --------------------------------------


set rstemp=nothing
conntemp.close ' Close the connection



redirect_vector = "DoShowStaffByGroup.asp?sort=" & sort_vector & "&group_number=" & group_vector


response.redirect redirect_vector


end if 'this was a valid user
%>




