<% 'Module: DoShowSurvey.asp

   'Description: This module processes the ShowSurvey.asp (Customer Survey)
   ' responses into the database for later review and also
   ' sends an email to a user for review.

   ' Once it collects and stores all of the data, it outputs a simple
   ' thank you page since the original page is called from a link from
   ' an email.
   '(C) 2000, 2001, 2002 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date		Who		What
   '-------		---		------------------------------------------------
	'08/27/02	SAV		Created original Module
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabelsAdmin.inc" -->


<%' Include this file to get special database cursor constants to read record count values %>


<!-- #INCLUDE FILE="Adovbs.inc" -->
<!-- #INCLUDE FILE="../Language/SendEmail.inc" -->


<%
	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Configuration" ' We will allow up to 10 Priority values

	set rstemp=conntemp.execute(mySQL)

	If rstemp.EOF = True  Then
		Response.write "No Configuration file found"
	Else


		' Get the other fields with another lookup




		MaxHistorySize =  CLng(rstemp("max_case_history_size"))
		MaxSummarySize =  Cint(rstemp("max_case_summary_size"))
		MaxResolutionSize =  Cint(rstemp("max_case_resolution_size"))

		'Response.write "MaxResolutionSize=	" & MaxResolutionSize

		smtp_host_address = rstemp("smtp_host_address")
		Standard_reply_to_address = rstemp("Standard_reply_to_address")
		Customer_case_notify = CInt(rstemp("customer_case_notify"))
		UserPageColor = rstemp("ts_user_page_color")

		' New 4.0 Fields
		Customersurvey = rstemp("Customersurvey") ' Boolean flag enabling customer Surveys
		SurveyEmailText =	rstemp("SurveyEmailText") ' Customer Survey Email Message Text
		TechVirtual = rstemp("TechVirtual") ' Techcenter virtual directory
		CustomerVirtual = rstemp("CustomerVirtual") ' CustomerCenter Virtual directory
		SurveyEmail1 = rstemp("SurveyEmail1") ' Emails to send results to

		'response.write "SurveyEmail1 = " & SurveyEmail1
		SurveyEmail2 = rstemp("SurveyEmail2")
		SurveyEmail3 = rstemp("SurveyEmail3")

		OrganizationFromNameInternal = rstemp("Customer_Name_Text") ' Use this for organization name in mail out
		OrganizationFromName = OrganizationFromNameInternal


	End If

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

%>


	<% ' We will need to cycle through all of the active questions
	' and store the results in the Survey_Results and Result_Detail tables
	' To do this, open up a record set of the questions and loop through and
	' and collect data as we step through the data.


	set conntemp=server.createobject("adodb.connection")

	conntemp.open myDSN ' Open the connection once here

	mySQL2="select * from Survey Order by Question_Order"

	set rstemp = server.createobject("adodb.recordset")
	rstemp.open mySQL2, conntemp, 1,3

	If rstemp.EOF = True  Then
		' No questions defined comes here

	Else

		' First save master survey results entry and then
		' save the detailed survey results.
		Set NewRecord = Server.CreateObject("ADODB.Recordset")

			SQL = "Select * from Survey_Results"

			'response.write SQL

			NewRecord.Open SQL,Conntemp,3,3

			NewRecord.AddNew


			NewRecord("Survey_Date") = Now()

			Case_Number = Request.form("Case_Number")

			NewRecord("Case_Number") = Request.form("Case_Number")

			NewRecord.Update

		NewRecord.Close
		set NewRecord = Nothing

		' Now we need that index for putting in the individual table results

		mySQL3="select * from Survey_Results where Case_Number = " & Case_Number

		set rstemp2 = server.createobject("adodb.recordset")
		rstemp2.open mySQL3, conntemp, 1,3

		rstemp2.MoveLast

		Result_ID = rstemp2("Results_ID")

		rstemp2.close
		set rstemp2 = Nothing

		' While we are storing the values in the database, we will also
		' be creating an email message that shows the questions and answer
		' so it can be sent to some selected users.

		Message = ""

		Message = "Customer Survey for Case: " & Case_Number & vbCRLF & vbCRLF



		Do While rstemp.EOF <> True

			Active = Rstemp("Active")

			If Active = True Then

			Survey_Question = rstemp("Survey_Question")
			Question_Type = rstemp("Question_Type")
			Question_ID = rstemp("Question_ID")
			Question_Order = rstemp("Question_Order")

			Message = Message & "QUESTION:" & Survey_Question & vbCRLF


		' Now save the data and loop through all of the questions

		Set NewRecord = Server.CreateObject("ADODB.Recordset")

			SQL = "Select * from Result_Detail"

			'response.write SQL

			NewRecord.Open SQL,Conntemp,3,3

			NewRecord.AddNew


			NewRecord("Results_ID") = Result_ID
			NewRecord("Question_ID") = Question_ID

			' Now check for Type 1 (1-5 Radio box choices)

			FormElementName = "Radio_" & Question_ID

			If Request.form(FormElementName) <> "" Then
				NewRecord("Range_Answer") = CInt(Request.form(FormElementName))
				Message = Message & "ANSWER: 1-5 Choice Button-" & Request.form(FormElementName)

			End If


			' Now check for Type 2 (YES/NO radio box)

			FormElementName = "YESNO_" & Question_ID

			If Request.form(FormElementName) <> "" Then ' Passed as "1" or "2"
				If Request.form(FormElementName) = "1" Then
					NewRecord("YES_NO_ANSWER") = True
					Message = Message & "ANSWER: YES"

				Else
					NewRecord("YES_NO_ANSWER") = False
					Message = Message & "ANSWER: NO"

				End if

			Else ' For SQL*Server we must set this bit field to something since NULLS are not allowed.

					NewRecord("YES_NO_ANSWER") = False


			End If

			' Now check for Type 3 (Open Ended Small Text Box)

			FormElementName = "TextBox_" & Question_ID

			If Request.form(FormElementName) <> "" Then
				NewRecord("Open_Ended_Answer") = Request.form(FormElementName)
				Message = Message & "ANSWER: " & Request.form(FormElementName)
			End If


			' Now check for Type 4 (Open Ended Text-area Box)

			FormElementName = "TextArea_" & Question_ID

			If Request.form(FormElementName) <> "" Then
				NewRecord("Open_Ended_Answer") = Request.form(FormElementName)
				Message = Message & "ANSWER: " & Request.form(FormElementName)

			End If

			Message = Message & vbCRLF & vbCRLF


			NewRecord.Update



			NewRecord.Close
			Set NewRecord = Nothing

		End IF ' If Active <> True


		rstemp.MoveNext
		Loop

	End If

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing


	' Now Send out Email to special users who get an email with the customer
	' survey results.  These are configured on a special configuration web-page.

	SubjectLine = "Customer Survey Results (TEST)"


	If SurveyEmail1 <> "" Then
	   ToEmail = SurveyEmail1
	   If MyOS = "Windows" Then
		  SendEmail ToEmail, ToFullName, SubjectLine, Message
	   Else
	     SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
	   End If
	End If


	If SurveyEmail2 <> "" Then
	   ToEmail = SurveyEmail2
	   If MyOS = "Windows" Then
		  SendEmail ToEmail, ToFullName, SubjectLine, Message
	   Else
	     SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
	   End If
	End If

	If SurveyEmail3 <> "" Then
	   ToEmail = SurveyEmail3
	   If MyOS = "Windows" Then
		  SendEmail ToEmail, ToFullName, SubjectLine, Message
	   Else
	     SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
	   End If
	End If





%>



<html>
<head>
<title><%=wc_Customer_Survey%></title>
</head>
<body>
<br>
<center>
<font size=+1><I>
<%=wc_Thank_you%>!

</i>

<br>
<br>

<a href=SurveyBuilder.asp><%=wc_Return_to_Survey_Builder%></a>
<br>

</center>




</body>
</html>



