<% 'Module: DoTCaseForm.asp NONSBCC

   'Description: This module add or updates the case table
   ' with the new case information. It displays an resultant page
   ' that shows the status of the case updating and emailing information.
   ' with an continue button to return back to display the case again or cancel.
   ' This functions sends out emails to the Customers, and techs
   ' notifying them of this new case.

   '(C) 2000,2001,2002, 2003, 2004, 2005, 2013 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '3/27/00	SAV		Created original ASP
   '09/17/00 SAV	Created from DoCaseForm.asp Module for customer case forms which
   ' is similar but Tech Case form has more fields.
   '03/23/01 SAV	Modifed for AdjustedTimeZone Variable
   '05/11/01 SAV	Added code for intial group assignment based on Categories
   '07/31/01 SAV	Added code to send short emails to cell phone email address for techs
   '09/05/02 SAV	Added feature to send Customers - customer survey emails
   '10/07/04 SAV	Added feature to send HTML emails
   '04/08/05 JC     Added feature to allow sending of individual survey just for this case
   '05/01/06 JC		Added obfuscated ID=customer_id and MODE=Auto to return URL to allow automatic logging in with DCF.asp
   '04/14/2011 CMB  Added check for empty time before creating repeating fields
   '05/04/11 CMB 	Checked to make sure assigned tech wasn't getting email before sending him out again in groups
   '10/03/11 CMB   Projects; new asset information on top
   '10/05/11 CMB   Expense date; configuration file parameters; added cdate() for billing date field (was storing in wrong in sqlserver)
   '10/10/11 CMB   $500 is apparently numeric in vbscript but fails later so get rid of $ in expenses and timespent sections
	'02/06/12 CMB  Log asset_number change
	'02/20/12 CMB  CDate screwing things up for UK Access
	'10/02/12 CMB  Wordpress
	'02/15/13 SAV  Version 8.0 Additional customer case assignments
	'04/2/2103 SAV	Added setting of escalation bit
	'04/24/13  CMB  Add note if customer removed
	'04/29/13  CMB  Changed additionalcustomercaseassignments emails so send correct login link for their customer_ID
   '05/24/13  CMB  Customers added or deleted get emails whether or not send email checked
   '06/04/13  CMB  Added case one line to email subject
   '07/25/2013 SAV	Added quote to replace double quotes on line description.
   '11/23/13  CMB  If force surveys is enabled, surveys sent automatically when closed, coninue just goes to tcase form whether closed or not
   '12/9/13   CMB  Changed updatekb button to continue in two places

%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->


<!-- #INCLUDE FILE="../Language/CodeCustomizations.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->
<!-- #INCLUDE FILE="../Language/SendEmail.inc" -->

<% If Version8Point0 = "YES" Then
%>

<!-- #INCLUDE FILE="../Language/SendTxtMsg.inc" -->

<% End If %>

<!-- #INCLUDE FILE="../Language/HTMLEmailTemplateTechUpdate.inc" -->
<!-- #INCLUDE FILE="../Language/HTMLEmailTemplateCustomerNotification.inc" -->
<!-- #INCLUDE FILE="../Language/HTMLEmailTemplateCustomerSurvey.inc" -->
<!-- #INCLUDE FILE="../Language/QBOptions.inc" -->
<!-- #INCLUDE FILE="../Language/HTMLEmailTemplateAdditionalCustomerCaseNotification.inc" -->
<!-- #INCLUDE FILE="../Language/HTMLEmailTemplateAdditionalNotification.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>

<%' Include this file for special database cursor constants %>

<!-- #INCLUDE FILE="Adovbs.inc" -->

<% 'Get the form data
    Dim TechEmailSent  '  CMB 05/04/2011
    TechEmailSent = 0  '  CMB 05/04/2011
     Dim SurveySent  ' 11/20/13
    SurveySent = ""  ' 11/20/13
    Dim SendCustomerCenterLink  ' 12/13/13
		SendCustomerCenterLink = "YES" ' Defaults to  including link - comment to remove

	LoginTech_ID = Request.Cookies ("ISS_TECH_CENTER_LOGIN")
	Tech_Full_Name = TechFullName(LoginTech_ID)

	Customer_ID = Request.form("Customer_ID")

		' Get Any optional case text fields data

		Text_Field_1 = Request.form("Text_field_1")
		Text_Field_2 = Request.form("Text_field_2")
		Text_Field_3 = Request.form("Text_field_3")
		Text_Field_4 = Request.form("Text_field_4")
		Text_Field_5 = Request.form("Text_field_5")
		Text_Field_6 = Request.form("Text_field_6")
		Text_Field_7 = Request.form("Text_field_7")
		Text_Field_8 = Request.form("Text_field_8")
		Text_Field_9 = Request.form("Text_field_9")
		Text_Field_10 = Request.form("Text_field_10")


		Case_Number = Request.form("Case_Num")
		If Case_Number = "0"  then
			CaseType = "NEW"
		End If

		Case_History = Request.form("Case_History")

		Case_Summary = Request.form("Summary")
		Case_Resolution = Request.form("Resolution")


		' Replace any double quotes from one line description with a single quote character
		' Changed added 7/25/2013 - SAV

		Case_One_Line_1 = Request.form("Case_One_Line")

		Case_One_Line = replace(Case_One_Line_1, """", "'")

		Asset_Number = Request.form("Asset_Number")

		' Get tech specific fields of Group_Number, Case_status, tech_id (assigned)
		' and case_severity (Priority)

		Group_Number_From_Form = Request.form("Group_Number")
		Case_Status = Request.form("Case_Status")
		Tech_ID = Request.form("Tech_ID")
		AssignedTechID = Request.form("Tech_ID") ' Save this for later with repeat Cases
		Dup_Case_Num = Request.form("Dup_Case_Num")
		Status = request.form("Case_Status")
		Case_Severity = Request.form("Case_Severity")

		' Schedule Case Form Fields

		ScheduleCase = Request.form("ScheduleCase")
		RepeatInterval = Request.form("RepeatInterval")
		DueMonth = Request.form("DueMonth")
		DueDay = Request.form("DueDay")
		DueYear = Request.Form("DueYear")
		DueHour = Request.form("DueHour")
		DueMinute = Request.form("DueMinute")
		DueAMPM = Request.Form("DueAMPM")
		External_Case_Number = Request.form("External_Case_Number")


		SendEmailValue = Request.form ("SendEmail") ' Radio button to send email to Customers
		' This fields is set to either "YES" or "NO"

		AssetGroup  = Request.form("AssetGroup") ' New Version 7.0 field


	' FIRST Get the values from the configuration file and into variables

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Configuration" ' We will allow up to 10 Priority values

	'set rstemp=conntemp.execute(mySQL)

	'**** Major problem with SQL*Server and Conntemp.execute when getting
	' configuration data.  One should use: recordset.open DSN connection 1, 3

	' Cursor type needs to be specified and use rstemp.open

	set rstemp = server.createobject("adodb.recordset")
	rstemp.open mySQL, conntemp, 1,3

	If rstemp.EOF = True  Then
		Response.write "No configuration file found"
		assets_db = 0 ' 10/05/11
	Else
		' Get the values from the configuration File

		TextBoxSizing = rstemp("Text_Box_Sizing")
		CasesummaryRows = rstemp("case_summary_rows")
		CasesummaryMaxRows = rstemp("case_summary_Max_Rows")
		CaseResolutionRows = rstemp("case_resolution_rows")
		CaseResolutionMaxRows = rstemp("Case_resolution_Max_Rows")
		CaseHistoryRows = rstemp("Case_History_Rows")
		CaseTextBoxColumns = rstemp("Case_Text_Box_Columns")
		TimeZoneAdjustment = rstemp("Time_zone_Adjustment")
		TimeZoneLabel = rstemp("Time_zone_Label")
		Language = rstemp("Language")
		ALLKBUpdate = rstemp("All_KB_Update")
		TimeSpentCategory = rstemp("Time_Spent_Category")
		TimeSpentInterval = rstemp("Time_Spent_Interval")
		DateDisplayFormat = rstemp("Date_Display_Format")

		MaxHistorySize =  CLng(rstemp("max_case_history_size"))

'		MaxSummarySize =  Cint(rstemp("max_case_summary_size"))
'		MaxResolutionSize =  Cint(rstemp("max_case_resolution_size"))

' Changed to handle larger than 32K - 11/29/2012
		MaxSummarySize =  CLng(rstemp("max_case_summary_size"))
		MaxResolutionSize =  CLng(rstemp("max_case_resolution_size"))



		'Response.write "MaxResolutionSize=	" & MaxResolutionSize

		smtp_host_address = rstemp("smtp_host_address")
		Standard_reply_to_address = rstemp("Standard_reply_to_address")
		Customer_case_notify = CInt(rstemp("customer_case_notify"))
		UserPageColor = rstemp("ts_user_page_color")

		' New 4.0 Fields
		Customersurvey = rstemp("Customersurvey") ' Boolean flag enabling customer surveys
		SurveyEmailText =	rstemp("SurveyEmailText") ' Customer Survey Email Message Text
		TechVirtual = rstemp("TechVirtual") ' Techcenter virtual directory
		CustomerVirtual = rstemp("CustomerVirtual") ' CustomerCenter Virtual directory
		 OrganizationFromName = rstemp("Customer_Name_Text") ' Use this for organization name in mail out

		' New 5.0 SMTP mailer options

		SendHTMLEmail = rstemp("SendHTMLEmail") ' Boolean value
		SMTP_User_Name = rstemp("SMTP_User_Name")
		SMTP_Password = rstemp("SMTP_Password")

		If SendHTMLEmail = True Then
			HTMLEmail = "YES"
		Else
			HTMLEmail = ""
		End IF


		' Get DatabaseType for inserting of ExtendedTimeSpent Entries
			DatabaseType  = rstemp("DatabaseType") ' Database should be set to ACCESS or SQLSERVER

	'*** version 7.5
		assets_db =  rstemp("assets_db")  ' 10/05/11

		bExpenses = False
		bAssetInspections = True ' backwards compabitility
		bAdditionalEmails = False ' backwards compabitility
		If AdditionalNotificationEmails = "YES" then ' backwards compabitility
			bAdditionalEmails = True
		End If

		If version7point5="YES" then
			If Not IsNull(rstemp("Expenses")) Then
				bExpenses = rstemp("Expenses")
			End If

		'	If not IsNull(rstemp("AssetInspections")) Then ' not used
				'bAssetInspections = rstemp("AssetInspections")
			'End If

			If not IsNull(rstemp("AdditionalNotificationEmails")) then
            if rstemp("AdditionalNotificationEmails") = True or rstemp("AdditionalNotificationEmails") = 1 then ' 03/21/13
					bAdditionalEmails = True  '  rstemp("AdditionalNotificationEmails") ' 03/21/13
					AdditionalNotificationEmails = "YES"  ' Set this variable too
				end if  ' 03/21/13
			end if
		End If



		' Version 7.0 fields
		If bAdditionalEmails = True or bAdditionalEmails = 1 Then 'Version 7.5  ' 03/21/13
			'Extracts the Primary additional notification email address

			PrimaryAdditionalNotificationEmail = rstemp("PrimaryAdditionalNotificationEmail") '
		End If

     WebCemterVersion = 5.0
      ForceSurvey=false
      TechMobileVirtual = ""
      CustomerMobileVirtual = ""

		if Version8point0="YES" Then
			If Not IsNull(rstemp("AdditionalCustomerCaseAssignments")) Then
				bAdditionalCustomerCaseAssignments = rstemp("AdditionalCustomerCaseAssignments")
			End If

			'****** 11/20/13
			CustomerMobileVirtual = rstemp("CustomerMobileVirtual")
			TechMobileVirtual = rstemp("TechMobileVirtual")

			if isnull(rstemp("WebCenterVersion")) then
				WebCenterVersion = 8.0
			Else
				WebCenterVersion = cdbl(rstemp("WebCenterVersion")) '11/19/13
			End if

	'		if webcenterversion > 8.0 then  '11/19/13
				if not isnull(rstemp("ForceSurvey")) then
					ForceSurvey = rstemp("ForceSurvey")
				Else
					ForceSurvey = false
				end if
	'		End if
        '*** end 11/20/13
	End If
End If

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

		' We will get and store all of the Categories below.
	If CInt(assets_db) = 1 then
		AssetEnabled = True
	Else
		AssetEnabled = False
	End If

		CreateTimeDateValues DateString, TimeString, DateTimeString

		' Now Get the DateString and TimeString from passed hidden form elements
		' and replace those other values for new cases only

		If Case_Number = "0" Then

			DateString = Request.form("DateString")
			TimeString = Request.form("TimeString")
		End If


		DefaultGroupNumber = GetDefaultGroupNumber()

		' Check for the required fields
		' You can add additional required fields or removed
		' restrictions by commenting out the checks below.

		ErrorMessage = "" ' Clear error message


		If Case_One_Line  = "" Then
			ErrorMessage = ErrorMessage & "<LI> " & wc_The_case_one_line_field_must_be_completed
		End If

		' Check to see if the size of the case_history is larger
		' or will be larger than the maximum size allowed in
		' the configuration file





		If Len(Case_History) >= (CLng(MaxHistorySize) - 100)   Then
			ErrorMessage = ErrorMessage & "<LI> " & wc_Case_History_text_is_too_long
		End If


		' If asset is entered, verify it is a valid asset number
		If Asset_Number <> "" and Asset_Number <> "0" Then  ' CMB 09/27/2011
			set conntemp=server.createobject("adodb.connection")
			conntemp.open myDSN

			mySQL="select * from Assets WHERE asset_Number = " & Asset_Number

			set rstemp=conntemp.execute(mySQL)

			If rstemp.EOF = True  Then
				ErrorMessage = ErrorMessage & "<LI> " & wc_Invalid_Asset_Number

			Else
				' Other wise it must exist so it is ok and no message
			End IF

			rstemp.close
			set rstemp=nothing
			conntemp.close ' Close the connection
			set conntemp=nothing
		End IF ' If Asset_Number <> ""


		' If Dup_Case_Num is entered, verify it is a valid case number
		If Dup_Case_Num <> "" Then
			set conntemp=server.createobject("adodb.connection")
			conntemp.open myDSN

			mySQL="select * from Cases WHERE case_number = " & Dup_Case_num

			set rstemp=conntemp.execute(mySQL)

			If rstemp.EOF = True  Then
				ErrorMessage = ErrorMessage & "<LI> " & wc_Invalid_Dup_case_Number

			Else
				' Other wise it must exist so it is ok and no message
			End IF

			rstemp.close
			set rstemp=nothing
			conntemp.close ' Close the connection
			set conntemp=nothing
		End IF ' If Dup_Case_Number <> ""

'**** error checking on expense items
If bExpenses=True Then
	td = Request.form("ExpenseDateDay")
	tm = Request.form("ExpenseDateMonth")
	ty = Request.form("ExpenseDateYear")

	if (td > "" and not IsNumeric(td)) or (tm> "" and not IsNumeric(tm)) or (ty > "" and not IsNumeric(ty)) then
		ErrorMessage = ErrorMessage & "<LI> " & wc_Invalid_Expense_Date
	End if

	if Request.form("Quantity") > "" and not IsNumeric(Request.form("Quantity"))  then
		ErrorMessage = ErrorMessage & "<LI> " & wc_Invalid_Quantity
	End if

	if Request.form("Cost") > "" and not IsNumeric(Request.form("Cost"))  then
		ErrorMessage = ErrorMessage & "<LI> " & wc_Invalid_Cost
	End if

	if Request.form("TaxRatePercent") > "" and not IsNumeric(Request.form("TaxRatePercent"))  then
		ErrorMessage = ErrorMessage & "<LI> " & wc_Invalid_Tax_Rate
	End if

End If
'**** error checking on time spent
	td = Request.form("TimeSpentDateDay")
	tm = Request.form("TimeSpentDateMonth")
	ty = Request.form("TimeSpentDateYear")

	If Request.form("TimeSpentHours") <> "" Then
		If Not IsNumeric(request.form("TimeSpentHours")) then
			ErrorMessage = ErrorMessage & "<LI> " & wc_Invalid_Time_Spent_Hours
		End If

		if (td > "" and not IsNumeric(td)) or (tm> "" and not IsNumeric(tm)) or (ty > "" and not IsNumeric(ty)) then
			ErrorMessage = ErrorMessage & "<LI> " & wc_Invalid_Time_Spent_Date
		End if


		'if Request.form("TimeSpentHourlyRate") = ""   then
			'ErrorMessage = ErrorMessage & "<LI> " & wc_Invalid_Hourly
		'End if
	End If

'*** End error checking

		' ************* USER CUSTOMIZATIONS **************************
		' Add your own data requirements as necessary and add any
		' error text to be displayed to ErrorMessage string variable.

		If ErrorMessage <> "" Then
		%>

<!-- #INCLUDE FILE="Techusererror.inc" -->

	<% Else 'Otherwise either add new or update case record
		' DO NOT MODIFY this code below with caution:
		' The case record has some required fields and the
		' several of the fields must be carefully filled in
		' to make other parts of the system work correctly.


	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  myDSN

	' Check to see if case_number exists then this is an update


		Set NewRecord = Server.CreateObject("ADODB.Recordset")

		If Case_Number = "0" Then
			SQL = "Select * from Cases"
		Else
				SQL = "Select * from Cases where case_number = " & case_number
		End IF

		'response.write SQL

		NewRecord.Open SQL,Conn,3,3


		If CaseType <> "NEW" And NewRecord.EOF = True then
			response.write " UPDATE ERROR - Existing record not found <br>"
			Response.write "SQL = " & SQL
			Response.flush
			Response.end
		End If



		If CaseType = "NEW" Then
			NewRecord.AddNew

			' For new records we fill in the
			' the opendate and open time fields
			' with the following formats:
			' OpenDate: YYYYMMDD

			' OpenTime: HHMMSS

			NewRecord("modified_flag") = 1
			NewRecord("Open_Date") = DateString ' YYYYMMDD
			NewRecord("Open_Time") = TimeString ' HHMMSS
			NewRecord("mod_date") = DateString ' YYYYMMDD
			NewRecord("mod_time") = TimeString ' HHMMSS
		' Reopen_Date and reopen_time fields are not really used
		' so we will use these fields to determine if it is new
		' case by only setting them during tech updates.

			'NewRecord("Reopen_Date") = Datestring
			'NewRecord("reopen_Time") = TimeString

			NewRecord("Customer_ID") = Customer_ID


			If Version7 = "YES" Then
				If AssetGroup <> "" Then
					NewRecord("AssetGroupIndex") = AssetGroup
				End If
			End IF


			' * * * * * * Schedule Case Fields Processing

			If ScheduleCase <> "" Then
				NewRecord("Scheduled_Case_Type") = ScheduleCase
			End IF

			If RepeatInterval <> "" Then
				NewRecord("Repeat_Interval") = RepeatInterval
			End IF

			' Attempt to create a valid date string and then check to see
			' if the date is valid and if so then set in the Due_Date_Time Date field

   			' Fix to handle UK formatted of date


   			If DueMonth <> "" AND DueDay <> "" AND DueYear <> "" Then
   			    If DateDisplayFormat = "DDMMYYYY" Then ' UK format
   			        DueDateString = DueDay & "/" & DueMonth & "/" & DueYear
   			    Else
   				    DueDateString = DueMonth & "/" & DueDay & "/" & DueYear
   				End if
			End IF

			If DueHour <> "" AND DueMinute <> "" and DueAMPM <> "" Then
				DueTimeString = DueHour & ":" & DueMinute & DueAMPM
			End IF

			' Check for a valid date string and reset to blank if not valid

			'response.write " DueDateString=" & DueDateString

			IF IsDate(DueDateString) = False Then
				DueDateString = "" ' Do not accept DueDateString
			End If

			If DueDateString <> "" Then ' DueDateString should MM/DD/YYYY
				NewRecord("Due_Date") = DueDateString
			End IF

			'response.write "Due_time= " & DueTimeString
			If DueTimeString <> "" AND DueTimeString <> ":"  Then ' DueTimeString should be HH:MM AM formats
				NewRecord("Due_Time") = DueTimeString
			End If


			' * * * * * * End Schedule Case Fields processing


			' Now Add in any info about changed records for Tech, Status, group and Priority
			Old_Group_Number = NewRecord("Group_Number")
			If IsNull(Old_Group_Number) Then
				Old_Group_Number = ""
			Else
				Old_Group_Number = CStr(Old_Group_Number)
			End If
			If Old_Group_Number <> Group_Number_from_Form then
				NewGroupName = GroupFullName(Group_Number_From_Form)
				GroupChanged = "YES"
				New_Case_History = New_Case_History &  wc_CASE_ASSIGNED_TO_GROUP  & NewGroupName & vbCRLF
			End IF

			OldAsset_Number = NewRecord("Asset_Number")  '02/06/12

			' Fixed problem of every updating marking the asset number as changed

			If IsNumeric(Asset_Number) = True then

				If OldAsset_Number <> CInt(Asset_Number)  then
						New_Case_History = New_Case_History & wc_CASE_ASSET_NUMBER_SET_TO & asset_Number & vbCRLF
				End If

			End IF

			Old_Tech_ID = NewRecord("Tech_ID")
			If Old_Tech_ID <> Tech_ID then

				NewTechName = TechFullName(Tech_ID)
				TechChanged = "YES"

				New_Case_History = New_Case_History &  wc_CASE_ASSIGNED_TO_TECH & NewTechName & vbCRLF
			End IF

			Old_Status = "0"
			If Old_Status <> Status  then
				StatusChanged = "YES"
				If Status = "0" Then
					NewStatus = wc_Open_Active
				Elseif Status = "1" Then
					NewStatus = wc_Closed
				Elseif Status = "2" Then
					NEwStatus = wc_Open_Waiting
				Else
					NewStatus = wc_Open_On_Hold
				End IF

				New_Case_History = New_Case_History  & wc_CASE_STATUS_SET    & NewStatus & vbCRLF
			End IF

			Old_Priority = "0"

			If Old_Priority <> Case_Severity then
				NewPriority = PriorityFullDescription(Case_Severity)

				New_Case_History = New_Case_History & wc_CASE_Priority_SET_TO  & NewPriority & vbCRLF
			End IF


			If Dup_case_Num  = "" Then
				NewRecord("Dup_case_num") = 0
			Else
				NewRecord("Dup_case_num") = Dup_Case_Num
			End If


			If Status = "" Then
				NewRecord("Status") = 0 ' Reset status back to undefined
			Else
				NewRecord("Status") = Case_Status ' Reset status back to undefined
			End IF

			If Case_Severity = "" Then
				NewRecord("Severity") = 0 ' Set back to 0 (un-assigned)
			Else
				NewRecord("Severity") = Case_Severity
			End IF

			NewRecord("Case_One_Line") = Case_One_Line

			If External_Case_Number <> "" Then
				NewRecord("External_Case_Number") = External_Case_Number
			End If



			If Asset_Number = "" Then
				NewRecord("Asset_Number") = 0 ' Default to zero
			Else
				NewRecord("Asset_Number") = Asset_Number
			End If

			NewRecord("Category_Count") = 100 ' Default to 100

			' Add tech assignment

			If Tech_ID <> "" Then
				NewRecord("Tech_ID") = Tech_ID
			Else ' Set back to null if undefined
				NewRecord("Tech_ID") = Null
			End If

			' Read and set all of the Categories that have come in

			For i = 1 to 50 ' Increase this up to 100 if necessary

				CategoryColumn = "C" & i
				CategoryValue = Request.form(CategoryColumn)

				If CategoryValue = "" OR IsNumeric(CategoryValue) = False Then
					CategoryValue = 0

				Else ' Value must be set so check if this defines a default group
					Category_Number = i
					Category_Item = CategoryValue
					' Perform small query to see if initial group assignment is set
					' for this category

					mySQL5="SELECT * from Categories where Category_Number = " & Category_Number & " AND Item_number = " & Category_Item

					'Response.write "SQL=" & mySQL5

					set rstemp5=conn.execute(mySQL5)

					if rstemp5.EOF then
						' This should not happen but ok
					Else
						Group_Number = rstemp5("Group_Number")
						If Group_Number <> "" Then
							NewDefaultGroup = Group_Number
						End IF

					End IF

					rstemp5.close
					set rstemp5=nothing

				End If
				NewRecord(CategoryColumn) = CategoryValue
			Next

			'* * * * * * * * * * * * * * * * * * * * *
			' Default Group Setting ******************
			' * * * * * * * * * * * * * * * * * * * * *
			' The initial setting of the default group can now be set by
			' a selected category and selecting a category item.
			' This can all be configured under system administration options
			' If category group is not enabled or if no category
			' item is selected, it then reverts to the original defaultGroup
			' This assignment is only done during the initial case creation.
			' For the Techs, any group assignment done directly by the
			' tech overrides the category group selection.

			If NewDefaultGroup <> "" Then
				DefaultGroupNumber = NewDefaultGroup ' Over with category group
			End IF

			'If Group_Number = "" Then set to the default group otherwise set to the passed group
			IF Group_Number_From_Form = "" Then
				NewRecord("Group_Number") = DefaultGroupNumber ' Categories or default
			Else
				NewRecord("Group_Number") = Group_Number_From_Form ' Group re-assigned
			End IF

			'ADDITIONAL CUSTOMERS ' add note if removed 04/24/13

If Version8Point0 = "YES" Then
			Set Conn2 = Server.CreateObject("ADODB.Connection")
			conn2.open  myDSN

            'additions
				For each customer in Request.form("AdditionalCustomerCaseAssignments")

					Set rs = Server.CreateObject("ADODB.Recordset")
					SQL = "Select contact_fname, contact_lname from Customers where customer_ID = '" & customer & "'"
					rs.Open SQL,Conn2,3,3
					if not rs.eof  then
						New_Case_History = New_Case_History & rs("contact_fname") & " " & rs("contact_lname") & " added as an Additional Customer" & vbCRLF
					End If

					rs.Close
					set rs = Nothing
			next

			'subtractions
			For each ID in Request.form("RemoveFromCustomerCaseAssignment") ' 04/24/13
				Set rs = Server.CreateObject("ADODB.Recordset")
				SQL = "Select contact_fname, contact_lname from AdditionalCustomerCaseAssignments  "
				SQL = SQL & " INNER JOIN CUSTOMERS on AdditionalCustomerCaseAssignments.customer_ID = Customers.customer_ID where CustomerCaseAssignmentIndex = " & ID
				rs.Open SQL,Conn2,3,3
				if not rs.eof  then
					New_Case_History = New_Case_History & rs("contact_fname") & " " & rs("contact_lname") & " removed from Additional Customers" & vbCRLF
				End If

				rs.Close
				Set rs = Nothing
			next

			Conn2.Close
			Set conn2 = nothing


End If

			' Time Stamp the Case History before we put it into the case record

			Case_History = "{r[" &  DatetimeString &  wc_Opened_by & " ["& Tech_Full_Name & "] ]r}"  & vbCRLF & New_Case_History & vbCRLF & Case_History

			' We need to check the size of the case_history before we put it
			' into the record

			If Len(Case_History) < (MaxHistorySize - 10) Then ' Only update is size is ok.
				NewRecord("Case_History") = Case_History
			Else
				Response.Write wc_Case_History_size_of & Len(Case_History)&  wc_exceeds_maximum_value_of  & MaxHistorySize - 10 & "<br>"
			End If

			' Update Summary and Resolution Fields
			' Limit the size based on the max case resolution and summary sizes

			' Note DO NOT RESET the case_Summary or Case_Resolution from
			' their NULL state if case_resolution is empty

			If Case_Resolution <> "" Then
				NewRecord("Case_Resolution") = Mid(Case_Resolution, 1, MaxResolutionSize - 5)
			End IF

			If Case_Summary <> "" Then
				NewRecord("Case_Summary") = Mid(Case_Summary, 1, MaxSummarySize - 5)
			End If

			' Update any option case text fields here

			If Text_field_1 <> "" Then
				NewRecord("Text_field_1") = Text_field_1
			End If
			If Text_field_2 <> "" Then
				NewRecord("Text_field_2") = Text_field_2
			End If
			If Text_field_3 <> "" Then
				NewRecord("Text_field_3") = Text_field_3
			End If
			If Text_field_4 <> "" Then
				NewRecord("Text_field_4") = Text_field_4
			End If
			If Text_field_5 <> "" Then
				NewRecord("Text_field_5") = Text_field_5
			End If
			If Text_field_6 <> "" Then
				NewRecord("Text_field_6") = Text_field_6
			End If
			If Text_field_7 <> "" Then
				NewRecord("Text_field_7") = Text_field_7
			End If
			If Text_field_8 <> "" Then
				NewRecord("Text_field_8") = Text_field_8
			End If
			If Text_field_9 <> "" Then
				NewRecord("Text_field_9") = Text_field_9
			End If
			If Text_field_10 <> "" Then
				NewRecord("Text_field_10") = Text_field_10
			End If

	' New Fields for Additional Notifications

		If bAdditionalEmails = True or bAdditionalEmails = 1 Then ' Version 7.5 03/19/13

		' Primary email is pulled from configuration table during email sending

           AdditionalNotifications = Request.form("AdditionalNotifications")

  '         Response.write "Form Values = " & AdditionalNotifications
  '         response.flush
  '         response.end



           If  AdditionalNotifications = "" Then
                NewRecord("AdditionalNotifications") = False
		   Else
                NewRecord("AdditionalNotifications") = True
           End If


           AdditionalCCList = Request.form("AdditionalCCList")
           If AdditionalCCList <> "" Then
		        NewRecord("AdditionalCCList") = AdditionalCCList
		   Else
                NewRecord("AdditionalCCList") = 	Null ' Set to Null
           End If

		End IF






		Else ' Update Case Info when case already exists


			If Version7 = "YES" Then
				If AssetGroup <> "" Then
					NewRecord("AssetGroupIndex") = AssetGroup
				End If

				If AssetGroup = "" Then
					NewRecord("AssetGroupIndex") = NULL
				End If


			End IF


	If Version8Point0 = "YES" Then

		NewRecord("Escalated") = FALSE ' Set escalated bit to false if updated
	End If





	' New Fields for Additional Notifications

		If bAdditionalEmails = True or bAdditionalEmails = 1  Then ' Version 7.5 ' 03/19/13

		' Primary email is pulled from configuration table during email sending

           AdditionalNotifications = Request.form("AdditionalNotifications")



'          Response.write "Form Values = " & AdditionalNotifications
'           response.flush
'           response.end


           If  AdditionalNotifications = "" Then
                NewRecord("AdditionalNotifications") = False ' sets to 0 in sqlserver
		   Else
                NewRecord("AdditionalNotifications") = True
           End If


           AdditionalCCList = Request.form("AdditionalCCList")
           If AdditionalCCList <> "" Then
		        NewRecord("AdditionalCCList") = AdditionalCCList
		   Else
                NewRecord("AdditionalCCList") = 	Null ' Set to Null
           End If

		End IF



			NewRecord("modified_flag") = 1


			' New Change 5/18/2009 -
			' Could be commented out - this will prevent Mod_Date and Mod_time
			' from being updated if the case is closed.  to reset the
			' mod date and time, simple re-open the case update and then re-close.


		'	If Status <> "1"   Then  ' If case is closed, DO NOt update mod_date mod_time

			If NewRecord("Status") <> 1 Then

				NewRecord("mod_date") = DateString ' YYYYMMSS
				NewRecord("mod_time") = TimeString ' HHMMSS
			End If


			' Set these fields only on TECH updates
			NewRecord("Reopen_Date") = Datestring
			NewRecord("reopen_Time") = TimeString

			NewRecord("Case_One_Line") = Case_One_Line


			' Update any option case text fields here

			If Text_field_1 <> "" Then
				NewRecord("Text_field_1") = Text_field_1
			End If
			If Text_Field_1 = "" AND NewRecord("Text_Field_1") <> "" Then
				NewRecord("Text_Field_1") = NULL ' Null out field if needed
			End IF


			If Text_field_2 <> "" Then
				NewRecord("Text_field_2") = Text_field_2
			End If
			If Text_Field_2 = "" AND NewRecord("Text_Field_2") <> "" Then
				NewRecord("Text_Field_2") = NULL ' Null out field if needed
			End IF

			If Text_field_3 <> "" Then
				NewRecord("Text_field_3") = Text_field_3
			End If
			If Text_Field_3 = "" AND NewRecord("Text_Field_3") <> "" Then
				NewRecord("Text_Field_3") = NULL ' Null out field if needed
			End IF

			If Text_field_4 <> "" Then
				NewRecord("Text_field_4") = Text_field_4
			End If
			If Text_Field_4 = "" AND NewRecord("Text_Field_4") <> "" Then
				NewRecord("Text_Field_4") = NULL ' Null out field if needed
			End IF

			If Text_field_5 <> "" Then
				NewRecord("Text_field_5") = Text_field_5
			End If
			If Text_Field_5 = "" AND NewRecord("Text_Field_5") <> "" Then
				NewRecord("Text_Field_5") = NULL ' Null out field if needed
			End IF

			If Text_field_6 <> "" Then
				NewRecord("Text_field_6") = Text_field_6
			End If
			If Text_Field_6 = "" AND NewRecord("Text_Field_6") <> "" Then
				NewRecord("Text_Field_6") = NULL ' Null out field if needed
			End IF


			If Text_field_7 <> "" Then
				NewRecord("Text_field_7") = Text_field_7
			End If
			If Text_Field_7 = "" AND NewRecord("Text_Field_7") <> "" Then
				NewRecord("Text_Field_7") = NULL ' Null out field if needed
			End IF

			If Text_field_8 <> "" Then
				NewRecord("Text_field_8") = Text_field_8
			End If
			If Text_Field_8 = "" AND NewRecord("Text_Field_8") <> "" Then
				NewRecord("Text_Field_8") = NULL ' Null out field if needed
			End IF

			If Text_field_9 <> "" Then
				NewRecord("Text_field_9") = Text_field_9
			End If
			If Text_Field_9 = "" AND NewRecord("Text_Field_9") <> "" Then
				NewRecord("Text_Field_9") = NULL ' Null out field if needed
			End IF

			If Text_field_10 <> "" Then
				NewRecord("Text_field_10") = Text_field_10
			End If
			If Text_Field_10 = "" AND NewRecord("Text_Field_10") <> "" Then
				NewRecord("Text_Field_10") = NULL ' Null out field if needed
			End IF



			' * * * * * * Schedule Case Fields Processing


			If NewRecord("External_Case_Number") <> "" and External_case_number = "" Then
				NewRecord("External_Case_Number") = Null
			End If

			If External_case_number <> "" Then
				NewRecord("External_Case_Number") = External_case_Number
			End If


			If NewRecord("Scheduled_Case_Type") <> "" And ScheduleCase = "" Then
				NewRecord("Scheduled_Case_Type") = Null
			End If

			If ScheduleCase <> "" Then
				NewRecord("Scheduled_Case_Type") = ScheduleCase
			End IF

			If RepeatInterval <> "" Then
				NewRecord("Repeat_Interval") = RepeatInterval
			End IF

			' Attempt to create a valid date string and then check to see
			' if the date is valid and if so then set in the Due_Date_Time Date field

   			' Fix to handle UK formatted of date


   			If DueMonth <> "" AND DueDay <> "" AND DueYear <> "" Then
   			    If DateDisplayFormat = "DDMMYYYY" Then ' UK format
   			        DueDateString = DueDay & "/" & DueMonth & "/" & DueYear
   			    Else
   				    DueDateString = DueMonth & "/" & DueDay & "/" & DueYear
   				End if
			End IF

			If DueHour <> "" AND DueMinute <> "" AND DueAMPM <> "" Then
				DueTimeString = DueHour & ":" & DueMinute & DueAMPM
			End IF

			' Check for a valid date string and reset to blank if not valid

			IF IsDate(DueDateString) = False Then
				DueDateString = "" ' Do not accept DueDateString
			End If

			' First Grab the Current Due Date and Due Time from the database


			Old_Due_Date = NewRecord("Due_Date")
			Old_Due_Time = NewRecord("Due_Time")

			' It is possible that the due date may want to be nulled out
			' so this section handles nulls out the date and time strings

			If NewRecord("Due_Date") <> "" and DueDateString = "" Then
				NewRecord("Due_Date") = NULL ' Reset back to Null
			End If

			If DueDateString <> "" Then ' DueDateString should MM/DD/YYYY
				NewRecord("Due_Date") = DueDateString
			End IF

			'response.write "Due_time= " & DueTimeString

			If NewRecord("Due_Time") <> "" AND DueTimeString = "" Then
				NewRecord("Due_Time") = NULL
			End If

			If DueTimeString <> "" Then ' DueTimeString should be HH:MM AM formats
				NewRecord("Due_Time") = DueTimeString
			End If


			' **** Logging any Due Date Changes

			' Determine if the a new Due_Date is being set and if so, then
			' document this in the history area


			' Debug
			'response.write "Comparing " & Old_due_date  &  DueDateString
			'response.write "Comparing " & Old_due_time  &  DuetimeString

			If NewRecord("Due_Date") <> Old_Due_Date Or NewRecord("Due_Time") <> Old_Due_Time Then
				Due_Date_Change_History = "CASE SCHEDULED DUE DATE/DUE TIME CHANGED TO: "  & DueDateString & "--" & DueTimeString & vbCRLF
			End IF




		' Special Code to set the schedule date to 2 days beyond the current
		' date if the schedule date is not set.

		' Special user customization - Set schedulecase to automatic set
		' a scheduled completion date/time if not set.

		'EnableAutoScheduledDate = "YES"

		If ScheduleCase = "" AND EnableAutoScheduledDate = "YES" THen

			SetScheduleDayInterval = 2 ' Set this to desired number of days

			NewDateTime = DateAdd("d", SetScheduleDayInterval, Now())

			'response.write " NewDateTime = " & NewDateTime


			DueTimeString = Hour(NewDateTime) & ":" & Minute(NEwDateTime) & right(CStr(NewDateTime), 2)

				NewRecord("Due_Time") = DueTimeString

   			    If DateDisplayFormat = "DDMMYYYY" Then ' UK format
   			        DueDateString = Day(NewDateTime) & "/" & Month(NewDateTime) & "/" & Year(NewDateTime)
   			    Else
   				    DueDateString = Month(NewDateTime) & "/" & Day(NewDateTime) & "/" & Year(NewDateTime)
   				End if

				NewRecord("Due_Date") = DueDateString

				NewRecord("Scheduled_Case_Type") = "ONCE"


		End If





			' * * * * * * End Schedule Case Fields processing



		'	If Asset_Number <> "" then  ' DONE LATER
			'	NewRecord("Asset_Number") = Asset_Number
			'End If
			Current_Case_History = NewRecord("Case_History")

			' Make sure we are not exceeding the size of the case_history field.

			' Append to the bottom of the case

			If Case_History = "" and Old_Status = Status and Old_Priority = Case_Severity then
			New_Case_History = ""
			else
			New_Case_History = vbCRLF & "{r[" &  DatetimeString &  wc_Updated_by & " ["& Tech_Full_Name & "] ]r}"  &  vbCRLF
		'	New_Case_History = Current_Case_History &	vbCRLF & "{r[" &  DatetimeString &  wc_Updated_by & " ["& Tech_Full_Name & "] ]r}"  &  vbCRLF
			End If


			' Now Add in any info about changed records for Tech, Status, group and Priority
			Old_Group_Number = CStr(NewRecord("Group_Number"))

			If Old_Group_Number <> Group_Number_From_Form then
				NewGroupName = GroupFullName(Group_Number_From_Form)
				GroupChanged = "YES"
				New_Case_History = New_Case_History &  wc_CASE_ASSIGNED_TO_GROUP  & NewGroupName & vbCRLF
			End IF

			OldAsset_Number = NewRecord("Asset_Number")  '02/06/12

			'Fixed problem of asset number message - 02/20/13 SAV

			If IsNumeric(Asset_Number) = True Then

				If OldAsset_Number <> Cint(Asset_Number) then
						New_Case_History = New_Case_History & wc_CASE_ASSET_NUMBER_SET_TO & asset_Number & vbCRLF
				End If
			End If


			Old_Tech_ID = NewRecord("Tech_ID")
			If IsNull(Old_Tech_ID) = True Then ' Handle Special condition of un-assigned
				If Tech_ID <> "" then
					TechChanged = "YES"

					NewTechName = TechFullName(Tech_ID)

					New_Case_History = New_Case_History &  wc_CASE_ASSIGNED_TO_TECH & NewTechName & vbCRLF
				End IF
			ElseIf Old_Tech_ID <> Tech_ID then
				TechChanged = "YES"

				NewTechName = TechFullName(Tech_ID)

				New_Case_History = New_Case_History &  wc_CASE_ASSIGNED_TO_TECH & NewTechName & vbCRLF
			End IF



			Old_Status = CStr(NewRecord("Status"))
			If Old_Status <> Status  then
				StatusChanged = "YES"
				If Status = "0" Then
					NewStatus = wc_Open_Active
				Elseif Status = "1" Then
					NewStatus = wc_Closed
				Elseif Status = "2" Then
					NEwStatus = wc_Open_Waiting
				Else
					NewStatus = wc_Open_On_Hold
				End IF

				New_Case_History = New_Case_History  & wc_CASE_STATUS_CHANGED_TO   & NewStatus & vbCRLF
			End IF


		' New code (9/16/2009) that displays the number of days/hours it took to close this case
		' to remove this feature, comment out this first line below
		SHOW_OPEN_DURATION = "YES"
		If SHOW_OPEN_DURATION = "YES" Then

			If StatusChanged = "YES" And Status = "1" Then '

			' Pull out Start time and end time

			open_date = NewRecord("Open_date")
			Open_time = NewRecord("Open_Time")

			Mod_Date = DateString
			Mod_Time = TimeString

			'Mod_date = rstemp("mod_date")
			'Mod_Time = rstemp("mod_time")

			HoursToClose = ComputeHourDifference(open_time, open_date, mod_Time, mod_date)

			Days_Opened = Int(HoursToClose/24)

			Hours_Open = Int(HoursToClose - Days_Opened*24)

			Open_Duration_String = "Days:" & Cstr(Days_Opened) & " Hours:" & Hours_Open


				New_Case_History = New_Case_History  & "CASE DURATION: " & Open_Duration_String  & vbCRLF

			End IF
		End IF


			Old_Priority = CStr(NewRecord("Severity"))
			If Old_Priority <> Case_Severity then
				NewPriority = PriorityFullDescription(Case_Severity)

				New_Case_History = New_Case_History & wc_CASE_Priority_CHANGED_TO   & NewPriority & vbCRLF
			End IF



			IF Due_Date_Change_History <> "" Then
				New_Case_History = New_Case_History &  Due_Date_Change_History
			End If


		' *******CATEGORY UPDATES******
		' Update any category changes and note any changes in the case history field

			For i = 1 to 50 ' Only reset values passed on update

				CategoryColumn = "C" & i
				CategoryValue = CInt(Request.form(CategoryColumn))
				If CategoryValue <> "" Then

				' Record any category changes in the case history


					PreviousCategoryValue = NewRecord(CategoryColumn)

					'debug
					'response.write "PreviousCategoryValue = " & PreviousCategoryValue
					'Response.write "CategoryValue = " & CategoryValue & "<br>"
					'response.flush
					'response.end


					If CategoryValue <> PreviousCategoryValue Then

					PreviousCategoryString = GetCategoryNameAndItem(i, PreviousCategoryValue)

					NewCategoryString = GetCategoryNameAndItem(i, CategoryValue)

						If PreviousCategoryString = "" Then

							New_Case_History = New_Case_History  & "CATEGORY CHANGED TO " &  NewCategoryString & vbCRLF
						Else
							New_Case_History = New_Case_History  & "CATEGORY CHANGED FROM " & PreviousCategoryString & " TO " &  NewCategoryString & vbCRLF
						End IF


					End IF


					NewRecord(CategoryColumn) = CInt(CategoryValue)
				End If
			Next

	'ADDITIONAL CUSTOMERS ' add note if removed 04/24/13

If Version8Point0 = "YES" Then
			Set Conn2 = Server.CreateObject("ADODB.Connection")
			conn2.open  myDSN

            'additions
				For each customer in Request.form("AdditionalCustomerCaseAssignments")

					Set rs = Server.CreateObject("ADODB.Recordset")
					SQL = "Select contact_fname, contact_lname from Customers where customer_ID = '" & customer & "'"
					rs.Open SQL,Conn2,3,3
					if not rs.eof  then
						New_Case_History = New_Case_History & rs("contact_fname") & " " & rs("contact_lname") & " added as an Additional Customer" & vbCRLF
					End If

					rs.Close
					set rs = Nothing
			next

			'subtractions
			For each ID in Request.form("RemoveFromCustomerCaseAssignment") ' 04/24/13
				Set rs = Server.CreateObject("ADODB.Recordset")
				SQL = "Select contact_fname, contact_lname from AdditionalCustomerCaseAssignments  "
				SQL = SQL & " INNER JOIN CUSTOMERS on AdditionalCustomerCaseAssignments.customer_ID = Customers.customer_ID where CustomerCaseAssignmentIndex = " & ID
				rs.Open SQL,Conn2,3,3
				if not rs.eof  then
					New_Case_History = New_Case_History & rs("contact_fname") & " " & rs("contact_lname") & " removed from Additional Customers" & vbCRLF
				End If

				rs.Close
				Set rs = Nothing
			next

			Conn2.Close
			Set conn2 = nothing


End If

	If Case_History = "" and Old_Status = Status and Old_Priority = Case_Severity Then
	   		New_Case_History = ""
			else
			New_Case_History = New_Case_History  & Case_History & vbCRLF
			End If

			' Now Add in the Current_Case_History to the string so that we can

			' New Case History String = New_Case_History so save this for customer emails
			New_Case_History_Without_OLD = New_Case_History

			New_Case_History = Current_Case_History  & New_Case_History


			If Len(New_Case_History) < (MaxHistorySize - 10) Then ' Only update is size is ok.
				NewRecord("Case_History") = New_Case_History
			Else
				Response.Write wc_Case_History_size_of  & Len(New_Case_History) & wc_exceeds_maximum_value_of  & MaxHistorySize - 10 & "<br>"
			End If


			' Update Summary and Resolution Fields
			' Limit the size based on the max case resolution and summary sizes

			' Only update these fields if the case_resolution or
			' case_summary is not empty.  DO NOT RESET these
			' from their null values

			If Case_Resolution <> "" Then
				NewRecord("Case_Resolution") = Mid(Case_Resolution, 1, MaxResolutionSize - 5)
			End If

			IF Case_Summary <> "" Then
				NewRecord("Case_Summary") = Mid(Case_Summary, 1, MaxSummarySize - 5)
			End IF


		' Update any category changes
		' old code not used

'			For i = 1 to 50 ' Only reset values passed on update
'
'				CategoryColumn = "C" & i
'				CategoryValue = CInt(Request.form(CategoryColumn))
'				If CategoryValue <> "" Then
'					NewRecord(CategoryColumn) = CInt(CategoryValue)
'				End If
'			Next

			' Update any Group, tech, status or severity assignements

			'If Group_Number = "" Then set to the default group otherwise set to the passed group
			IF Group_Number_From_Form = "" Then
				NewRecord("Group_Number") = CInt(DefaultGroupNumber)
			Else
				NewRecord("Group_Number") = CInt(Group_Number_From_Form)
			End IF


			' Add tech assignment - it might be reset back to un-assigned so we must set
			' this field back to null for assigned


			If Tech_ID <> "" Then
				NewRecord("Tech_ID") = Tech_ID
			Else
				NewRecord("Tech_ID") = Null
			End IF

			If Dup_case_Num  = "" Then
				NewRecord("Dup_case_num") = CInt(0)
			Else
				NewRecord("Dup_case_num") = CLng(Dup_Case_Num)
			End If


			If Status = "" Then
				NewRecord("Status") = CInt(0) ' Reset status back to undefined
			Else
				NewRecord("Status") = CInt(Case_Status) ' Reset status back to undefined
			End IF

			If Case_Severity = "" Then
				NewRecord("Severity") = 0
			Else
				NewRecord("Severity") = CInt(Case_Severity)
			End IF

			NewRecord("Case_One_Line") = Case_One_Line

			If Asset_Number = "" Then
				NewRecord("Asset_Number") = 0 ' Default to zero CMB
			Else
				NewRecord("Asset_Number") = CInt(Asset_Number)
			End If


		End If ' End if Add Record or Update

		NewRecord.Update

	If  err.number>0 then
	      response.write "VBScript Errors Occured:" & "<P>"
	      response.write "Error Number=" & err.number & "<P>"
	      response.write "Error Descr.=" & err.description & "<P>"
	      response.write "Help Context=" & err.helpcontext & "<P>"
	      response.write "Help Path=" & err.helppath & "<P>"
	      response.write "Native Error=" & err.nativeerror & "<P>"
	      response.write "Source=" & err.source & "<P>"
	      response.write "SQLState=" & err.sqlstate & "<P>"
	else
	'      response.write "No VBScript Errors Occured" & "<P>"
	end if


	IF  conn.errors.count> 0 then
	    response.write "Database Errors Occured" & "<P>"
		for counter= 0 to conn.errors.count
		      response.write "Error #" & conn.errors(counter).number & "<P>"
		      response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
		next
	else
	      'response.write "No Database Errors Occured!" & "<P>"
	end if

	NewRecord.Close
	Set NewRecord = Nothing

	Conn.Close
	Set Conn = Nothing


	' If this was a new case, we need to get the case_number for future reference

	If Case_Number = "0" Then
	' Get the case number of the case just submitted

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		mySQL2="SELECT * from Cases where Customer_ID = '" & Customer_ID & "' AND Open_date = '" & DateString & "' AND Open_Time = '" & TimeString & "'"

		' Response.write "SQL=" & mySQL2

		set rstemp2=conntemp.execute(mySQL2)

		if rstemp2.EOF then
			Case_number = "Case Not Found - Contact ISS Support "
		Else
			case_number = rstemp2("case_number")
		End IF

		rstemp2.close
		set rstemp2=nothing

		conntemp.close ' Close the connection
		set conntemp=nothing


	End If '  End of if Case_number = 0


	' Process TimeSpentBilling If Enabled and form elements completed

	TimeSpentNotes = Request.form("TimeSpentNotes")

	If TimeSpentNotes <> "" Then

		TimeSpentTech_ID = Request.form("TimeSpentTech_ID")
		TimeSpentInspectorID  = Request.form("InspectorID")
		TimeSpentHours = Request.form("TimeSpentHours")
		TimeSpentDate = Request.form("TimeSpentDate")

		' New Fields broken up by day, month and year for UK compatibility

		TimeSpentDateDay = Request.form("TimeSpentDateDay")
		TimeSpentDateMonth = Request.form("TimeSpentDateMonth")
		TimeSpentDateYear = Request.form("TimeSpentDateYear")

		TimeSpentBillable = Request.form("TimeSpentBillable")
		TimeSpentHourlyRate = Request.form("TimeSpentHourlyRate")
		'If Trim(TimeSpentHourlyRate) > "" then
			'TimeSpentHourlyRate = CDBL(TimeSpentHourlyRate)  ' cmb 10/10/2011 $ causes it to fail although passes IsNumeric
		'End If

		QBItemIndex = Request.form("QBItemIndex")


	If QBOption = "YES" and QBItemIndex <> "" Then

	' Get the QB Item name  and billing rate and place it into the extended time spent fields

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		mySQL2="SELECT * from QBItem where QBItemIndex = " & QBItemIndex

		' Response.write "SQL=" & mySQL2

		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			TimeSpentNotes = "QB Note not found"
			TimeSpentHourlyRate = "QB Hourly Rate not found"
		Else
			TimeSpentNotes =  rstemp2("QBItemName")
			TimeSpentHourlyRate = rstemp2("QBItemPrice")
		End IF

		rstemp2.close
		set rstemp2=nothing

		conntemp.close ' Close the connection
		set conntemp=nothing


	End If '  End of if QBOption = YES

		ProcessTimeSpentEntry case_number, TimeSpentTech_ID, TimeSpentDate, TimeSpentDateDay, TimeSpentDateMonth, TimeSpentDateYear, TimeSpentBillable,  TimeSpentHours, TimeSpentHourlyRate, TimeSpentNotes, TimeSpentInspectorID

	End If

 If bExpenses = True Then
'**************** Process Expense Items Start***********************
	'Get Form Elements First

	ExpenseDateDay = Request.form("ExpenseDateDay")
	ExpenseDateMonth = Request.form("ExpenseDateMonth")
	ExpenseDateYear = Request.form("ExpenseDateYear")

	ExpenseTech_ID = Request.form("ExpenseTech_ID")
	Quantity = Request.form("Quantity")
	Description = Request.form("Description")
	Cost = Request.form("Cost")
	If Trim(Cost) > "" then
		Cost = CDBL(Cost) ' ' 10/10/2011 If has $ sign, passes numeric but fails sqlserver insert
	End If
	TaxRatePercent = Request.form("TaxRatePercent")

	If Quantity <> "" AND Cost <> "" and isNumeric(quantity) and isNumeric(Cost) Then  ' Only add expense record if quantity and cost is filled in
		ProcessExpenseEntry case_number,ExpenseTech_ID, ExpenseDateDay, ExpenseDateMonth, ExpenseDateYear, Quantity,  Description, Cost, TaxRatePercent
	End If


'**************** Process Expense Items End ***********************
End If


'******* START AdditionalCustomerCaseAssignments Code and other - Verison 8.0 code

If Version8Point0 = "YES" Then

	' AdditionalCustomerCaseAssignments - Pull list of additional assigned customers to this case from the Form element

	' The table AdditionalCustomerCaseAssignment contains customer_ID and case_number



		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN



		' Now add all the selected project members incase they added some and
		' deleted others.

			Set Conn2 = Server.CreateObject("ADODB.Connection")
			conn2.open  myDSN


			For each customer in Request.form("AdditionalCustomerCaseAssignments")



					Set NewRecord = Server.CreateObject("ADODB.Recordset")
					SQL = "Select * from AdditionalCustomerCaseAssignments where customer_ID = '" & customer & "' And case_number = " & case_number
					NewRecord.Open SQL,Conn2,3,3
					if  NewRecord.eof then
						NewRecord.AddNew

						NewRecord ("Case_number") = Case_number
						NewRecord ("customer_ID") = customer
						NewRecord.Update
					End If

					NewRecord.Close
					Set NewRecord = Nothing
			next
			Conn2.Close

'/************************** this part was moved up so people being deleted get emails
Additional_Customer_Case_Assignment_List = wc_None

if  bAdditionalCustomerCaseAssignments = True Then
	 '***** User Customization Here ********************
		' Some users have request that email should be sent to Customers whenever a case
		' is closed even if the tech forgets to set the Send Email Radio Button.
		' If you wish to have this behavior, then uncomment the first IF statement below
		' and comment the second IF statement with a preceding single quote.

	' First Choice Below - Automatically Send Emails to Customers when first closed
	'If (Old_Status <> "1" and Status = "1")  OR SendEmailValue = "YES" Then ' First time it is closed force sending message

	' Second Choice below - Let Techs always choose if emails are to be sent
	' SBCC If SendEmailValue = "YES" Then  ' 05/24/13 always send even if send off
		If Customer_Case_Notify = 1 Then
				SendEmailToAdditionalCustomerCaseAssignment(Case_Number)
			'	response.write "SENDING"
		End If
	' SBCCEnd IF

End IF
'*********************** end fo part that was moved up

' Now delete any that have marked to be removed

		' Now add all the selected project members incase they added some and
		' deleted others.

			Set Conn2 = Server.CreateObject("ADODB.Connection")
			conn2.open  myDSN


			For each ID in Request.form("RemoveFromCustomerCaseAssignment") ' 04/24/13

					Set NewRecord = Server.CreateObject("ADODB.Recordset")
					SQL = "Select * from AdditionalCustomerCaseAssignments where CustomerCaseAssignmentIndex = " & ID
					NewRecord.Open SQL,Conn2,3,3
					if  NewRecord.eof  <> True then
						NewRecord.Delete
					End If

					NewRecord.Close
					Set NewRecord = Nothing
			next
			Conn2.Close




End IF ' End of If Version8Point0 = "YES

'******* END AdditionalCustomerCaseAssignments Code and other - Verison 8.0 code








	' First get the CategoryText so it can be sent out
	' with the Emails going to the techs and to the Groups.

	CategoryText = CreateCategoryText(Case_Number)
	' Debugging

	'Response.write " Category Text = " & CategoryText & "<P>"


	' Now send out 5 sets of emails including:
	' 	(1) Email to customer with case confirmation
	'	(2) Emails to any techs assigned to the default group
	' 	(3) Emails to any tech assigned to the that case
	'	(4) Additonal Notification Emails to primary Additional Notification Email
	'	and CC list -New for Version 7
	'   (5) Additional Customer-Case Assignments - Send notification emails to customers who are also assigned to this case


'************* Additional Notifications Email Code *************

		If bAdditionalEmails = True or bAdditionalEmails = 1 Then ' Version7.5 03/19/13

'			If AdditionalNotifications <> "" Then ' Additonal notifications is enabled so send out emails


				SendAdditionalNotificationEmail(Case_Number)
'			End If

		End If  ' End of If Additional Notifications

' ADDITIONAL CUSTOMER CASE NOTIFICATIONS EMAIL CODE USED TO BE HERE
'*************** Additional Customer-Case Notifications Email Code *****************


	' Only send Emails to Customers if the Send Customer Email flag is set to true

	Customer_Notification = wc_None
	Survey_Notification = wc_None

	 '***** User Customization Here ********************
		' Some users have request that email should be sent to Customers whenever a case
		' is closed even if the tech forgets to set the Send Email Radio Button.
		' If you wish to have this behavior, then uncomment the first IF statement below
		' and comment the second IF statement with a preceding single quote.

	' First Choice Below - Automatically Send Emails to Customers when first closed
	'If (Old_Status <> "1" and Status = "1")  OR SendEmailValue = "YES" Then ' First time it is closed force sending message

	' Second Choice below - Let Techs always choose if emails are to be sent
	If SendEmailValue = "YES" Then

		If Customer_Case_Notify = 1 Then
			SendEmailToCustomer(Case_Number) ' Email confirmation to customer
		End If
	End IF


	' *************** Send customer survey emails *******************
	' Surveys are NOT Sent from here anymore - Uncomment this old code if needed.

'	'Customersurvey = True ' Obtain from database value
'
'
	If ForceSurvey = true and (Old_Status <> "1" and Status = "1")  AND Customersurvey = True Then ' ONLY First time it is closed force sending message 11/22/13
		SendSurveyEmailToCustomer(Case_Number) ' Email survey email (link) to customer
	End IF



	' Send Email to Assigned Tech
		Tech_Notification = "None"
		SendEmailToAssignedTech Case_Number , Tech_Assigned_Email

	' Now send emails to persons assigned to this group
	Group_Notification = wc_None

	' * * * * * * * * * * * * *User Customizations * * * * * * * * * *
	' There are numerous options deciding when an email should be sent to
	' a group.  Listed below are come IF statement that can be
	' configured when emails are sent to group members.  The flags
	' GroupChanged, Status Changed, TechChanged will be set to the
	' value of "YES" if any of these conditions has changed or been
	' orginally set.  Using this flag, one can program how and when
	' they want emails set to Groups.

	' Approach 1: Always send group emails.


	SendEmailToAssignedGroupTechs Case_Number , Tech_Assigned_Email

	' Approach 2: - Comment line above and un-comment line below for this option
		'Email are send when:
			'Group changes (emails sent to new group only)
			' Case Status changes

	 ' If StatusChanged = "YES" OR GroupChanged = "YES" Then
			'SendEmailToAssignedGroupTechs Case_Number , Tech_Assigned_Email
	 'End If


	' New option to send emails to techs assign to the customer
	' To enable, uncomment the lines of codes below

	' SendEmailToCustomerAssignedTechFlag = "NO"
	'SendEmailToCustomerAssignedTechFlag = "YES"
	SendEmailWhenPriorityLowLevel = 2

	If SendEmailToCustomerAssignedTechFlag = "YES" AND (Cint(Case_Severity) <= SendEmailWhenPriorityLowLevel AND Cint(Case_Severity) <> 0) then
		SendEmailToCustomerAssignedTechs Case_Number , Tech_Assigned_Email
	End If




	'  * * * * Repeat Scheduled Cases Code
	' Last Item - Check if this is repeat Scheduled case and generate a new case
	' if they are closing a scheduled case

	If ScheduleCase = "REPEAT" AND Status = "1" Then
		CreateRepeatScheduledCase(Case_Number)
	End IF


%>

<% ' Display the page now %>

<html><head>
<Title><%=wc_Case_Confirmation%></title>
<!-- C. 1996, 1997, 1998, 1999, 2000, 2001, 2002 Internet Software Sciences -->
<!-- #INCLUDE FILE="Stylesheet.inc" -->
</head>

<body class=rightwindow>
<center>
<Table class=BGWrapper >
<tr>
<td width=50% align=center valign=center class=majorscreentitlefixed>

<%=wc_Case%> <font color=red><B><%=Case_Number%></b></font>
<%=wc_successfully_created_or_updated%>


</td>
</tr>
</table>


<p>
<table border=1 cellspacing=2 cellpadding=10 width=98%>
<tr><td>
<B><%=wc_Email_Notification_Report%>:</b><P>
<UL>
<LI><B><%=wc_Customer%>:</b>  <%=Customer_Notification%>

<% If bAdditionalCustomerCaseAssignments = True Then %>

<LI><B><%=wc_Additional_Customer_Case_Assignments%>:</b> <%=Additional_Customer_Case_Assignment_List%>

<% End If %>


<% ' Customer Surveys notification has been given as a separate step %>
<% if surveySent > "" Then %>
<LI><B>Customer Surveys sent:</b><%=SurveySent%>
<% end if %>

<LI><B><%=wc_Assigned_Tech%>:</b>  <%=Tech_Notification%>
<LI><B><%=wc_Assigned_Group_Members%>:</b>  <%=Group_Notification%>


<%If bAdditionalEmails = True or bAdditionalEmails = 1 Then ' Version 7.5 03/19/13
	If Request.form("AdditionalNotifications") <> "" Then
		 Additional_Notification_List = "Primary: "& PrimaryAdditionalNotificationEmail
	Else
		 Additional_Notification_List = "Primary: (None - Disabled)"
	End If

	Additional_Notification_List = Additional_Notification_List & " Other Recipients: " & AdditionalCCList
%>

<LI><B><%=wc_Additional_Notifications%>:</b>  <%=Additional_Notification_List%>

<% End If %>

</ul>

</font>
<P>

</td>
</tr>
</table>

<%
   ' Now see if we wish to give user the option to send an individual survey to this customer

 	If (Old_Status <> "1" and Status = "1")  AND Customersurvey = True then
 		if forcesurvey = true Then ' 11/21/13 already sent
 	    %>

 				 <%If AllKBUpdate = "YES" Then %>
 					<p>
 						<center>
 						<a href=UpdateOneKB.asp?casenumber=<%=Case_Number%>>
 						<img src=/<%=WCLanguageDirectory%>/ts_continue30x100.gif border=0></a>  <!-- 12/9/13 changed from updatekb -->
 						</center>
 				 <%Else ' AllKBUpdate = no  give them a choice %>
 						<% IF SBCC <> "YES" Then %>
 							<center>
 							<a href=UpdateOneKB.asp?casenumber=<%=Case_Number%>>
 							<img src=/<%=WCLanguageDirectory%>/ts_updatekb.gif border=0></a>
 							</center>
                   <% end if %>

 						<center>
 						<p><a href=TCaseForm.asp?customer_id=0&case_number=<%=Case_Number%>>
 						<img src=/<%=WCLanguageDirectory%>/ts_continue30x100.gif border=0></a>
 						</center>

 				 <% end if ' allkbupdate = true or false%>
       <% else '(force survey = false) give them option like before %>

 	    <table border=1 cellspacing=2 cellpadding=10 width=98%>

 	    <tr>
 	    <td colspan=2 align=center bgcolor=D0D0D0>
 	<B>    Please select one of the two choices below </b>
 	    </td>
 	    </tr>

          <tr>
 	    <form METHOD=POST ACTION=DoSingleSurvey.asp>

 				<td valign=middle>
 				 <%=wc_do_you_wish_to_survey%>
 				</td>
 			   <td valign=middle align=center>
 				<input type=hidden name=customer_id value="<%=Customer_ID%>">
 				<input type=hidden name=case_number value="<%=Case_number%>">

 				<% If ALLKBUpdate = "YES" Then %>
 					<input type=hidden name=AllKBUpdate value="YES">
 				<%Else %>
 					<input type=hidden name=AllKBUpdate value="NO">
 				<% End If %>

 				<input type=image name=sendsurvey src=/<%=WCLanguageDirectory%>/ts_send_survey30x100.gif border=0/>
 			   </td>
 			   </FORM>
 		  </tr>

 		<tr>
 			<td valign=middle>
 			 <%=wc_do_you_wish_to_Continue%>
 			</td>
 			<td valign=middle align=center>

 			<%If AllKBUpdate = "YES" Then %>
 				<p>
 					<a href=UpdateOneKB.asp?casenumber=<%=Case_Number%>>
 					<input type=image name=sendsurvey src=/<%=WCLanguageDirectory%>/ts_continue30x100.gif border=0/></a>
 			<%Else ' AllKBUpdate <> YES  so make continue link adding it to KB %>
 					<p><a href=TCaseForm.asp?customer_id=0&case_number=<%=Case_Number%>>
 					<img src=/<%=WCLanguageDirectory%>/ts_continue30x100.gif border=0></a>
 			<%End If %>
 	   </td>
 		  </tr>
 		 </table>
 		 </form>

      <% end if ' survey not forced %>

	<%	else ' Survey not enabled or not first closed %>
		<%If AllKBUpdate = "YES" Then ' update button which updates kb%>
			<p>
			<center>
			<a href=UpdateOneKB.asp?casenumber=<%=Case_Number%>>
			<img src=/<%=WCLanguageDirectory%>/ts_continue30x100.gif border=0></a>  <!-- changed from updatekb.gif 12/9/13 -->
			</center>
		<%Else ' AllKBUpdate = no ' continue just goes to form %>
			<center>
			<p><a href=TCaseForm.asp?customer_id=0&case_number=<%=Case_Number%>>
			<img src=/<%=WCLanguageDirectory%>/ts_continue30x100.gif border=0></a>
			</center>
		<%End If %>
<%
	End IF
%>

</body>
</html>

<% End if ' End of IF ErrorMessage <> ""%>

<% Sub CreateTimeDateValues( DateString, TimeString, DateTimeString)
'	This Sub creates the TimeDate values that are used
' 	when adding or updating the case record

	' We must very carefully create the date string that we are going to
	' use in the SQL instruction since the system can easily
	' return incorrect values like 9/12/99 or 09/12/1999
	' depending upon their regional settings so this code
	' will hopefully extract the right values.


	' Compute the new Date and Time based on Server Time Zones plus
	' or minus the Time Zone Adjustments.  The time difference between
	' the Server Time and time where the web transaction is taking
	' placing is set by the variable called TimeZoneAdjustment

	'TimeZoneAdjustment = 0 ' Set this +/- Server Time Zone

	'TimeZoneAdjustment is set in the System Configuration Menu
	' Stored in Database as String
	If TimeZoneAdjustment = "" Or IsNull(TimeZoneAdjustment) Then
		TimeZoneAdjustmentInt = 0
	Else
		TimeZoneAdjustmentInt = CInt(TimeZoneAdjustment)
	End If

	' Time Zone Label is also stored in configurable table in DB

	'TimeZoneLabel = "(PST)"

	NewDate = DateAdd("h", TimeZoneAdjustmentInt, Now)

	CurrentDateFormatted = CStr(Year(NewDate))

	If len(CStr(Month(Date))) < 2 then
		CurrentDateFormatted = CurrentDateFormatted & "0" & CStr(Month(NewDate))
	Else
		CurrentDateFormatted = CurrentDateFormatted & CStr(Month(NewDate))
	End If

	If len(CStr(Day(Date))) < 2 then
		CurrentDateFormatted = CurrentDateFormatted & "0" & CStr(Day(NewDate))
	Else
		CurrentDateFormatted = CurrentDateFormatted & CStr(Day(NewDate))
	End If

	DateString = CurrentDateFormatted ' In YYYYMMDD format

	' Now Create the time string in the format of HHMMSS

	TimeString = Right("0" & Hour(time), 2) & Right("0" & Minute(time),2) & Right("0" &Second(time),2)
	TimeString = Right("0" & DatePart("h",NewDate), 2) & Right("0" & DatePart("n", NewDate),2) & Right("0" & DatePart("s", NewDate),2)

	DateTimeString= Date & " " & time

'	DateTimeString =    WeekDayName(Weekday(NewDate)) & " " & MonthName(Month(NewDate)) & " " & Day(NewDate) & ", " & Year(NewDate) & " " & Time
	DateTimeString =    WeekDayName(Weekday(NewDate)) & " " & MonthName(Month(NewDate)) & " " & Day(NewDate) & ", " & Year(NewDate) & " "
	' Now computer the time in HH:MM PM/AM
	HourPart = DatePart("h", NewDate)


	'Response.write "HourPart = " & Hourpart & "<br>"
	'response.write "DateTimeString = " & DateTimeString

	' Fix to AM/PM Calculation corrected in version 4.0


	If HourPart = 0 Then
		NewHourPart = HourPart + 12
		DateTimeString = DateTimeString & NewHourPart & ":" & Right("0" & DatePart("n", NewDate),2) & " AM " & TimeZoneLabel
	End If


	If HourPart <> 0 AND HourPart < 12 Then
		DateTimeString = DateTimeString & HourPart & ":" & Right("0" & DatePart("n", NewDate),2) & " AM " & TimeZoneLabel
	End If

	If HourPart = 12 Then
		DateTimeString = DateTimeString & HourPart & ":" & Right("0" & DatePart("n", NewDate),2) & " PM " & TimeZoneLabel
	End If

	If HourPart >= 13 Then
		HourPart = HourPart - 12
		DateTimeString = DateTimeString & HourPart & ":" & Right("0" & DatePart("n", NewDate),2) & " PM " & TimeZoneLabel
	End IF

	' Debugging
	'DEBUGTIME = "YES"
	If DEBUGTIME = "YES" THen
		Response.write "TimeString = " & TimeString & "<br>"
		Response.write "DateString = " & DateString & "<br>"
		Response.write "DateTimeString = " & DatetimeString & "<br>"
		Response.flush
		Response.end
	End IF



	End Sub ' End of CreateTimeDateValues
%>



<% Function GetDefaultGroupNumber()
' This functions gets the current default group number from
' the Group_list table by searching for the row where the
' default flag = 1 and grabbing the group_number

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		mySQL2="select * from Group_list where default_flag = 1"
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			' There should always be a default group
			' send out an error
			response.write " No default group is set "
			Group_Number = 1
		Else
			GetDefaultGroupNumber = rstemp2("Group_number")
		End If

		rstemp2.close
		set rstemp2=nothing

		conntemp.close ' Close the connection
		set conntemp=nothing

	End Function
%>

<% Sub SendEmailToCustomer(Case_Number)
'	This subroutine sends out a confirmation email to the customer.
	' From the case number we need to first get the customer's email address


		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here
		If DatabaseType = "ORACLE" Then
			mySQL2="SELECT Customers.contact_fname, Customers.contact_lname, Customers.email, Cases.case_number FROM Cases, Customers where Cases.customer_id = Customers.customer_id and case_number = "& case_number
		Else
			mySQL2="SELECT Customers.contact_fname, Customers.SendTxtNotifications, Customers.contact_lname, Customers.email, Customers.Phone2, Cases.case_number FROM Cases INNER JOIN Customers ON Cases.customer_id = Customers.customer_id where case_number = "& case_number
		End If
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			ToEmail = ""
		Else
			ToEmail = rstemp2("email")
			ToFullName = rstemp2("contact_fname") & " " & rstemp2("contact_lname")
			TxtNumber = rstemp2("Phone2") ' Grab this in case you are sending TXT messages to customer
			SendTxtNotifications = rstemp2("SendTxtNotifications")

		End If

		rstemp2.close
		set rstemp2=nothing

		' Now get the part of the email message that should be sent out when Cases
		' are updated or created by the Tech+Center.

		mySQL2="SELECT * from Email_text" ' There should only be one row in this table
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			NewCaseMessage = ""
		Else
			NewCaseMessage = rstemp2("tech_update_case")
		End If

		rstemp2.close
		set rstemp2=nothing

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL2="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1

		Else
			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Case_customer_ID = rstemp2("Customer_ID")
			Status = CInt(Status)
		End If

		rstemp2.close
		set rstemp2=nothing


		conntemp.close ' Close the connection
		set conntemp=nothing

		' Now Build the Whole message body
		' *********************** USER CUSTOMIZATIONS**********************
		' The fix part of the message that is sent out can be modified by
		' changing the text below.

		Message = ""
		Message = NewCaseMessage
		Message = Message & vbCRLF & wc_Your_current_case_information_is & vbCRLF
		Message = Message & wc_Case_Number_capital_letters & Case_Number & vbCRLF
		Message = Message & wc_CASE_STATUS_CAPITAL_LETTERS
		If Status = 1 Then
			Message = Message & wc_Closed & vbCRLF
		Else
			Message = Message & wc_Open & vbCRLF
		End If
		Message = Message & wc_Customer_ID_capital_letters & Case_Customer_ID & vbCRLF
		Message = Message & wc_CASE_ONE_LINE_DESCRIPTION & Case_One_Line & vbCRLF & vbCRLF


		' The special color codes have to be removed before sending the case_history

		' If the case is not closed then send out smaller message with just the updates
		' if the case is closed, then send the whole case history

		If Status = 1 Then  ' Status = Closed .. so send whole history text
			Message = Message & wc_COMPLETE_CASE_HISTORY_BELOW & vbCRLF &"---------------------------------" & vbCRLF

			Case_Text = Case_History
		Else
			Message = Message & wc_IMPORTANT_CASE_UPDATES_BELOW & vbCRLF &"---------------------------------" & vbCRLF

			Case_Text = New_Case_History_Without_Old
		End If

		If Case_Text = "" Then
			Case_Text = Case_History ' For initial case openings
		End If


		'************** USER CUSTOMIZATION ************************
		' DISPLAY ENTIRE CASE HISTORY FOR CUSTOMER EMAIL
		' If you want to display the whole Case History every time simply uncomment the line below
		' Case_Text = Case_History
		'***************End USER CUSTOMIZATION ********************


		Case_History = CleanUpHistoryText(Case_Text)
		Message = Message & Case_History & vbCRLF

		If Case_Summary <> "" Then
			Message = Message & wc_Case_summary_head & vbCRLF & Case_Summary & vbCRLF
		End If

		If Case_Resolution <> "" Then
			Message = Message & wc_Case_Resolution_head & vbCRLF & Case_Resolution & vbCRLF
		End If


		' Now display a link back to the Customer+Center Home page
		' so they can get directly back to the customer+center to update the case.

		' Get the full server http URL for the direct LINK.
		 For each key in Request.serverVariables

		if Key = "SERVER_NAME" Then
			HostName =  Request.ServerVariables(key)
		End IF

		if Key = "SCRIPT_NAME" Then
			SCRIPT_Name =  Request.ServerVariables(key)
			' Replace DoEmailListSend.asp with RemoveFromList.asp
			' This will handle all of the necessary virtual directory mappings

			Virtual_Path = replace(Script_Name, "DoTCaseForm.asp", "DCF.asp")

		End IF


	Next


		' ******** Important User Customizations ***************
		' The Customer+Center virtual directory must be specified here
		' since it may not be customer40 if you are using a non-default name
		' Set your customer+center virtual directory name below
		' Also set if you want to turn on this embedded link to customer+center
		' then un-comment or comment out the SendCustomerCenterLink variable line below.

		' Set these to exactly your virtual directory names... this is case sensitive




		' ********** End User Customizations ***********************

		Virtual_Path = replace(Virtual_path, TechVirtual, CustomerVirtual,1,1,1)

		If SendCustomerCenterLink <> "" Then

			Message = Message & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF
			'--- create url with obfuscated customer_id and MODE=auto to enable automatic logging in with DCF.asp -------
			If WordPressSite > "" then  ' 10/02/12
				Params = "?WP=YES&MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Customer_ID))  ' WORDPRESS
				CaseLink= WordPressSite & "/DCF/" & Params
			Else
				CaseLink = "http://" &  hostname & Virtual_path & "?MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Case_Customer_ID))
			End If

			Message = Message &  Caselink & vbCRLF & vbCRLF


		End IF


		' Do not remove this line.

		Message = Message & EmailChecksum


		If HTMLEmail = "YES" Then

			NotificationReportTitle = wc_Notification_Report_Support_Case_Update

			updatedby = "tech"


			AltBody = Message ' First save Text message into separate variable
			Message = CreateHTMLCustomerMsg(Case_Number, CaseLink, NotificationReportTitle, updatedby)


			' Debugging
			'response.write Message


		End IF




		' *************User Customizations *************************
		' Customer Email Subject Line Customizations
		' **********************************************************

		' You can change the Subject line if necessary

		'There are three subject lines
		' (1) One for Newly Open cases by tech
		' (2) One for updating but not closed cases
		' (3) One for Closed cases

			If CaseType = "NEW" Then
				' 06/04/13 SubjectLine = "Notification Report - Support Case " & Case_Number & " " & wc_Opened
			    SubjectLine = "Notification Report - Support Case [" & Case_Number & "] -- " & Case_One_Line & " -- " & wc_Opened
			End IF

			If Status = 1 and CaseType <> "NEW" Then
			' 06/04/13	SubjectLine = "Notification Report -Support Case " & Case_Number & " " & wc_Closed
		      SubjectLine = "Notification Report - Support Case [" & Case_Number & "] -- " & Case_One_Line & " -- " & wc_Closed
			End If

			If (Status <> 1) and CaseType <> "NEW" Then
			' 06/04/13	SubjectLine = "Notification Report -Support Case " & Case_Number & " Update"
			   SubjectLine = "Notification Report - Support Case [" & Case_Number & "] -- " & Case_One_Line & " -- " & " Update"
			End If

		'SubjectLine = "Support Case " & Case_Number & " Update"

		' Now we have everything we need to send the email to the customer
		' Only send the message if ToEmail exists and Customer_case_notify flag is set

		If ToEmail <> ""  And Customer_case_notify = 1 Then
			 If MyOS = "Windows" Then
				SendEmail ToEmail, ToFullName, SubjectLine, Message
			 Else
				SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
			 End If
			Customer_Notification = "<I>" &  ToFullName & "</i>(" & ToEmail & ")"
		End If


	If Version8point0 = "YES" AND SendTxtNotifications Then

	' Txt Messaging code to send Txt Message to Customer
	' USER CUSTOMIZATION FOR TXT MESSAGES to customers

		CustomerTxtMessage = "Support Case " & Case_number & " has been created or updated.  Please check your email for full details."
		CustomerTxtMessage = Left( CustomerTxtMessage, 150)

		SendTxtMessage TxtNumber, CustomerTxtMessage

	End If



	'********************* Customization for second manager email - START of customization ****
	' Customization to send a second email to customers manager inside of the mailstop field.
	' uncomment the line below to enable sending an second email to a second customer email
	' address obtained from the mailstop field.

	'SendSecondEmail = "YES"

	if SendSecondEmail = "YES" Then

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here


		mySQL2="SELECT Customers.mailstop FROM Cases INNER JOIN Customers ON Cases.customer_id = Customers.customer_id where case_number = "& case_number

		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			SecondEmailAddress = ""
		Else
			SecondEmailAddress = rstemp2("mailstop")


		' Custom code to build that email address from first name letter and last name
'			spacefound = "NO"
'			for i=1 to len(SecondEmailAddress)
'				if mid(SecondEmailAddress,i,1) = " " Then
'					SpaceFound = "YES"
'				End If
'
'				if spacefound = "NO" THen
'					FirstNameValue = FirstNameValue & mid(SecondEmailAddress, i, 1)
'				ELSE
'					SecondNAmeValue = SecondNameVAlue & mid(secondemailaddress,i,1)
'				End IF
'			Next
'
'			' Some custom string additions to create the email address
'			NewSecondEmailaddress= left(FirstNameValue,1) & SecondNAmeValue & "@mycompany.com"
'			NewSecondEmailAddress = replace(NewSecondEmailAddress, " " , "")
'
'			'debugging
'
'			'response.write "NewEmailAddress = " & NEwSecondEmailAddress
'			'response.flush
'			'response.end

			NewEmailAddress = SecondEmailAddress

			ToFullName = NewEmailAddress
			ToEmail = NewEmailAddress

		End If

		rstemp2.close
		set rstemp2=nothing

			 If MyOS = "Windows" Then
				SendEmail ToEmail, ToFullName, SubjectLine, Message
			 Else
				SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
			 End If


		conntemp.close ' Close the connection
		set conntemp=nothing

	End If ' End of If SendSecondEmail = "YES"

	'********************* Customization for second manager email - START of customization ****




End Sub ' End of SendEmalToCustomer() subroutine
%>


<% Sub SendEmailToAdditionalCustomerCaseAssignment(Case_Number)
'	This subroutine sends out a confirmation email to the customers who are also assigned to this case
	' From the case number we need to first get the customer's email address


		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		' Now get the part of the email message that should be sent out when Cases
		' are updated or created by the Tech+Center.

		mySQL2="SELECT * from Email_text" ' There should only be one row in this table
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		if rstemp2.EOF then
			NewCaseMessage = ""
		Else
			NewCaseMessage = rstemp2("tech_update_case")
		End If

		rstemp2.close
		set rstemp2=nothing

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL2="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1

		Else
			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Case_customer_ID = rstemp2("Customer_ID")
			Status = CInt(Status)
		End If

		rstemp2.close
		set rstemp2=nothing


		conntemp.close ' Close the connection
		set conntemp=nothing

		' Now Build the Whole message body
		' *********************** USER CUSTOMIZATIONS**********************
		' The fix part of the message that is sent out can be modified by
		' changing the text below.

		Message = ""
		Message = NewCaseMessage
		Message = Message & vbCRLF & wc_Your_current_case_information_is & vbCRLF
		Message = Message & wc_Case_Number_capital_letters & Case_Number & vbCRLF
		Message = Message & wc_CASE_STATUS_CAPITAL_LETTERS
		If Status = 1 Then
			Message = Message & wc_Closed & vbCRLF
		Else
			Message = Message & wc_Open & vbCRLF
		End If
		Message = Message & wc_Customer_ID_capital_letters & Case_Customer_ID & vbCRLF
		Message = Message & wc_CASE_ONE_LINE_DESCRIPTION & Case_One_Line & vbCRLF & vbCRLF


		' The special color codes have to be removed before sending the case_history

		' If the case is not closed then send out smaller message with just the updates
		' if the case is closed, then send the whole case history

		If Status = 1 Then  ' Status = Closed .. so send whole history text
			Message = Message & wc_COMPLETE_CASE_HISTORY_BELOW & vbCRLF &"---------------------------------" & vbCRLF

			Case_Text = Case_History
		Else
			Message = Message & wc_IMPORTANT_CASE_UPDATES_BELOW & vbCRLF &"---------------------------------" & vbCRLF

			Case_Text = New_Case_History_Without_Old
		End If

		If Case_Text = "" Then
			Case_Text = Case_History ' For initial case openings
		End If


		'************** USER CUSTOMIZATION ************************
		' DISPLAY ENTIRE CASE HISTORY FOR CUSTOMER EMAIL
		' If you want to display the whole Case History every time simply uncomment the line below
		' Case_Text = Case_History
		'***************End USER CUSTOMIZATION ********************


		Case_History = CleanUpHistoryText(Case_Text)
		Message = Message & Case_History & vbCRLF

		If Case_Summary <> "" Then
			Message = Message & wc_Case_summary_head & vbCRLF & Case_Summary & vbCRLF
		End If

		If Case_Resolution <> "" Then
			Message = Message & wc_Case_Resolution_head & vbCRLF & Case_Resolution & vbCRLF
		End If


		' Now display a link back to the Customer+Center Home page
		' so they can get directly back to the customer+center to update the case.

		' Get the full server http URL for the direct LINK.
		 For each key in Request.serverVariables

		if Key = "SERVER_NAME" Then
			HostName =  Request.ServerVariables(key)
		End IF

		if Key = "SCRIPT_NAME" Then
			SCRIPT_Name =  Request.ServerVariables(key)
			' Replace DoEmailListSend.asp with RemoveFromList.asp
			' This will handle all of the necessary virtual directory mappings

			Virtual_Path = replace(Script_Name, "DoTCaseForm.asp", "DCF.asp")

		End IF


	Next


		' ******** Important User Customizations ***************
		' The Customer+Center virtual directory must be specified here
		' since it may not be customer40 if you are using a non-default name
		' Set your customer+center virtual directory name below
		' Also set if you want to turn on this embedded link to customer+center
		' then un-comment or comment out the SendCustomerCenterLink variable line below.





	'**** IMPORTANT - links to log in are not sent in this Additional Customer Case Assignment since we don't want this customer updating the case


		' ********** End User Customizations ***********************

		Virtual_Path = replace(Virtual_path, TechVirtual, CustomerVirtual,1,1,1)

		' *************User Customizations *************************
		' Customer Email Subject Line Customizations
		' **********************************************************

		' You can change the Subject line if necessary

		'There are three subject lines
		' (1) One for Newly Open cases by tech
		' (2) One for updating but not closed cases
		' (3) One for Closed cases

		If CaseType = "NEW" Then
			SubjectLine = "Support Case [" & Case_Number & " -- " & Case_One_Line & "] " & wc_Opened
		End IF

		If Status = 1 and CaseType <> "NEW" Then
			SubjectLine = "Support Case [" & Case_Number & " -- " & Case_One_Line & "] " & wc_Closed
		End If

		If (Status <> 1) and CaseType <> "NEW" Then
			SubjectLine = "Support Case [" & Case_Number & " -- " & Case_One_Line & "] " & "Update "
		End If

		'SubjectLine = "Support Case " & Case_Number & " Update"

'LOOP HERE because want to have different links for different people
		SaveMsg = Message

' ----- Start Of looping code

		' Now see if there are any techs configured for this group that have
		' configured email notification

		set conntemp5=server.createobject("adodb.connection")
		conntemp5.open myDSN ' Open the connection once here

		mySQL2 = "SELECT AdditionalCustomerCaseAssignments.Case_number, AdditionalCustomerCaseAssignments.CustomerCaseAssignmentIndex, AdditionalCustomerCaseAssignments.customer_id, Customers.contact_fname, Customers.email, Customers.contact_lname FROM AdditionalCustomerCaseAssignments INNER JOIN Customers ON AdditionalCustomerCaseAssignments.customer_id = Customers.customer_id where case_number = " & Case_number
'     07/31/13 changed rstemp2 to rstemp20 because of possible conflict with createhtmlcustomermessage

		set rstemp20=conntemp5.execute(mySQL2)

		if rstemp20.EOF then
			ToEmail = "" ' No body is configured as an additional assigned customer for this case
			Additional_Customer_Case_Assignment_List  = "No additional customer assignments for this case"
		Else
			Additional_Customer_Case_Assignment_List = ""

		' Loop through all of the entries and send  a customer notification email to each of them

			Do While rstemp20.EOF <> True
			   Message = SaveMsg
            customer_ID = rstemp20("Customer_ID")
            case_customer_ID = rstemp20("Customer_ID")
            contact_fname = rstemp20("Contact_fname")
            contact_lname = rstemp20("Contact_lname")
            ToFullName = rstemp20("contact_fname") & " " & rstemp20("contact_lname")
            ToEmail = rstemp20("email")
				SendIt = 0

				'If SendEmailValue = "YES" Then ' SBCC
						For each customer in Request.form("AdditionalCustomerCaseAssignments")
								if customer=customer_ID then
									SendIt = 1
								end if
						 Next
						 if SendIt = 0 then
							For each ID in Request.form("RemoveFromCustomerCaseAssignment") ' 04/24/13
								 customer=GetCustomerID(ID)
								 if customer=customer_ID then
									SendIt = 1
								 end if
							next
						 end if
				' SBCC End IF

				If SendCustomerCenterLink <> "" Then
						Message = Message & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF
						'--- create url with obfuscated customer_id and MODE=auto to enable automatic logging in with DCF.asp -------
						If WordPressSite > "" then  ' 10/02/12
							Params = "?WP=YES&MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Customer_ID))  ' WORDPRESS
							CaseLink= WordPressSite & "/DCF/" & Params
						Else
							CaseLink = "http://" &  hostname & Virtual_path & "?MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Case_Customer_ID))
						End If

						Message = Message &  Caselink & vbCRLF & vbCRLF
				End IF

					' Do not remove this line.
				Message = Message & EmailChecksum
' TEST caselink = "localhost/customer70/survey.asp"
				If HTMLEmail = "YES" Then
					NotificationReportTitle = wc_Notification_Report_Additional_Customer_Case_Assignment
					updatedby = "tech"
					AltBody = Message ' First save Text message into separate variable
				' 08/07/13	Message = CreateHTMLCustomerMsg(Case_Number, CaseLink, NotificationReportTitle, updatedby)
					Message = CreateHTMLAdditionalCustomerCaseMsg(Case_Number, CaseLink, NotificationReportTitle, updatedby,customer_id )

				End IF

				' Send out the email if an email address exists
				If ToEmail <> ""  and (SendIt = 1 or SendEmailValue = "YES") Then ' 05/24/13
					SendEmail ToEmail, ToFullName, SubjectLine, Message
					Additional_Customer_Case_Assignment_List = Additional_Customer_Case_Assignment_List & "<Br><I>" & ToFullName & "</i>(" & ToEmail & ")"
				End If

				rstemp20.MoveNext

			Loop

		End If

		rstemp20.close
		set rstemp20=nothing

		conntemp5.close ' Close the connection
		set conntemp5=nothing

'--------- end of looping code

End Sub ' End of SendEmailToAdditionalCustomerCaseAssignment() subroutine - Version 8.0
%>

<% Sub SendAdditionalNotificationEmail(Case_Number)
'	This subroutine sends out a notification email to the persons defined in the tech+center
	' From the case number.. we can get the CC list and Primary notification email
	' is found in the configuration table.


		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here
		If DatabaseType = "ORACLE" Then
			mySQL2="SELECT Customers.contact_fname, Customers.contact_lname, Customers.email, Cases.case_number FROM Cases, Customers where Cases.customer_id = Customers.customer_id and case_number = "& case_number
		Else
			mySQL2="SELECT Customers.contact_fname, Customers.contact_lname, Customers.email, Cases.case_number FROM Cases INNER JOIN Customers ON Cases.customer_id = Customers.customer_id where case_number = "& case_number
		End If
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			ToEmail = ""
		Else
			ToEmail = rstemp2("email")
			ToFullName = rstemp2("contact_fname") & " " & rstemp2("contact_lname")

		End If

		rstemp2.close
		set rstemp2=nothing

		' Now get the part of the email message that should be sent out when Cases
		' are updated or created by the Tech+Center.

		mySQL2="SELECT * from Email_text" ' There should only be one row in this table
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			NewCaseMessage = ""
		Else
			NewCaseMessage = rstemp2("tech_update_case")
		End If

		rstemp2.close
		set rstemp2=nothing

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL2="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1

		Else
			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Case_customer_ID = rstemp2("Customer_ID")
			Status = CInt(Status)

			If bAdditionalEmails = True Then ' Version 7.5  ' 03/21/13 changed from bAdditional to bAdditionalEmails
				AdditionalCCList = rstemp2("AdditionalCCList") ' CC list
				AdditionalNotificationsDb = rstemp2("AdditionalNotifications") ' True or False
			End If

		End If

		rstemp2.close
		set rstemp2=nothing


		conntemp.close ' Close the connection
		set conntemp=nothing

		' Now Build the Whole message body
		' *********************** USER CUSTOMIZATIONS**********************
		' The fix part of the message that is sent out can be modified by
		' changing the text below.

		Message = ""
		Message = NewCaseMessage
		Message = Message & vbCRLF & wc_Your_current_case_information_is & vbCRLF
		Message = Message & wc_Case_Number_capital_letters & Case_Number & vbCRLF
		Message = Message & wc_CASE_STATUS_CAPITAL_LETTERS
		If Status = 1 Then
			Message = Message & wc_Closed & vbCRLF
		Else
			Message = Message & wc_Open & vbCRLF
		End If
		Message = Message & wc_Customer_ID_capital_letters & Case_Customer_ID & vbCRLF
		Message = Message & wc_CASE_ONE_LINE_DESCRIPTION & Case_One_Line & vbCRLF & vbCRLF


		' The special color codes have to be removed before sending the case_history

		' If the case is not closed then send out smaller message with just the updates
		' if the case is closed, then send the whole case history

		If Status = 1 Then  ' Status = Closed .. so send whole history text
			Message = Message & wc_COMPLETE_CASE_HISTORY_BELOW & vbCRLF &"---------------------------------" & vbCRLF

			Case_Text = Case_History
		Else
			Message = Message & wc_IMPORTANT_CASE_UPDATES_BELOW & vbCRLF &"---------------------------------" & vbCRLF

			Case_Text = New_Case_History_Without_Old
		End If

		If Case_Text = "" Then
			Case_Text = Case_History ' For initial case openings
		End If


		'************** USER CUSTOMIZATION ************************
		' DISPLAY ENTIRE CASE HISTORY FOR CUSTOMER EMAIL
		' If you want to display the whole Case History every time simply uncomment the line below
		' Case_Text = Case_History
		'***************End USER CUSTOMIZATION ********************


		Case_History = CleanUpHistoryText(Case_Text)
		Message = Message & Case_History & vbCRLF

		If Case_Summary <> "" Then
			Message = Message & wc_Case_summary_head & vbCRLF & Case_Summary & vbCRLF
		End If

		If Case_Resolution <> "" Then
			Message = Message & wc_Case_Resolution_head & vbCRLF & Case_Resolution & vbCRLF
		End If




		' ********** End User Customizations ***********************



		' Do not remove this line.

		Message = Message & EmailChecksum


		If HTMLEmail = "YES" Then

			NotificationReportTitle = wc_Notification_Report_Support_Case_Update

			updatedby = "tech"


			AltBody = Message ' First save Text message into separate variable

			Message = CreateHTMLAdditionalNotificationMsg(Case_Number, CaseLink, NotificationReportTitle, UpdatedBy)

			' Debugging
			'response.write Message


		End IF


		' *************User Customizations *************************
		' Customer Email Subject Line Customizations
		' **********************************************************

		' You can change the Subject line if necessary

		'There are three subject lines
		' (1) One for Newly Open cases by tech
		' (2) One for updating but not closed cases
		' (3) One for Closed cases

			If CaseType = "NEW" Then
				' 06/04/13 SubjectLine = "Notification Report - Support Case " & Case_Number & " " & wc_Opened
			    SubjectLine = "Notification Report - Support Case " & Case_Number & " -- " & Case_One_Line & " -- " & wc_Opened
			End IF

			If Status = 1 and CaseType <> "NEW" Then
			' 06/04/13	SubjectLine = "Notification Report -Support Case " & Case_Number & " " & wc_Closed
		      SubjectLine = "Notification Report - Support Case " & Case_Number & " -- " & Case_One_Line & " -- " & wc_Closed
			End If

			If (Status <> 1) and CaseType <> "NEW" Then
			' 06/04/13	SubjectLine = "Notification Report -Support Case " & Case_Number & " Update"
			   SubjectLine = "Notification Report - Support Case " & Case_Number & " -- " & Case_One_Line & " -- " & " Update"
			End If

		'SubjectLine = "Support Case " & Case_Number & " Update"

		' Now we have everything we need to send the email to the customer
		' Only send the message if ToEmail exists and Customer_case_notify flag is set

		' We will send this email out to 2 types of emails
		'(1) Primary Notification Email
		'(2) Notification CC List





		' First get the primary notification email from the configuration file

	 ' Start to build up list of people that were sent the email


			Additional_Notification_List = "" 'Clear out list

			'debug
'				response.write "AdditionalNotificationsDb" = AdditionalNotificationsDb
'				response.flush
'				response.end




			IF AdditionalNotificationsDb = True AND PrimaryAdditionalNotificationEmail <> "" Then
				'Additional_Notification_List = PrimaryAdditionalNotificationEmail

'				response.write "PrimaryAdditionalNotificationEmail" = PrimaryAdditionalNotificationEmail
'				response.flush
'				response.end



			ToEmail = PrimaryAdditionalNotificationEmail
			ToFullName = PrimaryAdditionalNotificationEmail




			 If MyOS = "Windows" Then
				SendEmail ToEmail, ToFullName, SubjectLine, Message
			 Else
				SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
			 End If


		End If ' End of if AdditionalNotifications <> '"


		' Now get the CC list and extract individual emails from there and send them out


		IF AdditionalCCList  <> "" Then

		' Parse through the string that is comma delimited


			spacefound = "NO"
			EmailString = "" ' Clear out EmailString

			'response.write "AdditionalCCList = " & AdditionalCCList & "<br>"
			'response.flush
			'response.end


			for i=1 to len(AdditionalCCList)
				if (mid(AdditionalCCList,i,1) = " ") OR  (mid(AdditionalCCList,i,1) = ",") Then
					SpaceFound = "YES"
				End If

				if spacefound = "NO" Then

					OneCharacter = mid(AdditionalCCList,i,1)
					EmailString = EmailString & OneCharacter
				Else

					' space or comma found so send an email with that email address


					ToFullName = Trim(EmailString)
					ToEmail = Trim(EmailString)

				Additional_Notification_List = Additional_Notification_List & " " & ToEmail

			'		response.write "Sending inside For Loop -EMail to:" & EmailString
			'		response.flush
			'		response.end


					 If MyOS = "Windows" Then
						SendEmail ToEmail, ToFullName, SubjectLine, Message
					 Else
						SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
					 End If

					 EmailString = "" ' Clear out email string
					 SpaceFound = "NO"

				End IF

			Next


				' Send out last one that is not terminated with space or comma

					ToFullName = Trim(EmailString)
					ToEmail = Trim(EmailString)

				Additional_Notification_List = Additional_Notification_List & " " & ToEmail


			'		response.write "Sending last EMail to:" & EmailString
			'		response.flush
			'		response.end


					 If MyOS = "Windows" Then
						SendEmail ToEmail, ToFullName, SubjectLine, Message
					 Else
						SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
					 End If




		End If



End Sub ' End of SendAdditionalNotifications() subroutine
%>

<% Sub SendSurveyEmailToCustomer(Case_Number) ' rewritten 11/20/13
'	This subroutine sends out an email to the customer with a link to
	' web-based customer survey.
	' From the case number we need to first get the customer's email address

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		' Now get the part of the email message that should be sent out when Cases
		' are updated or created by the Tech+Center.

		mySQL2="SELECT * from Email_text" ' There should only be one row in this table
		set rstemp2=conntemp.execute(mySQL2)

		if rstemp2.EOF then
			NewCaseMessage = ""
		Else
			NewCaseMessage = rstemp2("tech_update_case")
		End If

		rstemp2.close
		set rstemp2=nothing

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL2="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL2)

		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1

		Else
			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Case_customer_ID = rstemp2("Customer_ID")
			Status = CInt(Status)
		End If

		rstemp2.close

		' Now Build the Whole message body
		' *********************** USER CUSTOMIZATIONS**********************
		' The fix part of the message that is sent out can be modified by
		' changing the text below.

		Message = ""
		Message = SurveyEmailText ' First part of message comes from configuration
		Message = Message & vbCRLF & vbCRLF

      SaveMsg = Message

		' Now display a link back to the Customer+Center Home page
		' so they can get directly back to the customer+center to update the case.

		' Get the full server http URL for the direct LINK.
	 For each key in Request.serverVariables
			if Key = "SERVER_NAME" Then
				HostName =  Request.ServerVariables(key)
			End IF

			if Key = "SCRIPT_NAME" Then
				SCRIPT_Name =  Request.ServerVariables(key)
				Virtual_Path = replace(Script_Name, "DoTCaseForm.asp", "CShowSurvey.asp")
			End IF
	Next

	Virtual_Path = replace(Virtual_path, TechVirtual, CustomerVirtual,1,99,1)


'**************** main customer ID
		mySQL2="SELECT customers.customer_ID, Customers.contact_fname, Customers.contact_lname, Customers.email, Cases.case_number FROM Cases INNER JOIN Customers ON Cases.customer_id = Customers.customer_id where case_number = "& case_number
		set rstemp2=conntemp.execute(mySQL2)
		Message = SaveMsg
		if rstemp2.EOF then
			ToEmail = ""
		Else
			ToEmail = rstemp2("email")
			Customer_ID = rstemp2("Customer_ID")
			ToFullName = rstemp2("contact_fname") & " " & rstemp2("contact_lname")
		End If

			if SBCC = "YES" then	 ' 11/20/13
				' 06/04/13 SubjectLine = wc_Customer_Survey_for_Case  & Case_Number
			  ' SubjectLine = wc_Customer_Survey_for_Case  & Case_Number &" -- " & case_one_line
			   SubjectLine = wc_Customer_Survey_for_Case  & Case_Number & ": " & case_one_line
				'Message = SaveMsg & wc_Click_link_below_customer_survey & vbCRLF & vbCRLF
				Message = SaveMsg &  "http://helpdesk.sbcc.edu" & Virtual_path & "?CN=" & Case_Number & "&CID=" & Customer_ID & vbCRLF & vbCRLF
				CaseLink = "http://helpdesk.sbcc.eduxxx/CShowSurvey.asp" & "?CN=" & Case_Number & "&CID=" & Customer_ID
				' CaseLink = "http://" &  hostname & Virtual_path & "?CN=" & Case_Number & "&CID=" & Customer_ID
			Else
				' You can change the Subject line if necessary
				SubjectLine = wc_Customer_Survey_for_Case  & Case_Number
				Message = SaveMsg & wc_Click_link_below_customer_survey & vbCRLF & vbCRLF
			' 11/20/13 changed it to above Message = Message &  "http://" &  hostname & Virtual_path & "?CN=" & Case_Number & vbCRLF & vbCRLF
				CaseLink = "http://" &  hostname & Virtual_path & "?CN=" & Case_Number & "&CID=" & Customer_ID
  				Message = Message &  Caselink & vbCRLF & vbCRLF
  			end if
  	  	 	SurveyLink = CaseLink

		' Do not remove this line.
		Message = Message & EmailChecksum

		rstemp2.close

		If HTMLEmail = "YES" Then
			AltBody = Message ' First save Text message into separate variable
			Message = CreateHTMLCustomerSurveyEmail(SurveyEmailText, SurveyLink, Case_One_Line)
		End IF

		' Now we have everything we need to send the email to the customer
		' Only send the message if ToEmail exists and Customer_case_notify flag is set

		If ToEmail <> ""  And Customer_case_notify = 1 Then
				SendEmail ToEmail, ToFullName, SubjectLine, Message
			SurveySent = SurveySent & "<BR><I>" &  ToFullName & "</i>(" & ToEmail & ")"
		End If

'************** additional customer case assignments
		mySQL2 = "SELECT AdditionalCustomerCaseAssignments.Case_number, AdditionalCustomerCaseAssignments.CustomerCaseAssignmentIndex, AdditionalCustomerCaseAssignments.customer_id, Customers.contact_fname, Customers.email, Customers.contact_lname FROM AdditionalCustomerCaseAssignments INNER JOIN Customers ON AdditionalCustomerCaseAssignments.customer_id = Customers.customer_id where case_number = " & Case_number

		set rstemp2=conntemp.execute(mySQL2)
		if rstemp2.EOF then
			ToEmail = ""
		Else
			Do While not rstemp2.EOF

				ToEmail = rstemp2("email")
				Customer_ID = rstemp2("Customer_ID")
				ToFullName = rstemp2("contact_fname") & " " & rstemp2("contact_lname")
				if SBCC = "YES" then	 ' 11/20/13
					' 06/04/13 SubjectLine = wc_Customer_Survey_for_Case  & Case_Number
				  ' SubjectLine = wc_Customer_Survey_for_Case  & Case_Number &" -- " & case_one_line
					SubjectLine = wc_Customer_Survey_for_Case  & Case_Number & ": " & case_one_line
					'Message = Message & wc_Click_link_below_customer_survey & vbCRLF & vbCRLF
					Message = Message &  "http://helpdesk.sbcc.edu" & Virtual_path & "?CN=" & Case_Number & "&CID=" & Customer_ID & vbCRLF & vbCRLF
					CaseLink = "http://helpdesk.sbcc.eduxxx/CShowSurvey.asp" & "?CN=" & Case_Number & "&CID=" & Customer_ID
					' CaseLink = "http://" &  hostname & Virtual_path & "?CN=" & Case_Number & "&CID=" & Customer_ID
				Else
					' You can change the Subject line if necessary
					SubjectLine = wc_Customer_Survey_for_Case  & Case_Number
					Message = SaveMsg & wc_Click_link_below_customer_survey & vbCRLF & vbCRLF
				' 11/20/13 changed it to above Message = Message &  "http://" &  hostname & Virtual_path & "?CN=" & Case_Number & vbCRLF & vbCRLF
					CaseLink = "http://" &  hostname & Virtual_path & "?CN=" & Case_Number & "&CID=" & Customer_ID
					Message = Message &  Caselink & vbCRLF & vbCRLF
				end if
     	  	 	SurveyLink = CaseLink

				Message = Message &  Caselink & vbCRLF & vbCRLF

			' Do not remove this line.
				Message = Message & EmailChecksum

				If HTMLEmail = "YES" Then
					AltBody = Message ' First save Text message into separate variable
					Message = CreateHTMLCustomerSurveyEmail(SurveyEmailText, SurveyLink, Case_One_Line)
				End IF

				' *************User Customizations *************************

				' Now we have everything we need to send the email to the customer
				' Only send the message if ToEmail exists and Customer_case_notify flag is set

				If ToEmail <> ""  And Customer_case_notify = 1 Then
						SendEmail ToEmail, ToFullName, SubjectLine, Message
						SurveySent = SurveySent & "<BR><I>" &  ToFullName & "</i>(" & ToEmail & ")"
				End If

			rstemp2.MoveNext
		Loop
      End If

		rstemp2.close
		Set rstemp2 = nothing

End Sub ' End of SendSurveyEmailToCustomer() subroutine
%>


<% Sub SendEmailToAssignedTech(Case_Number, Tech_Assigned_Email)
'	This subroutine sends out a notification email to a tech if a tech has already
	' being assigned to the case.  Only case updates will possibly have a
	' tech assigned to the case.

	' First we determine if case has a tech assigned to it.

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL2="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1
			Tech_ID = ""

		Else
			' Get all of the information while we are here

			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Tech_ID = rstemp2("Tech_ID")
			Customer_ID = rstemp2("Customer_ID")
			PriorityID = rstemp2("Severity")

			' Perform another query to get the Priority text
			mySQL4="SELECT * from Priority where PriorityID = " & PriorityID
			set rstemp4=conntemp.execute(mySQL4)

			PriorityText = rstemp4("ShortDesc")
			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			'******* CELL PHONE EMAIL TEXT FIELDS *****************************
			' Perform another query to get the customer information so
			' it can be displayed in the email for text page cell phone email
			' We will grab the two phone numbers and company name

			mySQL4="SELECT * from Customers where customer_id = '" & Customer_ID & "'"
			set rstemp4=conntemp.execute(mySQL4)


			CustomerCompany = rstemp4("Company")
			CustomerPhone1 = rstemp4("Phone1")
			CustomerPhone2 = rstemp4("Phone2")
			CustomerFullName = rstemp4("Contact_fname") & " " & rstemp4("Contact_lname")


			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			'********** CELL PHONE EMAIL TEXT FIELD ENDING

		End If

		rstemp2.close
		set rstemp2=nothing

		conntemp.close ' Close the connection since we may not open it again
		set conntemp=nothing


		If Tech_ID <> "" Then ' Tech Found so get their email

		' Check if Assigned tech is the one doing the updates to the
		' case and if so do not send an email

		If LoginTech_ID = Tech_ID Then
			Tech_Notification = " No message sent(Updated by assigned tech)"
			' Do not send out email

		Else


			set conntemp=server.createobject("adodb.connection")

			conntemp.open myDSN ' Open the connection once here

			' only send out email to tech if New_Case_notify = 1

				mySQL2="SELECT * from Tech_staff where Tech_ID = '" & Tech_ID & "' AND New_Case_Notify = 1"
				set rstemp2=conntemp.execute(mySQL2)

				' Check to see if any records are returned
				' if none found the
				if rstemp2.EOF then
					ToEmail = ""
				Else
					ToEmail = rstemp2("work_email")
					ToFullName = rstemp2("first_name") & " " & rstemp2("last_name")
					TechTxtNumber = rstemp2("Work_Phone2") ' Text Message number
					SendTXTWhenAssignedToTech = rstemp2("SendTXTWhenAssignedToTech")
					SendTXTWhenAssignedToGroup = rstemp2("SendTXTWhenAssignedToGroup")


					CellEmail = rstemp2("Home_Email")
					If IsNull(rstemp2("Home_Email")) Then
						CellEmail = ""
					End If

					' *** Important note about Tech staff fields if they are blanked out
					' The Tech staff edit functions do not properly NULL out the
					' the text fields in the database when they are cleared out.
					' They current set the first character to 0 but leave the other
					' characters there so the we can't check for string <> "".
					' The test below checks to see if the first characters is ASC "0"
					' ***************************************
					If Len(CellEmail) > 0 Then
						If ASC(Mid(CellEmail,1,1)) = 0 Then
							CellEmail = ""
						End IF
					End IF

					CellFullName = ToFullName

				End If

				rstemp2.close
				set rstemp2=nothing

				conntemp.close ' Close the connection
				set conntemp=nothing



				Message = ""

			'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************
			' To enable a short condensed email to be sent to a tech cell email address/home email
			' beginning of the email message, comment/uncomment the
			' variable definition below
			CELLPHONE_EMAIL_NOTIFICATION = "YES" ' Comment out this line to disable
			'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************

			If CELLPHONE_EMAIL_NOTIFICATION = "YES" Then
				CellMessage = ""
				CellMessage = CellMessage & Customer_ID & vbCRLF & CustomerCompany & vbCRLF &vbCRLF
				CellMessage = CellMessage & CustomerPhone1 & vbCRLF  & CustomerPhone2  & vbCRLF
				CellMessage = CellMessage & "->" & Case_One_Line & vbCRLF
				CellSubjectLine = wc_ALERT
			End If


				' Now Build the Whole message body
				' *********************** USER CUSTOMIZATIONS**********************
				' The fix part of the message that is sent out can be modified by
				' changing the text below.


				Message = Message & vbCRLF & wc_CASE & " " & case_number & " " & wc_Update_Notification_for_case_assigned_to_you & vbCRLF
				Message = Message & vbCRLF & wc_This_case_was_updated_by_another_Tech_staff_Member & vbCRLF

				' Now display a link directly to the tech+center for that case window.

				' Get the full server http URL for the direct LINK.
			 For each key in Request.serverVariables

			 	if Key = "SERVER_NAME" Then
					HostName =  Request.ServerVariables(key)
				End IF

			 	if Key = "SCRIPT_NAME" Then
					SCRIPT_Name =  Request.ServerVariables(key)
					' Replace DoEmailListSend.asp with RemoveFromList.asp
					' This will handle all of the necessary virtual directory mappings

					Virtual_Path = replace(Script_Name, "DoTCaseForm.asp", "SC.asp")

				End IF

			Next

				Message = Message & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF


                       '-------create the URL link with obfuscted user ID in it ---------------
			    Message = Message & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF
			    CaseLink = "http://" &  hostname & Virtual_path & "?MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Tech_ID))

		' If you have a special port number use this syntax below
			' Portnumber = "8080"
			'    CaseLink = "http://" &  hostname & ":" & Portnumber & Virtual_path & "?MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Tech_ID))
			    Message = Message &  Caselink & vbCRLF & vbCRLF

				Message = Message & vbCRLF & wc_Tech_assignment & ToFullName & vbCRLF

				Message = Message & wc_Case_Number_capital_letters & Case_Number & vbCRLF
				Message = Message & wc_CASE_STATUS_CAPITAL_LETTERS

				If CInt(Status) = 1 Then
					Message = Message & wc_Closed& vbCRLF
				ElseIf CInt(Status) = 0 Then
					Message = Message & wc_Open_Active & vbCRLF
				ElseIf CInt(Status) = 2 Then
					Message = Message & wc_Open_Waiting & vbCRLF
				ElseIf CInt(Status) = 3 Then
					Message = Message & wc_Open_On_Hold & vbCRLF
				End If
				Message = Message & wc_Priority_capital_letters & PriorityText & vbCRLF

				Message = Message & wc_Customer_ID_capital_letters & Customer_ID & vbCRLF
				Message = Message & wc_Company_Capitals & ": " & CustomerCompany & vbCRLF

				Message = Message & wc_Phone_numbers_capital_letters & CustomerPhone1 & "/" & CustomerPhone2 & vbCRLF

				Message = Message & wc_Case_description_capital_letters & Case_One_Line & vbCRLF

				Message = Message & CategoryText ' Display category text

				' The special color codes have to be removed before sending the case_history

				Case_Text = Case_History
				Case_History = CleanUpHistoryText(Case_Text)
				Message = Message & Case_History & vbCRLF

				If Case_Summary <> "" Then
					Message = Message & wc_Case_summary_head & vbCRLF & Case_Summary & vbCRLF
				End IF
				If Case_Resolution <> "" Then
					Message = Message & wc_Case_Resolution_head & vbCRLF & Case_Resolution & vbCRLF
				End If

				' Do not remove this line.
				Message = Message & EmailChecksum



				If HTMLEmail = "YES" Then

					NotificationReportTitle = wc_Notification_Report_Assigned_Tech_update

					AltBody = Message ' First save Text message into separate variable
					Message = CreateHTMLTechMsg(Case_Number, CaseLink, NotificationReportTitle)

				'	 Debugging
					'response.write Message
'response.flush
'response.end

				End IF


		' *************User Customizations *************************
		' Customer Email Subject Line Customizations
		' **********************************************************

		' You can change the Subject line if necessary

		'There are three subject lines
		' (1) One for Newly Open cases by tech
		' (2) One for updating but not closed cases
		' (3) One for Closed cases
		If CaseType = "NEW" Then
			SubjectLine = "Support Case " & Case_Number & " -- " & Case_One_Line & " -- " & wc_Opened
		End IF

		If Status = 1 and CaseType <> "NEW" Then
			SubjectLine = "Support Case " & Case_Number & " -- " & Case_One_Line & " -- " & wc_Closed
		End If

		If (Status <> 1) and CaseType <> "NEW" Then
			SubjectLine = "Support Case " & Case_Number & " -- " & Case_One_Line & " --  " & "Update "
		End If

		' Old subject line
		'SubjectLine = "*** " & wc_Support_Case  & Case_Number & " " & wc_Alert & " ***"

				' Now we have everything we need to send the email to the tech
				' Only send the message if ToEmail exists and

				If ToEmail <> ""   Then
				     TechEmailSent = 1  ' cmb 05/04/2011
					 If MyOS = "Windows" Then
						SendEmail ToEmail, ToFullName, SubjectLine, Message
					 Else
						SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
					 End If

					Tech_Notification = "<I>" &  ToFullName & "</i>(" & ToEmail & ")"



		If Version8point0 = "YES" AND SendTXTWhenAssignedToTech  Then

	' Txt Messaging code to send Txt Message to Assigned Tech
	' USER CUSTOMIZATION FOR TXT MESSAGES
	' Customize the Cell TXT message below if you wish to send out different text messages.
	' The TXT messaging system can only send out 150 characters maximum at one time.

		CellMessage = ""
		CellMessage = CellMessage & CustomerFullName & vbCRLF & "(" & CustomerCompany & ")" & vbCRLF
		CellMessage = CellMessage & "PH:" & CustomerPhone1 & vbCRLF  & "CELL:" & CustomerPhone2  & vbCRLF
		CellMessage = CellMessage & "->" & Case_One_Line & vbCRLF

		TechTxtMessage = CellMessage
		TechTxtMessage = Left( TechTxtMessage, 150)

		SendTxtMessage TechTxtNumber, TechTxtMessage

	End If





				End If

				' Determine if we should send out email to Tech's cell phone email address

				If CellEmail <> "" AND  CELLPHONE_EMAIL_NOTIFICATION = "YES"  Then

				' *************** User customizations *********************
				' This section below allows one to configure disabling cell emails
				' sent during certain hours. This is option can be configured by
				' un-commenting the lines below

				'LimitCellEmailHours = "YES"

				If LimitCellEmailHours = "YES" Then
					' The code below will limit cell emails sent between 7 AM and 5 PM
					StartLimitHour = 7 ' 24 hour time for 7 AM
					EndLimitHour = 17 ' 24 hour time for 5 PM

					If (Hour(Now) >= StartLimitHour) AND (Hour(Now) < EndLimitHour) Then
						' If in this range then do not send cell email
					Else ' outside of this range then send cell email
						 If MyOS = "Windows" Then
							SendEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
						 Else
							SendLinuxEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
						 End If

						Tech_Notification = Tech_Notification & " Cell:(" & CellEmail & ")"
					End If


				Else
					  If MyOS = "Windows" Then
						SendEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
					  Else
						SendLinuxEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
					  End If


					Tech_Notification = Tech_Notification & " Cell:(" & CellEmail & ")"

				End IF

				'*********** End User Customization Area *********************

				End If ' End of If CellEmail <> ""


			End IF ' End of If LoginTech_ID = Tech_ID

		End If ' Do not send out email if no tech is assigned

End Sub ' End of SendEmailToAssignedTech() subroutine
%>


<% Sub SendEmailToAssignedGroupTechs(Case_Number , Tech_Assigned_Email)
	'	This subroutine sends out a notification email to any tech that are
	' configured with the default group or assigned group.  Check to see if any of those techs have already been sent
	' an email from the SendEmailToAssignedTech() function

	' Set Group_Notification to blank
	 Group_Notification = ""


	' First we need to get the Group Number assigned for this case

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL2="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL2)

		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1
			Tech_ID = ""

		Else
			' Get all of the information while we are here

			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Tech_ID = rstemp2("Tech_ID")
			Group_Number = rstemp2("Group_Number")
			Customer_ID = rstemp2("Customer_ID")

			PriorityID = rstemp2("Severity")

			' Perform another query to get the Priority text
			mySQL4="SELECT * from Priority where PriorityID = " & PriorityID
			set rstemp4=conntemp.execute(mySQL4)

			PriorityText = rstemp4("ShortDesc")
			' Close record set

			rstemp4.close
			set rstemp4 = nothing


			'******* CELL PHONE EMAIL TEXT FIELDS *****************************
			' Perform another query to get the customer information so
			' it can be displayed in the email for text page cell phone email
			' We will grab the two phone numbers and company name

			mySQL4="SELECT * from Customers where customer_id = '" & Customer_ID & "'"
			set rstemp4=conntemp.execute(mySQL4)


			CustomerCompany = rstemp4("Company")
			CustomerPhone1 = rstemp4("Phone1")
			CustomerPhone2 = rstemp4("Phone2")

			CustomerFullName = rstemp4("Contact_fname") & " " & rstemp4("Contact_lname")



			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			'********** CELL PHONE EMAIL TEXT FIELD ENDING


			' Perform another query to get the Assigned Tech Name
			If Tech_ID <> "" Then

				mySQL4="SELECT * from Tech_staff where Tech_ID = '" & Tech_ID & "'"
				set rstemp4=conntemp.execute(mySQL4)

				AssignedTechName = rstemp4("First_Name") & " " & rstemp4("Last_Name")
				' Close record set

				rstemp4.close
				set rstemp4 = nothing
			End If


		End If

		rstemp2.close
		set rstemp2=nothing

		conntemp.close ' Close the connection since we may not open it again
		set conntemp=nothing

		' Now build the message since we may need to send it to more than one person

			'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************
			' To enable a short condensed email to be sent to a tech cell email address/home email
			' beginning of the email message, comment/uncomment the
			' variable definition below
			CELLPHONE_EMAIL_NOTIFICATION = "YES" ' Comment out this line to disable
			'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************

			If CELLPHONE_EMAIL_NOTIFICATION = "YES" Then
				CellMessage = ""
				CellMessage = CellMessage & Customer_ID & vbCRLF & CustomerCompany & vbCRLF &vbCRLF
				CellMessage = CellMessage & CustomerPhone1 & vbCRLF  & CustomerPhone2  & vbCRLF
				CellMessage = CellMessage & "->" & Case_One_Line & vbCRLF
				CellSubjectLine = wc_ALERT
			End If



			' Now Build the Whole message body
			' *********************** USER CUSTOMIZATIONS**********************
			' The fix part of the message that is sent out can be modified by
			' changing the text below.

			Message = ""


			Message = Message & vbCRLF & wc_CASE & " " & case_number & " " & wc_Update_Group_Notification & vbCRLF
			Message = Message & vbCRLF & wc_Tech_assignment & AssignedTechName & vbCRLF

			Message = Message & wc_Case_Number_capital_letters & Case_Number & vbCRLF

				' Now display a link directly to the tech+center for that case window.

				' Get the full server http URL for the direct LINK.
			 For each key in Request.serverVariables

			 	if Key = "SERVER_NAME" Then
					HostName =  Request.ServerVariables(key)
				End IF

			 	if Key = "SCRIPT_NAME" Then
					SCRIPT_Name =  Request.ServerVariables(key)
					' Replace DoEmailListSend.asp with RemoveFromList.asp
					' This will handle all of the necessary virtual directory mappings

					Virtual_Path = replace(Script_Name, "DoTCaseForm.asp", "SC.asp")

				End IF

			Next



			Message = Message & "CASE STATUS:"
			If CInt(Status) = 1 Then
				Message = Message & wc_Closed& vbCRLF
			ElseIf CInt(Status) = 0 Then
				Message = Message & wc_Open_Active & vbCRLF
			ElseIf CInt(Status) = 2 Then
				Message = Message & wc_Open_Waiting & vbCRLF
			ElseIf CInt(Status) = 3 Then
				Message = Message & wc_Open_on_hold & vbCRLF
			End If

			Message = Message & wc_Priority_capital_letters & PriorityText & vbCRLF


			Message = Message & wc_Customer_ID_capital_letters & Customer_ID & vbCRLF
			Message = Message & wc_Company_Capitals & ": " & CustomerCompany & vbCRLF

			Message = Message & wc_Phone_numbers_capital_letters & CustomerPhone1 & "/" & CustomerPhone2 & vbCRLF

			Message = Message & wc_Case_description_capital_letters & Case_One_Line & vbCRLF

			Message = Message & CategoryText ' Display category text

			' The special color codes have to be removed before sending the case_history

			Case_Text = Case_History
			Case_History = CleanUpHistoryText(Case_Text)
			Message = Message & Case_History & vbCRLF

			If Case_Summary <> "" Then
				Message = Message & wc_Case_summary_head & vbCRLF & Case_Summary & vbCRLF
			End IF
			If Case_Resolution <> "" Then
				Message = Message & wc_Case_Resolution_head	 & vbCRLF & Case_Resolution & vbCRLF
			End If


			' Old Subject Line
	'		SubjectLine = "Group Alert For Case " & Case_Number

		' *************User Customizations *************************
		' Customer Email Subject Line Customizations
		' **********************************************************

		' You can change the Subject line if necessary

		'There are three subject lines
		' (1) One for Newly Open cases by tech
		' (2) One for updating but not closed cases
		' (3) One for Closed cases

		If CaseType = "NEW" Then
			SubjectLine = "Group Alert For Case " & Case_Number & " -- " & Case_One_Line & " -- " & wc_Opened
		End IF

		If Status = 1 and CaseType <> "NEW" Then
			SubjectLine = "Group Alert For Case " & Case_Number  & " -- " & Case_One_Line & " -- " & wc_Closed
		End If

		If (Status <> 1) and CaseType <> "NEW" Then
			SubjectLine = "Group Alert For Case " & Case_Number  & " -- " & Case_One_Line & " -- " & "Update"
		End If



		' Now see if there are any techs configured for this group that have
		' configured email notification


		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN ' Open the connection once here

			mySQL2="SELECT * from Groups where Group_Number = " & Group_Number &" AND New_Case_Notify = 1"
			set rstemp2=conntemp.execute(mySQL2)

			' Check to see if any records are returned
			' if none found the
			if rstemp2.EOF then
				ToEmail = "" ' No body is configured
			Else
			' Loop through all of the entries and send email to each of them
			' each for the one where the tech_id is the same as the assigned tech.

			Do While rstemp2.EOF <> True
				' For each tech, we will have to get their email address
				Tech_ID = rstemp2("tech_id")
				Group_Tech_ID = Tech_ID

if Tech_ID <> AssignedTechID or TechEmailSent = 0 then  ' CMB 05/04/2011
				' Now get the email for each tech_id

				mySQL3="SELECT * from Tech_staff where Tech_ID = '" & Tech_ID & "'"
				set rstemp3=conntemp.execute(mySQL3)

				' Check to see if any records are returned
				' if none found the
				if rstemp3.EOF then
					ToEmail = ""
				Else
					ToEmail = rstemp3("work_email")
					ToFullName = rstemp3("first_name") & " " & rstemp3("last_name")
					CellEmail = rstemp3("Home_Email")
					TechTxtNumber = rstemp3("Work_Phone2") ' Text Message number
					SendTXTWhenAssignedToTech = rstemp3("SendTXTWhenAssignedToTech")
					SendTXTWhenAssignedToGroup = rstemp3("SendTXTWhenAssignedToGroup")

					If IsNull(rstemp3("Home_Email")) Then
						CellEmail = ""
					End If

					' *** Important note about Tech staff fields if they are blanked out
					' The Tech staff edit functions do not properly NULL out the
					' the text fields in the database when they are cleared out.
					' They current set the first character to 0 but leave the other
					' characters there so the we can't check for string <> "".
					' The test below checks to see if the first characters is ASC "0"
					' ***************************************
					If Len(CellEmail) > 0 Then
						If ASC(Mid(CellEmail,1,1)) = 0 Then
							CellEmail = ""
						End IF
					End IF

					CellFullName = ToFullName

				End If

				rstemp3.close
				set rstemp3=nothing

				' Part of the message is a web link for the tech to directly log back
				' into the Tech+Center and go directly to the case.  The link here must
				' have the Tech_ID for the person who we are sending the email to
				' so it is changed for each tech for who this email is sent.

				FixedMessage = ""

				FixedMessage = Message

				TotalTxtMessage = "" ' Reset old one

				TotalTxtMessage = FixedMessage


				TotalTxtMessage = FixedMessage & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF
				'-------create the URL link with obfuscted user ID in it -----------
				CaseLink = "http://" &  hostname & Virtual_path & "?MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Tech_ID))

				TotalTxtMessage = TotalTxtMessage &  CaseLink

				TotalTxtMessage = TotalTxtMessage & EmailChecksum


				If HTMLEmail = "YES" Then

					NotificationReportTitle = wc_Notification_Report_Assigned_Group_update

					AltBody = TotalTxtMessage ' First save Text message into separate variable
					FullMessage = CreateHTMLTechMsg(Case_Number, CaseLink, NotificationReportTitle)


					' DEBUGGING - Remove comment to view the HTML message on the browser
					'response.write FullMessage
				'	response.flush
				'	response.end



				Else ' Option to not send HTML emails.


					FullMessage = TotalTxtMessage

				End IF

				' Send out the email if an email address exists
				If ToEmail <> "" AND LoginTech_ID <> Group_Tech_ID   Then
					  If MyOS = "Windows" Then
						SendEmail ToEmail, ToFullName, SubjectLine, FullMessage
					  Else
						 SendLinuxEmail ToEmail, ToFullName,  SubjectLine, FullMessage
					  End If
					Group_Notification = Group_Notification & "<Br><I>" & ToFullName & "</i>(" & ToEmail & ")"

				End If



	If Version8point0 = "YES" And SendTXTWhenAssignedToGroup  Then

	' Txt Messaging code to send Txt Message to Assigned Tech
	' USER CUSTOMIZATION FOR TXT MESSAGES
	' Customize the Cell TXT message below if you wish to send out different text messages.
	' The TXT messaging system can only send out 150 characters maximum at one time.

		CellMessage = ""
		CellMessage = CellMessage & CustomerFullName & vbCRLF & "(" & CustomerCompany & ")" & vbCRLF
		CellMessage = CellMessage & "PH:" & CustomerPhone1 & vbCRLF  & "CELL:" & CustomerPhone2  & vbCRLF
		CellMessage = CellMessage & "->" & Case_One_Line & vbCRLF

		TechTxtMessage = CellMessage
		TechTxtMessage = Left( TechTxtMessage, 150)

		SendTxtMessage TechTxtNumber, TechTxtMessage

	End If




				' Send out emails to techs cell email address

				If CellEmail <> "" AND LoginTech_ID <> Group_Tech_ID AND CELLPHONE_EMAIL_NOTIFICATION = "YES"  Then

				' *************** User customizations *********************
				' This section below allows one to configure disabling cell emails
				' sent during certain hours. This is option can be configured by
				' un-commenting the lines below

				'LimitCellEmailHours = "YES"

					If LimitCellEmailHours = "YES" Then
						' The code below will limit cell emails sent between 7 AM and 5 PM
						StartLimitHour = 7 ' 24 hour time for 7 AM
						EndLimitHour = 17 ' 24 hour time for 5 PM

						If (Hour(Now) >= StartLimitHour) AND (Hour(Now) < EndLimitHour) Then
							' If in this range then do not send cell email
						Else ' outside of this range then send cell email
							  If MyOS = "Windows" Then
								SendEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
							  Else
								SendLinuxEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
							  End If

							Group_Notification = Group_Notification & " Cell:(" & CellEmail & ")"
						End If

					Else
					  If MyOS = "Windows" Then
						SendEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
					  Else
					    SendLinuxEmail CellEmail,  CellFullName, CellSubjectLine, CellMessage
					  End If

						Group_Notification = Group_Notification & " Cell:(" & CellEmail & ")"

					End IF


				End If

				' Add some message why we didn't send group to assigned tech
				If LoginTech_ID = Group_Tech_ID Then
					Group_Notification = Group_Notification & "<Br><I>" & ToFullName & "</i>(" & ToEmail & ")- " & wc_No_message_sent
				End IF
End IF ' CMB 05/04/2011
				rstemp2.MoveNext

			Loop

			End If

			rstemp2.close
			set rstemp2=nothing

			conntemp.close ' Close the connection
			set conntemp=nothing


End Sub ' End of SendEmailToAssignedGroupTechs() subroutine
%>

<% Sub SendEmailToCustomerAssignedTechs(Case_Number , Tech_Assigned_Email)
	'	This subroutine sends out a notification email to any tech that are
	' configured with the default group or assigned group.  Check to see if any of those techs have already been sent
	' an email from the SendEmailToAssignedTech() function

	' Set Group_Notification to blank
	 CustomerAssignedTech_Notification = ""


	' First we need to get the Group Number assigned for this case

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL2="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1
			Tech_ID = ""

		Else
			' Get all of the information while we are here

			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Tech_ID = rstemp2("Tech_ID")
			Group_Number = rstemp2("Group_Number")
			Customer_ID = rstemp2("Customer_ID")

			PriorityID = rstemp2("Severity")

			' Perform another query to get the Priority text
			mySQL4="SELECT * from Priority where PriorityID = " & PriorityID
			set rstemp4=conntemp.execute(mySQL4)

			PriorityText = rstemp4("ShortDesc")
			' Close record set

			rstemp4.close
			set rstemp4 = nothing


			'******* CELL PHONE EMAIL TEXT FIELDS *****************************
			' Perform another query to get the customer information so
			' it can be displayed in the email for text page cell phone email
			' We will grab the two phone numbers and company name

			mySQL4="SELECT * from Customers where customer_id = '" & Customer_ID & "'"
			set rstemp4=conntemp.execute(mySQL4)


			CustomerCompany = rstemp4("Company")
			CustomerPhone1 = rstemp4("Phone1")
			CustomerPhone2 = rstemp4("Phone2")


			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			'********** CELL PHONE EMAIL TEXT FIELD ENDING


			' Perform another query to get the Assigned Tech Name
			If Tech_ID <> "" Then

				mySQL4="SELECT * from Tech_staff where Tech_ID = '" & Tech_ID & "'"
				set rstemp4=conntemp.execute(mySQL4)

				AssignedTechName = rstemp4("First_Name") & " " & rstemp4("Last_Name")
				' Close record set

				rstemp4.close
				set rstemp4 = nothing
			End If


		End If

		rstemp2.close
		set rstemp2=nothing

		conntemp.close ' Close the connection since we may not open it again
		set conntemp=nothing

		' Now build the message since we may need to send it to more than one person

			'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************
			' To enable a short condensed email to be sent to a tech cell email address/home email
			' beginning of the email message, comment/uncomment the
			' variable definition below
			CELLPHONE_EMAIL_NOTIFICATION = "YES" ' Comment out this line to disable
			'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************

			If CELLPHONE_EMAIL_NOTIFICATION = "YES" Then
				CellMessage = ""
				CellMessage = CellMessage & Customer_ID & vbCRLF & CustomerCompany & vbCRLF &vbCRLF
				CellMessage = CellMessage & CustomerPhone1 & vbCRLF  & CustomerPhone2  & vbCRLF
				CellMessage = CellMessage & "->" & Case_One_Line & vbCRLF
				CellSubjectLine = wc_ALERT
			End If



			' Now Build the Whole message body
			' *********************** USER CUSTOMIZATIONS**********************
			' The fix part of the message that is sent out can be modified by
			' changing the text below.

			Message = ""


			Message = Message & vbCRLF & wc_CASE & " " & case_number & " " & wc_Update_Group_Notification & vbCRLF
			Message = Message & vbCRLF & wc_Tech_assignment & AssignedTechName & vbCRLF

			Message = Message & wc_Case_Number_capital_letters & Case_Number & vbCRLF

				' Now display a link directly to the tech+center for that case window.

				' Get the full server http URL for the direct LINK.
			 For each key in Request.serverVariables

			 	if Key = "SERVER_NAME" Then
					HostName =  Request.ServerVariables(key)
				End IF

			 	if Key = "SCRIPT_NAME" Then
					SCRIPT_Name =  Request.ServerVariables(key)
					' Replace DoEmailListSend.asp with RemoveFromList.asp
					' This will handle all of the necessary virtual directory mappings

					Virtual_Path = replace(Script_Name, "DoTCaseForm.asp", "SC.asp")

				End IF

			Next



			Message = Message & "CASE STATUS:"
			If CInt(Status) = 1 Then
				Message = Message & wc_Closed& vbCRLF
			ElseIf CInt(Status) = 0 Then
				Message = Message & wc_Open_Active & vbCRLF
			ElseIf CInt(Status) = 2 Then
				Message = Message & wc_Open_Waiting & vbCRLF
			ElseIf CInt(Status) = 3 Then
				Message = Message & wc_Open_on_hold & vbCRLF
			End If

			Message = Message & wc_Priority_capital_letters & PriorityText & vbCRLF


			Message = Message & wc_Customer_ID_capital_letters & Customer_ID & vbCRLF
			Message = Message & wc_Company_Capitals & ": " & CustomerCompany & vbCRLF

			Message = Message & wc_Phone_numbers_capital_letters & CustomerPhone1 & "/" & CustomerPhone2 & vbCRLF

			Message = Message & wc_Case_description_capital_letters & Case_One_Line & vbCRLF

			Message = Message & CategoryText ' Display category text

			' The special color codes have to be removed before sending the case_history

			Case_Text = Case_History
			Case_History = CleanUpHistoryText(Case_Text)
			Message = Message & Case_History & vbCRLF

			If Case_Summary <> "" Then
				Message = Message & wc_Case_summary_head & vbCRLF & Case_Summary & vbCRLF
			End IF
			If Case_Resolution <> "" Then
				Message = Message & wc_Case_Resolution_head	 & vbCRLF & Case_Resolution & vbCRLF
			End If


			' Old Subject Line
		'	SubjectLine = "Group Alert For Case " & Case_Number

		' *************User Customizations *************************
		' Customer Email Subject Line Customizations
		' **********************************************************

		' You can change the Subject line if necessary

		'There are three subject lines
		' (1) One for Newly Open cases by tech
		' (2) One for updating but not closed cases
		' (3) One for Closed cases

		If CaseType = "NEW" Then
			SubjectLine = "Assigned Customer/Tech Alert For Case -- " & Case_One_Line & " -- " &  wc_Opened
		End IF

		If Status = 1 and CaseType <> "NEW" Then
			SubjectLine = "Assigned Customer/Tech  Alert For Case -- " & Case_One_Line & " -- " & wc_Closed
		End If

		If (Status <> 1) and CaseType <> "NEW" Then
			SubjectLine = "Assigned Customer/Tech  Alert For Case -- " & Case_One_Line & " -- " & " - Update"
		End If

		'*****************************************************************

		' IMPORTANT CODE HERE for this subroutine
		' it checks to see if any techs are assigned to this customer in the
		' customertechassignment table.  Multiple techs might be assigned to a single customer



		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN ' Open the connection once here

			mySQL2="SELECT * from customertechassignment where customer_ID = '" & Customer_ID &"'"
			set rstemp2=conntemp.execute(mySQL2)

			'Debugging
			'response.write "MySQL2 = " & mySQL2

			' Check to see if any records are returned
			' if none found the
			if rstemp2.EOF then

				' Debugging
				'response.write "No Customer/Tech Assignments"

				ToEmail = "" ' Nobody is configured
			Else
			' Loop through all of the entries and send email to each of them
			' each for the one where the tech_id is the same as the assigned tech.

			Do While rstemp2.EOF <> True
				' For each tech, we will have to get their email address
				Tech_ID = rstemp2("tech_id")
				Group_Tech_ID = Tech_ID

				' Now get the email for each tech_id

				mySQL3="SELECT * from Tech_staff where Tech_ID = '" & Tech_ID & "'"
				set rstemp3=conntemp.execute(mySQL3)

				' Check to see if any records are returned
				' if none found the
				if rstemp3.EOF then
					ToEmail = ""
				Else
					ToEmail = rstemp3("work_email")
					ToFullName = rstemp3("first_name") & " " & rstemp3("last_name")
					CellEmail = rstemp3("Home_Email")
					If IsNull(rstemp3("Home_Email")) Then
						CellEmail = ""
					End If

					' *** Important note about Tech staff fields if they are blanked out
					' The Tech staff edit functions do not properly NULL out the
					' the text fields in the database when they are cleared out.
					' They current set the first character to 0 but leave the other
					' characters there so the we can't check for string <> "".
					' The test below checks to see if the first characters is ASC "0"
					' ***************************************
					If Len(CellEmail) > 0 Then
						If ASC(Mid(CellEmail,1,1)) = 0 Then
							CellEmail = ""
						End IF
					End IF

					CellFullName = ToFullName

				End If

				rstemp3.close
				set rstemp3=nothing

				' Part of the message is a web link for the tech to directly log back
				' into the Tech+Center and go directly to the case.  The link here must
				' have the Tech_ID for the person who we are sending the email to
				' so it is changed for each tech for who this email is sent.

				FixedMessage = ""

				FixedMessage = Message

				TotalTxtMessage = "" ' Reset old one

				TotalTxtMessage = FixedMessage


				TotalTxtMessage = FixedMessage & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF
				'-------create the URL link with obfuscted user ID in it -----------
				CaseLink = "http://" &  hostname & Virtual_path & "?MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Tech_ID))

				TotalTxtMessage = TotalTxtMessage &  CaseLink

				TotalTxtMessage = TotalTxtMessage & EmailChecksum


				If HTMLEmail = "YES" Then

					'NotificationReportTitle = wc_Notification_Report_Assigned_Group_update
					NotificationReportTitle = "Notification Report for Customer/Tech Assignment update"

					AltBody = TotalTxtMessage ' First save Text message into separate variable
					FullMessage = CreateHTMLTechMsg(Case_Number, CaseLink, NotificationReportTitle)


					' DEBUGGING - Remove comment to view the HTML message on the browser
					'response.write Message


				Else ' Option to not send HTML emails.


					FullMessage = TotalTxtMessage

				End IF

				' Send out the email if an email address exists
				If ToEmail <> "" AND LoginTech_ID <> Group_Tech_ID   Then
					  If MyOS = "Windows" Then
						SendEmail ToEmail, ToFullName, SubjectLine, FullMessage
					  Else
						 SendLinuxEmail ToEmail, ToFullName,  SubjectLine, FullMessage
					  End If

					If CustomerTechAssignment_Notification = wc_none then
							CustomerTechAssignment_Notification = "<Br><I>" & ToFullName & "</i>(" & ToEmail & ")"
					Else
							CustomerTechAssignment_Notification = CustomerTechAssignment_Notification & "<Br><I>" & ToFullName & "</i>(" & ToEmail & ")"
					End If

				End If

				' Send out emails to techs cell email address

				If CellEmail <> "" AND LoginTech_ID <> Group_Tech_ID AND CELLPHONE_EMAIL_NOTIFICATION = "YES"  Then

				' *************** User customizations *********************
				' This section below allows one to configure disabling cell emails
				' sent during certain hours. This is option can be configured by
				' un-commenting the lines below

				'LimitCellEmailHours = "YES"

					If LimitCellEmailHours = "YES" Then
						' The code below will limit cell emails sent between 7 AM and 5 PM
						StartLimitHour = 7 ' 24 hour time for 7 AM
						EndLimitHour = 17 ' 24 hour time for 5 PM

						If (Hour(Now) >= StartLimitHour) AND (Hour(Now) < EndLimitHour) Then
							' If in this range then do not send cell email
						Else ' outside of this range then send cell email
							  If MyOS = "Windows" Then
								SendEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
							  Else
								SendLinuxEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
							  End If

							'CustomerTechAssignment_Notification = CustomerTechAssignment_Notification & " Cell:(" & CellEmail & ")"
						End If

					Else
					  If MyOS = "Windows" Then
						SendEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
					  Else
					    SendLinuxEmail CellEmail,  CellFullName, CellSubjectLine, CellMessage
					  End If

						CustomerTechAssignment_Notification = CustomerTechAssignment_Notification & " Cell:(" & CellEmail & ")"

					End IF


				End If

				' Add some message why we didn't send group to assigned tech
				If LoginTech_ID = Group_Tech_ID Then
					CustomerTechAssignment_Notification = CustomerTechAssignment_Notification & "<Br><I>" & ToFullName & "</i>(" & ToEmail & ")- " & wc_No_message_sent
				End IF

				rstemp2.MoveNext
			Loop

			End If

			rstemp2.close
			set rstemp2=nothing

			conntemp.close ' Close the connection
			set conntemp=nothing


End Sub ' End of SendEmailToCustomerAssignedTechs() subroutine
%>






<% Function CleanUpHistoryTextNew(Case_Text)
' This functions removes all of the special color coding codes
' that exists in the case_history field so when the email is sent it sends
' it without all of those funny colors.


' This subroutines formats the case_text with the proper color coding conventions

NewText = Case_Text
	' Tags entered by the user can be security issue so we will replace
	' them with printable html text of &lt; and & gt;


		' Replace the special color coding characters

		NewText = Replace (Newtext, chr(10), vbCRLF)

		NewText = Replace (NewText, "{g[", "")

		NewText = Replace (NewText, "{r[", "")

		NewText = Replace (NewText, "]r}", "")

		NewText = Replace (NewText, "]g}", "")

'		NewText = Replace (NewText, vbLF, vbCRLF)

		' There are some places where we have put LFCR
		' at the end of the end of the lines in techcenter
'		NewText = Replace (NewText, vbLF & vbCR, vbCRLF)

		' Other places have just LF (10)
'		NewText = Replace (Newtext, vbCR, vbCRLF)

	CleanUpHistoryText = NewText

'	For i = 1 to len(NewText)
'		NewMessage  = NewMessage & mid(NewText,i,1)
'		NewMessage = NewMessage & "[" & asc(mid(NewText,i,1)) & "]"
'	next

'	response.write NewMessage


'	CleanUpHistoryText = Case_Text

End function
%>

<% Function CleanUpHistoryText(Case_Text)
' This functions removes all of the special color coding codes
' that exists in the case_history field so when the email is sent it sends
' it without all of those funny colors.


' This subroutines formats the case_text with the proper color coding conventions

NewText = Case_Text
	' Tags entered by the user can be security issue so we will replace
	' them with printable html text of &lt; and & gt;




' Debugging

'response.write "History Text = " & Case_Text & "<P>"


		' Replace the special color coding characters

		NewText = Replace (Newtext, chr(10), vbCRLF)

		NewText = Replace (NewText, "{g[", "")

		NewText = Replace (NewText, "{r[", "")

		NewText = Replace (NewText, "]r}", "")

		NewText = Replace (NewText, "]g}", "")

'		NewText = Replace (NewText, vbLF, vbCRLF)

		' There are some places where we have put LFCR
		' at the end of the end of the lines in techcenter
		NewText = Replace (NewText, vbLF & vbCR, vbCRLF)

		' Other places have just LF (10)
'		NewText = Replace (Newtext, vbCR, vbCRLF)

		' Other Tests

		' This is the important one to remove extra spaces for the emails!!
		NewText = Replace (Newtext, vbCRLF,"" )


		' Do not use these
'		NewText = Replace (Newtext, "", chr(10))
'		NewText = Replace (NewText, "


	CleanUpHistoryText = NewText

'Debugging


'
'	For i = 1 to len(NewText)'
'		NewMessage  = NewMessage & mid(NewText,i,1)
'		NewMessage = NewMessage & "[" & asc(mid(NewText,i,1)) & "]"
'	next

'	response.write NewMessage


'	CleanUpHistoryText = Case_Text

End function
%>

<% Function GetCasestatus(CaseNumber)
	' This function gets the case status information for existing Cases
	' to see if it is closed or open.  This function returned "OPEN" Or "CLOSED"
		' Now get case information
		set conntemp=server.createobject("adodb.connection")
				conntemp.open myDSN

				mySQL2="SELECT * from Cases where Case_Number = " & CaseNumber

				set rstemp=conntemp.execute(mySQL2)

				' Check to see if any records are returned
				' if none found the

				If rstemp.EOF = True Then
					GetCasestatus = "OPEN" ' Set this variable to prevent problems on next page
				Else
					If rstemp("Status") = 1 Then
						GetCasestatus = "CLOSED"
					Else
						GetCasestatus = "OPEN"
					End IF
				End If

				rstemp.close
				set rstemp=nothing
				conntemp.close ' Close the connection
				set conntemp=nothing

	End Function ' End of GetCasestatus
%>

<% Function TechFullName(Tech_ID)
	'This function gets the full name of the Tech or Sales Contact logged
	'into the system.

		If Tech_ID = "" Then
			TechFullName = "Un-assigned"
		Else

			set conntemp=server.createobject("adodb.connection")
			conntemp.open myDSN ' Open the connection once here

			mySQL2="select * from Tech_staff where tech_id = '" & Tech_id & "'"
			set rstemp2=conntemp.execute(mySQL2)

			' Check to see if any records are returned
			' if none found the
			if rstemp2.EOF then
				TechFullName = "User Not Defined for Tech_ID: " & Tech_id
			Else
				TechFullName = rstemp2("first_name") & " " & rstemp2("Last_name")
			End If

			rstemp2.close
			set rstemp2=nothing
			conntemp.Close
			Set conntemp = nothing

		End If


	End Function ' End of TechFullName
	%>

<% Function GroupFullName(Group_Number)
	'This function gets the full name of the Passed Group Number
		If Group_Number = "" Then
			GroupFullName = "Default Group"
		Else

			set conntemp=server.createobject("adodb.connection")
			conntemp.open myDSN ' Open the connection once here

			mySQL2="select * from Group_list where Group_Number = " & Group_Number
			set rstemp2=conntemp.execute(mySQL2)

			if rstemp2.EOF then
				GroupFullName = "Group Not Defined"
			Else
				GroupFullName = rstemp2("Group_Name")
			End If

			rstemp2.close
			set rstemp2=nothing
			conntemp.Close
			Set conntemp = nothing

		End If

	End Function ' End of GroupFullName
%>

<% Function PriorityFullDescription(Priority_Number)
	'This function gets the full description of the Passed Priority Number
		If Priority_Number  = "" Then
			PriorityFullDescription =  "Priority Not Defined"
		Else

			set conntemp=server.createobject("adodb.connection")
			conntemp.open myDSN ' Open the connection once here

			mySQL2="select * from Priority where PriorityID =  " & Priority_Number
			set rstemp2=conntemp.execute(mySQL2)

			if rstemp2.EOF then
				PriorityFullDescription = "Priority Not Defined"
			Else
				PriorityFullDescription = rstemp2("ShortDesc")
			End If

			rstemp2.close
			set rstemp2=nothing
			conntemp.Close
			Set conntemp = nothing

		End If

	End Function ' End of PriorityFullDescription Function
%>

<% Function CreateCategoryText(Case_Number)
	' This function performs a query of the set Categories and
	' returns a string to be used when sending out the email messages

	mySQL3 = "select * from Cases where case_number = " & Case_Number

	'response.write mySQL3

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN ' Open the connection once here


	set rstemp2=conntemp.execute(mySQL3)


	' Create the category display for this case

	CategoryString = ""
	for i = 1 to 20 ' Increase this beyond 20 if more than 20 Categories
		CategoryItem = CInt(rstemp2("C"&i))
		If CategoryItem <> 0 Then
			' Some category value is set so see if the state of the category
			' equal to one (customer+tech display) and get the category
			' and category item description from the table lookup.

			'mySQL4 = "select * from Categories where category_number = " & i & " AND Item_number = " & CategoryItem & " AND State = 1"

			' Show all categories if not disabled
			mySQL4 = "select * from Categories where category_number = " & i & " AND Item_number = " & CategoryItem & " AND ((State = 2) OR (State = 1))"


			'response.write mySQL4 ' Debugging only

			set rstemp3=conntemp.execute(mySQL4)


			If rstemp3.EOF <> True THEN
				Item_name = rstemp3("Item_name")
				CategoryName = rstemp3("Category_name")

				CategoryString = CategoryString &  "  [" & CategoryName & "==" & Item_Name & "]"
				CategoryString = CategoryString & vbCRLF
				' Close this intermediate record set

			End If

			rstemp3.close
			set rstemp3=nothing
		End If
	next ' Loop through the first 20 Categories

		If CategoryString = "" then
			CategoryString = wc_Categories & ":" & wcNone  & vbCRLF
		Else
			CategoryString = wc_Categories & ":" & vbCRLF & CategoryString
		End If

	CreateCategoryText = CategoryString ' Put function return value


	rstemp2.close
	set rstemp2=nothing

	conntemp.close ' Close the connection
	set conntemp=nothing


 End Function ' CreateCategoryText
%>

<% Function CreateRepeatScheduledCase(Case_Number)
	' This function will open a new scheduled case based on information
	' found in the old case.  It will set the new scheduled
	' date and time to be repeat_interval number of days from the
	' originally scheduled due date.  The following fields will
	' be transferred from the old case to the newly opened case.
	' No emails will be sent.
	' Fields transfered:
		' Case_One_Line
		' Case_Summary
		' Case_Resolution
		' Group_Assignment (Group_Number)
		' Tech Assignment (Tech_ID)
		' Scheduled_Case_Type
		' Repeat_Interval
		' Due_Time
		' Customer_ID
		' Any Category Assignments
		' Priority (Severity)
		' Asset_Number
		' Duplicate_Case_Number

	' Fields recreated dynamically
		' Due Date (Repeat_Interval + Last Due_Date)
		' Open_Date
		' Open_Time
		' Mod_Date
		' Mod_Time
		' Status - Set to Open
		' Case History

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  myDSN

	' Check to see if case_number exists then this is an update


		Set NewRecord = Server.CreateObject("ADODB.Recordset")

			SQL = "Select * from Cases"

		'response.write SQL

		NewRecord.Open SQL,Conn,3,3

			NewRecord.AddNew

			' For new records we fill in the
			' the opendate and open time fields
			' with the following formats:
			' OpenDate: YYYYMMDD

			' OpenTime: HHMMSS

			NewRecord("modified_flag") = 1
			NewRecord("Open_Date") = DateString ' YYYYMMDD
			NewRecord("Open_Time") = TimeString ' HHMMSS
			NewRecord("mod_date") = DateString ' YYYYMMDD
			NewRecord("mod_time") = TimeString ' HHMMSS
			NewRecord("Reopen_Date") = Datestring
			NewRecord("reopen_Time") = TimeString

			NewRecord("Customer_ID") = Customer_ID

			If Version7 = "YES" Then
				If AssetGroup <> "" Then
					NewRecord("AssetGroupIndex") = AssetGroup
				End If
			End IF




			' * * * * * * Schedule Case Fields Processing

			If ScheduleCase <> "" Then
				NewRecord("Scheduled_Case_Type") = ScheduleCase
			End IF

			If RepeatInterval <> "" Then
				NewRecord("Repeat_Interval") = RepeatInterval
			End IF

			' Attempt to create a valid date string and then check to see
			' if the date is valid and if so then set in the Due_Date_Time Date field

			DueDateString = DueMonth & "/" & DueDay & "/" & DueYear
			DueTimeString = DueHour & ":" & DueMinute & DueAMPM

			' Check for a valid date string and reset to blank if not valid

			IF IsDate(DueDateString) = False Then
				DueDateString = "" ' Do not accept DueDateString
			End If

			' Now we must add the Repeat Interval to the due_date
			' to create a new due date


			If DueDateString <> "" and RepeatInterval <> "" Then
				New_Due_Date = DateAdd("d", RepeatInterval, DueDateString)
			End If


			If IsDate(New_Due_Date) = True Then ' verify valid new date
				NewRecord("Due_Date") = New_Due_Date
			End IF

			' Keep the same Due Time
			'response.write "Due_time= " & DueTimeString
			If DueTimeString <> "" and trim(duetimestring) <> ":" Then ' DueTimeString should be HH:MM AM formats cmb 04/14/11
				NewRecord("Due_Time") = DueTimeString
			End If




			' * * * * * * End Schedule Case Fields processing


			' Now Add in any info about changed records for Tech, Status, group and Priority
			Old_Group_Number = NewRecord("Group_Number")
			If IsNull(Old_Group_Number) Then
				Old_Group_Number = ""
			Else
				Old_Group_Number = CStr(Old_Group_Number)
			End If
			If Old_Group_Number <> Group_Number_from_Form then
				NewGroupName = GroupFullName(Group_Number_From_Form)
				GroupChanged = "YES"
				Repeat_History = Repeat_History &  wc_CASE_ASSIGNED_TO_GROUP  & NewGroupName & vbCRLF
			End IF


			Old_Tech_ID = NewRecord("Tech_ID")
			If Old_Tech_ID <> AssignedTechID then

				NewTechName = TechFullName(AssignedTechID)
				TechChanged = "YES"

				Repeat_History = Repeat_History &  wc_CASE_ASSIGNED_TO_TECH & NewTechName & vbCRLF
			End IF


			Old_Priority = "0"

			If Old_Priority <> Case_Severity then
				NewPriority = PriorityFullDescription(Case_Severity)

				Repeat_History = Repeat_History & wc_CASE_Priority_SET_TO & NewPriority & vbCRLF
			End IF


			If Dup_case_Num  = "" Then
				NewRecord("Dup_case_num") = 0
			Else
				NewRecord("Dup_case_num") = Dup_Case_Num
			End If

			' Set status to undefined for this new record
			NewRecord("Status") = 0 ' Reset status back to undefined

			If Case_Severity = "" Then
				NewRecord("Severity") = 0 ' Set back to 0 (un-assigned)
			Else
				NewRecord("Severity") = Case_Severity
			End IF

			NewRecord("Case_One_Line") = Case_One_Line
			If Asset_Number = "" Then
				NewRecord("Asset_Number") = 0 ' Default to zero
			Else
				NewRecord("Asset_Number") = Asset_Number
			End If

			NewRecord("Category_Count") = 100 ' Default to 100

			' Add tech assignment

			If AssignedTechID <> "" Then
				NewRecord("tech_ID") = AssignedTechID
			Else ' Set back to null if undefined
				NewRecord("Tech_ID") = Null
			End If

			' Read and set all of the Categories that have come in

			For i = 1 to 50 ' Increase this up to 100 if necessary

				CategoryColumn = "C" & i
				CategoryValue = Request.form(CategoryColumn)

				If CategoryValue = "" OR IsNumeric(CategoryValue) = False Then
					CategoryValue = 0

				Else ' Value must be set so check if this defines a default group
					Category_Number = i
					Category_Item = CategoryValue
					' Perform small query to see if initial group assignment is set
					' for this category

					mySQL5="SELECT * from Categories where Category_Number = " & Category_Number & " AND Item_number = " & Category_Item

					'Response.write "SQL=" & mySQL5

					set rstemp5=conn.execute(mySQL5)

					if rstemp5.EOF then
						' This should not happen but ok
					Else
						Group_Number = rstemp5("Group_Number")
						If Group_Number <> "" Then
							NewDefaultGroup = Group_Number
						End IF

					End IF

					rstemp5.close
					set rstemp5=nothing

				End If
				NewRecord(CategoryColumn) = CategoryValue
			Next

			'* * * * * * * * * * * * * * * * * * * * *
			' Default Group Setting ******************
			' * * * * * * * * * * * * * * * * * * * * *
			' The initial setting of the default group can now be set by
			' a selected category and selecting a category item.
			' This can all be configured under system administration options
			' If category group is not enabled or if no category
			' item is selected, it then reverts to the original defaultGroup
			' This assignment is only done during the initial case creation.
			' For the Techs, any group assignment done directly by the
			' tech overrides the category group selection.

			If NewDefaultGroup <> "" Then
				DefaultGroupNumber = NewDefaultGroup ' Over with category group
			End IF

			'If Group_Number = "" Then set to the default group otherwise set to the passed group
			IF Group_Number_From_Form = "" Then
				NewRecord("Group_Number") = DefaultGroupNumber ' Categories or default
			Else
				NewRecord("Group_Number") = Group_Number_From_Form ' Group re-assigned
			End IF

			' Time Stamp the Case History before we put it into the case record

			Case_History = "{r[" &  DatetimeString &  wc_Repeat_Scheduled_Case_Opened_by_Scheduler & " ]r}"  & vbCRLF & Repeat_History

			' We need to check the size of the case_history before we put it
			' into the record

			If Len(Case_History) < (MaxHistorySize - 10) Then ' Only update is size is ok.
				NewRecord("Case_History") = Case_History
			Else
				Response.Write wc_Case_History_size_of & Len(Case_History)& wc_exceeds_maximum_value_of & MaxHistorySize - 10 & "<br>"
			End If

			' Update Summary and Resolution Fields
			' Limit the size based on the max case resolution and summary sizes

			NewRecord("Case_Resolution") = Mid(Case_Resolution, 1, MaxResolutionSize - 5)
			NewRecord("Case_Summary") = Mid(Case_Summary, 1, MaxSummarySize - 5)

		NewRecord.Update

	If  err.number>0 then
	      response.write "VBScript Errors Occured:" & "<P>"
	      response.write "Error Number=" & err.number & "<P>"
	      response.write "Error Descr.=" & err.description & "<P>"
	      response.write "Help Context=" & err.helpcontext & "<P>"
	      response.write "Help Path=" & err.helppath & "<P>"
	      response.write "Native Error=" & err.nativeerror & "<P>"
	      response.write "Source=" & err.source & "<P>"
	      response.write "SQLState=" & err.sqlstate & "<P>"
	else
	'      response.write "No VBScript Errors Occured" & "<P>"
	end if


	IF  conn.errors.count> 0 then
	    response.write "Database Errors Occured" & "<P>"
		for counter= 0 to conn.errors.count
		      response.write "Error #" & conn.errors(counter).number & "<P>"
		      response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
		next
	else
	      'response.write "No Database Errors Occured!" & "<P>"
	end if

	NewRecord.Close
	Set NewRecord = Nothing

	Conn.Close
	Set Conn = Nothing

	End Function
%>

<% Sub ProcessTimeSpentEntry(Case_number, TimeSpentTech_ID, TimeSpentDate, TimeSpentDateDay, TimeSpentDateMonth, TimeSpentDateYear, TimeSpentBillable, TimeSpentHours, TimeSpentHourlyRate, TimeSpentNotes, TimeSpentInspectorID)

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  myDSN


		Set NewRecord = Server.CreateObject("ADODB.Recordset")

			SQL = "Select * from TimeSpent"
			'response.write SQL

			NewRecord.Open SQL,Conn,3,3

			NewRecord.AddNew


		' Set all of the variables the same for either new/update

		' Get the values from the form elements into variables by the same name

		' Get the case number from above for existing or new case.

		NewRecord("case_number") = case_number

		If TimeSpentTech_ID <> "" or TimeSpentTech_ID <> Null Then
			NewRecord("Tech_ID") = TimeSpentTech_ID
		End If


		If (TimeSpentDateDay <> "" AND TimeSpentDateMonth <> "" And TimeSpentDateYear <> "" ) OR TimeSpentDate <> Null Then

			' Always insert into the database in US format for Access

		' IF UK format, and SQL, then we need to insert the date in UK formats and not US formats

			'CHANGED 02/20/12 for UK people Access - CDate was screwing things up;

		 ' If DateDisplayFormat = "DDMMYYYY" AND DatabaseType = "SQLSERVER" Then  ' UK format - stored in UK or US format
				'TimeSpentDate = TimeSpentDateDay & "/" & TimeSpentDateMonth & "/" & TimeSpentDateYear
		 ' Else
				'TimeSpentDate = TimeSpentDateMonth & "/" & TimeSpentDateDay & "/" & TimeSpentDateYear
		  'End If

		'	NewRecord("Invoice_Date") = CDate(TimeSpentDate) ' 10/5/11 added cdate because sqlserver was storing it wrong!

		  If DateDisplayFormat = "DDMMYYYY" then  'AND DatabaseType = "SQLSERVER" Then  ' UK format - stored in UK or US format
				TimeSpentDate = TimeSpentDateDay & "/" & TimeSpentDateMonth & "/" & TimeSpentDateYear
				NewRecord("Invoice_Date") = CDate(TimeSpentDate) ' 10/5/11 added cdate because sqlserver was storing it wrong!
		  Else
				TimeSpentDate = TimeSpentDateMonth & "/" & TimeSpentDateDay & "/" & TimeSpentDateYear
				NewRecord("Invoice_Date") = TimeSpentDate
		  End If


		End If


		If TimeSpentBillable <> "YES"  Then
			NewRecord("Billable") = False
		Else
			NewRecord("Billable") = True

		End If

		' Important Fix - January 31, 2006
		'The HourlyRate and Hours can not be null.. they should default to Zero


NewRecord("Hours") = TimeSpentHours

		If TimeSpentNotes <> "" or TimeSpentNotes <> Null Then
			NewRecord("TimeSpentNote") = TimeSpentNotes
		End If

		If TimeSpentHourlyRate <> "" or TimeSpentHourlyRate <> Null Then
			'NewRecord("HourlyRate") = TimeSpentHourlyRate
		Else
			NewRecord("HourlyRate") = 0

		End If

		NewRecord("Inspector") = TimeSpentInspectorID

		NewRecord.Update


	NewRecord.Close

	Conn.Close

	Set NewRecord = Nothing




  End Sub

%>



<%

' -------------------------------------------------------------------

Function Obfuscate(Mystring)

seedx = Timer()
' response.write "seedx is " & seedx & "<P>"
If Instr(seedx,".") Then
 aryseed = split(seedx,".")
 seed = Cdbl(aryseed(0)) + Cdbl(aryseed(1))
Else
 seed = 12345
End If



'response.write "seed is " & seed & "<P>"

Randomize(seed)
' response.write  " and seed is " & seed & "<br>"


strlength = Len(Mystring)

'response.write "The string is " & Mystring & " which has length of " & strlength & "<BR>"


Dim Arystring(80)


fuse = 0

  ' put in initial population

  For I = 0 to Strlength - 1
      Arystring(I) = PickOne(Strlength)
  Next

  Valid = "No"

While Valid = "No"
	 Valid = "Yes"
	 'response.write "--------------------------------BREAK----------------------------------<p>"
	 For I = 0 to Strlength - 1
	   For J = 0 to I
		 If I <> J Then ' dont compare with self
			  'response.write " comparing pos " & I & " which contains " & Arystring(I) & " with pos " & J & " which contains " & Arystring(J) & "<BR>"
			  if Arystring(I) = Arystring(J) Then
			     Valid = "No"
			     ' response.write "Dup found<br>"
			     Arystring(I) = PickOne(Strlength)
			  end if
			  fuse= fuse + 1
			  if fuse > 30000 Then
						response.write "----------------abort----------"
						response.flush
						response.end
			  End if
		End If
	   Next

	 Next
Wend



Arystring(Strlength) = (Strlength) ' Plant the length
'response.write "-----------Length set in pos " & Strlength & "<BR>"


For I = 0 to Strlength - 1 ' now that we have position vectors in place, plant the secret message
	 offset = Arystring(I)

	 ThisChar = Mid(MyString,I+1,1)
	 ThisChar = Asc(ThisChar) - 48
	 Arystring(offset) = ThisChar
	 'response.write "Planting " & ThisChar & " in position " & Offset & " which is " & Chr(ThisChar+48) & "<BR>"
Next

' Now fill in the empties with random values


	for i = 0 to 79
		 if Arystring(i) = "" Then
		   Arystring(i) = Int(Rnd()*78) + 1
		 End if
	next


Target = "" ' and now we add 48 to each element
for i = 0 to 79
	 if Arystring(i) <> "" Then
		'response.write "String pos " & i & " is " & Arystring(i) & " which maps to " & Arystring(i)+48 & " which is the character " & Chr(Arystring(i)+48) & "<br>"
	 else
		'response.write "String pos " & i & " is " & "&#920;<br>"
	 End if
	 Target = Target & Chr(Arystring(i)+48)
Next

Obfuscate = Target

End Function

%>


<%

' -------------------------------------------------------------------
Function PickOne(MinVal)
  candidate = Int(Rnd()*78) + 1
  TooLow = "Yes"
  While TooLow = "Yes"
	  If candidate <= MinVal Then
		'response.write "Candidate " & candidate & " is Too Low<br>"
		candidate = Int(Rnd()*78) + 1
	  Else
		TooLow = "No"
	  End If
  Wend

  PickOne = candidate
End Function

%>

<% Function GetCategoryNameAndItem(CategoryNumber, CategoryItem)
	' This function gets passed the category number and category item and returns
	' a formatted string with it.


	set conntemp5=server.createobject("adodb.connection")
	conntemp5.open myDSN ' Open the connection once here


			mySQL4 = "select * from Categories where category_number = " & CategoryNumber & " AND Item_number = " & CategoryItem


			'response.write mySQL4 ' Debugging only

			set rstemp8=conntemp5.execute(mySQL4)


			If rstemp8.EOF <> True THEN
				Item_name = rstemp8("Item_name")
				CategoryName = rstemp8("Category_name")

				CategoryString = CategoryString &  "  [" & CategoryName & "==" & Item_Name & "]"
				'CategoryString = CategoryString & vbCRLF
				' Close this intermediate record set

			End If

			rstemp8.close
			set rstemp8=nothing


		'If CategoryString = ""  then
		'	CategoryString =  wcNone
		'End If




	conntemp5.close ' Close the connection
	set conntemp5=nothing


GetCategoryNameAndITem = CategoryString

End Function
%>

<%
Function ComputeHourDifference(open_time, open_date, mod_Time, mod_date)


			FormattedOpenDate = mid(Open_Date,5,2) & "/" & mid(Open_Date,7,2) & "/" & mid(Open_Date,1,4)
			' Now we need to add the time as well to that string as hh:mm
			FormattedOpenTime = mid(Open_Time,1,2) & ":" & mid(Open_Time,3,2)
			FormattedOpenDateTime = FormattedOpenDate & " " & formattedOpenTime

			CurrentDate = FormatDateTime( Date, vbGeneralDate)
			' Now put this OpenDate format into a format that the DateDiff() function
			' can work with converting from YYYYMMDD to mm/dd/yyyy

			FormattedModDate = mid(Mod_Date,5,2) & "/" & mid(Mod_Date,7,2) & "/" & mid(mod_Date,1,4)
			' Now we need to add the time as well to that string as hh:mm
			FormattedModTime = mid(Mod_Time,1,2) & ":" & mid(Mod_Time,3,2)
			FormattedDateTime = FormattedModDate & " " & formattedModTime

			MinutesDiff = DateDiff("n", FormattedOpenDateTime, FormattedDatetime )
			'response.write "Now=" & Now()
			'response.write "FormattedDateTime = " & FormattedDatetime
			'response.write "Minutes Difference = " & MinutesDiff

			ComputeHourDifference = MinutesDiff/60

		' Debugging
		'response.write "Open_time = " & open_time & " Open Date = " & Open_Date
		'response.write "mod_time = " & mod_time & " mod Date = " & mod_Date
		'response.write "Hour Difference = " & ComputeHourDifference




 End Function

%>

<% Sub 	ProcessExpenseEntry ( case_number,ExpenseTech_ID, ExpenseDateDay, ExpenseDateMonth, ExpenseDateYear, Quantity,  Description, cost, TaxRatePercent)

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  myDSN


		Set NewRecord = Server.CreateObject("ADODB.Recordset")

			SQL = "Select * from Expenses"
			'response.write SQL

			NewRecord.Open SQL,Conn,3,3

			NewRecord.AddNew


		' Set all of the variables the same for either new/update

		' Get the values from the form elements into variables by the same name

		' Get the case number from above for existing or new case.

		NewRecord("case_number") = case_number

		If ExpenseTech_ID <> "" or ExpenseTech_ID <> Null Then
			NewRecord("Tech_ID") = ExpenseTech_ID
		End If


		If (ExpenseDateDay <> "" AND ExpenseDateMonth <> "" And ExpenseDateYear <> "" ) OR ExpenseDate <> Null Then

			' Always insert into the database in US format for Access

			' 02/20/12	ExpenseDate = ExpenseDateMonth & "/" & ExpenseDateDay & "/" & ExpenseDateYear

			 If DateDisplayFormat = "DDMMYYYY" then ' AND DatabaseType = "SQLSERVER" Then  ' UK format - stored in UK or US format
					ExpenseDate = ExpenseDateDay & "/" & ExpenseDateMonth & "/" & ExpenseDateYear
					NewRecord("ExpenseDate") = CDate(ExpenseDate) ' 10/5/11 added cdate because sqlserver was storing it wrong!
			  Else
					ExpenseDate = ExpenseDateMonth & "/" & ExpenseDateDay & "/" & ExpenseDateYear
					NewRecord("ExpenseDate") = ExpenseDate
			  End If
				'response.write ExpenseDate
				'response.flush
				'response.end


			'NewRecord("ExpenseDate") = CDate(ExpenseDate)
		End If


		If Quantity <> ""  Then
			NewRecord("Quantity") = Quantity
		Else
			NewRecord("Quantity") = Null
		End If


		If Cost <> ""  Then
			NewRecord("Cost") = Cost
		Else
			NewRecord("Cost") = Null
		End If

		If Description <> ""  Then
			NewRecord("Description") = Description
		Else
			NewRecord("Description") = Null ' CMB fixed
		End If


		If TaxRatePercent <> ""  Then
			NewRecord("TaxRatePercent") = TaxRatePercent
		Else
			NewRecord("TaxRatePercent") = Null
		End If


		NewRecord.Update


	NewRecord.Close

	Conn.Close

	Set NewRecord = Nothing




  End Sub

%>

<% Function GetCustomerID(ID)
			Set Conn2 = Server.CreateObject("ADODB.Connection")
			conn2.open  myDSN

			Set NewRecord = Server.CreateObject("ADODB.Recordset")
			SQL = "Select Customer_ID from AdditionalCustomerCaseAssignments where CustomerCaseAssignmentIndex = " & ID
			NewRecord.Open SQL,Conn2,3,3
			if NewRecord.eof  then
				GetCustomerID = 0
			else
				GetCustomerID = NewRecord("customer_ID")
			End If

			NewRecord.Close
			Set NewRecord = Nothing
			Conn2.Close
End Function
%>
