<% 'Module: EditStaffMember.asp

   'Description: This module is the Page that enables editing of Staff Member Details
   'This program expects at least one parameter to be passed to it on the URL when it
   'is invoked - namely "techid". The value of this parameter is used to select which
   'staff member is read up and displayed - and possible eventually edited. If this
   'parameter is not present or specifies an empty string, then a new record will be created.

   'example format of calling URL: EditStaffMember.asp?techid=css-1000


   '(C) 2000, 2001, 2002 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------	    ---		------------------------------------------------
   '08/06/02	 JC		Created original ASP version based on previous dll? version
   '02/28/13	SAV		Added sort for group_name when showing techs group assignments
   '12/2/13    CMB      Customer survey results
'GLOBALS
Dim DatabaseType
Dim Tech_ID


%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<%' Include this file for special database cursor constants %>


<%' Get the Internationalisation File %>

<!-- #INCLUDE FILE="../Language/wcLabelsAdmin.inc" -->
<!-- #INCLUDE FILE="../Language/CodeCustomizations.inc" -->



<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 5

	CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN") ' Get the Logged TechID from the cookie

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="SELECT * from Tech_staff where Tech_ID = '" & CookieID & "' AND Tech_Level >= " & TechLevel
		set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF <> True Then
			ValidUser = "YES" ' Set this variable to prevent problems on next page
			this_user_level = rstemp("tech_level")
		End If

		rstemp.close
		set rstemp=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing

 ' End of ASP page security checks
 %>


<% if ValidUser <> "YES" Then %>
	<% ASPPage = "EditConfiguration.asp"%>

	<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function %>


<% GetDatabaseConfiguration ts_user_page_color, Assets_db, customer_Drop_Down %>

<%
' Pick up the techid from the URL of From Variable as appropriate

If Request.querystring("techid") <> "" Then
     tech_id = Request.querystring("techid")
Else
     tech_id = Request.Form("techid")
End If

if tech_id <> "" Then
   mode="update"
'  Get this members values from the tech_staff table and into variables

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Tech_staff where tech_id = '" & tech_id & "'"
    'response.write mySQL
    'response.flush
    'response.end
	set rstemp=conntemp.execute(mySQL)

	If rstemp.EOF = True  Then
		Response.write "No record found for this tech ID"
	Else

		' Get the values from the table

        first_name = rstemp("first_name")
        last_name = rstemp("last_name")
        home_address = rstemp("home_address")
        home_city = rstemp("home_city")
        home_state = rstemp("home_state")
        home_zip = rstemp("home_zip")
        home_email = rstemp("home_email")
        home_phone = rstemp("home_phone")
        home_fax = rstemp("home_fax")
        department = rstemp("department")
        mailstop = rstemp("mailstop")
        work_email = rstemp("work_email")
        work_phone1 = rstemp("work_phone1")
        work_phone2 = rstemp("work_phone2")
        work_fax = rstemp("work_fax")
        current_customer_id = rstemp("current_customer_id")
        tech_password = rstemp("tech_password")
        tech_level = rstemp("tech_level")
        show_dispatch_flag = rstemp("show_dispatch_flag")
        new_case_notify = rstemp("new_case_notify")
        notes = rstemp("notes")

        ' Version 8

        SendTxtWhenAssignedToTech = rstemp("SendTXTWhenAssignedToTech")
        SendTxtWhenAssignedToGroup = rstemp("SendTXTWhenAssignedToGroup")


	End If

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing
else  ' we need to create a new record for a tech
        mode="new"
       'set empty or default values

        tech_id = ""
        first_name = ""
        last_name = ""
        home_address = ""
        home_city = ""
        home_state = ""
        home_zip = ""
        home_email = ""
        home_phone = ""
        home_fax = ""
        department = ""
        mailstop = ""
        work_email = ""
        work_phone1 = ""
        work_phone2 = ""
        work_fax = ""
        current_customer_id = ""
        tech_password = "dummy"
        tech_level = "2"
        show_dispatch_flag = "0"
        new_case_notify = "0"
        notes = ""
        SendTXTWhenAssignedToTech = "0"
        SentTXTWhenAssignedToGroup = "0"


end if ' if there was (not) an existing tech_id to be processed
%>

<html>
<!-- (C) 1996,1997, 1998, 1999, 2000, 2001, 2002 by Internet Software Sciences -->

<head>
<title>Staff Member Information - CSS</title>
</head>
<body bgcolor=#<%=ts_User_Page_Color%>>
<center>
<table border=1 cellspacing=2 cellpadding=10 width=98%>
<tr>
  <td align=center>
  <font size=+1><b><%=wc_Staff_Member_Information%></b></font>
      <%

      if request.querystring("status") = "yes" Then
           response.write "<font color=red > &nbsp; " & wc_Update_confirmed & "</font>"
         end if
        %>
   <br>
  </td>
  <td align=center valign=center>
     <font size=+1 color=red>
		<%
		if tech_id = "" Then
			Response.write  wc_New
		else
			Response.write Ucase(tech_id)
		end if
		%>
	</font>
  </td>
</tr>
</table>

<p>

<FORM METHOD=POST ACTION=DoEditStaffMember.asp>

 <input type=hidden name=tech_id  value="<%=tech_id%>">



<table border=1 cellspacing=2 cellpadding=12 width=100%>
	<tr>
		<td>
		<b><%=wc_Home%></b></font>
		</td>
		<td>
		<b><%=wc_Work%></b></font>
		</td>

	</tr>

<tr valign=top>
    <% ' -------------------left column --------------------------------------- %>
	<td><font size=-1>
	<b><%=wc_first_name%>:</b><br>
	   <input type=text name=first_name size=35 maxlength=50 value="<%=first_name%>">

	<br><b><%=wc_last_name%>:</b><br>
	   <input type=text name=last_name size=35 maxlength=50 value="<%=last_name%>">

	<br><b><%=wc_address%>:</b><br>
	   <input type=text name=home_address size=35 maxlength=80 value="<%=home_address%>">

	<br><b><%=wc_city%>:</b><br>
	   <input type=text name=home_city size=35 maxlength=40 value="<%=home_city%>">

	<br><b><%=wc_state%>:</b><br>
	   <input type=text name=home_state size=35 maxlength=40 value="<%=home_state%>">

	<br><b><%=wc_zipcode%>:</b><br>
	   <input type=text name=home_zip size=35 maxlength=40 value="<%=home_zip%>">

	<br><b><%=wc_Cell_email_notification_email%>: </b><br>
	   <input type=text name=home_email size=35 maxlength=80 value="<%=home_email%>">

	<br><b><%=wc_phone%>:</b><br>
	   <input type=text name=home_phone size=35 maxlength=20 value="<%=home_phone%>">

	<br><b><%=wc_fax%>:</b><br>
	   <input type=text name=home_fax size=35 maxlength=20 value="<%=home_fax%>">

	</td>
<% ' -------------------right column --------------------------------------- %>
	<td><font size=-1>

	<b><%=wc_department%>:</b><br>
	   <input type=text name=department size=35 maxlength=50 value="<%=department%>">

	<br><b><%=wc_mailstop%>:</b><br>
	   <input type=text name=mailstop size=35 maxlength=50 value="<%=mailstop%>">

	<br><b><%=wc_Work_email_notification_email%>:</b><br>
	   <input type=text name=work_email size=35 maxlength=80 value="<%=work_email%>">

	<br><b><%=wc_phone1%>:</b><br>
	   <input type=text name=work_phone1 size=35 maxlength=20 value="<%=work_phone1%>">

	<br><b><%=wc_phone2%>: (12 Digit Format:+1XXXxxxXXXX)</b><br>
	   <input type=text name=work_phone2 size=35 maxlength=20 value="<%=work_phone2%>">

	<br><b><%=wc_fax%>:</b><br>
	   <input type=text name=work_fax size=35 maxlength=20 value="<%=work_fax%>">

	<br><b><%=wc_login_id%>:</b><br>
	   <input type=text name=current_customer_id size=35 maxlength=20 value="<%=current_customer_id%>">

	<br><b><%=wc_password%>:</b><br>
	   <input type=password name=tech_password size=35 maxlength=20 value="<%=tech_password%>">

	<% '--- If the record we are looking at has tech level = 6 and the logged on user is not 6, then don't let him mess with this %>
    <% If this_user_level < 6 AND tech_level > 5 Then %>
        <% ' Do nothing - don't show the block at all because we don't want to allow lesser folks to downgrade a sys admin%>
    <% Else %>
	<br><b><%=wc_security_level%>:</b><br>

	<select size=1 name=tech_level>
		<option  value=2 <% if tech_level = "2" then response.write " selected " %>><%=wc_Support_staff_read_only%></option>
		<option  value=3 <% if tech_level = "3" then response.write " selected " %>><%=wc_Support_staff_read_write %></option>
		<option  value=4 <% if tech_level = "4" then response.write " selected " %>><%=wc_Dispatcher%></option>
		<option  value=5 <% if tech_level = "5" then response.write " selected " %>><%=wc_System_administrator%></option>

	   <% If this_user_level > 5 Then ' Alllow only a configurator to create new configurators %>
		<option  value=6 <% if tech_level = "6" then response.write " selected " %>><%=wc_System_configurator%></option>
       <% End If %>
	<% End If %>

	</select>


	<%
	  if show_dispatch_flag = "1" Then
		   temp = " checked "
	  else
		   temp = ""
	  end if
	%>
	<p>
	<input type=checkbox name=show_dispatch_flag <%=temp%>> <%=wc_Display_member_on_dispatch_screen%><br>


	<p>
	<%
	  if new_case_notify = "1" Then
		   temp = " checked "
	  else
		   temp = ""
	  end if
	%>
	<input type=checkbox name=new_case_notify <%=temp%>> <%=wc_Notify_by_email_if_case_assigned1%><br>

<% If Version8Point0 = "YES" Then
%>
	<p>
	<%
	  if SendTXTWhenAssignedToTech  Then
		   temp = " checked "
	  else
		   temp = ""
	  end if
	%>
	<input type=checkbox name=SendTXTWhenAssignedToTech <%=temp%>> Send TXT messages when case is assigned to this tech<br>


	<p>
	<%
	  if SendTXTWhenAssignedToGroup  Then
		   temp = " checked "
	  else
		   temp = ""
	  end if
	%>
	<input type=checkbox name=SendTXTWhenAssignedToGroup<%=temp%>> Send TXT messages when case is assigned to tech group<br>

<% End If ' end of Version 8.0 %>



	</td>
    <% ' -------------------end of two columns  --------------------------------------- %>

</tr>
<!-- 12/2/13 -->
<TR><TD><TABLE>
<!-- end 12/2/13 -->
<% ' Now read up group memberships of this individual - if any


	set conntemp2=server.createobject("adodb.connection")
	conntemp2.open myDSN

	mySQL2="SELECT " + _
		  "Groups.Tech_id as Groups_tech_id, " + _
		  "Groups.Group_number as Groups_group_number, " + _
		  "Groups.New_case_notify as Groups_new_case_notify, " + _
		  "Group_list.group_name as  Gl_group_name " + _
		  "FROM Groups, Group_list " + _
		  "WHERE Groups.tech_id = '" & tech_id & "' " + _
		  "AND Groups.Group_number = Group_list.Group_number "


' New alhabetical ordering of groups by Group_Name - 2/28/13
	mySQL2="SELECT " + _
		  "Groups.Tech_id as Groups_tech_id, " + _
		  "Groups.Group_number as Groups_group_number, " + _
		  "Groups.New_case_notify as Groups_new_case_notify, " + _
		  "Group_list.group_name as  Gl_group_name " + _
		  "FROM Groups, Group_list " + _
		  "WHERE Groups.tech_id = '" & tech_id & "' " + _
		  "AND Groups.Group_number = Group_list.Group_number ORDER BY Group_Name"


			'response.write mySQL2
			'response.flush
			'response.end

	set rstemp2=conntemp2.execute(mySQL2)

	If rstemp2.EOF = True  Then
	   %>
		 <tr>
		   <td colspan=2>
			  <font size=-1><%=wc_Not_currently_member_support_group%></font>
		   </td>
		</tr>
	  <%
	Else
        ' -----------  put out the top matter for this sub-table
         %>
		<tr>
		 <td colspan=2>
		   <table border=0 cellspacing=1 cellpadding=1 width=85%>
		   <tr>
			   <td colspan=2 valign=top>
				<b><%=wc_Support_group_membership%>:</b></font><br>
			   </td>
		    </tr>
		   <tr>
		   </tr>
		   <tr>
			   <td><font size=-1>
			   </td>
       <%
       Do while (Not rstemp2.eof) ' ---------- put out individual lines in this sub table
	   %>

		   <tr>
			   <td><font size=-1><font color=blue><b> <%=rstemp2("Gl_group_name")%> </b></font>
			   </td>
			   <% if rstemp2("Groups_new_case_notify") = "1" Then %>
			       <% '--------- Following lines cause generation of a "Form" variable named "GROUPn" where n is the group number   %>
			       <td nowrap><font size=-1> <input type=checkbox checked name=group<%=rstemp2("Groups_group_number")%>>
			   <% else %>
			       <td nowrap><font size=-1> <input type=checkbox name=group<%=rstemp2("Groups_group_number")%>>
			  <% end if %>
			  <%=wc_Notify_by_email_if_case_assigned2%> <br>
			   </td>
		   </tr>

	  <%

       rstemp2.Movenext
       Loop

       ' ---------- And close off this sub table
      %>
		   </table>
		  </td>
		</tr>

     <%
    End If
	rstemp2.close
	set rstemp2=nothing
	conntemp2.close ' Close the connection
	set conntemp2=nothing
%>
<!-- 12/2/13 -->
</table></td>
<%GetSurveyInfo() %>
</tr>
<!-- end 12/2/13 -->

	<tr>
		<td colspan=2><font size=-1>
		  <b><%=wc_notes%>:</b><br>
			 <textarea name=notes wrap=virtual rows=3 cols=60><%=notes%></textarea>
		</td>
</tr>
</table>



<p><b>


<table border=0 cellspacing=1 cellpadding=1 width=98%>
<tr>
<td align=center>
<input type=image name=b_submit src=/<%=WCLanguageDirectory%>/ts_submit30x80.gif border=0>
</td>
<td align=center>
<a href=SystemAdmin.asp><img src=/<%=WCLanguageDirectory%>/ts_cancel30x80.gif border=0></a>
</td>
</tr>
</table>
</b>
</form>
</body>
</html>


<% End If 'it was a valid user %>


<% Sub GetDatabaseConfiguration(ts_user_page_color, Assets_db, customer_drop_down)
	'This function gets the database configuration information
	' including the max size of the history field and
	' the email message appendages

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		mySQL2="select * from Configuration"
		set rstemp2=conntemp.execute(mySQL2)

		if rstemp2.EOF then
			ts_user_page_color = "FFFFFF"
			Assets_db = 0
		Else
			DatabaseType  = rstemp2("DatabaseType") ' Database should be set to ACCESS or SQLSERVER ' 12/2/13
			ts_user_page_color = rstemp2("ts_user_page_color")
			Assets_db = rstemp2("Assets_db")
			customer_drop_down = rstemp2("customer_id_list")
		End If

		rstemp2.close
		set rstemp2=nothing


		conntemp.close ' Close the connection
		set conntemp=nothing

	End Sub ' End of GetdatabaseConfiguration
%>

<% sub GetSurveyInfo()
%>
 <TD><TABLE>
 <%
	set conntemp2=server.createobject("adodb.connection")
	conntemp2.open myDSN

if  DatabaseType = "SQLSERVER" then
	sSql = "	SELECT survey.question_ID,	 "
	sSQL = sSQL & " cast(avg(convert(float,range_answer)) as decimal(10,2)) as av "
	sSQL = sSQL & " from ((((result_detail"
	sSQL = sSQL & " left join survey_results on result_detail.results_id = survey_results.results_ID)"
	sSQL = sSQL & " left join survey on result_detail.question_ID = survey.Question_ID)"
	sSQL = sSQL & " left join cases on survey_results.case_number = cases.case_number)"
	sSQL = sSQL & " left join tech_staff on cases.tech_ID = tech_staff.tech_ID)"
	sSQL = sSQL & " where active = 'true' and question_type = 1 "
	sSQL = sSQL & "and tech_staff.tech_id = '" & tech_ID & "'"
	sSql = sSql & " Group by survey.question_ID, survey.Question_order "
	sSQL = sSQL & "order by survey.Question_order "

Else
	sSql = "	SELECT survey.question_ID,	 "
	sSQL = sSQL & "  avg(range_answer) as av "   ' different for ACCESS
	sSQL = sSQL & " from ((((result_detail"
	sSQL = sSQL & " left join survey_results on result_detail.results_id = survey_results.results_ID)"
	sSQL = sSQL & " left join survey on result_detail.question_ID = survey.Question_ID)"
	sSQL = sSQL & " left join cases on survey_results.case_number = cases.case_number)"
	sSQL = sSQL & " left join tech_staff on cases.tech_ID = tech_staff.tech_ID)"
	sSQL = sSQL & " where active = true and question_type = 1 "  ' different for ACCESS
	sSQL = sSQL & "and tech_staff.tech_id = '" & tech_ID & "'"
	sSql = sSql & " Group by survey.question_ID, survey.Question_order "
	sSQL = sSQL & "order by survey.Question_order "

End If
	set rstemp2=conntemp2.execute(sSQL)

	If rstemp2.EOF   Then
	   %>

		 <tr>
		   <td colspan=2>
			  <font size=-1>No Survey Results</font>
		   </td>
		</tr>
	  <%
	Else
        ' -----------  put out the top matter for this sub-table

         %>
		<tr>
		 <td colspan=2>
		   <table border=0 cellspacing=1 cellpadding=1 width=85%>
		   <tr>
			   <td colspan=2 valign=top NOWRAP>
				<b>Customer Survey Average for This Tech</b></font><br>
			   </td>
		    </tr>
		   <tr>
		   </tr>
		   <tr>
			   <td><font size=-1>
			   </td>
       <%
       Do while Not rstemp2.eof ' ---------- put out individual lines in this sub table
              sQuestion = GetSurveyQuestion(rstemp2("Question_ID"))
              sAvg = rstemp2("av")
	   %>

		   <tr>
			   <td nowrap><font size=-1><font color=blue><b> <%=sQuestion%>: </b></font>
			   </td>
			       <td nowrap><font size=-1> <%=sAvg%>			   </td>
		   </tr>

	  <%

       rstemp2.Movenext
       Loop

       ' ---------- And close off this sub table
      %>
		   </table>
		  </td>
		</tr>
     <%
    End If
	rstemp2.close
	set rstemp2=nothing
	conntemp2.close ' Close the connection
	set conntemp2=nothing
	%>
	</TABLE></TD>
<%
	End Sub
%>
<%
Function GetSurveyQuestion(QuestionID)

  		Dim answer
  		Answer = ""

		set conntemp4=server.createobject("adodb.connection")

		conntemp4.open myDSN ' Open the connection once here

		mySQL2="select Survey_Question from survey where question_ID = " & QuestionID

		set rstemp = server.createobject("adodb.recordset")
		rstemp.open mySQL2, conntemp4, 1,3

		If NOT rstemp.EOF   Then
			if not isnull(rstemp("survey_Question")) then
				answer = rstemp("survey_Question")
         end if
		End If

		rstemp.close
		set rstemp=nothing
		conntemp4.close ' Close the connection
		set conntemp4=nothing

		GetSurveyQuestion = answer

End Function
%>
