
<% 'Module: EmailToCase.asp - Version 7.5

   'Description: This module performs the email to Case polling function for
   ' the Web+Center Help Desk.

   ' The Email To Case function works by having this window up on some machine in the
   ' brower running at all times and it performs an auto-refresh of a page
   ' that performs the quering of an email POP account and if an email exists, it will parse it
   	' and then create a customer from the address if needed, and then create a support case from it
   	' and then send the appropirate email notifications back to the customer and techs as if a
   	' support case was created by customer+center or the tech+center application,


   ' To Stop the EmailToCase Feature, one should simply close this window.  Only one
   ' of these windows should be activated at any one time.

   '(C) 1998,1999, 2000, 2001, 2002, 2005- 2011 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------		---		------------------------------------------------
   '6/11/2002	SAV		Created original Escalation.asp page
	'5/6/2005	SAV		Updated Escalation for HTML based emails
	'05/27/2010	SAV		Created EmailToCase.asp page form Escalation.asp
	'10/18/2010	SAV		Added the feature to support attachments
	'03'12/2011 CMB     Initialize C columns in Case Table for SqlServer so CustomerOptions.asp works; changed default virtual dir to 70
    '04/21/2011 CMB    Get Rid of apostrophes in sender name
	 '04/26/2011 CMB    Use CLNG rather than CINT in checking file size attachments; also check to make sure config size is numeric
    '06/07/2011 CMB    Add slash to upload file
    '10/05/2011 CMB    COnfigurable AdditionalEmails version 7.5
    '08/10/2012 CMB    Multiple cases being created from same email if multiple emails come in during the check interval
    '                  Also changed ncount to acount for attachments and i used for loop counter was being re-used.
    '                  Got rid of second call to open configuration file (moved up)
    '                  Also bug where gave same case number if cases came in at same time
    '06/10/13   CMB    Deal with apostrohes
    '06/10/13	SAV		Added code that sets the LastEmailToCaseCheck field in the configuration table to show that it is being polled

	' CONSTANTS

Server.ScriptTimeout = 600 'Setting timeout for ASP scripting

Dim vbNullString
vbNullString = ""


Dim nRet, nCount, messageId, oPop3, oMsg, errStr, tempFolder, pos, emailContent, aCount
nRet = 0
nCount = -1

tempFolder = Server.MapPath(Request.ServerVariables("PATH_INFO"))
pos = InStrRev( tempFolder, "\" )
If pos > 0 Then
	tempFolder = Mid( tempFolder, 1, pos )
End If
tempFolder = tempFolder & "emlFolder"

%>


<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/EmailPorts.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->
<!-- #INCLUDE FILE="../Language/SendEmail.inc" -->
<!-- #INCLUDE FILE="../Language/CodeCustomizations.inc" -->


<% If Version7 = "YES" Then %>
<!-- #INCLUDE FILE="../Language/HTMLEmailTemplateAdditionalNotification.inc" -->
<% End If %>



<!-- #INCLUDE FILE="../Language/HTMLEmailTemplateTechUpdate.inc" -->
<!-- #INCLUDE FILE="../Language/HTMLEmailTemplateCustomerNotification.inc" -->
<!-- #INCLUDE FILE="../Language/HTMLEmailTemplateCustomerSurvey.inc" -->


<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->

<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 2 ' Allow valid techs to access this function.


	CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN") ' Get the Logged TechID from the cookie

	If SecurityON = "YES" Then ' Execute this code only if Security Option Flag is set to YES
		' This flag will be set in the DB_define.inc file.

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="SELECT * from Tech_staff where Tech_ID = '" & CookieID & "' AND Tech_Level >= " & TechLevel
		set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF <> True Then
			TechFullName = rstemp("first_name") & " " & rstemp("Last_name")
			ValidUser = "YES" ' Set this variable to prevent problems on next page
		End If

		rstemp.close
		set rstemp=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing
	Else
		ValidUser = "YES"
	End If


 ' End of ASP page security checks
 %>
<%
' The following is the password for the autostart feature for EmailToCase.  Modify this and use the URL
' <Hostname>/tech70/EmailToCase.asp?Pass=<AutostartPass> substituting whatever you entered below into <AutostartPass>
	if Request.querystring("pass") = "AutostartPass" Then
		ValidUser= "YES"
	End If
%>


<% if ValidUser <> "YES" Then %>
	<% ASPPage = "Escalation.asp"%>

	<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function %>

<% UserPageColor = "FFFFFF" %>

<% 'Get the EmailToCase Configuration options %>
<%

   ' NOTE - the Connection "conntemp" is opened ONCE here at the beginning of the main path
   ' of the program - and it remains open until the end - thus catering for use by multiple
   ' subroutines during execution without intermediate opening and closing of the connection

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL2="select * from EmailToCaseConfig"
	set rstemp2=conntemp.execute(mySQL2)

	' Check to see if any records are returned
	' if none found the
	if rstemp2.EOF then


		Serveraddr = ""
		username = ""
		password = ""
		checkintervalminutes = 0
		EmailDomainRequired = ""
		OnlyExistingEmailAddresses = "NO"
		AllowAttachedFiles = "NO"

	Else

		If rstemp2("OnlyExistingEmailAddresses") = True THEN
			OnlyExistingEmailAddresses = "YES"
		Else
			OnlyExistingEmailAddresses = "NO"
		End If

		If rstemp2("AllowAttachedFiles") = True THEN
			AllowAttachedFiles = "YES"
		Else
			AllowAttachedFiles = "NO"
		End If


		Checkintervalminutes  = rstemp2("checkintervalminutes")

		' Need to multiply by 60 since http refresh tag is seconds

		CheckIntervalSeconds =  Checkintervalminutes  * 60

		Serveraddr = rstemp2("popemailaddress")
		username = rstemp2("popemailusername")
		password = rstemp2("popemailpassword")

		EmailDomainRequired = rstemp2("EmailDomainRequired")

		If rstemp2("DisableEmailToCase") = True THEN
			DisableEmailToCase = "YES"
		Else
			DisableEmailToCase = "NO"
		End If


		If rstemp2("CustomerNotificationEmail") = True THEN
			CustomerNotificationEmail = "YES"
		Else
			CustomerNotificationEmail = "NO"
		End If

		EmailToCaseReplyToName = rstemp2("EmailToCaseReplyToName")
		EmailToCaseReplyToEmail = rstemp2("EmailToCaseReplyToEmail")



	'We need to set the reply to Email Address for notification emails that are sent from
	' EmailToCase so that the reply to email addresses are not the same as the standard reply to
	' address that the other tech/customer emails sent out.

	' to over-ride the standard reply to email address we set the following values
		' If the a Global variable called FromEmailAddress and FromEmail is set, use these instead:

			FromEmailAddress =  EmailToCaseReplyToEmail
			FromName = EmailToCaseReplyToName


	End If

	rstemp2.close
	set rstemp2=nothing


	' Get the system settings such as SMTP addresses


	mySQL="select * from Configuration" ' We will allow up to 10 Priority values

	set rstemp = server.createobject("adodb.recordset")
	rstemp.open mySQL, conntemp, 1,3

	' Old Way - Do not  use with SQL*Server
	'set rstemp=conntemp.execute(mySQL)

	If rstemp.EOF = True  Then
		Response.write "No Configuration file found"
	Else

		TextBoxSizing = rstemp("Text_Box_Sizing")
		CasesummaryRows = rstemp("case_summary_rows")
		CasesummaryMaxRows = rstemp("case_summary_Max_Rows")
		CaseResolutionRows = rstemp("case_resolution_rows")
		CaseResolutionMaxRows = rstemp("Case_resolution_Max_Rows")
		CaseHistoryRows = rstemp("Case_History_Rows")
		CaseTextBoxColumns = rstemp("Case_Text_Box_Columns")
		TimeZoneAdjustment = rstemp("Time_zone_Adjustment")
		TimeZoneLabel = rstemp("Time_zone_Label")
		Language = rstemp("Language")
		ALLKBUpdate = rstemp("All_KB_Update")
		TimeSpentCategory = rstemp("Time_Spent_Category")
		TimeSpentInterval = rstemp("Time_Spent_Interval")
		DateDisplayFormat = rstemp("Date_Display_Format")

		smtp_host_address = rstemp("smtp_host_address")
		Standard_reply_to_address = rstemp("Standard_reply_to_address")
		UserPageColor = rstemp("ts_user_page_color")
		Customer_case_notify = CInt(rstemp("customer_case_notify"))

		MaxHistorySize =  CLng(rstemp("max_case_history_size"))
		MaxSummarySize =  Cint(rstemp("max_case_summary_size"))
		MaxResolutionSize =  Cint(rstemp("max_case_resolution_size"))

		' New 4.0 Fields
		Customersurvey = rstemp("Customersurvey") ' Boolean flag enabling customer Surveys
		SurveyEmailText =	rstemp("SurveyEmailText") ' Customer Survey Email Message Text
		TechVirtual = rstemp("TechVirtual") ' Techcenter virtual directory
		CustomerVirtual = rstemp("CustomerVirtual") ' CustomerCenter Virtual directory
	   OrganizationFromName = rstemp("Customer_Name_Text") ' Use this for organization name in mail out

		' New 5.0 SMTP mailer options

		SendHTMLEmail = rstemp("SendHTMLEmail") ' Boolean value
		SMTP_User_Name = rstemp("SMTP_User_Name")
		SMTP_Password = rstemp("SMTP_Password")

		If SendHTMLEmail = True Then
			HTMLEmail = "YES"
		Else
			HTMLEmail = ""
		End IF

		TechCenterVirtualDirectory = rstemp("TechVirtual")
		CustomerCenterVirtualDirectory = rstemp("CustomerVirtual")
		Customer_case_notify = CInt(rstemp("customer_case_notify"))

 	' Get virtual directory and upload physical directories from configuration tables

		FileUpLoadDestinationPath = rstemp("FileUploadPhysicalPath") ' Set this to your full destination path

		FileUploadVirtualDirectory = rstemp("FileUploadVirtualDirectory") ' You must configure this virtual in IIS - Allow read ONLY!
		' For security reasons, do not allow FileVirtualDirectory Script or execute permissions

		MaxFileUploadSize = rstemp("MaxFileUploadSize") ' Maximum Allowed download file size in bytes

		If MaxFileUploadSize = NULL or not IsNumeric(MaxFileUploadSize) then  ' CMB 04/26/2011
			FileUploadMaximumSize = 0
		Else
			FileUploadMaximumSize = MaxFileUploadSize
		End If
	End If

			'**** version 7.5
			bAdditionalEmails = False ' backwards compabitility

			If AdditionalNotificationEmails = "YES" then ' backwards compabitility
				bAdditionalEmails = True
			End If

			If version7point5="YES" then
				If not IsNull(rstemp("AdditionalNotificationEmails")) then
					bAdditionalEmails = rstemp("AdditionalNotificationEmails") ' possibly overwrite include file value
				end if
			End If

			' Version 7.0 fields
			If bAdditionalEmails = True Then ' Version 7.5
				'Extracts the Primary additional notification email address

				PrimaryAdditionalNotificationEmail = rstemp("PrimaryAdditionalNotificationEmail") '
			End If



		' Code to set value into configuration table with current time this was polled.
		if Version8Point0 = "YES" Then
			rstemp("LastEmailToCaseCheck") = now() ' Set current time this was polled
			rstemp.update
		End If



	rstemp.close
	set rstemp=nothing

%>

<HTML>
<HEAD>

<% If CheckIntervalSeconds <> 0 Then %>
   <META HTTP-EQUIV="Refresh" CONTENT="<%=CheckIntervalSeconds%>">
<%End If %>

   <TITLE><%=wc_Email_To_Case%></TITLE>
<!-- (C) 1996,1998, 1999, 2000, 2001, 2002-2010 by Internet Software Sciences -->
</HEAD>
<BODY BGCOLOR="#<%=UserPageColor%>">
<center>
<table cellspacing=2 cellpadding=2 width=90% border=1><tr>
<th bgcolor=F0D0D0><font size=-1><%=wc_Status%></th>
<th bgcolor=F0D0D0><font size=-1>Refresh Rate/Last Checked</th>

</tr>
<tr>
<% If DisableEmailToCase = "YES" then %>
<td align=center bgcolor=red><font size=-1>
<B><%=wc_DISABLED%></b>
</td>
<%else%>
<td  align=center bgcolor=GREEN><font size=-1>
<B><%=wc_RUNNING%></b>
</td>
<%End If %>


<td align=center >
<font size=-1><%=CheckIntervalMinutes%> &nbsp;&nbsp;<%=wc_Minutes%> /

<%
	HourDisplay = Hour(Now())

	If HourDisplay > 12 Then
		HourDisplay = HourDisplay - 12
		AMPM  = " PM"
	Else
		AMPM = " AM"

	End IF

	Response.write HourDisplay & ":"

	MinuteDisplay = Minute(now())
	IF MinuteDisplay < 10 then

		response.write "0" & MinuteDisplay
	Else
		response.write MinuteDisplay
	End If

	Response.write AMPM

%>


</font>
</td>


</tr>



</table>



<% if DisableEmailToCase = "YES" Then
	Cases_Found_String = "---"
Else

	'response.write "Checking for emails"


%>



<br>
<table cellspacing=2 cellpadding=2 width=90% border=1>
<tr>
<td colspan=3 bgcolor=F0C0F0 align=center>
<font size=-1><B><%=wc_Email_To_Case_Report%></b>
</td>
</tr>


<tr>
<td colspan=3>


<% ' ************** START OF EMAIL POLLING CODE ***************************

Set oPop3 = Server.CreateObject("ANPOP.POPMAIN") ' creating POPMAIN object
Set oMsg = Server.CreateObject("ANPOP.POPMSG") 'creating POPMSG object

 'For IMAP4 server, please add the following code
  'oPop3.IMAP4Connection = 1
  'oPop3.ServerPort = 143


	'oPop3.NTLMAuth = 1 ' turn this option one for MS exchange servers running in secure mode


'run ASP with specified user security context
'If oMsg.ImpersonateUser( "administrator", "ad1234", "" ) <> 0 Then
'	Response.Write "logon user failed"
'End If



  '**********************************************************
  ' Code for SSL connections or special ports for Pop Mail Services like Google, Office 365
  ' Uncomment the two lines below to enable

'  oPop3.ServerPort = 995
'  oPop3.SSL_init
  '**********************************************************


nRet = oPop3.Connect( ServerAddr, Username, Password ) 'connecting POP3 server

If nRet = 0 then
	nCount = oPop3.GetTotalOfMails()  ' Getting total count of mails existing on server
	NumberOfEmails = nCount  ' added 08/10/12
	If nCount = -1 Then
		errStr = "Error with GetTotalOfMails method"
	End If
Else
	errStr = "Error with connecting server: " & ServerAddr
End If

For i = 1 to nCount
	messageId = oPop3.GetMsgID(i)
	If messageId = vbNullString Then
		errStr = "Error with GetMsgID method"
		Exit For
	End If

'	response.write "MessageId = " & messageID


		emailContent = oPop3.Retrieve(i)
		If emailContent = vbNullString Then
			errStr = "Error with Retrieve method"
			Exit For
		End If


		oMsg.RegisterKey = LK

		oMsg.RawContent = emailContent 'passing message to POPMSG object.

		RawBody = oMsg.GetBodyText

		Body = oMsg.HtmlToText(RawBody) ' Remove any HTML tags if they exist

		' There are other function available with ANPOP email component that could
		' be used to build the body of the message from the incoming HTML/Text msg


		Subject = oMsg.GetSubject
		SenderName = oMsg.GetFrom()
		SenderEmail = oMsg.GetFromAddress()

		'*** cmb 04/21/2011 get rid of apostrophes in sendername or crashes
		SenderName=Replace(SenderName,"'","")

		' File Attachement code


		If AllowFileAttachments = "YES" Then

			tempFolder = "c:\temp_attachments"
			  If oMsg.CreateFolder( tempFolder ) <> 0 Then
				err = "error with Create temporary folder"
			  End If

			  aCount = oMsg.GetAttachmentCount() ' cmb changed from ncount 08/10/12

			' debugging
		'	response.write " Attachment Count = " & aCount  ' cmb changed from ncount 08/10/12


			  'For ia = 1 To aCount  					' cmb changed from ncount 08/10/12 and i to ia
				'fileName = oMsg.GetAttachmentName(ia) <FONT color=green>'get attachment name</FONT>
			'	nSize = oMsg.GetAttachmentSize(ia) <FONT color=green>'get attachment size</FONT>
			'	<FONT color=green>'save attachment to temporary directory</FONT>
			'	If oMsg.SaveAttachment( tempFolder, ia ) &lt;&gt; 0 Then
			'	  err = "error with SaveAttachment"
			'	  GoTo ErrorHandler
			'	End If
			 ' Next

		End If ' End of if File Attachments is enabled






		'Debugging
'		response.write "<hr>"
'		response.write "subject = " & subject & "<br>"
'		response.write "Sender Name=" & SenderName & "<br>"
'		response.write "Sender Email" & SenderEmail & "<br>"

'		response.write "body = " & body & "<br>"


	' Now do the processing of the email to the case ticket

	' ************************ EMAIL FILTERS ************************
	' Step 1 - FILTER unwanted emails based on filter requirements

	' FILTER #1 = Check if accepting emails only from a certain domain
	EmailToCaseFailureMsg = "" ' Clear out Failure message which is also a flag

	IF EmailDomainRequired <> "" Then
		If Instr(SenderEmail, EmailDomainRequired) = 0 Then
			EmailToCaseFailureMsg   = " Rejected Email based on invalid domain name for Case from Email address: " & SenderEmail & "<br>"
			'response.write "ErrorMsg =" &  EmailToCaseFailureMsg
		else
			'response.write "Email Domain checked passed/not required"

		End IF

	End IF

	' FILTER #2 Check if email address must already exist in the Web+Center customer database

	'debug
	'response.write "OnlyExistingEmails= " & OnlyExistingEmailAddresses

	IF OnlyExistingEmailAddresses = "YES" Then

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  myDSN

	' Check to see if customer_ID exists then this is an update by checking
	' their email address.

		Set NewRecord = Server.CreateObject("ADODB.Recordset")

			SQL = "Select * from Customers where email = '" & SenderEmail & "'"

			'response.write SQL

			NewRecord.Open SQL,Conn,3,3

			If NewRecord.EOF = True Then ' If email not found then create account
				EmailToCaseFailureMsg =   EmailToCaseFailureMsg & " Rejected Email since Email does not already exist in customer database with email address: " & SenderEmail & "<br"
			End IF


			NewRecord.Close

			Conn.Close

			Set NewRecord = Nothing


	End if ' End of If Only ExistingEmailAddresses



	' Create Customer record of EmailToCaseFailureMsg is blank

	' If Failure then display it

	If EmailToCaseFailureMsg <> "" Then

		response.write "<B>Mail To Case Failure:"  & EmailToCaseFailureMsg & "<hr>"
	End If






If EmailToCaseFailureMsg = ""  Then

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  myDSN

	' Check to see if customer_ID exists then this is an update by checking
	' their email address.

		Set NewRecord = Server.CreateObject("ADODB.Recordset")

			SQL = "Select * from Customers where email = '" & SenderEmail & "'"

			'response.write SQL

			NewRecord.Open SQL,Conn,3,3

			If NewRecord.EOF = True Then ' If email not found then create account
				NewRecord.AddNew
				' for New records we create the customer_ID
				' by taking the Lastname + "_" +  First.  If
				' there are more than 20 characters, then we take
				' just the first 20 characters of this and call
				' it the Customer_ID.

				' First replace any spaces with underscores

				newSendername = replace(sendername, " ", "_") ' original code
				newSendername = replace(newsendername, "'", "") ' 06/10/13

				Customer_ID = newSenderName
				If Len(customer_ID) > 20 Then
					Customer_ID = Left(Customer_ID, 20)
				End If

				' The Customer_ID must be unique verify this combination
				' of Last_First is not already used.  If it is, then
				' add an 3 digit random number to the end of the ID.

				UniqueCustomerID = CheckForUniqueTableValues("Customers", "customer_ID", customer_ID)

				If UniqueCustomerID <> "UNIQUE" THEn
					Customer_ID = mid(Customer_ID, 1,17) ' lop off last two characters
					Randomize ' Seed the generator with a new value
					Customer_ID = Customer_ID & cstr(Int(rnd*100))
					'response.write "New ID = " & Customer_ID
				End If

				' Run this test again incase we have duplicates

				UniqueCustomerID = CheckForUniqueTableValues("Customers", "customer_ID", customer_ID)

				If UniqueCustomerID <> "UNIQUE" THEn
					Customer_ID = mid(Customer_ID, 1,17) ' lop off last two characters
					Randomize ' Seed the generator with a new value
					Customer_ID = Customer_ID & cstr(Int(rnd*100))
					'response.write "New ID = " & Customer_ID
				End If


				NewRecord("Customer_ID") = Customer_ID

				' IMPORTANT - DO NOT RESET THIS EVEN IF THEY
				' CHANGE THEIR NAMES.  There is an option within
				' the tech+center that will allow techs to
				' change the customer_id.

			' Set Customer_username equal to customer_ID for now

			Customer_Username = Customer_ID ' Set to customer_id since they are both 20 characters and unique
			' users can log in with their email address and default password of "password"


			' Set all of the variables the same for either new/update

		NewRecord("customer_password") = "password"
		NewRecord("contact_fname") = SenderName
		NewRecord("contact_lname") = ""
		NewRecord("email") = Senderemail  ' set the email field


		If customer_Username <> "" Then
			NewRecord("customer_username") = customer_username
		End If

		NewRecord.Update
	If  err.number>0 then
	      response.write "VBScript Errors Occured:" & "<P>"
	      response.write "Error Number=" & err.number & "<P>"
	     response.write "Error Descr.=" & err.description & "<P>"
	      response.write "Help Context=" & err.helpcontext & "<P>"
	      response.write "Help Path=" & err.helppath & "<P>"
	      response.write "Native Error=" & err.nativeerror & "<P>"
	      response.write "Source=" & err.source & "<P>"
	      response.write "SQLState=" & err.sqlstate & "<P>"
	else
	'      response.write "No VBScript Errors Occured" & "<P>"
	end if
	IF  conn.errors.count> 0 then
	      response.write "Database Errors Occured" & "<P>"
	for counter= 0 to conn.errors.count
	      response.write "Error #" & conn.errors(counter).number & "<P>"
	      response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
	next
	else
	'      response.write "No Database Errors Occured!" & "<P>"
	end if


	' Else if record found (EOF <> True ) then get the customer_Id field

	Else
		Customer_Id = NewRecord("Customer_ID")
	End IF



	NewRecord.Close

	Conn.Close

	Set NewRecord = Nothing


End If ' End of If EmailToCaseFailureMsg <> ""


If EmailToCaseFailureMsg <> "" Then
	response.write "Email To Case Failure:<Br>"
	response.write EmailToCaseFailureMsg & "<hr>"
Else
	' Report another message later with more information
'	response.write "<B>Sender Email:</b>" & SenderEmail & "<Br>"
'	response.write "<B>Customer_ID:</b>" & Customer_ID

End If


' Now create the case if the EmailToCaseFailureMsg <> ""


'****************** CREATE CASE CODE AND SEND EMAILS ******************

If EmailToCaseFailureMsg = "" Then

			Case_Number = 0
			CaseType = "NEW"


		Case_History = Body ' Get History of message from email body

		Case_History = "Case History:" & vbCRLF & Case_History


		Case_One_Line = Subject


		' We will get and store all of the categories below.

		' Call functions to get configuration and SMTP info
      ' CMB 08/10/12 MOVED THIS UP TO other configuration - no need to get this multiple times
	' FIRST Get the values from the configuration file and into variables



		CreateTimeDateValues DateString, TimeString, DateTimeString
		DefaultGroupNumber = GetDefaultGroupNumber()

		' Check for the required fields
		' You can add additional required fields or removed
		' restrictions by commenting out the checks below.

		ErrorMessage = "" ' Clear error message

		If Case_One_Line  = "" Then
			ErrorMessage = ErrorMessage & "<LI> " & wc_The_case_one_line_field_must_be_completed
		End If



		' Check to see if the size of the case_history is larger
		' or will be larger than the maximum size allowed in
		' the configuration file


		If Len(Case_History) >= (Clng(MaxHistorySize) - 100)   Then
			ErrorMessage = ErrorMessage & "<LI> " & wc_Case_History_text_is_too_long
		End If


		If Case_Number <> "" Then
			If GetCasestatus(Case_Number) = "CLOSED" Then
				ErrorMessage = ErrorMessage & "<LI> " & wc_Case_Already_Closed_Block
			End If
		End If

		' ************* USER CUSTOMIZATIONS **************************
		' Add your own data requirements as necessary and add any
		' error text to be displayed to ErrorMessage string variable.

		If ErrorMessage <> "" Then
		%>

<!-- #INCLUDE FILE="Techusererror.inc" -->

	<% Else 'Otherwise either add new or update case record
		' DO NOT MODIFY this code below with caution:
		' The case record has some required fields and the
		' several of the fields must be carefully filled in
		' to make other parts of the system work correctly.


	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  myDSN

	' Check to see if case_number exists then this is an update


		Set NewRecord = Server.CreateObject("ADODB.Recordset")

		If DatabaseType <> "ACCESS97" Then
			NewRecord.CursorLocation = adUseClient
		End If



		' CODE to handle a reply to an existing notification email

		'response.write "Case_One_Line = " & Case_One_Line

		If Instr(Case_One_Line, "Support Case [") <> 0 Then

			CaseType = "" ' Clear out CaseType if this a reply to existing case.

			'Previous Case record found

			' So extract case number between the brackets

			StartNumberLocation  = (Instr(Case_One_Line, "[") + 1)
			EndNumberLocation = (Instr(Case_One_Line, "]") - 1)

			SubjectCaseNumber = mid(Case_One_Line, StartNumberLocation, (EndNumberLocation-StartNumberLocation + 1))

			'debug
			'response.write "Subject Case number = " & SubjectCaseNumber
			' Take the extracted case number and use it for the query below.

			Case_Number  = SubjectCaseNumber

			' If this is an existing case reply, then we only want the new part of the body added to the body
			' so we will search for the keyword of "Notification" and then only take
			' information before that and insert that into the body instead of the whole email.

			' ***** CUSTOMIZATION***** You can configure this keyword to search for below

			StartOfOldBodyKeyword = "Notification"

			LocationOfKeyword  = Instr(Case_History, StartOfOldBodyKeyword)

			If LocationOfKeyword <> 0 Then

				NewBodyString = Mid(Case_History, 1, (LocationOfKeyword -1))
				Case_History = NewBodyString

				'debug
				'response.write "Case_History = " & Case_History
			End if


		End If


'**** cmb
		' File Attachement code
		FileUploadStatus = ""
		If AllowAttachedfiles = "YES" Then
			  aCount = oMsg.GetAttachmentCount()   ' cmb changed from ncount 08/10/12
			  If aCount > 0 then   ' cmb changed from ncount 08/10/12
			    For FileCount = 1 To aCount   ' cmb changed from ncount 08/10/12
				  fileName = oMsg.GetAttachmentName(FileCount)
				  nSize = oMsg.GetAttachmentSize(FileCount)
				  If (CLNG(nSize) >= CLNG(FileUploadMaximumSize)) AND (FileUploadMaximumSize <> 0)  Then
				'	FileUploadStatus = FileUploadStatus & "File Attached to Support Email Failure with file: " & FileName & " (" & nSize & " Bytes).  File is too large to upload or other error; "
					case_History = case_History & " File Attached to Support Email Failure with file: " & FileName & " (" & nSize & " Bytes).  File is too large to upload or other error; "
				 end if
				next
			 end if
		end if  'allowattachedfiles = yes
'****
		SQL = "Select * from Cases where case_number = " & case_number
		'response.write SQL

		NewRecord.Open SQL,Conn,3,3

		If NewRecord.EOF = True Then
			NewRecord.AddNew

			' For new records we fill in the
			' the opendate and open time fields
			' with the following formats:
			' OpenDate: YYYYMMDD

			' OpenTime: HHMMSS
			NewRecord("modified_flag") = 1
			NewRecord("Open_Date") = DateString ' YYYYMMDD
			NewRecord("Open_Time") = TimeString ' HHMMSS
			NewRecord("mod_date") = DateString ' YYYYMMDD
			NewRecord("mod_time") = TimeString ' HHMMSS

	' Reopen_Date and reopen_time fields are not really used
		' so we will use these fields to determine if it is new
		' case by only setting them during tech updates.
		' Do not set the reopen_date and reopen_time with new case creation

			'NewRecord("Reopen_Date") = Datestring
			'NewRecord("reopen_Time") = TimeString


			NewRecord("Customer_ID") = Customer_ID

			'********************** User Customization Option ********************
			' Uncommenting and editing the line below will automatically
			' assign the case to the defined tech when the case is first created in the
			' the customer+center application. This option should only
			' be enabled for small support organizations that want to always
			' initially assign the case to one tech.  The typical method is to have
			' group assignments made, but the tech assignment is done by techs or
			' dispatchers in the tech+center application.

			' Note: The Tech_ID defined must match the case of the Tech_ID in the tech_staff table.

			'InitialTechAssignment = "CSS-1000" ' Uncomment and edit the CSS-1000 to the desired tech


			If InitialTechAssignment <> "" Then
				NewRecord("Tech_ID") = InitialTechAssignment
			End If


			'***********************End User Customizations ***********************


			' Default Group Is set below by either categories or default Group
			'NewRecord("Group_Number") = DefaultGroupNumber - See Below

			NewRecord("Dup_case_num") = 0
			NewRecord("Status") = 0

			NewRecord("Severity") = 0

			' In special cases, the true case severity (priority might be passed and set here)

			If Case_Severity = "" Then
				NewRecord("Severity") = 0 ' Set back to 0 (un-assigned)
			Else
				NewRecord("Severity") = Case_Severity
			End IF

			' Important Fix - If Case_One_Line is greater than 100 character, it will
			' generate an OLE-DB error as it is trying to place more than 100 characters
			' into this 100 character field

			If Len(Case_One_Line) > 99 Then
				NewOneLine = Mid(Case_One_Line, 1, 96) & "..."
			Else
				NewOneLine = Case_One_Line
			End If


			NewRecord("Case_One_Line") = NewOneLine

			If Asset_Number = "" Then
				NewRecord("Asset_Number") = 0 ' Default to zero
			Else
				NewRecord("Asset_Number") = Asset_Number
			End If


			' Set the case severity if it is passed

			If Case_Severity = "" Then
				NewRecord("Severity") = 0 ' Set back to 0 (un-assigned)
			Else
				NewRecord("Severity") = Case_Severity
			End IF


			NewRecord("Category_Count") = 100 ' Default to 100

		    ' *************** set categories to 0 so Login link works for SqlServer CMB 3/12/2011 *********************
			For iCount = 1 to 50
					CategoryColumn = "C" & iCount
					NewRecord(CategoryColumn) = 0
			Next

			'* * * * * * * * * * * * * * * * * * * * *
			' Default Group Setting ******************
			' * * * * * * * * * * * * * * * * * * * * *
			' The initial setting of the default group can now be set by
			' a selected category and selecting a category item.
			' This can all be configured under system administration options
			' If category group is not enabled or if no category
			' item is selected, it then reverts to the original defaultGroup
			' This assignment is only done during the initial case creation.

			If NewDefaultGroup <> "" Then
				DefaultGroupNumber = NewDefaultGroup ' Over with category group
			End IF

			NewRecord("Group_Number") = DefaultGroupNumber

			' Time Stamp the Case History before we put it into the case record

			Case_History = "{g[" &  DatetimeString & " " & "Created from Email from "  & " ["& customer_id & "] ]g}"  & vbCRLF & Case_History  & vbCRLF

			NewRecord("Case_History") = Case_History

		Else ' Update Case Info when case already exists

			'Most of the fields stay the same.. update the mod_date and modified flag and append to the case history

			NewRecord("modified_flag") = 1
			NewRecord("mod_date") = DateString ' YYYYMMSS
			NewRecord("mod_time") = TimeString ' HHMMSS

			' Do not reset this
			'NewRecord("Case_One_Line") = Case_One_Line

			Current_Case_History = NewRecord("Case_History")

			' Make sure we are not exceeding the size of the case_history field.

			' Append to the bottom of the case

			Case_History = Current_Case_History &	vbCRLF & "{g[" &  DatetimeString &  " " &  wc_Updated_by & " ["& customer_id & "] ]g}"  &  vbCRLF & Case_History & vbCRLF
			If Len(Case_History) < (MaxHistorySize - 10) Then ' Only update is size is ok.
				NewRecord("Case_History") = Case_History
			End If


		End If ' End if Add Record or Update

		NewRecord.Update

	If  err.number>0 then
	      response.write "VBScript Errors Occured:" & "<P>"
	      response.write "Error Number=" & err.number & "<P>"
	      response.write "Error Descr.=" & err.description & "<P>"
	      response.write "Help Context=" & err.helpcontext & "<P>"
	      response.write "Help Path=" & err.helppath & "<P>"
	      response.write "Native Error=" & err.nativeerror & "<P>"
	      response.write "Source=" & err.source & "<P>"
	      response.write "SQLState=" & err.sqlstate & "<P>"
	else
	'      response.write "No VBScript Errors Occured" & "<P>"
	end if
	IF  conn.errors.count> 0 then
	      response.write "Database Errors Occured" & "<P>"
	for counter= 0 to conn.errors.count
	      response.write "Error #" & conn.errors(counter).number & "<P>"
	      response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
	next
	else
	'      response.write "No Database Errors Occured!" & "<P>"
	end if

	NewRecord.Close
	Set NewRecord = Nothing

	Conn.Close
	Set Conn = Nothing


	' If this was a new case, we need to get the case_number for future reference

	If Case_Number = 0 Then

		NewCase = "YES"

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

	'	mySQL2="SELECT * from Cases where Customer_ID = '" & Customer_ID & "' AND Open_date = '" & DateString & "' AND Open_Time = '" & TimeString & "'"
		mySQL2="SELECT max(Case_Number) as maxcase from Cases where Customer_ID = '" & Customer_ID & "' AND Open_date = '" & DateString & "' AND Open_Time = '" & TimeString & "'"
		mySQL2 = mySQL2 & " group by customer_ID, Open_date, open_time "   ' cmb 08/10/12 - getting duplicate case numbers if multiple sent at same time

		' Response.write "SQL=" & mySQL2

		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_number = "Case Not Found - Contact ISS Support "
		Else
			case_number = rstemp2("maxcase")
		End IF

		rstemp2.close
		set rstemp2=nothing

		conntemp.close ' Close the connection
		set conntemp=nothing

	End If '  End of if Case_number = 0


' ****** FILE ATTACHMENT FEATURE START *************
' If enable, one can attach files to the case here.. it will append a line to the case history
' with the file name and provide a link to the new attached file.



		' File Attachement code

		If AllowAttachedfiles = "YES" Then

	'		tempFolder = "c:\temp_attachments"
	'		  If oMsg.CreateFolder( tempFolder ) <> 0 Then
	'			err = "error with Create temporary folder"
	'		  End If

			  aCount = oMsg.GetAttachmentCount()   ' cmb changed from ncount 08/10/12

			' debugging
		'	response.write " Attachment Count = " & aCount  ' cmb changed from ncount 08/10/12

		If aCount > 0 then   ' cmb changed from ncount 08/10/12
			  For FileCount = 1 To aCount   ' cmb changed from ncount 08/10/12
				fileName = oMsg.GetAttachmentName(FileCount)
				nSize = oMsg.GetAttachmentSize(FileCount)

				' Debug
				'response.write "Filename/size = " & filename & "/" & nsize & " Max allowed " & FileUploadMaximumSize

				' First create new name based on case number


				'FileUploadMaximumSize  = 0
				If (CLNG(nSize) >= CLNG(FileUploadMaximumSize)) AND (FileUploadMaximumSize <> 0)  Then  'CMB changed to CLNG 4/26/2011
					FileUploadStatus = "File Attached to Support Email Failure with file: " & FileName & " (" & nSize & " Bytes).  File is too large to upload or other error. "
				Else

				' ********* File Renaming options code *********************************
					NewFileName = "C" & Case_Number & "." & FileName
					' Create the full name of the path and file name
					'FullPathFileName = "C:\wcfiledownloads\" & NewFileName

					'******* need to add slash to physical path
				    FullPathFileName = FileUpLoadDestinationPath & "\" & NewFileName  ' CMB 06/07/2011
					'FullPathFileName = FileUpLoadDestinationPath & NewFileName

					'Debug
					'response.write "FullPathFileNAme = " & FullPathFileName

					' Save file with full pathname and file name
					if (oMsg.SaveAttachmentAs( fullPathFileName, FileCount ) <> 0 )  Then
						Response.write "Error attaching file " & fullpathfilename
					End If

					' Now create a link to the file so we can add it to the case history

		' We must create a full URL link to this file by determining the current
		' URL for DoAttachFiletoCase.asp and then replacing the virtual directory name
		' and also the file name

			 For each key in Request.serverVariables

			 	if Key = "SERVER_NAME" Then
					HostName =  Request.ServerVariables(key)
				End IF

			 	if Key = "SCRIPT_NAME" Then
					SCRIPT_Name =  Request.ServerVariables(key)

					Virtual_Path = replace(Script_Name, "EmailToCase.asp", NewFileName,1,99.1)

					' We next need to replace TechCenter Virtual Directory Name with the
					' the download virtual directory



					If TechCenterVirtualDirectory = "" Then
						TechCenterVirtual = "tech70"
					Else
						TechCenterVirtual = TechCenterVirtualDirectory
					End If

					'Response.write "Virtual_Path = " &  Virtual_Path

					'Response.write "TechCenterVirtual = " & TechCenterVirtual

					Virtual_Path = replace(Virtual_Path, TechCenterVirtual, FileUploadVirtualDirectory,1,99,1)

				End IF

			Next


			FullFileURL = "http://" &  hostname & Virtual_Path

			' Possible customization might be required here if using a alias like Help desk so this line above
			' might be replaced with

			'FullFileURL = "http://" &  hostname & "/wcfiledownloads/"

			FileUploadStatus = "Attached Email File: [" & Filename & "] downloaded and renamed: <<a href=""" & FullFileURL & """>>" & NewFileName  & " (" & nSize & " Bytes)<</a>>"&vbCRLF

		' Now we just need to re-open the case record and append a line to the case history with
		' that has the link to the fule.

' ---------------------- Code to add to case history with link -----------------

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  myDSN


	' This should alway be an update to existing case

	' Check to see if case_number exists then this is an update


		Set NewRecord = Server.CreateObject("ADODB.Recordset")

		If DatabaseType <> "ACCESS97" Then
			NewRecord.CursorLocation = adUseClient
		End If

		SQL = "Select * from Cases where case_number = " & case_number
		'response.write SQL

		NewRecord.Open SQL,Conn,3,3

		If NewRecord.EOF <> True  Then

		' For this, we will only update the case history with a link
		' to the newly attached file but will not
		' send any notification messages to customer or techs

			NewRecord("mod_date") = DateString ' YYYYMMDD
			NewRecord("mod_time") = TimeString ' HHMMSS
			NewRecord("Reopen_Date") = Datestring
			NewRecord("reopen_Time") = TimeString


			' New Change added April 21st Update Modified_flag when file is downloaded
			' to change the color to red for viewing techs

			NewRecord("modified_flag") = 1

			' Time Stamp the Case History before we put it into the case record

			Current_Case_History = NewRecord("Case_History")

			' Make sure we are not exceeding the size of the case_history field.

			' Append to the bottom of the case

			New_Case_History = Current_Case_History &	vbCRLF  &  "{g[" &  DatetimeString &  " File Uploaded From Email "  & "]g}"  &  vbCRLF  & FileUploadStatus

			If Len(New_Case_History) < (MaxHistorySize - 10) Then ' Only update if size is ok.
				NewRecord("Case_History") = New_Case_History
			Else
				Response.Write "Case History size of " & Len(New_Case_History)& " exceeds maximum value of " & MaxHistorySize - 10 & "<br>"
			End If

			NewRecord("Case_History") = Mid(New_Case_History, 1, MaxHistorySize-10)

		NewRecord.Update

		If  err.number>0 then
			  response.write "VBScript Errors Occured:" & "<P>"
			  response.write "Error Number=" & err.number & "<P>"
			  response.write "Error Descr.=" & err.description & "<P>"
			  response.write "Help Context=" & err.helpcontext & "<P>"
			  response.write "Help Path=" & err.helppath & "<P>"
			  response.write "Native Error=" & err.nativeerror & "<P>"
			  response.write "Source=" & err.source & "<P>"
			  response.write "SQLState=" & err.sqlstate & "<P>"
		else
		'      response.write "No VBScript Errors Occured" & "<P>"
		end if
		IF  conn.errors.count> 0 then
			  response.write "Database Errors Occured" & "<P>"
		for counter= 0 to conn.errors.count
			  response.write "Error #" & conn.errors(counter).number & "<P>"
			  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
		next
		else
		'      response.write "No Database Errors Occured!" & "<P>"
		end if

	End IF ' If EOF  <> True

	NewRecord.Close
	Set NewRecord = Nothing

	Conn.Close
	Set Conn = Nothing

' ----------------------------------- End of Code to add link to case history




				End If ' End of IF File size is okay

			  Next

			End If ' One or more attachments must exist

		End If ' End of if File Attachments is enabled


' ****** FILE ATTACHMENT FEATURE END *************



	' Now send out 3 sets of emails including:
	' 	(1) Email to customer with case confirmation
	'	(2) Emails to any techs assigned to the default group
	' 	(3) Emails to any tech assigned to the that case
	'	(4) Additonal Notification Emails to primary Additional Notification Email
	'	and CC list -New for Version 7

'************* Additional Notifications Email Code *************

		If bAdditionalEmails=True Then ' Version 7.5

		'	If AdditionalNotifications <> "" Then ' Additonal notifications is enabled so send out emails


				SendAdditionalNotificationEmail(Case_Number)
		'	End If

		End If  ' End of If Additional Notifications




	'-->AKS<-- ByPassed for now
	'-->SAV<-- Re-enabled

	'**************** CONFIGURATIONS web configured **********************
	' To turn on/off sending emails to customers/techs, comment out lines below

	' Emails to customer can be disable with the EmailToCaseConfiguration page

	If CustomerNotificationEmail = "YES" Then


'	If CustomerNotificationEmail = "YES" AND (NewCase = "YES") Then





		SendEmailToCustomer(Case_Number) ' Email confirmation to customer

	End IF



	' First get the CategoryText so it can be sent out
	' with the Emails going to the techs and to the Groups.

	' This is not needed for emailto case processing.

	'CategoryText = CreateCategoryText(Case_Number)


	If CaseType <> "NEW" OR InitialTechAssignment <> "" Then ' Only send out email to tech if it is an update or InitialTechAssignment is set
		'-->AKS<-- ByPassed for now
		SendEmailToAssignedTech Case_Number , Tech_Assigned_Email
	End If

	' Now send emails to persons assigned to this group
	'-->AKS<-- ByPassed for now
	SendEmailToAssignedGroupTechs Case_Number , Tech_Assigned_Email


' ***** END OF CREATE and Send EMails function

End If  ' End of IF EmailToCaseFailureMSg

End If




    If MsgID = messageId then 'Getting the unqiue identifier of message.
		emailContent = oPop3.Retrieve(k)
		If emailContent = vbNullString Then
			errStr = "Error with Retrieve method"
			Exit For
		End If
		oMsg.RawContent = emailContent 'passing message to POPMSG object.

		Body = oMsg.GetBodyText

'				response.write "body2 = " & body
'
'				response.flush
'				response.end




'		response.write "subject = " & subject
'
'		response.flush
'		response.end


        Randomize
		sPath = tempFolder & "\"
		sFile = CLng(Rnd * 100000) & ".eml" 'randomly generate a file name and save email file to disk
		sPath = sPath & sFile
		If oMsg.ExportFile( sPath ) <> 0 Then
			errStr = "Error with ExportFile method, IUSER_MACHINE doesn't have write permission for this folder: " & tempFolder & "<br>"
			errStr = errStr & ", Please use ImpersonateUser method to run this ASP with administrator"
		End If
        Exit for
      End if

response.write "<B>New Case:</b> " & Case_number &"<br>"
response.write "<B>Subject</b>:" & Subject &"<br>"
response.write "<B>Customer_ID:</b>" & Customer_ID & "<hr>"


'	response.write "<B>Sender Email:</b>" & SenderEmail & "<Br>"
'	response.write "<B>Customer_ID:</b>" & Customer_ID



 Next

'oMsg.RevertToSelf() 'logoff  user

' Do not close connection yet , so we can delete those emails.

'oPop3.Close 'closing connection.

'response.flush
'response.end


' ******** DELETE EMAILS from this account
' Now delete the email so the won't be read again

' CHANGED CODE - use original nCount since more may have come in since started processing
 ' old code in old_delete sub below

  If NumberOfEmails = 0 Then
    'err = "no email"

 	' Call oPop3.Close()   'Close connection
  	 'Set oPop3 = Nothing
  	' Set oMsg = Nothing
  Else
  	 	For i2 = 1 To NumberOfEmails  ' cmb changed from ncount 08/10/12 and i to i2
			 If oPop3.Delete(i2)  <> 0 Then 'Delete email from server
				  response.write "error with Delete"
				  Call oPop3.Close()   'Close connection
				  Set oPop3 = Nothing
				  Set oMsg = Nothing
			'      goto ErrorHandler
			 End If
  		Next
  End If

'ErrorHandler:
  Call oPop3.Close()   'Close connection
  Set oPop3 = Nothing
  Set oMsg = Nothing

' **************************************
' End of DELETE EMAILS sectin
' **************************************

'		response.flush
'		response.end

%>

</td>
</tr>
	</table>

<%
End If ' End if Disable_ALL = "YES"
%>

</BODY>
</HTML>

<%
'	If AnotherMessage = "YES" Then  ' CMB commented outt 08/10/12

	'	ReDirectString = "EmailToCase.asp"
		'response.redirect(ReDirectString)
	'End IF

%>

<%End If ' End of security checks %>

<% SUB OLD_DELETE()
 'Get total count of emails

 If nCount2 = -1 Then   ' cmb changed from ncount 08/10/12
    response.write  "error with GetTotalOfMails"
  Call oPop3.Close()   'Close connection
  Set oPop3 = Nothing
  Set oMsg = Nothing


 '   goto ErrorHandler
  ElseIf nCount2 = 0 Then  ' cmb changed from ncount 08/10/12
    'err = "no email"

  Call oPop3.Close()   'Close connection
  Set oPop3 = Nothing
  Set oMsg = Nothing



'    goto ErrorHandler
  End If

  ' Check if more than one Email has been found, if so the call this whole function again once the program has finished

  If nCount2 > 1 Then   ' cmb changed from ncount 08/10/12
  	AnotherMessage = "YES"
 	Else
 	AnotherMessage = "NO"
 End If

' Only delete 1 message at a time

	If nCount2 > 1 then  ' cmb changed from ncount 08/10/12
		nCount2 = 1  ' cmb changed from ncount 08/10/12
	End If


  For i2 = 1 To nCount2  ' cmb changed from ncount 08/10/12 and i to i2
    If oPop3.Delete(i2)  <> 0 Then 'Delete email from server
		 response.write "error with Delete"
		  Call oPop3.Close()   'Close connection
		  Set oPop3 = Nothing
		  Set oMsg = Nothing
	'      goto ErrorHandler
    End If
  Next

'ErrorHandler:
'  Call oPop3.Close()   'Close connection
'  Set oPop3 = Nothing
'  Set oMsg = Nothing

END SUB
%>
<% Function CreateCaseSendEmails()




	CreateCaseSendEmails = 0
's
 	End Function
%>






<% ' Functions to Escalate Cases %>

<%Sub CreateTimeDateValues( DateString, TimeString, DateTimeString)
'	This Sub creates the TimeDate values that are used
' 	when adding or updating the case record

	' We must very carefully create the date string that we are going to
	' use in the SQL instruction since the system can easily
	' return incorrect values like 9/12/99 or 09/12/1999
	' depending upon their regional settings so this code
	' will hopefully extract the right values.


	' Compute the new Date and Time based on Server Time Zones plus
	' or minus the Time Zone Adjustments.  The time difference between
	' the Server Time and time where the web transaction is taking
	' placing is set by the variable called TimeZoneAdjustment

	'TimeZoneAdjustment = 0 ' Set this +/- Server Time Zone

	'TimeZoneAdjustment is set in the System Configuration Menu
	' Stored in Database as String
	If TimeZoneAdjustment = "" Or IsNull(TimeZoneAdjustment) Then
		TimeZoneAdjustmentInt = 0
	Else
		TimeZoneAdjustmentInt = CInt(TimeZoneAdjustment)
	End If

	' Time Zone Label is also stored in configurable table in DB

	'TimeZoneLabel = "(PST)"

	NewDate = DateAdd("h", TimeZoneAdjustmentInt, Now)

	CurrentDateFormatted = CStr(Year(NewDate))

	If len(CStr(Month(Date))) < 2 then
		CurrentDateFormatted = CurrentDateFormatted & "0" & CStr(Month(NewDate))
	Else
		CurrentDateFormatted = CurrentDateFormatted & CStr(Month(NewDate))
	End If

	If len(CStr(Day(Date))) < 2 then
		CurrentDateFormatted = CurrentDateFormatted & "0" & CStr(Day(NewDate))
	Else
		CurrentDateFormatted = CurrentDateFormatted & CStr(Day(NewDate))
	End If

	DateString = CurrentDateFormatted ' In YYYYMMDD format

	' Now Create the time string in the format of HHMMSS

	TimeString = Right("0" & Hour(time), 2) & Right("0" & Minute(time),2) & Right("0" &Second(time),2)
	TimeString = Right("0" & DatePart("h",NewDate), 2) & Right("0" & DatePart("n", NewDate),2) & Right("0" & DatePart("s", NewDate),2)

	DateTimeString= Date & " " & time

	DateTimeString =    WeekDayName(Weekday(NewDate)) & " " & MonthName(Month(NewDate)) & " " & Day(NewDate) & ", " & Year(NewDate) & " " & Time
	DateTimeString =    WeekDayName(Weekday(NewDate)) & " " & MonthName(Month(NewDate)) & " " & Day(NewDate) & ", " & Year(NewDate) & " "
	' Now computer the time in HH:MM PM/AM
	HourPart = DatePart("h", NewDate)
	If HourPart > 12 Then
		HourPart = HourPart - 12
		DateTimeString = DateTimeString & HourPart & ":" & Right("0" & DatePart("n", NewDate),2) & " PM " & TimeZoneLabel
	Else
		DateTimeString = DateTimeString & HourPart & ":" & Right("0" & DatePart("n", NewDate),2) & " AM " & TimeZoneLabel
	End IF


	End Sub ' End of CreateTimeDateValues
%>



<% Sub GetDatabaseConfiguration(MaxHistorySize, MaxSummarySize, MaxResolutionSize, smtp_host_address,Standard_reply_to_address, Customer_case_notify, userpagecolor)
	'This function gets the database configuration information
	' including the max size of the history field and
	' the email message appendages


		mySQL2="select * from Configuration"
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			MaxHistorySize = 2000 ' Default to white if record not found
		Else
		    MaxHistorySize =  CLng(rstemp2("max_case_history_size"))
			MaxSummarySize =  rstemp2("max_case_summary_size")
			MaxResolutionSize =  rstemp2("max_case_resolution_size")

			smtp_host_address = rstemp2("smtp_host_address")
			Standard_reply_to_address = rstemp2("Standard_reply_to_address")
			Customer_case_notify = CInt(rstemp2("customer_case_notify"))
			UserPageColor = rstemp2("ts_user_page_color")
		End If

		rstemp2.close
		set rstemp2=nothing


	End Sub ' End of GetdatabaseConfiguration
	%>



<% Sub SendEscalationEmail(Case_Number, Tech_Assigned_Email)
	'	This subroutine sends out a notification email to individual for
	' case escalation.

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL5="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL5)

	If  err.number>0 then
	      response.write "VBScript Errors Occured:" & "<P>"
	      response.write "Error Number=" & err.number & "<P>"
	     response.write "Error Descr.=" & err.description & "<P>"
	      response.write "Help Context=" & err.helpcontext & "<P>"
	      response.write "Help Path=" & err.helppath & "<P>"
	      response.write "Native Error=" & err.nativeerror & "<P>"
	      response.write "Source=" & err.source & "<P>"
	      response.write "SQLState=" & err.sqlstate & "<P>"


	else
	      ' response.write "No VBScript Errors Occured" & "<P>"
	end if


	IF  conntemp.errors.count> 0 then
	    response.write "Database Errors Occured" & "<P>"
		for counter= 0 to conntemp.errors.count
		      response.write "Error #" & conntemp.errors(counter).number & "<P>"
		      response.write "Error desc. -> " & conntemp.errors(counter).description & "<P>"
		next

	else
	      ' response.write "No Database Errors Occured!" & "<P>"
	end if



		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1
			Tech_ID = ""

		Else
			' Get all of the information while we are here

			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Tech_ID = rstemp2("Tech_ID")
			Customer_ID = rstemp2("Customer_ID")
			PriorityID = rstemp2("Severity")

			' Perform another query to get the Priority text
			mySQL6="SELECT * from Priority where PriorityID = " & PriorityID
			set rstemp4=conntemp.execute(mySQL6)

			PriorityText = rstemp4("ShortDesc")
			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			' Perform another query to get the Tech's Full Name

			If IsNull(Tech_ID) = False OR Tech_ID <> "" Then
				mySQL6="SELECT * from Tech_staff where Tech_ID = '" & Tech_ID & "'"
				set rstemp4=conntemp.execute(mySQL6)

				If rstemp4.EOF <> True Then
				Tech_Full_Name =  rstemp4("First_name") & " " & rstemp4("Last_name")
			    End If

			    ' Close record set

			   rstemp4.close
			   set rstemp4 = nothing
			End If


			'******* CELL PHONE EMAIL TEXT FIELDS *****************************
			' Perform another query to get the customer information so
			' it can be displayed in the email for text page cell phone email
			' We will grab the two phone numbers and company name

			mySQL6="SELECT * from Customers where customer_id = '" & Customer_ID & "'"
			set rstemp4=conntemp.execute(mySQL6)


			CustomerCompany = rstemp4("Company")
			CustomerPhone1 = rstemp4("Phone1")
			CustomerPhone2 = rstemp4("Phone2")


			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			'********** CELL PHONE EMAIL TEXT FIELD ENDING

		End If

		rstemp2.close
		set rstemp2=nothing


			Message = ""

			' Now Build the Whole message body
			' *********************** USER CUSTOMIZATIONS**********************
			' The fix part of the message that is sent out can be modified by
			' changing the text below.


			Message = Message & vbCRLF & wc_Case_capital_letters & " " & case_number & "  " & wc_Case_Escalation_Notification_for_case & vbCRLF

			' Now display a link directly to the tech+center for that case window.

			' Get the full server http URL for the direct LINK.
		 For each key in Request.serverVariables

			if Key = "SERVER_NAME" Then
				HostName =  Request.ServerVariables(key)
			End IF

			if Key = "SCRIPT_NAME" Then
				SCRIPT_Name =  Request.ServerVariables(key)
				' Replace DoEmailListSend.asp with RemoveFromList.asp
				' This will handle all of the necessary virtual directory mappings

				' Make this subsitution case insensitive with the 1,99,1

				'Virtual_Path = replace(Script_Name, "escalation.asp", "SC.asp")
				Virtual_Path = replace(Script_Name, "escalation.asp", "SC.asp",1,99,1)

			End IF

		Next

			Message = Message & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF
			Message = Message &  "http://" &  hostname & Virtual_path &"?ID=" & Tech_ID & "&N=" & Case_Number & vbCRLF

				' Create Case Link for HTML message
			CaseLink = "http://" &  hostname & Virtual_path &"?ID=" & Tech_ID & "&N=" & Case_Number


			Message = Message & vbCRLF & wc_Tech_assignment & Tech_Full_Name & vbCRLF

			Message = Message & wc_Case_Number_capital_letters  & Case_Number & vbCRLF
			Message = Message & wc_Case_Status_capital_letters

			If CInt(Status) = 1 Then
				Message = Message & wc_Closed & vbCRLF
			ElseIf CInt(Status) = 0 Then
				Message = Message & wc_Open_Active & vbCRLF
			ElseIf CInt(Status) = 2 Then
				Message = Message & wc_Open_Waiting	& vbCRLF
			ElseIf CInt(Status) = 3 Then
				Message = Message & wc_Open_On_Hold & vbCRLF
			End If
			Message = Message & wc_Priority_capital_letters & PriorityText & vbCRLF

			Message = Message & wc_Customer_ID_capital_letters & Customer_ID & vbCRLF
			Message = Message & wc_Phone_numbers_capital_letters & CustomerPhone1 & "/" & CustomerPhone2 & vbCRLF

			Message = Message & wc_Case_description_capital_letters & Case_One_Line & vbCRLF

			Message = Message & CategoryText ' Display category text

			' The special color codes have to be removed before sending the case_history

			Case_Text = Case_History
			Case_History = CleanUpHistoryText(Case_Text)
			Message = Message & wc_Case_History & ": " & vbCRLF & Case_History & vbCRLF

			If Case_Summary <> "" Then
				Message = Message & wc_Case_summary_head & vbCRLF & Case_Summary & vbCRLF
			End IF
			If Case_Resolution <> "" Then
				Message = Message & wc_Case_Resolution_head & vbCRLF & Case_Resolution & vbCRLF
			End If

			' Do not remove this line.
			Message = Message & EmailChecksum


			SubjectLine = wc_Case_email_subject1 & Case_Number & wc_Case_email_subject2

			' Now we have everything we need to send the email to the tech
			' Only send the message if ToEmail exists and

			If HTMLEmail = "YES" Then

				'NotificationReportTitle = wc_Notification_Report_Assigned_Tech_update
				NotificationReportTitle = wc_Notification_Report_Case_Escalation


				AltBody = Message ' First save Text message into separate variable
				Message = CreateHTMLTechMsg(Case_Number, CaseLink, NotificationReportTitle)

				' Debugging
				'response.write Message


			End IF





			If Tech_Assigned_Email <> ""   Then
				'Response.write "Sending Email for Escalation"

			   If MyOS = "Windows" Then
				 SendEmail Tech_Assigned_Email, "", SubjectLine, Message
			   Else
				 SendLinuxEmail Tech_Assigned_Email, "", SubjectLine, Message
			   End If

			End If




End Sub ' End of SendEscalationEmail() subroutine
%>

<% Sub EscalateUpdateNewCase(Case_Number, NewCase_Group)

' This sub will perform the necessary updating to the case by:
'	(1) Updating the Mod Time with the current time and Date
'	(2) Upating the history showing that the case was escalated
'	(3) Show that the group was modifed to specified group if needed


	' First create the Date and Time strings

	CreateTimeDateValues DateString, TimeString, DateTimeString


	' Check to see if case_number exists then this is an update


		Set NewRecord = Server.CreateObject("ADODB.Recordset")

		If Case_Number = "0" Then
			SQL = "Select * from Cases"
		Else
				SQL = "Select * from Cases where case_number = " & case_number
		End IF

		'response.write SQL
		'response.write "Escalating/Updating Case: " & Case_Number

		NewRecord.Open SQL,Conntemp,3,3

		' We should only need to do existing case updates

			NewRecord("modified_flag") = 1
			NewRecord("mod_date") = DateString ' YYYYMMSS
			NewRecord("mod_time") = TimeString ' HHMMSS


			'NewRecord("Case_One_Line") = Case_One_Line

			' *************************************************************
			' Only a limited set of fields will be updated by escalation!
			'**************************************************************

			Current_Case_History = NewRecord("Case_History")

			' Make sure we are not exceeding the size of the case_history field.

			' Append to the bottom of the case

			New_Case_History = Current_Case_History &	vbCRLF & "{r[" &  DatetimeString &  " Updated by [Escalation PROCESS] ]r}"  &  vbCRLF

			' Now Add in any info about changed records for Tech, Status, group and priority
			Old_Group_Number = Cint(NewRecord("Group_Number"))


			' Newcase_Group is passed as a parameter to this sub

			If NewCase_Group <> 0 Then

				If Old_Group_Number <> Newcase_Group then
					NewGroupName = GroupFullName(Newcase_Group)
					GroupChanged = "YES"
					New_Case_History = New_Case_History &  wc_Case_Escalation_changed_group_to  & NewGroupName & vbCRLF

					' Reset the group to the new escalation group
					NewRecord("Group_Number") = Newcase_Group

				End IF
			End IF ' Only process new group if group is not zero

	'		Old_Priority = CStr(NewRecord("Severity"))
	'		If Old_Priority <> Case_Severity then
	'			NewPriority = PriorityFullDescription(Case_Severity)
'
	'			New_Case_History = New_Case_History & wc_Case_priority_changed_to    & NewPriority & vbCRLF
	'		End IF


			New_Case_History = New_Case_History  & wc_Case_History & ": " & vbCRLF & Case_History & vbCRLF
			If Len(New_Case_History) < (MaxHistorySize - 10) Then ' Only update is size is ok.
				NewRecord("Case_History") = New_Case_History
			Else
				Response.Write wc_Case_History_size_of & Len(New_Case_History) & wc_exceeds_maximum_value_of & MaxHistorySize - 10 & "<br>"
			End If


			' Update Summary and Resolution Fields
			' Limit the size based on the max case resolution and summary sizes

			' Only update these fields if the case_resolution or
			' case_summary is not empty.  DO NOT RESET these
			' from their null values

			If Case_Resolution <> "" Then
				NewRecord("Case_Resolution") = Mid(Case_Resolution, 1, MaxResolutionSize - 5)
			End If

			IF Case_Summary <> "" Then
				NewRecord("Case_Summary") = Mid(Case_Summary, 1, MaxSummarySize - 5)
			End IF

		NewRecord.Update

	If  err.number>0 then
	      response.write "VBScript Errors Occured:" & "<P>"
	      response.write "Error Number=" & err.number & "<P>"
	      response.write "Error Descr.=" & err.description & "<P>"
	      response.write "Help Context=" & err.helpcontext & "<P>"
	      response.write "Help Path=" & err.helppath & "<P>"
	      response.write "Native Error=" & err.nativeerror & "<P>"
	      response.write "Source=" & err.source & "<P>"
	      response.write "SQLState=" & err.sqlstate & "<P>"
	else
	'      response.write "No VBScript Errors Occured" & "<P>"
	end if


	IF  conntemp.errors.count> 0 then
	    response.write "Database Errors Occured" & "<P>"
		for counter= 0 to conntemp.errors.count
		      response.write "Error #" & conntemp.errors(counter).number & "<P>"
		      response.write "Error desc. -> " & conntemp.errors(counter).description & "<P>"
		next
	else
	      'response.write "No Database Errors Occured!" & "<P>"
	end if

	NewRecord.Close
	Set NewRecord = Nothing


	End Sub

%>


<% Sub SendEscalationCellEmail(Case_Number, Email_Address)

	' First we determine if case has a tech assigned to it.

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL7="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL7)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1
			Tech_ID = ""

		Else
			' Get all of the information while we are here

			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Tech_ID = rstemp2("Tech_ID")
			Customer_ID = rstemp2("Customer_ID")
			PriorityID = rstemp2("Severity")

			' Perform another query to get the Priority text
			mySQL8="SELECT * from Priority where PriorityID = " & PriorityID
			set rstemp4=conntemp.execute(mySQL8)

			PriorityText = rstemp4("ShortDesc")
			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			'******* CELL PHONE EMAIL TEXT FIELDS *****************************
			' Perform another query to get the customer information so
			' it can be displayed in the email for text page cell phone email
			' We will grab the two phone numbers and company name

			mySQL8="SELECT * from Customers where customer_id = '" & Customer_ID & "'"
			set rstemp4=conntemp.execute(mySQL8)


			CustomerCompany = rstemp4("Company")
			CustomerPhone1 = rstemp4("Phone1")
			CustomerPhone2 = rstemp4("Phone2")


			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			'********** CELL PHONE EMAIL TEXT FIELD ENDING

		End If

		rstemp2.close
		set rstemp2=nothing


		'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************
		' To enable a short condensed email to be sent to a tech cell email address/home email
		' beginning of the email message, comment/uncomment the
		' variable definition below
		CELLPHONE_EMAIL_NOTIFICATION = "YES" ' Comment out this line to disable
		'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************

		If CELLPHONE_EMAIL_NOTIFICATION = "YES" Then
			CellMessage = ""
			CellMessage = CellMessage & Customer_ID & vbCRLF & CustomerCompany & vbCRLF &vbCRLF
			CellMessage = CellMessage & CustomerPhone1 & vbCRLF  & CustomerPhone2  & vbCRLF
			CellMessage = CellMessage & "->" & Case_One_Line & vbCRLF
			CellSubjectLine = wc_Alert
		End If


	   If MyOS = "Windows" Then
		  SendEmail Email_Address, "", CellSubjectLine, CellMessage
	   Else
	     SendLinuxEmail Email_Address, "",  CellSubjectLine, CellMessage
	   End If




End Sub ' End of SendEscalationCellEmail() subroutine
%>


<% Function GroupFullName(Group_Number)
	'This function gets the full name of the Passed Group Number
		If Group_Number = "" Then
			GroupFullName = "Default Group"
		Else

			mySQL8="select * from Group_list where Group_Number = " & Group_Number
			set rstemp2=conntemp.execute(mySQL8)

			' Check to see if any records are returned
			' if none found the
			if rstemp2.EOF then
				GroupFullName = "Group Not Defined"
			Else
				GroupFullName = rstemp2("Group_Name")
			End If

			rstemp2.close
			set rstemp2=nothing


		End If

	End Function ' End of GroupFullName
%>


<% Function CleanUpHistoryText(Case_Text)
' This functions removes all of the special color coding codes
' that exists in the case_history field so when the email is sent it sends
' it without all of those funny colors.


' This subroutines formats the case_text with the proper color coding conventions

NewText = Case_Text
	' Tags entered by the user can be security issue so we will replace
	' them with printable html text of &lt; and & gt;


		' Replace the special color coding characters

		NewText = Replace (Newtext, chr(10), vbCRLF)

		NewText = Replace (NewText, "{g[", "")

		NewText = Replace (NewText, "{r[", "")

		NewText = Replace (NewText, "]r}", "")

		NewText = Replace (NewText, "]g}", "")

'		NewText = Replace (NewText, vbLF, vbCRLF)

		' There are some places where we have put LFCR
		' at the end of the end of the lines in techcenter
'		NewText = Replace (NewText, vbLF & vbCR, vbCRLF)

		' Other places have just LF (10)
'		NewText = Replace (Newtext, vbCR, vbCRLF)

	CleanUpHistoryText = NewText

'	For i = 1 to len(NewText)
'		NewMessage  = NewMessage & mid(NewText,i,1)
'		NewMessage = NewMessage & "[" & asc(mid(NewText,i,1)) & "]"
'	next

'	response.write NewMessage


'	CleanUpHistoryText = Case_Text

End function
%>


<% Function CheckForUniqueTableValues(Tablename, Columnname, tablevalue)
	'This function checks to see if the passed column for a selected
	' table is unique (ie email in customer table, username, etc)
	' This functions either a "UNIQUE" or "NOTUNIQUE" returns

		' Notice we using another connection incase we already using conntemp.

		set conntemp2=server.createobject("adodb.connection")

		conntemp2.open myDSN ' Open the connection once here


		' Fix for username with single quotes in them

		FixedTableValue = replace(TableValue, "'", "''")

		mySQL2="select * from " & tablename & " where " & Columnname & " = '" & FixedTableValue & "'"

		set rstemp5=conntemp2.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp5.EOF then
			CheckForUniqueTableValues = "UNIQUE"
		Else
			CheckForUniqueTableValues = "NONUNIQUE"
		End If

		rstemp5.close
		set rstemp5=nothing

		conntemp2.close ' Close the connection
		set conntemp2=nothing

	End Function ' End of CheckForUniqueTableValues
	%>


<% Function GetDefaultGroupNumber()
' This functions gets the current default group number from
' the Group_List table by searching for the row where the
' default flag = 1 and grabbing the group_number

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		mySQL2="select * from Group_list where default_flag = 1"
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			' There should always be a default group
			' send out an error
			response.write " No default group is set "
			Group_Number = 1
		Else
			GetDefaultGroupNumber = rstemp2("Group_number")


		End If

		rstemp2.close
		set rstemp2=nothing

		conntemp.close ' Close the connection
		set conntemp=nothing

	End Function
%>

<% Function GetCasestatus(CaseNumber)
	' This function gets the case status information for existing cases
	' to see if it is closed or open.  This function returned "OPEN" Or "CLOSED"
		' Now get case information
		set conntemp=server.createobject("adodb.connection")
				conntemp.open myDSN

				mySQL2="SELECT * from Cases where Case_Number = " & CaseNumber

				set rstemp=conntemp.execute(mySQL2)

				' Check to see if any records are returned
				' if none found the

				If rstemp.EOF = True Then
					GetCasestatus = "OPEN" ' Set this variable to prevent problems on next page
				Else
					'-->AKS<-- Added CInt casting below.
					If CInt(rstemp("Status")) = 1 Then
						GetCasestatus = "CLOSED"
					Else
						GetCasestatus = "OPEN"
					End IF
				End If

				rstemp.close
				set rstemp=nothing
				conntemp.close ' Close the connection
				set conntemp=nothing

	End Function ' End of GetCasestatus
%>

<% Sub SendEmailToCustomer(Case_Number)
'	This subroutine sends out a confirmation email to the customer.
	' From the case number we need to first get the customer's email address


		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		mySQL2="SELECT Customers.contact_fname, Customers.contact_lname, Customers.email, Cases.case_number FROM Cases INNER JOIN Customers ON Cases.customer_id = Customers.customer_id where case_number = "& case_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			ToEmail = ""
		Else
			ToEmail = rstemp2("email")
			ToFullName = rstemp2("contact_fname") & " " & rstemp2("contact_lname")

		End If

		rstemp2.close
		set rstemp2=nothing

		' Now get the part of the email message that should be sent out when cases are created

		mySQL2="SELECT * from Email_text" ' There should only be one row in this table
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			NewCaseMessage = ""
		Else
			NewCaseMessage = rstemp2("customer_update_case")
		End If

		rstemp2.close
		set rstemp2=nothing

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL2="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1

		Else
			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")

		End If

		rstemp2.close
		set rstemp2=nothing


		conntemp.close ' Close the connection
		set conntemp=nothing

		' Now Build the Whole message body
		' *********************** USER CUSTOMIZATIONS**********************
		' The fix part of the message that is sent out can be modified by
		' changing the text below.

		Message = ""
		Message = NewCaseMessage
		Message = Message & vbCRLF & wc_Your_current_case_information_is & vbCRLF
		Message = Message & wc_Case_Number_capital_letters & Case_Number & vbCRLF
		Message = Message & wc_CASE_STATUS_CAPITAL_LETTERS
		If Status = 1 Then
			Message = Message & wc_Closed & vbCRLF
		Else
			Message = Message & wc_Open & vbCRLF
		End If
		Message = Message & wc_Customer_ID_capital_letters & Customer_ID & vbCRLF
		Message = Message & wc_CASE_ONE_LINE_DESCRIPTION & Case_One_Line & vbCRLF & vbCRLF

		' The special color codes have to be removed before sending the case_history

		Case_Text = Case_History
		Case_History = CleanUpHistoryText(Case_Text)
		Message = Message & wc_Case_History & ":"& vbCRLF & Case_History & vbCRLF

		If Case_Summary <> "" Then
			Message = Message & wc_Case_summary_head & vbCRLF & Case_Summary & vbCRLF
		End If

		If Case_Resolution <> "" Then
			Message = Message & wc_Case_Resolution_head & vbCRLF & Case_Resolution & vbCRLF
		End If

		' Now display a link back to the Customer+Cente Home page for Future reference

		' Now display a link directly to the tech+center for that case window.

		' Get the full server http URL for the direct LINK.
		 For each key in Request.serverVariables

		if Key = "SERVER_NAME" Then
			HostName =  Request.ServerVariables(key)
		End IF

		if Key = "SCRIPT_NAME" Then
			SCRIPT_Name =  Request.ServerVariables(key)
			' Replace DoEmailListSend.asp with RemoveFromList.asp
			' This will handle all of the necessary virtual directory mappings

			Virtual_Path = replace(Script_Name, "EmailToCase.asp", "DCF.asp")

		End IF

	Next



		' ******** Important User Customizations ***************
		' The Customer+Center virtual directory must be specified here
		' since it may not be customer70 if you are using a non-default name
		' Set your customer+center virtual directory name below
		' Also set if you want to turn on this embedded link to customer+center
		' then un-comment or comment out the SendCustomerCenterLink variable line below.

		' Set these to exactly your virtual directory names... this is case sensitive

		'CustomerCenterVirtual = "customer70"
		'TechCenterVirtual = "tech70"


		'CustomerCenterVirtual = CustomerVirtual
		'TechCenterVirtual = TechVirtual ' Obtain this from the database


		If CustomerVirtual = "" Then
			CustomerCenterVirtual = "customer70"
		Else
			CustomerCenterVirtual = CustomerVirtual ' Grab it from database
		End IF

		If TechVirtual = "" Then
			TechCenterVirtual = "tech70"
		Else
			TechCenterVirtual = TechVirtual
		End If




		' ******************* START customizations *************************************
		' If you do not want to provide a customer link then comment out this line

		SendCustomerCenterLink = "YES" ' Defaults to  including link - comment to remove

		' ********** End User Customizations ***********************

		Virtual_Path = replace(Virtual_path, TechCenterVirtual, CustomerCenterVirtual,1,99,1)

		If SendCustomerCenterLink <> "" Then

			Message = Message & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF
			'--- create url with obfuscated customer_id and MODE=auto to enable automatic logging in with DCF.asp -------
			CaseLink = "http://" &  hostname & Virtual_path & "?MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Customer_ID))
			Message = Message &  Caselink & vbCRLF & vbCRLF


		End IF





           ' response.write "Case customer id is ----" & Customer_ID & "++++++<p>"
           'response.flush
           ' response.end

'			Message = Message & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF
'			'--- create url with obfuscated customer_id and MODE=auto to enable automatic logging in with DCF.asp -------
'			CaseLink = "http://" &  hostname & Virtual_path & "?MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Customer_ID))
'			Message = Message &  Caselink & vbCRLF & vbCRLF


		' Do not remove this line.

		Message = Message & EmailChecksum


		If HTMLEmail = "YES" Then

			NotificationReportTitle = wc_Notification_Report_Support_Case_Update

			Updatedby = "customer"

			AltBody = Message ' First save Text message into separate variable
			Message = CreateHTMLCustomerMsg(Case_Number, CaseLink, NotificationReportTitle, updatedby)


			' Debugging
			'response.write Message


		End IF







		'*************************************************
		' ********** User Customization Options ***********
		' Edit the subject line string below to change the subject
		'**************************************************


		If CaseType = "NEW" Then
			SubjectLine = "Support Case [" & Case_Number & "] " & wc_Opened

		End IF

		If Status = 1  Then
			SubjectLine = "Support Case [" & Case_Number & "] " & "Updated"
		End If

		If (Status <> 1) and CaseType <> "NEW" Then
			SubjectLine = "Support Case [" & Case_Number & "] Update"
		End If



'		SubjectLine = "Support Case ["& Case_number & "]  New Or Update "
		' This subject has the case number so we can parse it for appending to the case rather
		' than creating a new case.


		' Now we have everything we need to send the email to the customer
		' Only send the message if ToEmail exists and Customer_case_notify flag is set

		If ToEmail <> ""  And Customer_case_notify = 1 Then
		  If MyOs = "Windows" Then
			SendEmail ToEmail, ToFullName, SubjectLine, Message
		  Else
			SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
		  End If
		End If


	'********************* Customization for second manager email - START of customization ****
	' Customization to send a second email to customers manager inside of the mailstop field.
	' uncomment the line below to enable sending an second email to a second customer email
	' address obtained from the mailstop field.

	'SendSecondEmail = "YES"

	if SendSecondEmail = "YES" Then

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here


		mySQL2="SELECT Customers.mailstop FROM Cases INNER JOIN Customers ON Cases.customer_id = Customers.customer_id where case_number = "& case_number

		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			SecondEmailAddress = ""
		Else
			SecondEmailAddress = rstemp2("mailstop")

		' Custom code to build that email address from first name letter and last name
'			spacefound = "NO"
'			for i=1 to len(SecondEmailAddress)
'				if mid(SecondEmailAddress,i,1) = " " Then
'					SpaceFound = "YES"
'				End If
'
'				if spacefound = "NO" THen
'					FirstNameValue = FirstNameValue & mid(SecondEmailAddress, i, 1)
'				ELSE
'					SecondNAmeValue = SecondNameVAlue & mid(secondemailaddress,i,1)
'				End IF
'			Next
'
'			' Some custom string additions to create the email address
'			NewSecondEmailaddress= left(FirstNameValue,1) & SecondNAmeValue & "@mycompany.com"
'			NewSecondEmailAddress = replace(NewSecondEmailAddress, " " , "")
'
'			'debugging
'
'			'response.write "NewEmailAddress = " & NEwSecondEmailAddress
'			'response.flush
'			'response.end

			NewEmailAddress = SecondEmailAddress

			ToFullName = NewEmailAddress
			ToEmail = NewEmailAddress

		End If

		rstemp2.close
		set rstemp2=nothing

			 If MyOS = "Windows" Then
				SendEmail ToEmail, ToFullName, SubjectLine, Message
			 Else
				SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
			 End If


		conntemp.close ' Close the connection
		set conntemp=nothing

	End If ' End of If SendSecondEmail = "YES"

	'********************* Customization for second manager email - START of customization ****





End Sub ' End of SendEmalToCustomer() subroutine
%>

<%

' -------------------------------------------------------------------

Function Obfuscate(Mystring)

seedx = Timer()
' response.write "seedx is " & seedx & "<P>"
If Instr(seedx,".") Then
 aryseed = split(seedx,".")
 seed = Cdbl(aryseed(0)) + Cdbl(aryseed(1))
Else
 seed = 12345
End If



'response.write "seed is " & seed & "<P>"

Randomize(seed)
' response.write  " and seed is " & seed & "<br>"


strlength = Len(Mystring)

'response.write "The string is " & Mystring & " which has length of " & strlength & "<BR>"


Dim Arystring(80)


fuse = 0

  ' put in initial population

  For I = 0 to Strlength - 1
      Arystring(I) = PickOne(Strlength)
  Next

  Valid = "No"

While Valid = "No"
	 Valid = "Yes"
	 'response.write "--------------------------------BREAK----------------------------------<p>"
	 For I = 0 to Strlength - 1
	   For J = 0 to I
		 If I <> J Then ' dont compare with self
			  'response.write " comparing pos " & I & " which contains " & Arystring(I) & " with pos " & J & " which contains " & Arystring(J) & "<BR>"
			  if Arystring(I) = Arystring(J) Then
			     Valid = "No"
			     ' response.write "Dup found<br>"
			     Arystring(I) = PickOne(Strlength)
			  end if
			  fuse= fuse + 1
			  if fuse > 30000 Then
						response.write "----------------abort----------"
						response.flush
						response.end
			  End if
		End If
	   Next

	 Next
Wend



Arystring(Strlength) = (Strlength) ' Plant the length
'response.write "-----------Length set in pos " & Strlength & "<BR>"


For I = 0 to Strlength - 1 ' now that we have position vectors in place, plant the secret message
	 offset = Arystring(I)

	 ThisChar = Mid(MyString,I+1,1)
	 ThisChar = Asc(ThisChar) - 48
	 Arystring(offset) = ThisChar
	 'response.write "Planting " & ThisChar & " in position " & Offset & " which is " & Chr(ThisChar+48) & "<BR>"
Next

' Now fill in the empties with random values


	for i = 0 to 79
		 if Arystring(i) = "" Then
		   Arystring(i) = Int(Rnd()*78) + 1
		 End if
	next


Target = "" ' and now we add 48 to each element
for i = 0 to 79
	 if Arystring(i) <> "" Then
		'response.write "String pos " & i & " is " & Arystring(i) & " which maps to " & Arystring(i)+48 & " which is the character " & Chr(Arystring(i)+48) & "<br>"
	 else
		'response.write "String pos " & i & " is " & "&#920;<br>"
	 End if
	 Target = Target & Chr(Arystring(i)+48)
Next

Obfuscate = Target

End Function

%>

<%

' -------------------------------------------------------------------
Function PickOne(MinVal)
  candidate = Int(Rnd()*78) + 1
  TooLow = "Yes"
  While TooLow = "Yes"
	  If candidate <= MinVal Then
		'response.write "Candidate " & candidate & " is Too Low<br>"
		candidate = Int(Rnd()*78) + 1
	  Else
		TooLow = "No"
	  End If
  Wend

  PickOne = candidate
End Function

%>

<% Function GetCategoryNameAndItem(CategoryNumber, CategoryItem)
	' This function gets passed the category number and category item and returns
	' a formatted string with it.


	set conntemp5=server.createobject("adodb.connection")
	conntemp5.open myDSN ' Open the connection once here


			mySQL4 = "select * from Categories where category_number = " & CategoryNumber & " AND Item_number = " & CategoryItem


			'response.write mySQL4 ' Debugging only

			set rstemp8=conntemp5.execute(mySQL4)


			If rstemp8.EOF <> True THEN
				Item_name = rstemp8("Item_name")
				CategoryName = rstemp8("Category_name")

				CategoryString = CategoryString &  "  [" & CategoryName & "==" & Item_Name & "]"
				'CategoryString = CategoryString & vbCRLF
				' Close this intermediate record set

			End If

			rstemp8.close
			set rstemp8=nothing


		'If CategoryString = ""  then
		'	CategoryString =  wcNone
		'End If




	conntemp5.close ' Close the connection
	set conntemp5=nothing


GetCategoryNameAndITem = CategoryString

End Function
%>

<% Sub SendAdditionalNotificationEmail(Case_Number)
'	This subroutine sends out a notification email to the persons defined in the tech+center
	' From the case number.. we can get the CC list and Primary notification email
	' is found in the configuration table.


		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here
		If DatabaseType = "ORACLE" Then
			mySQL2="SELECT Customers.contact_fname, Customers.contact_lname, Customers.email, Cases.case_number FROM Cases, Customers where Cases.customer_id = Customers.customer_id and case_number = "& case_number
		Else
			mySQL2="SELECT Customers.contact_fname, Customers.contact_lname, Customers.email, Cases.case_number FROM Cases INNER JOIN Customers ON Cases.customer_id = Customers.customer_id where case_number = "& case_number
		End If
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			ToEmail = ""
		Else
			ToEmail = rstemp2("email")
			ToFullName = rstemp2("contact_fname") & " " & rstemp2("contact_lname")

		End If

		rstemp2.close
		set rstemp2=nothing

		' Now get the part of the email message that should be sent out when Cases
		' are updated or created by the Tech+Center.

		mySQL2="SELECT * from Email_text" ' There should only be one row in this table
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			NewCaseMessage = ""
		Else
			NewCaseMessage = rstemp2("tech_update_case")
		End If

		rstemp2.close
		set rstemp2=nothing

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL2="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1

		Else
			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Case_customer_ID = rstemp2("Customer_ID")
			Status = CInt(Status)

			If bAdditionalEmails=True Then ' Version 7.5
				AdditionalCCList = rstemp2("AdditionalCCList") ' CC list
				AdditionalNotifications = rstemp2("AdditionalNotifications") ' Set to 0 or 1 if primary additional notifications enabled
			End If

		End If

		rstemp2.close
		set rstemp2=nothing


		conntemp.close ' Close the connection
		set conntemp=nothing

		' Now Build the Whole message body
		' *********************** USER CUSTOMIZATIONS**********************
		' The fix part of the message that is sent out can be modified by
		' changing the text below.

		Message = ""
		Message = NewCaseMessage
		Message = Message & vbCRLF & wc_Your_current_case_information_is & vbCRLF
		Message = Message & wc_Case_Number_capital_letters & Case_Number & vbCRLF
		Message = Message & wc_CASE_STATUS_CAPITAL_LETTERS
		If Status = 1 Then
			Message = Message & wc_Closed & vbCRLF
		Else
			Message = Message & wc_Open & vbCRLF
		End If
		Message = Message & wc_Customer_ID_capital_letters & Case_Customer_ID & vbCRLF
		Message = Message & wc_CASE_ONE_LINE_DESCRIPTION & Case_One_Line & vbCRLF & vbCRLF


		' The special color codes have to be removed before sending the case_history

		' If the case is not closed then send out smaller message with just the updates
		' if the case is closed, then send the whole case history

		If Status = 1 Then  ' Status = Closed .. so send whole history text
			Message = Message & wc_COMPLETE_CASE_HISTORY_BELOW & vbCRLF &"---------------------------------" & vbCRLF

			Case_Text = Case_History
		Else
			Message = Message & wc_IMPORTANT_CASE_UPDATES_BELOW & vbCRLF &"---------------------------------" & vbCRLF

			Case_Text = New_Case_History_Without_Old
		End If

		If Case_Text = "" Then
			Case_Text = Case_History ' For initial case openings
		End If


		'************** USER CUSTOMIZATION ************************
		' DISPLAY ENTIRE CASE HISTORY FOR CUSTOMER EMAIL
		' If you want to display the whole Case History every time simply uncomment the line below
		' Case_Text = Case_History
		'***************End USER CUSTOMIZATION ********************


		Case_History = CleanUpHistoryText(Case_Text)
		Message = Message & "Case History:"& vbCRLF & Case_History & vbCRLF

		If Case_Summary <> "" Then
			Message = Message & wc_Case_summary_head & vbCRLF & Case_Summary & vbCRLF
		End If

		If Case_Resolution <> "" Then
			Message = Message & wc_Case_Resolution_head & vbCRLF & Case_Resolution & vbCRLF
		End If




		' ********** End User Customizations ***********************



		' Do not remove this line.

		Message = Message & EmailChecksum


		If HTMLEmail = "YES" Then

			NotificationReportTitle = wc_Notification_Report_Support_Case_Update

			updatedby = "tech"


			AltBody = Message ' First save Text message into separate variable

			Message = CreateHTMLAdditionalNotificationMsg(Case_Number, CaseLink, NotificationReportTitle, UpdatedBy)

			' Debugging
			'response.write Message


		End IF


		' *************User Customizations *************************
		' Customer Email Subject Line Customizations
		' **********************************************************

		' You can change the Subject line if necessary

		'There are three subject lines
		' (1) One for Newly Open cases by tech
		' (2) One for updating but not closed cases
		' (3) One for Closed cases

		If CaseType = "NEW" Then
			SubjectLine = "Notification Report - Support Case " & Case_Number & " " & wc_Opened

		End IF

		If Status = 1 and CaseType <> "NEW" Then
			SubjectLine = "Notification Report -Support Case " & Case_Number & " " & wc_Closed
		End If

		If (Status <> 1) and CaseType <> "NEW" Then
			SubjectLine = "Notification Report -Support Case " & Case_Number & " Update"
		End If


		'SubjectLine = "Support Case " & Case_Number & " Update"

		' Now we have everything we need to send the email to the customer
		' Only send the message if ToEmail exists and Customer_case_notify flag is set

		' We will send this email out to 2 types of emails
		'(1) Primary Notification Email
		'(2) Notification CC List





		' First get the primary notification email from the configuration file

	 ' Start to build up list of people that were sent the email


			Additional_Notification_List = "" 'Clear out list


			IF AdditionalNotifications = "1" AND PrimaryAdditionalNotificationEmail <> "" Then
				'Additional_Notification_List = PrimaryAdditionalNotificationEmail



			ToEmail = PrimaryAdditionalNotificationEmail
			ToFullName = PrimaryAdditionalNotificationEmail


			 If MyOS = "Windows" Then
				SendEmail ToEmail, ToFullName, SubjectLine, Message
			 Else
				SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
			 End If


		End If ' End of if AdditionalNotifications <> '"


		' Now get the CC list and extract individual emails from there and send them out


		IF AdditionalCCList  <> "" Then

		' Parse through the string that is comma delimited


			spacefound = "NO"
			EmailString = "" ' Clear out EmailString

			'response.write "AdditionalCCList = " & AdditionalCCList & "<br>"
			'response.flush
			'response.end


			for i=1 to len(AdditionalCCList)
				if (mid(AdditionalCCList,i,1) = " ") OR  (mid(AdditionalCCList,i,1) = ",") Then
					SpaceFound = "YES"
				End If

				if spacefound = "NO" Then

					OneCharacter = mid(AdditionalCCList,i,1)
					EmailString = EmailString & OneCharacter
				Else

					' space or comma found so send an email with that email address


					ToFullName = Trim(EmailString)
					ToEmail = Trim(EmailString)

				Additional_Notification_List = Additional_Notification_List & " " & ToEmail

			'		response.write "Sending inside For Loop -EMail to:" & EmailString
			'		response.flush
			'		response.end


					 If MyOS = "Windows" Then
						SendEmail ToEmail, ToFullName, SubjectLine, Message
					 Else
						SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
					 End If

					 EmailString = "" ' Clear out email string
					 SpaceFound = "NO"

				End IF

			Next


				' Send out last one that is not terminated with space or comma

					ToFullName = Trim(EmailString)
					ToEmail = Trim(EmailString)

				Additional_Notification_List = Additional_Notification_List & " " & ToEmail


			'		response.write "Sending last EMail to:" & EmailString
			'		response.flush
			'		response.end


					 If MyOS = "Windows" Then
						SendEmail ToEmail, ToFullName, SubjectLine, Message
					 Else
						SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
					 End If




		End If



End Sub ' End of SendAdditionalNotifications() subroutine
%>


<% Function CreateCategoryText(Case_Number)
	' This function performs a query of the set Categories and
	' returns a string to be used when sending out the email messages

	mySQL3 = "select * from Cases where case_number = " & Case_Number

	'response.write mySQL3

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN ' Open the connection once here


	set rstemp2=conntemp.execute(mySQL3)


	' Create the category display for this case

	CategoryString = ""
	for i = 1 to 20 ' Increase this beyond 20 if more than 20 Categories
		CategoryItem = CInt(rstemp2("C"&i))
		If CategoryItem <> 0 Then
			' Some category value is set so see if the state of the category
			' equal to one (customer+tech display) and get the category
			' and category item description from the table lookup.

			'mySQL4 = "select * from Categories where category_number = " & i & " AND Item_number = " & CategoryItem & " AND State = 1"

			' Show all categories if not disabled
			mySQL4 = "select * from Categories where category_number = " & i & " AND Item_number = " & CategoryItem & " AND ((State = 2) OR (State = 1))"


			'response.write mySQL4 ' Debugging only

			set rstemp3=conntemp.execute(mySQL4)


			If rstemp3.EOF <> True THEN
				Item_name = rstemp3("Item_name")
				CategoryName = rstemp3("Category_name")

				CategoryString = CategoryString &  "  [" & CategoryName & "==" & Item_Name & "]"
				CategoryString = CategoryString & vbCRLF
				' Close this intermediate record set

			End If

			rstemp3.close
			set rstemp3=nothing
		End If
	next ' Loop through the first 20 Categories

		If CategoryString = "" then
			CategoryString = wc_Categories & ":" & wcNone  & vbCRLF
		Else
			CategoryString = wc_Categories & ":" & vbCRLF & CategoryString
		End If

	CreateCategoryText = CategoryString ' Put function return value


	rstemp2.close
	set rstemp2=nothing

	conntemp.close ' Close the connection
	set conntemp=nothing


 End Function ' CreateCategoryText
%>


<% Sub SendEmailToAssignedGroupTechs(Case_Number , Tech_Assigned_Email)
	'	This subroutine sends out a notification email to any tech that are
	' configured with the default group or assigned group.  Check to see if any of those techs have already been sent
	' an email from the SendEmailToAssignedTech() function


	' First we need to get the Group Number assigned for this case

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL2="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1
			Tech_ID = ""

		Else
			' Get all of the information while we are here

			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Tech_ID = rstemp2("Tech_ID")
			Group_Number = rstemp2("Group_Number")

		End If

		rstemp2.close
		set rstemp2=nothing


		'******* CELL PHONE EMAIL TEXT FIELDS *****************************
		' Perform another query to get the customer information so
		' it can be displayed in the email for text page cell phone email
		' We will grab the two phone numbers and company name

		mySQL4="SELECT * from Customers where customer_id = '" & Customer_ID & "'"
		set rstemp4=conntemp.execute(mySQL4)


		CustomerCompany = rstemp4("Company")
		CustomerPhone1 = rstemp4("Phone1")
		CustomerPhone2 = rstemp4("Phone2")


		' Close record set

		rstemp4.close
		set rstemp4 = nothing

		'********** CELL PHONE EMAIL TEXT FIELD ENDING


		conntemp.close ' Close the connection since we may not open it again
		set conntemp=nothing

		' Now build the message since we may need to send it to more than one person

			'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************
			' To enable a short condensed email to be sent to a tech cell email address/home email
			' beginning of the email message, comment/uncomment the
			' variable definition below
			CELLPHONE_EMAIL_NOTIFICATION = "YES" ' Comment out this line to disable
			'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************

			If CELLPHONE_EMAIL_NOTIFICATION = "YES" Then
				CellMessage = ""
				CellMessage = CellMessage & Customer_ID & vbCRLF & CustomerCompany & vbCRLF &vbCRLF
				CellMessage = CellMessage & CustomerPhone1 & vbCRLF  & CustomerPhone2  & vbCRLF
				CellMessage = CellMessage & "->" & Case_One_Line & vbCRLF
				CellSubjectLine = "*C-UPDATE*"
			End If


			' Now Build the Whole message body
			' *********************** USER CUSTOMIZATIONS**********************
			' The fix part of the message that is sent out can be modified by
			' changing the text below.

			Message = ""
			Message = Message & vbCRLF & "Case " & case_number & " Update Group Notification:" & vbCRLF
			Message = Message & vbCRLF & "This case has been updated by the customer. "
			Message = Message & " Please review the information under Case History to see the new information entered by the customer."& vbCRLF
		Message = Message & wc_Case_Number_capital_letters & Case_Number & vbCRLF
		Message = Message & wc_CASE_STATUS_CAPITAL_LETTERS
		If Status = 1 Then
			Message = Message & wc_Closed & vbCRLF
		Else
			Message = Message & wc_Open & vbCRLF
		End If
		Message = Message & wc_Customer_ID_capital_letters & Customer_ID & vbCRLF
		Message = Message & wc_CASE_ONE_LINE_DESCRIPTION & Case_One_Line & vbCRLF & vbCRLF


		Message = Message & CategoryText ' Display category text



			' The special color codes have to be removed before sending the case_history

			Case_Text = Case_History
			Case_History = CleanUpHistoryText(Case_Text)
			Message = Message & "Case History:"& vbCRLF & Case_History & vbCRLF


		If Case_Summary <> "" Then
			Message = Message & wc_Case_summary_head & vbCRLF & Case_Summary & vbCRLF
		End If

		If Case_Resolution <> "" Then
			Message = Message & wc_Case_Resolution_head & vbCRLF & Case_Resolution & vbCRLF
		End If

		'*********************************************************************
		'******* User Customization Area - Change this subject line if needed
		'*********************************************************************
			'SubjectLine = "Customer Update For Case " & Case_Number

			If CaseType = "NEW" Then
				SubjectLine = "New Customer Case: " & Case_Number

			Else
				SubjectLine = "Customer Update For Case " & Case_Number

			End IF


		' Now see if there are any techs configured for this group that have
		' configured email notification


		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

			mySQL2="SELECT * from Groups where Group_Number = " & Group_Number &" AND New_Case_Notify = 1"
			set rstemp2=conntemp.execute(mySQL2)

			' Check to see if any records are returned
			' if none found the
			if rstemp2.EOF then
				ToEmail = "" ' No body is configured
			Else
			' Loop through all of the entries and send email to each of them
			' each for the one where the tech_id is the same as the assigned tech.

			Do While rstemp2.EOF <> True
				' For each tech, we will have to get their email address
				Tech_ID = rstemp2("tech_id")

				' Now get the email for each tech_id

				mySQL3="SELECT * from Tech_staff where Tech_ID = '" & Tech_ID & "'"
				set rstemp3=conntemp.execute(mySQL3)

				' Check to see if any records are returned
				' if none found the
				if rstemp3.EOF then
					ToEmail = ""
				Else
					ToEmail = rstemp3("work_email")
					ToFullName = rstemp3("first_name") & " " & rstemp3("last_name")
					' Get Cell Email Email Address

					CellEmail = rstemp3("Home_Email")
					If IsNull(rstemp3("Home_Email")) Then
						CellEmail = ""
					End If

					' *** Important note about Tech staff fields if they are blanked out
					' The Tech staff edit functions do not properly NULL out the
					' the text fields in the database when they are cleared out.
					' They current set the first character to 0 but leave the other
					' characters there so the we can't check for string <> "".
					' The test below checks to see if the first characters is ASC "0"
					' ***************************************
					If Len(CellEmail) > 0 Then
						If ASC(Mid(CellEmail,1,1)) = 0 Then
							CellEmail = ""
						End IF
					End IF

					CellFullName = ToFullName

				End If

				rstemp3.close
				set rstemp3=nothing


				' ****************** User Customization Options*****************************
				' Special Optional Section to provide links to tech to directly open the case
				' To enable this section, uncomment the SendTechLink variable below.
				' Note: It may be necessary to edit the virtual directory definitions below
				' if you did not define them as Tech30 and Customer30 as the default.

				SendTechLink = "YES"  ' Uncomment this line if you want to activate this option.

				If SendTechLink = "YES" Then

								' Now display a link directly to the tech+center for that case window.

								' Get the full server http URL for the direct LINK.
							 For each key in Request.serverVariables

								if Key = "SERVER_NAME" Then
									HostName =  Request.ServerVariables(key)
								End IF

								if Key = "SCRIPT_NAME" Then
									SCRIPT_Name =  Request.ServerVariables(key)
									' Replace DoEmailListSend.asp with RemoveFromList.asp
									' This will handle all of the necessary virtual directory mappings

									Virtual_Path = replace(Script_Name, "EmailToCase.asp", "SC.asp")

									' Edit these virtual directory settings if needed - case sensitive

									If CustomerVirtual = "" Then
										CustomerCenterVirtual = "customer70"
									Else
										CustomerCenterVirtual = CustomerVirtual ' Grab it from database
									End IF

									If TechVirtual = "" Then
										TechCenterVirtual = "tech70"
									Else
										TechCenterVirtual = TechVirtual
									End If



									Virtual_Path = replace(Virtual_Path, CustomerCenterVirtual, TechCenterVirtual,1,99,1)

								End IF

							Next

								' The TechLinkMessage is created for each tech and has to be added
								' in at the last moment in sending the message.

								TechLinkMessage = ""  ' Clear message each time
								TechLinkMessage = TechLinkMessage & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF

							    CaseLink = "http://" &  hostname & Virtual_path & "?MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Tech_ID))
			                    TechLinkMessage = TechLinkMessage &  Caselink & vbCRLF


				End If ' End of If

				'******************End User Customizations Options ***************************

				If HTMLEmail = "YES" Then

					NotificationReportTitle = wc_Notification_Report_Assigned_Group_update

					AltBody = TotalMessage ' First save Text message into separate variable
					Message = CreateHTMLTechMsg(Case_Number, CaseLink, NotificationReportTitle)
					TotalMessage = Message


					' DEBUGGING - Remove comment to view the HTML message on the browser
					'response.write Message


				Else ' Option to not send HTML emails.

					TotalMessage = Message & TechLinkMessage & EmailChecksum

				End IF



				' Send out the email if an email address exists
				If ToEmail <> "" AND ToEmail <> Tech_Assigned_Email   Then

				   If MyOS = "Windows" Then
					  SendEmail ToEmail, ToFullName, SubjectLine, TotalMessage
				   Else
					 SendLinuxEmail ToEmail, ToFullName, SubjectLine, TotalMessage
				   End If

				End If


				' Send out emails to techs cell email address

				If CellEmail <> "" AND ToEmail <> Tech_Assigned_Email AND CELLPHONE_EMAIL_NOTIFICATION = "YES"  Then

				' *************** User customizations *********************
				' This section below allows one to configure disabling cell emails
				' sent during certain hours. This is option can be configured by
				' un-commenting the lines below

				'LimitCellEmailHours = "YES"

					If LimitCellEmailHours = "YES" Then
						' The code below will limit cell emails sent between 7 AM and 5 PM
						StartLimitHour = 7 ' 24 hour time for 7 AM
						EndLimitHour = 17 ' 24 hour time for 5 PM

						If (Hour(Now) >= StartLimitHour) AND (Hour(Now) < EndLimitHour) Then
							' If in this range then do not send cell email
						Else ' outside of this range then send cell email
						     If MyOS = "Windows" Then
							      SendEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
							 Else
							      SendLinuxEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
							 End if

							Group_Notification = Group_Notification & " Cell:(" & CellEmail & ")"
						End If

					Else
					    If MyOS = "Windows" Then
						   SendEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
						Else
						   SendLinuxEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
						End If
						Group_Notification = Group_Notification & " Cell:(" & CellEmail & ")"

					End IF


				End If


				rstemp2.MoveNext
			Loop

			End If

			rstemp2.close
			set rstemp2=nothing

			conntemp.close ' Close the connection
			set conntemp=nothing


End Sub ' End of SendEmailToAssignedGroupTechs() subroutine
%>


<% Sub SendEmailToAssignedTech(Case_Number, Tech_Assigned_Email)
'	This subroutine sends out a notification email to a tech if a tech has already
	' being assigned to the case.  Only case updates will possibly have a
	' tech assigned to the case.

	' First we determine if case has a tech assigned to it.

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		' Now get the case Information (One Line, summary, resolution, etc)

		mySQL2="SELECT * from Cases where case_number = " & case_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Case_History = ""
			Case_summary = ""
			Case_Resolution = ""
			Status = 1
			Tech_ID = ""

		Else
			' Get all of the information while we are here

			Case_History = rstemp2("Case_History")
			Case_Summary = rstemp2("Case_Summary")
			Case_Resolution = rstemp2("Case_Resolution")
			Case_One_Line = rstemp2("Case_One_Line")
			Status = rstemp2("Status")
			Tech_ID = rstemp2("Tech_ID")
			Customer_ID = rstemp2("Customer_ID")
			PriorityID = rstemp2("Severity")

			' Perform another query to get the Priority text
			mySQL4="SELECT * from Priority where PriorityID = " & PriorityID
			set rstemp4=conntemp.execute(mySQL4)

			PriorityText = rstemp4("ShortDesc")
			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			'******* CELL PHONE EMAIL TEXT FIELDS *****************************
			' Perform another query to get the customer information so
			' it can be displayed in the email for text page cell phone email
			' We will grab the two phone numbers and company name

			mySQL4="SELECT * from Customers where customer_id = '" & Customer_ID & "'"
			set rstemp4=conntemp.execute(mySQL4)


			CustomerCompany = rstemp4("Company")
			CustomerPhone1 = rstemp4("Phone1")
			CustomerPhone2 = rstemp4("Phone2")


			' Close record set

			rstemp4.close
			set rstemp4 = nothing

			'********** CELL PHONE EMAIL TEXT FIELD ENDING

		End If

		rstemp2.close
		set rstemp2=nothing

		conntemp.close ' Close the connection since we may not open it again
		set conntemp=nothing


		If Tech_ID <> "" Then ' Tech Found so get their email

		' Check if Assigned tech is the one doing the updates to the
		' case and if so do not send an email

		If LoginTech_ID = Tech_ID Then
			Tech_Notification = " No message sent(Updated by assigned tech)"
			' Do not send out email

		Else


			set conntemp=server.createobject("adodb.connection")

			conntemp.open myDSN ' Open the connection once here

			' only send out email to tech if New_Case_notify = 1

				mySQL2="SELECT * from Tech_staff where Tech_ID = '" & Tech_ID & "' AND New_Case_Notify = 1"
				set rstemp2=conntemp.execute(mySQL2)

				' Check to see if any records are returned
				' if none found the
				if rstemp2.EOF then
					ToEmail = ""
				Else
					ToEmail = rstemp2("work_email")
					ToFullName = rstemp2("first_name") & " " & rstemp2("last_name")

					CellEmail = rstemp2("Home_Email")
					If IsNull(rstemp2("Home_Email")) Then
						CellEmail = ""
					End If

					' *** Important note about Tech staff fields if they are blanked out
					' The Tech staff edit functions do not properly NULL out the
					' the text fields in the database when they are cleared out.
					' They current set the first character to 0 but leave the other
					' characters there so the we can't check for string <> "".
					' The test below checks to see if the first characters is ASC "0"
					' ***************************************
					If Len(CellEmail) > 0 Then
						If ASC(Mid(CellEmail,1,1)) = 0 Then
							CellEmail = ""
						End IF
					End IF

					CellFullName = ToFullName

				End If

				rstemp2.close
				set rstemp2=nothing

				conntemp.close ' Close the connection
				set conntemp=nothing



				Message = ""

			'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************
			' To enable a short condensed email to be sent to a tech cell email address/home email
			' beginning of the email message, comment/uncomment the
			' variable definition below
			CELLPHONE_EMAIL_NOTIFICATION = "YES" ' Comment out this line to disable
			'******* USER CUSTOMIZATION FOR CELL PHONE EMAILS **********************

			If CELLPHONE_EMAIL_NOTIFICATION = "YES" Then
				CellMessage = ""
				CellMessage = CellMessage & Customer_ID & vbCRLF & CustomerCompany & vbCRLF &vbCRLF
				CellMessage = CellMessage & CustomerPhone1 & vbCRLF  & CustomerPhone2  & vbCRLF
				CellMessage = CellMessage & "->" & Case_One_Line & vbCRLF
				CellSubjectLine = wc_ALERT
			End If


				' Now Build the Whole message body
				' *********************** USER CUSTOMIZATIONS**********************
				' The fix part of the message that is sent out can be modified by
				' changing the text below.


				Message = Message & vbCRLF & wc_CASE & " " & case_number & " " & wc_Update_Notification_for_case_assigned_to_you & vbCRLF
				Message = Message & vbCRLF & wc_This_case_was_updated_by_another_Tech_staff_Member & vbCRLF

				' Now display a link directly to the tech+center for that case window.

				' Get the full server http URL for the direct LINK.
			 For each key in Request.serverVariables

			 	if Key = "SERVER_NAME" Then
					HostName =  Request.ServerVariables(key)
				End IF

			 	if Key = "SCRIPT_NAME" Then
					SCRIPT_Name =  Request.ServerVariables(key)
					' Replace DoEmailListSend.asp with RemoveFromList.asp
					' This will handle all of the necessary virtual directory mappings

					Virtual_Path = replace(Script_Name, "DoTCaseForm.asp", "SC.asp")

				End IF

			Next

				Message = Message & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF


                       '-------create the URL link with obfuscted user ID in it ---------------
			    Message = Message & vbCRLF & wc_Click_link_below_to_login_and_update & vbCRLF
			    CaseLink = "http://" &  hostname & Virtual_path & "?MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Tech_ID))

		' If you have a special port number use this syntax below
			' Portnumber = "8080"
			'    CaseLink = "http://" &  hostname & ":" & Portnumber & Virtual_path & "?MODE=auto&N=" &   Case_Number &  "&ID=" & server.urlencode(obfuscate(Tech_ID))
			    Message = Message &  Caselink & vbCRLF & vbCRLF

				Message = Message & vbCRLF & wc_Tech_assignment & ToFullName & vbCRLF

				Message = Message & wc_Case_Number_capital_letters & Case_Number & vbCRLF
				Message = Message & wc_CASE_STATUS_CAPITAL_LETTERS

				If CInt(Status) = 1 Then
					Message = Message & wc_Closed& vbCRLF
				ElseIf CInt(Status) = 0 Then
					Message = Message & wc_Open_Active & vbCRLF
				ElseIf CInt(Status) = 2 Then
					Message = Message & wc_Open_Waiting & vbCRLF
				ElseIf CInt(Status) = 3 Then
					Message = Message & wc_Open_On_Hold & vbCRLF
				End If
				Message = Message & wc_Priority_capital_letters & PriorityText & vbCRLF

				Message = Message & wc_Customer_ID_capital_letters & Customer_ID & vbCRLF
				Message = Message & wc_Company_Capitals & ": " & CustomerCompany & vbCRLF

				Message = Message & wc_Phone_numbers_capital_letters & CustomerPhone1 & "/" & CustomerPhone2 & vbCRLF

				Message = Message & wc_Case_description_capital_letters & Case_One_Line & vbCRLF

				Message = Message & CategoryText ' Display category text

				' The special color codes have to be removed before sending the case_history

				Case_Text = Case_History
				Case_History = CleanUpHistoryText(Case_Text)
				Message = Message & "Case History:"& vbCRLF & Case_History & vbCRLF

				If Case_Summary <> "" Then
					Message = Message & wc_Case_summary_head & vbCRLF & Case_Summary & vbCRLF
				End IF
				If Case_Resolution <> "" Then
					Message = Message & wc_Case_Resolution_head & vbCRLF & Case_Resolution & vbCRLF
				End If

				' Do not remove this line.
				Message = Message & EmailChecksum



				If HTMLEmail = "YES" Then

					NotificationReportTitle = wc_Notification_Report_Assigned_Tech_update

					AltBody = Message ' First save Text message into separate variable
					Message = CreateHTMLTechMsg(Case_Number, CaseLink, NotificationReportTitle)

					' Debugging
					'response.write Message


				End IF


		' *************User Customizations *************************
		' Customer Email Subject Line Customizations
		' **********************************************************

		' You can change the Subject line if necessary

		'There are three subject lines
		' (1) One for Newly Open cases by tech
		' (2) One for updating but not closed cases
		' (3) One for Closed cases

		If CaseType = "NEW" Then
			SubjectLine = "Support Case " & Case_Number & " " & wc_Opened

		End IF

		If Status = 1 and CaseType <> "NEW" Then
			SubjectLine = "Support Case " & Case_Number & " " & wc_Closed
		End If

		If (Status <> 1) and CaseType <> "NEW" Then
			SubjectLine = "Support Case " & Case_Number & " Update"
		End If



		' Old subject line
		'SubjectLine = "*** " & wc_Support_Case  & Case_Number & " " & wc_Alert & " ***"

				' Now we have everything we need to send the email to the tech
				' Only send the message if ToEmail exists and

				If ToEmail <> ""   Then
					 If MyOS = "Windows" Then
						SendEmail ToEmail, ToFullName, SubjectLine, Message
					 Else
						SendLinuxEmail ToEmail, ToFullName, SubjectLine, Message
					 End If

					Tech_Notification = "<I>" &  ToFullName & "</i>(" & ToEmail & ")"
				End If

				' Determine if we should send out email to Tech's cell phone email address

				If CellEmail <> "" AND  CELLPHONE_EMAIL_NOTIFICATION = "YES"  Then

				' *************** User customizations *********************
				' This section below allows one to configure disabling cell emails
				' sent during certain hours. This is option can be configured by
				' un-commenting the lines below

				'LimitCellEmailHours = "YES"

				If LimitCellEmailHours = "YES" Then
					' The code below will limit cell emails sent between 7 AM and 5 PM
					StartLimitHour = 7 ' 24 hour time for 7 AM
					EndLimitHour = 17 ' 24 hour time for 5 PM

					If (Hour(Now) >= StartLimitHour) AND (Hour(Now) < EndLimitHour) Then
						' If in this range then do not send cell email
					Else ' outside of this range then send cell email
						 If MyOS = "Windows" Then
							SendEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
						 Else
							SendLinuxEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
						 End If

						Tech_Notification = Tech_Notification & " Cell:(" & CellEmail & ")"
					End If


				Else
					  If MyOS = "Windows" Then
						SendEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
					  Else
						SendLinuxEmail CellEmail, CellFullName, CellSubjectLine, CellMessage
					  End If


					Tech_Notification = Tech_Notification & " Cell:(" & CellEmail & ")"

				End IF

				'*********** End User Customization Area *********************

				End If ' End of If CellEmail <> ""


			End IF ' End of If LoginTech_ID = Tech_ID

		End If ' Do not send out email if no tech is assigned

End Sub ' End of SendEmailToAssignedTech() subroutine
%>



