
<% 'Module: FixTechIDFields.asp

   'Description: This module is called directly from a manually entered
   ' URL to fix the problem where the cases tables has non-null Tech_ID Fields
   ' but they are empty string values in there.
   ' This occured since previous versions had code that would populate the
   ' case_summary and case_resolution fields with non-null empty values
   ' rather than leaving them as null.

   ' The Error occurs when using the IS NOT NULL function.  It seems to return
   ' values of fields that are empty.  It returns different results than
   ' the ISNULL() function.

   'It will walk through the entire case table and only restore those
   ' fields where the case_summary or case_resolution are empty strings
   ' back to a null value.

   '(C) 1999, 2001, 2002,2003, 2004 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '08/21/01	SAV		Created original FixNonNullEmptyFields.asp page
   '01/08/04	SAV		Created Original FixTechIDFields.asp module

	' CONSTANTS
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="db_define.inc" -->



<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="ADOVBS.INC" -->

<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 6 ' Allow Admins to see this function.


	CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN") ' Get the Logged TechID from the cookie

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="SELECT * from tech_staff where Tech_ID = '" & CookieID & "' AND Tech_Level >= " & TechLevel
		set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF <> True Then
			ValidUser = "YES" ' Set this variable to prevent problems on next page
		End If

		rstemp.close
		set rstemp=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing

 ' End of ASP page security checks
 %>


<% if ValidUser <> "YES" Then %>
	<% ASPPage = "FixNonNullEmptyFields.asp"%>

	<!-- #include file=InvalidUser.inc-->

<%else '  Valid User for this function %>


<% 'First Show the Report Menu at the top of the page
%>

<html>

<head>
<title>Web+Center Database Fix Utility for Non-null empty Tech ID  case values</title>
</head>

<% 'Get the value of the User Screen background color from the Configuration Table %>
<%
	set conntemp=server.createobject("adodb.connection")

	conntemp.open myDSN ' Open the connection once here

	mySQL2="select * from Configuration"
	set rstemp2=conntemp.execute(mySQL2)

	' Check to see if any records are returned
	' if none found the
	if rstemp2.EOF then
		UserPageColor = "FFFFFF" ' Default to white if record not found
	Else
		UserPageColor = rstemp2("ts_user_page_color")
	End If

	rstemp2.close
	set rstemp2=nothing

	' Don't close connection here
'	conntemp.close ' Close the connection
'	set conntemp=nothing

%>

<body bgcolor="<%=UserPageColor%>">
<center>






<% ' Get the statistics of the cases

' Get Total number of open cases

	sqltemp="select * from cases order by case_number"
	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.

	If DatabaseType <> "ACCESS97" Then
		rstemp.CursorLocation = adUseClient
	End If

	rstemp.open sqltemp, conntemp, adopenstatic
	TotalCases = rstemp.recordcount

	rstemp.close ' Close table for now
	conntemp.close

	set rstemp = Nothing


%>

<B>Fixing Non-Null Empty Strings in Case Table/Tech ID Field - Reviewing   (<%=TotalCases%> Total Cases)</b><P>

<hr>

<center>
Fixing Case Tech_ID Fields
</center>
	<table width=90% border=1>
	<tr>
	<th bgcolor=F0D0E0><font size=-1>Case Number</th>
	<th bgcolor=D0E0F0><font size=-1>Fixed Tech_ID Notes</th>

	</tr>

<%
	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  myDSN


		Set NewRecord = Server.CreateObject("ADODB.Recordset")
			SQL = "Select * from cases where Tech_ID Is NOT NULL order by Case_number"

			'response.write SQL

			NewRecord.Open SQL,Conn,3,3

			Do while NewRecord.EOF <> True

%>
	<tr><td><font size=-1>
	<%=NewRecord("Case_number")%>
	</td>
	<td><font size=-1>


<% ' Display the fields %>

	<% ' Now display the Ascii for each character


	For i = 1 to len(NewRecord("Tech_ID"))

		Response.write "[" & asc(mid(NewRecord("Tech_ID"),i,1)) & "]"

	next
	%>

<%

	If Len(NewRecord("Tech_ID")) <> 0 Then
		If  asc(mid(NewRecord("Tech_ID"),1,1)) = 0 Then
			NewRecord("Tech_ID") = Null ' Reset Value back to True Null
			response.write "<font color=red>FIXED</font>"
		End If

	End IF


%>


	</td>

	</tr>

<%
			NewRecord.MoveNext
		Loop

'		NewRecord.Update

		NewRecord.Close
		Set NewRecord = Nothing

		Conn.Close
		Set Conn = Nothing

%>


	</table>




 Complete Case Table has been successfully updated fixing non-null empty
 Tech_ID field back to proper Database Nulls.
 <P>


 To confirm this operation,

 run this <a href=FixTechIDFields.asp>Fix Non-Null Empty Tech ID Fields</a> Script again.
 <P>


	</body>
	</html>



<%End If ' End of security checks %>