
<% 'Module: ImportAssets.asp

	' Version 2.0

   'Description: This module is designed to be customized by the end user
   ' to import Assets from external asset database table (Access or SQL or other)
   ' and import that information into the assets table.

   ' Assets columns definitions vary in size and requirements (such as indexed)
   ' so caution should be used when importing data of various sizes into
   ' the various columns.

   ' This module should only be used by advanced Web+Center
   ' administrators and configurators.  To use this module, one
   ' must be famillar with the web+center database tables that you are
   ' importing data into and the table that you are exporting
   ' data from.

   ' Directions: To import data into the Assets Web+Center table,
   ' you must first create an another Access or ODBC compliant database
   ' with the data you plan on importing. Once you have created
   ' this database, you must edit the code below to match the column names
   ' in your (source) database to the selected columns in the web+center database.
   ' Look for the areas labeled " USER CUSTOMIZATIONS HERE"
   ' IMPORTANT: Before launching any data conversion process, please completely
   ' backup the database so it can be restored and conversion process
   ' attempted again.

   '(C)  2004 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date	Who		What
   '-------	---		------------------------------------------------
   '6/04/04	SAV		Created original ImportAssets.asp Script
   '09/26/11 CMB    Fields are now almost all 100 characters.

	' CONSTANTS

	' Set the time out to 20 minutes so it does not time out with larger imports
	Server.ScriptTimeOut = 1200 ' Set to 1200 seconds (20 minutes)
	NewRecords = 0
	UpdatedRecords = 0

%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="db_define.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="ADOVBS.INC" -->



<html>

<head>
<title>Web+Center Asset Import Script </title>
</head>

<body bgcolor=FFFFFF>

<% ' ********************* USER CUSTOMIZATION ********************
	' Step 1: On the line below, edit the ODBC connect string for your
	' database that you have created with your customer records.
	' Currently it is initially configured for a DSN called "NewAssets"
	' If your require a userid and password, enter it into the string too.
	' You must configure the DSN for this database by going to the
	' the ODBC32 icon under the control panel.

		'YourDatabaseDSN ="DSN=NewAssets;uid=;pwd="
		YourDatabaseDSN ="DSN=Jims;uid=;pwd="

	' Step 2: Edit the table name below from "NewAssets" to the name
	' of your table in your database that contains the new Asset
	' records.

		'YourDatabaseTableName = "Equipment2008"
		YourDatabaseTableName = "Inventory 09"  ' EXCEL TAB

	' Step 3: Map any map of the columns in your database to the Web+Center
	' asset database.  Follow the instructions for checking for existing
	' customers if you are attempting to associate the asset with an
	' existing Web+Center customer.

	' For example, to map a column in your database called "tagnumber"
	' with the Web+Center Customers table "PropertyTag", which is
	' the Asset Property Tag Column, set the variable named
	' "Property_Tag" equal to the string "tagnumber".
	'
	' Map all of the appropriate columns as is appropriate.  If there is
	' desination field mapped for which you do not have data or donot
	' want to import data, then comment out that selected line.

	' Destination columns define the destination column in the Web+Center
	' database.  DO NOT  modify the variable name or the name of the
	' column in the web+center asset database.


	' Field Mapping Variable Settings
	'Destination Column Name	Source Column Name	Field Description & Size
	'-----------------------	------------------	--------------------------
	Computer_ID		 = 			"Computer_ID"		'Computer_ID
	Property_Tag = 				"ExpressServiceTag"			'Property_Tag
	Equipment_Type		= 		"Description"			'Equipment Type or Description
	Lease_Or_purchase = 		"Lease"			'Lease or Purchase Defintion
	Purchase_Order_Num = 		"PONumber"				'Purchase Order Number
	Serial_Number		=		"FixedAssetID"			'Serial Number
	Acquired_From	 = 			"DepartmentLocation"		' Acquired From Group or code
	Date_Acquired	= 			"DateAcquired"	' Date Purchaed or Acquired

	Date_In_Service = 			"DateInService"	' Date in Service
	Processor_Speed	= 			"processorspeed"	' Processor Speed
	Ram_Size	=				"RamSize"			' Ram Size
	Hd_Size		=				"HDSize"			' Hard Drive Size
	Monitor_model	=			"MonitorModel"		' Monitor Model
	Monitor_Size	=			"MonitorSize"		' Monitor Size
	Monitor_Serial_Num = 	"MonitorSerialNumber" ' Monitor Serial number


	Assigned_Group		= 		"AssignedGroup"		' Assigned Group
	Location			= 		"Location"			' Location
	Date_Assigned		= 		"DateAssigned"				' Date Assigned Field



	IP_Address			= 		"IPAddress"		' IP Address
	Wall_Port_Number	= 		"WallPort"	' Wall Port Number
	Operating_System1	=		"OperatingSystem1" ' Operating System 1
	Operating_System2	=		"OperatingSystem2" ' Operating System 2

'	Custom_Field1		= 		"Make"		' Custom Field 1 (50 chars)
'	Custom_Field2		= 		"Model"		' Custom Field 2 (50 chars)
'	Custom_Field3		= 		"Custom_Field3"		' Custom Field 3 (50 chars)
'	Custom_Field4		= 		"User Type"		' Custom Field 4 (50 chars)
'	Custom_Field5		= 		"Custom_Field5"		' Custom Field 5 (50 chars)


	' Asset Assignments - These go into the Asset Assignment Table
'	First_name			= 		"First Name"		' Compares first and last name
'	Last_Name			= 		"Last Name"
'	AssetAssignment 		= 		"AssetAssignment"


'******** Software Applications Fields ****************************************

'	app1				=		"App1"
'	app1_product_id		= 		"app1_product_id"
'	app1_install_date	= 		"app1_install_date"



	' ******************* END CUSTOMIZATIONS **********************

	' Now we will attempt to import all of the information.
	' We will need to open two ODBC connections so we can move
	' data from one data source to another.

%>
	<center><font face=arial>Web+Center Asset Data Import Filter</font></center><P>
	<font size=-1 face=arial>
	<B>Directions</b>:
	<UL>Before running this script, you must customize
	this ASP script to match your data input requirements and configure
	a ODBC DNS for  your source database.  Please review the
	documentation on the ImportAssets.asp page by opening the file
	with an ASCII editor.<P>
	</ul>
<%

	TotalImportedRecords = 0

	Dummy_Field = 0

	response.write "<B>Database Connectivity Tests:</b>"
'	response.write "<UL> Connection to (Destination) Web+Center Database Successful.<br>"


	' Now close it now that we know it is ok


	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  YourDatabaseDSN ' If it fails here, then check your connect string.

	response.write " Connection to Source (Your Assets to be Imported into Web+Center) Database Successful.</ul>"

	Response.write "<b>Importing Data Records For:</b><UL>"

	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from " & YourDatabaseTableName
			SourceRecord.Open SQL2,Conn2,3,3

	Do while SourceRecord.EOF <> True

			Set Conn = Server.CreateObject("ADODB.Connection")
			conn.open  myDSN   ' Conn = Destination Database

			Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
			SQL = "Select * from Assets"

				'response.write SQL

				DestinationRecord.Open SQL,Conn,3,3


		DestinationRecord.AddNew ' Add new record
		NewRecords = NewRecords + 1
		Record = "NEW"


	' Instructions on how to choose what items to import

	' Uncomment the Field variable name in the table above if you want
	' to import that field.  If you do not want to import data into that
	' database column, then besure to comment that variable out.

	' In the code below, it checks if the variable is set or not set
	' If the variable is unset (commented out), then no import is attempted.


			If Computer_ID <> "" Then
				If IsNull(SourceRecord(Computer_ID)) = False Then
				Computer_ID_Value = Trim(SourceRecord(Computer_ID))


					If Computer_ID_Value <> "" Then
					'response.write "Attempting to put in Computer ID of " & SourceRecord(Computer_ID)
						DestinationRecord("Computer_ID") = Computer_ID_Value
					End If
				End If

			End If

			If Property_Tag <> "" Then
				If IsNull(SourceRecord(Property_Tag)) = False Then
				DestinationRecord("Property_Tag") = SourceRecord(Property_Tag)
				End if
			End If

			If Equipment_Type <> "" Then
				If IsNull(SourceRecord(Equipment_Type)) = False Then
					DestinationRecord("Equipment_Type") = Mid (SourceRecord(Equipment_Type), 1, 100)
				End If

			End If

			If Lease_Or_Purchase <> "" Then
				If IsNull(SourceRecord(Lease_Or_Purchase)) = False Then
					DestinationRecord("Lease_Or_Purchase") = Mid (SourceRecord(Lease_Or_Purchase), 1, 100)
				End If
			End If

			If Purchase_Order_Num <> "" Then
				If IsNull(SourceRecord(Purchase_Order_Num)) = False Then
					DestinationRecord("Purchase_Order_Num") = Mid (SourceRecord(Purchase_Order_Num), 1, 100)
				End If
			End If

			If Serial_Number <> "" Then
				If IsNull(SourceRecord(Serial_Number)) = False Then
					DestinationRecord("Serial_Number") = Mid (SourceRecord(Serial_Number), 1 , 100)
				End If
			End If

			If Acquired_From <> "" Then
				If IsNull(SourceRecord(Acquired_From)) = False Then
					DestinationRecord("Acquired_From") = Mid (SourceRecord(Acquired_From), 1, 100)
				End If

			End If

			If Date_In_Service <> "" Then
				If IsNull(SourceRecord(Date_In_Service)) = False Then
					DestinationRecord("Date_In_Service") = Mid (SourceRecord(Date_In_Service), 1, 100)
				End If

			End If

			If Processor_Speed <> "" Then
				If IsNull(SourceRecord(Processor_Speed)) = False Then
					DestinationRecord("Processor_Speed") = Mid (SourceRecord(Processor_Speed), 1, 100)
				End If

			End If

			If Ram_Size <> "" Then
				If IsNull(SourceRecord(Ram_Size)) = False Then
					DestinationRecord("Ram_Size") = Mid (SourceRecord(Ram_Size), 1, 100)
				End If

			End If

			If Hd_Size <> "" Then
				If IsNull(SourceRecord(Hd_Size)) = False Then
					DestinationRecord("Hd_Size") = Mid (SourceRecord(Hd_Size), 1, 100)
				End If

			End If


			If Monitor_Model <> "" Then
				if IsNull(SourceRecord(Monitor_Model)) = False Then
					DestinationRecord("Monitor_Model") = mid (SourceRecord(Monitor_Model), 1 ,100)
				End If
			End If


			If Monitor_Size <> "" Then
				if IsNull(SourceRecord(Monitor_Size)) = False Then
					DestinationRecord("Monitor_Size") = mid (SourceRecord(Monitor_Size), 1 ,100)
				End If
			End If


			If Monitor_Serial_num <> "" Then
				if IsNull(SourceRecord(Monitor_Serial_num)) = False Then
					DestinationRecord("Monitor_Serial_num") = mid (SourceRecord(Monitor_Serial_num), 1 ,100)
				End If
			End If

			If assigned_group <> "" Then
				if IsNull(SourceRecord(assigned_group)) = False Then
					DestinationRecord("assigned_group") = mid (SourceRecord(assigned_group),1,100)
				End If
			End If

			If location <> "" Then
				if IsNull(SourceRecord(location)) = False Then
					DestinationRecord("location") = mid (SourceRecord(location),1, 100)
				End If
			End If

			If date_assigned <> "" Then
				if IsNull(SourceRecord(date_assigned)) = False Then
					DestinationRecord("date_assigned") = mid (SourceRecord(date_assigned), 1, 100)
				End If
			End If


			If ip_address <> "" Then
				if IsNull(SourceRecord(ip_address)) = False Then
					DestinationRecord("ip_address") = mid (SourceRecord(ip_address), 1, 100)
				End If
			End If

			If wall_port_number <> "" Then
				if IsNull(SourceRecord(wall_port_number)) = False Then
					DestinationRecord("wall_port_number") = mid (SourceRecord(wall_port_number), 1, 100)
				End If
			End If

			If Operating_System1 <> "" Then
				if IsNull(SourceRecord(Operating_System1)) = False Then
					DestinationRecord("Operating_System1") = mid (SourceRecord(Operating_System1), 1, 100)
				End If
			End If


			If Operating_System2 <> "" Then
				if IsNull(SourceRecord(Operating_System2)) = False Then
					DestinationRecord("Operating_System2") = mid (SourceRecord(Operating_System2), 1, 100)
				End If
			End If


		'* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
		' Applications Section
		' Duplicate this code for the remaining 14 applications if needed..


			If app1 <> "" Then
				if IsNull(SourceRecord(app1)) = False Then
					DestinationRecord("app1") = mid (SourceRecord(app1), 1, 20)
				End If
			End If


			If app1_product_id <> "" Then
				if IsNull(SourceRecord(app1_product_id)) = False Then
					DestinationRecord("app1_product_id") = mid (SourceRecord(app1_product_id), 1, 25)
				End If
			End If


			If app1_install_date <> "" Then
				if IsNull(SourceRecord(app1_install_date)) = False Then
					DestinationRecord("app1_install_date") = mid (SourceRecord(app1_install_date), 1, 15)
				End If
			End If


		'* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

		'* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
		' Custom Fields Section

			' (5) Custom Fields (50 characters each)


			If Custom_Field1 <> "" Then
				if IsNull(SourceRecord(Custom_Field1)) = False And SourceRecord(Custom_Field1) <> "" Then
					DestinationRecord("Custom_Field1") = mid (SourceRecord(Custom_Field1), 1, 100)
				End If
			End If


			If Custom_Field2 <> "" Then
				if IsNull(SourceRecord(Custom_Field2)) = False And SourceRecord(Custom_Field2) <> "" Then
					DestinationRecord("Custom_Field2") = mid (SourceRecord(Custom_Field2), 1, 100)
				End If
			End If

			If Custom_Field3 <> "" Then
				if IsNull(SourceRecord(Custom_Field3)) = False And SourceRecord(Custom_Field3) <> "" Then
					DestinationRecord("Custom_Field3") = mid (SourceRecord(Custom_Field3), 1, 100)
				End If
			End If

			If Custom_Field4 <> "" Then
				if IsNull(SourceRecord(Custom_Field4)) = False And SourceRecord(Custom_Field4) <> "" Then
					DestinationRecord("Custom_Field4") = mid (SourceRecord(Custom_Field4), 1, 100)
				End If
			End If

			If Custom_Field5 <> "" Then
				if IsNull(SourceRecord(Custom_Field5)) = False And SourceRecord(Custom_Field5) <> "" Then
					DestinationRecord("Custom_Field5") = mid (SourceRecord(Custom_Field5), 1, 100)
				End If
			End If

		'* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


		'* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
		' Asset Assignment Sections.
		' For Customer Assignment, we must check if the customer exists in the
		' customers table and we must obtain the Customer_ID from that table and
		' place it in the assetassignment table.

			' Asset Assignments


			' If required, we can check the new asset record to see if the
			' assigned asset record already exists in the Web+Center customer database.

			If First_Name <> "" Then
				if IsNull(SourceRecord(First_Name)) = False Then
					FirstNameSource = mid (SourceRecord(First_Name), 1, 50)
				End If
			End If


			If Last_Name <> "" Then
				if IsNull(SourceRecord(Last_Name)) = False Then
					LastNameSource = mid (SourceRecord(Last_Name), 1, 50)
				End If
			End If


			Customer_ID = ""


			Customer_ID = CheckForMatchingCustomer(FirstNameSource, LastNameSource)

			'Response.write "Customer_ID = " & Customer_ID & "<P>"



			' If the customer_ID is not blank then it found a matching customer
			' and customer_ID and that asset assignment should be placed into the
			' assetassignment table.

			' Before we can place the asset into the AssetAssignment table, we must
			' complete the asset record insertion and get the asset_number (autonumber)
			' since the asset_number mustbe placed into the assetassignment table.


			DestinationRecord("Dummy_Field") = Dummy_field


			DestinationRecord.Update

			DestinationRecord.Close
			Set DestinationRecord = Nothing

			Conn.Close
			Set Conn = Nothing

			Asset_Number = GetAssetNumber(Dummy_Field)

			'Response.write "Asset_Number = " & Asset_Number

			' Now add entry to asset_assignment table if Customer_ID is found.

			' NEW CODE to get assetassignment (customer_id) and place it into the assetAssigment table


			If AssetAssignment <> "" Then
				if IsNull(SourceRecord(AssetAssignment)) = False Then
					AssetAssignmentSource = mid (SourceRecord(AssetAssignment), 1, 50)
				End If
			End If




			IF Customer_ID <> "" Then

			Set Conn3 = Server.CreateObject("ADODB.Connection")
			conn3.open  myDSN   ' Conn3 = AssetAssignment Database


				Set AssignmentRecord = Server.CreateObject("ADODB.Recordset")
				SQL6 = "Select * from AssetAssignment"


				AssignmentRecord.Open SQL6,Conn3,3,3


				AssignmentRecord.AddNew ' Add new record

				AssignmentRecord("Asset_Number") = Asset_Number
				' OLD WAY
				'AssignmentRecord("Customer_ID") = Customer_ID
				' NEW way

				AssignmentRecord("Customer_ID") = AssetAssignmentSource

				AssignmentRecord.Update

				AssignmentRecord.Close
				Set AssignmentRecord = Nothing

							Conn3.Close
							Set Conn3 = Nothing

			End If


			Dummy_Field = Dummy_Field + 1

			'Now make assignment by passing Dummy_fieldpseudo counter



				response.write " <font color=green> <LI>New Asset " & Asset_Number & "  Added: Computer_ID:" &  SourceRecord(Computer_ID) & " Property Tag: " & sourceRecord(Property_Tag) & " Customer_ID:" & Customer_ID & "</font></li>"
				response.flush



		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1


	' Now put in the Customer_ID into the Asset_Assignment table if it exists




	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections


	' conn is already closed

	Set SourceRecord = Nothing
	Conn2.close

%>

	</ul>

	<B>Asset Data Import Completed Successfully</B><P>
	<UL>
	<LI><%=TotalImportedRecords%> Total Asset records imported/Updated<br>
	</ul>


</body>
</html>





<% Function CheckForMatchingCustomer(FirstNameSource, LastNameSource)
	'This function checks to see if the passed first and last name match in
	' the web+center customers table and if so, then it returns the customer_id

		' Notice we using another connection incase we already using conntemp.

		' We need to replace all single quotes in the table value with
		' double quotes to prevent a SQL error.



		' fix name with single quotes

		If lastnamesource <> "" Then

			lastnamesource = replace(lastnamesource, "'", "''")
		End If

		' fix spaces

		If firstnamesource <> "" Then

			firstnamesource = replace(firstnamesource, " ", "")
		End If

		' remove single quotes in first names fields

		If firstnamesource <> "" Then

			firstnamesource = replace(firstnamesource, "'", "")
		End If


		set conntemp2=server.createobject("adodb.connection")

		conntemp2.open myDSN ' Open the connection once here

		mySQL2="Select * from Customers where  contact_lname like '" & lastnamesource & "%' AND contact_fname like '" & firstnamesource & "%'"

		set rstemp5=conntemp2.execute(mySQL2)

		'response.write "mysql2= " & mySQL2

		' Check to see if any records are returned
		' if none found the
		if rstemp5.EOF then
			CheckForMatchingCustomer = "" ' Set to Empty if no match
		Else
			CheckForMatchingCustomer = rstemp5("Customer_ID")
		End If


		'Response.write "CheckforMatchingCustomer = " & CheckforMatchingcustomer

		rstemp5.close
		set rstemp5=nothing

		conntemp2.close ' Close the connection
		set conntemp2=nothing

	End Function ' End of CheckForMatchingCustomer
	%>



<% Function CheckForUniqueTableValues(Tablename, Columnname, tablevalue)
	'This function checks to see if the passed column for a selected
	' table is unique (ie email in customer table, username, etc)
	' This functions either a "UNIQUE" or "NOTUNIQUE" returns

		' Notice we using another connection incase we already using conntemp.

		' We need to replace all single quotes in the table value with
		' double quotes to prevent a SQL error.

		NewTableValue = replace(TableValue, "'", "''")


		set conntemp2=server.createobject("adodb.connection")

		conntemp2.open myDSN ' Open the connection once here

		mySQL2="select * from " & tablename & " where " & Columnname & " = '" & NewTableValue & "'"

		set rstemp5=conntemp2.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp5.EOF then
			CheckForUniqueTableValues = "UNIQUE"
		Else
			CheckForUniqueTableValues = "NONUNIQUE"
		End If

		rstemp5.close
		set rstemp5=nothing

		conntemp2.close ' Close the connection
		set conntemp2=nothing

	End Function ' End of CheckForUniqueTableValues
	%>



<% Function GetAssetNumber(Dummy_Number)
	'This function get the asset_number from the saved dummy_number field

		' Notice we using another connection incase we already using conntemp.

		set conntemp2=server.createobject("adodb.connection")

		conntemp2.open myDSN ' Open the connection once here

		mySQL2="select * from assets  where  dummy_field = " & Dummy_Number

		'response.write "mysql2= " & mySQL2

		set rstemp5=conntemp2.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp5.EOF then
			GetAssetNumber = 0
		Else
			GetAssetNumber = rstemp5("Asset_Number")
		End If

		rstemp5.close
		set rstemp5=nothing

		conntemp2.close ' Close the connection
		set conntemp2=nothing

	End Function ' GetAssetNumber
	%>


