
<% 'Module: ImportFilter.asp

   'Description: This module is sample Data Import Filter.
   ' This module should only be used by advanced Web+Center
   ' administrators and configurators.  To use this module, one
   ' must be famillar with the web+center database tables that you are
   ' importing data into and the table that you are exporting
   ' data from.
   
   ' Directions: To import data into the Customers Web+Center table,
   ' you must first create an another Access or ODBC compliant database
   ' with the data you plan on importing. Once you have created
   ' this database, you must edit the code below to match the column names
   ' in your (source) database to the selected columns in the web+center database.
   ' Look for the areas labeled " USER CUSTOMIZATIONS HERE"
   ' IMPORTANT: Before launching any data conversion process, please completely
   ' backup the database so it can be restored and conversion process
   ' attempted again.  
 
   '(C) 2000 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date	Who		What
   '-------	---		------------------------------------------------
   '6/07/00	SAV		Created original ImportFilter.asp page

	' CONSTANTS
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->

<html>

<head>
<title>Web+Center Customer Data Import Process</title>
</head>

<body bgcolor=FFFFFF>

<% ' ********************* USER CUSTOMIZATION ********************
	' Step 1: On the line below, edit the ODBC connect string for your 
	' database that you have created with your customer records.
	' Currently it is initially configured for a DSN called "NewCustomers"
	' If your require a userid and password, enter it into the string too.
	' You must configure the DSN for this database by going to the
	' the ODBC32 icon under the control panel.
	
		YourDatabaseDSN ="DSN=NewCustomers;uid=;pwd="
		
	' Step 2: Edit the table name below from "MoreCustomers" to the name
	' of your table in your database that contains the new customer 
	' records.
		
		YourDatabaseTableName = "MoreCustomers"
		
	' Step 3: Map any map of the columns in your database to the Web+Center
	' customer database.  Follow the instructions for creating the special
	' CustomerID field from your First and Last Name fields.
	
	' For example, to map a column in your database called "LastName"
	' with the Web+Center Customers table "Contact_lname", which is
	' the Customer Last Name field, Column, set the variable named
	' "Contact_lname" equal to the string "Lastname".  
	'
	' Map all of the appropriate columns as is appropriate.  If there is
	' desination field mapped for which you do not have data or donot
	' want to import data, then comment out that selected line.
	
	'IMPORTANT: DO NOT modify the Destination Column name, only the source names
	
	' Field Mapping Variable Settings
	'Destination Column Name	Source Column Name	Field Description
	'-----------------------	------------------	--------------------------
	Contact_lname = 			"Lastname"			'Customers Last Name
	Contact_fname = 			"Firstname"			'Customers First Name
'	customer_password = 		"Password"			'Customer Password
'	company = 					"Company"			'Customer's Company
'	address = 					"Address"			'Customers's Street Address
'	mailstop = 					"mailstop"			' Mail stop address if exists
'	city = 						"City"				' City name
'	State = 					"State"				' State two letter name
'	zip	=						"Zip"				' Zipcode
	email = 					"Email"				' Email Address
	phone1 = 					"Phone1"			' Work Phone Number
'	phone2 = 					"Phone2"			' Home Phone Number
'	fax = 						"fax"				' Fax Number
'	contact_method =			"contact_method"		' Set to email, fax or phone
'	Contact_Times = 			"Contact_Times"		' Notes about contacting person
	Customer_username = 		"Customer_username"	' customerID login
	' ******************* END CUSTOMIZATIONS **********************
	
	' Now we will attempt to import all of the information.  In addition
	' to the fields above, we will also create a unique "customer_id"
	' key field that is built by using the Lastname field + "_" (underscore)
	' + the First name up to 20 characters.  
	
	' We will need to open two ODBC connections so we can move
	' data from one data source to another.

%>
	<center><font face=arial>Web+Center Customer Data Import Filter</font></center><P>
	<font size=-1 face=arial>
	<B>Directions</b>: 
	<UL>Before running this script, you must customize
	this ASP script to match your data input requirements and configure
	a ODBC DNS for  your source database.  Please review the
	documentation on the ImportFilter.asp page by opening the file
	with an ASCII editor.<P>
	</ul>
<%	

	TotalImportedRecords = 0
	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  myDSN   ' Conn = Destination Database

	response.write "<B>Database Connectivity Tests:</b>"
	response.write "<UL> Connection to (Destination) Web+Center Database Successful.<br>"
	
	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  YourDatabaseDSN ' If it fails here, then check your connect string.
	
	response.write " Connection to Source Database Successful.</ul>"
	
	Response.write "<b>Importing Data Records For:</b><UL>"
	
	' Now step through all of the records on the source database

	Set SourceRecord = Server.CreateObject("ADODB.Recordset")
			SQL2 = "Select * from " & YourDatabaseTableName 
			SourceRecord.Open SQL2,Conn2,3,3

	Do while SourceRecord.EOF <> True
		' Create a new record on the desintation database
		
		Set DestinationRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from Customers" ' 

			'response.write SQL

			DestinationRecord.Open SQL,Conn,3,3
			DestinationRecord.AddNew
			' Import the data if variable is not commented out above
			
			If Contact_lname <> "" Then
				DestinationRecord("Contact_Lname") = SourceRecord(Contact_lname)
			End If
			
			If Contact_fname <> "" Then
				DestinationRecord("Contact_fname") = SourceRecord(Contact_fname)
			End If

			If Customer_password <> "" Then
				DestinationRecord("Customer_password") = SourceRecord(customer_password)
			End If

			If Company <> "" Then
				DestinationRecord("company") = SourceRecord(Company)
			End If

			If Address <> "" Then
				DestinationRecord("Address") = SourceRecord(Address)
			End If

			If MailStop <> "" Then
				DestinationRecord("MailStop") = SourceRecord(MailStop)
			End If

			If City <> "" Then
				DestinationRecord("City") = SourceRecord(City)
			End If

			If State <> "" Then
				DestinationRecord("State") = SourceRecord(State)
			End If

			If Zip <> "" Then
				DestinationRecord("Zip") = SourceRecord(Zip)
			End If

			If email <> "" Then
				DestinationRecord("email") = SourceRecord(email)
			End If

			If phone1 <> "" Then
				DestinationRecord("phone1") = SourceRecord(Phone1)
			End If

			If phone2 <> "" Then
				DestinationRecord("phone2") = SourceRecord(Phone2)
			End If

			If fax <> "" Then
				DestinationRecord("fax") = SourceRecord(fax)
			End If
				
			If Contact_method <> "" Then
				DestinationRecord("contact_method") = SourceRecord(contact_method)
			End If

			If Contact_Times <> "" Then
				DestinationRecord("Contact_Times") = SourceRecord(Contact_times)
			End If

			If customer_username <> "" Then
				DestinationRecord("customer_username") = SourceRecord(customer_username)
			End If
			
			' Now create the unique customer_ID field
			
			Customer_ID = SourceRecord(Contact_lname) & "_" & SourceRecord(contact_fname)
			If Len(customer_ID) > 20 Then
				Customer_ID = Left(Customer_ID, 20)
			End If

			' The Customer_ID must be unique verify this combination
			' of Last_First is not already used.  If it is, then
			' add an 3 digit random number to the end of the ID.

			UniqueCustomerID = CheckForUniqueTableValues("Customers", "customer_ID", customer_ID)

			If UniqueCustomerID <> "UNIQUE" THEn
				Customer_ID = mid(Customer_ID, 1,17) ' lop off last two characters
				Randomize ' Seed the generator with a new value
				Customer_ID = Customer_ID & cstr(Int(rnd*100))
				'response.write "New ID = " & Customer_ID
			End If

			' Run this test again incase we have duplicates

			UniqueCustomerID = CheckForUniqueTableValues("Customers", "customer_ID", customer_ID)

			If UniqueCustomerID <> "UNIQUE" THEn
				Customer_ID = mid(Customer_ID, 1,17) ' lop off last two characters
				Randomize ' Seed the generator with a new value
				Customer_ID = Customer_ID & cstr(Int(rnd*100))
				'response.write "New ID = " & Customer_ID
			End If


			DestinationRecord("Customer_ID") = Customer_ID

			' IMPORTANT - DO NOT RESET THIS EVEN IF THEY 
			' CHANGE THEIR NAMES.  There is an option within
			' the tech+center that will allow techs to 
			' change the customer_id.


				DestinationRecord.Update

				response.write " <font color=green> <LI>User: " &  SourceRecord(contact_fname) & " " & sourceRecord(Contact_lname) & "</font></li>"

				If  err.number>0 then
					  response.write "VBScript Errors Occured:" & "<P>"
					  response.write "Error Number=" & err.number & "<P>"
					 response.write "Error Descr.=" & err.description & "<P>"
					  response.write "Help Context=" & err.helpcontext & "<P>"
					  response.write "Help Path=" & err.helppath & "<P>"
					  response.write "Native Error=" & err.nativeerror & "<P>"
					  response.write "Source=" & err.source & "<P>"
					  response.write "SQLState=" & err.sqlstate & "<P>"
				else
				'      response.write "No VBScript Errors Occured" & "<P>"
				end if
				IF  conn.errors.count> 0 then
					  response.write "Database Errors Occured" & "<P>"
				for counter= 0 to conn.errors.count
					  response.write "Error #" & conn.errors(counter).number & "<P>"
					  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
				next
				else
				'      response.write "No Database Errors Occured!" & "<P>"
				end if

				
		DestinationRecord.Close
		Set DestinationRecord = Nothing
		SourceRecord.MoveNext
		TotalImportedRecords = TotalImportedRecords + 1
	loop

	SourceRecord.Close ' Close the source recordset
	' Close both connections
	
	Conn.Close
	Set SourceRecord = Nothing
	Conn2.close
	
%>

	</ul>
	
	<B>Data Import Completed Successfully</B><P>
	<UL> <%=TotalImportedRecords%> Customer records imported<br>
	</ul>
	

</body>
</html>

<% Function CheckForUniqueTableValues(Tablename, Columnname, tablevalue)
	'This function checks to see if the passed column for a selected
	' table is unique (ie email in customer table, username, etc)
	' This functions either a "UNIQUE" or "NOTUNIQUE" returns
	
		' Notice we using another connection incase we already using conntemp.
		
		set conntemp2=server.createobject("adodb.connection")
	
		conntemp2.open myDSN ' Open the connection once here
	
		mySQL2="select * from " & tablename & " where " & Columnname & " = '" & TableValue & "'" 
			
		set rstemp5=conntemp2.execute(mySQL2)
	
		' Check to see if any records are returned
		' if none found the
		if rstemp5.EOF then
			CheckForUniqueTableValues = "UNIQUE"
		Else
			CheckForUniqueTableValues = "NONUNIQUE"	
		End If
	
		rstemp5.close
		set rstemp5=nothing
		
		conntemp2.close ' Close the connection
		set conntemp2=nothing
	
	End Function ' End of CheckForUniqueTableValues
	%>

