
<% 'Module: MyCases.asp

   'Description: This module displays the individual pending screen (My Cases Button).

   '(C) 1998,1999, 2000, 2001, 2002- 2007 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '6/25/2000	SAV		Created original MyCases.asp page
   '08/17/2006  SAV		Added my scheduled activites for the day at the top of the page.
   '11/05/1012  CMB     Nicer styles

	' CONSTANTS
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->
<!-- #INCLUDE FILE="../Language/GetPriorityFontColor.inc" -->
<!-- #INCLUDE FILE="../Language/CodeCustomizations.inc" -->


<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->

<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 2 ' Allow valid techs to access this function.


	CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN") ' Get the Logged TechID from the cookie

	If SecurityON = "YES" Then ' Execute this code only if Security Option Flag is set to YES
		' This flag will be set in the db_define.inc file.

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="SELECT * from Tech_staff where Tech_ID = '" & CookieID & "' AND Tech_Level >= " & TechLevel
		set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF <> True Then
			TechFullName = rstemp("first_name") & " " & rstemp("Last_name")
			ValidUser = "YES" ' Set this variable to prevent problems on next page
		End If

		rstemp.close
		set rstemp=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing
	Else
		ValidUser = "YES"
	End If


 ' End of ASP page security checks
 %>


<% if ValidUser <> "YES" Then %>
	<% ASPPage = "MyCases.asp"%>

	<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function %>

<% 'Get the value of the User Screen background color
	' And the open Cases refresh rate from the Configuration Table

	set conntemp=server.createobject("adodb.connection")

	conntemp.open myDSN ' Open the connection once here

	mySQL2="select * from Configuration"


	'**** Major problem with SQL*Server and Conntemp.execute when getting
	' configuration data.  One should use: recordset.open DSN connection 1, 3

	' Cursor type needs to be specified and use rstemp.open

	set rstemp2 = server.createobject("adodb.recordset")
	rstemp2.open mySQL2, conntemp, 1,3



	'set rstemp2=conntemp.execute(mySQL2)

	' Check to see if any records are returned
	' if none found the
	if rstemp2.EOF then
		UserPageColor = "FFFFFF" ' Default to white if record not found
	Else
		UserPageColor = rstemp2("ts_user_page_color")
		Pending_Screen_Refresh_Rate = rstemp2("Pending_Screen_Refresh_Rate")
		ts_pending_color = rstemp2("ts_Pending_Color")
		WCDateFormat = rstemp2("Date_Display_Format")
		TimeZoneAdjustment = rstemp2("Time_zone_Adjustment")

		Database = rstemp2("DatabaseType") ' Database should be set to ACCESS or SQLSERVER or MYSQL

		Databasetype2 = Database


		Language = rstemp2("Language")

		If Instr(Language,  "Calendar") Then
			DisableWebCenterCalendar = "NO"
		Else
			DisableWebCenterCalendar = "YES"
		End If



	End If

	rstemp2.close
	set rstemp2=nothing
	' Do NOT close connection here ... wait until end of module
'	conntemp.close ' Close the connection
'	set conntemp=nothing

%>


<HTML>
<HEAD>

<% If Pending_Screen_Refresh_rate <> 0 Then %>
   <META HTTP-EQUIV="Refresh" CONTENT="<%=Pending_Screen_Refresh_Rate%>">
<%End If %>

   <TITLE><%=wc_My_Cases%></TITLE>
   <!-- #INCLUDE FILE="Stylesheet.inc" -->


<!-- (C) 1996,1998, 1999, 2000, 2001, 2002 by Internet Software Sciences -->
</HEAD>

<BODY class=topwindow>







<% ' Now search for the open Cases for a specified tech
	' It can be called from the button panel as MyCases.asp where the Logged in
	' tech cookie is found and use to define the tech or it is called
	' from other Cases, the techID is passed as a query string

	If Request.Querystring("TechID") <> "" Then
		CookieID = Request.Querystring("TechID")
	End IF


' 	Get the name of the tech

	 ' We need to get the tech name directly from the database since we won't have
		' the tech name since no rows were returned

		MySQL3 = " Select * from Tech_staff where tech_ID =  '" & CookieID & "'"

		set rstemp2=Server.CreateObject("adodb.Recordset")

		rstemp2.open mySQL3, conntemp, adopenstatic

		If rstemp2.EOF <> "True" Then
			TechFullName = rstemp2("First_Name") & " " & rstemp2("Last_name")
		Else
			TechFullName = "Tech Not Defined"
		End IF
		rstemp2.close
		set rstemp2=nothing


' We also need to get the record count of cases open for this tech


		mySQL2="SELECT * from Cases where Tech_ID = '" & CookieID & "' AND Status <> 1 "
		If DatabaseType <> "ORACLE" Then
			mySQL2 = " SELECT Group_list.group_name, Cases.case_number, Cases.Scheduled_Case_Type, Cases.Due_Date, Cases.Due_Time, Cases.customer_id, Cases.open_date, Cases.open_time, Cases.mod_date, Cases.mod_time, Cases.case_one_line, Cases.severity, Cases.status, Cases.modified_flag, Customers.contact_lname, Customers.contact_fname, Customers.company FROM (Cases INNER JOIN Group_list ON Cases.group_number = Group_list.group_number) INNER JOIN Customers ON Cases.customer_id = Customers.customer_id where Tech_ID = '" & CookieID & "' AND Status <> 1 "
		Else
			mySQL2 = " SELECT Group_list.group_name, Cases.case_number, Cases.customer_id, Cases.open_date, Cases.open_time, Cases.mod_date, Cases.mod_time, Cases.case_one_line, Cases.severity, Cases.status, Cases.modified_flag, Customers.contact_lname, Customers.contact_fname, Customers.company FROM Cases, Group_list, Customers WHERE Cases.customer_id=Customers.customer_id AND Cases.group_number = Group_list.group_number AND Cases.customer_id = Customers.customer_id AND Tech_ID = '" & CookieID & "' AND Status <> 1 "
		End If


		mySQL2 = mySQL2

		'response.write "MySQL = " & mySQL2 & "<br>"


	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.

	If DatabaseType <> "ACCESS97" Then
		rstemp.CursorLocation = adUseClient
	End If

	rstemp.open mySQL2, conntemp, adopenstatic


		'set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF <> True Then

			RecordsFound = rstemp.recordcount

		Else

			RecordsFound  = 0
		End IF

		' Close this record set
		rstemp.close
		set rstemp=nothing


%>

<% ' Display any scheduled activities for the day first

If DisableWebCenterCalendar <> "YES" Then


	MyEvents = DisplayMyScheduledEvents()

Else

%>

<table width=100% cellspacing=2 cellpadding=2 border=0 class=InnerFormwrapper>
<tr>
<td width= 14% align=center class=BP2minorformtitle>
<b>
<%=RecordsFound %> &nbsp;<%=wc_Open_Cases_for%>
&nbsp;<%=TechFullName%>
&nbsp;&nbsp;&nbsp;(<a href=ExportMyCases.asp?xyzTech=<%=CookieID%> target=user_screen><%=wc_Export%></a>)&nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<a href=MyCases.asp target=MyCasesNewWindow>
<img src= "newwindow.gif" border=0></a>
&nbsp;&nbsp;&nbsp;
</b>
</td>
</tr>
</table>

<%

End If

%>


<%

'		set conntemp=server.createobject("adodb.connection")
'		conntemp.open myDSN

		'  * * * * * * Time Zone Adjustment Calculation * * * * *

		' Late is computed by comparing the Date and time with the system time
		' A special date computation is needed if TimeZoneAdjustment is set.
		If TimeZoneAdjustment = "" Or IsNull(TimeZoneAdjustment) = True Then
				TimeZoneAdjustmentInt = 0
			Else
				TimeZoneAdjustmentInt = CInt(TimeZoneAdjustment)
		End If

		NewDate = DateAdd("h", TimeZoneAdjustmentInt, Now)
		NewDateDateOnly = DateValue(NewDate)
		NewTime = TimeValue(NewDate)


		mySQL2="SELECT * from Cases where Tech_ID = '" & CookieID & "' AND Status <> 1 "
		If DatabaseType <> "ORACLE" Then
			mySQL2 = " SELECT Group_list.group_name, Cases.case_number, Cases.Scheduled_Case_Type, Cases.Due_Date, Cases.Due_Time, Cases.customer_id, Cases.open_date, Cases.open_time, Cases.mod_date, Cases.mod_time, Cases.case_one_line, Cases.severity, Cases.status, Cases.modified_flag, Customers.contact_lname, Customers.contact_fname, Customers.company FROM (Cases INNER JOIN Group_list ON Cases.group_number = Group_list.group_number) INNER JOIN Customers ON Cases.customer_id = Customers.customer_id where Tech_ID = '" & CookieID & "' AND Status <> 1 "
		Else
			mySQL2 = " SELECT Group_list.group_name, Cases.case_number, Cases.customer_id, Cases.open_date, Cases.open_time, Cases.mod_date, Cases.mod_time, Cases.case_one_line, Cases.severity, Cases.status, Cases.modified_flag, Customers.contact_lname, Customers.contact_fname, Customers.company FROM Cases, Group_list, Customers WHERE Cases.customer_id=Customers.customer_id AND Cases.group_number = Group_list.group_number AND Cases.customer_id = Customers.customer_id AND Tech_ID = '" & CookieID & "' AND Status <> 1 "
		End If


		' Now add Sort Order and toggle sort order if necessary

		SortOrder = Request.Querystring("SortBy")

		' Define Default Sort Orders that will be changed below to
		' toggle the views from Ascending to Decending

		AscendDescend = Request.Querystring("Ascend")
		If AscendDescend = "" Then
			AscendDescend = "ASC"
		End If


		If AscendDescend = "ASC" Then
			AscendDescend = "DESC"
		Else
			AscendDescend = "ASC"
		End If

		If SortOrder = "case_number" OR SortOrder = ""  Then
			FixedSortOrder = " Case_Number "
			Case_Number_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "severity"  Then
			FixedSortOrder = " Severity"
			Severity_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "open_time"  Then
			FixedSortOrder = " Open_Date " & AscendDescend & ", Open_Time "
			Open_time_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "mod_time"  Then
			FixedSortOrder = " mod_Date " & AscendDescend & ", mod_Time "
			mod_time_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "contact_fname"  Then
			FixedSortOrder = " contact_fname "
			contact_fname_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "group_name"  Then
			FixedSortOrder = " group_name "
			group_name_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "status"  Then
			FixedSortOrder = " status "
			status_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "Due_Date"  Then
			FixedSortOrder = " Due_Date " & AscendDescend & ", Due_Time "
			due_date_Background = " bgcolor=FFFFFF "
		End IF


		mySQL2 = mySQL2 & " Order by " & FixedSortOrder  & " " & AscendDescend

		'response.write "MySQL = " & mySQL2 & "<br>"


	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.

	If DatabaseType <> "ACCESS97" Then
		rstemp.CursorLocation = adUseClient
	End If

	rstemp.open mySQL2, conntemp, adopenstatic


		'set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF <> True Then

		RecordsFound = rstemp.recordcount

	 ' We need to get the tech name directly from the database since we won't have
		' the tech name since no rows were returned

		MySQL3 = " Select * from Tech_staff where tech_ID =  '" & CookieID & "'"

		set rstemp2=Server.CreateObject("adodb.Recordset")

		rstemp2.open mySQL3, conntemp, adopenstatic

		If rstemp2.EOF <> "True" Then
			TechFullName = rstemp2("First_Name") & " " & rstemp2("Last_name")
		Else
			TechFullName = "Tech Not Defined"
		End IF
		rstemp2.close
		set rstemp2=nothing


	%>

<% ' Display the Table Headers %>

<TABLE class=TightTableWrapper cellspacing=1 width=100%>
<TR>
<TD  class=ColumnLabel align=center><A HREF="MyCases.asp?TechID=<%=CookieID%>&SortBy=case_number&Ascend=<%=AscendDescend%>"><%=wc_Case%></A></TD>

<TD  class=ColumnLabel align=center><A HREF="MyCases.asp?TechID=<%=CookieID%>&SortBy=severity&Ascend=<%=AscendDescend%>"><%=wc_P%></A></TD>

<TD  class=ColumnLabel align=center><A HREF="MyCases.asp?TechID=<%=CookieID%>&SortBy=status&Group_Number=<%=Group_Number%>&Ascend=<%=AscendDescend%>"><%=wc_Status%></A></TD>


<TD  class=ColumnLabel align=center><A HREF="MyCases.asp?TechID=<%=CookieID%>&SortBy=open_time&Ascend=<%=AscendDescend%>"><%=wc_Opened%></A></TD>

<TD  class=ColumnLabel align=center><A HREF="MyCases.asp?TechID=<%=CookieID%>&SortBy=mod_time&Ascend=<%=AscendDescend%>"><%=wc_Modified%></A></TD>

<TD  class=ColumnLabel align=center><A HREF="MyCases.asp?TechID=<%=CookieID%>&SortBy=Due_Date&Ascend=<%=AscendDescend%>"><%=wc_Due_Date%></A></TD>


<TD  class=ColumnLabel align=center><A HREF="MyCases.asp?TechID=<%=CookieID%>&SortBy=contact_fname&Ascend=<%=AscendDescend%>"><%=wc_Customer%></a> / One Line Description</TD>

<TD  class=ColumnLabel align=center><A HREF="MyCases.asp?TechID=<%=CookieID%>&SortBy=group_name&Ascend=<%=AscendDescend%>"><%=wc_Group%></A></TD>
</TR>

<%

			do while not rstemp.eof

			If CInt(rstemp("Modified_Flag")) = 0 Then
				FontColor= "000000" ' Black font color
			Else
				FontColor = "FF0000" ' All Red
			End If

	' Call in function to show different font colors based on severity
	' This is now in a function called GetPriorityFontColor(Severity)
	' This routine is in a INC file called GetPriorityFontColor.inc located in the language directory.
	' Customize this one file if needed.

' New enhancement to have the font color based  on priority/severity

	Severity = rstemp("severity")

	' Comment out this line below to use the current modified flag red/black text

	FontColor = GetPriorityFontColor(Severity)


	%>
<TR>
<TD align=center
   <% If Case_Number_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>
WIDTH="4%">
<B>

<% ' If case_number is less than 1000, then fill to the left with extra zeros

	Case_Number = rstemp("Case_Number")

	If len(case_number) = 1 Then
		DisplayCaseNumber = "000" & Case_Number
	ElseIf LEn(case_number) = 2 Then
		DisplayCaseNumber = "00" & Case_Number
	Elseif Len(case_number) = 3 Then
		DisplayCaseNumber = "0" & Case_Number
	Else
		DisplayCaseNumber = Case_Number
	End If
%>


<A HREF="TCaseForm.asp?b_get_x=0&b_get_y=0&customer_id=0&case_number=<%=Case_number%>" target="user_screen"><%=DisplayCaseNumber%></A></B>&nbsp;<BR><A HREF=TCaseForm.asp?b_get_x=0&b_get_y=0&customer_id=0&case_number=<%=rstemp("Case_number")%> target="newcasewindow<%=rstemp("Case_number")%>"><IMG SRC="newwindow.gif" BORDER=0 ></A>
</TD>

<TD
   <% If Severity_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

><FONT COLOR="#<%=FontColor%>"><%=rstemp("Severity")%></FONT></TD>

<TD
   <% If Status_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

><FONT COLOR="#<%=FontColor%>">

<% ' Case Status Mappings
	' 0 = Active
	' 1 = closed
	' 2 = Wating
	' 3 = On-Hold
%>
<%
	Case_status_value = CInt(rstemp("status"))
	If case_status_value = 0 THEN
		response.write wc_Active
	ElseIf case_status_value = 2 THEN
		response.write wc_Waiting
	Else
		response.write wc_On_Hold
	End If
%>


<%

			If CInt(rstemp("Modified_Flag")) = 1 Then
				Response.write "<img src=red_tri.gif><br>"
			End If
%>

</FONT>

<% ' Now Display the Scheduled Case Status Too



	Due_Date = rstemp("Due_Date")
	Due_Time = rstemp("Due_Time")

	If IsNull(Due_Date) = False AND IsNull(Due_Time) = False Then

	' Comment out these lines if you don't like the blink
	StartBlinkTag = "<Blink>"
	EndBlinkTag = "</Blink>"

		If Due_date < NewDateDateOnly Then
			response.write "<font color=RED>"
			response.write StartBlinkTag & "LATE" & EndBlinkTag & "</font>"
		Elseif Due_date = NewDateDateOnly AND  Due_Time <= NewTime Then
			response.write "<font  color=RED>"
			response.write StartBlinkTag & "LATE" & EndBlinkTag & "</font>"
		Else
			response.write "<font  color=GREEN>"
			response.write "OK</font>"
		End IF
	End IF




%>


</TD>

<TD ALIGN=CENTER WIDTH="9%"

   <% If Open_time_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>


>
<FONT COLOR="#<%=FontColor%>">


<% ' Date and Time must be reformatted from the internal Text format of:
	' YYYYMMDD to mm/dd/yyyy
	' And Time must be converted from: HHMMSS in 24 hour format to AM/PM formats

	' Depending upon the WCDateFormat Setting (set in db_define.inc) we will
	' display the date in
	' in MM/DD/YYYY (US Version and default) or DD/MM/YYYY for UK version

	If WCDateFormat = "DDMMYYYY" Then
		ConvertedOpenDate =   mid(rstemp("open_date"),7,2) & "/" & mid(rstemp("open_date"),5,2) & "/" & mid(rstemp("open_date"),1,4)
	Else
		ConvertedOpenDate = mid(rstemp("open_date"),5,2) & "/" & mid(rstemp("open_date"),7,2) & "/" & mid(rstemp("open_date"),1,4)
	End IF

	ConvertedOpenTime = mid(rstemp("Open_time"), 1,2) & ":" & mid(rstemp("Open_time"),3,2)

	ConvertedHour = int(mid(rstemp("Open_time"),1,2))
	If ConvertedHour > 12 then
		ConvertedHour = ConvertedHour -12
		AMPM = " PM"
		ConvertedOpenTime = CStr(ConvertedHour) & mid(ConvertedOpenTime, 3,3)
	Else

		If ConvertedHour = 12 Then
			AMPM = " PM"
		Else
			AMPM = " AM"
		End If

	End If


%>

<%=ConvertedOpenDate%><Br>
<%=ConvertedOpenTime%><%=AMPM%>



</FONT>
</TD>

<TD ALIGN=CENTER WIDTH="9%"

   <% If mod_time_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

>
<FONT COLOR="#<%=FontColor%>">

<% ' Date and Time must be reformatted from the internal Text format of:
	' YYYYMMDD to mm/dd/yyyy
	' And Time must be converted from: HHMMSS in 24 hour format to AM/PM formats

	' Depending upon the WCDateFormat Setting (set in db_define.inc) we will
	' display the date in
	' in MM/DD/YYYY (US Version and default) or DD/MM/YYYY for UK version

	If WCDateFormat = "DDMMYYYY" Then

		ConvertedmodDate = mid(rstemp("mod_date"),7,2) & "/" & mid(rstemp("mod_date"),5,2)  &  "/" & mid(rstemp("mod_date"),1,4)
	else ' Default to US version
		ConvertedmodDate = mid(rstemp("mod_date"),5,2) & "/" & mid(rstemp("mod_date"),7,2) & "/" & mid(rstemp("mod_date"),1,4)
	End IF

	ConvertedmodTime = mid(rstemp("mod_time"), 1,2) & ":" & mid(rstemp("mod_time"),3,2)

	ConvertedHour = int(mid(rstemp("mod_time"),1,2))
	If ConvertedHour > 12 then
		ConvertedHour = ConvertedHour -12
		AMPM = " PM"
		ConvertedmodTime = CStr(ConvertedHour) & mid(ConvertedmodTime, 3,3)
	Else
		If ConvertedHour = 12 Then
			AMPM = " PM"
		Else
			AMPM = " AM"
		End If

	End If


%>

<%=ConvertedModDate%><Br>
<%=ConvertedModTime%><%=AMPM%>


</FONT>
</TD>

<TD ALIGN=CENTER WIDTH="9%"
   <% If due_date_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>
>
<FONT COLOR="#<%=FontColor%>">


<% ' Display the Date in UK or US formats depending upon configuration value %>
<% 	If WCDateFormat = "DDMMYYYY" Then ' Set to UK date formats
		DateDisplayString = Day(rstemp("Due_Date")) & "/" & Month(rstemp("Due_Date")) & "/" & Year(rstemp("Due_Date"))
	Else
		DateDisplayString = Month(rstemp("Due_Date")) & "/" & Day(rstemp("Due_Date")) & "/"  & Year(rstemp("Due_Date"))
	End IF

%>
<%=DateDisplayString%><br>

<%' Create Time Display String %>
<% ' Check if Due_Time is Null %>

<%
If ISNull(rstemp("Due_Time")) = False Then

	 DueHour = Hour(rstemp("Due_Time"))

	If DueHour > 12 Then
		DueHour = DueHour - 12
	End If


	DueHour = CStr(DueHour)
	If Len(DueHour) < 2 Then
		DueHour = "0" & DueHour
	End If
	DueMinute = CStr(Minute(rstemp("Due_Time")))
	If Len(DueMinute) < 2 Then
		DueMinute = "0" & DueMinute
	End If

	AMPM = Right(CStr(rstemp("Due_Time")),2)

	DisplayTimeString = DueHour & ":" & DueMinute & " " & AMPM
%>

<%=DisplayTimeString %>

<%	Else ' Display no time setting %>

--:--

<%End If %>

</font>
</TD>




<TD WIDTH="52%"
   <% If contact_fname_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

>
<FONT COLOR="#<%=FontColor%>">

(
<a href=NewCustomer.asp?ID=<%=rstemp("Customer_ID")%> target= "user_screen">
<%=rstemp("Contact_fname")%>
<% response.write " " %>
<%=rstemp("Contact_lname")%></a>)

<% ' Display the company name only if it exists
	If rstemp("Company") <> "" Then
		Response.write " [" & rstemp("Company") & "]"
	End If
%>

<br>


<B><%=rstemp("Case_One_Line")%></b></FONT></TD>

<TD WIDTH="12%"
   <% If group_name_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

><FONT COLOR="#<%=FontColor%>"><%=rstemp("Group_Name")%>
</FONT>
</TD>
</TR>

<%

				rstemp.MoveNext
			loop

%>

</table>

<center>
<font size=-2 face=arial>
<img src=red_tri.gif> = Case updated but not yet viewed or updated by assigned tech
</font>


<%


		Else ' No cases for tech
	%>

<% ' We need to get the tech name directly from the database since we won't have
	' the tech name since no rows were returned

	MySQL3 = " Select * from Tech_staff where tech_ID =  '" & CookieID & "'"

	set rstemp2=Server.CreateObject("adodb.Recordset")

	rstemp2.open mySQL3, conntemp, adopenstatic

	If rstemp2.EOF <> "True" Then
		TechFullName = rstemp2("First_Name") & " " & rstemp2("Last_name")
	Else
		TechFullName = "Tech Not Defined"
	End IF
	rstemp2.close
	set rstemp2=nothing
%>

<CENTER>No open Cases for: <B><%=TechFullName%></B></CENTER>

		<%End If %>

	<%	 ' Close the record set and close the connection

		rstemp.close
		set rstemp=nothing

		' Close the only connection to the database

		conntemp.close ' Close the connection
		set conntemp=nothing
	%>




&nbsp;
</BODY>
</HTML>



<%End If ' End of security checks %>



<% ' START OF FUNCTION TO DISPLAY SCHEDULED CASES  ********************%>





<% Function DisplayMyScheduledEvents()

%>

<table width=100% cellspacing=2 cellpadding=2 border=0 class=InnerFormwrapper>
<tr>
<td width= 14% align=center class=minorformtitle>
<b>

Todays Scheduled Events and <%=RecordsFound %> &nbsp;<%=wc_Open_Cases_for%>
&nbsp;<%=TechFullName%>
&nbsp;&nbsp;&nbsp;(<a href=ExportMyCases.asp?xyzTech=<%=CookieID%> target=user_screen><%=wc_Export%></a>)&nbsp;&nbsp;&nbsp;



&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=MyCases.asp target=MyCasesNewWindow><img src= "newwindow.gif" border=0></a>&nbsp;&nbsp;&nbsp;


</b>
</td>


</tr>



<%' Now display the events for this day %>


<%


' Compute current Date
	CurrentYear = Year(Now())
	CurrentMonth = Month(Now())
	CurrentDay = Day(Now())


	NextYear = Year(Now())
	NextMonth = Month(Now())
	NextDay = Day(Now())

	NextDate = Now()

	openouter = "no"
	openinner = "no"


' Have both current and next as the same day of the year



	'*****Important Change 8/29/05 SQL queries need to be UK or US specific

'	If WCDateFormat = "DDMMYYYY" Then   ' UK Format
	If WCDateFormat = "DDMMYYYY" AND (DatabaseType2 <> "SQLSERVER") Then   ' UK Format


		SQLDateString = NextDay & "/" & NextMonth & "/" & NextYear
	Else
		SQLDateString = NextMonth & "/" & NextDay & "/" & NextYear
	End If


	StartDate = SQLDateString
	NextDate = SQLDateString


	' Set the Selected_ID to the tech_ID from the cookie

	Selected_ID = CookieID



		'response.write "NewDate = " & NextDate

		DayNumber = Day(NextDate)

		' Now check if any events for this date by creating a special query
		' that will check for events for this person for this date

		Tech_ID = Request.Cookies("ISS_TECH_CENTER_LOGIN")

		mySQL2 = "SELECT Event_Attending.Tech_ID, Schedule.Schedule_ID, Event_Type.Event_Type_Name, Schedule.Start_Date, Schedule.Start_Time, Schedule.customer_ID, Schedule.End_Time, Schedule.End_Date, Schedule.Event_Title, Schedule.Event_Status FROM (Event_Attending INNER JOIN Schedule ON Event_Attending.Schedule_ID = Schedule.Schedule_ID) INNER JOIN Event_Type ON Schedule.Event_Type_ID = Event_Type.Event_Type_ID "
		'mySQL2 = "SELECT Event_Attending.Tech_ID, Schedule.Schedule_ID, Event_Type.Event_Type_Name, Schedule.Start_Date, Schedule.Start_Time, Schedule.End_Time, Schedule.End_Date, Schedule.Event_Title, Schedule.Event_Status, Customers.contact_fname, Customers.contact_lname, Customers.company FROM ((Event_Attending INNER JOIN Schedule ON Event_Attending.Schedule_ID = Schedule.Schedule_ID) INNER JOIN Event_Type ON Schedule.Event_Type_ID = Event_Type.Event_Type_ID) INNER JOIN Customers ON Schedule.Customer_ID = Customers.customer_id "

        If selected_id = wc_All_Tech_Staff Then
            show_attendees = "Yes"
		    mySQL2 = mySQL2 & " Where 2 = 2 "
		Else
		    show_attendees = "No"
		   mySQL2 = mySQL2 & " Where Event_Attending.Tech_ID = '" & selected_ID & "' "
		End If



		' Now add dates into query
		' Note Access version requires # for dates, SQL requires single quotes


		If DatabaseType2 = "ACCESS" Then
				mySQL2 = mySQL2 & " and  Start_Date <= #" & NextDate & "# And End_Date >= #"& NextDate & "#"
		End IF

		If DatabaseType2 = "SQLSERVER" Then
			mySQL2 = mySQL2 & "  and Start_Date <= '" & NextDate & "' And End_Date >= '"& NextDate & "'"
		End IF

		If DatabaseType2 = "MYSQL" Then
			mySQL2 = mySQL2 & " and  Start_Date <= '" & YYMMDD(NextDate) & "' And End_Date >= '"& YYMMDD(NextDate) & "'"
		End IF

        mySQL2 = mySQL2 & " ORDER BY Schedule.start_time"   ' order the meetings by start time within a given day

		' Debugging
		'response.write " MYSQL2 = " & mySQL2


		'mySQL2 = " select * from Schedule"

	If openouter = "no" Then
		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN
		openouter = "yes"
	end If




	set rstemp2=conntemp.execute(mySQL2)

	ThisDebug="Yes"
	If thisDebug = "No" Then
			response.write "SQL=" &  mySQL2
			if rstemp2.EOF then
			   response.write "<p> I have eof<p>"
			else
			  response.write "<p> I DO NOT have eof<p>"
			End if
			response.flush
		    response.end
    End If



	' Check to see if any records are returned
	' if none found the
	if rstemp2.EOF then ' Close out the table cell

		If NextDay = CurrentDay AND NextMonth = CurrentMonth AND NextYear = CurrentYear THEN
			response.write "<tr><td   class=CalendarListToday>" & vbCRLF
		Else
			response.write "<tr><td class=CalendarListText>" & vbCRLF
		End If

		response.write "<a href=ShowDayCalendar.asp?PassedDay=" & DayNumber & "&PassedMonth=" & PassedMonth & "&PassedYear=" & PassedYear & ">"
		response.write DayNumber & "</a>"


		DayName = WeekDayName(WeekDay(NextDate))
		response.write " / " & DayName

		'response.write "&nbsp;&nbsp;&nbsp;("
		'response.write "<a href=ShowDayCalendar.asp?PassedDay=" & DayNumber & "&PassedMonth=" & PassedMonth & "&PassedYear=" & PassedYear & ">"
		'response.write wc_My_Calendar & "</a>)"


		'response.write "&nbsp;&nbsp;&nbsp;("
		'response.write "<a href=ShowGroupDayCalendar.asp?PassedDay=" & DayNumber & "&PassedMonth=" & PassedMonth & "&PassedYear=" & PassedYear & ">"
		'response.write wc_Group_Calendar & "</a>)"
%>

 - (No events scheduled for Tech for today)

<!--
 <a href='javascript:var w=window.open("ExportMyCalendarEvents.asp?PassedDay=<%=NextDay%>&PassedMonth=<%=NextMonth%>&PassedYear=<%=NextYear%>","subwindow","width=600,height=200,screenX=50,screenY=50,left=50,top=50,scrollbars=yes,resizable=yes")'>
(vCalendar Sync All Events)</a>

-->


<%

		response.write "<br></td>"
		response.write "</tr>"

	Else ' There is at least one entry for this date



		If NextDay = CurrentDay AND NextMonth = CurrentMonth AND NextYear = CurrentYear THEN
			response.write "<tr><td  class=CalendarListToday>"  & vbCRLF
			todayclass="CalendarListToday"
		Else
			response.write "<tr><td class=CalendarListText>" & vbCRLF
			todayclass="CalendarListText"
		End If

		response.write "<a href=ShowDayCalendar.asp?PassedDay=" & DayNumber & "&PassedMonth=" & PassedMonth & "&PassedYear=" & PassedYear & " target=user_screen >"
		response.write DayNumber & "</a>"




		DayName = WeekDayName(WeekDay(NextDate))
		response.write " / " & DayName



%>

	&nbsp;&nbsp;&nbsp;&nbsp;
 <a href='javascript:var w=window.open("ExportMyCalendarEvents.asp?PassedDay=<%=NextDay%>&PassedMonth=<%=NextMonth%>&PassedYear=<%=NextYear%>","subwindow","width=600,height=200,screenX=50,screenY=50,left=50,top=50,scrollbars=yes,resizable=yes")'>
(vCalendar Sync for all my events today)</a>

<%


		'response.write "&nbsp;&nbsp;&nbsp;("
		'response.write "<a href=ShowDayCalendar.asp?PassedDay=" & DayNumber & "&PassedMonth=" & PassedMonth & "&PassedYear=" & PassedYear & " target=user_screen>"
		'response.write wc_My_Calendar & "</a>)"

		'response.write "&nbsp;&nbsp;&nbsp;("
		'response.write "<a href=ShowGroupDayCalendar.asp?PassedDay=" & DayNumber & "&PassedMonth=" & PassedMonth & "&PassedYear=" & PassedYear & " target=user_screen>"
		'response.write wc_Group_Calendar & "</a>)"


		response.write "<Table >" ' initiate table containing event details

       previous_id = ""

		Do While rstemp2.EOF <> True
			Schedule_ID = rstemp2("Schedule_ID")


			' Get the Customer and company information from a separate Query

			Customer_ID = rstemp2("customer_id")
			CustomerName = "" ' Clear out customer name

			If Customer_ID <> ""  Then

				MySQL3 = " Select * from Customers where customer_id =  '" & customer_id & "'"



                If openinner = "no" Then
				   set rstemp3=Server.CreateObject("adodb.Recordset")
				   openinner= "yes"
				end if

				rstemp3.open mySQL3, conntemp, adopenstatic

				If rstemp3.EOF <> "True" Then
					CustomerName = rstemp3("contact_fname") & " " &  rstemp3("Contact_lname")
					Company = rstemp3("Company")
				Else
					CustomerName = ""
					Company = ""
				End If

				rstemp3.close ' Close the Record set now

			End IF

			CustomerNAme = CustomerName & "/" & Company


			'Event_Type_ID = rstemp2("Event_Type_ID")
			'Email_Reminder = rstemp2("email_reminder")
			Start_Date = rstemp2("Start_Date")
			Start_Time = rstemp2("Start_Time")
			End_Date = rstemp2("End_Date")
			End_Time = rstemp2("End_Time")
			Tech_ID =  rstemp2("Tech_ID")
			Event_Title = rstemp2("Event_Title")
			'Event_Notes = rstemp2("Event_Notes")
			Status = rstemp2("Event_Status")
			'CustomerName = rstemp2("contact_fname") & " " &  rstemp2("Contact_lname")
			'Company = rstemp2("Company")
			'CustomerNAme = CustomerName & "/" & Company
			Event_Type = rstemp2("Event_Type_Name")



	' -------- start of a meeting item ------------------
	if Schedule_ID <> previous_id Then

            response.write "<tr><td width=20 align=right valign=top>&bull;</td><td class=" & todayclass & ">"
			response.write "<B><a href=EditEvent.asp?ID=" & Schedule_ID & " target=user_screen>" & Event_Title & "</a></b>"

			response.write "&nbsp;&nbsp;" & Start_Time & "-" & End_Time





			If Customer_ID <> "" Then
				response.write "&nbsp;&nbsp;&nbsp;(" &  CustomerName & ")"
			End If


			If status = "0" Or status = "" Then
			StatusString = wc_No_Status
			End If

			If status = "1"  Then
			StatusString = wc_Scheduled
			End IF

			If status = "2"  Then
			StatusString = wc_Postponed
			End IF

			If status = "3"  Then
			StatusString = wc_Cancelled
			End IF

			If status = "4"  Then
			StatusString = wc_Rescheduled
			End IF

			response.write "&nbsp;&nbsp;&nbsp;&nbsp;<B>[" & StatusString & "]</B>"

			' Display a link to sync this one calendar item

%>

&nbsp;&nbsp;
 <a href='javascript:var w=window.open("ExportMyCalendarEvents.asp?PassedDay=<%=NextDay%>&PassedMonth=<%=NextMonth%>&PassedYear=<%=NextYear%>&EventID=<%=Schedule_ID%>","subwindow","width=600,height=200,screenX=50,screenY=50,left=50,top=50,scrollbars=yes,resizable=yes")'>
(vCalendar Sync)</a>

<%

			response.write "</td>"



			If show_attendees = "Yes" Then
				response.write "</tr><tr><td width=20></td><td class=" & todayclass & ">"
				response.write " <b>Attendees: </b>"
				ResolveName Tech_ID
		    End If

	Else
	        If show_attendees = "Yes" Then
                   ResolveName Tech_ID
            End If

	End If

 ' -------- end of a meeting item ------------------





		previous_id = Schedule_ID


		rstemp2.movenext


		loop
        response.write "</tr></table>" ' end of meetings within a given day
		response.write "</td></tr>"


	End If ' End of If rstemp = EOF



	Event_Type = ""
	CustomerName = ""





%>

</table>






<%
	DisplayMyScheduleEvents = "YES"

	End Function
%>


<% Function YYMMDD(datestring)
' This function takes a date string in MM/DD/YY format and recasts it in YY/MM/DD format

   DIM aryChunk
   aryChunk = Split(datestring,"/")
   YYMMDD = aryChunk(2) & "/" & aryChunk(0) & "/" & aryChunk(1)

End Function
%>