<% 'Module: OpenCasesByDuration.asp

   'Description: This module is the basic report module from which other report
   ' modules can be built from.
   ' This page can be customized by the user to either add custom
   ' reports or to modify the Tech+Center Control Status Panel.
   ' Please refer to the Web+Center user documentation on how to
   ' modify this script.  This should only be done by advanced system
   ' users and all changes should be carefully changed.  Any code that
   ' updates the database will not be supported without additional
   ' cost from Internet Software Sciences.  Persons adding to this code
   ' should be familar with the ASP programming and how to access a
   ' database from the ASP progamming scripting language.

   '(C) 1999, 2001, 2002 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '9/09/99	SAV		Created original OpenCasesByTech.asp page
   '9/13/99	SAV		Created original from OpencasesByTech page
   '07/18/02	SAV		Fixed problem with day checking from 8 to 7 days.

	' CONSTANTS
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" --> <% ' Besure this file is placed into the TechCenter directory %>
<% 'First Show the Report Menu at the top of the page
%>

<html>

<head>
<title><%=wc_Open_Cases_By_Duration%></title>
</head>

<% 'Get the value of the User Screen background color from the Configuration Table %>
<%
	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL2="select * from Configuration"
	set rstemp2=conntemp.execute(mySQL2)

	' Check to see if any records are returned
	' if none found the
	if rstemp2.EOF then
		UserPageColor = "FFFFFF" ' Default to white if record not found
	Else
		UserPageColor = rstemp2("ts_user_page_color")
	End If

	WCDateFormat = rstemp2("Date_Display_Format")

	rstemp2.close
	set rstemp2=nothing

%>

<body bgcolor="<%=UserPageColor%>">
<center>
<font size=+1><%=wc_Open_Cases_By_Duration%></font></center>
<P>

<%' First get all of the open Cases total count since we will need that for our percentage calculation%>
<% ' Get Total number of Cases

	connectMe=myDSN
	sqltemp="select * from Cases where status <> 1"
	set rstemp=Server.CreateObject("adodb.Recordset")

	'-->AKS<-- Need to specify cursore for record count to be correct.
	If DatabaseType <> "ACCESS97" Then
		rstemp.CursorLocation = adUseClient
	End If

	rstemp.open sqltemp, connectme, adopenstatic
	TotalOpenCases = rstemp.recordcount
	rstemp.close
	set rstemp=nothing

%>

<% ' The Duration Report places open Cases into the following durations caluclated from the open_date to
	' to the current date.  There are 6 bins which each open case is placed into:
	' Today = Date Difference = 0
	' Yesterday = Date Difference = 1
	' 2-7 days old (1 Week)
	' 8-31 Days (1 month)
	' 32-162 Days (6 months)
	' 163 or more (6 months or older)

	' Using the DateDiff() VB scripting function we can determine the difference between the
	' starting date and the today's date.
	' The following variables are used to store counts for these various bins

	TodaysCases = 0
	YesterdaysCases = 0
	ThisWeeksCases = 0
	SecondWeekCases = 0
	ThirdFourthWeekCases = 0
	ThisMonthsCases = 0
	SixMonthCases = 0
	GreaterThanSixMonthCases = 0

' Now step through data set

	' Get the Case statistics from the case table
%>
<%
	mySQL="select * from Cases where status <> 1 order by Status"
	set rstemp=conntemp.execute(mySQL)

	' Check to see if any records are returned
	' if none found then login fails.

	If  rstemp.eof then ' Check to see if any open Cases
		TotalOpenCases = 0

	Else ' Must be one or more open Cases
		CurrentDate = FormatDateTime( Date, vbGeneralDate)
		'-->AKS<-- For some reason ORACLE does not return recordcount so need to calculate it.

		Do While not rstemp.eof


			OpenDate = rstemp("Open_Date") ' Open_Date is a String type and not a real Date type
			' Now put this OpenDate format into a format that the DateDiff() function can
			' work with converting from YYYYMMDD to mm/dd/yyyy
            ' But be sure to flip the MM and DD if DateFormat is set to UK

			If WCDateFormat = "DDMMYYYY" Then
                FormattedOpenDate = mid(OpenDate,7,2) & "/" & mid(OpenDate,5,2) & "/" & mid(OpenDate,1,4)
            Else
			    FormattedOpenDate = mid(OpenDate,5,2) & "/" & mid(OpenDate,7,2) & "/" & mid(OpenDate,1,4)
			End If

			DaysOpened = DateDiff("d",  FormattedOpenDate, CurrentDate)

			if DaysOpened = 0 Then
				TodaysCases = TodaysCases + 1
			'Elseif DaysOpened = 1 Then
			'	YesterdaysCases  = 1 + YesterdaysCases
			Elseif (DaysOpened > 0) AND (DaysOpened < 8) Then
				ThisWeeksCases = 1 + ThisWeeksCases
			Elseif ((DaysOpened > 7) AND (DaysOpened < 15)) Then
				SecondWeekCases = 1 + SecondWeekCases
			ElseIf (DaysOpened > 14) and (DaysOpened < 32) Then
				ThisMonthsCases = 1 + ThisMonthsCases
			Else
				SixMonthCases = 1 + SixMonthCases
			End IF

			rstemp.movenext
		loop
	End If


	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing
%>


<% ' Now display the graphics %>

<center>
<table width=95% border = 1>
<tr>
<th width=30% bgcolor=E0E0E0><font size=-1><%=wc_Duration%></th>
<th width=10% bgcolor=E0E0E0><font size=-1> # </th>
<th width=10% bgcolor=E0E0E0><font size=-1> % <%=wc_of_Total%></th>
<th width=50% bgcolor=E0E0E0><font size=-1><%=wc_Graphical_Percentage%></th>
</tr>

<tr>
<td width=30%><font size=-1><B>Total Open Cases</b></td>
<td width=10% align=center><font size=-1><%=TotalOpenCases%></td>
<% If TotalOpenCases = 0 Then
		Percentage = 0
	Else
 		Percentage = 100
	End If
%>

<td align=center width=10%><font size=-1>
<% if Percentage = 0 Then
	response.write "-"
Else
	response.write Percentage & "%"
End If
%>

</td>
<td width=50%><font size=-1>
<%' Build a table graphic with color and fixed size %>
<table><tr><td bgcolor=red width=<%=Percentage*2%>><font size=-1>&nbsp</td></tr></table>
</td>
</tr>



<tr>
<td width=30%><font size=-1><B>Opened 0-7 Days Ago</b></td>
<td width=10% align=center><font size=-1><%=ThisWeeksCases%></td>
<% If TotalOpenCases = 0 Then
		Percentage = 0
	Else
 		Percentage = Int(100* (ThisWeeksCases/TotalOpenCases))
	End If
%>

<td align=center width=10%><font size=-1>
<% if Percentage = 0 Then
	response.write "-"
Else
	response.write Percentage & "%"
End If
%>

</td>
<td width=50%><font size=-1>
<%' Build a table graphic with color and fixed size %>
<table><tr><td bgcolor=PURPLE width=<%=Percentage*2%>><font size=-1>&nbsp</td></tr></table>
</td>
</tr>


<tr>
<td width=30%><font size=-1><B>Opened 8-14 Days</b></td>
<td width=10% align=center><font size=-1><%=SecondWeekCases%></td>
<% If TotalOpenCases = 0 Then
		Percentage = 0
	Else
 		Percentage = Int(100* (SecondWeekCases/TotalOpenCases))
	End If
%>

<td align=center width=10%><font size=-1>
<% if Percentage = 0 Then
	response.write "-"
Else
	response.write Percentage & "%"
End If
%>

</td>
<td width=50%><font size=-1>
<%' Build a table graphic with color and fixed size %>
<table><tr><td bgcolor=ORANGE width=<%=Percentage*2%>><font size=-1>&nbsp</td></tr></table>
</td>
</tr>


<tr>
<td width=30%><font size=-1><B>Opened 15-31 Days</b></td>
<td width=10% align=center><font size=-1><%=ThisMonthsCases%></td>
<% If TotalOpenCases = 0 Then
		Percentage = 0
	Else
 		Percentage = Int(100* (ThisMonthsCases/TotalOpenCases))
	End If
%>

<td align=center width=10%><font size=-1>
<% if Percentage = 0 Then
	response.write "-"
Else
	response.write Percentage & "%"
End If
%>

</td>
<td width=50%><font size=-1>
<%' Build a table graphic with color and fixed size %>
<table><tr><td bgcolor=ORANGE width=<%=Percentage*2%>><font size=-1>&nbsp</td></tr></table>
</td>
</tr>



<tr>
<td width=30%><font size=-1><B>Opened greater than 31 Days</b></td>
<td width=10% align=center><font size=-1><%=SixMonthCases%></td>
<% If TotalOpenCases = 0 Then
		Percentage = 0
	Else
 		Percentage = Int(100* (SixMonthCases/TotalOpenCases))
	End If
%>

<td align=center width=10%><font size=-1>
<% if Percentage = 0 Then
	response.write "-"
Else
	response.write Percentage & "%"
End If
%>

</td>
<td width=50%><font size=-1>
<%' Build a table graphic with color and fixed size %>
<table><tr><td bgcolor=YELLOW width=<%=Percentage*2%>><font size=-1>&nbsp</td></tr></table>
</td>
</tr>



</table>
</center>

<br><center>
<a href=Reports.asp><img src=/<%=WCLanguageDirectory%>/ts_reports21x120.gif border=0></a>
</center>


</body>
</html>


