<% 'Module: OpenCasesByGroup.asp

   'Description: This module is the basic report module from which other report
   ' modules can be built from.
   ' This page can be customized by the user to either add custom
   ' reports or to modify the Tech+Center Control Status Panel.
   ' Please refer to the Web+Center user documentation on how to
   ' modify this script.  This should only be done by advanced system
   ' users and all changes should be carefully changed.  Any code that
   ' updates the database will not be supported without additional
   ' cost from Internet Software Sciences.  Persons adding to this code
   ' should be familar with the ASP programming and how to access a
   ' database from the ASP progamming scripting language.

   '(C) 1999 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '9/09/99	SAV		Created original OpenCasesByTech.asp page
   '9/10/99	SAV		Created from OpenCasesByTech.asp page
   '08/05/11 CMB    cleaned up; uk dates

   ' this report takes all cases that are currently open and groups them by GROUP

	' CONSTANTS
	%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->


<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->
<!-- #INCLUDE FILE="Reports.inc" -->

<% 'First Show the Report Menu at the top of the page
%>
<html>
<head>
<title>Open Cases By Group</title>
</head>

<%
    call  GetConfig(DateDisplayFormat,UserPageColor,DatabaseType)
%>

<body bgcolor="<%=UserPageColor%>">
<center>
<table border=1 width=95%>
<tr>
<td align=center bgcolor=F0F0BO>
<font size=-1><%=wc_CASE_REPORT%></font>
</td>
<td bgcolor=F0E0F0 align=center>
<font size=+1>Open Cases By Group</font>
<center>
<font size=-2>This report shows all cases that are CURRENTLY open broken down by group.<br> Percentage
is based on all cases currently open by any group.</font>

</td>
<td align=center bgcolor=B0F0F0>
<font size=-1><%=Now%></font>
</td>
</tr></table>
</center>

<%' First get all of the open Cases total count since we will need that for our percentage calculation%>
<%
	 'Get Total number of cases still open
	set conn=server.createobject("adodb.connection")
	conn.open myDSN
	sqltemp="select Count(Case_Number) as cnt from Cases where status <> 1 "
	set rstemp=Server.CreateObject("adodb.Recordset")

	rstemp.open sqltemp, conn, adopenstatic
	TotalOpenCases = rstemp("cnt")
	rstemp.close
	set rstemp=nothing
%>

<center>
<table width=95% border = 1>
<tr>
<th width=30% bgcolor=E0E0E0><font size=-1><%=wc_Group_Name%></th>
<th width=10% bgcolor=E0E0E0><font size=-1> # </th>
<th width=10% bgcolor=E0E0E0><font size=-1> % <%=wc_of_Total%></th>
<th width=50% bgcolor=E0E0E0><font size=-1><%=wc_Graphical_Percentage%></th>
</tr>

<% ' Get all open Cases, sort by GROUP  compute what percentage that each GROUP has and then display it graphically
	If TotalOpenCases = 0 then ' Check to see if any open Cases
%>
		<tr><td colspan=4><font size=-1> No Open Cases </font></td></tr>
<%
	Else ' Must be one or more open Cases
			set rstemp=Server.CreateObject("adodb.Recordset")

			sqltemp = "select count(cases.group_number) as cnt,cases.group_number,group_Name from cases "
			sqltemp = sqltemp & "left outer join group_list on group_list.group_number = cases.group_number "
			sqltemp = sqltemp & " where status <> 1 "
			sqltemp =  sqltemp & "group by cases.group_number, group_list.group_name "
			sqltemp = sqltemp & " Order by " & "cases.Group_Number"
			rstemp.open sqltemp, conn, adopenstatic

			' Setup for the first one  outside of the loop
			Color = "Purple" ' Set up First color


			do while not rstemp.eof

	 			color=RotateColor(color)
	 			TechOpenCases = rstemp("Cnt")
				If IsNull(rstemp("Group_Name"))then
					Group_Name = "Not Assigned"
				Else
					Group_Name = rstemp("Group_Name")
					Group_Number = ""
				End If
				TechOpenCases = rstemp("cnt")
				if isnull(rstemp("Group_Number")) then
					Group_Number = ""
				else
					Group_Number = rstemp("Group_Number")
				end if
		%>
<tr>

<td><font size=-1><%=Group_Name%></td>
<td align=center><font size=-1>
<B><a href=DoSearch1.asp?Group_Number=<%=Group_Number%>&Case_Status=4&ResultsView=BRIEF>
<%=TechOpenCases%></b>

</td>
<%
'Percentage = CInt(100* (TechOpenCases/TotalOpenCases))
Percentage = Round(100*(TechOpenCases/TotalOpenCases),1)
%>

<td align=center><font size=-1><%=Percentage%>%
</td>
<td><font size=-1>
<%' Build a table graphic with color and fixed size %>
<table><tr><td bgcolor=<%=color%> width=<%=Percentage*3%>><font size=-1>&nbsp</td></tr></table>

</td>
</tr>

<%
			rstemp.movenext
		loop
		rstemp.close
		set rstemp=nothing
	End If

	conn.close ' Close the connection
	set conn=nothing

 ' Display the summary row information
	color=RotateColor(color)
%>
<tr>
<td bgcolor=FFFFFF align=right><font size=-1> <B>-----------  <%=wc_Summary_Total%>:</b></td>

<td align=center bgcolor=FFFFFF><font size=-1><B><%=TotalOpenCases%></b></td>

<td align=center bgcolor=FFFFFF><font size=-1><B>100% </b></td>

<td bgcolor=FFFFFF><font size=-1>
<%' Build a table graphic with color and fixed size %>
<table><tr><td bgcolor=<%=color%> width=<%=100*3%>><font size=-1>&nbsp</td></tr></table>

</td>
</tr>

</table>
<P>
<center>
<a href=Reports.asp><img src=/<%=WCLanguageDirectory%>/ts_reports21x120.gif border=0></a>
</center>
</body>
</html>


