<% 'Module: AssetInfo.asp

   'Description: This module is the AssetInfo edit and new asset
   ' module that is used to create new or update existing
   ' asset information.

   '(C) 2000-2006 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '12/15/00	SAV		Created original AssetInfo Page
	'12/03/01	SAV		Integrated AssetLabels.inc into this page
	'08/28/2006 SAV		Modified the module to be more configurable for asset systems
    '04/12/2011 CMB     added Inspection History (probably should add asset label definition?)
    '10/03/2011 CMB     Added 3 subs to support dropdowns.  Look to see whether dropdown.  Add way to create case from asset;
    '                   Merged 3 calls to configuration. Changed method of getting asset notes
	'10/10/2011 CMB     3 columns;
	'12/07/11   CMB     Email; cancel does 'prev'
	'12/11/11   CMB     Remove from email box; use organization name instead
	'01/05/12   CMB     Order by for asset inspections
	'02/20/12   CMB     Moved app stuff to other column
   '04/30/12   CMB     Changed javascript from retire to surplus;
   '04/14/14   CMB     Attaching for hosted systems

%>


<% ' CUSTOMIZATION NOTES:
	' The asset management system of Web+Center is designed to be customized to fit your
	' particular asset requirements.
	'   To customize the asset system for your data requirements, follow the
	' 	the steps below.

	' Step 1: First in Assetlabels.inc, uncomment the line that will bring in AssetLabelsCustom.inc
	' by uncommenting the line that says CustomAssets = "YES"
	'
	' Step 2: Customize the labels in AssetLabelsCustom.inc to your own data requirements
	' Step 3: Determine which asset fields you want to have on your own tech+center asset
	'  form by commenting out the asset label definition.  IF the asset label does not exist,
	' then that asset field will not be displayed.
%>


<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->
<!-- #INCLUDE FILE="../Language/CodeCustomizations.inc" -->
<!-- #INCLUDE FILE="Reports.inc" -->

<% ' To customize the Asset labels, edit the file called AssetLabels.inc
	' and then copy the edited file to customercenter directory
%>

<!-- #INCLUDE FILE="../Language/AssetLabels.inc" -->

<%' Include this file for special database cursor constants %>

<!-- #INCLUDE FILE="Adovbs.inc" -->

<% ' Put all of your custom web site changes into BCHeader.inc %>


<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 2 ' Allow only levels 2 and above
	If SBCC = "YES" then
		EditTechLevel = 4
	Else
		EditTechLevel = 3 ' was > than not >= so making it 3
	End If

	CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN") ' Get the Logged TechID from the cookie

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="SELECT * from Tech_staff where Tech_ID = '" & CookieID & "' AND Tech_Level >= " & TechLevel
		set rstemp=conntemp.execute(mySQL2)

		If rstemp.EOF <> True Then
			ValidUser = "YES" ' Set this variable to prevent problems on next page
			Tech_Level = rstemp("Tech_Level")
			if not IsNull(rstemp("Work_Email")) then  ' EMAILS
				TechEmail = rstemp("Work_Email") ' EMAILS
			Else ' EMAILS
				TechEmail = "" ' EMAILS
			End If ' EMAILS
		End If

		rstemp.close
		set rstemp=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing

 ' End of ASP page security checks
 %>


<% if ValidUser <> "YES" Then %>
	<% ASPPage = "AssetInfo.asp"%>

	<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function %>

<% ' Get get the Database information starting with configuration information %>

<% ' Get the information about the time formats

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Configuration"
	'**** Major problem with SQL*Server and Conntemp.execute when getting
	' configuration data.  One should use: recordset.open DSN connection 1, 3

	set rstemp2 = server.createobject("adodb.recordset")
	rstemp2.open mySQL, conntemp, 1,3

	if rstemp2.EOF then
		UserPageColor = "FFFFFF" ' Default to white if record not found
		bAssetInspections = True  ' backwards compabitility
	Else
		UserPageColor = rstemp2("ts_user_page_color")
		WCDateFormat = rstemp2("Date_Display_Format")
		TimeSpentCategory = rstemp2("Time_Spent_Category")
		If TimeSpentCategory <> "" then
			TimeSpentCategory = "C" & TimeSpentCategory
		End If

		Customer_ID_List = rstemp2("customer_id_list")
		TimeSpentInterval = rstemp2("Time_Spent_Interval")
		MinutesPerCategory = TimeSpentInterval

		bAssetInspections = True ' backwards compabitility
		FileUpLoadDestinationPath = rstemp2("FileUploadPhysicalPath") ' Set this to your full destination path  ' 04/14/14

		If version7point5="YES" then
			If not IsNull(rstemp2("AssetInspections")) Then ' not used
				bAssetInspections = rstemp2("AssetInspections")

			End If
		End If

	End If

	rstemp2.close
	set rstemp2=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

%>

<% ' Determine if this a new Asset entry or an edit of an existing asset

	 Asset_number = Request.Querystring("Asset_number")
	 If Asset_number = "" THen
	 	Asset_number = "NEW"
	End IF

	'Response.write "Asset_number = " & Asset_number & "<br>"

	If Asset_Number <> "NEW" Then ' Get all of the asset values
		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		Set rstemp2 = Server.CreateObject("ADODB.Recordset") ' NEW ASSETS changed this

		mySQL2="select * from Assets where asset_number =" & Asset_number
		'set rstemp2=conntemp.execute(mySQL2)
		rstemp2.Open mySQL2,conntemp,3,3  ' NEW ASSETS changed open command in order to get memo fields

		' Check to see if any records are returned
		' if none found then
		if rstemp2.EOF then
			response.write " Invalid Asset_number:" & Asset_number
		Else

			computer_id = rstemp2("Computer_id")
			property_tag = rstemp2("Property_tag")
			Equipment_type = rstemp2("equipment_type")

			lease_or_purchase = rstemp2("lease_or_purchase")

			purchase_order_num = rstemp2("purchase_order_num")

			serial_number = rstemp2("serial_number")

			' Acquisition
			acquired_from = rstemp2("acquired_from")
			date_acquired = rstemp2("date_acquired")
			date_in_service = rstemp2("date_in_service")

			' Specifications

			Processor_speed = rstemp2("processor_speed")
			ram_size = rstemp2("ram_size")
			hd_size = rstemp2("hd_size")
			monitor_model = rstemp2("monitor_model")
			monitor_size = rstemp2("monitor_size")
			Monitor_serial_num = rstemp2("Monitor_serial_num")

			'assignments

			assigned_group = rstemp2("assigned_group")
			location = rstemp2("location")
			date_assigned = rstemp2("date_assigned")
			ip_address = rstemp2("ip_address")
			wall_port_number =rstemp2("wall_port_number")

			' Applications
			operating_system1 = rstemp2("operating_system1")
			operating_system2 = rstemp2("operating_system2")

			app1 = rstemp2("app1")
			app1_product_id = rstemp2("app1_product_id")
			app1_install_date = rstemp2("app1_install_date")

			app2 = rstemp2("app2")
			app2_product_id = rstemp2("app2_product_id")
			app2_install_date = rstemp2("app2_install_date")

			app3 = rstemp2("app3")
			app3_product_id = rstemp2("app3_product_id")
			app3_install_date = rstemp2("app3_install_date")

			app4 = rstemp2("app4")
			app4_product_id = rstemp2("app4_product_id")
			app4_install_date = rstemp2("app4_install_date")

			app5 = rstemp2("app5")
			app5_product_id = rstemp2("app5_product_id")
			app5_install_date = rstemp2("app5_install_date")

			app6 = rstemp2("app6")
			app6_product_id = rstemp2("app6_product_id")
			app6_install_date = rstemp2("app6_install_date")

			app7 = rstemp2("app7")
			app7_product_id = rstemp2("app7_product_id")
			app7_install_date = rstemp2("app7_install_date")

			app8 = rstemp2("app8")
			app8_product_id = rstemp2("app8_product_id")
			app8_install_date = rstemp2("app8_install_date")

			app9 = rstemp2("app9")
			app9_product_id = rstemp2("app9_product_id")
			app9_install_date = rstemp2("app9_install_date")

			app10 = rstemp2("app10")
			app10_product_id = rstemp2("app10_product_id")
			app10_install_date = rstemp2("app10_install_date")

			app11 = rstemp2("app11")
			app11_product_id = rstemp2("app11_product_id")
			app11_install_date = rstemp2("app11_install_date")

			app12 = rstemp2("app12")
			app12_product_id = rstemp2("app12_product_id")
			app12_install_date = rstemp2("app12_install_date")

			app13 = rstemp2("app13")
			app13_product_id = rstemp2("app13_product_id")
			app13_install_date = rstemp2("app13_install_date")

			app14 = rstemp2("app14")
			app14_product_id = rstemp2("app14_product_id")
			app14_install_date = rstemp2("app14_install_date")

			app15 = rstemp2("app15")
			app15_product_id = rstemp2("app15_product_id")
			app15_install_date = rstemp2("app15_install_date")

			' Get the custom fields 1-5
			custom_field1 = rstemp2("custom_field1")
			custom_field2 = rstemp2("custom_field2")
			custom_field3 = rstemp2("custom_field3")
			custom_field4 = rstemp2("custom_field4")
			custom_field5 = rstemp2("custom_field5")

			LastUpdate = rstemp2("LastUpdate")
			UpdatedBy = rstemp2("UpdatedBy")

			' Get the asset_notes

			AssetNotes = rstemp2("assetnotes")

		End If ' End if If EOF <> True


	rstemp2.close
	set rstemp2=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing


	' Get any asset assignment from the AssetAssignment Table

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="select * from AssetAssignment where asset_number =" & Asset_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			'response.write " No assigment Found for Asset:" & asset_number
			' No assignment found which is ok
		Else
			Customer_id = rstemp2("Customer_ID")
			Tech_id = rstemp2("tech_id")
			Asset_number2 = rstemp2("Asset_number2")
		End If ' End if If EOF <> True

		rstemp2.close
		set rstemp2=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing

	End IF 'if Asset <> NEW
%>

<html>


<!-- (C) 1996,1998, 1999, 2000, 2001, 2002, 2003 by Internet Software Sciences -->

<head>

<STYLE TYPE='text/css'>
P.pagebreakhere {page-break-before: always}
</STYLE>

<title><%=wc_Asset_Information%></title>

<script language=javascript> window.focus(); window.print();
</SCRIPT>

<!-- #INCLUDE FILE="Stylesheet.inc" -->


</head>

<body class=rightwindow>
<% If cint(Tech_Level) >=  cint(EditTechLevel) and Asset_number <> "NEW" THEN ' show two extra buttons for administrators and above  '02/03/12 %>

<br clear=all>
<%End If ' Do not show button when read/write allowed %>

<center>
<table width=99% border=1>
<td width=50% align=center valign=center>
Asset Number:  <font  color=red><%= Asset_number%></font>
</td>
</tr></table>

<FORM name="myform" action=DoAssetInfo.asp Method = POST>
   <!-- code to support going back to previous search page -->
   <%
   Dim SearchURL
  	if inStr(Request.ServerVariables("HTTP_REFERER"),"DoAssetsBrief.asp") > 1 or inStr(Request.ServerVariables("HTTP_REFERER"),"AssetReport.asp") > 1 then
  	'	response.write "YEP"
  	'	response.flush
  	'	response.end
  		SearchURL = Request.ServerVariables("HTTP_REFERER")
  	Else
  		if inStr(Request.ServerVariables("HTTP_REFERER"),"DoAssetNotes.asp") > 1 or inStr(Request.ServerVariables("HTTP_REFERER"),"DoAssetInfo.asp") > 1 then
  			SearchURL = "Assets.asp"
  			searchURL = request.querystring("FROM")
  		else
  			if request.form("SearchURL") = "" then
  				SearchURL = "Assets.asp"
  			Else
  				SearchURL = request.form("SearchURL")
  			End if
  		End If
	End If
	%>
		<input type=hidden name=hdnSearchURL value="<%=SearchURL%>" >
	<!-- END PREV -->

<% If Asset_Number <> "NEW" Then %>
<input type=hidden name="asset_number" value=<%=Asset_number%>>
<%End IF %>

<table cellspacing=1 cellpadding=3 border=1 width=99%>
<tr>
<td valign=top width=33% align=left> <!-- 3 columns was width=50%  THIS IS START OF COLUMN 1 -->
   <table cellpadding=0 cellspacing=0 width=99%>
			 <tr><td class=PRTInnerformWrapperTight align=center><%=Asset_Information_Label%></td></tr>



			<tr><td class=prttightbodytext><%=Computer_ID_Label%>:  <b><%=computer_id%></b><br>
			<%=Description_Label%>:  <b><%=Equipment_Type%></b><br>
			<%=Property_Tag_Label%>:  <b><%=property_tag%></b><br>
			<%=Serial_Number_Label%>:  <b><%=serial_number%></b>
			</td></tr>


		<!-- ASSET ASSIGNMENTS -->
		

			<tr><td height=2></td></tr>

			<tr><td class=PRTInnerformWrapperTight align=center><%=Asset_Assignments_Label%></td></tr>

			<tr><td class=prttightbodytext><%=wc_Customer%>:  <B><%=Customer_ID%></b><br>
			<%=wc_Tech%>: <b><%=tech_id%></b><br>
			<%=wc_Other_Asset_Number%>:  <b><%=asset_number2%></b>
			
			</td></tr>
			<tr><td height=2></td></tr>

	        <tr><td class=PRTInnerformWrapperTight align=center><%=Asset_Details_Acquisition_Label%></td></tr>
			<td class=prttightbodytext><%=Location_Label%>:  <b><%=location%></b><br>
			<%=Assigned_Group_Label%>:  <b><%=assigned_group%></b><br>
			<%=Date_Assigned_Label%>:  <b><%=date_assigned%></b><br>
			<%=IP_Address_Label%>:  <b><%=ip_address%></b><br>
			<%=Wall_Port_Number_Label%>:  <b><%=wall_port_number%></b><br>
			<%=Lease_Or_Purchase_Label%>:  <b><%=lease_or_purchase%></b><br>
			<%=Purchase_Order_Number_Label%>:  <b><%=purchase_order_num%></b><br>
			<%=Date_acquired_Label%>:  <b><%=date_acquired%></b><br>
			<%=Acquired_From_Label%>:  <b><%=acquired_from%></b><br>
			<%=Date_Put_into_Service_Label%>:  <b><%=date_in_service%></b>
			</td></tr>			
		<!--    SPECIFICATIONS SECTION -->

			<tr><td height=2></td></tr>
            <tr><td class=PRTInnerformWrapperTight align=center><%=Specifications_Label%></td></tr>
			<tr><td class=PRTTightBodyText><%=Processor_Speed_Label%>:  <b><%=processor_speed%></b><br>
			<%=RAM_size_Label%>:  <b><%=ram_size%></b><br>
			<%=Hard_Drive_Size_Label%>:  <b><%=hd_size%></b><br>
			<%=Monitor_model_Label%>:  <b><%=monitor_model%></b><br>
			<%=Monitor_Size_Label%>:  <b><%=monitor_size%></b><br>
			<%=Monitor_Serial_Number_Label%>:  <b><%=monitor_serial_num%></b>
			</td></tr>
			
			<!--    CUSTOM FIELDS SECTION -->
			<tr><td height=2></td></tr>
			<tr><td class=PRTInnerFormWrapperTight align=center><%=Custom_Fields_Label%></td></tr>
			<TR><td class=PRTTightBodyText><%=Custom_Field_1_Label%>:  <b><%=custom_field1%></b><br>
			<%=Custom_Field_2_Label%>:  <b><%=custom_field2%></b><br>
			<%=Custom_Field_3_Label%>:  <b><%=custom_field3%></b><br>
			<%=Custom_Field_4_Label%>:  <b><%=custom_field4%></b><br>
			<%=Custom_Field_5_Label%>:  <b><%=custom_field5%></b>
			</td></tr>
			
			<% ' Re arrange date from yyyymmddhhmmss to a easier format

	If WCDateFormat = "DDMMYYYY" Then
		NewLastUpdatedDateTime = mid(LastUpdate, 7,2) & "/" & mid(LastUpdate, 5,2) & "/" & mid(LastUpdate, 1,4) & " " & mid(LastUpdate, 9,2) & ":" & Mid(LastUpdate, 11,2)
	Else
		NewLastUpdatedDateTime = mid(LastUpdate, 5,2) & "/" & mid(LastUpdate, 7,2) & "/" & mid(LastUpdate, 1,4) & " " & mid(LastUpdate, 9,2) & ":" & Mid(LastUpdate, 11,2)
	End IF

	%>
			<tr><td class=PRTInnerFormWrapperTight align=center>Last Updated</td></tr>
			<tr><td class=PRTTightBodyText>Date:  <b><%=NewLastUpdatedDateTime%></b><br>


<% ' Get the Full name of the tech instead of the tech_id

	TechFullNameString = TechFullName(UpdatedBy)
%>

			Tech: <b><%=TechFullNameString%></b></td></tr>
			</table>


</td>

<!-- -------------------------------------- COLUMN 2 -------------------------------------------------------- -->

						<!-- SOFTWARE SECTION -->
<td valign=top width=33%> <!-- COLUMN 2 -->

      <table cellpadding=0 cellspacing=0 width=99%>
	  		
			<tr><td class=PRTInnerFormWrapperTight align=center ><%=Software_Label%></td></tr>
			<tr><td class=PRTTightBodyText><%=Operating_System_1_Label%>:  <b><%=operating_system1%></b><br>
			<%=Operating_System_2_Label%>:  <b><%=operating_system2%></b>
			</td></tr>

			<% If app1 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_1_Label%>:  <b><%=app1%></b><br>
				<%=App_1_product_ID_Label%>:  <b><%=app1_product_id%></b><br>
				<%=App_1_installation_date_Label%>:  <b><%=app1_install_date%></b>
				</td></tr>

			<% End If %>

			<% If app2 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_2_Label%>:  <b><%=app2%></b><br>
				<%=App_2_product_ID_Label%>:  <b><%=app2_product_id%></b><br>
				<%=App_2_installation_date_Label%>:  <b><%=app2_install_date%></b>
				</td></tr>

			<% End If %>

			<% If app3 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<td class=PRTTightBodyText><%=App_3_Label%>:  <b><%=app3%></b><br>
				<%=App_3_product_ID_Label%>:  <b><%=app3_product_id%></b><br>
				<%=App_3_installation_date_Label%>:  <b><%=app3_install_date%></b>
				</td></tr>

			<% End If %>

			<% If app4 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_4_Label%>:  <b><%=app4%></b><br>
				<%=App_4_product_ID_Label%>:  <b><%=app4_product_id%></b><br>
				<%=App_4_installation_date_Label%>:  <b><%=app4_install_date%></b>
				</td></tr>

			<% End If %>

			<% If app5 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_5_Label%>:  <b><%=app5%></b><br>
				<%=App_5_product_ID_Label%>:  <b><%=app5_product_id%></b><br>
				<%=App_5_installation_date_Label%>:  <b><%=app5_install_date%></b>
				</td></tr>

			<% End If %>

			<% If app6 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_6_Label%>:  <b><%=app6%></b><br>
				<%=App_6_product_ID_Label%>:  <b><%=app6_product_id%></b><br>
				<%=App_6_installation_date_Label%>:  <b><%=app6_install_date%></b>
				</td></tr>

			<% End If %>

			<% If app7 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_7_Label%>:  <b><%=app7%></b><br>
				<%=App_7_product_ID_Label%>:  <b><%=app7_product_id%></b><br>
				<%=App_7_installation_date_Label%>:  <b><%=app7_install_date%></b>
				</td></tr>

			<% End If %>

			<% If app8 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_8_Label%>:  <b><%=app8%></b><br>
				<%=App_8_product_ID_Label%>:  <b><%=app8_product_id%></b><br>
				<%=App_8_installation_date_Label%>:  <b><%=app8_install_date%></b>
				</td></tr>

			<% End If %>
			<% If app9 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_9_Label%>:  <b><%=app9%></b><br>
				<%=App_9_product_ID_Label%>:  <b><%=app9_product_id%></b><br>
				<%=App_9_installation_date_Label%>:  <b><%=app9_install_date%></b>
				</td></tr>

			<% End If %>

			<% If app10 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_10_Label%>:  <b><%=app10%></b><br>
				<%=App_10_product_ID_Label%>:  <b><%=app10_product_id%></b><br>
				<%=App_10_installation_date_Label%>:  <b><%=app10_install_date%></b>
				</td></tr>

			<% End If %>
			<% If app11 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_11_Label%>:  <b><%=app11%></b><br>
				<%=App_11_product_ID_Label%>:  <b><%=app11_product_id%></b><br>
				<%=App_11_installation_date_Label%>:  <b><%=app11_install_date%></b>
				</td></tr>

			<% End If %>
			<% If app12 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_12_Label%>:  <b><%=app12%></b><br>
				<%=App_12_product_ID_Label%>:  <b><%=app12_product_id%></b><br>
				<%=App_12_installation_date_Label%>:  <b><%=app12_install_date%></b>
				</td></tr>

			<% End If %>
			<% If app13 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_13_Label%>:  <b><%=app13%></b><br>
				<%=App_13_product_ID_Label%>:  <b><%=app13_product_id%></b><br>
				<%=App_13_installation_date_Label%>:  <b><%=app13_install_date%></b>

			<% End If %>
			<% If app14 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_14_Label%>:  <%=app14%></b><br>
				<%=App_14_product_ID_Label%>:  <b><%=app14_product_id%></b><br>
				<%=App_14_installation_date_Label%>:  <b><%=app14_install_date%></b>
				</td></tr>

			<% End If %>
			<% If app15 <> "" Then %>

				<tr><td height=2></td></tr><tr><td bgcolor=black height=2></td></tr>
				<tr><td class=PRTTightBodyText><%=App_15_Label%>:  <b><%=app15%></b><br>
				<%=App_15_product_ID_Label%>:  <b><%=app15_product_id%></b><br>
				<%=App_15_installation_date_Label%>:  <b><%=app15_install_date%></b>
				</td></tr></table>

			<% End If %>



	<!-- MOVE THE FOLLOWING LINE TO MOVE WHERE THE 3RD COLUMN STARTS -->
	</table></td></table>
	<P CLASS="pagebreakhere">
	<table border=1 width=99%>
	

<! -- ASSET NOTES SECTION -->
	

		<!--    ASSET NOTES SECTION -->
		<tr><td height=2></td></tr>
			<tr><td class=PRTInnerFormWrapperTight align=center ><%=wc_Asset_Notes%></td></tr>

			<% IF AssetNotes <> "" Then %>

				<tr><td class=PRTTightBodyText WRAP="true"><%=assetnotes%></td></tr>

			<% End If %>
			<%
				if bAssetInspections = True then
					getinspectionhistory(Asset_number)
				End If
				%>

<!-- FILE ATTACH - saved file only -->
</FORM>

</td>
</tr>
</table>
</td>
</tr>
</table>
<p>
<center><!--</form> removed for attaching file-->
</body></html>

<%End If %>

<% Function TechFullName(Tech_ID)
	'This function gets the full name of the Tech or Sales Contact logged
	'into the system.

		If Tech_ID = "" Then
			TechFullName = "Un-assigned"
		Else

			set conntemp=server.createobject("adodb.connection")
			conntemp.open myDSN ' Open the connection once here

			mySQL2="select * from Tech_staff where tech_id = '" & Tech_id & "'"
			set rstemp2=conntemp.execute(mySQL2)

			' Check to see if any records are returned
			' if none found the
			if rstemp2.EOF then
				TechFullName = "User Not Defined for Tech_ID: " & Tech_id
			Else
				TechFullName = rstemp2("first_name") & " " & rstemp2("Last_name")
			End If

			rstemp2.close
			set rstemp2=nothing
			conntemp.Close
			Set conntemp = nothing

		End If


	End Function ' End of TechFullName
	%>


<% Function GetInspectionHistory(Asset_ID)

if asset_ID <> "NEW" then
			set conntemp=server.createobject("adodb.connection")
			conntemp.open myDSN ' Open the connection once here

			mySQL2="SELECT InspectionStatus.InspectionStatus, Inspection.Case_Number, Inspection.Asset_Number, Inspection.InspectionDate, Inspection.InspectionTime, Inspection.Tech_ID, inspectionnotes, tech_staff.first_name+' '+tech_staff.last_name AS FullName "
			mySQL2= mySQL2 & "FROM (Inspection LEFT JOIN InspectionStatus ON Inspection.InspectionStatusIndex = InspectionStatus.InspectionStatusIndex) INNER JOIN tech_staff ON Inspection.Tech_ID = tech_staff.tech_id "
			mySQL2= mySQL2 & "WHERE Inspection.Asset_Number= " & asset_ID
			mySQL= mySQL2 & " ORDER BY InspectionDate DESC, InspectionTime DESC, InspectionIndex DESC " ' 01/05/2012

			set rstemp2=conntemp.execute(mySQL2)
			'response.write "<tr><td>SQL : " & mySQL2 & "</td></tr>" ' TEST

			' Check to see if any records are returned
			'if not rstemp2.eof then

			response.write "<tr><td class=minorformtitle align=center>Inspection History:</td></tr>"

			Do While not rstemp2.EOF
				response.write "<tr><td class=formlabel><font color=green><b>"
				sDate = formatdateTime(rstemp2("InspectionDate"),vbLongDate)
				x=InStrRev(rstemp2("InspectionTime"),":") ' get rid of seconds
				sTime = Left(rstemp2("InspectionTime"),x-1) & " " & Right(rstemp2("InspectionTime"),3) ' get rid of seconds
 				response.write sDate & " " & sTime & "</font></b></br>"

				response.write "<font color=brown><b>Inspection performed by: </b>" & rstemp2("fullname") & "</font></br>"
				response.write "<b>Status: </b>"
				response.write rstemp2("InspectionStatus")
				response.write "</br>"
				response.write "<b>Note: </b>"
				response.write rstemp2("InspectionNotes")
				response.write "</br></br></td></tr>"
			'	response.write "<tr><td class=formlabel>" & rstemp2("inspectiondate") & " " &  rstemp2("inspectiontime") & " " & rstemp2("inspectionstatus") & " " & rstemp2("inspectionnotes") & "</td></tr>"
				rstemp2.MoveNext
			Loop

			rstemp2.close
			set rstemp2=nothing
			conntemp.Close
			Set conntemp = nothing
		End if
	End Function ' End of GetInspectionHistory
	%>

<%' The following subs were for NEW ASSETS %>
<% Function IsDropDown(AssetCategoryName,bInOutRequired) ' CMB 09/13/11
' looks to see whether this is defined as an assetcategory and if so, returned whether required or not;
' otherwise doesn't change value

	Dim bReturn

	bReturn = false

	'This function returns true if this is a category in the AssetCategory table
		If Version7point5 = "YES" then
			set conntemp=server.createobject("adodb.connection")
			conntemp.open myDSN ' Open the connection once here

			mySQL2="Select * from AssetCategories where AssetCategory = '" & AssetCategoryName & "'"

			set rstemp2=conntemp.execute(mySQL2)
			if not rstemp2.eof then
				if rstemp2("IsRequired") = true then
					bInOutRequired = true
				End If
				bReturn = true
			end if

			rstemp2.close
			set rstemp2=nothing
			conntemp.Close
			Set conntemp = nothing
		End If
		IsDropDown = bReturn
	End Function
	%>

<% Sub GetDropDownValues(AssetCategoryName, SelectedValue) ' CMB 09/13/11
' This sub fills a dropdown box with values from the assetCategory Table and sets the selected attribute to either the current or the default
	Dim bFound  ' if the selected value in the list of category items - if not have to add it to dropdown
	If SelectedValue > "" then
		bFound = 0
	else
		bFound = 1
	end if

	'This function gets the values of the drop down plus blank plus selectedvalue
		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN ' Open the connection once here

		mySQL2="Select * from AssetCategoryItems where AssetCategoryID IN (select assetcategoryID from assetcategories where assetcategory = '" & AssetCategoryName & "') order by AssetCategoryItem"
		'response.write "SQL" & selectedvalue
		'response.flush
		'response.end
		set rstemp2=conntemp.execute(mySQL2)
		response.write "<Option value=> </OPTION>"   ' blank

		Do While not rstemp2.eof

				'if this is the default or the selected value, set this to selected
				if selectedvalue > "" then
					if Selectedvalue = rstemp2("AssetCategoryItem") then
						bFound = 1
						response.write "<Option value=""" & rstemp2("AssetCategoryItem") & """ SELECTED>" & rstemp2("AssetCategoryItem") & "</OPTION>"
					else
						response.write "<Option value=""" & rstemp2("AssetCategoryItem") & """>" & rstemp2("AssetCategoryItem") & "</OPTION>"
					End if
				else ' use default
					if (not isnull(rstemp2("IsDefault")) and rstemp2("IsDefault") = 1) then
						response.write "<Option value=""" & rstemp2("AssetCategoryItem") & """ SELECTED>" & rstemp2("AssetCategoryItem") & "</OPTION>"
					else
						response.write "<Option value=""" & rstemp2("AssetCategoryItem") & """>" & rstemp2("AssetCategoryItem") & "</OPTION>"
					end if
				End if
			RsTemp2.MoveNext
		Loop

		if bFound = 0 then
			response.write "<Option value=""" & SelectedValue & """ SELECTED>" & SelectedValue & "</OPTION>"
		End if

		rstemp2.close
		set rstemp2=nothing
		conntemp.Close
		Set conntemp = nothing

	End Sub
	%>

	<%
	Sub DropdownOrText(LabelName,ColName,SelectedValue,nSize,nMax,bRequired)
	'This sub writes a textbox or dropdown to the screen.  If brequired is true, puts an Red asterisk after the label
	' if brequired is fall and it IS a dropdown (IsDropDown) then also puts a red asterisk after the label
		Dim bIsDropDown
		Dim bIsRequired


		If LabelName <> "" Then
			bIsRequired = false
			bIsDropDown = IsDropDown(LabelName,bIsRequired)

			' Put up label
			response.write "<tr><td class=formlabelsuper>" & LabelName & ":"
			if bIsRequired or bRequired then
				response.write "<font color=red>*</font>"
			end if
			response.write "</td></tr>"
			response.write "<tr><td class=formboxholder>"

			If bIsDropDown then
				response.write "<SELECT Name=" & ColName & ">"
				call GetDropDownValues(LabelName,SelectedValue)
				response.write "</SELECT>"
			 else
				response.write "<input type=text name=" & ColName & " size=" & nSize & " maxlength=" & nMax & " value=""" & SelectedValue & """>"
			 end if

			response.write "</td></tr>"

		End If

		End Sub
%>
<%
Function GetCaseCount(nAss)
' This function returns the number of cases associated with a given asset number

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL4="SELECT count(Case_Number) as cnt from cases where Asset_Number = " & nAss
		set rstemp4=conntemp.execute(mySQL4)

		If rstemp4.EOF  Then
			GetCaseCount = 0
		Else
			GetCaseCount = rstemp4("cnt")
		End If

		rstemp4.close
		set rstemp4=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing

End Function
%>