<% 'Module: PrintTCaseForm.asp

   'Description: This module displays the Tech+Center case form'
   ' It is passed either a customer_ID or a case ID
   ' This page is meant to be displayed so it can be printed to a printer.
   '(C) 2000 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '09/14/00	SAV		Created original TCaseForm.asp Page
  	'05/13/01	SAV		Modified for PrintTCaseForm.asp
  	'02/12/22   CMB      Country -> wc_country
  	'11/21/13	SAV		Added Expenses to printTCaseForm.asp

	' CONSTANTS
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->
<!-- #INCLUDE FILE="Stylesheet.inc" -->
<!-- #INCLUDE FILE="../language/codecustomizations.inc" -->



<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->
<% 'First Show the Report Menu at the top of the page
%>

<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 2 ' Allow only levels 2 and above


	CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN") ' Get the Logged TechID from the cookie

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="SELECT * from Tech_staff where Tech_ID = '" & CookieID & "' AND Tech_Level >= " & TechLevel
		set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF <> True Then
			ValidUser = "YES" ' Set this variable to prevent problems on next page
			Tech_Level = rstemp("Tech_Level")
		End If

		rstemp.close
		set rstemp=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing

 ' End of ASP page security checks
 %>


<% if ValidUser <> "YES" Then %>
	<% ASPPage = "PrintTCaseForm.asp"%>

	<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function %>

<% ' Get get the Database information starting with Configuration information %>


<%
	' FIRST Get the values from the configuration file and into variables

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Configuration" ' We will allow up to 10 priority values

	'**** Major problem with SQL*Server and Conntemp.execute when getting
	' configuration data.  One should use: recordset.open DSN connection 1, 3

	' Cursor type needs to be specified and use rstemp.open

	set rstemp = server.createobject("adodb.recordset")
	rstemp.open mySQL, conntemp, 1,3

	If rstemp.EOF = True  Then
		Response.write "No configuration file found"
		assets_db = 0
		ts_user_page_color = "FFFFFF"
	Else

		' Get the values from the configuration File

		TextBoxSizing = rstemp("Text_Box_Sizing")
		CasesummaryRows = rstemp("case_summary_rows")
		CasesummaryMaxRows = rstemp("case_summary_Max_Rows")
		CaseResolutionRows = rstemp("case_resolution_rows")
		CaseResolutionMaxRows = rstemp("Case_resolution_Max_Rows")
		CaseHistoryRows = rstemp("Case_History_Rows")
		CaseTextBoxColumns = rstemp("Case_Text_Box_Columns")
		TimeZoneAdjustment = rstemp("Time_zone_Adjustment")
		TimeZoneLabel = rstemp("Time_zone_Label")
		Language = rstemp("Language")

		ts_user_page_color = "FFFFFF"
		assets_db =  rstemp("assets_db")

		If Instr(Language, "Calendar" ) Then
			DisableWebCenterCalendar = "NO"
		Else
			DisableWebCenterCalendar = "YES"
		End If

		ALLKBUpdate = rstemp("All_KB_Update")
		TimeSpentCategory = rstemp("Time_Spent_Category")
		MinutesPerCategory = rstemp("Time_Spent_Interval")
		WCDateFormat = rstemp("Date_Display_Format")
		ExtendedTimeSpent = rstemp("ExtendedTimeSpent")

		FileUpLoadDestinationPath = rstemp("FileUploadPhysicalPath") ' Set this to your full destination path



		'*** version 7.5
		bExpenses = False
		bAssetInspections = True ' backwards compabitility
		bAdditionalEmails = False ' backwards compabitility

		If AdditionalNotificationEmails = "YES" then ' backwards compabitility
			bAdditionalEmails = True
		End If

		If version7point5="YES" then
			If Not IsNull(rstemp("Expenses")) Then
				bExpenses = rstemp("Expenses")
			End If
			If not IsNull(rstemp("AssetInspections")) Then
				bAssetInspections = rstemp("AssetInspections")
			End If
			If not IsNull(rstemp("AdditionalNotificationEmails")) then
				bAdditionalEmails = rstemp("AdditionalNotificationEmails")
			end if
		End If

		If bAdditionalEmails = True Then ' version7.5
			'Extracts the Primary additional notification email address

			PrimaryAdditionalNotificationEmail = rstemp("PrimaryAdditionalNotificationEmail") '
		End If


		'*** New 8.0 Flags ****
		bDueDateControls = True ' default to 'show'

		if Version8point0="YES" Then
			If Not IsNull(rstemp("AdditionalCustomerCaseAssignments")) Then
				bAdditionalCustomerCaseAssignments = rstemp("AdditionalCustomerCaseAssignments")
			End If
			If Not IsNull(rstemp("DueDateControls")) Then
				bDueDateControls = rstemp("DueDateControls")
			'	response.write "DueDate set to " & bDueDateControls
			'	response.flush
			'	response.end


			End If

			EnableSMS = rstemp("EnableSMS") ' Check if SMS is enabled

		End If

		Customer_ID_List = rstemp("customer_id_list") ' Customer_ID list flag for AdditionalCustomerCaseAssignments

	TechCenterFileUpload = rstemp("TechCenterFileUpload")
	' Boolean determining if file upload is enabled on customer side.

	If TechCenterFileUpload = True then
		'Response.write "TechCenterFileUpload = True"
		AttachFile = "YES"
	End If

	End If

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

	If CInt(assets_db) = 1 then
		AssetEnabled = True
	Else
		AssetEnabled = False
	End If

%>

<%	' Get The Customer_ID and Case_num Fields

	' This form can be called as a link or as FORM submit so
	' we must be able to handle Querystring or form elements

	Customer_ID = Request.QueryString("Customer_ID")
	Case_Number = Request.QueryString("Case_number")

	If Case_Number = "" Then
		Case_Number = Request.form("Case_number")
		Customer_ID = Request.form("Customer_ID")
	End If


	If Case_Number = "0" Then
	' Verify the customer_ID is a valid one before we proceed
	' since we always require a customer to create or update a case

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="select * from Customers where Customer_ID = '" & Customer_ID & "'"

		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			InvalidCustomer = "YES"
		Else
			InvalidCustomer = "NO"
		End If

		rstemp2.close
		set rstemp2=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing

	End If




	If Case_Number = "0" OR Case_number = ""  then
		Case_number = "NEW"
	End If

%>

<% If InvalidCustomer = "YES" Then
		DisplayInvalidCustomerPage()
	Else ' Customer_ID is ok so call the rest of the code

	' Get the Case Information if Case_number <> "NEW"
	If Case_Number <> "NEW" Then

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="select * from Cases where Case_number = " & Case_number

		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Response.write " Case Not Found "
		Else
			' Get all of the fields
			Dup_case_num = rstemp2("Dup_case_num")
			Group_number = rstemp2("Group_number")
			Asset_number = rstemp2("Asset_number")
			customer_Id = rstemp2("Customer_ID")
			tech_ID = rstemp2("tech_id")
			open_date = rstemp2("Open_Date")
			Open_time = rstemp2("Open_Time")
			Reopen_time = rstemp2("Reopen_time")
			mod_date = rstemp2("Mod_date")
			mod_time = rstemp2("Mod_time")
			case_one_line = rstemp2("case_one_line")
			case_history = rstemp2("Case_history")
			case_summary = rstemp2("Case_summary")
			case_resolution = rstemp2("Case_resolution")
			status = CInt(rstemp2("Status"))
			severity = CInt(rstemp2("Severity"))
			modified_flag = rstemp2("modified_flag")

			External_Case_Number = rstemp2("External_Case_number")


			Due_Time = rstemp2("Due_Time")

			Due_Date = rstemp2("Due_Date")

			status = CInt(rstemp2("Status"))

		' Check for any optional text field values

			Field_1_Value = rstemp2("text_field_1")
			Field_2_Value = rstemp2("text_field_2")
			Field_3_Value = rstemp2("text_field_3")
			Field_4_Value = rstemp2("text_field_4")
			Field_5_Value = rstemp2("text_field_5")
			Field_6_Value = rstemp2("text_field_6")
			Field_7_Value = rstemp2("text_field_7")
			Field_8_Value = rstemp2("text_field_8")
			Field_9_Value = rstemp2("text_field_9")
			Field_10_Value = rstemp2("text_field_10")





		End If

		rstemp2.close
		set rstemp2=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing

	' Set the modified_flag if read by the assigned tech

		SetModification_Flag case_number

	End IF ' End if Case_Number <> "NEW"


	' Now Get the customer Information for NEw or existing cases


		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2= " select * from Customers where Customer_ID = '" & Customer_ID & "'"

		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			Response.write " Customer  Not Found "
		Else
			' Get all of the fields
			contact_fname = rstemp2("contact_fname")
			contact_lname = rstemp2("contact_lname")
			company = rstemp2("company")
			address = rstemp2("address")
			mailstop = rstemp2("mailstop")
			city = rstemp2("city")
			state = rstemp2("state")
			zip = rstemp2("Zip")
			country = rstemp2("Country")
			email = rstemp2("Email")
			phone1 = rstemp2("Phone1")
			phone2 = rstemp2("phone2")
			fax = rstemp2("fax")
			contact_method = rstemp2("contact_method")
			contact_times = rstemp2("Contact_times")


		End If

		rstemp2.close
		set rstemp2=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing



%>


<% ' Display the Case Form %>



<html>

<!-- (C) 1996,1998, 1999, 2000-2009 by Internet Software Sciences -->

<head>

<title>Case: <%=Case_Number%> </title>

</head>


<script language=javascript> window.focus(); window.print();
</SCRIPT>



<body>

<p>

<center>





<%'---------------------------------------- customer info %>
<center><table width=98% border=1><tr><td bgcolor=D0D0F0 colspan=2>
<center>

<B>Case:</b>  <%=Case_number%> &nbsp;&nbsp;&nbsp;&nbsp;<%=case_one_line%><br>
</center>
</td></tr>

<tr>
<td bgcolor=FFFFFF>
<font size=-1><B><%=wc_Due_Date%>:</b>
&nbsp;&nbsp;<%=Due_Date%>

</td>

<td bgcolor=FFFFFF>
<font size=-1><B><%=wc_Due_Time%>:</b>
&nbsp;&nbsp;<%=Due_Time%>

</td>


</tr>


</table></center>
<br>

<table border=1 cellspacing=2 cellpadding=3 width=98%>

<tr>

<td valign=top>

<font size=-1>


<b><%=Customer_ID%></b><br>


<b>Name: </b>

<%=contact_fname%>
<% Response.write " " %>

<%=contact_lname%>
<br>


<b>Company: </b>
<%=Company %>

<br>


<b>Street: </b>
<%=Address%>

<br>


<b>Mailstop: </b>
<%=MailStop %>

<br>


<b>City/St/Zip: </b>

<%=city %>, <%=State %> <%=Zip %>



<br>


<b><%=wc_Country%>: </b>
<%=Country %>


<br>


</font></td>

<td valign=top>

<font size=-1>


<b>Email: </b>

<%=Email %>

<br>


<b>Phone1: </b>

<%=Phone1 %>

<br>


<b>Phone2: </b>
<%=Phone2 %>

<br>


<b>Fax: </b>
<%=Fax %>

<br>


<b>Contact by:</b>
<%=Contact_Method%>
<br>



<b>Notes: </b>
<%=Contact_times %>

<br>


</font></td>

<td valign=top>

<%'---------------------------------------- case number %>



<br>
<center>
  <font size=+2 color=red>
  <% ' Put Extra Zeros infront of short case numbers
  		ExtraZeros = 4 - Len(Case_number)
		If ExtraZeros = 1 Then
			Response.write "0"
		Elseif ExtraZeros = 2 Then
			Response.write "00"
		Elseif ExtraZeros = 3 Then
			Response.write "000"
		Else
			' Only display up to 3 extra zeros
		End IF
 %>

  <%=Case_number%>
  </font></center>
  <br>


<center>
   <font size=-1>


	<% IF AssetEnabled = False Then
		response.write "<P>" ' Centering for case number text
		End If
	%>

 <% ' Display link to duplicate case if  duplicate case number is present. %>


	<% If CLng(Dup_Case_Num) = 0 Then %>

      <b>Duplicate Case:</b> &nbsp;&nbsp;&nbsp;None<br>

   <%Else %>

	<b>Duplicate Case:</b> &nbsp;&nbsp;&nbsp;
    <%=DUp_Case_num%> <br>

	<% End IF ' End of Duplicate Case Number  = ""
	%>


   <% if AssetEnabled = True then
	' Display link to asset form if asset
	' number is present.
      if Not IsNull(asset_number) Then
	If CLng(asset_number) > 0 Then
	 %>

             <b>Asset Number:</b>&nbsp;&nbsp;&nbsp;
			 <%=Asset_Number%><br>

    <%Else %>

         <br><b>Asset Number:</b>&nbsp;&nbsp;&nbsp;None<br>


     <%End If  ' End of If asset_number > 0  %>
    <%Else %>

         <br><b>Asset Number:</b><br>


     <%End If  ' End of If not null asset_number > 0  %>


   <%else ' If Assetenabled = true Else statement %>

  <%End If %>

</center>

</td>

</tr>

</table>


<% ' Display the asset information is an asset is assigned

	If Asset_number <> "" And Asset_Number <> 0 Then
		DisplayAssetInfo(Asset_Number)
	End If
%>

<%'---------------------------------------- one line description %>

<br>
<table border=1 cellspacing=3 cellpadding=4 width=98%>

<tr>

<td bgcolor=F0B0E0><font size=-1>

<% ' Put these special hidden fields to be compatible with the Techsupp.dll?DoCaseform() %>
<b>One Line Description:</b> &nbsp;&nbsp;&nbsp;<%=case_one_line%><br>



</td>

<td width=20% bgcolor=FFFFFF><font size=-1>
<B><%=wc_Reference%>:</b>

<%=External_Case_Number%>

</td>
</tr>

<%'---------------------------------------- case history field %>


<tr>

<td colspan=2><font size=-1>

<b>Case History:</b><br>

                <% ' Display history log. %>
	<% If Case_number <> "NEW"  AND case_history <> "" Then
			New_History = Format_Case_Text(Case_History)
			Response.write New_History 'New_History
		End If
	%>

</td>

</tr>




<tr>




</tr>

<%'---------------------------------------- summary %>


<tr>

<td><font size=-1>



<b>Case Summary:</b><br>
<%

	If Case_Summary <> "" Then
		New_Summary = Format_Case_Text(Case_Summary)
	Else
		New_Summary = ""
	End If

%>
<%=New_summary %><P>



</td>


</tr>

<%'---------------------------------------- resolution %>


<tr>

<td colspan=2><font size=-1>

<b>Case Resolution:</b><br>
<%

	If Case_Resolution <> "" Then
		New_Resolution = Format_Case_Text(Case_Resolution)
	Else
		New_Resolution = Case_Resolution
	End If
%>


<%=New_resolution %>

</td>

</tr>

<%'---------------- category assignment (case form) %>


	<tr>
	<TD VALIGN=CENTER COLSPAN="2">
	<TABLE BORDER=0 CELLPADDING=2 WIDTH="99%" >
	<TR>
	<% ' Display the  Categories

	If case_Number <> "NEW" Then 'exist case so open up case record
		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL="select * from Cases where case_number = " & case_Number

		set rstemp=conntemp.execute(mySQL)


		' Do Not close the recordset or connection yet since we will
		' need it for displaying the categories
	End If



		If Case_Number = "NEW" Then ' Open connection if new case

			set conntemp=server.createobject("adodb.connection")
			conntemp.open myDSN
		End If

		' For techs, display categories that are not disabled.

		mySQL2="select * from Categories where  State <> 0  Order by Category_index ASC"

		'set rstemp2=conntemp.execute(mySQL2)
		set rstemp2 = Server.CreateObject("ADODB.Recordset")

		If DatabaseType <> "ACCESS97" THEN
			rstemp2.CursorLocation = adUseClient
		End If

		rstemp2.Open mySQL2, conntemp,adOpenDynamic,adLockReadOnly

		' Check to see if any records are returned
		' if none found then login fails.

		If  rstemp2.eof then ' Check to see any Categories exist
			' No categories exist so don't display anything here
		Else %>

	<%

			Category_name = rstemp2("Category_name")
			Category_number = CInt(rstemp2("Category_number"))
	%>
			<TD WIDTH="50%"><font size=-1>

	<%
					response.write "<B>" & Category_name & ":</b><br>"

			Do While Not rstemp2.EOF
				if CInt(rstemp2("Category_number")) <> Category_number THEN
					response.write "</td>"

					' Decide if we need to close this inner table row
					' So we have two columns of drop down lists

					CatNum = CatNum + 1
					If CatNum = 2 Then
						response.write "</tr><tr>"
						Catnum = 0
					End IF
					%>
					<td width=50%><font size=-1>

					<%
						Response.write "<B>" & rstemp2("Category_Name") & "</b><br>" & vbCRLF
					Category_number = CInt(rstemp2("Category_number"))
				End If

				' Checked if this option is already select for this case
				If Case_Number <> "NEW" Then
					If IsNull(rstemp2("item_number")) Then
						ItmNumber = 0
					Else
						ItmNumber = rstemp2("item_number")
					End If
					If IsNull(rstemp("C" & CInt(Category_number))) Then
						CatGNumber = 0
					Else
						CatGNumber = rstemp("C" & CInt(Category_number))
					End If
					If CInt(CatGNumber) = CInt(ItmNumber) Then
						response.write rstemp2("item_name")  & chr(10) & chr(13)
					Else
						'response.write "<option value=" & rstemp2("item_number") & ">" & rstemp2("item_name") & "</option>" & chr(10) & chr(13)
					End IF
				End If '  End of case_number <> ""

				If Case_Number = "NEW" Then
					response.write "<option value=" & rstemp2("item_number") & ">" & rstemp2("item_name") & "</option>" & chr(10) & chr(13)
				End If


				rstemp2.MoveNext
			Loop
			response.write "</select></td></tr></table>"
		End IF

		rstemp2.close
		set rstemp2=nothing

		' If Not new case then close the other record set
		If Case_Number <> "NEW" Then
			rstemp.close ' close the original record set
			set rstemp=nothing
		End IF


		conntemp.close ' Close the connection
		set conntemp=nothing

	%>

	</td></tr>


<% ' --------------- Group and Case Status/Assigned Staff Member and Priority %>

<TR>
<TD ALIGN=CENTER colspan=2>
<TABLE BORDER=0 CELLPADDING=2 WIDTH="98%" >
<TR>
<TD><B><FONT SIZE=-1>Assigned group:&nbsp;</FONT></B>
<font size=-1>
<BR>

<% ' Get the Groups from the database

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Group_list Order by Group_Name"
	set rstemp=conntemp.execute(mySQL)

	' Check to see if any records are returned
	' if none found then login fails.

	If  rstemp.eof then ' Check to see any Groups exist

	Else
		Do While rstemp.EOF <> True
			If CInt(rstemp("Group_Number")) = CInt(Group_number) Then
				response.write rstemp("group_name") & chr(10) & chr(13)
			Else

			End IF

			rstemp.MoveNext

		Loop

		response.write "</select>"
	End IF

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

 ' End of Display the Group List
 %>

</TD>

<TD><B><FONT SIZE=-1>Status:&nbsp;</FONT></B>

<% ' Hard coded status's are:
	' 0 = default = Open (Active)
	' 1 = Closed
	' 2 = Open (Waiting)
	' 3 = Open (On-Hold)
%>


<FONT SIZE=-1><BR>

<% IF Status = 0 then %>
	Open (Active)
<%End If %>

<% If Status = 1 Then %>
Closed
<%End If %>

<% If Status = 2 Then %>
Open (Waiting)
<%End If %>

<% If Status = 3 Then %>
Open (On Hold)
<%End If %>

</TD>

</tr>
<tr>




<TD><B><FONT SIZE=-1>Assigned staff member:&nbsp;</FONT></B>
<font size=-1><BR>

<% ' Display the List of Techs

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Tech_staff Order by Last_Name"
	set rstemp=conntemp.execute(mySQL)

	' Check to see if any records are returned
	' if none found then login fails.

	If  rstemp.eof then ' Check to see any Groups exist

	Else
		Do While rstemp.EOF <> True

		' Get the first group associated with this tech if it is exists
		' and display it as the display part of the drop down item.

		' * * * * * * * User customization * * * * * * * * * *
		' If you do not want groups to be display with tech then
		' comment out the next 12 or so lines of code

		mySQL3="SELECT Group_list.group_name, Groups.tech_id FROM Group_list INNER JOIN Groups ON Group_list.group_number = Groups.group_number "
		mySQL3 = mySQL3 & " where tech_id = '" & rstemp("Tech_ID") & "'"
		set rstemp3=conntemp.execute(mySQL3)

		If rstemp3.EOF <> True Then
			GroupName = " ("& rstemp3("Group_name") & ")" ' Grab only the first one
		Else
			GroupName = "" ' Clear group name
		End IF

		rstemp3.close ' close the record set
		set rstemp3=nothing
		' * * * * * * * * End User Customizations * * * * * * * * * * * * *


			IF Tech_Id = rstemp("Tech_id") Then
				response.write  rstemp("Last_Name") & "," & rstemp("first_Name")  & GroupName & "</option>" & chr(10) & chr(13)
			End If

			rstemp.MoveNext

		Loop

		response.write "</td>"
	End IF

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

%>

<TD><B><FONT SIZE=-1>Priority:&nbsp;</FONT></B>
<font size=-1>
<BR>


<% ' Display the List of Priorities

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Priority order by Priorityid"
	set rstemp=conntemp.execute(mySQL)

	' Check to see if any records are returned
	' if none found then login fails.

	If  rstemp.eof then ' Check to see any priorities exist

	Else
		Do While rstemp.EOF <> True
		  '  if CInt(rstemp("PriorityID")) > 0 then
				If Severity = Cint(rstemp("PriorityID")) Then
					response.write  rstemp("ShortDesc") & chr(10) & chr(13)
				End If
		'	end if
			rstemp.MoveNext
		Loop
		response.write "</select></td>"
	End IF

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing
%>




</TR>
</table>

</td></tr>

</table>


	<% '******* DISPLAY THE OPTIONAL CASE FORM TEXT BOXES ***************************%>

	<% ' Get the values if they exist

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Case_Text_Field_Labels" ' There should be no rows or only 1

	set rstemp=conntemp.execute(mySQL)

	If rstemp.EOF <> True then
		Field_1_Label = rstemp("Field_1_Label")
		Field_2_Label = rstemp("Field_2_Label")
		Field_3_Label = rstemp("Field_3_Label")
		Field_4_Label = rstemp("Field_4_Label")
		Field_5_Label = rstemp("Field_5_Label")
		Field_6_Label = rstemp("Field_6_Label")
		Field_7_Label = rstemp("Field_7_Label")
		Field_8_Label = rstemp("Field_8_Label")
		Field_9_Label = rstemp("Field_9_Label")
		Field_10_Label = rstemp("Field_10_Label")

		Field_1_State = rstemp("Field_1_State")
		Field_2_State = rstemp("Field_2_State")
		Field_3_State = rstemp("Field_3_State")
		Field_4_State = rstemp("Field_4_State")
		Field_5_State = rstemp("Field_5_State")
		Field_6_State = rstemp("Field_6_State")
		Field_7_State = rstemp("Field_7_State")
		Field_8_State = rstemp("Field_8_State")
		Field_9_State = rstemp("Field_9_State")
		Field_10_State = rstemp("Field_10_State")

	End If


	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

	' Now determine if any of the case text fields are enabled for ALL view(2) or tech view (1)
	' or determine if any of the fields are greater than 0

	If Field_1_State > 0  OR Field_2_State > 0 OR  Field_3_State > 0 OR  Field_4_State > 0 OR  Field_5_State > 0 OR  Field_6_State > 0 OR  Field_7_State  > 0 OR  Field_8_State > 0 OR  Field_9_State > 0 OR  Field_10_State > 0  THEN
	' At least one field is enabled for ALL view (customer and techs) so open up table cell for it

%>

<br>
	<table border=1 width=98% >

	<tr>
	<td align=center  bgcolor="F0E0C0" WIDTH="98%" colspan=2>

	<% ' Start new Table for Optional text fields %>

	<table cellspacing=2 cellpadding=2 WIDTH="98%" >
	<tr>

	<td align=left colspan=2 bgcolor=F0E0C0><font size=-1>
	<B>
	<%=wc_Optional_Information_Fields%>:
	</b>
	</td>
	</tr>


	<% If Field_1_State > 0  Then %>

	<tr><td align=right bgcolor=F0E0C0 width="50%" ><font size=-1>
	<B><%=Field_1_Label%>: &nbsp;&nbsp;
	</b>
	</td>
	<td align=left bgcolor=F0E0C0>
	<font size=-1>
<%=Field_1_Value%>
	</td>
	</tr>

	<% End If %>

	<% If Field_2_State > 0  Then %>

	<tr><td align=right bgcolor=F0E0C0 width="50%"  ><font size=-1 >
	<B><%=Field_2_Label%>: &nbsp;&nbsp;
	</b>
	</td>
	<td align=left bgcolor=F0E0C0>
	<font size=-1>
	<%=Field_2_Value%>
	</td>
	</tr>

	<% End If %>

	<% If Field_3_State >  0 Then %>

	<tr><td align=right bgcolor=F0E0C0 width="50%"  ><font size=-1>
	<B><%=Field_3_Label%>: &nbsp;&nbsp;
	</b>
	</td>
	<td align=left bgcolor=F0E0C0>
	<font size=-1>
<%=Field_3_Value%>
	</td>
	</tr>

	<% End If %>

	<% If Field_4_State > 0 Then %>

	<tr><td align=right bgcolor=F0E0C0 width="50%"  ><font size=-1 >
	<B><%=Field_4_Label%>: &nbsp;&nbsp;
	</b>
	</td>
	<td align=left bgcolor=F0E0C0>
	<font size=-1>
<%=Field_4_Value%>
	</td>
	</tr>

	<% End If %>

	<% If Field_5_State > 0 Then %>

	<tr><td align=right bgcolor=F0E0C0 width="50%"  ><font size=-1 >
	<B><%=Field_5_Label%>: &nbsp;&nbsp;
	</b>
	</td>
	<td align=left bgcolor=F0E0C0>
	<font size=-1>
<%=Field_5_Value%>
	</td>
	</tr>

	<% End If %>

	<% If Field_6_State > 0 Then %>

	<tr><td align=right bgcolor=F0E0C0 width="50%"  ><font size=-1>
	<B><%=Field_6_Label%>: &nbsp;&nbsp;
	</b>
	</td>
	<td align=left bgcolor=F0E0C0>
	<font size=-1>
<%=Field_6_Value%>
	</td>
	</tr>

	<% End If %>

	<% If Field_7_State > 0 Then %>

	<tr><td align=right bgcolor=F0E0C0 width="50%"  ><font size=-1 >
	<B><%=Field_7_Label%>: &nbsp;&nbsp;
	</b>
	</td>
	<td align=left bgcolor=F0E0C0>
	<font size=-1>
<%=Field_7_Value%>
	</td>
	</tr>

	<% End If %>

	<% If Field_8_State > 0 Then %>

	<tr><td align=right bgcolor=F0E0C0 width="50%"  ><font size=-1 >
	<B><%=Field_8_Label%>: &nbsp;&nbsp;
	</b>
	</td>
	<td align=left bgcolor=F0E0C0>
	<font size=-1>
<%=Field_8_Value%>
	</td>
	</tr>

	<% End If %>

	<% If Field_9_State > 0 Then %>

	<tr><td align=right bgcolor=F0E0C0 width="50%"  ><font size=-1 >
	<B><%=Field_9_Label%>: &nbsp;&nbsp;
	</b>
	</td>
	<td align=left bgcolor=F0E0C0>
	<font size=-1>
<%=Field_9_Value%>
	</td>
	</tr>

	<% End If %>

	<% If Field_10_State > 0 Then %>

	<tr><td align=right bgcolor=F0E0C0 width="50%"  ><font size=-1>
	<B><%=Field_10_Label%>: &nbsp;&nbsp;
	</b>
	</td>
	<td align=left bgcolor=F0E0C0>
	<font size=-1>
<%=Field_10_Value%>
	</td>
	</tr>



	<% End If %>


</table>


	<%End If ' If no Case Text fields are enabled for customer view %>

</td>
</tr>
</table>

	<% '******* END OF DISPLAY THE OPTIONAL CASE FORM TEXT BOXES ***************************%>


<% 'Display the extended time Spent Entries for this case %>

<% ' Time Spent Billing Option ***********%>

    <% If ExtendedTimeSpent = True or  ExtendedTimeSpent = Null or ExtendedTimeSpent = 1 Then
			TimeSpentBilling = "YES"
		End If

	%>

<% If TimeSpentBilling = "YES" Then  ' Only display this option if enabled %>

<br>

<table width=98%  bgcolor=B0B0B0>

<% Spacerheight = 2 %>


<%
  spacerline2 = "<tr><td><table cellspacing=0 cellpadding=0 width=100% ><tr><td height=" & spacerheight & "> </td></tr></table></td></tr>"
%>


<% ' following nested table is necessary to get consistent vertical line-up of left-hand-edge %>


	<tr><td  height=<%=spacerheight%> colspan=2></td></tr>


<tr>
   <td colspan=2 align=center>
     <table width=98% cellpadding=0 cellspacing=0 border=0>
       <tr>
         <td align=center class=MinorFormTitle><%=wc_Time_Spent_Billing%></td>
       </tr>
      </table>
   </td>
</tr>

<%
 response.write spacerline
%>

<tr>

<td colspan=2>
<table class=FormTable width=98% cellpadding=1 cellspacing=1>
<tr>
<td class=formlabelsuper align=center>
<%=wc_Date %>
</td>


<td class=formlabelsuper align=center>
<%=wc_Tech %>
</td>

<td class=formlabelsuper align=center>
<%=wc_Billable %>
</td>

<td class=formlabelsuper align=center>

<%=wc_Hours %>
</td>

<td class=formlabelsuper align=center>
<%=wc_Hourly_Rate %>
</td>

<td class=formlabelsuper align=center>
<%=wc_Notes %>
</td>

</tr>

<% ' Now display any billing records for this case number if they exist %>

	<% ' Get the values if they exist

	TotalBillableHours = 0
	TotalBillableAmount = 0

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN


	If Case_Number <> "NEW" Then

		mySQL="SELECT Tech_staff.tech_id, Tech_staff.first_name, Tech_staff.last_name, TimeSpent.Invoice_Date, TimeSpent.Tech_ID, TimeSpent.Billable, TimeSpentIndex, TimeSpent.Hours, TimeSpent.HourlyRate , TimeSpent.TimeSpentNote FROM Tech_staff INNER JOIN TimeSpent ON Tech_staff.tech_id = TimeSpent.Tech_ID  WHERE Case_Number = " & Case_Number
	Else
		mySQL="SELECT Tech_staff.tech_id, Tech_staff.first_name, Tech_staff.last_name, TimeSpent.Invoice_Date, TimeSpent.Tech_ID, TimeSpent.Billable, TimeSpentIndex, TimeSpent.Hours, TimeSpent.HourlyRate , TimeSpent.TimeSpentNote FROM Tech_staff INNER JOIN TimeSpent ON Tech_staff.tech_id = TimeSpent.Tech_ID  WHERE Case_Number = 999999"

	End If

'	response.write "SQL= " & mySQL
'    response.flush
	set rstemp = server.createobject("adodb.recordset")
	rstemp.open mySQL, conntemp, 1,3


	If  rstemp.eof then ' Check to see any time spent values exist for this case number

	Else
		Do While rstemp.EOF <> True

%>

<tr>

<td class=formlisting>

<%=rstemp("Invoice_Date") %>

</td>



<td class=formlisting>
<%=rstemp("last_name") %>, &nbsp; <%=rstemp("first_name") %>


</td>

<td class=formlisting>

<% If rstemp("Billable") = True Then
	Response.write wc_YES
  Else
	Response.write wc_NO
End If
%>
</td>

<td class=formlisting>
<%=rstemp("Hours") %>


</td>

<td class=formlisting>
<%=rstemp("HourlyRate") %>


</td>

<td class=formlisting>
<%=rstemp("TimeSpentNote") %><br>

</td>





</tr>


<%

	' Calculate Total Billable Hours

	If rstemp("Billable") = True Then
		TotalBillableHours = TotalBillableHours + rstemp("Hours")
		'-- fix this -- TotalBillableAMount = rstemp("Hours") * rstemp("HourlyRate") + TotalBillableAmount
		' We need to round to 2 dec places in case this calculation generates more e.g. 5.25 * 5.25 = 27.5625

		' we also need to guard against these fields being empty

		 HoldHourlyRate = rstemp("HourlyRate")
		 If isNull(HoldHourlyRate) Then
		   HoldHourlyRate = 0
		 End If

		 HoldHours = rstemp("Hours")
		 If isNull(HoldHours) Then
		   HoldHours = 0
		 End If

		tempholder = HoldHours * HoldHourlyRate
		tempholder = Round(tempholder,2)
		TotalBillableAmount = TotalBillableAmount + tempholder

	End IF

	TotalHours = TotalHours + rstemp("Hours") ' Always in hours independently of billable.

			rstemp.MoveNext
		Loop

	End IF

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

%>

<% ' Now display the summary information for time spent %>

<tr>
<td colspan=3 class=formlisting align=center>



<b><%=wc_Billable_Total%>:</b> &nbsp; <%=TotalBillableHours%> &nbsp; <%=wc_Hrs%>
/ &nbsp; <%=wc_Time_Spent_Currency%> <%=TotalBillableAmount %>

</td>

<td colspan=4 class=formlisting align=center>



<b><%=wc_Total_Hours%>:</b> &nbsp; <%=TotalHours%> &nbsp; <%=wc_HRS%>

</td>

</tr>

</table>


	<% If bExpenses=True Then %>

		<% DisplayExpenses  Case_Number %>

	<% End If %>







</tr>
</td>
</table>


<%End If ' End of if ExtendedTimeSpent enabled %>



</form>
</body>
</html>


<% End If ' End of Customer_Invalid = NO %>


<%End If ' End of security checks %>

<%
Function Format_Case_Text(Case_Text)

' This subroutines formats the case_text with the proper color coding conventions

NewText = Case_Text
	' Tags entered by the user can be security issue so we will replace
	' them with printable html text of &lt; and & gt;

	' We need to replace double tag characters to double brackets so we can
	' convert them back to real tags

		NewText = Replace (NewText, "<<", "[[")
		NewText = Replace (NewText, ">>", "]]")

		' Now replace regular tags with &gt; and & lt;

		NewText = Replace (NewText, "<", "&lt;")
		NewText = Replace (NewText, ">", "&gt;")


		' Now replace back the other double tags back to regular tags

		NewText = Replace (NewText, "[[", "<")
		NewText = Replace (NewText, "]]", ">")

		' Replace the special color coding characters

		NewText = Replace (NewText, "{g[", "<font color=#008000>")

		NewText = Replace (NewText, "{g[", "<font color=#008000>")

		NewText = Replace (NewText, "{r[", "<font color=#FF0000>")

		NewText = Replace (NewText, "]r}", "</font>")

		NewText = Replace (NewText, "]g}", "</font>")


'	NewText = replace(NewText, chr(13)&chr(10), "<br>")



'	NewText = replace(NewText, chr(13), "<br>")
	NewText = replace(NewText, chr(10), "<br>")
'	NewText = replace(NewText, chr(10)&chr13, "<br>")


	Format_Case_Text = NewText

End function
%>



<% Sub GetDatabaseConfiguration(ts_user_page_color, Assets_db)
	'This function gets the database configuration information
	' including the max size of the history field and
	' the email message appendages

		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		mySQL2="select * from Configuration"
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			ts_user_page_color = "FFFFFF"
			Assets_db = 0
		Else
			ts_user_page_color = rstemp2("ts_user_page_color")
			Assets_db = rstemp2("Assets_db")
		End If

		rstemp2.close
		set rstemp2=nothing


		conntemp.close ' Close the connection
		set conntemp=nothing

	End Sub ' End of GetdatabaseConfiguration
	%>

<% Sub DisplayPriorityFromTable(CurrentPriority)
	' This sub display the priority drop down option for the case
	' case form from the prioirty table and not hard coded.
	' It is passed the current value so we know which
	' option to mark as "SELECTED"


		set conntemp=server.createobject("adodb.connection")

		conntemp.open myDSN ' Open the connection once here

		mySQL2="select * from Priority"
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
		' Display a default sets of priority

		Else
			Response.write "<SELECT size=1 name=case_severity>"
			Do While Rstemp2.EOF <> True

				If CurrentPriority = rstemp2("PriorityID") Then
					Reponse.write "<option value=" & rstemp2("PriorityID") & " SELECTED>" & rstemp2("Shortdesc") & "</option>"
				Else
					Reponse.write "<option value=" & rstemp2("PriorityID") & ">" & rstemp2("Shortdesc") & "</option>"

				End If
				rstemp2.movenext
			loop
		End IF

		rstemp2.close
		set rstemp2=nothing


		conntemp.close ' Close the connection
		set conntemp=nothing

	End Sub ' End of DisplayPriorityFromTable
	%>


<% Sub SetModification_Flag(case_number)
	' This function will check to see if the tech viewing this case has been assigned
	' to this case.  If they are assigned to this case ,
	' then the case "Modification_flag" will be cleared
	' so it won't appear red in their open cases display.  Any updates by the customer or
	' other techs will reset the modification_flag  back to 1.

		Set Conn = Server.CreateObject("ADODB.Connection")
		conn.open  myDSN



			Set NewRecord = Server.CreateObject("ADODB.Recordset")

					SQL = "Select * from Cases where case_number = " & case_number

			'response.write SQL

			NewRecord.Open SQL,Conn,3,3

			If NewRecord.EOF = True Then
				' This should not occur
			Else ' Update Case Info when case already exists

				LoginTech_ID = Request.Cookies ("ISS_TECH_CENTER_LOGIN")

				' Only Clear the modified flag if the assigned tech is viewing this case

				If LoginTech_ID = NewRecord("Tech_ID") Then ' Clear Modified_flag
					NewRecord("modified_flag") = 0
					NewRecord.Update
					If  err.number>0 then
						  response.write "VBScript Errors Occured:" & "<P>"
						  response.write "Error Number=" & err.number & "<P>"
						  response.write "Error Descr.=" & err.description & "<P>"
						  response.write "Help Context=" & err.helpcontext & "<P>"
						  response.write "Help Path=" & err.helppath & "<P>"
						  response.write "Native Error=" & err.nativeerror & "<P>"
						  response.write "Source=" & err.source & "<P>"
						  response.write "SQLState=" & err.sqlstate & "<P>"
					else
					'      response.write "No VBScript Errors Occured" & "<P>"
					end if
					IF  conn.errors.count> 0 then
						  response.write "Database Errors Occured" & "<P>"
					for counter= 0 to conn.errors.count
						  response.write "Error #" & conn.errors(counter).number & "<P>"
						  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
					next
					else
					'      response.write "No Database Errors Occured!" & "<P>"
					end if

					End IF

			End If ' End if Add Record or Update

		' Close recordset and connections

		NewRecord.Close
		Set NewRecord = Nothing

		Conn.Close
		Set Conn = Nothing

 End Sub 'SetModificationFlag
%>

<% Sub DisplayInvalidCustomerPage()
	' This function simply display a warning page that the entered
	'or passed customerID is not valid with a back button and
	' and a cancel button
%>
<html>
<!-- (C) 1996,1998 by Internet Software Sciences -->
<head><title>Case Form Error Page</title>
</head>
<body bgcolor=#D8D8D8>
<center>
<table border=1 cellspacing=2 cellpadding=10 width=98%>
<tr>
<td align=center><font size=+1>
<b>New Case Error</b>
</font>
<br>
<font size=+1 color=blue>
<b>
</b>
</font>
</td>
</tr>
</table>
<p>
<table border=1 cellspacing=2 cellpadding=10 width=98%>
<tr>
<td>
<center>
<b>No Matching Customer Record Found</b><P>
Please try again or use the
<a href=GetCustomer.asp> Customer Search Form </a>
to find<br> a customer and open a new case.


</center>
</td></tr>
</table><center>
<p><table border=0 cellspacing=1 cellpadding=1 width=50%>
<tr><td align=center>
<a href="javascript:history.back();" alt="Back Button">
<img src=/<%=WCLanguageDirectory%>/ts_search_again30x120.gif border=0></a>
</td>
<td align=center>
<a href=UserScreen.asp>
<img src=/<%=WCLanguageDirectory%>/ts_cancel30x80.gif border=0></a>
</td>
</tr>
</table>
<p>
</body>
</html>

<%End Sub %>


<%
Sub DisplayAssetInfo(Asset_number)

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="select * from Assets where asset_number =" & Asset_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			response.write " Invalid Asset_number:" & Asset_number
		Else

			computer_id = rstemp2("Computer_id")
			property_tag = rstemp2("Property_tag")
			Equipment_type = rstemp2("equipment_type")
			lease_or_purchase = rstemp2("lease_or_purchase")
			purchase_order_num = rstemp2("purchase_order_num")

			serial_number = rstemp2("serial_number")

			' Acquisition
			acquired_from = rstemp2("acquired_from")
			date_acquired = rstemp2("date_acquired")
			date_in_service = rstemp2("date_in_service")

			' Specifications

			Processor_speed = rstemp2("processor_speed")
			ram_size = rstemp2("ram_size")
			hd_size = rstemp2("hd_size")
			monitor_model = rstemp2("monitor_model")
			monitor_size = rstemp2("monitor_size")
			Monitor_serial_num = rstemp2("Monitor_serial_num")

			'assignments

			assigned_group = rstemp2("assigned_group")
			location = rstemp2("location")
			date_assigned = rstemp2("date_assigned")
			ip_address = rstemp2("ip_address")
			wall_port_number =rstemp2("wall_port_number")

			' Applications
			operating_system1 = rstemp2("operating_system1")
			operating_system2 = rstemp2("operating_system2")

			app1 = rstemp2("app1")
			app1_product_id = rstemp2("app1_product_id")
			app1_install_date = rstemp2("app1_install_date")

			app2 = rstemp2("app2")
			app2_product_id = rstemp2("app2_product_id")
			app2_install_date = rstemp2("app2_install_date")

			app3 = rstemp2("app3")
			app3_product_id = rstemp2("app3_product_id")
			app3_install_date = rstemp2("app3_install_date")

			app4 = rstemp2("app4")
			app4_product_id = rstemp2("app4_product_id")
			app4_install_date = rstemp2("app4_install_date")

			app5 = rstemp2("app5")
			app5_product_id = rstemp2("app5_product_id")
			app5_install_date = rstemp2("app5_install_date")

			app6 = rstemp2("app6")
			app6_product_id = rstemp2("app6_product_id")
			app6_install_date = rstemp2("app6_install_date")

			app7 = rstemp2("app7")
			app7_product_id = rstemp2("app7_product_id")
			app7_install_date = rstemp2("app7_install_date")

			app8 = rstemp2("app8")
			app8_product_id = rstemp2("app8_product_id")
			app8_install_date = rstemp2("app8_install_date")

			app9 = rstemp2("app9")
			app9_product_id = rstemp2("app9_product_id")
			app9_install_date = rstemp2("app9_install_date")

			app10 = rstemp2("app10")
			app10_product_id = rstemp2("app10_product_id")
			app10_install_date = rstemp2("app10_install_date")

			app11 = rstemp2("app11")
			app11_product_id = rstemp2("app11_product_id")
			app11_install_date = rstemp2("app11_install_date")

			app12 = rstemp2("app12")
			app12_product_id = rstemp2("app12_product_id")
			app12_install_date = rstemp2("app12_install_date")

			app13 = rstemp2("app13")
			app13_product_id = rstemp2("app13_product_id")
			app13_install_date = rstemp2("app13_install_date")

			app14 = rstemp2("app14")
			app14_product_id = rstemp2("app14_product_id")
			app14_install_date = rstemp2("app14_install_date")

			app15 = rstemp2("app15")
			app15_product_id = rstemp2("app15_product_id")
			app15_install_date = rstemp2("app15_install_date")

			' Get the custom fields 1-5
			custom_field1 = rstemp2("custom_field1")
			custom_field2 = rstemp2("custom_field2")
			custom_field3 = rstemp2("custom_field3")
			custom_field4 = rstemp2("custom_field4")
			custom_field5 = rstemp2("custom_field5")

			' Get the asset_notes

			'AssetNotes = rstemp2("assetnotes")

		End If ' End if If EOF <> True


	rstemp2.close
	set rstemp2=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing



	' Get AssetNotes separately since there appears to be a problem
	' accessing this memo field under SQL*Server with the Select * statement.


		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="select assetnotes  from Assets where asset_number =" & Asset_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			response.write " Invalid Asset_number:" & Asset_number
		Else

			AssetNotes = rstemp2("assetnotes")

		End If ' End if If EOF <> True


	rstemp2.close
	set rstemp2=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing


	' Get any asset assignment from the AssetAssignment Table

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="select * from AssetAssignment where asset_number =" & Asset_number
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the
		if rstemp2.EOF then
			'response.write " No assigment Found for Asset:" & asset_number
			' No assignment found which is ok
		Else
			Customer_id = rstemp2("Customer_ID")
			Tech_id = rstemp2("tech_id")
			Asset_number2 = rstemp2("Asset_number2")


		End If ' End if If EOF <> True

	rstemp2.close
	set rstemp2=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing


 ' Now display a table with the info

%>

<Table border=1 width=98%>
<tr>
<td colspan=2 align=center bgcolor=FFFFFF valign=top>
<font size=-1><B>Asset Information &nbsp;&nbsp;&nbsp;(Asset # <%=Asset_Number%>)</b></font>
</td></tr>

<tr><td width=50%  valign=top><font size=-1>

<center>
<b>Asset Info:</b>
</center>
<hr width=80%>

<b>Description:</b>
<%=equipment_type%><br>
<b>Property tag:</b>
<%=property_tag%><br>

<b>Assigned group:</b>
<%=assigned_group%><br>
<b>Location:</b>
<%=location%><br>
<b>Date assigned:</b>
<%=date_assigned%><br>
<b>IP address:</b>
<%=ip_address%><br>
<b>Wall port number:</b>
<%=wall_port_number%>
<Br>

<font size=-1>
<center>
<b>Asset Details</b>
</center>
<hr width=80%>
<b>Computer ID:</b>
<%=computer_id%>
<br>
<b>Lease or purchase:</b>
<%=lease_or_purchase%>
<br>
<b>Purchase order number:</b>
<%=purchase_order_num%>
<br>
<b>Serial number:</b>
<%=serial_number%>

<% If Custom_field1 = Null AND Custom_Field2 = Null and Custom_field3= Null and Custom_field4 = Null and Custom_Field5 = Null Then

	' Donot display the custom fields at all
Else
%>
<center><b>Custom Fields</b></center>
<hr width=80%>
<%End If %>

<% If Custom_field1 <> "" Then %>
<b><%=Custom_Field_1_Label%>:</b>
<%=custom_field1%>
<br>
<%End If %>

<% If Custom_field2 <> "" Then %>
<b><%=Custom_Field_2_Label%>:</b>
<%=custom_field2%>
<br>
<%End If %>

<% If Custom_field3 <> "" Then %>
<b><%=Custom_Field_3_Label%>:</b>
<%=custom_field3%>
<br>
<%End If %>

<% If Custom_field4 <> "" Then %>
<b><%=Custom_Field_4_Label%>:</b>
<%=custom_field4%>
<br>
<%End If %>

<% If Custom_field4 <> "" Then %>
<b><%=Custom_Field_5_Label%>:</b>
<%=custom_field5%>
<%End If %>

</td>
<td valign=top>


<font size=-1>
<center><b>Specifications</b></center>
<hr width=80%>
<b>Processor speed:</b>
<%=processor_speed%>
<br><b>RAM size:</b>
<%=ram_size%><br>
<b>Hard drive size:</b>
<%=hd_size%><br>
<b>Monitor model:</b>
<%=monitor_model%>
<br>
<b>Monitor size:</b>
<%=monitor_size%><br>
<b>Monitor serial number:</b><br>
<%=monitor_serial_num%>


<center><b>Software</b></center>
<hr width=80%>
<b>Operating system 1:</b>
<%=operating_system1%><br>
<b>Operating system 2:</b>
<%=operating_system2%><br>
<center><b>Asset Notes</b></center>
<hr width=80%>
<b>Notes:</b><br>
<%=assetnotes%><br>

</td>
</tr>
</table>




<%
End Sub
%>


<% ' New code to display the expenses %>


<% Sub DisplayExpenses(case_number)
%>




    <% If ExtendedTimeSpent = True or  ExtendedTimeSpent = Null or ExtendedTimeSpent = 1 Then
			TimeSpentBilling = "YES"
		End If

	%>

<% If TimeSpentBilling = "YES" Then  ' Only display this option if enabled %>


<%
  spacerline2 = "<tr><td><table cellspacing=0 cellpadding=0 width=100% ><tr><td height=" & spacerheight & "> </td></tr></table></td></tr>"
%>


<% ' following nested table is necessary to get consistent vertical line-up of left-hand-edge %>


	<tr><td  height=<%=spacerheight%> colspan=2></td></tr>


<tr>
   <td colspan=2 align=center>
     <table width=100% cellpadding=0 cellspacing=0 border=0>
       <tr>
         <td align=center class=MinorFormTitle>Expenses</td>
       </tr>
      </table>
   </td>
</tr>

<%
 response.write spacerline
%>

<tr>

<td colspan=2>
<table class=FormTable width=100% cellpadding=1 cellspacing=1>
<tr>
<td class=formlabelsuper align=center>
<%=wc_Date %>
</td>


<td class=formlabelsuper align=center>
<%=wc_Tech %>
</td>

<td class=formlabelsuper align=center>
Quantity
</td>

<td class=formlabelsuper align=center>


Description

</td>




<td class=formlabelsuper align=center>

Cost

</td>


<td class=formlabelsuper align=center>

Tax Rate

</td>


<td class=formlabelsuper align=center>
SubTotal
</td>

<td class=formlabelsuper align=center>
Total
</td>





</tr>

<% ' Now display any expense records for this case number if they exist %>

	<% ' Get the values if they exist

	TotalExpenses = 0

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN


	If Case_Number <> "NEW" Then
		mySQL = "SELECT Expenses.case_number, tech_staff.first_name, tech_staff.last_name, Expenses.Description, Expenses.Cost, Expenses.Quantity, Expenses.TaxRatePercent, Expenses.ExpenseDate, Expenses.ExpenseIndex FROM (Expenses INNER JOIN tech_staff ON Expenses.Tech_ID = tech_staff.tech_id) INNER JOIN cases ON  (Expenses.case_number = cases.case_number)  WHERE Expenses.Case_Number = " & Case_Number
		' too many joins methinks mySQL = "SELECT Expenses.case_number, tech_staff.first_name, tech_staff.last_name, Expenses.Description, Expenses.Cost, Expenses.Quantity, Expenses.TaxRatePercent, Expenses.ExpenseDate, Expenses.ExpenseIndex FROM (Expenses INNER JOIN tech_staff ON Expenses.Tech_ID = tech_staff.tech_id) INNER JOIN cases ON (tech_staff.tech_id = cases.tech_id) AND (Expenses.case_number = cases.case_number)  WHERE Expenses.Case_Number = " & Case_Number
	Else
		mySQL = "SELECT Expenses.case_number, tech_staff.first_name, tech_staff.last_name,  Expenses.TaxRatePercent, Expenses.Description, Expenses.Cost, Expenses.Quantity, Expenses.ExpenseDate, Expenses.ExpenseIndex FROM (Expenses INNER JOIN tech_staff ON Expenses.Tech_ID = tech_staff.tech_id) INNER JOIN cases ON (tech_staff.tech_id = cases.tech_id) AND (Expenses.case_number = cases.case_number)  WHERE Expenses.Case_Number = 99999"
	End If

'	response.write "SQL= " & mySQL
'    	response.flush

	set rstemp = server.createobject("adodb.recordset")
	rstemp.open mySQL, conntemp, 1,3

	If  rstemp.eof then ' Check to see any expense values exist for this case number

	Else
		Do While rstemp.EOF <> True

%>

<tr>

<td class=formlisting>



<% ' Alternate Method to displaying the invoice date to handle UK compatibility date formats %>

<% 'Try this method to switch Day and Month %>


<%
	Locale = GetLocale() ' CMB 0
	Call SetLocale (1033)  ' CMB

	If WCDateFormat = "DDMMYYYY" Then ' UK format
		CorrectedInvoiceDate = Day(rstemp("ExpenseDate")) & "/" & Month(rstemp("ExpenseDate")) & "/" & Year(rstemp("ExpenseDate"))
	Else
		CorrectedInvoiceDate = Month(rstemp("ExpenseDate")) & "/" & Day(rstemp("ExpenseDate")) & "/" & Year(rstemp("ExpenseDate"))
	End If
	Call SetLocale(Locale) ' CMB
%>

<%=CorrectedInvoiceDate%>


</td>



<td class=formlisting>
<%=rstemp("last_name") %>, &nbsp; <%=rstemp("first_name") %>


</td>


<td class=formlisting>

<%=rstemp("Quantity") %>

</td>


<td class=formlisting>

<%=rstemp("Description") %>

</td>


<td class=formlisting align=right>

<%=wc_Time_Spent_Currency%>
<%=rstemp("Cost")%>



</td>

<td class=formlisting align=right>

<%=rstemp("TaxRatePercent")%>



</td>



<td class=formlisting align=right>

<% ' Compute sub total cost with quantity and cost and adding to totalexpenses



	'SubTotal = Round(rstemp("Quantity") * rstemp("Cost"),2)  CMB 09/27/2011
	If not isnull(rstemp("Quantity")) and not isnull(rstemp("Cost")) then
		SubTotal = Round(rstemp("Quantity") * rstemp("Cost"),2)  'CMB 09/27/2011
	Else
		subtotal = 0
	End If

	response.write wc_Time_Spent_Currency & SubTotal
%>
</td>


<td class=formlisting align=right>

<% ' Compute total cost by adding subtotal and tax x subtotal totalexpenses

	TaxRatePercent = rstemp("TaxRatePercent")


	If IsNull(TaxRatePercent)  OR TaxRatePercent = 0 Then
		Tax = 0
	Else

		Tax = SubTotal * (CDBL(TaxRatePercent)/100)
'		response.write "Tax = " & tax
'		response.flush
'		response.end

	End If


	Total = Subtotal + Tax

	TotalExpenses = Round(TotalExpenses + Total, 2)

	response.write wc_Time_Spent_Currency & Total
%>
</td>






</tr>


<%


			rstemp.MoveNext
		Loop

	End IF

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

%>

<% ' Now display the form element to allow users to enter new expenses
    'data for storing
%>



<% ' Now display the summary information for time spent %>

<tr>
<td colspan=7 class=formlisting align=right>



<b>Expense Totals:</b>

</td>

<td colspan=1 class=formlisting align=right>

<%=wc_Time_Spent_Currency%><%=TotalExpenses %>




</tr>

</table>


</td>


</tr>


<%End If ' End of If Time Spent Billing Option enabled %>



<% ' ******************* End of Web+Center Expense Feature ********************************%>


<% End Sub %>



