<% 'Module: SC.asp (Same as TechLoginshowCase.asp) SC = Show Case

   'Description: This module is the special version of the Login Page
   ' that is called from the email messages sent to techs so they can directly
   ' call this page and login from their email windows and call a
   ' browser window.

   ' This page can be configured for either requiring the tech to login again
   ' or it can directly log the tech in.  Options are listed below under
   ' User Customizations

   '(C) 2000,2001 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '6/13/2000	SAV		Created original DoMacLogin.asp page
   '02/06/2001	SAV		Removed multiple connections to database to one connection
	'03/02/2001	SAV		Create TechLoginShowCase.asp module from DoTechLogin.asp
	'08/28/2001	SAV		Created SC.asp (shorter name for possible email link wrap problem
	'05/02/06   JC      Modified to accept MODE=auto on URL and obfuscated Tech_id
	' CONSTANTS
%>

<%' Set Global application variables - must be done prior to anything else %>
<!-- #INCLUDE FILE="SetGlobal.asp" -->

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="Adovbs.inc" -->



<% ' Verify that the user is already logged if their cookie is set.

    If request.querystring("Mode") = "" then
	    TechID = request.querystring("ID")
	else
	    TechID = deobfuscate(request.querystring("ID"))
	end if


	Case_Number = Request.querystring("N")

	 CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN")

	 'IMPORTANT CHANGE - 11/18/2013 - If a tech is already logged into, do not use the tech_ID from the
	 ' notification email but instead use the current logged in Tech_ID to display the tech+center page.
	 ' This will prevent someone loggin as someone else if they are already logged in if they get that link from another tech

	If CookieID <> "" Then
		TechID = CookieID
	End If

' Allow any tech logged in to pass security and view the support case.

	 If CookieID = "" OR CookieID = NULL Then
	 	LoginFailed = "YES"
	Else
		LoginFailed = "NO"
	End IF

	' * * * * * * User Customizations * * * * * * *
	' A second approach is to automatically login the tech from this
	' call even if they are not logged in.
		'Security = "NOPASSWORD"
		Security = "PASSWORDREQUIRED"
	' * * * * * * * * User Customziations * * * * * * *

    ' if we received a deobfusctaed user_id where the URL contained MODE=auto, then we can alog in directly

    ' CHOOSE (1) or (2) Below

	' (1)Uncomment this line to allow people to directly log in with cookie set - DEFAULT
	If loginFailed = "YES" and CookieID = "" and (Security = "NOPASSWORD" or request.querystring("Mode") <> "" ) Then

	' (2) Uncomment this line if you wish to prevent login unless tech is already logged in.

'	If loginFailed = "NO" Then


	' Log the tech at the same time.

	' Old Way
	' Important : It appear that we need to still set the cookie the old way
	' and new way to be compatible with techsupp.dll cookie reading code when
	' using MS Internet Explorer.  - Not exactly sure why the cookie code is
	' is sending and receiving the cookies differently, but for now we
	' need to set both cookies to compatible with techsupp.dll with IE.

	' so that is why we have both the addheader method and response.cookies
	' approach.
	response.addheader "Set-Cookie", "ISS_TECH_CENTER_LOGIN="&TechID&"; path=/;"

	' New Way (Compatible with ASP modules)

		Response.Cookies("ISS_TECH_CENTER_LOGIN") = TechID

	 Response.Cookies("ISS_TECH_CENTER_LOGIN").Path = "/"
	 Response.Cookies("ISS_TECH_CENTER_LOGIN").Secure = FALSE

		CookieString= "ISSTECHCENTERLOGIN"
	' Let them expire after each session
	'	 Response.Cookies(Cookiestring).Expires = Date + 90

	'	 Response.Cookies(Cookiestring).Path = "/"
	'	 Response.Cookies(Cookiestring).Secure = FALSE

	'	Response.Cookies ("MemberID") =  "3"
	'	Response.Cookies ("MemberID").Expires = Date + 90

	' Set the LoginFailed Flag to NO
	LoginFailed = "NO"

	End IF


	If LoginFailed = "YES"  Then

%>

<html><!-- (C) 1996,1998, 1999, 2000, 2001 by Internet Software Sciences-->
<head>
<title>Tech+Center Case Login </title>
</head>
<body bgcolor=#D8D8D8>
<center><table border=1 cellspacing=2 cellpadding=10
width=98%><tr><td><div align=center><font size=+1><b>
Tech+Center Case Login </b></font><br><font size=+1 color=blue><b></b></font></div><div
align=left><p><font size=-1></div></td></tr></table><p>
<center>
<table width=80%><tr><td bgcolor=D0D0D0 align=center>
<font size=-1 face=arial>

<form action=DoTechLoginShowCase.asp method=post>
<input type=hidden name=Case_Number value="<%=Case_Number%>">

Please enter your Tech+Center LoginID or your Tech_ID and password below to login and view or update this case.<P>


<br>


<% ' We will automatically filled in their LoginID or Display Tech_ID if LoginID is blank
	' Changed added 12/04/13 - SAV
		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="select * from Tech_staff where Tech_ID= '" & TechID & "'"
		'response.write "SQL= " & mySQL2

		set rstemp=conntemp.execute(mySQL2)

		if rstemp.eof = True then
			DisplayId = TechID
		Else

			IF IsNull(rstemp("current_customer_id")) Then
				DisplayId = TechID
			Else
				DisplayID= rstemp("Current_customer_id")
			End If

		End If

			rstemp.close
			set rstemp=nothing
			conntemp.close ' Close the connection
			set conntemp=nothing

%>


<B>LoginID or Tech_ID:</b>  <input size=10 maxlength=20 name=Login_Tech_ID type=text value="<%=DisplayID%>"> <br><br>


<B>Password:</b>  <input size=10 maxlength=20 name=password type=password>

<P>
<input type=image name=b_login src=/<%=WCLanguageDirectory%>/ts_login30x100.gif border=0>
</form>




</td></tr></table>

</td></tr></table>

<br>
</form>
</body>
</html>


<%Else ' Go directly to a special 3 frame document.

%>



<html><!-- (C) 1996,1998, 1999, 2000, 2001 by Internet Software Sciences -->
<head>
<title>Tech+Center</title>
</head>
<frameset cols="160,80%">
<frame src=Toptions.asp?TechID=<%=techid%> scrolling=auto name=options_screen>
<frameset rows="10%, 90%">
<frame src=MyCases.asp?TechID=<%=techid%> scrolling=auto name=pending_screen>
<frame src=TCaseForm.asp?Customer_ID=0&Case_number=<%=Case_Number%> scrolling=auto name=user_screen>
</frameset>
</frameset>
</html>


<% End If %>

<%

Function DeObfuscate(thecode)

For I = 1 to 80 ' search for the string length value
	 ThisChar = Mid(thecode,I,1)
	 thisChar = Asc(thisChar) - 48
	 if Cint(thisChar) = Cint(I-1) Then
	  Strlength = I-1
	  Exit For
	 End if
Next
 'response.write "String length is " & Strlength & "<BR>"

Target = ""
For I = 1 to Strlength

  Offset =  Asc(Mid(thecode,I,1)) - 48
   ' response.write "Offset Number " & I & " has the value " & offset
  Target = Target & Mid(thecode,offset+1,1)
 ' Response.write " where the char I see is " & Mid(thecode,offset+1,1) & "<BR>"
Next
DeObfuscate = Target
End Function

%>

