<% 'Module: Search.asp


   'Description: This module is the search engine first page.
   '(C) 1999, 2000, 2001, 2002, 2003, 2004 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '2/15/00	SAV		Created original Search page
   '4/26/01	AJS		Changed Search By Case Status to work properly
   '1/5/04  JC      Upgraded to support "AND" search capability with keywords
   '02/02/2011  CMB Added ability to produce CSV file
	'04/25/13   CMB     Version 8 support for primary only; include code customizations
	'02/07/14   CMB   Default sort order is case number descending for non imports

   ' ---------Note:
   ' This is the first module of a set of three that work together, namely Search.asp DoSearch1.asp and DoSearch.asp
   ' The second two fo these were cloned from the old DoSearch.asp with extensive modifications
   ' This module is almost the same as before, except it now includes 2 radio buttons to allow the user
   ' to specify "Any" or "All" keywords must be present in a record to make it qualify (i.e. equivalent ot OR and AND )
   '
   ' Then the second module (DoSearch1.asp) generates an appropriate SQL statement - but the SQL statement is generated
   ' as if "Any" was specified by the user - no matter what the setting of the radio buttons. But then if "All" wa spewcified
   ' it performs this qualification itself after records have been retrieved by the SQL statement
   '
   ' Then - instead of displaying qualified records to the user, it stashes a list of the qualified case numbers
   ' in an array held in a session variable
   '
   ' The the third program (DoSearch2.asp) uses this array to retrieve the records and display them. This way it can
   ' show pages of 15 hits at a time and go back to the array fro subsequent pages without doing the database search again.

	' CONSTANTS
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->
<!-- #INCLUDE FILE="../Language/CodeCustomizations.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->

<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 2 ' Allow any tech  to access this function.

	CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN") ' Get the Logged TechID from the cookie

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="SELECT * from Tech_staff where Tech_ID = '" & CookieID & "' AND Tech_Level >= " & TechLevel
		set rstemp=conntemp.execute(mySQL2)

		If rstemp.EOF <> True Then
			ValidUser = "YES" ' Set this variable to prevent problems on next page
		End If

		rstemp.close
		set rstemp=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing

 ' End of ASP page security checks
 %>


<% if ValidUser <> "YES" Then %>
	<% ASPPage = "Search.asp"%>

	<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function %>




<% 'First Show the Report Menu at the top of the page
%>


<html>

<head>
<title><%=wc_Case_Search%></title>
<!-- #INCLUDE FILE="Stylesheet.inc" -->
</head>

<% 'Get the value of the User Screen background color from the Configuration Table %>
<%
	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL2="select * from Configuration"
	set rstemp2=conntemp.execute(mySQL2)

	if rstemp2.EOF then
		UserPageColor = "FFFFFF" ' Default to white if record not found
	Else
		UserPageColor = rstemp2("ts_user_page_color")
		Customer_ID_List = rstemp2("customer_id_list")
	End If

	rstemp2.close
	set rstemp2=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

%>

<%  spacerheight=0 %>

<%
chunksize = Session("chunksize")
'response.write "Chunksize picked up = " & chunksize & "<P>"
if chunksize = "" then chunksize = 35
if Not isNumeric(chunksize)  then chunksize = 35
Session("chunksize") = chunksize

%>

<body class=rightwindow>
<CENTER>

<center>
<Table class=BGWrapper >
<tr>
<td width=50% align=center valign=center class=majorscreentitlefixed><%=wc_Case_Search%></td>
</tr>
</table>

<FORM METHOD=POST name="myform" ACTION=DoSearchProjects1.asp>

<TABLE class=outerformwrapper cellspacing=0 cellpadding=0 width=62%>


<tr>
  <td>
      <TABLE cellpadding=1 cellspacing=1 width=100%>
      <tr>

	    <td   width=50%>
	       <TABLE class=BGwrapper cellpadding=0 cellspacing=0> <!-- Search and Display -->

	          <tr>
	            <td class=formlabelsuper><%=wc_Results_View%>:</td>
	            <td class=formboxholder>
					<INPUT type=radio name=ResultsView value="BRIEF" CHECKED><span class=tinyprint><%=wc_Brief%></span>

							 <input type=radio name=ResultsView value="DETAILED"><span class=tinyprint><%=wc_Detailed%></span>

	            </td>
	         </tr>

	         <tr>
	            <td class=formlabelsuper><%=wc_Sort_Results_by_Case_Number%>:</td>
	            <td>
	               <select name=sortorder>
	                  <option selected  value="Descending"><%=wc_descending%>
	                  <option value="Ascending"><%=wc_ascending%>

	               </select>
	           </td>
	         </tr>
	         <tr>
	           <td class=formlabelsuper>Number of results per page:</td>
	            <td  class=formboxholder><input type=text name=chunksize value=<%=chunksize%> size=2</td>

	         </tr>
	           <tr>
				  <td align=center valign=bottom colspan=2>&nbsp;<INPUT type=image name=b_search src=SearchAndDisplay.gif border=0></td>
			  </TR>

	       </TABLE>
	    </td>

	<td valign=top width=50%>
	    <TABLE  class=BGwrapper cellpadding=0 cellspacing=0 > <!-- EXPORT BOX -->
	    	<TR>
				<td  class=formlabelsuper><B>
					<%=wc_Export_Format%>:</b>
				</td>
				<td  class=formboxholder>
					<select name=FormatType size=1>
						<option value="COMMA" Selected><%=wc_Comma_Delimited_File_format%></option>
						<option value="TAB"><%=wc_TAB_Delimited_Excel_format%></option>
						<option value="COMMASCREEN"><%=wc_Comma_Delimited_To_Screen_format%></option>
					</select>
				</td>
			</tr>
			 <tr>
				<td class=formlabelsuper>Sort results on:</td>
				<td>
				   <select name=SortField>
					  <option selected value="Cases.Case_Number">Case Number
					  <option  value="Open_Date">Date Opened
				   </select>
			   </td>
	         </tr>
			 <tr>
				<td class=formlabelsuper>Sort results by:</td>
				<td>
				   <select name=ExportSortOrder>
					  <option selected value="Ascending"><%=wc_ascending%>
					  <option  value="Descending"><%=wc_descending%>
				   </select>
			   </td>
	         </tr>
	           <tr>
				  <td align=center valign=bottom colspan=2>&nbsp;<INPUT type=image name=e_search src=SearchAndExport.gif border=0></td>
			  </TR>
		</TABLE>
				</TD>
			</TR>

<tr>
</table>

<table class=innerformwrapper cellspacing=0 cellpadding=0 width=100%>
<tr><td height=1 ></td></tr>
<tr><td class=minorformtitle align=center><%=wc_Search_By_Key_Word_in_KB%></td></tr>
<tr>
<td align=center>


<TABLE BORDER=0  cellpadding=0 cellspacing=2 width=100%>
<TR>
	<TD width=50% class=formboxholder><span class=formlabelsuper><%=wc_Search_Knowledge_Base%>:</span>
	<br><INPUT type=text name=search_string size=30 maxlength=50></font></TD>



	<TD width=50% class=formboxholder><span class=formlabelsuper><%=wc_Multiple_Words%>:</span><br>
		<INPUT type=radio name=SearchType value="ANY" CHECKED><span class=tinyprint><%=wc_Any%></span>
	    <input type=radio name=SearchType value="ALL"><span class=tinyprint><%=wc_All%></span>

	</td>


</TR>
</TABLE>
</td>
</tr>



<tr><td class=minorformtitle align=center><%=wc_Search_By_Attribute%></td></tr>
<tr>
<td>

<% ' Display the  Categories


	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	'mySQL="select * from Categories where  State <> 0 Order by Category_Number, item_number"
	mySQL="select * from Categories where  State <> 0 Order by Category_index ASC"

	set rstemp=conntemp.execute(mySQL)
	If  rstemp.eof then ' Check to see any Categories exist

	Else %>
<center>

<table   border=0 cellspacing=2 cellpadding=2 width=100%><tr>

<%

		Category_name = rstemp("Category_name")
		Category_number = rstemp("Category_number")

%>
		<td align=center width=50% class=formboxholder><span class=formlabelsuper>

<%
				response.write Category_name & "</span><br>"
				response.write "<select name=c" & rstemp("category_number") & " size = 3>"
				response.write "<option selected value= >Ignore</option>"
				response.write "<option value=""" & wc_Category_Not_Set & """>" & wc_Category_Not_Set & "</option>"


		Odd = 1

		Do While rstemp.EOF <> True
			'-->AKS<-- Numeric conversion to INT.
			Category_number = CInt(Category_number)

			if CInt(rstemp("Category_number")) <> Category_number THEN
				response.write "</select></td>"
				If Odd = 1 Then
					Odd = 2
					Response.write "<td align=center class=formboxholder><span class=formlabelsuper>"
					Response.write rstemp("Category_Name") & "</span><br>"  & chr(10)
					response.write "<select name=c" & rstemp("category_number") & " size = 3>" & chr(10)
					response.write "<option selected value= >Ignore</option>"
					response.write "<option value=""" & wc_Category_Not_Set & """>" & wc_Category_Not_Set & "</option>"


				Else
					Odd = 1
					response.write "</tr></tr>"
					Response.write "<td align=center class=formboxholder><span class=formlabelsuper>"
					Response.write rstemp("Category_Name") & "</span><br>" & chr(10)
					response.write "<select name=c" & rstemp("category_number") & " size = 3>" & chr(10)

					response.write "<option selected value= >Ignore</option>"
					response.write "<option value=""" & wc_Category_Not_Set & """>" & wc_Category_Not_Set & "</option>"



				End If
				Category_number = rstemp("Category_number")
			End If

				response.write "<option value=" & rstemp("item_number") & ">" & rstemp("item_name") & "</option>" & chr(10) & chr(13)

			rstemp.MoveNext

		Loop



		response.write "</select></td>"

		If Odd = 1 Then 'fill out with a blank entry
		  response.write "<td class=formlabel></td>"
		End If

		response.write "</tr></table></center>"
	End IF

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing




%>
</td>
</tr>
<tr><td  class=lightline align=center height=3></td></tr>
<tr>
<td>

<% ' Display the Form questions at the bottom of the page %>
<center>
<table  border=0 cellspacing=0 cellpadding=0  width=100%>
<TR>
	<TD ALIGN=CENTER>
	<TABLE   cellspacing=2 cellpadding=2 width=100%>
	<TR >
	<TD width=33% valign=top class=formboxholder><span class=formlabelsuper><%=wc_Start_Date_Time%>:</span><br>
	<span class=tinyprint>
	(mm/dd/yyyy)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(HH:MM)<br></span>

	<INPUT type=text name=start_date size=11 maxlength=10>&nbsp;&nbsp;&nbsp;&nbsp;

	<INPUT type=text name=start_Time_hh size=1 maxlength=2>:<INPUT type=text name=start_Time_mm size=1 maxlength=2>

	<br>


	</TD>

	<TD width=33% valign=top class=formboxholder><span class=formlabelsuper><%=wc_End_Date_Time%>
	:</span><br>
	<span class=tinyprint>(mm/dd/yyyy)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(HH:MM)<br></span>

	<INPUT type=text name=end_date size=11 maxlength=10>&nbsp;&nbsp;&nbsp;&nbsp;
	<INPUT type=text name=end_Time_hh size=1 maxlength=2>:<INPUT type=text name=end_Time_mm size=1 maxlength=2>


	</TD>

	<TD width=34% valign=top class=formboxholder><span class=formlabelsuper><%=wc_Date_Type%>:</span><br>
	<span class=tinyprint><%=wc_Create_Last_Modify%><br></span>

	<SELECT  name=date_type>
	<OPTION selected value=0><%=wc_Creation_date%></OPTION>
	<OPTION value=1><%=wc_Last_modification_date%></FONT></OPTION>
	</SELECT></TD>
	</TR>
	</TABLE>
</TD>
</TR>
</table>

</td>
</tr>
<tr><td class=lightline align=center height=3></td></tr>
<tr>
<td>

<TR>
<TD ALIGN=CENTER>
<TABLE BORDER=0 cellspacing=2 CELLPADDING=2 WIDTH="100%" >
<TR>
<TD class=formboxholder><span class=formlabelsuper><%=wc_Assigned_group%>:&nbsp;</span>

<BR><SELECT size=1 name=group_number>
<option value="""" selected>Ignore</option>

<% ' Get the Groups from the database

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Group_list Order by Group_Name"
	set rstemp=conntemp.execute(mySQL)

	If  rstemp.eof then ' Check to see any Groups exist

	Else
		Do While rstemp.EOF <> True
				response.write "<option value=" & rstemp("group_number") & ">" & rstemp("group_name") & "</option>" & chr(10) & chr(13)

			rstemp.MoveNext

		Loop

		response.write "</select>"
	End IF

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

 ' End of Display the Group List
 %>

</TD>

<TD class=formboxholder><span class=formlabelsuper><%=wc_Status%>:&nbsp;</span>
<BR><SELECT size=1 name=case_status><OPTION selected value="">Ignore</OPTION>
<OPTION value=1>Closed Cases</OPTION>
<OPTION value=4>All Open Cases</OPTION>
<OPTION value=0>Open (Active)</OPTION>
<OPTION value=2>Open (Waiting)</OPTION>
<OPTION value=3>Open (On-Hold)</OPTION>


</font>
</SELECT></TD>

<TD class=formboxholder><span class=formlabelsuper><%=wc_Customer_ID%>:&nbsp;</span>
<BR>

<% ' The customerID field can either be a drop down box if that option is selected
	' or it can be a text box for large customer databases

	CustomerDropDown = "YES"

	'--AKS<-- Conversion to INT required
	Customer_Id_List = CInt(Customer_Id_List)

	If Customer_Id_List = 1 Then
		Response.write "<SELECT size=1 name=customer_id>"
		Response.write "<OPTION selected value="""">Ignore</OPTION>"

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Customers Order by Contact_lname"
	set rstemp=conntemp.execute(mySQL)

	' Check to see if any records are returned
	' if none found then login fails.

	If  rstemp.eof then ' Check to see any Groups exist

	Else
		Do While rstemp.EOF <> True
				response.write "<option value=" & rstemp("customer_id") & ">" & rstemp("customer_id") & "</option>" & chr(10) & chr(13)

			rstemp.MoveNext

		Loop

		response.write "</select>"
	End IF

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

 ' End of Display the Customer_List

End If


   If Customer_Id_List = 2 Then ' If using on-click and Javascript sub-window
            %>
            <font size=-1><input size=20 name=customer_id maxlength=20 value = "<%= Customer_ID %>">
		    <a href='javascript:var w=window.open("Customer_Id_Assist.asp","subwindow","width=<%=wc_Width_Customer_Id_Assist_Window%>,height=400,screenX=50,screenY=50,left=50,top=50,scrollbars=yes,resizable=yes")'>
		    <img src="/<%=WCLanguageDirectory%>/Assist.gif" border=0></a>
            <%
      End If  ' End of If using on-click and Javascript sub-window

      If Customer_Id_List = 0 Then' If using copy/paste sub-window
			%>
            <font size=-1><input size=20 name=customer_id maxlength=20 value = "<%= Customer_ID %>">
		    <a href=Customer_Id_Copy_Paste.asp target=subwindow>
		    <img src="/<%=WCLanguageDirectory%>/Assist.gif" border=0></a>
			<%
     End If ' End of If using copy/paste sub-window

	if Version8point0="YES" Then  ' 04/25/13
%>
   		 &nbsp;&nbsp;
   		<%= wc_Primary_only%>&nbsp;&nbsp;<input type=checkbox name=PrimaryOnly CHECKED>

<%
End If
%>
</TD>
</TR>

<TR>
<TD class=formboxholder nowrap><span class=formlabelsuper><%=wc_Assigned_staff_member%>:</span>
<BR><SELECT size=1 name=tech_id><OPTION selected value="">Ignore</OPTION>

<% ' Option to allow to search for cases un-assigned by tech %>


<option value="Un-assigned"><%=wc_Not_Assigned%></option>





<% ' Display the List of Techs

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Tech_staff Order by Last_Name"
	set rstemp=conntemp.execute(mySQL)

	If  rstemp.eof then ' Check to see any Groups exist

	Else
		Do While rstemp.EOF <> True
				response.write "<option value=" & rstemp("tech_id") & ">" & rstemp("Last_Name") & "," & rstemp("first_Name") & "</option>" & chr(10) & chr(13)

			rstemp.MoveNext

		Loop

		response.write "</select></td>"
	End IF

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

%>

<TD class=formboxholder><span class=formlabelsuper><%=wc_Priority%>:</span>

<BR><SELECT size=1 name=case_severity><OPTION selected value=""><FONT SIZE=-1>Ignore</OPTION>

<% ' Display the List of Priorities

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Priority order by Priorityid"
	set rstemp=conntemp.execute(mySQL)

	If  rstemp.eof then ' Check to see any Groups exist

	Else
		Do While rstemp.EOF <> True
		    if CInt(rstemp("PriorityID")) >= 0 then
				response.write "<option value=" & CInt(rstemp("PriorityID")) & ">" & rstemp("ShortDesc") & "</option>" & chr(10) & chr(13)
			end if
			rstemp.MoveNext
		Loop
		response.write "</select></td>"
	End IF

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing
%>


<!--
<OPTION value=1>Priority 1 (Highest=1)</OPTION>
<OPTION value=2>Priority 2 (Highest=1)</OPTION>
<OPTION value=3>Priority 3 (Highest=1)</OPTION>
<OPTION value=4>Priority 4 (Highest=1)</OPTION>
-->

</SELECT></TD>


<TD class=formboxholder ><span class=formlabelsuper><%=wc_Duplicates%>:</span>

<BR><SELECT size=1 name=dup_Cases><OPTION selected value=""><FONT SIZE=-1>Ignore</OPTION><OPTION value=1>No
duplicate Cases</FONT></OPTION></SELECT></TD>
</TR>

<TR>
<TD class=formboxholder><span class=formlabelsuper><%=wc_Case_number%>:&nbsp;</span>

<BR><INPUT type=text name=case_number size=15 maxlength=15></TD>

<TD class=formboxholder><span class=formlabelsuper><%=wc_Asset_number%>:&nbsp;</span>
<font size=-1>
<BR><INPUT type=text name=asset_number size=15 maxlength=15>
		  	<a href='javascript:var w=window.open("AssetNumberAssist.asp","subwindow","width=<%=wc_Width_Customer_Id_Assist_Window%>,height=400,screenX=50,screenY=50,left=50,top=50,scrollbars=yes,resizable=yes")'><img src="/<%=WCLanguageDirectory%>/Assist.gif" border=0></a>


</font></TD>

<TD class=formboxholder><span class=formlabelsuper><%=wc_Scheduled_Cases%>:&nbsp;</span>
<FONT SIZE=-1><BR><SELECT size=1 name=ScheduledCase>
<OPTION selected value="">Ignore</OPTION>
<OPTION value="ALL">All Scheduled Cases</OPTION>
<OPTION value="ONCE">All Single Event Cases</OPTION>
<OPTION value="REPEATED">All Repeating Cases</OPTION>
<OPTION value="LATE">Cases Overdue</OPTION>
<OPTION value="TODAY">Cases Scheduled Today</OPTION>

<
</SELECT></TD>

<% ' New fields for Reference Number and Duplicate Case Number %>
<TR>
<TD class=formboxholder><span class=formlabelsuper><%=wc_Dup_Case_number%>:&nbsp;</span>
<BR><INPUT type=text name=Dup_case_number size=15 maxlength=15></TD>

<TD class=formboxholder><span class=formlabelsuper><%=wc_Reference_Number%>:&nbsp;</span>

<BR><INPUT type=text name=External_Case_Number size=15 maxlength=30></font></TD>

<TD class=formboxholder><span class=formlabelsuper><%=wc_Reference_Type%>:&nbsp;</span>
<BR><SELECT size=1 name=ReferenceType>
<OPTION selected value="">Ignore</OPTION>
<OPTION value="REFERENCEONLY">Reference Cases</OPTION>
<OPTION value="NOREFERENCEONLY">No Reference Cases</OPTION>

</font>
</SELECT></TD>


</TR>
</TABLE>
</TD>
</TR>

<!-- ---------start adding optional fields---------------- -->





	<% '******* DISPLAY THE OPTIONAL CASE FORM TEXT BOXES ***************************%>

	<% ' Get the values if they exist

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Case_Text_Field_Labels" ' There should be no rows or only 1

	set rstemp=conntemp.execute(mySQL)

	If rstemp.EOF <> True then
		Field_1_Label = rstemp("Field_1_Label")
		Field_2_Label = rstemp("Field_2_Label")
		Field_3_Label = rstemp("Field_3_Label")
		Field_4_Label = rstemp("Field_4_Label")
		Field_5_Label = rstemp("Field_5_Label")
		Field_6_Label = rstemp("Field_6_Label")
		Field_7_Label = rstemp("Field_7_Label")
		Field_8_Label = rstemp("Field_8_Label")
		Field_9_Label = rstemp("Field_9_Label")
		Field_10_Label = rstemp("Field_10_Label")

		Field_1_State = rstemp("Field_1_State")
		Field_2_State = rstemp("Field_2_State")
		Field_3_State = rstemp("Field_3_State")
		Field_4_State = rstemp("Field_4_State")
		Field_5_State = rstemp("Field_5_State")
		Field_6_State = rstemp("Field_6_State")
		Field_7_State = rstemp("Field_7_State")
		Field_8_State = rstemp("Field_8_State")
		Field_9_State = rstemp("Field_9_State")
		Field_10_State = rstemp("Field_10_State")

	End If


	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

	' Now determine if any of the case text fields are enabled for ALL view(2) or tech view (1)
	' or determine if any of the fields are greater than 0

	If Field_1_State > 0  OR Field_2_State > 0 OR  Field_3_State > 0 OR  Field_4_State > 0 OR  Field_5_State > 0 OR  Field_6_State > 0 OR  Field_7_State  > 0 OR  Field_8_State > 0 OR  Field_9_State > 0 OR  Field_10_State > 0  THEN
	' At least one field is enabled for ALL view (customer and techs) so open up table cell for it

%>
     <tr><td  class=MinorFormTitle colspan=2 align=center><%=wc_Search_By_Further_Attributes%></td></tr>
	<tr>
	<td align=center   WIDTH="100%" colspan=2>

	<% ' Start new Table for Optional text fields %>



	<table cellspacing=2 CELLPADDING=0  WIDTH=100%   border=0>








  <%

  spacerline = ""
  notr = "Yes"

  %>

	<% OddEven = "Even" %>

	<% If Field_1_State > 0  Then %>
	    <% If OddEven = "Even" and notr = "Yes" Then
	        response.write "<tr>"
	       End If
	     %>

		<td class=formlabelsuper ><blockquote>
		<%=Field_1_Label%>: &nbsp;&nbsp;
		</br>
		<span class=formboxholder>
		<input type=text name="text_Field_1" size=30 maxlength=100 value="<%=Field_1_Value%>">
		</span></td>
	    <% If OddEven = "Odd" Then
	        response.write "</tr>"
	        response.write  spacerline
	        notr = "No"
	        response.write "<tr>"
	        OddEven = "Even"
	       Else
	        OddEven = "Odd"
	       End If
	     %>
	<% End If %>

	<% If Field_2_State > 0  Then %>
	    <% If OddEven = "Even" and notr = "Yes" Then
	         response.write "<tr>"
	       End If
	     %>

		<td class=formlabelsuper ><blockquote>
		<%=Field_2_Label%>: &nbsp;&nbsp;
		</br>
		<span class=formboxholder>
		<input type=text name="text_Field_2" size=30 maxlength=100 value="<%=Field_2_Value%>">
		</span></td>
	    <% If OddEven = "Odd" Then
	        response.write "</tr>"
	        response.write spacerline
	        notr = "No"
	        response.write "<tr>"
	        OddEven = "Even"
	       Else
	        OddEven = "Odd"
	       End If
	     %>
	<% End If %>


	<% If Field_3_State > 0  Then %>
	    <% If OddEven = "Even" and notr = "Yes" Then
	       response.write "<tr>"
	       End If
	     %>

		<td class=formlabelsuper ><blockquote>
		<%=Field_3_Label%>: &nbsp;&nbsp;
		</br>
		<span class=formboxholder>
		<input type=text name="text_Field_3" size=30 maxlength=100 value="<%=Field_3_Value%>">
		</span></td>
	    <% If OddEven = "Odd" Then
	        response.write "</tr>"
	        response.write spacerline
	        notr = "No"
	        response.write "<tr>"
	        OddEven = "Even"
	       Else
	        OddEven = "Odd"
	       End If
	     %>
	<% End If %>


	<% If Field_4_State > 0  Then %>
	    <% If OddEven = "Even" and notr = "Yes" Then
	       response.write "<tr>"
	       End If
	     %>

		<td class=formlabelsuper ><blockquote>
		<%=Field_4_Label%>: &nbsp;&nbsp;
		</br>
		<span class=formboxholder>
		<input type=text name="text_Field_4" size=30 maxlength=100 value="<%=Field_4_Value%>">
		</span></td>
	    <% If OddEven = "Odd" Then
	        response.write "</tr>"
	        response.write spacerline
	        notr = "No"
	        response.write "<tr>"
	        OddEven = "Even"
	       Else
	        OddEven = "Odd"
	       End If
	     %>
	<% End If %>


	<% If Field_5_State > 0  Then %>
	    <% If OddEven = "Even" and notr = "Yes" Then
	       response.write "<tr>"
	       End If
	     %>

		<td class=formlabelsuper ><blockquote>
		<%=Field_5_Label%>: &nbsp;&nbsp;
		</br>
		<span class=formboxholder>
		<input type=text name="text_Field_5" size=30 maxlength=100 value="<%=Field_5_Value%>">
		</span></td>
	    <% If OddEven = "Odd" Then
	        response.write "</tr>"
	        response.write spacerline
	        notr = "No"
	        response.write "<tr>"
	        OddEven = "Even"
	       Else
	        OddEven = "Odd"
	       End If
	     %>
	<% End If %>


	<% If Field_6_State > 0  Then %>
	    <% If OddEven = "Even" and notr = "Yes" Then
	       response.write "<tr>"
	       End If
	     %>

		<td class=formlabelsuper ><blockquote>
		<%=Field_6_Label%>: &nbsp;&nbsp;
		</br>
		<span class=formboxholder>
		<input type=text name="text_Field_6" size=30 maxlength=100 value="<%=Field_6_Value%>">
		</span></td>
	    <% If OddEven = "Odd" Then
	        response.write "</tr>"
	        response.write spacerline
	        notr = "No"
	        response.write "<tr>"
	        OddEven = "Even"
	       Else
	        OddEven = "Odd"
	       End If
	     %>
	<% End If %>


	<% If Field_7_State > 0  Then %>
	    <% If OddEven = "Even" and notr = "Yes" Then
	       response.write "<tr>"
	       End If
	     %>

		<td class=formlabelsuper ><blockquote>
		<%=Field_7_Label%>: &nbsp;&nbsp;
		</br>
		<span class=formboxholder>
		<input type=text name="text_Field_7" size=30 maxlength=100 value="<%=Field_7_Value%>">
		</span></td>
	    <% If OddEven = "Odd" Then
	        response.write "</tr>"
	        response.write spacerline
	        notr = "No"
	        response.write "<tr>"
	        OddEven = "Even"
	       Else
	        OddEven = "Odd"
	       End If
	     %>
	<% End If %>


	<% If Field_8_State > 0  Then %>
	    <% If OddEven = "Even" and notr = "Yes" Then
	       response.write "<tr>"
	       End If
	     %>

		<td class=formlabelsuper ><blockquote>
		<%=Field_8_Label%>: &nbsp;&nbsp;
		</br>
		<span class=formboxholder>
		<input type=text name="text_Field_8" size=30 maxlength=100 value="<%=Field_8_Value%>">
		</span></td>
	    <% If OddEven = "Odd" Then
	        response.write "</tr>"
	        response.write spacerline
	        notr = "No"
	        response.write "<tr>"
	        OddEven = "Even"
	       Else
	        OddEven = "Odd"
	       End If
	     %>
	<% End If %>


	<% If Field_9_State > 0  Then %>
	    <% If OddEven = "Even" and notr = "Yes" Then
	       response.write "<tr>"
	       End If
	     %>

		<td class=formlabelsuper ><blockquote>
		<%=Field_9_Label%>: &nbsp;&nbsp;
		</br>
		<span class=formboxholder>
		<input type=text name="text_Field_9" size=30 maxlength=100 value="<%=Field_9_Value%>">
		</span></td>
	    <% If OddEven = "Odd" Then
	        response.write "</tr>"
	        response.write spacerline
	        notr = "No"
	        response.write "<tr>"
	        OddEven = "Even"
	       Else
	        OddEven = "Odd"
	       End If
	     %>
	<% End If %>


	<% If Field_10_State > 0  Then %>
	    <% If OddEven = "Even" and notr = "Yes" Then
	       response.write "<tr>"
	       End If
	     %>

		<td class=formlabelsuper ><blockquote>
		<%=Field_10_Label%>: &nbsp;&nbsp;
		</br>
		<span class=formboxholder>
		<input type=text name="text_Field_10" size=30 maxlength=100 value="<%=Field_10_Value%>">
		</span></td>
	    <% If OddEven = "Odd" Then
	        response.write "</tr>"
	        response.write spacerline
	        notr = "No"
	        response.write "<tr>"
	        OddEven = "Even"
	       Else
	        OddEven = "Odd"
	       End If
	     %>
	<% End If %>


	<% ' If we ended up on the wrong side emit an empty dummy to fill out the table %>

	    <% If OddEven = "Odd" Then
	       response.write "<td class=formlabelsuper></td></tr>"
	       End If
	     %>



	</table>

	</td></tr>

   <tr><td class=formspacer height=5 colspan=2></td></tr>
	<%End If ' If no Case Text fields are enabled for customer view %>



	<% '******* END OF DISPLAY THE OPTIONAL CASE FORM TEXT BOXES ***************************%>





<% ' Close inside table %>

</table>




<!-- ---------end of  adding optional fields---------------- -->

</TABLE>


</td>
</tr>


</table> <!-- end of inner form wrapper -->

</td>
</tr>
</table> <!-- end of outer form wrapper -->

</FORM>

</BODY>
</HTML>

<%End If ' End of security check %>
