<% 'Module: SurveyReportAvgByTechGroup.asp

   'Description: This module is the basic report module from which other report
   ' modules can be built from.  This report gives a report showing the Average Customer Survey result
   ' for a specific tech group or all groups for all surveys or a specified date range.
   ' This page can be customized by the user to either add custom
   ' reports or to modify the Tech+Center Control Status Panel.
   ' Please refer to the Web+Center user documentation on how to
   ' modify this script.  This should only be done by advanced system
   ' users and all changes should be carefully changed.  Any code that
   ' updates the database will not be supported without additional
   ' cost from Internet Software Sciences.  Persons adding to this code
   ' should be familar with the ASP programming and how to access a
   ' database from the ASP progamming scripting language.

   '(C) 1999, 2000, 2001-2013 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '9/09/99	SAV		Created original OpenCasesByTech.asp page
   '10/5/01 SAV		Create originalOpenCasesByCustoerByDate.asp module
   '10/6/01 SAV		Created CasesByCategory.asp module
    '06/01/11 CMB   Rewrote using group by and reports.inc
   '08/05/11 CMB   UK Date; clean up
   '08/31/12  CMB    Added links for reports that call dosearch1.asp which i had to change also
   '11/22/13	SAV	Created SurveyReportAvgByTech.asp module from CaseBy Category report module
   '11/25/13	SAV	CreatedSurveyReportAvgByTechGroup.asp module from SurveyReportAvgByTech.asp
   '12/11/13   CMB    rewrote with group by rather than break processing
   '12/19/13	SAV  Added links to show details

	' CONSTANTS
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->
<!-- #INCLUDE FILE="../Language/codeCustomizations.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>

<!-- #INCLUDE FILE="Adovbs.inc" -->
<!-- #INCLUDE FILE="Reports.inc" -->
<% ' GLOBALS
Dim First_Question_ID
Dim First_Survey_Question
Dim Question_Found
%>

<% ' Check if EXPORT checkbox is checked and if so export results to excel spreadsheet

	If Request.Form("Export") <> "" Then
		ExportFlag = "YES"
		Delimiter = vbTab
		Response.ContentType = "application/vnd.ms-excel"

		'Debug Excel code
		'Response.write "Cell one" & vbtab
		'Response.write "Cell two" &   vbCRLF

	' EXPORT FORMAT

	End If

	InputQuestionID = ""
	InputQuestionID = request.form("Question_ID")
	IF InputQuestionID <> "" and InputQuestionID <> 0 Then
		Question_ID = InputQuestionID
	Else   ' 12/11/13
		Question_ID = 0  'First_Question_ID  ' 12/11/13
	End If

	Group_Number = Request.form("Group_Number") ' Check if passed as value from form submit

%>

<% 'Get the value of the User Screen background color from the Configuration Table

    call  GetConfig(DateDisplayFormat,UserPageColor,DatabaseType)
    DatabaseType2 = DatabaseType


 ' Now see if this page is getting called as form submit with date filter
	'criteria.  If it is then we need to grab that data and put it into the
	'the date range fields.

		Start_Date = Request.form("Start_date")
		End_Date = Request.form("End_Date")

 If ExportFlag <> "YES" Then
%>

<html>

<head>
<title><%=wc_Survey_Results_Average_By_Tech_Group%></title>
</head>

<body bgcolor="<%=UserPageColor%>">
<center>
<table border=1 width=95%>
<tr>
<td align=center bgcolor=F0F0BO>
<font size=-1><%=wc_Survey_Report%></font>
</td>
<td bgcolor=F0E0F0 align=center>
<font size=+1><%=wc_Survey_Results_Average_By_Tech_Group%></font>
<center>
<font size=-2>This report shows the average customer response value from a selected 1-5 type customer survey
question. <br> You can select ALL TECH GROUPS or a specific Tech group and chose a date range when the surveys were submitted
or all surveys.</font>

</td>
<td align=center bgcolor=B0F0F0>
<font size=-1><%=Now%></font>
</td>

</tr></table>

</center>

<form action=SurveyReportAvgByTechGroup.asp method=post>

<center>
<table border=1 WIDTH="95%" >
<TR>
<TD ALIGN=CENTER bgcolor=C0F0E0>
<TABLE BORDER=0 CELLPADDING=7 WIDTH="90%" >
<TR>
<TD valign=top><B><FONT SIZE=-1><%=wc_Start_date%>:</FONT></b><br>
<font size=-2>
<% if datedisplayformat = "DDMMYYYY" then
		response.write "(dd/mm/yyyy)"
	else
		response.write "(mm/dd/yyyy)"
	end if
%>

<br></font>
<font size=-1>
<INPUT type=text name=start_date size=11 maxlength=10 value="<%=Start_Date%>"></TD>

<TD valig=top><B><FONT SIZE=-1><%=wc_End_date%>:</font></b><br>
<font size=-2>
<% if datedisplayformat = "DDMMYYYY" then
		response.write "(dd/mm/yyyy)"
	else
		response.write "(mm/dd/yyyy)"
	end if
%>

<br></FONT>
<font size=-1>
<INPUT type=text name=end_date size=11 maxlength=10 value="<%=End_Date%>"></TD>

<TD valign=top><B><FONT SIZE=-1><%=wc_Survey_Question%>:</font></b><br>
<font size=-2>
<%=wc_Select_One%><br></font>

<FONT SIZE=-1><SELECT size=1 name=Question_id>
<option value=0>Select a question</option>

<% ' ****** Display only the "1-5" type survey questions in the dropdown


call DisplayQuestions(InputQuestionID)
%>
		</td>

<TD valign=top><B><FONT SIZE=-1><%=wc_Assigned_group%>:</FONT></B>
<br><font size=-2><%=wc_Select_One%></font><br>
<%
	Call DisplayGroups(group_Number)
 %>


</SELECT></font></TD>

<td><B><FONT SIZE=-1>

<input type=checkbox name="EXPORT">&nbsp;&nbsp;EXPORT<Br>

</font></b>
<font size=-2><br>
</font>


<INPUT type=image name=b_search src=/<%=WCLanguageDirectory%>/ts_submit30x80.gif border=0></TD>

</TR>
</TABLE>
</TD>
</TR>
</table>
</center>

<P>
</form>


<% End If ' IF EXPORTFLAG <> YES
%>


<% ' If no 1-5 type question surveys available, simply avoid all of the code below and display a message to indicate
	' no 1-5

     If Question_Found <>"YES" AND EXPORTFLAG <> "YES" Then
%>
<br>
<Center>

<font size=+1> No 1-5 Type Survey questions found </font>
</center>

<br>

<% Else %>
	<% ' Create the query based on the entered date range if they entered any data

		WhereStatement = ""

		' Survey Date Range check

' NOTE CMB Have to change this depending on how they entered date
' if sql server might have to check locale
' if dateformat = mm then switch date

		Start_Date = Request.form("Start_Date")

		If Start_Date <> "" Then
			Start_Date = PadDate(Start_Date) ' CMB 08/15/2011

			if WCDateFormat = "DDMMYYYY" then  ' CMB 08/15/2011 put in US format
				NewStart = SwitchMonthDate (Start_Date) ' CMB 08/15/2011 ' CMB 08/15/2011
			Else
				NewStart = Start_Date ' CMB 08/15/2011
			end if

			If DatabaseType2 = "SQLSERVER" Then
				WhereStatement = WhereStatement & AndText & " Survey_Date >= '" & NewStart & "'"
			End IF

			If DatabaseType2 = "ACCESS" Then
				WhereStatement = WhereStatement & AndText & " Survey_Date >= #" & NewStart & "#"
			End IF

			If DatabaseType2 = "MYSQL" Then
				WhereStatement = WhereStatement & AndText & " Survey_Date >= '" & YYMMDD(NewStart) & "'"
			End IF

			AndText = " AND "
		End If

		End_date = Request.form("End_Date")

		If End_Date <> "" Then
			End_Date = PadDate (End_Date) ' CMB 08/15/2011

			if WCDateFormat = "DDMMYYYY" then  ' CMB 08/15/2011 put in US format
				NewEnd = SwitchMonthDate (End_Date)
			Else
				NewEnd = End_Date
			end if

			If DatabaseType2 = "SQLSERVER" Then
				WhereStatement = WhereStatement & AndText & " Survey_Date <=  '" & NewEnd & "'"
			End IF

			If DatabaseType2 = "ACCESS" Then
				WhereStatement = WhereStatement & AndText & " Survey_Date <= #" & NewEnd & "#"
			End IF

			If DatabaseType2 = "MYSQL" Then
				WhereStatement = WhereStatement & AndText & " Survey_Date <=  '" & YYMMDD(NewEnd) & "'"
			End IF

			AndText = " AND "
		End If

		'response.write "WhereSTatement = " & whereStatement

		' Survey Question ID into QUERY

	' If Question_ID is passed as a form element, take it, other wise find the first one and use it

		IF InputQuestionID <> "" and InputQuestionID <> 0 Then
			Question_ID = InputQuestionID
		Else   ' 12/11/13
			Question_ID = 0  'First_Question_ID  ' 12/11/13
		End If

		If  Question_ID <> ""  Then
				WhereStatement = WhereStatement & AndText & " Result_detail.Question_ID = " & Question_ID
			AndText = " AND "
		End IF

		' ALL tech Groups or a specific tech group

		Group_Number = Request.form("Group_Number")

		IF group_Number = 0 Or Group_Number = "" Then
			' Do not add any special WHERE statement
		Else
				WhereStatement = WhereStatement & AndText & " Cases.Group_Number = " & Group_Number
		End If

      WhereWithoutWhere = "" & WhereStatement  ' 08/31/12

'		If WhereStatement <> "" Then  ' 12/11/13
			WhereStatement = " Where " & WhereStatement
'		End IF

		' Add order by clause
		' NOTE and group name is not null?
		If DatabaseType2 = "SQLSERVER" Then
				WhereStatement = WhereStatement & AndText & "  active = 'true' and question_type = 1 "
		Else
					WhereStatement = WhereStatement & AndText & "  active = true and question_type = 1 "
		End If
		AndTest = " AND "

		WhereStatement = WhereStatement & " group by	cases.group_number, group_list.group_name, survey.question_ID, survey.question_order "

		WhereStatement = WhereStatement & " Order by cases.Group_Number "

%>

<% ' Display the Survey Question Name at the top of the table

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN ' Open the connection once here

	mySQL2 = "select * from Survey where question_ID = " & Question_ID
	'response.write "ID" & question_ID
	'response.end
'	response.flush

	set rstemp2=conntemp.execute(mySQL2)

	' Check to see if any records are returned

	If rstemp2.eof Then
		Survey_Question = " No Survey Question Found "
	Else
		Survey_Question = rstemp2("Survey_Question")
	End If

	rstemp2.close
	set rstemp2 = Nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

 If ExportFlag <> "YES" Then
%>

<center>
<B><%=wc_Survey_Question%>:
<font color=blue><%=Survey_Question%></font> <%=wc_Report%></b><br>

<table width=95% border = 1>
<tr>
<th width=30% bgcolor=E0E0E0><font size=-1><%=wc_Assigned_Group%></th>
<th width=10% bgcolor=E0E0E0><font size=-1> # of Surveys </th>
<th width=10% bgcolor=E0E0E0><font size=-1> 1-5 Average</th>
<th width=50% bgcolor=E0E0E0><font size=-1>1-5 Color Coding</th>
</tr>

<% Else ' If export then put out headers for spreadsheet
	response.write wc_Assigned_Group & vbtab
	response.write "# of Surveys" &  vbtab
	response.write "1-5 Average" &  vbtab
	response.write vbCRLF

 End if ' End of If EXPORTFLAG <> YES
%>

<%
	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN ' Open the connection once here

	'mySQL = "SELECT Result_Detail.Question_ID, Result_Detail.RANGE_ANSWER, Survey_Results.Case_Number, tech_staff.tech_level, tech_staff.first_name, tech_staff.last_name, Survey_Results.Case_Number, cases.case_number, Survey_Results.Survey_Date, tech_staff.tech_id, group_list.group_name, cases.group_number FROM (tech_staff INNER JOIN ((Result_Detail INNER JOIN Survey_Results ON Result_Detail.Results_ID = Survey_Results.Results_ID) INNER JOIN cases ON Survey_Results.Case_Number = cases.case_number) ON tech_staff.tech_id = cases.tech_id) INNER JOIN group_list ON cases.group_number = group_list.group_number "
	'mySQL = "SELECT Result_Detail.Question_ID, Result_Detail.RANGE_ANSWER, Survey_Results.Case_Number,  Survey_Results.Case_Number, cases.case_number, Survey_Results.Survey_Date,  group_list.group_name, cases.group_number FROM (((Result_Detail INNER JOIN Survey_Results ON Result_Detail.Results_ID = Survey_Results.Results_ID) INNER JOIN cases ON Survey_Results.Case_Number = cases.case_number) ) INNER JOIN group_list ON cases.group_number = group_list.group_number "

	mySQL = "SELECT survey.question_ID,	"
	mySQL = mySQL & "group_list.group_Name,  "

	If DatabaseType2 = "SQLSERVER" Then
		mySQL = mySQL & "cast(avg(convert(float,range_answer)) as decimal(10,2)) as av ,"
	Else
		mySQL = mySQL & "format(avg(range_answer),'fixed') as av, "
	End If

   mySQL = mySQL & " count(range_answer) as cnt "
	mySQL = mySQL & "from ((((result_detail "
	mySQL = mySQL & "left join survey_results on result_detail.results_id = survey_results.results_ID) "
	mySQL = mySQL & "left join survey on result_detail.question_ID = survey.Question_ID) "
	mySQL = mySQL & "left join cases on survey_results.case_number = cases.case_number) "
	mySQL = mySQL & "left join group_list on cases.group_number = group_list.group_number) "

	mySQL = mySQL & WhereStatement

	'DEBUG
	'response.write mysql
	'response.flush
'response.end

	set rstemp=Server.CreateObject("adodb.Recordset")
	rstemp.open mySQL, conntemp, adopenstatic

	If  rstemp.eof then ' Check to see if any open Cases
%>
		<% If ExportFlag <> "YES" Then
		%>
			<tr><td colspan=4 align=center><font size=-1><B> No Matching Surveys Found Found </b></font></td></tr>
		<%Else
				response.write "No 	Matching Surveys Found"
		 End IF

	Else ' Must be one or more surveys that fit the criteria

		do while not rstemp.eof
				SurveyAvg = rstemp("av")
				SurveyCount = rstemp("cnt")
				if NOT isnull(rstemp("Group_Name")) Then
					Group_Name = rstemp("Group_Name")
	         	Else
	         group_Name = "Not Assigned"
	         end if

	 			If ExportFlag <> "YES" Then
		%>

			<tr>
			<td align=left><font size=-1><%=Group_Name%>
			</td>
			<td align=center><font size=-1><a href=SurveyReportDetailsByTechGroup.asp?Group_Number=<%=Group_Number%>&Question_ID=<%=Question_ID%>><%=SurveyCount%>
			</td>

			<% ' Calculate Survey Average

				'SurveyAvg = SurveyTotal/SurveyCount
	%>
			<td align=center><font size=-1><%=SurveyAvg%>
			</td>
	<%
			if isnull(rstemp("av")) then
			  Color="BLACK"
			Else
				more=CSng(SurveyAvg)

				GraphicSize = 50*more




				surveyavg = cint(surveyavg)
				'SurveyAvgColor = Int(SurveyAvg)
				If SurveyAvg >  4 Then
					Color="GREEN"
				Else
					If SurveyAvg >  3 Then
						Color="BLUE"
					Else
						If SurveyAvg > 2 Then
							Color="PURPLE"
						Else
							If SurveyAvg >  1 Then
								Color="YELLOW"
							Else
							'	If SurveyAvg = 1 Then
									Color="RED"
								'End If
							end if
						end if
					end if
				end if
			end if
			%>

			<td bgcolor=FFFFFF><font size=-1>
			<%' Build a table graphic with color and fixed size %>
			<table><tr><td bgcolor=<%=color%>  width=<%=GraphicSize%> ><font size=-1>&nbsp</td></tr></table>
			</td>
			</tr>

		<% Else ' EXPORT this row
				response.write Group_Name &vbtab  ' 12/10/13 used to be techfullname
				response.write SurveyCount & vbtab

			'	SurveyAvg = SurveyTotal/SurveyCount
				response.write SurveyAvg & vbtab
				response.write vbCRLF
		 	End IF

			rstemp.movenext
		loop

 IF ExportFlag <> "YES" Then
%>


<tr><td font size=-2 colspan=4>
</td>
</tr>

<tr>
<td colspan=4>
<table>
<tr>
<td>Color Coding Legend: </td>

<td bgcolor=RED>&nbsp;&nbsp;&nbsp;1&nbsp;&nbsp;&nbsp; </td>
<td bgcolor=YELLOW>&nbsp;&nbsp;&nbsp;2&nbsp;&nbsp;&nbsp; </td>
<td bgcolor=PURPLE>&nbsp;&nbsp;&nbsp;3&nbsp;&nbsp;&nbsp; </td>
<td bgcolor=BLUE>&nbsp;&nbsp;&nbsp;4&nbsp;&nbsp;&nbsp; </td>
<td bgcolor=GREEN>&nbsp;&nbsp;&nbsp;5&nbsp;&nbsp;&nbsp; </td>

</tr>
</table>
</td>
</tr>


</table>
<P>
<center>
<a href=Reports.asp><img src=/<%=WCLanguageDirectory%>/ts_reports21x120.gif border=0></a>
</center>

<% End IF ' Endof ExportFlag <> YES
 End If ' End of if eof

 IF ExportFlag <> "YES" Then
%>

</body>
</html>

<% End If ' no survey questions found
End If
%>

<% SUB DisplayQuestions(ID)
	set conntemp=server.createobject("adodb.connection")

	conntemp.open myDSN ' Open the connection once here
'	mySQL2="select * from Survey where question_Type = 1 Order by Question_Order "  ' where active = true and questiontype = 1
   if databaseType2 = "SQLSERVER" then
		mySQL2="select * from Survey where question_Type = 1 and active = 'true' Order by Question_Order "  ' where active = true and questiontype = 1
   Else
		mySQL2="select * from Survey where question_Type = 1 and active = true Order by Question_Order "  ' where active = true and questiontype = 1
   End If

	set rstemp = server.createobject("adodb.recordset")
	rstemp.open mySQL2, conntemp, 1,3

	If rstemp.EOF   Then
%>
	<option value="">No Survey Questions Defined</option>
<%
	Else
      Question_Found = "YES"
		Do While NOT rstemp.EOF

			Active = Rstemp("Active")  ' active not checked
			Survey_Question = rstemp("Survey_Question")
			If Len(Survey_Question) > 37 Then
				Short_Question = Mid(Survey_Question, 1, 37) ' Shorten version
				Short_Question = Short_Question & "..."
			Else
				Short_Question = Survey_Question
			End If

			Question_Type = rstemp("Question_Type")
			Question_ID = rstemp("Question_ID")
			Question_Order = rstemp("Question_Order")

			If First_Question_ID = "" Then  ' WAS <> ""
				First_Question_ID = Question_ID ' Only grab the first one for the default case
			End If

			IF First_Survey_Question = "" Then
				First_Survey_Question  = Survey_Question ' Pick up a default survey question
			End IF

	' Show selected if passed one question_ID from form
	If cint(ID) = Question_ID Then
%>
		<option value="<%=Question_ID%>" SELECTED><%=Short_Question%></option>
<% Else %>
		<option value="<%=Question_ID%>"><%=Short_Question%></option>
<% End If%>

<%
	rstemp.MoveNext
	Loop

		If Question_Found <> "YES" Then%>
			<option>No 1-5 Type Questions Found</option>

<%		End If
	End If

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

End Sub
%>

<% Sub DisplayGroups(sID) %>

<SELECT size=1 name=group_number>
<option value=0>All Tech Groups</option>

<% ' Get the Groups from the database

	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL="select * from Group_list Order by Group_Name"
	set rstemp=conntemp.execute(mySQL)

	Do While NOT rstemp.EOF
		If CInt(rstemp("Group_Number")) = CInt(Group_number) Then
			response.write "<option value=" & rstemp("group_number") & " SELECTED>" & rstemp("group_name") & "</option>" & chr(10) & chr(13)
		Else
			response.write "<option value=" & rstemp("group_number") & ">" & rstemp("group_name") & "</option>" & chr(10) & chr(13)
		End IF

		rstemp.MoveNext
	Loop

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

 ' End of Display the Group List
End Sub %>