<% 'Module: TechReport.asp

   'Description: This module is the search engine first page.
   '(C) 1999, 2000, 2001, 2002 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '2/15/00	SAV		Created original Search page
   '07/21/2011 CMB  Cleaned up; UK date compliance
   '03/27/12   CMB  Added 'date modified' to date fields

   'NOTE THIS REPORT shows ...uses last modified date

	' CONSTANTS
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->
<!-- #INCLUDE FILE="Reports.inc" -->

<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 2 ' Allow any tech  to access this function.

	ValidUser = IsValidUser (TechLevel)

 ' End of ASP page security checks
 %>

<% if ValidUser <> "YES" Then %>
	<% ASPPage = "Search.asp"%>

	<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function %>

<% 'Get the value of the User Screen background color from the Configuration Table
    call  GetConfig(DateDisplayFormat,UserPageColor,DatabaseType)
%>

<% 'First Show the Report Menu at the top of the page
%>

<html>

<head>
<title><%=wc_Tech_Report%></title>
<!-- #INCLUDE FILE="Stylesheet.inc" -->
</head>

<body class=rightwindow>
<center>

<% ' Get the tech cookie or this page is called from the supervisors report,
	' it passed a request.querystring variable called xyztech.  This will
	' override the cookie value

	CookieID = Request.Querystring("xyztech")

	If CookieID = "" Then ' check if cookieID not set so use cookie
		CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN")
	End If

	'Start_Date and End_Date may be passed from supervisor report

	Start_Date = Request.Querystring("Start_Date")
	End_Date = Request.Querystring("End_Date")

	'If Start_Date <> "" THen
		' replace the *'s with the slashes
		'Start_Date = replace (Start_date, "*", "/")
	'End IF

	'If End_Date <> "" THen
		' replace the *'s with the slashes
	'	End_Date = replace( End_date, "*", "/")
	'End IF

' Get the Logged TechID from the cookie
FullTechName = GetTechName(CookieID)
%>

<center>
<table class=BGWrapper>
<tr>
<td class=MinorScreenTitle><%=wc_Technician_Report_For%>  </td>
<td class=TitleInsert>&nbsp;<%=FullTechName%>&nbsp;</td>

</tr>
</table>

<FORM METHOD=POST ACTION=DoTechReport.asp>

<center>

<input type=hidden value="BRIEF" name=resultsview >

<% ' Display the Form questions at the bottom of the page %>
<center>
<p>
<TABLE BORDER=0 CELLPADDING=3 cellspacing=0 class=innerformwrapper>

<TR>

<td class=lightline width=3></td>
<TD  align=right class=formlabelsuper><B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=wc_Start_date%>:
</b><br>(<%=wc_date%>&nbsp;<%=wc_modified%>)</td>
<td class=formboxholder>
	<span class=tinyprint>
<% if datedisplayformat = "DDMMYYYY" then
		response.write "(dd/mm/yyyy)"
	else
		response.write "(mm/dd/yyyy)"
	end if
%>
	</span><br>
	<INPUT type=text name=start_date size=11 maxlength=10 value="<%=Start_Date%>">
</TD>
<td class=lightline width=3></td>

<TD   align=right class=formlabelsuper><B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=wc_End_date%>:</b>
<br>(<%=wc_date%>&nbsp;<%=wc_modified%>)</td>

<td class=formboxholder>

	<span class=tinyprint>
<% if datedisplayformat = "DDMMYYYY" then
		response.write "(dd/mm/yyyy)"
	else
		response.write "(mm/dd/yyyy)"
	end if
%>
	</span><br>
	<INPUT type=text name=end_date size=11 maxlength=10 value="<%=End_Date%>">
</TD>
<td class=lightline width=3></td>

<TD valign=bottom class=formboxholder align=center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<input type=image src="/<%=WCLanguageDirectory%>/ts_submit30x80.gif" name=b_submit border=0>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<input type=hidden name=date_type value=1>
</TD>

<td class=lightline width=3></td>
</TR>
</TABLE>

<hr>
<input type=hidden name=tech_id value="<%=CookieID%>">

</FORM>

</BODY>
</HTML>

<%End If ' End of security check %>

<% Function GetTechName(Passed_Tech_ID)
' This function returns the name of the tech from the Tech_ID

	set conntemp=server.createobject("adodb.connection")

	conntemp.open myDSN ' Open the connection once here

	mySQL2="select * from Tech_staff where Tech_ID = '" & Passed_Tech_ID & "'"

	set rstemp2=conntemp.execute(mySQL2)

	' Check to see if any records are returned
	' if none found then login fails.
	if rstemp2.EOF then
		GetTechName = "Tech (" & Passed_tech_id & ") No Longer Registered" ' Tech may no longer exist in the database
	Else
		GetTechName = rstemp2("first_name") & " " & rstemp2("last_name")
	End If

	rstemp2.close
	set rstemp2=nothing
	conntemp.close
	Set Conntemp = Nothing

End Function
%>
