<% 'Module: TimeToCloseByCategory.asp

   'Description: This module is the basic report module from which other report
   ' modules can be built from.
   ' This page can be customized by the user to either add custom
   ' reports or to modify the Tech+Center Control Status Panel.
   ' Please refer to the Web+Center user documentation on how to
   ' modify this script.  This should only be done by advanced system
   ' users and all changes should be carefully changed.  Any code that
   ' updates the database will not be supported without additional
   ' cost from Internet Software Sciences.  Persons adding to this code
   ' should be familar with the ASP programming and how to access a
   ' database from the ASP progamming scripting language.

   '(C) 1999, 2000, 2001-2007 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '9/09/99	SAV		Created original OpenCasesByTech.asp page
   '10/5/01 SAV		Create originalOpenCasesByCustoerByDate.asp module
   '10/6/01 SAV		Created CasesByCategory.asp module
   '3/15/05	SAV		Created AvgTimeToCloseByGroup.asp
   '03/21/07 SAV	Created TimeToCloseByCategory.asp - Special version for Mako Surgical
   '08/05/2011 CMB  Cleaned up; UK date compliance; added PadDate

	' CONSTANTS

		' Important - This defines what category to use to created the report.

		CategoryColumn  = "C4"
		CategoryColumnNumber = 4
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="db_define.inc" -->
<!-- #INCLUDE FILE="../language/wcLabels.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>

<!-- #INCLUDE FILE="ADOVBS.INC" -->
<!-- #INCLUDE FILE="Reports.inc" -->

<html>

<head>
<% wc_Time_To_Close_By_Category = "Time To Close By Category"%>
<title><%=wc_Time_To_Close_By_Category%></title>
</head>

<% 'Get the value of the User Screen background color from the Configuration Table
    call  GetConfig(DateDisplayFormat,UserPageColor,DatabaseType)
%>

<% ' Now see if this page is getting called as form submit with date filter
	'criteria.  If it is then we need to grab that data and put it into the
	'the date range fields.

		Start_Date = Request.form("Start_date")
		End_Date = Request.form("End_Date")
%>

<body bgcolor="<%=UserPageColor%>">
<center>
<table border=1 width=95%>
<tr>
<td align=center bgcolor=F0F0BO>
<font size=-1><%=wc_CASE_REPORT%></font>
</td>
<td bgcolor=F0E0F0 align=center>
<font size=+1><%=wc_Time_To_Close_By_Category%>&nbsp; <%=CategoryColumnNumber%></font>
<font size=-2><br>This report shows cases in Category <%=CategoryColumnNumber%> (can be easily modified by programmer) <br>opened between start and
end date range broken down by item.</font>

</td>
<td align=center bgcolor=B0F0F0>
<font size=-1><%=Now%></font>
</td>

</tr></table>

</center>

<form action=TimeToCloseByCategory.asp method=post>

<center>
<table border=1 WIDTH="95%" >
<TR>
<TD ALIGN=CENTER bgcolor=C0F0E0>
<TABLE BORDER=0 CELLPADDING=7 WIDTH="90%" >
<TR>
<TD valign=top><B><FONT SIZE=-1><%=wc_Start_date%>:</FONT></b><br>
<font size=-2>
<% if datedisplayformat = "DDMMYYYY" then
		response.write "(dd/mm/yyyy)"
	else
		response.write "(mm/dd/yyyy)"
	end if
%>
<br></font>
<font size=-1>
<INPUT type=text name=start_date size=11 maxlength=10 value="<%=Start_Date%>"></TD>

<TD valig=top><B><FONT SIZE=-1><%=wc_End_date%>:</font></b><br>
<font size=-2>
<% if datedisplayformat = "DDMMYYYY" then
		response.write "(dd/mm/yyyy)"
	else
		response.write "(mm/dd/yyyy)"
	end if
%>
<br></FONT>
<font size=-1>
<INPUT type=text name=end_date size=11 maxlength=10 value="<%=End_Date%>"></TD>
</font></TD>

<td valign=middle>
<INPUT type=image name=b_search src=/<%=WCLanguageDirectory%>/ts_submit30x80.gif border=0></TD>
</TR>
</TABLE>
</TD>
</TR>
</table>
</center>

<P>
</form>

<% ' Create the query based on the entered date range if they entered any data
		WhereStatement = ""
		AndText = ""

		If Start_Date <> "" Then
			Start_Date = PadDate(Start_Date)
			NewStartDate = MakeYYYYMMDD(Start_date,DateDisplayFormat)
			WhereStatement = " Cases.Open_Date  >= '" & NewStartDate & "'"
			AndText = " AND "
		End if

		If End_date <> "" Then
			End_Date = PadDate(End_Date)
			NewEndDate = MakeYYYYMMDD(End_date,DateDisplayFormat)
			WhereStatement = WhereStatement & AndText & " Cases.Open_Date  <= '" & NewEndDate & "'"
			AndText = " AND "
		End IF

	'	If WhereStatement <> "" Then
			'WhereStatement = " Where Status = 1  AND " & WhereStatement
		'Else
		'	WhereStatement = " Where Status = 1 "
		'End IF

		' Add in additional code to select only certain cases for specific category settings

	' *********************FIRST QUERY********** START **********************

		FinalWhereStatement =  WhereStatement & AndText &  " Cases." & CategoryColumn & " = 1"

		' We are looking for both open and closed cases.

		If FinalWhereStatement <> "" Then
			FinalWhereStatement = "  From cases Where " & FinalWhereStatement
		End IF

		' Add order by clause

		'FinalWhereStatement = FinalWhereStatement & " Order by cases.Open_Date, Open_Time"
%>

<%' First get all of the cases total count since we will need that for our percentage calculation

	sqltemp= "select Count(Case_Number) as cnt  " & FinalWhereStatement

	set conn=server.createobject("adodb.connection")
	conn.open myDSN
	set rstemp=Server.CreateObject("adodb.Recordset")

	rstemp.open sqltemp, conn, adopenstatic
	TotalCategoryCases = rstemp("cnt")
	rstemp.close
	set rstemp=nothing
%>

<center>

<% CategoryName = GetCategoryName(CategoryColumnNumber)
	ItemName = GetCategoryItemName(CategoryColumnNumber, 1)
%>

<B><%=CategoryName%> - <%=ItemName%></b><br>

<table width=95% border = 1>
<tr>
<th width=30% bgcolor=F8F8F8><font size=-1>Description</th>
<th width=10% bgcolor=F8F8F8><font size=-1> # of Cases </th>
<th width=10% bgcolor=F8F8F8><font size=-1> % of Total</th>
<th width=10% bgcolor=F8F8F8><font size=-1> Avg (Hours)</th>
<th width=10% bgcolor=F8F8F8><font size=-1> Graphical Percentage of Total</th>

</tr>

<%' Now step through data set and record counts in variables %>

<%
	sqltemp= "select * " & FinalWhereStatement
	set rstemp=Server.CreateObject("adodb.Recordset")
	rstemp.open sqltemp, conn, adopenstatic

	' Check to see if any records are returned
	' if none found then login fails.

	If  rstemp.eof then ' Check to see if any open cases
		Closedinside24Hours = 0
		Closedoutside24hours = 0
		StillOpenOutside24Hours = 0
		StillOpenInside24Hours = 0
		Percentage = 0
		TablePercentage = 0
		AvgValue = 0
		TotalCases = 0
	Else
		Closedinside24Hours = 0
		Closedoutside24hours = 0
		StillOpenOutside24Hours = 0
		StillOpenInside24Hours = 0
		Percentage = 0
		TablePercentage = 0
		AvgValue = 0
		TotalCases = 0

		do while not rstemp.eof

			' Pull out Start time and end time

			open_date = rstemp("Open_date")
			Open_time = rstemp("Open_Time")
			Mod_date = rstemp("mod_date")
			Mod_Time = rstemp("mod_time")
'
			If rstemp("Status") = 1 Then ' Compute the time if status = 1 (closed)

				HoursToClose = ComputeHourDifference(open_time, open_date, mod_Time, mod_date)

	'			'debugging
			'	response.write "AVGHours = " & AvgHours & "<br>"

				If HoursToClose < 24 Then
					ClosedInside24Hours = ClosedINside24Hours + 1
					TotalHoursToCloseInside24 = HoursToClose + TotalHoursToCloseInside24
				End IF

				If HoursToClose >= 24 Then
					ClosedOutside24Hours = CLosedOutside24Hours + 1
					TotalHoursToCloseOutside24 = TotalHoursToCloseOutside24 + HoursToClose
				End If

				TotalHoursToClose = TotalHoursToClose + HoursToClose
				TotalClosedCases = TotalClosedCases + 1

			End IF ' STatus = closed

			If rstemp("Status") <> 1 THen
					HoursFromOpen = ComputeHourDifference(open_time, open_date, mod_Time, mod_date)

					If HoursFromOpen < 24 Then
						StillOpenInside24Hours = StillOpenInside24Hours + 1
					End IF

					IF HoursFromOpen >= 24 THen
						StillOpenOutside24hours  = StillOpenOutside24Hours + 1
					End IF
			End IF

			TotalCases = TotalCases + 1
			rstemp.movenext
	loop

	' Display the results

	'Compute values
	Percentage = (ClosedInside24Hours/TotalCases)*100
	AvgValue = TotalHoursToCloseInside24/TotalClosedCases
	TablePercentage  = (ClosedInside24Hours/TotalCases)*200
%>

<tr>

<td><font size=-1>
Total Cases</td>
<td><font size=-1><%=TotalCases%></td>
<td><font size=-1>100%</td>
<td><font size=-1>-</td>

<td><font size=-1>
<table bgcolor=RED width=200><tr><td></td></tr></table>
</td>
</tr>

<tr>
<td><font size=-1>Closed within 24  hours</td>
<td><font size=-1><%=ClosedInside24Hours%></td>
<td><font size=-1><%=Round(Percentage,2) %></td>
<td><font size=-1><%=Round(AvgValue,2)%></td>

<td><font size=-1>
<table bgcolor=RED width=<%=TablePercentage %>><tr><td></td></tr></table>
</td>
</tr>

<% 'Compute outside of 24 hours

	Percentage = (ClosedOutside24Hours/TotalCases)*100
	AvgValue = TotalHoursToCloseOutside24/TotalClosedCases
	TablePercentage  = (ClosedOutside24Hours/TotalCases)*200
%>

<tr>

<td><font size=-1>
Closed outside of 24  hours</td>
<td><font size=-1><%=ClosedOutside24Hours%></td>
<td><font size=-1><%=Round(Percentage,2) %></td>
<td><font size=-1><%=Round(AvgValue,2)%></td>

<td><font size=-1>
<table bgcolor=RED width=<%=TablePercentage %>><tr><td></td></tr></table>
</td>
</tr>

<% 'Compute outside of 24 hours

	Percentage = (StillOpenOutside24Hours/TotalCases)*100
	AvgValue = TotalHoursToClose/TotalCases
	TablePercentage  = (StillOpenOutside24Hours/TotalCases)*200
%>

<tr>

<td><font size=-1>
Still Open Outside of 24  hours
</td>
<td><font size=-1><%=StillOpenOutside24Hours%>
</td>
<td><font size=-1><%=Round(Percentage,2) %>
</td>
<td><font size=-1>-</td>

<td><font size=-1>
<table bgcolor=RED width=<%=TablePercentage %>><tr><td></td></tr></table>
</td>
</tr>

<% 'Compute inside of 24 hours and still open

	Percentage = (StillOpenInside24Hours/TotalCases)*100
	AvgValue = TotalHoursToClose/TotalCases
	TablePercentage  = (StillOpenInside24Hours/TotalCases)*200
%>

<tr>

<td><font size=-1>
Still Open inside of 24  hours</td>
<td><font size=-1><%=StillOpenInside24Hours%></td>
<td><font size=-1><%=Round(Percentage,2) %></td>
<td><font size=-1>-</td>

<td><font size=-1>
<table bgcolor=RED width=<%=TablePercentage %>><tr><td></td></tr></table>
</td>
</tr>

</table>
</td>
</tr>

<% End If ' Do not display last if no items or only one row %>
<%
	rstemp.close ' Close the record set and the connection
	set rstemp=nothing
'	conntemp.close ' Close the connection
'	set conntemp=nothing
%>
	<%' Close the Table %>

</table>
</center>

<% ' ******************* END OF FIRST QUERY *************************** %>

<%	' *********************SECOND QUERY - Mid Term ********** START **********************

		FinalWhereStatement =  WhereStatement & AndText &  " Cases." & CategoryColumn & " = 2"

		' We are looking for both open and closed cases.

		If FinalWhereStatement <> ""Then
			FinalWhereStatement = " From cases Where "& FinalWhereStatement
		End IF

		' Add order by clause

		'FinalWhereStatement = FinalWhereStatement & " Order by cases.Open_Date, Open_Time"
%>

<%' First get all of the cases total count since we will need that for our percentage calculation

	sqltemp= "select Count(Case_Number) as cnt " & FinalWhereStatement

	set conn=server.createobject("adodb.connection")
	conn.open myDSN
	set rstemp=Server.CreateObject("adodb.Recordset")

	rstemp.open sqltemp, conn, adopenstatic
	TotalCategoryCases = rstemp("cnt")
	rstemp.close
	set rstemp=nothing
%>

<br>
<center>

<% CategoryName = GetCategoryName(CategoryColumnNumber)
	ItemName = GetCategoryItemName(CategoryColumnNumber, 2)
%>

<B><%=CategoryName%> - <%=ItemName%></b><br>

<table width=95% border = 1>
<tr>
<th width=30% bgcolor=F8F8F8><font size=-1>Description</th>
<th width=10% bgcolor=F8F8F8><font size=-1> # of Cases </th>
<th width=10% bgcolor=F8F8F8><font size=-1> % of Total</th>
<th width=10% bgcolor=F8F8F8><font size=-1> Avg (Hours)</th>
<th width=10% bgcolor=F8F8F8><font size=-1> Graphical Percentage of Total</th>
</tr>

<%' Now step through data set and record counts in variables %>

<% ' Get all open cases, sort by Tech ID and count for each tech and then
	' compute what percentage that Tech ID has and then display it graphically
	'
	sqltemp= "select *  " & FinalWhereStatement
	set rstemp=Server.CreateObject("adodb.Recordset")
	rstemp.open sqltemp, conn, adopenstatic

	' Check to see if any records are returned

	If  rstemp.eof then ' Check to see if any open cases

		Closedinside24Hours = 0
		Closedoutside24hours = 0
		StillOpenOutside24Hours = 0
		StillOpenInside24Hours = 0

		Percentage = 0
		TablePercentage = 0
		AvgValue = 0
		TotalHoursToCloseInside24 = 0
		TotalHoursToCloseOutside24 = 0

	Else

		Closedinside24Hours = 0
		Closedoutside24hours = 0
		StillOpenOutside24Hours = 0
		StillOpenInside24Hours = 0

		Percentage = 0
		TablePercentage = 0
		AvgValue = 0
		TotalHoursToCloseInside24 = 0
		TotalHoursToCloseOutside24 = 0

		TotalCases = 0

		do while not rstemp.eof

			' Pull out Start time and end time

			open_date = rstemp("Open_date")
			Open_time = rstemp("Open_Time")
			Mod_date = rstemp("mod_date")
			Mod_Time = rstemp("mod_time")
'
			If rstemp("Status") = 1 Then ' Compute the time if status = 1 (closed)

				HoursToClose = ComputeHourDifference(open_time, open_date, mod_Time, mod_date)

	'			'debugging
			'	response.write "AVGHours = " & AvgHours & "<br>"

				If HoursToClose < 72 Then
					ClosedInside24Hours = ClosedINside24Hours + 1
					TotalHoursToCloseInside24 = HoursToClose + TotalHoursToCloseInside24
				End IF

				If HoursToClose >= 72 Then
					ClosedOutside24Hours = CLosedOutside24Hours + 1
					TotalHoursToCloseOutside24 = TotalHoursToCloseOutside24 + HoursToClose
				End If

				TotalHoursToClose = TotalHoursToClose + HoursToClose
				TotalClosedCases = TotalClosedCases + 1

			End IF ' STatus = closed

			If rstemp("Status") <> 1 THen
					HoursFromOpen = ComputeHourDifference(open_time, open_date, mod_Time, mod_date)

					If HoursFromOpen < 72 Then
						StillOpenInside24Hours = StillOpenInside24Hours + 1
					End IF

					IF HoursFromOpen >= 72 THen
						StillOpenOutside24hours  = StillOpenOutside24Hours + 1
					End IF
			End IF

			TotalCases = TotalCases + 1

			rstemp.movenext
	loop

	' Display the results

	'Compute values
	Percentage = (ClosedInside24Hours/TotalCases)*100
	AvgValue = TotalHoursToCloseInside24/TotalClosedCases
	TablePercentage  = (ClosedInside24Hours/TotalCases)*200
%>

<tr>

<td><font size=-1>
Total Cases</td>
<td><font size=-1><%=TotalCases%></td>
<td><font size=-1>100%</td>
<td><font size=-1>-</td>

<td><font size=-1>
<table bgcolor=RED width=200><tr><td></td></tr></table>
</td>
</tr>

<tr>

<td><font size=-1>
Closed within 72  hours</td>
<td><font size=-1><%=ClosedInside24Hours%></td>
<td><font size=-1><%=Round(Percentage,2) %></td>
<td><font size=-1><%=Round(AvgValue,2)%></td>

<td><font size=-1>
<table bgcolor=RED width=<%=TablePercentage %>><tr><td></td></tr></table>
</td>
</tr>

<% 'Compute outside of 24 hours

	Percentage = (ClosedOutside24Hours/TotalCases)*100
	AvgValue = TotalHoursToCloseOutside24/TotalClosedCases
	TablePercentage  = (ClosedOutside24Hours/TotalCases)*200
%>

<tr>

<td><font size=-1>
Closed outside of 72  hours</td>
<td><font size=-1><%=ClosedOutside24Hours%></td>
<td><font size=-1><%=Round(Percentage,2) %></td>
<td><font size=-1><%=Round(AvgValue,2)%></td>

<td><font size=-1>
<table bgcolor=RED width=<%=TablePercentage %>><tr><td></td></tr></table>
</td>
</tr>

<% 'Compute outside of 24 hours

	Percentage = (StillOpenOutside24Hours/TotalCases)*100
	AvgValue = TotalHoursToClose/TotalCases
	TablePercentage  = (StillOpenOutside24Hours/TotalCases)*200
%>

<tr>

<td><font size=-1>
Still Open Outside of 72  hours</td>
<td><font size=-1><%=StillOpenOutside24Hours%></td>
<td><font size=-1><%=Round(Percentage,2) %></td>
<td><font size=-1>-</td>

<td><font size=-1>
<table bgcolor=RED width=<%=TablePercentage %>><tr><td></td></tr></table>
</td>
</tr>

<% 'Compute inside of 24 hours and still open

	Percentage = (StillOpenInside24Hours/TotalCases)*100
	AvgValue = TotalHoursToClose/TotalCases
	TablePercentage  = (StillOpenInside24Hours/TotalCases)*200
%>

<tr>

<td><font size=-1>
Still Open inside of 72  hours</td>
<td><font size=-1><%=StillOpenInside24Hours%></td>
<td><font size=-1><%=Round(Percentage,2) %></td>
<td><font size=-1>-</td>

<td><font size=-1>
<table bgcolor=RED width=<%=TablePercentage %>><tr><td></td></tr></table>
</td>
</tr>

</table>
</td>
</tr>

<% End If ' Do not display last if no items or only one row %>

<%
	rstemp.close ' Close the record set and the connection
	set rstemp=nothing
'	conntemp.close ' Close the connection
'	set conntemp=nothing
%>

	<%' Close the Table %>

</table>

<% ' ******************* END OF SECOND QUERY *************************** %>



<%	' *********************THIRD QUERY - Mid Term ********** START **********************

		'FinalWhereStatement =  WhereStatement & AndText &  " Cases.C5  = 3"

		FinalWhereStatement =  WhereStatement & AndText &  " Cases." & CategoryColumn & " = 3"

		' We are looking for both open and closed cases.
		If FinalWhereStatement <> "" Then
			FinalWhereStatement = " FROM CASES Where " & FinalWhereStatement
		End IF

		' Add order by clause

		'FinalWhereStatement = FinalWhereStatement & " Order by cases.Open_Date, Open_Time"
%>
<%' First get all of the cases total count since we will need that for our percentage calculation

	sqltemp= "select Count(Case_Number) as cnt " & FinalWhereStatement

	set conn=server.createobject("adodb.connection")
	conn.open myDSN
	set rstemp=Server.CreateObject("adodb.Recordset")

	rstemp.open sqltemp, conn, adopenstatic
	TotalCategoryCases = rstemp("cnt")
	rstemp.close
	set rstemp=nothing
%>

<br>

<center>

<% CategoryName = GetCategoryName(CategoryColumnNumber)
	ItemName = GetCategoryItemName(CategoryColumnNumber, 3)
%>

<B><%=CategoryName%> - <%=ItemName%></b><br>

<table width=95% border = 1>
<tr>
<th width=30% bgcolor=F8F8F8><font size=-1>Description</th>
<th width=10% bgcolor=F8F8F8><font size=-1> # of Cases </th>
<th width=10% bgcolor=F8F8F8><font size=-1> % of Total</th>
<th width=10% bgcolor=F8F8F8><font size=-1> Avg (Hours)</th>
<th width=10% bgcolor=F8F8F8><font size=-1> Graphical Percentage of Total</th>
</tr>

<%' Now step through data set and record counts in variables %>

<% ' Get all open cases, sort by Tech ID and count for each tech and then
	sqltemp= "select *  " & FinalWhereStatement
	set rstemp=Server.CreateObject("adodb.Recordset")
	rstemp.open sqltemp, conn, adopenstatic

	If  rstemp.eof then ' Check to see if any open cases
		Closedinside24Hours = 0
		Closedoutside24hours = 0
		StillOpenOutside24Hours = 0
		StillOpenInside24Hours = 0

		Percentage = 0
		TablePercentage = 0
		AvgValue = 0
		TotalHoursToCloseInside24 = 0
		TotalHoursToCloseOutside24 = 0

	Else

		Closedinside24Hours = 0
		Closedoutside24hours = 0
		StillOpenOutside24Hours = 0
		StillOpenInside24Hours = 0

		Percentage = 0
		TablePercentage = 0
		AvgValue = 0
		TotalHoursToCloseInside24 = 0
		TotalHoursToCloseOutside24 = 0

		TotalCases = 0

		do while not rstemp.eof

			' Pull out Start time and end time

			open_date = rstemp("Open_date")
			Open_time = rstemp("Open_Time")
			Mod_date = rstemp("mod_date")
			Mod_Time = rstemp("mod_time")
'
			If rstemp("Status") = 1 Then ' Compute the time if status = 1 (closed)

				HoursToClose = ComputeHourDifference(open_time, open_date, mod_Time, mod_date)
	'			'debugging
			'	response.write "AVGHours = " & AvgHours & "<br>"

				ClosedInside24Hours = ClosedINside24Hours + 1
				TotalHoursToCloseInside24 = HoursToClose + TotalHoursToCloseInside24
				TotalHoursToClose = TotalHoursToClose + HoursToClose
				TotalClosedCases = TotalClosedCases + 1

			End IF ' STatus = closed

			If rstemp("Status") <> 1 THen
					HoursFromOpen = ComputeHourDifference(open_time, open_date, mod_Time, mod_date)
					StillOpenOutside24hours  = StillOpenOutside24Hours + 1
			End IF

			TotalCases = TotalCases + 1
			rstemp.movenext
	loop

	' Display the results

	'Compute values
	Percentage = (ClosedInside24Hours/TotalCases)*100
	AvgValue = TotalHoursToCloseInside24/TotalClosedCases
	TablePercentage  = (ClosedInside24Hours/TotalCases)*200
%>

<tr>

<td><font size=-1>
Total Cases</td>
<td><font size=-1><%=TotalCases%></td>
<td><font size=-1>100%</td>
<td><font size=-1>-</td>

<td><font size=-1>
<table bgcolor=RED width=200><tr><td></td></tr></table>
</td>
</tr>

<tr>

<td><font size=-1>
Closed Cases
</td>
<td><font size=-1><%=ClosedInside24Hours%></td>
<td><font size=-1><%=Round(Percentage,2) %></td>
<td><font size=-1><%=Round(AvgValue,2)%></td>

<td><font size=-1>
<table bgcolor=RED width=<%=TablePercentage %>><tr><td></td></tr></table>
</td>
</tr>

<% 'Compute inside of 24 hours and still open

	Percentage = (StillOpenOutside24Hours/TotalCases)*100
	AvgValue = TotalHoursToClose/TotalCases
	TablePercentage  = (StillOpenOutside24Hours/TotalCases)*200
%>

<tr>
<td><font size=-1>
Cases Still Open
</td>
<td><font size=-1><%=StillOpenOutside24Hours%></td>
<td><font size=-1><%=Round(Percentage,2) %></td><td><font size=-1>-</td>

<td><font size=-1>
<table bgcolor=RED width=<%=TablePercentage %>><tr><td></td></tr></table>
</td>
</tr>

</table>

</td>

</tr>

<% End If ' Do not display last if no items or only one row %>

<%
	rstemp.close ' Close the record set and the connection
	set rstemp=nothing
	conn.close ' Close the connection
	set conn=nothing
%>
	<%' Close the Table %>

</table>

<% ' ******************* END OF THIRD QUERY *************************** %>

<P>
<center>
<a href=reports.asp><img src=/<%=WCLanguageDirectory%>/ts_reports21x120.gif border=0></a>
</center>
</body>
</html>

<% Function GetCategoryItemName(Category_Number, item_number)
' This function returns the item_name for this category from both Category_Number and item_number
	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN
	set rstemp2=Server.CreateObject("adodb.Recordset")

	mySQL2="select * from categories where Category_number = " & Category_Number & " AND Item_Number = " & item_number

	If Item_Number = 0 Then
		GetCategoryItemName = "<B>Category Not Set</b>"
	Else
		set rstemp2=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		if rstemp2.EOF then
			GetCategoryItemName = "<B>Category Setting Disabled</b>"
		Else
			GetCategoryItemName = rstemp2("Item_name")
		End If

		rstemp2.close
		set rstemp2=nothing

	End If
	conntemp.close
	set conntemp = nothing

End Function
%>

<% Function GetCategoryName(Category_Number)
' This function returns the name for this category from Category_Number
	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN
	set rstemp2=Server.CreateObject("adodb.Recordset")

	mySQL2="select * from categories where Category_number = " & Category_Number

	set rstemp2=conntemp.execute(mySQL2)

	' Check to see if any records are returned
	if rstemp2.EOF then
		GetCategoryName = "<B>Category Setting Disabled</b>"
	Else
		GetCategoryName = rstemp2("Category_name")
	End If

	rstemp2.close
	set rstemp2=nothing
	conntemp.close
	set conntemp = nothing

End Function
%>



