
<% 'Module: TodaysStatistics.asp

   'Description: This module is the todays statistics reports page.
   ' This page can be customized by the user to either add custom
   ' reports or to modify the Tech+Center Control Status Panel.
   ' Please refer to the Web+Center user documentation on how to
   ' modify this script.  This should only be done by advanced system
   ' users and all changes should be carefully changed.  Any code that
   ' updates the database will not be supported without additional
   ' cost from Internet Software Sciences.  Persons adding to this code
   ' should be familar with the ASP programming and how to access a
   ' database from the ASP progamming scripting language.

   '(C) 1999 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date		Who		What
   '-------		---		------------------------------------------------
   '9/09/99		SAV		Created original Reports.asp page
   '04/01/02	SAV		Created new TodaysStatistics.asp page
   '08/05/11 CMB    cleaned up a little bit BUT DID NOT REWRITE;

	' CONSTANTS
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->
<!-- #INCLUDE FILE="Reports.inc" -->

<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 5 ' Allow Admins to see this function.
	ValidUser = IsValidUser (TechLevel)
	%>

<% if ValidUser <> "YES" Then %>
	<% ASPPage = "Reports.asp"%>

	<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function %>

<% 'First Show the Report Menu at the top of the page
%>

<html>

<head>
<title><%=wc_Reports%></title>
</head>

<%
    call  GetConfig(DateDisplayFormat,UserPageColor,DatabaseType)
   	call SetLocale(1033) ' need to do this for UK compliance  CMB
%>
<body bgcolor="<%=UserPageColor%>">
<center>
<table border=1 width=95%>
<tr>
<td align=center bgcolor=F0F0BO>
<font size=-1><%=wc_CASE_REPORT%></font>
</td>
<td bgcolor=F0E0F0 align=center>
<font size=+1>System Status</font>
<center>
<font size=-2>This report shows activity for today.
<br>Percentages are based on the number of cases opened today.</font>
</td>
<td align=center bgcolor=B0F0F0>
<font size=-1><%=Now%></font>
</td>

</tr></table>
</center>

<% ' Get the statistics of the Cases

' Get Total number of open cases
	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	sqltemp="select count(Case_Number) as cnt from Cases where status <> 1"
	set rstemp=Server.CreateObject("adodb.Recordset")

	rstemp.open sqltemp, conntemp, adopenstatic
	TotalOpenCases = rstemp("cnt")
	rstemp.close
	set rstemp=nothing
%>

<% ' Closed Cases Today

' Get Total number of closed cases for today

	CurrentDateFormatted = CreateCurrentDateFormatted()

	sqltemp="select count(Case_Number) as cnt from Cases where status = 1 AND Mod_Date = '" & CurrentDateFormatted & "'"
	set rstemp=Server.CreateObject("adodb.Recordset")

	rstemp.open sqltemp, conntemp, adopenstatic
	CasesClosedToday = rstemp("cnt")
	rstemp.close
	set rstemp=nothing
%>

<% ' Cases Opened Today

' Get Total number of open cases for today

	sqltemp="select count(Case_Number) as cnt from Cases where Open_Date = '" & CurrentDateFormatted & "'"
	set rstemp=Server.CreateObject("adodb.Recordset")

	rstemp.open sqltemp, conntemp, adopenstatic
	CasesOpenedToday =  rstemp("cnt")
	rstemp.close
	set rstemp=nothing
%>

<% ' Cases Opened and Closed Today

' Get Total number of open cases for today


	sqltemp="select count(Case_Number) as cnt from Cases where Status = 1 AND Open_Date = '" & CurrentDateFormatted & "'"
	set rstemp=Server.CreateObject("adodb.Recordset")
	rstemp.open sqltemp, conntemp, adopenstatic
	OpenedClosedToday = rstemp("cnt")
	rstemp.close
	set rstemp=nothing

%>

<% ' Cases Opened and still open Today

' Get Total number of open cases for today

	sqltemp="select count(Case_Number) as cnt from Cases where Status <> 1 AND Open_Date = '" & CurrentDateFormatted & "'"
	set rstemp=Server.CreateObject("adodb.Recordset")

	rstemp.open sqltemp, conntemp, adopenstatic
	OpenedstillOpenToday = rstemp("cnt")
	rstemp.close
	set rstemp=nothing
%>

<% ' Cases Opened today, still open, un-assigned to other group other than default

' Get Total number of open cases for today

	' First get the group_number of the default group from the Group_List table

	sqltemp="select Group_Number from Group_list where Default_flag = 1"
	set rstemp=Server.CreateObject("adodb.Recordset")
	rstemp.open sqltemp, conntemp, adopenstatic
	DefaultGroupNumber  = rstemp("Group_Number")
	rstemp.close
	set rstemp=nothing

	' first Cases that are still open for today
	sqltemp="select count(Case_Number) as cnt from Cases where Status <> 1 AND Open_Date = '" & CurrentDateFormatted & "' AND Group_Number = "& DefaultGroupNumber
	set rstemp=Server.CreateObject("adodb.Recordset")
	rstemp.open sqltemp, conntemp, adopenstatic

	CasesUnassignedToGroup = rstemp("cnt")
	rstemp.close
	set rstemp=nothing

%>

<% ' Get Total number of Cases

	sqltemp="select count(Case_Number) as cnt  from Cases"

	set rstemp=Server.CreateObject("adodb.Recordset")
	rstemp.open sqltemp, conntemp, adopenstatic
	TotalCases =  rstemp("cnt")
	rstemp.close
	set rstemp=nothing
%>

<% ' Get Total number of Customers

'	connectMe=myDSN
	sqltemp="select count(Customer_Number) as cnt from Customers"

	set rstemp=Server.CreateObject("adodb.Recordset")
	rstemp.open sqltemp, conntemp, adopenstatic
	TotalCustomers = rstemp("cnt")
	rstemp.close
	set rstemp=nothing

%>

<% ' Get number of available techs

'	connectMe=myDSN
	sqltemp="select count(Tech_ID) as cnt from Tech_staff where availability = 1"
	set rstemp=Server.CreateObject("adodb.Recordset")

	rstemp.open sqltemp, conntemp, adopenstatic
	AvailableStaff = rstemp("cnt")
	rstemp.close
	set rstemp=nothing
%>

<% ' Get number of un-available techs

'	connectMe=myDSN
	sqltemp="select count(Tech_ID) as cnt from Tech_staff where availability <> 1"
	set rstemp=Server.CreateObject("adodb.Recordset")

	rstemp.open sqltemp, conntemp, adopenstatic
	UnAvailableStaff = rstemp("cnt")
	rstemp.close
	set rstemp=nothing

' Now close the database connection
	conntemp.close ' Close the connection
	set conntemp=nothing
%>

<center>
<table width=95% border = 1 cellpadding=3>
<tr>
<th align=center colspan=2 bgcolor=E0E0E0 width=50%><font size=-1>
<%=wc_Case_Summary_Information%></th>
<th align=center colspan=2 bgcolor=E0E0E0 width=50%><font size=-1>
<%=wc_Total_System_Status%></th></tr>

<tr>
<td width=40%><font size=-1>
<b><%=wc_Total_Open_Cases%></b></td>
<td  width=10% align=center>
<font size=-1><%=TotalOpenCases%></td>
<td width=40%><font size=-1><B><%=wc_Total_Customers%></b></td>
<td width=10% align=center><font size=-1> <%=TotalCustomers%></td> </tr>
<tr>

<tr><td width=25%><font size=-1><b><%=wc_Cases_Closed_Today%></b></td>
<td  width=10% align=center><font size=-1><%=CasesClosedToday%></td>

<td><font size=-1><B><%=wc_Total_Number_Of_Cases%></b></td>
<td width=10% align=center><font size=-1><%=TotalCases %></td>
</tr>

<tr><td><font size=-1>
<b><%=wc_Cases_Opened_Today%></b></td>
<td width=10% align=center><font size=-1><%=CasesOpenedToday%></td>

<td><font size=-1><B><%=wc_Available_Tech_staff%></b></td>
<td width=10% align=center><font size=-1> <%=AvailableStaff%></td></tr>

<tr>

<td><font size=-1> </td><td width=10% align=center><font size=-1> </td>
<td><font size=-1><B><%=wc_Busy_Tech_staff%></b></td>
<td width=10% align=center><font size=-1><%=UnAvailableStaff%></td></tr>
</table>
</center>

<hr>

<% ' show graphics of case status %>

<center>
<table width=95% border = 1>

<tr>
<th bgcolor=E0E0E0 align=center><font size=-1><%=wc_Case_Statistics%> </th>
<th bgcolor=E0E0E0 align=center><font size=-1>#</th>
<th bgcolor=E0E0E0 align=center><font size=-1><%=wc_Percent%></th>
<th bgcolor=E0E0E0 align=center><font size=-1><%=wc_Graphical_Percentage%> </th>
</tr>
<tr>
<td width=30%><font size=-1><B><%=wc_Cases_Opened_Today%></b></td>
<td width=10% align=center><font size=-1><%=CasesOpenedToday%></td>
<% If CasesOpenedToday = 0 Then
		Percentage = 0
	Else
 		Percentage = 100
	End If
%>

<td align=center width=10%><font size=-1>
<% if Percentage = 0 Then
	response.write "-"
Else
	response.write int(Percentage) & "%"
End If
%>

</td>
<td width=50%><font size=-1>
<%' Build a table graphic with color and fixed size %>
<table><tr><td bgcolor=red width=<%=Percentage*2%>><font size=-1>&nbsp</td></tr></table>
</td>
</tr>

<tr>
<td width=30%><font size=-1><B><%=wc_Opened_Closed_Today%></b></td>
<td width=10% align=center><font size=-1><%=OpenedClosedToday%></td>
<% If CasesOpenedToday = 0 Then
		Percentage = 0
	Else
 		Percentage = int(100*(OpenedClosedToday/CasesOpenedToday))
	End If
%>
<td align=center width=10%><font size=-1>
<% if Percentage = 0 Then
	response.write "-"
Else
	response.write Percentage & "%"
End If
%>

</td>
<td width=50%><font size=-1>
<%' Build a table graphic with color and fixed size %>
<table><tr><td bgcolor=GREEN width=<%=Percentage*2%>><font size=-1>&nbsp</td></tr></table>
</td>
</tr>

<tr>
<td width=30%><font size=-1><B><%=wc_Opened_Today_Still_Open%></b></td>
<td width=10% align=center><font size=-1><%=OpenedStillOpenToday%></td>
<% If CasesOpenedToday = 0 Then
		Percentage = 0
	Else
 		Percentage = int(100*(OpenedStillOpenToday/CasesOpenedToday))
	End If
%>

<td align=center width=10%><font size=-1>
<% if Percentage = 0 Then
	response.write "-"
Else
	response.write Percentage & "%"
End If
%>

</td>
<td width=50%><font size=-1>
<%' Build a table graphic with color and fixed size %>
<table><tr><td bgcolor=PURPLE width=<%=Percentage*2%>><font size=-1>&nbsp</td></tr></table>
</td>
</tr>

<tr>
<td width=30%><font size=-1><B><%=wc_Assigned_to_Default_Group%></b></td>
<td width=10% align=center><font size=-1><%=Casesunassignedtogroup%></td>
<% If CasesOpenedToday = 0 Then
		Percentage = 0
	Else
 		Percentage = Int(100*(CasesUnassignedToGroup/CasesOpenedToday))
	End If
%>

<td align=center width=10%><font size=-1>
<% if Percentage = 0 Then
	response.write "-"
Else
	response.write Percentage & "%"
End If
%>

</td>
<td width=50%><font size=-1>
<%' Build a table graphic with color and fixed size %>
<table><tr><td bgcolor=YELLOW width=<%=Percentage*2%>><font size=-1>&nbsp</td></tr></table>
</td>
</tr>
</table>
<P>
<center>
<a href=Reports.asp><img src=/<%=WCLanguageDirectory%>/ts_reports21x120.gif border=0></a>
</center>

</body>
</html>


<%End If ' End of security checks %>
