<% 'Module: TopTen.asp

   'Description: This module is the search engine first page.
   '(C) 1999, 2000, 2001, 2002 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '2/15/00	SAV		Created original Search page
   '01/15/02 SAV	Created original TopTen.asp Page from Supervisor Report
   '07/12/2011      UK date formats
   ' note this works now but needs testing;  does it make sense

' NOTE  This report retrieves statistics for logged in tech and also the one with the greatest time spent;
' uses date last modified
	' CONSTANTS
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->
<!-- #INCLUDE FILE="Reports.inc" -->

<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 3 ' Allow all read/write techs and above to access this function.
	ValidUser = IsValidUser (TechLevel)
 %>

<% if ValidUser <> "YES" Then %>
	<% ASPPage = "TopTech.asp"%>

	<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function %>
<%
    call  GetConfig(DateDisplayFormat,UserPageColor,DatabaseType)
    Call GetTimeSpentStuff(TimeSpentCategory,TimeSpentInterval)
    MinutesPerCategory = TimeSpentInterval
  	CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN")

%>

<%
	CurrentDateFormatted = CreateCurrentDateFormatted
	End_Date = CurrentDateFormatted

	Call SetLocale(1033)
	' Start Date is computed by subtracking one month from the current date

	' This ASP modules can be passed different dates as different query strings
	' with parameters like
		'TopTech.asp?interval=month ' One month
		'TopTech.asp?interval=week ' One week (7 days)
		'TopTech.asp?interval=twoweek ' Two weeks (14 days)

		Call SetLocale(1033) ' watch this!  MakeYYYYMMDD uses config date format, dateadd and now uses locale

	Interval = Request.Querystring("Interval")
	If Interval <> "" Then
		If Interval = "month" Then
			NewDate = DateAdd("m", -1, date)
		Elseif Interval = "week" then
			NewDate = DateAdd("d", -7, date)
		Elseif Interval = "twoweek" then
			NewDate = DateAdd("d", -14, date)
		else
			NewDate = DateAdd("m", -1, date)
		End IF
	Else
			NewDate = DateAdd("m", -1, date)
	End If

	NewDate = PadDate(NewDate)
	CurrentDateFormatted = MakeYYYYMMDD(NewDate,"MMDDYYYY")
	Start_Date = CurrentDateFormatted
%>
<html>

<head>
<title><%=wc_Top_Tech_Report%></title>
</head>

<body bgcolor="<%=UserPageColor%>">

<center>
<table border=1 width=95%>
<tr>
<td align=center bgcolor=F0F0BO>
<font size=-1><%=wc_case_report%></font>
</td>
<td bgcolor=F0E0F0 align=center>
<font size=+1><%=wc_Top_Tech_Comparisons_for_the%>
<% If Interval = "month" then
		response.write wc_Last_Month
	elseif Interval = "week" then
		response.write wc_Last_Week
	elseif Interval = "twoweek" then
		response.write wc_Last_Two_Weeks
	Else
		response.write " Last Month "
	End IF
%>
</font><br><font size=-2>This report retrieves time-spent statistics for the cases closed by the logged-in tech,<br> as well
as the technician with the greatest amount of time-spent, during the selected time interval.
</font>

</td>
<td align=center bgcolor=B0F0F0>
<font size=-1><%=Now%></font>
</td>

</tr></table>

</center>

<% ' Now Display the report
%>

<%' Now step through all of the case table with the only criteria being
	' the modified date range.  This could cause alot of records to be read and analyzed.
 %>

<% ' Build the query from the passed Start Date and End Date

		WhereStatement = " Cases.Mod_Date >= '" & Start_Date & "' AND cases.mod_Date <= '" & End_Date & "' and cases.Tech_ID is NOT NULL "

	' Now Add that Where clause to the select statement
		mySQL="select count(case_number) as cnt, Cases.Tech_ID, "
		mySQL=mySQL & "first_Name, Last_Name "
		mySQL=mySQL & "from cases left outer join tech_Staff on cases.Tech_ID = tech_Staff.tech_ID "
		mySQL=mySQL & " WHERE " & wherestatement
		mySql=mySQL &  " AND STATUS = 1 "  ' Added 08/15/11
		mySQL=mySQL & " group by cases.tech_id, last_Name, First_Name "
		mySQL=mySQL & " order by cases.Tech_ID"

		'response.write mySQL

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		set rstemp=Server.CreateObject("adodb.Recordset")
		set rstemp=conntemp.execute(mySQL)

		If rstemp.eof Then
			'Response.write " <P>No matching records found <P>.. Please enter a wider date range.<P>"

		Else ' At least one record exists

			MaxTotalMinutes = 0
			LoggedInTechName = CookieID ' the query won't return any records for this guy if no closed cases, therefore wont have tech name
			LoggedInTechTotal = 0

			do while not rstemp.eof
					' First get the name of the tech or put Not Assigned if blank
					' Now output the table row with name, number, percentage, and graphic
				if isnull(rstemp("Last_Name")) then
					LastName = ""
				else
					LastName = rstemp("Last_Name")
				end if
				if isnull(rstemp("First_Name")) then
					FirstName = ""
				else
					FirstName = rstemp("First_Name")
				end if

				TechName = trim(FirstName & " " & LastName)

				If trim(TechName) = "" then
					TechName = "Not Assigned"
				End if
				Tech_ID = rstemp("Tech_ID")

			'	TechOpenCases = rstemp("Cnt")
			'	color=RotateColor(color)
	%>

<%
	' Special Time Category
	' If the variable TimeSpentCategory is set to a particular value in the
	' DB_define.inc file, Time Spent reporting will be turned on.
	' To enable this row, set the variable TimeSpentCategory to the category column number
	' used to store this value.  IT should be C1 or C2, or C3... to C100.
	' One should also set the MinutesPerCategory variable to show the correct computations
	' of the time spent.

		call GetStats(Tech_ID, TimeSpentCategory, whereStatement, JobsClosed, CompletionTime) ' returns closed and total completion time

 		'Only Display time Average time if TimeSpentCategory Variable is set

			IF TimeSpentCategory <> "" Then

				 ' Completion time is computed by taking the Completiontime running sum
				' of time categories and then dividing by the number of jobs closed
				' and then multiply by  minutes per category value

				If JobsClosed <> 0 Then
					AverageCompletionTime = Int(CompletionTime*MinutesPerCategory/JobsClosed)
				Else
					AverageCompletionTime = 0
				End IF

				'Compute the time and display it in hours and minutes if greater than 60

				TotalMinutes = Int(CompletionTime*MinutesPerCategory)

				If TotalMinutes > MaxTotalMinutes then
					MaxTotalMinutes = TotalMinutes  ' this gets the tech with the maximum minutes
				End IF

				If CookieID = Tech_ID Then
					LoggedInTechName = TechName  ' was loggedintechtotal!
					LoggedInTechTotal = TotalMinutes
				End IF
			End IF

			rstemp.movenext
			count = count + 1
		loop

	End if ' End if RecordCount = 0

	rstemp.close
	set rstemp=nothing
%>

<% ' Display the Results table now %>

<table width=100% border=1>
<tr><th width=20% align=center bgcolor=FFFFFF>
<%=wc_Tech%>
</th>
<th width=20% bgcolor=FFFFFF>
<%=wc_Total_Time%>
</th>
<th width=60% bgcolor=FFFFFF>
<%=wc_Graphical_Percentage_of_Top_Tech%>
</th>
</tr>

<tr><td width=20% align=center>

<%=LoggedInTechName %>
</td>
<td width=20%>

<%
		If LoggedInTechTotal <=60 then
			Response.write LoggedInTechTotal & " Min."
		Else
			TotalHours = int(LoggedInTechTotal/60)
			TotalMinutes = LoggedInTechTotal - TotalHours*60
			Response.write TotalHours & " Hrs " & TotalMinutes & " Min."
		End IF
%>

</td>

<td width=60%>
<% Color = "Blue"
	If LoggedInTechTotal <> 0 and MaxTotalMinutes <> 0 Then
		Percentage = LoggedInTechTotal/MaxTotalMinutes * 100
	Else
		Percentage = 0
	End If
%>

<table><tr><td bgcolor=<%=color%> width=<%=Percentage*3%>><font size=-1>&nbsp</td></tr></table>

</td>
</tr>
<tr><td width=20% align=center>
TOP TECH
</td>
<td width=20%>

<%
		 	If MaxTotalMinutes <=60 then
				Response.write MaxTotalMinutes & " Min."
			Else
				TotalHours = int(MaxTotalMinutes/60)
				TotalMinutes = MaxTotalMinutes - TotalHours*60
				Response.write TotalHours & " Hrs " & TotalMinutes & " Min."
			End IF
%>

</td>

<td width=60%>
<% Color = "Red"
	Percentage = 100
%>

<table><tr><td bgcolor=<%=color%> width=<%=Percentage*3%>><font size=-1>&nbsp</td></tr></table>
</td>
</tr>

</table>

<P>
<center>
<a href=Reports.asp><img src=/<%=WCLanguageDirectory%>/ts_reports21x120.gif border=0></a>
</center>

</body>
</html>

<%End If ' End of security check
%>

<% Sub GetStats(Passed_Tech_ID, sTimeSpentCategory, sWhere, outClosed, outCompletionTime)
' Totals Number of jobs closed and sum time spent

	if sTimeSpentCategory <> "" then
		mySQL2="select count(Case_Number) as cnt, sum(" & sTimeSpentCategory & ") as nSum from Cases where Tech_ID = '" & Passed_Tech_ID & "' "
	Else
		mySQL2="select count(Case_Number) as cnt, 0 as nSum from Cases where Tech_ID = '" & Passed_Tech_ID & "' "
	End if

	if sWhere > "" then
		mySQL2=mySQL2 & "AND " & sWhere ' always will have where statement in this report
	End if

	mySQL2=mySQL2 & " AND Status = 1 "

	set rstemp2=conntemp.execute(mySQL2)

	outClosed = rstemp2("cnt")
	if outclosed = 0 then
		outCompletionTime = 0
	else
		outCompletionTime = rstemp2("nsum")
	end if

	rstemp2.close
	set rstemp2=nothing


End Sub
%>
