<%  ' Module: Updateonekb.inc
	'
	' Description: Update Module for Knowledge Base DURING CASE Submit
	'
	' This module simply adds one case to the knowledge base
	' and continue with the DoTCaseForm.asp processing.
	
	' NOTE: This is an INC file, not an ASP file.
			
	'	
	' (C) 2000, 2001 Internet Software Sciences
	'
	' Author: Scott Vanderlip
	' History:
	' Date		Who		What
	' -----		----	----------------------------------------------
	'10/11/99	SAV		Created original template file
	'03/28/01	SAV		Created Updateonekb.inc file from UpdateOneKB.asp file
%>

<% 'Get the KB Configuration options %>
<%
	set conntemp=server.createobject("adodb.connection")
	conntemp.open myDSN

	mySQL2="select * from KBConfiguration"
	set rstemp2=conntemp.execute(mySQL2)

	' Check to see if any records are returned
	' if none found the
	if rstemp2.EOF then
		LastUpdate = ""
		IncludeOneLine = "?"
		IncludeHistory =  "?"
		IncludeSummary ="?"
		IncludeResolution = "?"

	Else
		LastUpdate = rstemp2("LastKBDate")
		If rstemp2("IncludeOneLine") = True THEN
			IncludeOneLine = "YES"
		Else
			IncludeOneLine = "NO"
		End If

		If rstemp2("IncludeHistory") = True THEN
			IncludeHistory = "YES"
		Else
			IncludeHistory = "NO"
		End If


		If rstemp2("IncludeSummary") = True THEN
			IncludeSummary = "YES"
		Else
			Includesummary = "NO"
		End If


		If rstemp2("IncludeResolution") = True THEN
			IncludeResolution = "YES"
		Else
			IncludeResolution = "NO"
		End If

	End If

	rstemp2.close
	set rstemp2=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

%>


<% ' The variables should already exist from the DoTCaseForm.asp module


	'Case_Number contains the case number.
	' Case_History (New case) or New_Case_History (Appending to case) hold case history
	' Case_Resolution holds resolution
	' Case_summary hold case summary
	' Case_One_Line holds the one line description
	
	
		CaseOneLine = Case_One_Line
		History = Case_History
		If History = "" Then
			History = New_Case_History
		End IF
		
		Casesummary = Case_summary
		CaseResolution = Case_Resolution
		CaseNumber = case_number

			' First Process History
			Section = 2

			If IncludeHistory = "YES" THEN
				History = UCASE(History)
				NewHistory = Fix_Case_Text(History)
				response.write "History = " & NewHistory
				'response.write "<P> Words = <br>"
				CreateWordList(NewHistory)
			End If

			If IncludeOneLine = "YES" THEN
				' Second Process One Line Description
				Section = 1
				CaseOneLine = UCASE(CaseOneLine)
				NewCaseOneLine = Fix_Case_Text(CaseOneLine)
				'response.write "Case One Line = " & NewCaseOneLine
				'response.write "<P> Words = <br>"
				CreateWordList(NewCaseOneLine)
			End If

			If IncludeSummary = "YES" THEN
				' Third Process Case Summary
				Section = 3
				Casesummary = UCASE(Casesummary)
				NewCasesummary = Fix_Case_Text(Casesummary)
				'response.write NewHistory
				'response.write "<P> Words = <br>"
				CreateWordList(Casesummary)
			End IF

			If IncludeResolution = "YES" THEN
				' 4th  Process Case Resolution
				Section = 4
				Casesummary = UCASE(CaseResolution)
				NewCasesummary = Fix_Case_Text(Casesummary)
				'response.write NewHistory
				'response.write "<P> Words = <br>"
				CreateWordList(Casesummary)
			End If
	
%>


<% ' Add to Knowledge database and knowledge base word mappings
Sub AddToKB(Word, CaseNumber)
' This routine add words to the knowledge base
' Before we place it into the database, we will do some additional processing on the
' on the word such as remove the period, commas with spaces proceeding, etc
' and any extra spaces

' Case 1 - If we detect a "." ( period followed by a space we will remove both characters)
		NewWord = Replace (NewText, ". ", "")

' Case 2 - If we detect a "," ( comma followed by a space we will remove both characters)
		NewWord = Replace (NewText, ", ", "")

' Case 3 - If we detect a "! " ( Check for "!" followed by a space we will remove both characters)
		NewWord = Replace (NewText, "! ", "")

' Case 4 - If we detect a "! " ( check for "?" followed by a space we will remove both characters)
		NewWord = Replace (NewText, "? ", "")

	WordIndex = "" ' Clear this value initially

	word = trim(word) ' Lastly, remove all extra leading and following spaces
	If Len(Word) < 2 Then ' word must be 2 characters or more
		Exit Sub ' Exit without checking to see if the word exists
	End If


	' Check to see if the last character is a "." or "," or "?" or "!" and if so
	' then remove that character so we don't put in two entries like "dog." and "dog"

	RightCharacter = right(word, 1) ' Get right most character

	If RightCharacter = "." OR RightCharacter = "," or RightCharacter = "?" or RightCharacter = "!" Then
		Word = mid(word, 1, (len(Word)-1)) ' Remove the last character
	end If

	' Now check to see if the word remaining if 2 or more characters.
	If Len(Word) < 2 Then ' word must be 2 characters or more
		Exit Sub ' Exit without checking to see if the word exists
	End If


	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  myDSN ' Open connection

	' Search Word will need to have any single quotes converted to two single quotes
	' for valid SQL search syntax

		for i = 1 to len(word)
			if (Mid(Word, i,1) = "'") Then
				SearchWord = SearchWord & "''"
			else
				SearchWord = SearchWord & Mid(Word, i,1)
			End If
		next


	Set NewRecord = Server.CreateObject("ADODB.Recordset")
		SQL = "Select * from  KBWords where word = '" & SearchWord & "'"
		NewRecord.Open SQL,Conn,3,3 ' Open Record Set for Update or new
 
		If NewRecord.EOF = True Then ' Word not found so add it.
			NewRecord.AddNew
			NewRecord("Word") = Word
			NewRecord.Update


		If  err.number>0 then
			  response.write "VBScript Errors Occured:" & "<P>"
			  response.write "Error Number=" & err.number & "<P>"
			  response.write "Error Descr.=" & err.description & "<P>"
			  response.write "Help Context=" & err.helpcontext & "<P>"
			  response.write "Help Path=" & err.helppath & "<P>"
			  response.write "Native Error=" & err.nativeerror & "<P>"
			  response.write "Source=" & err.source & "<P>"
			  response.write "SQLState=" & err.sqlstate & "<P>"
		else
		'      response.write "No VBScript Errors Occured" & "<P>"
		end if
		IF  conn.errors.count> 0 then
'			  response.write "Database Errors Occured" & "<P>"
'		for counter= 0 to conn.errors.count
'			  response.write "Error #" & conn.errors(counter).number & "<P>"
'			  response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
'		next
		else
		'      response.write "No Database Errors Occured!" & "<P>"
		end if


		Else
		
' Don't try and read the index immediately since this fails under certain drivers.

'			WordIndex = NewRecord("WordIndex") ' Get this index for next mapping step

			' Word already exists in the database so do not put it in again.
		End If

	NewRecord.Close
	Set NewRecord = Nothing

	' Close the connection and reopen it to make sure it was updated

	Conn.Close
	Set Conn = Nothing

	' Get the WordIndex
	If WordIndex = "" Then

	Set Conn = Server.CreateObject("ADODB.Connection")
	conn.open  myDSN

		mySQL2="select * from KBWords where Word = '" & SearchWord & "'"

		set rstemp=conn.execute(mySQL2)

'		' Check to see if any records are returned
		If rstemp.EOF <> True Then
			WordIndex = rstemp("WordIndex")
		Else
			Response.write "Error in finding WordIndex for word: " & SearchWord & "<br>"
		End If

		rstemp.close
		set rstemp=nothing

	End If

	' Now check add this to the kbmap table if it does not exist
	' for this case number before closing connection

		Set NewRecord = Server.CreateObject("ADODB.Recordset")
			SQL = "Select * from  KBMap where wordindex = " & WordIndex & " AND Case_Number = "& CaseNumber

			'response.write SQL

			NewRecord.Open SQL,Conn,3,3

			If NewRecord.EOF = True Then
				NewRecord.AddNew
				NewRecord("WordIndex") = WordIndex
				NewRecord("Case_Number") = CaseNumber
				NewRecord("Section") = Section
				' Define what section 1=oneline 2=history 3 = summary 4=resolution
				NewRecord.Update

			Else
				' Word already exists in the database so do not put it in again.
			End If

	If  err.number>0 then
	      response.write "VBScript Errors Occured:" & "<P>"
	      response.write "Error Number=" & err.number & "<P>"
	     response.write "Error Descr.=" & err.description & "<P>"
	      response.write "Help Context=" & err.helpcontext & "<P>"
	      response.write "Help Path=" & err.helppath & "<P>"
	      response.write "Native Error=" & err.nativeerror & "<P>"
	      response.write "Source=" & err.source & "<P>"
	      response.write "SQLState=" & err.sqlstate & "<P>"
	else
	'      response.write "No VBScript Errors Occured" & "<P>"
	end if
	IF  conn.errors.count> 0 then
'	      response.write "Database Errors Occured" & "<P>"
'	for counter= 0 to conn.errors.count
'	      response.write "Error #" & conn.errors(counter).number & "<P>"
'	      response.write "Error desc. -> " & conn.errors(counter).description & "<P>"
'	next
	else
	'      response.write "No Database Errors Occured!" & "<P>"
	end if


	NewRecord.Close
	Set NewRecord = Nothing

	Conn.Close
	Set Conn = Nothing



End Sub
%>


<% Sub CreateWordList(text)
' This routine goes letter by letter through the passed text and picks out words
'that are separated by spaces.

If text <> "" Then

	TextLen = Len(text)
	LastChar = " " ' Start off with a space

	NewWord = ""
	For i = 1 to textlen
		CurrentChar = mid(text, i,1)
		if CurrentChar = chr(32) AND LastChar <> chr(32) THEN
			' New Word is found

			' Remove any extra spaces on the left and right sides of the word
			' Trim any word to 50 characters or less
			If Len(NewWord) > 50 Then
				NewWord = Mid(NewWord, 1, 50)
			End If

			AddToKB NewWord, CaseNumber
			'response.write NewWord & "<br>"
			NewWord = ""
			LastChar = " " ' Set last character to 32
		Else

			NewWord = NewWord & currentchar
			LastChar = CurrentChar
		End If
	next

	' Output last word
			' Remove any extra spaces on the left and right sides of the word
			' Trim any word to 50 characters or less
			If Len(NewWord) > 50 Then
				NewWord = Mid(NewWord, 1,50)
			End If

			AddToKB NewWord, CaseNumber

			'response.write NewWord & "<br>"

End If ' End of if text <> blank

End Sub
%>


<%Function Fix_Case_Text(Case_Text)

' This subroutines remove the special inserted formatted characters

If Case_text <> "" THEN

NewText = Case_Text


		NewText = Replace (NewText, "{G[", "")

		NewText = Replace (NewText, "{R[", "")

		NewText = Replace (NewText, "]R}", "")

		NewText = Replace (NewText, "]G}", "")

		' Other replacements
		' Replace all CR with spaces

		NewText = Replace (NewText, chr(10), " ")
		NewText = Replace (NewText, chr(13), " ")

		' Replace commas with spaces
		NewText = Replace (NewText, chr(13), ",")

End IF
	Fix_Case_text = NewText

End function
%>
