
<% 'Module:

   'Description: This module should only be run once to import the webcenter30 tables
   ' into a copy of the webcenter 2.5 database structure.

   ' Before this script is run, one must have an webcenter database that has an ODBC name
   ' called webcenter_db and a new database ODBC called webcenter30_db.

   ' Once those ODBC database source are set up, run this script and it will add the
   ' webcenter 30 tables and populate the priority table.

   ' DO  delete any databases until you can verify that the new database tables
   ' have been succesfully created.

   '(C) 2000 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date	Who		What
   '-------	---		------------------------------------------------
	'10/24/00	SAV - Created initial version.
	' CONSTANTS

	NewRecords = 0
	UpdatedRecords = 0

%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->


<html>

<head>
<title>Web+Center30 Add New Tables Utility</title>
</head>

<body bgcolor=FFFFFF>

<% ' ********************* USER CUSTOMIZATION ********************
	' Step 1: On the line below, edit the ODBC connect string for your
	' original webcenter database.
	' Currently it is initially configured for a DSN called "webcenter_db"
	' If your require a userid and password, enter it into the string too.

		NewWebcenter30DatabaseDSN = "DSN=webcenter30_db;uid=wc30;pwd=wc30pass"

	' Open second connection to source database
	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  NewWebcenter30DatabaseDSN ' If it fails here, then check your connect string.

	response.write " Connection to New Webcenter30 Database Successful.</ul>"

	Conn2.close


	Response.write "<b>Creating New Tables:</b><UL>"


%>

Scott Table created with <%=RecordsChanged%> Records changed.<P>



<% ' Create the CustomerNotes Table

mySQL2 = "CREATE TABLE CustomerNotes ( notesID AUTOINCREMENT constraint Primarykeyname Primary Key ,	Contactnotes memo ,Customer_ID text (20)  ,Textnote1 text (200)  ,Textnote2 text (200)  ,Textnote3 text (200)  ,Textnote4 text (200)  ,Textnote5 text (200)  ,Textnote6 text (200)  ,Textnote7 text (200)  ,Textnote8 text (200)  ,Textnote9 text (200)  ,Textnote10 text (200)  ,CustCat1 int  ,CustCat2 int  ,CustCat3 int  ,CustCat4 int  ,CustCat5 int  ,CustCat6 int  ,CustCat7 int  ,CustCat8 int  ,CustCat9 int  ,CustCat10 int  ); "

	set conntemp=server.createobject("adodb.connection")

	conntemp.open NewWebcenter30DatabaseDSN ' Open the connection to new database

	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created CustomerNotes Table.<P>"


%>


<% ' Create the BConfiguration Table


mySQL2 ="CREATE TABLE BConfiguration (	BConfgurationID AUTOINCREMENT constraint Primarykeyname Primary Key, BWhiteBoard memo  ,OptionColor text (50)  ,UserWindowColor text (50)  ,AssignedContactsColor text (50)  ,RemoveEmailText text (200)  ,Box1Label text (50)  ,Box2Label text (50)  ,Box3Label text (50)  ,Box4Label text (50)  ,Box5Label text (50)  ,Box6Label text (50)  ,Box7Label text (50)  ,Box8Label text (50)  ,Box9Label text (50)  ,Box10Label text (50)  ,Box1Enabled Logical  ,Box2Enabled Logical  ,Box3Enabled Logical  ,Box4Enabled Logical  ,Box5Enabled Logical  ,Box6Enabled Logical  ,Box7Enabled Logical  ,Box8Enabled Logical  ,Box9Enabled Logical  ,Box10Enabled Logical  ); "


		set conntemp=server.createobject("adodb.connection")

		conntemp.open NewWebcenter30DatabaseDSN ' Open the connection to new database

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		conntemp.close ' Close the connection
		set conntemp=nothing

		response.write "Succesfully created BConfiguration Table.<P>"


%>

<% ' Create the CustomerTechAssignment Table



	mySQL2 = "CREATE TABLE CustomerTechAssignment (CustomerTechAssignmentID  AUTOINCREMENT constraint Primarykeyname Primary Key  ,Customer_ID text(20)  ,Tech_ID text (20)  );"

	set conntemp=server.createobject("adodb.connection")

	conntemp.open NewWebcenter30DatabaseDSN ' Open the connection to new database

	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created CustomerTechAssignment Table.<P>"


%>

<% ' Create the DeleteList Table

	mySQL2 = "CREATE TABLE DeleteList (ListDeleteID  AUTOINCREMENT constraint Primarykeyname Primary Key   ,Customer_ID text (20)  ,DeletedByIP text (20)  ,DateDeleted datetime  );"

	set conntemp=server.createobject("adodb.connection")

	conntemp.open NewWebcenter30DatabaseDSN ' Open the connection to new database

	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created DeleteList Table.<P>"


%>

<% ' Create the EmailCategory Table

	mySQL2 = "CREATE TABLE EmailCategory (EmailCategoryID AUTOINCREMENT constraint Primarykeyname Primary Key,EmailCategory text (100) );"

	set conntemp=server.createobject("adodb.connection")

	conntemp.open NewWebcenter30DatabaseDSN ' Open the connection to new database

	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created EmailCategory Table.<P>"

%>

<% ' Create the EmailCategoryLinks Table

	mySQL2 = "CREATE TABLE EmailCategoryLinks (EmailCustomerCategoryID AUTOINCREMENT constraint Primarykeyname Primary Key,Customer_ID text (20), EmailCategoryID Int );"

		set conntemp=server.createobject("adodb.connection")

		conntemp.open NewWebcenter30DatabaseDSN ' Open the connection to new database

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		conntemp.close ' Close the connection
		set conntemp=nothing

		response.write "Succesfully created EmailCategoryLinks Table.<P>"

%>

<% ' Create the EmailText Table

	mySQL2 = "CREATE TABLE EmailText (EmailTextID AUTOINCREMENT constraint Primarykeyname Primary Key   ,EmailTextTitle text (50)  ,EmailTextSubject text (100)  ,CustomDearUser Logical   ,RemovalLink Logical  ,EmailText memo  ,Attachments text (100)  ,ReplyToEmail text(100)  ,FromOrganization text(100)  );"

		set conntemp=server.createobject("adodb.connection")

		conntemp.open NewWebcenter30DatabaseDSN ' Open the connection to new database

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		conntemp.close ' Close the connection
		set conntemp=nothing

		response.write "Succesfully created EmailText Table.<P>"

%>


<% ' Create the Priority Table


	mySQL2 = "CREATE TABLE Priority (PriorityID LONG constraint Primarykeyname Primary Key   ,ShortDesc text (20)  ,LongDesc text (50)  ); "


	set conntemp=server.createobject("adodb.connection")

	conntemp.open NewWebcenter30DatabaseDSN ' Open the connection to new database

	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created Priority Table.<P>"

%>

<% ' Create the UserCategory Table


	mySQL2 = "CREATE TABLE UserCategory (UserCategoryID AUTOINCREMENT constraint Primarykeyname Primary Key   ,UserCategory text(50) NULL );"
		set conntemp=server.createobject("adodb.connection")

		conntemp.open NewWebcenter30DatabaseDSN ' Open the connection to new database

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		conntemp.close ' Close the connection
		set conntemp=nothing

		response.write "Succesfully created UserCategory Table.<P>"

%>

<% ' Populate the Priority Table with default values


		set conntemp=server.createobject("adodb.connection")

		conntemp.open NewWebcenter30DatabaseDSN ' Open the connection to new database

		mySQL2 = "Insert into Priority (PriorityID, ShortDesc, LongDesc) values(0,'Not Assigned', 'Not Assigned');"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Insert into Priority (PriorityID, ShortDesc, LongDesc) values(1, 'Critical (1)', 'Critical');"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Insert into Priority (PriorityID, ShortDesc, LongDesc) values(2, 'Severe (2)', 'Severe');"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Insert into Priority (PriorityID, ShortDesc, LongDesc) values(3, 'Serious (3)', 'Serious');"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Insert into Priority (PriorityID, ShortDesc, LongDesc) values(4, 'Important (4)', 'Important');"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		conntemp.close ' Close the connection
		set conntemp=nothing

		response.write "Successfully populated the Priority Table with default values.<P>"

%>

<% ' Create the AssetAssignment Table

mySQL2 = "CREATE TABLE AssetAssignment ( AssetAssignmentID AUTOINCREMENT constraint Primarykeyname Primary Key , asset_number int, 	customer_id text (20)  ,Tech_id text (20)  ,asset_number2  int ); "

	set conntemp=server.createobject("adodb.connection")

	conntemp.open NewWebcenter30DatabaseDSN ' Open the connection to new database

	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created AssetAssignment Table.<P>"

%>

<% ' Now we need to ALTER the existing Assets table by adding some new columns
	'and also changing the size of existing columns.

%>


<% ' Add New Columns to the Asset Table

		set conntemp=server.createobject("adodb.connection")

		conntemp.open NewWebcenter30DatabaseDSN ' Open the connection to new database

		' Adding new Columns

		mySQL2 = "Alter Table Assets Add Column LastUpdate Text (20) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Assets Add Column UpDatedBy Text (20) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Assets Add Column AssetNotes memo ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		' Add custom fields 1 -5

		mySQL2 = "Alter Table Assets Add Column Custom_Field1 Text (50) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Assets Add Column Custom_Field2 Text (50) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Assets Add Column Custom_Field3 Text (50) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Assets Add Column Custom_Field4 Text (50) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Assets Add Column Custom_Field5 Text (50) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText


		response.write "Successfully Added New Columns to the Asset Table.<P>"


		' Now Alter the existing table columns sizes

		' Computer_Id increases from 25 to 50
		mySQL2 = "Alter Table Assets Alter Column computer_id text (50);"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		' property_tag increases from 25 to 50
		mySQL2 = "Alter Table Assets Alter Column property_tag text (50);"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		' equipment_type increases from 20 to 100
		mySQL2 = "Alter Table Assets Alter Column computer_id text (100);"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		' Monitor_serial_num  from 25 to 30
		mySQL2 = "Alter Table Assets Alter Column monitor_serial_num text (30);"

		conntemp.execute mySQL2, RecordsChanged, adCmdText


		' Assigned_group increases from 25 to 50
		mySQL2 = "Alter Table Assets Alter Column assigned_group text (50);"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		' location increases from 25 to 50
		mySQL2 = "Alter Table Assets Alter Column location text (50);"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		' Operating_system1 increases from 25 to 30
		mySQL2 = "Alter Table Assets Alter Column Operating_system1 text (30);"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		' Operating_system2 increases from 25 to 30
		mySQL2 = "Alter Table Assets Alter Column Operating_system1 text (30);"

		conntemp.execute mySQL2, RecordsChanged, adCmdText


		conntemp.close ' Close the connection
		set conntemp=nothing

		response.write "Successfully increase sizes of existing columns in the Asset Table.<P>"

%>


</body>
</html>



