
<% 'Module: Upgradewebcenter31to35.asp

   'Description: This module should only be run once to create the table differences
   ' between version 3.1 and version 3.5.

 	' All of the differences between 3.1 and 3.5 are:
	' (1) additions to the  configuration table  to enable the new configuration
	' (2) changes to the categories table to allow for group assignments.
	' (3) Changes to the Cases table to allow for scheduled cases
	' (4) Changes to the Cases for External_Case_Number (Reference #) field
	' (5) Changes to Customers Table adding field ViewEmailCategoryID field for super users

	' Always backup any database (webcenter30.mdb) before running these 
	' upgrade scripts so you can run the script again if necessary.

   ' DO NOT delete any databases until you can verify that the new database tables
   ' have been succesfully created.

   '(C) 2000, 2001 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date	Who		What
   '-------	---		------------------------------------------------
	'04/10/01	SAV - Created initial version.
	'06/11/01	SAV - Updated with case table updates.
	'06/27/01	SAV - Added a few more fields
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->


<html>

<head>
<title>Web+Center Version 3.5 Database Upgrade Utility</title>
</head>

<body bgcolor=FFFFFF>


<P>
<B>Version 3.5 Table Upgrade </b>(Version 3.1 to Version 3.5)<P>
	Step 1: Testing Connection to Webcenter Database <br>
	If this fails, then verify your ODBC DSN points to your old database file.<br>


<% '  First check database connectivity

	' The connect string MyDSN is set in the DB_define.inc file
	' located in this directory.

	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.

	Conn2.close

%>
	Connection to Webcenter Database - Successful.<P>
	
	Step 2: Adding new columns to Configuration/Categories table.</b>


<% ' Now we need to ALTER the Configuration table by adding new columns.

%>


<% ' Add changes to Customers Table
		' * * * * * * Add new column to customers table * * * *

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.		

		mySQL2 = "Alter Table Customers Add Column ViewEmailCategoryID Int ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText
		
%>
		Successfully Added New Column to the Customers Table.<P>


<% ' Add external case number field to Cases Table
		' * * * * * * Add new column to cases table * * * *

		mySQL2 = "Alter Table Cases Add Column External_Case_Number Text (30) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Successfully Added New Column External_Case_Number to Cases Table.<P>"

		 Adding New Columns to Configuration table.<P>


<% ' Add New Columns to the Configuration Table

		' Adding new Columns

		mySQL2 = "Alter Table Configuration Add Column text_Box_Sizing Text (10) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText
		
		mySQL2 = "Alter Table Configuration Add Column Case_Summary_Rows Text (5) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Configuration Add Column Case_Summary_Max_Rows Text (5) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Configuration Add Column Case_Resolution_Rows Text (5) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Configuration Add Column Case_Resolution_Max_Rows Text (5) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Configuration Add Column Case_History_Rows Text (5) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Configuration Add Column Case_Text_Box_Columns Text (5) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Configuration Add Column Time_Zone_Adjustment Text (5) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Configuration Add Column Time_Zone_Label Text (20) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		' Move to the end since this failed on some conversions
'		mySQL2 = "Alter Table Configuration Add Column Language Text (50) ;"
'
'		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Configuration Add Column All_KB_Update Text (10) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Configuration Add Column Time_Spent_Category Text (5) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Configuration Add Column Time_Spent_Interval Text (10) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Configuration Add Column Date_Display_Format Text (20) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText
				
%>				
	Successfully Added New Columns to the Configuration Table.<P>

<%
		' * * * * * * Add columns to categories table * * * *

		mySQL2 = "Alter Table Categories Add Column Group_Number Int ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>

		Successfully Added New Column to the Categories Table.<P>
		Adding  New Columns to the Cases Table.<P>


<%

		' * * * * * * Add scheduled cases columns to cases table * * * *

		mySQL2 = "Alter Table Cases Add Column Scheduled_Case_Type Text (20) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Cases Add Column Repeat_Interval Text (20) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Cases Add Column Due_Date DATETIME ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Cases Add Column Due_Time DATETIME ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Alter Table Cases Add Column Overdue_Email Text (100) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>

		Successfully Added New Columns to the Cases Table for Scheduled cases.<P>


<%
		conntemp.close ' Close the connection
		set conntemp=nothing

%>
		<p>Populating new columns with default data...
		
<%		

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.		

		

		mySQL2 = "Update Configuration set Text_Box_Sizing = 'AUTO' where Configuration_Setting = 0 "
		conntemp.execute mySQL2, RecordsChanged, adCmdText 

		mySQL2 = "Update Configuration set Case_Summary_Rows = 3 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText 

		mySQL2 = "Update Configuration set Case_Summary_Max_Rows = 10 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText 


		mySQL2 = "Update Configuration set Case_Resolution_Rows = 3 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText 

		mySQL2 = "Update Configuration set Case_Resolution_Max_Rows = 10 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText 

		mySQL2 = "Update Configuration set Case_History_Rows = 4 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText 


		mySQL2 = "Update Configuration set Case_Text_Box_Columns = 65 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText 

		mySQL2 = "Update Configuration set Time_Zone_Adjustment = 0 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText 

		mySQL2 = "Update Configuration set Date_Display_Format = 'MMDDYYYY' where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText 


		' Do this last incase there is an error performing this step.
		
		mySQL2 = "Alter Table Configuration Add Column Language Text (50) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText


		conntemp.close ' Close the connection
		set conntemp=nothing

		response.write " <br>New Configuration Table default entries set successfully."



%>

</body>
</html>
