
<% 'Module: Upgradewebcenter35to40.asp

   'Description: This module should only be run once to create the table differences
   ' between version 3.5 and version 4.0.

 	' All of the differences between 3.5 and 4.0 are:
 	' (1) Addition of the following new tables:
 	'	Case_Text_field_Labels
 	'	Escalation
 	'	Event_Attending
 	'	Event_Type
 	'	Result_detail
 	'	Schedule
 	'	Survey
 	'	Survey_Results

 	'(2) New columns added to Configuration, Customer_Notes and Cases table


	' Always backup any database (webcenter30/35.mdb) before running these
	' upgrade scripts so you can run the script again if necessary.

   ' DO NOT delete any databases until you can verify that the new database tables
   ' have been succesfully created.

   '(C) 2000, 2001, 2002, 2003 Internet Software Sciences
   ' www.inet-sciences.com


   'History:

   'Date	Who		What
   '-------	---		------------------------------------------------
	'04/10/01	SAV - Created initial version.
	'06/11/01	SAV - Updated with case table updates.
	'06/27/01	SAV - Added a few more fields
	'01/13/03	SAV	- Created New Upgradewebcenter35to40.asp module
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->

<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->


<html>

<head>
<title>Web+Center Version 3.5 to Version 4.0 Database Upgrade Utility</title>
</head>

<body bgcolor=FFFFFF>


<P>
<B>Web+Center Version 3.5 to Version 4.0 Database Upgrade Utility<P></b>
	Step 1: Testing Connection to Webcenter Database <br>
	If this fails, then verify your ODBC DSN points to your old (Version 3.5) database file.<br>
	You should set up a ODBC DSN called <U>webcenter40_db</u>
	and point this ODBC DSN to your existing 3.5 database Access file (webcenter35.mdb or webcenter30.mdb).
	<P>




<% '  First check database connectivity

	' The connect string MyDSN is set in Global.asa and then set in DB_define.inc file
	' located in this directory.

	Set Conn2 = Server.CreateObject("ADODB.Connection")
	conn2.open  myDSN ' If it fails here, then check your connect string.

	Conn2.close

%>
	Connection to Webcenter Database - Successful.<P>

	Step 2: Adding new Tables to Database.</b>
	<P>
	Adding Case_Text_Field_Labels Tables and columns...<br>

<%
	' **************************************************************
	'**********ADDING Case_Text_Field_Labels Table******************
	' **************************************************************

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

	mySQL2 = "CREATE TABLE Case_Text_Field_Labels  ( Cases_Text_Field_Index AUTOINCREMENT constraint Primarykeyname Primary Key , Field_1_Label text (80), Field_2_Label text (80), Field_3_Label text (80), Field_4_Label text (80), Field_5_Label text (80), Field_6_Label text (80), Field_7_Label text (80), Field_8_Label text (80), Field_9_Label text (80), Field_10_Label text (80), asset_number int, 	customer_id text (20), Tech_id text (20), Field_1_State int, Field_2_State int, Field_3_State int, Field_4_State int, Field_5_State int, Field_6_State int, Field_7_State int, Field_8_State int, Field_9_State int, Field_10_State int); "

	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created Case_Text_Field_Labels Table.<P>"

%>

	Adding Escalation Tables and columns...<br>

<%
	' **************************************************************
	'**********ADDING Escalation Table******************
	' **************************************************************

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

	mySQL2 = "CREATE TABLE Escalation  ( Escalation_Number AUTOINCREMENT constraint Primarykeyname Primary Key , Disable_All LOGICAL, Escalation_Refresh_Rate int, Newcase_Enable   LOGICAL, Newcase_interval int, Newcase_Email  text (100), 	Newcase_Group int , Newcase_CellEmail  text (100), Existcase_Enable   LOGICAL , Existcase_Interval int, Existcase_Priority int , Existcase_status  int, Existcase_email  text (100) , Existcase_group int , Existcase_CellEmail   text (100) ); "


	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created Escalation Table.<P>"

%>


	Adding Event_Attending Table and columns...<br>

<%
	' **************************************************************
	'**********ADDING Event_Attending Table******************
	' **************************************************************

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

	mySQL2 = "CREATE TABLE Event_Attending  ( Event_Attending_ID AUTOINCREMENT constraint Primarykeyname Primary Key , Schedule_ID int, Tech_ID text (20) );"

	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created Event_Attending Table.<P>"

%>


	Adding Event_Type Table and columns...<br>

<%
	' **************************************************************
	'**********ADDING Event_Type Table******************
	' **************************************************************

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

	mySQL2 = "CREATE TABLE Event_Type  ( Event_Type_ID AUTOINCREMENT constraint Primarykeyname Primary Key , Event_Type_Name text (50) , 	Event_Type_gif text (100) );"


	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created Event_Type Table.<P>"

%>


	Adding Result_Detail Table and columns...<br>

<%
	' **************************************************************
	'**********ADDING Result_Detail Table******************
	' **************************************************************

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

	mySQL2 = "CREATE TABLE Result_Detail  ( Result_Detail_ID AUTOINCREMENT constraint Primarykeyname Primary Key , 	Results_ID int, Question_ID int, YES_NO_ANSWER  LOGICAL, 	OPEN_ENDED_ANSWER MEMO, RANGE_ANSWER int );"

	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created Result_Detail Table.<P>"

%>


	Adding Schedule Table and columns...<br>

<%
	' **************************************************************
	'**********ADDING Schedule ******************
	' **************************************************************

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

	mySQL2 = "CREATE TABLE Schedule  ( Schedule_ID AUTOINCREMENT constraint Primarykeyname Primary Key , 	Customer_ID text (20)  , Event_Type_ID  int , Email_Reminder int  , Start_Date datetime , Start_Time datetime  , End_Date datetime , End_Time datetime, Tech_ID text (20) , Event_Title text (100) , 	Event_Notes MEMO , Event_Status int , case_number int );"


	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created Schedule Table.<P>"

%>


	Adding Survey Table and columns...<br>

<%
	' **************************************************************
	'**********ADDING Survey ******************
	' **************************************************************

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

	mySQL2 = "CREATE TABLE Survey  ( Question_ID AUTOINCREMENT constraint Primarykeyname Primary Key , 	Survey_Question MEMO , 	Question_Type int  , Active  LOGICAL , Question_Order  int );"

	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created Survey Table.<P>"

%>

	Adding Survey_Results Table and columns...<br>

<%
	' **************************************************************
	'**********ADDING Survey_Results ******************
	' **************************************************************

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

	mySQL2 = "CREATE TABLE Survey_Results  ( Results_ID AUTOINCREMENT constraint Primarykeyname Primary Key , Customer_ID text (20)  , Survey_Date datetime , Case_Number int );"


	conntemp.execute mySQL2, RecordsChanged, adCmdText

	conntemp.close ' Close the connection
	set conntemp=nothing

	response.write "Succesfully created Survey_Results Table.<P>"

%>


<% '***********    ADDING NEW COLUMNS TO EXISTING TABLES ***************%>



<% ' Now we need to ALTER the Cases table by adding new columns.

%>

	Adding New Columns to Cases Table ... <P>

<% ' Add changes to Cases Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "Alter Table Cases Add Text_Field_1 text (100) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<br>

<% ' Add changes to Cases Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "Alter Table Cases Add Text_Field_2  text (100) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<br>

<% ' Add changes to Cases Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "Alter Table Cases Add Text_Field_3 text (100) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<br>

<% ' Add changes to Cases Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "Alter Table Cases Add Text_Field_4 text (100) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<br>

<% ' Add changes to Cases Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "Alter Table Cases Add Text_Field_5 text (100) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<br>

<% ' Add changes to Cases Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "Alter Table Cases Add Text_Field_6 text (100) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<br>

<% ' Add changes to Cases Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "Alter Table Cases Add Text_Field_7 text (100) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<br>

<% ' Add changes to Cases Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "Alter Table Cases Add Text_Field_8 text (100) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<br>

<% ' Add changes to Cases Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "Alter Table Cases Add Text_Field_9 text (100) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<br>

<% ' Add changes to Cases Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "Alter Table Cases Add Text_Field_10 text (100) ;"

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<br>
		Cases Tables Upgrade Complete<P>

	Adding New Columns to Configuration Table ... <P>



<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add TechCenterFileUpload  LOGICAL; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add CustomerCenterFileUpload  LOGICAL ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add FileUploadPhysicalPath text (100) ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	FileUploadVirtualDirectory text (100); "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	RenameUploadFile  LOGICAL ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	MaxFileUploadSize text (20) ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	CustomerPasswordRequired LOGICAL ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>

<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	CustomerAssetsearch text (20) ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "Alter Table Configuration Add EncryptPasswords  LOGICAL ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	Customersurvey  LOGICAL; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	SurveyEmail1 text (80) ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add SurveyEmail2 text (80); "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	SurveyEmail3 text (80); "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>



<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	SurveyEmailText MEMO; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>

<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	TechVirtual text (100) ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>



<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	CustomerVirtual text (100) ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	BusinessVirtual text (100) ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	LanguageVirtual text(100) ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	DatabaseType text (20) ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	Option1 text(50); "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to Configuration Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table Configuration Add 	 Option2 text (50) ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>
		Configuration Table Updates Completed<P>


	Adding New Columns to CustomerNotes Table ... <P>



<% ' Add changes to CustomerNotes Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table CustomerNotes Add 	Tech_ID text (20); "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>


<% ' Add changes to CustomerNotes Table

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.

		mySQL2 = "	Alter Table CustomerNotes Add 	LastModifiedDate DATETIME ; "

		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
		Column Added<Br>
		CustomerNotes Table Updates Completed<P>
		Table Column Updates Completed<P>


<%
		conntemp.close ' Close the connection
		set conntemp=nothing

%>



<% ' ******** Now populate some of the database fields with default data %>


		<p>Populating new columns with default data...<br>
		Configuration File column Updates...<Br>


<%

		Set Conntemp = Server.CreateObject("ADODB.Connection")
		conntemp.open  myDSN ' If it fails here, then check your connect string.



		mySQL2 = "Update Configuration set  TechCenterFileUpload = 0 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Update Configuration set CustomerCenterFileUpload = 0 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Update Configuration set  RenameUploadFile = 0 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Update Configuration set  CustomerPasswordRequired = 1 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Update Configuration set  CustomerAssetsearch = 'ALLAssets' where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Update Configuration set  EncryptPasswords = 0 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText


		mySQL2 = "Update Configuration set  Customersurvey = 0 where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Update Configuration set  DatabaseType = 'ACCESS' where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Update Configuration set TechVirtual = 'tech40' where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText


		mySQL2 = "Update Configuration set CustomerVirtual = 'customer40' where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Update Configuration set BusinessVirtual = 'business40' where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Update Configuration set languageVirtual = 'wclanguage' where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Update Configuration set Customer_Name_Text = 'Customer Support/Help Desk' where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText


		mySQL2 = "Update Configuration set TechVirtual = 'tech40' where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText

		mySQL2 = "Update Configuration set TechVirtual = 'tech40' where Configuration_Setting = 0"
		conntemp.execute mySQL2, RecordsChanged, adCmdText


%>

	Configuration Table Data Updated...<P>

	Updating Escalation Table Data... <br>


<%
		mySQL2 = "insert into Escalation ( 	 Disable_All,  Escalation_Refresh_Rate, Newcase_Enable,  Newcase_Interval,  Existcase_enable,  Existcase_interval ) values (1, 15, 0, 30, 0, 30 );"
		conntemp.execute mySQL2, RecordsChanged, adCmdText

%>
	Escalation Table Data Updated <P>

<%
		conntemp.close ' Close the connection
		set conntemp=nothing

		response.write " <br><B>Web+Center 3.5 <U>Database</u> successfully upgraded to Version 4.0.</b>"

%>

<P>

<font color=red>Important New Additional Step</font><br>


	You should also upgrade your category table entries by running the
	FixCategoryLists.asp module.  Without this, your Categories may not
	be properly displayed.<P>

	This script is located in the techcenter directory and can be run by clicking

	<a href=FixCategoryLists.asp> HERE </a>
	<P>



</body>
</html>
