<%
 module = "SQL_Script_Interpreter"

 ' NAME = UpgradeWebcenter40to50Access.asp - Upgrade script from 4.0 to 5.0

'(C)  2004-2008 Internet Software Sciences
' www.inet-sciences.com


'History:

'Date			Who		What
'-------		---		------------------------------------------------
' 11/16/2004	JC		Created initial version
' 03/30/2005	SAV		Created version for 4.0 to 5.0 upgrade
' 02/04/2008	SAV		Created 5.0 to 6.0 version upgrade

' This module is an autolytic program - i.e. it is a program that digests it's own source code file as a data file.
' To explain how it works, consider there are 2 phases when this code executes:
'
' a) When the module is being processed by the ASP interpreter
'    ----------------------------------------------------
' The first part of the module is actualy executable code written in ASP, but the second part
' of the module is passed over by the ASP interpreter because it thinks it is html code - which technically
' it is - so while the ASP interpreter in fact passes this part through to the client when the module is executed
' it doesn't appear on the user's screen because it is seen as "comments" by the browser
'
' b) When the module is executing as a program
'    -----------------------------------------
' The program fist figures out the location of itself (i.e. the filename on which the module itself resides)
' by means of examining variables made available by the server
' Once it has figured out the full path to this file, it reads the file as data and processes it thus:
'   1) It skips over and ignores any lines in the file until is sees a line containing "START" concatenated with "SCRIPT"
'   2) It takes subsequent lines and concatenates them into a command string until it finds one ending in a semi-colon
'   3) When it encounters a line ending in a semi-colon, it executes the command string (accumulated so far) as a SQL statement
'   4) It continues doing (2) and (3) until it sees a line containing "STOP" concatenated with "SCRIPT" whereupon it reverts to (1)
'   5) While doing (2) and (3) it ignores any line whose first character is # - i.e. treats it as a comment in the script
' In essence it is a script interpreter using the MySQL conventions for comments and end-of-command
'
%>
<html>
<head>
<title> Script Engine </title>
</head>
<style>
.Wrapper {
		border-width: 2px;
		border-style: solid;
		border-color: black;
		background-color: palegreen;
		padding-top: 5px;
		padding-bottom: 5px;
		padding-left: 15px;
		padding-right: 15px;
		}

</style>
<body bgcolor=cornsilk>

<%
' first we need to figure out the full pathname to the file we are being executed from, so we ourselves can read this file
Basepath  = Server.MapPath(".")
scriptname = Request.ServerVariables("script_name")

' Now pull out the actual filename from the full scriptname
a = InstrRev(scriptname, "/") ' Note this is always forward slash as it is an http URL and not a filepath
lambda = Len(scriptname)
b = Lambda - a
FileName = Right(scriptname,b)

' Now figure out if we want to use a forward or backward slash in assempling the path name - depends on our OS
xxxpos = Instr(Basepath, "\")
if xxxpos <> 0 then
   slash = "\"
else
   slash = "/"
end if

' Now we are ready to assemble the full pathname to the file
filepath = Basepath & slash & filename

' Set up a couple of other flags and constants we will be needing

bypass = "Yes"
tabchar = Chr(9)
startscriptflag = "START" & "SCRIPT"
stopscriptflag = "STOP" & "SCRIPT"

' -----------------------------------------------------------------------------------
'   CAUTION - This program is currently set to use the DSN as defined in global.asa
'
'  If using a different test database, replace the line following this comment block
'  withone that looks like
'
'            Application("myDSN") = "DSN=webcenter50_db;uid=wc50;pwd=wc50pass"
'
'  but with the parameter values adjusted as appropriate
' -----------------------------------------------------------------------------------

 myDSN=Application("myDSN")

' And now we can start executing real work

set conntemp=server.createobject("adodb.connection")
conntemp.open myDSN



 response.write "<font color=red size=+1>Processing The File " & FilePath & "</font><p>"

Set fs1 = CreateObject("Scripting.FileSystemObject")
REM the "1" in the next statement represents "ForReading"
Set b = fs1.OpenTextFile(FilePath, 1, FALSE)


linecounter = 0
SQL = ""

While not b.AtEndOfStream
   InRec  = b.Readline
   ' start processing a single line of input
   linecounter = linecounter + 1
   Inrec = Trim(InRec)
   Inrec = Replace(InRec,tabchar," ") ' replace any tab characters with a single space
   firstchar = Left(InRec,1)
   lastchar = Right(InRec,1)


   If InRec = "" Then
     'do nothing
   Elseif firstchar = "#" Then
      'do nothing
   Elseif Instr(InRec, startscriptflag) Then
      bypass = "No"
   Elseif Instr(InRec, stopscriptflag) Then
      bypass = "Yes"
   Elseif bypass = "Yes" Then
      ' do nothing
   Else
	response.write "<font size=-1> " & linecounter & " <font color=navy> "   & Replace(Inrec, " ", "&nbsp;") & "</font></font><br>"
	' concatenate this line into the end of the SQL statement
	SQL = SQL & Inrec & " "
   End If

   ' Now if we have hit a line that ends in semi-colon, then execute the accumulated SQL command

   If SQL <> "" and lastchar = ";" Then

   ' remove the semicolon (and the extra seaparator space we inserted) at the end of the SQL command
     xpos = Len(SQL)
     xpos = xpos-2
     SQL2 = Left(SQL, xpos)

     response.write "<p><font color=red>Executing</font><br><blockquote><div class=wrapper> " & SQL2 & "</div></blockquote><P>"
     response.flush
     set rstemp=conntemp.execute(SQL2)
     SQL = ""
   End if


Wend


b.Close
%>


<p>



<!-- STARTSCRIPT


# Any line starting with "#" is a comment line for the script engine - usefull for temporarily disabling lines



# V6 Table existing column definition changes of sizes
# Asset table columns were increased to allow for a more flexible asset management configuration


# This reports an error when attempting to change the size of these to 100 but it appears
# to work when changing the size of them directly in the database Access design tool.
# These have been commented out here for now.

ALTER TABLE Assets ALTER COLUMN app1 CHAR(100);
ALTER TABLE Assets ALTER COLUMN app1_product_id CHAR(100);
ALTER TABLE Assets ALTER COLUMN app1_install_date CHAR(100);

ALTER TABLE Assets ALTER COLUMN app2 CHAR(100);
ALTER TABLE Assets ALTER COLUMN app2_product_id CHAR(100);
ALTER TABLE Assets ALTER COLUMN app2_install_date CHAR(100);
#
ALTER TABLE Assets ALTER COLUMN app3 CHAR(100);
ALTER TABLE Assets ALTER COLUMN app3_product_id CHAR(100);
ALTER TABLE Assets ALTER COLUMN app3_install_date CHAR(100);
#
ALTER TABLE Assets ALTER COLUMN app4 CHAR(100);
ALTER TABLE Assets ALTER COLUMN app4_product_id CHAR(100);
ALTER TABLE Assets ALTER COLUMN app4_install_date CHAR(100);
#
ALTER TABLE Assets ALTER COLUMN app5 CHAR(100);
ALTER TABLE Assets ALTER COLUMN app5_product_id CHAR(100);
ALTER TABLE Assets ALTER COLUMN app5_install_date CHAR(100);
#
#ALTER TABLE Assets ALTER COLUMN app6 CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app6_product_id CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app6_install_date CHAR(100);
#
#ALTER TABLE Assets ALTER COLUMN app7 CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app7_product_id CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app7_install_date CHAR(100);
#
#ALTER TABLE Assets ALTER COLUMN app8 CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app8_product_id CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app8_install_date CHAR(100);
#
#ALTER TABLE Assets ALTER COLUMN app9 CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app9_product_id CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app9_install_date CHAR(100);
#
#ALTER TABLE Assets ALTER COLUMN app10 CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app10_product_id CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app10_install_date CHAR(100);
#
#ALTER TABLE Assets ALTER COLUMN app11 CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app11_product_id CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app11_install_date CHAR(100);
#
#ALTER TABLE Assets ALTER COLUMN app12 CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app12_product_id CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app12_install_date CHAR(100);
#
#ALTER TABLE Assets ALTER COLUMN app13 CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app13_product_id CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app13_install_date CHAR(100);
#
#ALTER TABLE Assets ALTER COLUMN app14 CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app14_product_id CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app14_install_date CHAR(100);
#
#ALTER TABLE Assets ALTER COLUMN app15 CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app15_product_id CHAR(100);
#ALTER TABLE Assets ALTER COLUMN app15_install_date CHAR(100);


STOPSCRIPT -->




</body>
</html>
