
<% 'Module: status.asp

   'Description: This module displays the system "status" showing the
   ' dispatcher screen  and all of open cases.


   '(C) 1998,1999, 2000, 2001, 2002 - 2006 Internet Software Sciences
   ' www.inet-sciences.com

   'History:

   'Date		Who		What
   '-------	---		------------------------------------------------
   '6/25/2000	SAV		Created original MyCases.asp page
   '3/27/05		SAV		Created from MyCases.asp page to show all open cases
   '11/1/2006	SAV		Created from DisplayAllOpenCAses.asp page
   '1/3/2013   CMB      7.0 -> 7.x

	' CONSTANTS
%>

<%' Get the Database DNS and login information - Edit this file to change the DSN connection string%>

<!-- #INCLUDE FILE="DB_define.inc" -->
<!-- #INCLUDE FILE="../Language/wcLabels.inc" -->
<!-- #INCLUDE FILE="../Language/CodeCustomizations.inc" -->


<%' Include this file to get special database cursor constants to read record count values %>
<!-- #INCLUDE FILE="Adovbs.inc" -->
<!-- #INCLUDE FILE="Reports.inc" -->

<% ' ASP Page Security Checks ***********************************
	' This security will check to see if the logged in tech member
	'has the right user level to
	' run this function.  If not, then display an error page.

	' Set the minumum tech security level required for this function.
	' 6 = Configurator = Highest Rights
	' 5 = Administrator
	' 4 = Dispatcher
	' 3 = Tech Read/Write
	' 2 = Tech Read only
	' 1 = No access - Lowest Rights

	TechLevel = 2 ' Allow valid techs to access this function.


	CookieID = Request.Cookies("ISS_TECH_CENTER_LOGIN") ' Get the Logged TechID from the cookie

	If SecurityON = "YES" Then ' Execute this code only if Security Option Flag is set to YES
		' This flag will be set in the db_define.inc file.

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN

		mySQL2="SELECT * from Tech_staff where Tech_ID = '" & CookieID & "' AND Tech_Level >= " & TechLevel
		set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF <> True Then
			TechFullName = rstemp("first_name") & " " & rstemp("Last_name")
			ValidUser = "YES" ' Set this variable to prevent problems on next page
			RealTech_Level = rstemp("Tech_Level")
'			response.write "RealTechLevel  = " & realtech_level
'			response.flush
'			response.end


		End If

		rstemp.close
		set rstemp=nothing
		conntemp.close ' Close the connection
		set conntemp=nothing
	Else
		ValidUser = "YES"

	End If


 ' End of ASP page security checks
 %>


<% if ValidUser <> "YES" Then %>
	<% ASPPage = "MyCases.asp"%>

	<!-- #include file=Invaliduser.inc-->

<%else '  Valid User for this function %>

<% 'Get the value of the User Screen background color
	' And the open Cases refresh rate from the Configuration Table

	set conntemp=server.createobject("adodb.connection")

	conntemp.open myDSN ' Open the connection once here

	mySQL2="select * from Configuration"
	set rstemp2=conntemp.execute(mySQL2)

	' Check to see if any records are returned
	' if none found the
	if rstemp2.EOF then
		UserPageColor = "FFFFFF" ' Default to white if record not found
	Else
		UserPageColor = rstemp2("ts_user_page_color")
		Pending_Screen_Refresh_Rate = rstemp2("Pending_Screen_Refresh_Rate")
		ts_pending_color = rstemp2("ts_Pending_Color")
		WCDateFormat = rstemp2("Date_Display_Format")
		TimeZoneAdjustment = rstemp2("Time_zone_Adjustment")

		DatabaseType2 = rstemp2("DatabaseType")

		if Version8point0="YES" Then
			If Not IsNull(rstemp2("AdditionalCustomerCaseAssignments")) Then
				bAdditionalCustomerCaseAssignments = rstemp2("AdditionalCustomerCaseAssignments")
			End If
			If Not IsNull(rstemp2("DueDateControls")) Then
				bDueDateControls = rstemp2("DueDateControls")
			'	response.write "DueDate set to " & bDueDateControls
			'	response.flush
			'	response.end


			End If

			EnableSMS = rstemp2("EnableSMS") ' Check if SMS is enabled

		End If




	End If

	rstemp2.close
	set rstemp2=nothing
	' Do NOT close connection here ... wait until end of module
	conntemp.close ' Close the connection
	set conntemp=nothing

%>


<HTML>
<HEAD>

<% If Pending_Screen_Refresh_rate <> 0 Then %>
   <META HTTP-EQUIV="Refresh" CONTENT="<%=Pending_Screen_Refresh_Rate%>">
<%End If %>

   <TITLE>Permit Manager</TITLE>
   <!-- #INCLUDE FILE="Stylesheet.inc" -->

<!-- (C) 1996,1998, 1999, 2000, 2001, 2002-2007 by Internet Software Sciences -->
</HEAD>


<% ' Now Display the system status %>

<% ' Get the statistics of the Cases

' Get Total number of open cases

	set conntemp=server.createobject("adodb.connection")

	conntemp.open myDSN ' Open the connection once here

	SqlTemp = "Select count(case_Number) as cnt from cases where status <> 1"  ' CMB 05/23/2011
	'sqltemp="select * from Cases where status <> 1"
	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.

	'If DatabaseType <> "ACCESS97" Then ' CMB 05/23/2011
		'rstemp.CursorLocation = adUseClient ' CMB 05/23/2011
	'End If ' CMB 05/23/2011

	rstemp.open sqltemp, conntemp, adopenstatic
	'TotalOpenCases = rstemp.recordcount
	TotalOpenCases = rstemp("cnt") ' CMB 05/23/2011
	rstemp.close
	set rstemp=nothing

%>

<% ' Closed Cases Today

' Get Total number of closed cases for today


	' We must very carefully create the date string that we are going to
	' use in the SQL instruction since the system can easily
	' return incorrect values like 9/12/99 or 09/12/1999
	' depending upon their regional settings so this code
	' will hopefully extract the right values.

	CurrentDateFormatted = CreateCurrentDateFormatted() ' CMB use function call

	sqltemp="select count(Case_Number) as cnt from Cases where status = 1 AND Mod_Date = '" & CurrentDateFormatted & "'"
	'sqltemp="select * from Cases where status = 1 AND Mod_Date = '" & CurrentDateFormatted & "'"
	set rstemp=Server.CreateObject("adodb.Recordset")

	'-->AKS<-- Need to specify cursore for record count to be correct.
	'If DatabaseType <> "ACCESS97" Then
		'rstemp.CursorLocation = adUseClient
	'End If

	rstemp.open sqltemp, conntemp, adopenstatic
	'CasesClosedToday = rstemp.recordcount
	CasesClosedToday = rstemp("cnt") ' CMB 05/23/2011
	rstemp.close
	set rstemp=nothing

%>

<% ' Cases Opened Today

' Get Total number of open cases for today

	CurrentDate = FormatDateTime( Date, vbGeneralDate)

	' Current Date will be return in MM/DD/YY and we want it  YYYYMMDD format
	' The next steps moves the strings around


	'sqltemp="select * from Cases where Open_Date = '" & CurrentDateFormatted & "'"
	sqltemp="select count(Case_Number) as cnt from Cases where Open_Date = '" & CurrentDateFormatted & "'"

	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.
	'If DatabaseType <> "ACCESS97" Then
		'rstemp.CursorLocation = adUseClient
	'End If

	rstemp.open sqltemp, conntemp, adopenstatic
	'CasesOpenedToday = rstemp.recordcount
	CasesOpenedToday = rstemp("cnt")
	rstemp.close
	set rstemp=nothing

%>

<% ' Cases Opened and Closed Today

' Get Total number of open cases for today


	'sqltemp="select * from Cases where Status = 1 AND Open_Date = '" & CurrentDateFormatted & "'"
	sqltemp="select count(case_Number) as cnt from Cases where Status = 1 AND Open_Date = '" & CurrentDateFormatted & "'"

	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.
	'If DatabaseType <> "ACCESS97" Then
		'rstemp.CursorLocation = adUseClient
	'End If
	rstemp.open sqltemp, conntemp, adopenstatic
	'OpenedClosedToday = rstemp.recordcount
	OpenedClosedToday = rstemp("cnt")

	rstemp.close
	set rstemp=nothing

%>

<% ' Cases Opened and still open Today

' Get Total number of open cases for today

	'sqltemp="select * from Cases where Status <> 1 AND Open_Date = '" & CurrentDateFormatted & "'"
	sqltemp="select count(Case_Number) as cnt from Cases where Status <> 1 AND Open_Date = '" & CurrentDateFormatted & "'"

	set rstemp=Server.CreateObject("adodb.Recordset")

	'-->AKS<-- Need to specify cursore for record count to be correct.
	'If DatabaseType <> "ACCESS97" Then
		'rstemp.CursorLocation = adUseClient
	'End If

	rstemp.open sqltemp, conntemp, adopenstatic
	'OpenedstillOpenToday = rstemp.recordcount
	OpenedstillOpenToday = rstemp("cnt")
	rstemp.close
	set rstemp=nothing

%>

<% ' Cases Opened today, still open, un-assigned to other group other than default

' Get Total number of open cases for today


	' First get the group_number of the default group from the Group_List table

	sqltemp="select * from Group_list where Default_flag = 1"
	set rstemp=Server.CreateObject("adodb.Recordset")
	rstemp.open sqltemp, conntemp, adopenstatic
	if not rstemp.bof then
		rstemp.MoveFirst
	end if
	DefaultGroupNumber  = rstemp("Group_Number")
	rstemp.close
	set rstemp=nothing

	' first Cases that are still open for today
	'sqltemp="select * from Cases where Status <> 1 AND Open_Date = '" & CurrentDateFormatted & "' AND Group_Number = "& DefaultGroupNumber
	sqltemp="select count(Case_Number) as cnt from Cases where Status <> 1 AND Open_Date = '" & CurrentDateFormatted & "' AND Group_Number = "& DefaultGroupNumber
	set rstemp=Server.CreateObject("adodb.Recordset")

	'-->AKS<-- Need to specify cursore for record count to be correct.
	'If DatabaseType <> "ACCESS97" Then
		'rstemp.CursorLocation = adUseClient
	'End If

	rstemp.open sqltemp, conntemp, adopenstatic
	'CasesUnassignedToGroup = rstemp.recordcount
	CasesUnassignedToGroup = rstemp("cnt")

	rstemp.close
	set rstemp=nothing

%>

<% ' Get Total number of Cases

	sqltemp="select count(case_Number) as cnt from Cases"
	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.
	'If DatabaseType <> "ACCESS97" Then
		'rstemp.CursorLocation = adUseClient
	'End If

	rstemp.open sqltemp, conntemp, adopenstatic
	'TotalCases = rstemp.recordcount
	TotalCases = rstemp("cnt")
	rstemp.close
	set rstemp=nothing

%>

<% ' Get Total number of Customers

'	connectMe=myDSN
	sqltemp="select count(customer_ID) as cnt from Customers"
	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.

	'If DatabaseType <> "ACCESS97" Then
		'rstemp.CursorLocation = adUseClient
	'End IF
	rstemp.open sqltemp, conntemp, adopenstatic
	'TotalCustomers = rstemp.recordcount
	TotalCustomers = rstemp("cnt")
	rstemp.close
	set rstemp=nothing

%>

<% ' Get number of available techs

'	connectMe=myDSN
	'sqltemp="select * from Tech_staff where availability = 1"
	sqltemp="select count(tech_ID) as cnt from Tech_staff where availability = 1"

	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.
	'If DatabaseType <> "ACCESS97" Then
		'rstemp.CursorLocation = adUseClient
	'End IF

	rstemp.open sqltemp, conntemp, adopenstatic
	'AvailableStaff = rstemp.recordcount
	AvailableStaff = rstemp("cnt")
	rstemp.close
	set rstemp=nothing

%>

<% ' Get number of un-available techs

'	connectMe=myDSN
	sqltemp="select count(tech_ID) as cnt from Tech_staff where availability <> 1"
	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.
	'If DatabaseType <> "ACCESS97" Then
		'rstemp.CursorLocation = adUseClient
	'End If

	rstemp.open sqltemp, conntemp, adopenstatic
	UnAvailableStaff = rstemp("cnt")
	rstemp.close
	set rstemp=nothing


' Now close the database connection
	conntemp.close ' Close the connection
	set conntemp=nothing


%>

<% ' Display the List of other techs to show their contacts
%>
<body class=rightwindow>
<P>
<CENTER>
<Table class=BGWrapper>
<tr>
     <td class=tinyprint valign=top><a href=newcase.asp><img src=../language/new_permit.png></a>&nbsp;&nbsp;&nbsp;<a href=getcase.asp><img src=../language/get_permit.png></a>&nbsp;&nbsp;&nbsp;<a href=search.asp><img src=../language/search_permits.png></a></td>
</tr>
</table>

<br>
<center>
<table class=outerformwrapper width=95% cellspacing=1 cellpadding=3>
<tr>
<TD>
        <table  class=InnerformWrapper align=center width=80%>
<tr>

<th align=center colspan=2 bgcolor=E0E0E0 width=50%  class=TightBodyTextHiLight>
<%=wc_Case_Summary_Information%></th>
<th align=center colspan=2 bgcolor=E0E0E0 width=50% class=TightBodyTextHiLight>
<%=wc_Total_System_Status%></th></tr>

<tr>
<td width=40% class=TightBodyText>
<b><%=wc_Total_Open_Cases%></b></td>
<td  width=10% align=center class=TightBodyText>
<%=TotalOpenCases%></td>
<td width=40% class=TightBodyText><B><%=wc_Total_Customers%></b></td>
<td width=10% align=center class=TightBodyText> <%=TotalCustomers%></td> </tr>

<tr>


<tr><td width=25% class=TightBodyText><b><%=wc_Cases_Closed_Today%></b></td>
<td  width=10% align=center class=TightBodyText><font size=-1><%=CasesClosedToday%></td>

<td class=TightBodyText><B><%=wc_Total_Number_Of_Cases%></b></td>
<td width=10% align=center class=TightBodyText><%=TotalCases %></td>
</tr>

<tr><td class=TightBodyText>
<b><%=wc_Cases_Opened_Today%></b></td>
<td width=10%  class=TightBodyText align=center><%=CasesOpenedToday%></td>

<td class=TightBodyText ><B><%=wc_Available_Tech_staff%></b></td>
<td class=TightBodyText width=10% align=center> <%=AvailableStaff%></td></tr>

<tr>

<td class=TightBodyText><B> Cases Open and Closed Today</b>

</td><td width=10% align=center class=TightBodyText>
<%=OpenedClosedToday%>

</td>
<td class=TightBodyText><B><%=wc_Busy_Tech_staff%></b></td>
<td class=TightBodyText width=10% align=center><%=UnAvailableStaff%></td></tr>
</table>
</TD></TR></TABLE>
</center>





<% ' First Display the tech/dispatcher screen %>

<hr>



<Center>


        <center>
        <table  class=outerformwrapper cellspacing=1 cellpadding=3 width=95% >
<TR><TD align=center>
<TABLE class=innerformwrapper width=90%>
	<%' Display the Staff availability, name, phone, phone/cell and email with links

	set conntemp=server.createobject("adodb.connection")

	conntemp.open myDSN ' Open the connection once here

	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.

	If DatabaseType <> "ACCESS97" Then
		rstemp.CursorLocation = adUseClient
	End If

	mySQL="select * from Tech_staff where show_dispatch_flag = 1 order by Last_name, first_name"

	set rstemp=conntemp.execute(mySQL)


	' Check to see if any records are returned
	' if none found then login fails.
	If  rstemp.eof then ' Check to see any Cases exist
		response.write "<center>No Tech Contacts found</center><P>"
	Else
%>
	<tr>
	<td></td>

	<td></td>

	<td class=menutext align=center><%=wc_Jobs%></td>

	<td class=menutext align=center><%=wc_Phone%></td>

	<td class=menutext align=center><%=wc_Phone2_Cell%></td>

	<td class=menutext align=center><%=wc_Email%></td>

	<td class=menutext align=center><%=wc_Notes%></td>
	</tr>

<%
		Do While rstemp.EOF <> True


	%>
	<tr>
	<td>

	<% ' Availability States are 1 = Available and 2 = Busy %>
	<% ' It may not be set properly so check for that %>


	<%  Availability = rstemp("Availability")
	If IsNull(Availability) = True Then
	%>
		<img src=red-on.gif>
	<%Else

		If CInt(rstemp("Availability")) = 1 Then
	%>
		<img src=green-on.gif>
		<%Else %>
			<img src=red-on.gif>
		<%End If %>
	<%End If %>

	</td>

	<td class=datavalue nowrap>
				<%=rstemp("First_Name")%>
				<%
					response.write " "
				%>

				<%=rstemp("Last_Name")%> <br>
			</td>

	<% ' Now determine how many open jobs this tech has
	mySQL4="select * from Cases where Tech_id = '" & rstemp("Tech_ID") & "' and Status <> 1"

	set rstemp4=conntemp.execute(mySQL4)


	' Check to see if any records are returned
	' if none found then login fails.
	If  rstemp4.eof then ' Check to see any Cases exist
		AssignedCases = 0
	Else
		AssignedCases = 0
		Do While Rstemp4.EOF <> True
			AssignedCases = AssignedCases + 1
			rstemp4.MoveNext
		Loop

	End If

	rstemp4.Close ' Close the recordset
	set rstemp3=nothing


	%>

	<td align=center class=formlabel nowrap>
		<%=AssignedCases%>
	</td>


	<td align=center class=formlabel nowrap>
	<%=rstemp("Work_Phone1") %><br>
	</td>

	<td align=center class=formlabel nowrap>



<% If Version8point0 = "YES" and EnableSMS = True  Then  ' Special SMS message block

CaseVector2 = "SendSMSTechPopup.asp?Tech_ID=" & rstemp("Tech_ID")'
%>

	<a href='javascript:var w=window.open("<%=CaseVector2%>","subwindow","width=600,height=300,screenX=50,screenY=50,left=50,top=50,scrollbars=yes,resizable=yes")'><%=rstemp("Work_Phone2") %></a><br>

<% Else %>
<%=rstemp("Work_Phone2") %>

<% End If %>

	</td>

	<td align=center class=formlabel nowrap>
	<a href=mailto:<%=rstemp("Work_Email") %>>
	<% response.write "" %>
	<%=rstemp("Work_Email")%></a><br>
	</td>
	<td class=formlabel>
	<%=rstemp("Notes") %><br>
	</td>

	</tr>

	<%
			rstemp.movenext
		loop

	End IF

	rstemp.close
	set rstemp=nothing
	conntemp.close ' Close the connection
	set conntemp=nothing

	%>

		</table>
</TD></TR></Table>


<% ' Now search for the open Cases for a specified tech
	' It can be called from the button panel as MyCases.asp where the Logged in
	' tech cookie is found and use to define the tech or it is called
	' from other Cases, the techID is passed as a query string

	If Request.Querystring("TechID") <> "" Then
		CookieID = Request.Querystring("TechID")
	End IF

		set conntemp=server.createobject("adodb.connection")
		conntemp.open myDSN


		ViewType = Request.QueryString("ViewType")

		' Force ViewType = TODAY

		ViewType = "TODAY"

			' Possible ViewTypes are: ALL, ONCE, REPEAT, LATE, TODAY

		'  * * * * * * Time Zone Adjustment Calculation * * * * *

		' Late is computed by comparing the Date and time with the system time
		' A special date computation is needed if TimeZoneAdjustment is set.
		If TimeZoneAdjustment = "" Or IsNull(TimeZoneAdjustment) = True Then
				TimeZoneAdjustmentInt = 0
			Else
				TimeZoneAdjustmentInt = CInt(TimeZoneAdjustment)
		End If

		NewDate = DateAdd("h", TimeZoneAdjustmentInt, Now)
		NewDateDateOnly = DateValue(NewDate)
		NewTime = TimeValue(NewDate)

		' Important Note
		' SQL*Server Time/Date deliminter is single quote and not # which is
		' for Access

		' This is a special case when we need to know if it is Access or
		' SQL*Server.  We must use the # symbol for Access and single
		' quotes for SQL*Server

	' SQL 2005 Fix
	' Create a FixedDate value for users with SQL and UK settings

	If (DatabaseType2 = "SQLSERVER") AND  (WCDateFormat = "DDMMYYYY") Then

	   DIM aryChunk
	   DateString = Date

	   aryChunk = Split(datestring,"/")
	   FixedDate = aryChunk(1) & "/" & aryChunk(0) & "/" & aryChunk(2)

	 Else

	 	FixedDate = Date ' Do not modify date if not UK and SQL Server
	 	'debug
	 	'response.write "FixedDate = " & FixedDate


	 End IF


		If DatabaseType <> "ORACLE" Then
			mySQL2 = " SELECT Group_list.group_name, Cases.case_number, Cases.Scheduled_Case_Type, Cases.Due_Date, Cases.Due_Time, Cases.customer_id, Cases.open_date, Cases.open_time, Cases.mod_date, Cases.mod_time, Cases.case_one_line, Cases.severity, Cases.status, Cases.modified_flag, Customers.contact_lname, Customers.contact_fname, Customers.company FROM (Cases INNER JOIN Group_list ON Cases.group_number = Group_list.group_number) INNER JOIN Customers ON Cases.customer_id = Customers.customer_id "

			' Depending upon the type of ViewType, change the WHERE statement
			If ViewType = "ALL" Then
				mySQL2 = mySQL2 & "	where Scheduled_Case_Type IS NOT Null AND  Status <> 1 "
			Elseif ViewType = "ONCE" Then
				mySQL2 = mySQL2 & "	where Scheduled_Case_Type = 'ONCE' AND  Status <> 1 "
			Elseif ViewType = "REPEATED" Then
				mySQL2 = mySQL2 & "	where Scheduled_Case_Type ='REPEAT' AND  Status <> 1 "



			Elseif ViewType = "LATE" and DatabaseType2 = "SQLSERVER" Then
				mySQL2 = mySQL2 & "	where Scheduled_Case_Type IS NOT NULL AND  Due_Date <= '" & NewDateDateOnly & "' And Due_Time <= '"& NewTime & "' AND Status <> 1 "
			Elseif ViewType = "LATE" and DatabaseType2 = "ACCESS" Then
				mySQL2 = mySQL2 & "	where Scheduled_Case_Type IS NOT NULL AND  Due_Date <= #" & NewDateDateOnly & "# And Due_Time <= #"& NewTime & "# AND Status <> 1 "
			Elseif ViewType = "LATE" and DatabaseType2 = "MYSQL" Then
				mySQL2 = mySQL2 & "	where Scheduled_Case_Type IS NOT NULL AND  Due_Date <= '" & YYMMDD(NewDateDateOnly) & "' And Due_Time <= '"& NewTime & "' AND Status <> 1 "



			Elseif ViewType = "TODAY" and DatabaseType2 = "SQLSERVER" Then
			'	mySQL2 = mySQL2 & "	where Scheduled_Case_Type IS NOT NULL AND  Due_Date = '" & FixedDate & "'  AND Status <> 1 "
				mySQL2 = mySQL2 & "	where  Due_Date = '" & FixedDate & "'  AND Status <> 1 "

			Elseif ViewType = "TODAY" and DatabaseType2 = "ACCESS" Then
			'	mySQL2 = mySQL2 & "	where Scheduled_Case_Type IS NOT NULL AND  Due_Date = #" & Date & "#  AND Status <> 1 "
				mySQL2 = mySQL2 & "	where Due_Date = #" & Date & "#  AND Status <> 1 "

			Elseif ViewType = "TODAY" and DatabaseType2 = "MYSQL" Then
				mySQL2 = mySQL2 & "	where Scheduled_Case_Type IS NOT NULL AND  Due_Date = '" & YYMMDD(Date) & "'  AND Status <> 1 "


			End IF
		End If

		If DatabaseType = "ORACLE" Then
			mySQL2 = " SELECT Group_list.group_name, Cases.case_number,  Cases.Scheduled_Case_Type, Cases.Due_Date, Cases.Due_Time, Cases.customer_id, Cases.open_date, Cases.open_time, Cases.mod_date, Cases.mod_time, Cases.case_one_line, Cases.severity, Cases.status, Cases.modified_flag, Customers.contact_lname, Customers.contact_fname, Customers.company FROM Cases, Group_list, Customers WHERE Cases.customer_id=Customers.customer_id AND Cases.group_number = Group_list.group_number AND Cases.customer_id = Customers.customer_id AND Tech_ID = '" & CookieID & "' AND Status <> 1 "
		End If


		' Now add Sort Order and toggle sort order if necessary

		SortOrder = Request.Querystring("SortBy")

		' Define Default Sort Orders that will be changed below to
		' toggle the views from Ascending to Decending

		AscendDescend = Request.Querystring("Ascend")
		If AscendDescend = "" Then
			AscendDescend = "ASC"
		End If


		If AscendDescend = "ASC" Then
			AscendDescend = "DESC"
		Else
			AscendDescend = "ASC"
		End If

		If SortOrder = "case_number" OR SortOrder = ""  Then
			FixedSortOrder = " Case_Number "
			Case_Number_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "severity"  Then
			FixedSortOrder = " Severity"
			Severity_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "open_time"  Then
			FixedSortOrder = " Open_Date " & AscendDescend & ", Open_Time "
			Open_time_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "Due_Date"  Then
			FixedSortOrder = " Due_Date " & AscendDescend & ", Due_Time "
			mod_time_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "contact_fname"  Then
			FixedSortOrder = " contact_fname "
			contact_fname_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "group_name"  Then
			FixedSortOrder = " group_name "
			group_name_Background = " bgcolor=FFFFFF "
		End IF

		If SortOrder = "status"  Then
			FixedSortOrder = " status "
			status_Background = " bgcolor=FFFFFF "
		End IF


		mySQL2 = mySQL2 & " Order by " & FixedSortOrder  & " " & AscendDescend

		'response.write "MySQL = " & mySQL2 & "<br>"


	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.

	If DatabaseType <> "ACCESS97" Then
		rstemp.CursorLocation = adUseClient
	End If

	rstemp.open mySQL2, conntemp, adopenstatic


		'set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF <> True Then

		RecordsFound = rstemp.recordcount

	 ' We need to get the tech name directly from the database since we won't have
		' the tech name since no rows were returned

		MySQL3 = " Select * from Tech_staff where tech_ID =  '" & CookieID & "'"

		set rstemp2=Server.CreateObject("adodb.Recordset")

		rstemp2.open mySQL3, conntemp, adopenstatic

		If rstemp2.EOF <> "True" Then
			TechFullName = rstemp2("First_Name") & " " & rstemp2("Last_name")
		Else
			TechFullName = "Tech Not Defined"
		End IF
		rstemp2.close
		set rstemp2=nothing


	%>

	<% ' Display Different message for the various types of ViewTypes %>
<center>
<table class=BGWrapper>
<tr>
<td class=TitleInsert><%=RecordsFound %>  </td>
<td class=TitleInsert>&nbsp;
	<% If ViewType = "ALL" Then %>
	 Open Scheduled Cases Found
	<%End If %>

	<% If ViewType = "ONCE" Then %>
	 Single Event Scheduled Cases Found
	<%End If %>

	<% If ViewType = "REPEATED" Then %>
	 Repeat Scheduled Cases Found
	<%End If %>

	<% If ViewType = "LATE" Then %>
	 Late Scheduled Cases Found
	<%End If %>

	<% If ViewType = "TODAY" Then %>
		<% If RecordsFound >1 then %>
	 		Cases Due Today
		<%Else %>
			Case Due Today
		<%End If %>
	<%End If %>
&nbsp;</td>
</tr>

</table>

<table cellpadding=0 cellspacing=0><tr><td height=0></td> </tr></table> <!-- little spacer  -->

<% ' Display the Table Headers %>

<TABLE  class=TightTableWrapper cellspacing=1>
<TR>
<TD  class=ColumnLabel align=center><A HREF="status.asp?ViewType=<%=ViewType%>&TechID=<%=CookieID%>&SortBy=case_number&Ascend=<%=AscendDescend%>">Case</A></TD>

<TD  class=ColumnLabel align=center><A HREF="status.asp?ViewType=<%=ViewType%>&TechID=<%=CookieID%>&SortBy=severity&Ascend=<%=AscendDescend%>">Priority</A></TD>

<TD  class=ColumnLabel align=center><A HREF="status.asp?ViewType=<%=ViewType%>&TechID=<%=CookieID%>&SortBy=status&Group_Number=<%=Group_Number%>&Ascend=<%=AscendDescend%>">Status</A></TD>


<TD  class=ColumnLabel align=center><A HREF="status.asp?ViewType=<%=ViewType%>&TechID=<%=CookieID%>&SortBy=open_time&Ascend=<%=AscendDescend%>">Opened</A></TD>

<TD  class=ColumnLabel align=center><A HREF="status.asp?ViewType=<%=ViewType%>&TechID=<%=CookieID%>&SortBy=Due_Date&Ascend=<%=AscendDescend%>">Due</A></TD>

<TD  class=ColumnLabel align=center><A HREF="status.asp?ViewType=<%=ViewType%>&TechID=<%=CookieID%>&SortBy=contact_fname&Ascend=<%=AscendDescend%>">Customer</a> / One Line Description</TD>

<TD  class=ColumnLabel align=center><A HREF="status.asp?ViewType=<%=ViewType%>&TechID=<%=CookieID%>&SortBy=group_name&Ascend=<%=AscendDescend%>">Group</A></TD>
</TR>

<%

			do while not rstemp.eof

			If CInt(rstemp("Modified_Flag")) = 0 Then
				FontColor= "000000" ' Black font color
			Else
				FontColor = "FF0000" ' All Red
			End If
' New enhancement to have the font color based  on priority/severity

	Severity = rstemp("severity")

	If Severity = 0 Then
				FontColor= "000000" ' Black font color
	elseif Severity = 1 then
				FontColor= "FF0000" ' red font color
	elseif Severity = 2 then
				FontColor= "0000FF" ' blue font color
	elseif Severity = 3 then
				FontColor= "00FF00" ' green font color
	elseif Severity = 4 then
				FontColor= "FF4500" ' orange-red font color
	elseif Severity = 5 then
				FontColor= "FF00FF" ' magenta font color
	elseif Severity = 6 then
				FontColor= "8B4513" ' brown font color
	elseif Severity > 6 then
				FontColor= "808080" ' grey font color

	End IF




	%>
<TR>
<TD WIDTH="4%">
   <% If Case_Number_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>


<B>

<% ' If case_number is less than 1000, then fill to the left with extra zeros

	Case_Number = rstemp("Case_Number")

	If len(case_number) = 1 Then
		DisplayCaseNumber = "000" & Case_Number
	ElseIf LEn(case_number) = 2 Then
		DisplayCaseNumber = "00" & Case_Number
	Elseif Len(case_number) = 3 Then
		DisplayCaseNumber = "0" & Case_Number
	Else
		DisplayCaseNumber = Case_Number
	End If
%>


<A HREF="TCaseForm.asp?b_get_x=0&b_get_y=0&customer_id=0&case_number=<%=Case_number%>" target="user_screen"><%=DisplayCaseNumber%></A></B>&nbsp;<BR>
<A HREF=TCaseForm.asp?b_get_x=0&b_get_y=0&customer_id=0&case_number=<%=rstemp("Case_number")%> target="newcasewindow<%=rstemp("Case_number")%>"><IMG SRC="newwindow.gif" BORDER=0 ></A></TD>

<TD
   <% If Severity_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>
>

<FONT COLOR="#<%=FontColor%>">

<%= PriorityFullDescription(rstemp("Severity")) %>


</FONT></TD>

<TD
   <% If status_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

><FONT COLOR="#<%=FontColor%>">

<% ' Case Status Mappings
	' 0 = Active
	' 1 = closed
	' 2 = Wating
	' 3 = On-Hold
%>
<%
	Case_status_value = CInt(rstemp("status"))
	If case_status_value = 0 THEN
		response.write "Active"
	ElseIf case_status_value = 2 THEN
		response.write "Waiting"
	Else
		response.write "On-Hold"
	End If
%>


</FONT>

<% ' Now Display the Scheduled Case Status Too



	Due_Date = rstemp("Due_Date")
	Due_Time = rstemp("Due_Time")

	' * * * * * * * User Customizations * * * * * * * *
	' Disable/Enable Blink Tag Here - Comment out next two lines ***********
	StartBlinkTag = "<blink>"
	EndBlinkTag = "</blink>"
	' * * * * * * End User Customizations * * * * * * * * *

	If IsNull(Due_Date) = False AND IsNull(Due_Time) = False Then


		If Due_date < NewDateDateOnly Then
			response.write "<font size=-1 color=RED>"
			response.write StartBlinkTag & "LATE" & EndBlinkTag & "</font>"
		Elseif Due_date = NewDateDateOnly AND  Due_Time <= NewTime Then
			response.write "<font size=-1 color=RED>"
			response.write StartBlinkTag & "LATE" & EndBlinkTag & "</font>"
		Else
			response.write "<font size=-1 color=GREEN>"
			response.write "OK</font>"
		End IF
	End IF

%>

</TD>

<TD ALIGN=CENTER WIDTH="9%"
   <% If Open_time_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

>
<FONT COLOR="#<%=FontColor%>">


<% ' Date and Time must be reformatted from the internal Text format of:
	' YYYYMMDD to mm/dd/yyyy
	' And Time must be converted from: HHMMSS in 24 hour format to AM/PM formats

	' Depending upon the WCDateFormat Setting (set in DB_define.inc) we will
	' display the date in
	' in MM/DD/YYYY (US Version and default) or DD/MM/YYYY for UK version

	If WCDateFormat = "DDMMYYYY" Then
		ConvertedOpenDate =   mid(rstemp("open_date"),7,2) & "/" & mid(rstemp("open_date"),5,2) & "/" & mid(rstemp("open_date"),1,4)
	Else
		ConvertedOpenDate = mid(rstemp("open_date"),5,2) & "/" & mid(rstemp("open_date"),7,2) & "/" & mid(rstemp("open_date"),1,4)
	End IF

	ConvertedOpenTime = mid(rstemp("Open_time"), 1,2) & ":" & mid(rstemp("Open_time"),3,2)

	ConvertedHour = int(mid(rstemp("Open_time"),1,2))
	If ConvertedHour > 12 then
		ConvertedHour = ConvertedHour -12
		AMPM = " PM"
		ConvertedOpenTime = CStr(ConvertedHour) & mid(ConvertedOpenTime, 3,3)
	Else
		AMPM = " AM"
	End If

%>

<%=ConvertedOpenDate%><Br>
<%=ConvertedOpenTime%><%=AMPM%>



</FONT>
</TD>

<TD ALIGN=CENTER WIDTH="9%"
   <% If mod_time_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

>
<FONT COLOR="#<%=FontColor%>">


<% ' Display the Date in UK or US formats depending upon configuration value %>
<% 	If WCDateFormat = "DDMMYYYY" Then ' Set to UK date formats
		DateDisplayString = Day(rstemp("Due_Date")) & "/" & Month(rstemp("Due_Date")) & "/" & Year(rstemp("Due_Date"))
	Else
		DateDisplayString = Month(rstemp("Due_Date")) & "/" & Day(rstemp("Due_Date")) & "/"  & Year(rstemp("Due_Date"))
	End IF

%>
<%=DateDisplayString%><br>

<%' Create Time Display String %>
<% ' Check if Due_Time is Null %>

<%
If ISNull(rstemp("Due_Time")) = False Then

	 DueHour = Hour(rstemp("Due_Time"))

	If DueHour > 12 Then
		DueHour = DueHour - 12
	End If


	DueHour = CStr(DueHour)
	If Len(DueHour) < 2 Then
		DueHour = "0" & DueHour
	End If
	DueMinute = CStr(Minute(rstemp("Due_Time")))
	If Len(DueMinute) < 2 Then
		DueMinute = "0" & DueMinute
	End If

	AMPM = Right(CStr(rstemp("Due_Time")),2)

	DisplayTimeString = DueHour & ":" & DueMinute & " " & AMPM
%>

<%=DisplayTimeString %>

<%	Else ' Display no time setting %>

--:--

<%End If %>

</FONT>

</TD>

<TD WIDTH="56%"
   <% If contact_fname_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

>
<FONT COLOR="#<%=FontColor%>">

(
<a href=NewCustomer.asp?ID=<%=rstemp("Customer_ID")%> target= "user_screen">
<%=rstemp("Contact_fname")%>
<% response.write " " %>
<%=rstemp("Contact_lname")%></a>)

<% ' Display the company name only if it exists
	If rstemp("Company") <> "" Then
		Response.write " [" & rstemp("Company") & "]"
	End If
%>

<br>


<B><%=rstemp("Case_One_Line")%></b></FONT></FONT></TD>

<TD WIDTH="12%"
   <% If group_name_Background = "" Then
          response.write "class=TightBodyText"
      Else
          response.write "class=TightBodyTextHilight"
      End If %>

><FONT COLOR="#<%=FontColor%>"><%=rstemp("Group_Name")%>
</FONT>
</TD>
</TR>

<%

				rstemp.MoveNext
			loop

		Else
	%>

<% ' We need to get the tech name directly from the database since we won't have
	' the tech name since no rows were returned

	MySQL3 = " Select * from Tech_staff where tech_ID =  '" & CookieID & "'"

	set rstemp2=Server.CreateObject("adodb.Recordset")

	rstemp2.open mySQL3, conntemp, adopenstatic

	If rstemp2.EOF <> "True" Then
		TechFullName = rstemp2("First_Name") & " " & rstemp2("Last_name")
	Else
		TechFullName = "Tech Not Defined"
	End IF
	rstemp2.close
	set rstemp2=nothing
%>

<!--<Div class = "TightBodyTextHilight">

<CENTER>No permits found scheduled for today</CENTER>

</div>-->


		<%End If %>

	<%	 ' Close the record set and close the connection

		rstemp.close
		set rstemp=nothing

		' Close the only connection to the database

		conntemp.close ' Close the connection
		set conntemp=nothing
	%>


</TABLE>
<%

View = Request.Querystring("View")


If View = "" Then
	View = "MyOpenProjects"
End if



If view = "MyOpenProjects" Then

	Wherestatement = " WHERE ProjectLeader = '" & cookieID & "' AND ProjectStatus = 0"
	OrderBy = " ORDER By ProjectDueDate ASC"
	TableHeader = " My Open Projects"

End If


If view = "AllClosedProjects" Then

	Wherestatement = " WHERE ProjectStatus = 1"
	OrderBy = " ORDER By ProjectDueDate ASC"
	TableHeader = " All Closed Projects"



End If

If view = "AllOpenProjects" Then

	Wherestatement = " WHERE ProjectStatus = 0"
	OrderBy = " ORDER By ProjectDueDate ASC"
	TableHeader = " All Open Projects"


End If

If view = "AllProjects" Then

	Wherestatement = ""
	OrderBy = " ORDER By ProjectDueDate ASC"
	TableHeader = " All Open and Closed Projects"



End If



' Debugging
'response.write "Where = " & Wherestatement
'response.flush
'response.end

		mySQL2 = "SELECT Projects.[ProjectID], Projects.[ProjectName], Projects.[ProjectLeader], Projects.[ProjectDescription], Projects.[HoursEstimated], Projects.[ResourcesEstimated], Projects.[MakePublic], Projects.[ProjectReferenceNumber], Projects.[ProjectStatus], Projects.[AdditionalProjectMembers], Projects.[ProjectDueDate], tech_staff.first_name, tech_staff.last_name FROM Projects "
		'mySQL2 = mySQL2 & " INNER JOIN tech_staff ON Projects.ProjectLeader = tech_staff.tech_id"  ' CMB i think this needs to be outer
		mySQL2 = mySQL2 & " LEFT OUTER JOIN tech_staff ON Projects.ProjectLeader = tech_staff.tech_id"  ' CMB i think this needs to be outer

	mySQL2 = mySQL2  & WhereStatement & OrderBy


'		mySQL2 = mySQL2 & " Order by " & FixedSortOrder  & " " & AscendDescend

		'response.write "MySQL = " & mySQL2 & "<br>"

	set conntemp=server.createobject("adodb.connection")

	conntemp.open myDSN ' Open the connection once here


	set rstemp=Server.CreateObject("adodb.Recordset")
	'-->AKS<-- Need to specify cursore for record count to be correct.

	If DatabaseType <> "ACCESS97" Then
		rstemp.CursorLocation = adUseClient
	End If

	rstemp.open mySQL2, conntemp, adopenstatic


		'set rstemp=conntemp.execute(mySQL2)

		' Check to see if any records are returned
		' if none found the

		If rstemp.EOF <> True Then

		RecordsFound = rstemp.recordcount

' Display the Table Headers

%>




<TABLE class=TightTableWrapper cellspacing=1 width = 100%  >






<Tr>
<TD  class=MinorFormTitle align=center colspan=5>
<%= TableHeader %>
<td>
</tr>


<TR>
<TD  class=ColumnLabel align=center>PROJECT</TD>

<TD  class=ColumnLabel align=center>#</TD>

<TD  class=ColumnLabel align=center>Project Lead</TD>

<TD  class=ColumnLabel align=center>Date Due</TD>

<TD  class=ColumnLabel align=center>Status</TD>

</TR>

<%

			do while not rstemp.eof

	' Code here to get project rows


%>
	<TR>

	<TD align=left class=TightBodyText > <a href=MakeProject.asp?ID=<%=rstemp("ProjectID")%>><%= rstemp("ProjectName") %></a>

  </td>

	<TD align=center class=TightBodyText >  <%= rstemp("ProjectID") %>

  </td>
	<TD align=center class=TightBodyText >  <%= rstemp("First_name") %>&nbsp;<%=rstemp("Last_name") %>


  </td>

	<TD align=center class=TightBodyText >  <%= rstemp("ProjectDueDate") %>

  </td>

<% if rstemp("ProjectStatus") = 0 then

%>

	<TD align=center class=TightBodyText >  OPEN

  </td>

<% else %>


	<TD align=center class=TightBodyText >  CLOSED

  </td>

<% End If' End if ProjectStatus is 0 or 1 %>

</tr>



<%
				rstemp.MoveNext
			loop

		Else  ' If no projects found matching criteria

%>

	<!--<center>
	No Projects found matching search criteria
	</center>-->

<% End If  ' end of if no records found %>

	<%	 ' Close the record set and close the connection

		rstemp.close
		set rstemp=nothing

		' Close the only connection to the database

		conntemp.close ' Close the connection
		set conntemp=nothing
	%>


</TABLE>

</BODY>
</HTML>



<%End If ' End of security checks %>

<% Function YYMMDD(datestring)
' This function takes a date string in MM/DD/YY format and recasts it in YY/MM/DD format

   DIM aryChunk
   aryChunk = Split(datestring,"/")
   YYMMDD = aryChunk(2) & "/" & aryChunk(0) & "/" & aryChunk(1)

End Function
%>


<% Function PriorityFullDescription(Priority_Number)
	'This function gets the full description of the Passed Priority Number
		If Priority_Number  = "" Then
			PriorityFullDescription =  "Priority Not Defined"
		Else

			set conntemp5=server.createobject("adodb.connection")
			conntemp5.open myDSN ' Open the connection once here

			mySQL2="select * from Priority where PriorityID =  " & Priority_Number
			set rstemp5=conntemp5.execute(mySQL2)

			' Check to see if any records are returned
			' if none found the
			if rstemp5.EOF then
				PriorityFullDescription = "Priority Not Defined"
			Else
				PriorityFullDescription = rstemp5("ShortDesc")
			End If

			rstemp5.close
			set rstemp5=nothing
			conntemp5.Close
			Set conntemp5 = nothing

		End If

	End Function ' End of PriorityFullDescription Function
%>

<hr>
<Div class = "TightBodyTextHilight">
<center><a href="tools.asp">Documentation and Support Tools</a></center>
</div>
<hr>


</BODY>
</HTML>



